<?php

	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");

	class Account extends FJF_CMD{
		var $sessionModel = null;

		function __construct(){
			$this->sessionModel = new SessionModel();
		}

		function execute(){
			require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["app_web_path"] . "/includes/header_commands.php");
			
			$header["title"] = "User Account Settings";
			
			$record = $this->sessionModel->getRecordBy("users", $this->sessionModel->uid);
			if(!$this->sessionModel->uid || !$record) FJF_BASE::redirect("/");
			
			$recordSettings = $this->sessionModel->getRecordBy("users_settings", $this->sessionModel->uid, "user_id");
			if(!$recordSettings){
				$recordSettings = new stdClass;
				$recordSettings->user_id = $record->id;
			}
			$dob = array();
			if($record->dob){
				$dob["y"] = substr($record->dob, 0, 4);
				$dob["m"] = substr($record->dob, 5, 2);
				$dob["d"] = substr($record->dob, 8, 2);
			}
      
      if($_SERVER["REQUEST_METHOD"] == "POST"){
      	$record->first_name = isset($_POST["first_name"]) ? trim($_POST["first_name"]) : '';
				$record->last_name = isset($_POST["last_name"]) ? trim($_POST["last_name"]) : '';
    		$record->gender = isset($_POST["gender"]) ? intval($_POST["gender"]) : 0;
				$dob["m"] = isset($_POST["dob_m"]) && $_POST["dob_m"] ? intval($_POST["dob_m"]) : 0;
				$dob["d"] = isset($_POST["dob_d"]) && $_POST["dob_d"] ? intval($_POST["dob_d"]) : 0;
				$dob["y"] = isset($_POST["dob_y"]) && $_POST["dob_y"] ? intval($_POST["dob_y"]) : 0;
				//$record->dob = (isset($_POST["dob"]) && $_POST["dob"] != "") ? date("Y-m-d", @strtotime(trim($_POST["dob"]))) : null;
        $recordSettings->race = isset($_POST["race"]) && $_POST["race"] != "" ? trim($_POST["race"]) : "";
				
        $recordSettings->education = isset($_POST["education"]) ? trim($_POST["education"]) : "";
				$recordSettings->education_other = isset($_POST["education_other"]) ? trim($_POST["education_other"]) : "";
				
				$recordSettings->income = isset($_POST["income"]) ? trim($_POST["income"]) : "";
				$recordSettings->investable_assets = isset($_POST["investable_assets"]) ? trim($_POST["investable_assets"]) : "";
				$recordSettings->investor_type = isset($_POST["investor_type"]) ? trim($_POST["investor_type"]) : "";
				$recordSettings->self_directed = isset($_POST["self_directed"]) ? trim($_POST["self_directed"]) : "";
				$recordSettings->trade_often = isset($_POST["trade_often"]) ? trim($_POST["trade_often"]) : "";
				$recordSettings->trade_length = isset($_POST["trade_length"]) ? trim($_POST["trade_length"]) : "";
				
				$recordSettings->investment_style = isset($_POST["investment_style"]) && is_array($_POST["investment_style"]) ? implode(",", $_POST["investment_style"]) : "";
				$recordSettings->investment_style_other = isset($_POST["investment_style_other"]) ? trim($_POST["investment_style_other"]) : "";
				
				$recordSettings->invest_in = isset($_POST["invest_in"]) && is_array($_POST["invest_in"]) ? implode(",", $_POST["invest_in"]) : "";
				$recordSettings->invest_in_other = isset($_POST["invest_in_other"]) ? trim($_POST["invest_in_other"]) : "";
				
				$recordSettings->trade = isset($_POST["trade"]) && is_array($_POST["trade"]) ? implode(",", $_POST["trade"]) : "";
				$recordSettings->holding_period = isset($_POST["holding_period"]) ? trim($_POST["holding_period"]) : "";
				
				$recordSettings->investment_ideas = isset($_POST["investment_ideas"]) && is_array($_POST["investment_ideas"]) ? implode(",", $_POST["investment_ideas"]) : "";
				$recordSettings->investment_ideas_other = isset($_POST["investment_ideas_other"]) ? trim($_POST["investment_ideas_other"]) : "";
				
				$recordSettings->broker = isset($_POST["broker"]) && is_array($_POST["broker"]) ? implode(",", $_POST["broker"]) : "";
				$recordSettings->broker_other_bank = isset($_POST["broker_other_bank"]) ? trim($_POST["broker_other_bank"]) : "";
				$recordSettings->broker_other_online = isset($_POST["broker_other_online"]) ? trim($_POST["broker_other_online"]) : "";
				
				if(!$record->first_name){
					$hasError = true;
        	$status .= "FIRST NAME is missing.<br />";
				}
				if(!$record->last_name){
					$hasError = true;
        	$status .= "LAST NAME is missing.<br />";
				}
        if(!$dob["m"] || !$dob["d"] || !$dob["y"]){
        	$hasError = true;
        	$status .= "DATE OF BIRTH is missing.<br />";
				}else{
					$record->dob = $dob["y"] . "-";
					if($dob["m"] < 10) $record->dob .= "0";
					$record->dob .= $dob["m"] . "-";
					if($dob["d"] < 10) $record->dob .= "0";
					$record->dob .= $dob["d"];
					$record->dob = date("Y-m-d", @strtotime($record->dob));
					$now = date("Y-m-d");
					$y13 = date("Y-m-d", @strtotime($now . ' -13 years'));
					if(strtotime($y13) < strtotime($record->dob)){
						$hasError = true;
        		$status .= "We love your enthusiasm, but unfortunately, users under 13 are not allowed to use MarketProphit.com.<br />See our <a href='/terms-of-service'>terms of service</a> for more info.<br />";
					}
				}
        
        if(!$hasError){
          if(!$this->sessionModel->saveRecord("users", get_object_vars($record)) || !$this->sessionModel->saveRecord("users_settings", get_object_vars($recordSettings))){
					 	$hasError = true;
            $status = "Error has occured. Please try again or contact support.";
          }
          else{
            $status = "Your account info updated successfully.";
          }
				}
      }//POST
      
      if(isset($recordSettings->investment_style) && $recordSettings->investment_style) $recordSettings->investment_style = explode(",", stripslashes($recordSettings->investment_style));
      if(isset($recordSettings->invest_in) && $recordSettings->invest_in) $recordSettings->invest_in = explode(",", stripslashes($recordSettings->invest_in));
			if(isset($recordSettings->trade) && $recordSettings->trade) $recordSettings->trade = explode(",", $recordSettings->trade);
			if(isset($recordSettings->investment_ideas) && $recordSettings->investment_ideas) $recordSettings->investment_ideas = explode(",", stripslashes($recordSettings->investment_ideas));
			if(isset($recordSettings->broker) && $recordSettings->broker) $recordSettings->broker = explode(",", stripslashes($recordSettings->broker));
      
      $options = array(
      	"race" => array("White", "African American", "Hispanic", "Asian", "Other"),
				"education" => array( "none", "high school", "associate degree", "bachelors", "masters", "PhD", "MBA", "JD", "MD", "other"),
				"income" => array("none", "<25k", "25-50k", "50-75k", "75-100k", "100-150k", "150-250k", "250-500k", ">500k"),
				"investable_assets" => array("none", "<10k", "10-25k", "25-50k", "50-75k", "75-100k", "100-150k", "150-250k", "250-500k",
					"500k-1M", "1-5M", "5-10M", ">10M"),
				"investor_type" => array(
					"self_directed" => "self directed (I manage my own money)",
					"passive" => "passive (my money is managed by a financial advisor)",
					"both" => "both",
					"neither" => "neither"
				),
				"self_directed" => array(),
				"passive" => array(),
				"trade_often" => array("more than once a day", "once a day", "once a week", "once a month", "a few times a year", "never"),
				"trade_length" => array("never", "beginner (less than 1 year)", "1-3 years", "3-5 years", "5-10 years", "more than 10 years"),
				"investment_style" => array("sector", "growth", "balanced", "value", "technical", "income", "fundamental",  "small cap",
					"mid cap", "large cap", "international", "emerging market", "global", "country/regional"),
				"invest_in" => array("equities", "fixed income", "currencies", "commodities", "mutual funds", "private companies/private debt", "hedge funds"),
				"trade" => array("futures", "options", "ETF's", "none"),
				"holding_period" => array("intraday", "1 day", "a few days", "1 week", "a few weeks", "long term"),
				"investment_ideas" => array("newspaper", "stock chat rooms", "forums", "email newsletters", "blogs", "mailed newsletters",
					"co-workers", "financial television programs", "friends / family", "social media financial websites", "financial advisor",
					"financial magazines", "financial websites"),
				"broker" => array("Charles Schwab", "Fidelity", "T.D. Ameritrade", "Wells Fargo", "Bank of America", "Vanguard", "T. Rowe Price",
					"Scottrade", "Smith Barney", "JP Morgan", "E-Trade")
			);
			
			for($s=0; $s<100; $s+=5){
				$str = "";
				$str .= $s . "-" . ($s+5) . "%";
				$options["self_directed"][] = $str;
				$options["passive"][] = $str;
			}
			$options["passive"] = array_reverse($options["passive"]);
			
			$backURL = (isset($_SERVER["HTTP_REFERER"]) && $_SERVER["HTTP_REFERER"] != "") ? parse_url($_SERVER["HTTP_REFERER"], PHP_URL_PATH) : "";
			
			$templateParams = array(
        "has_error" => $hasError,
        "status" => $status,
        "header" => $header,
        "record" => $record,
        "record_settings" => $recordSettings,
        "back_url" => $backURL,
        "options" => $options,
        "dob" => $dob
      );
			
			return $this->displayTemplate("account.tpl", $templateParams);
		}
	}

?>