<?php

	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/users_sentiment_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/pagination_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/twitter_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/user_model.php");

	class AccountDashboard extends FJF_CMD{
		
		var $sessionModel = null;
		var $usersSentimentModel = null;
		var $paginationModel = null;
		var $twitterModel = null;
		var $userModel = null;

		function __construct(){
			$this->sessionModel = new SessionModel();
			$this->sessionModel->notLoginRedirect();
			$this->sessionModel->checkLockedPage();
			$this->usersSentimentModel = new UsersSentimentModel();
			$this->paginationModel = new paginationModel();
			$this->twitterModel = new TwitterModel();
			$this->userModel = new UserModel();
		}

		function execute(){
			require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["app_web_path"] . "/includes/header_commands.php");
			
			$user = $this->sessionModel->getUser();
			$header["title"] = "User Account Dashboard";
			$records = null;
			$order = null;
			$pages = null;
			$searchParams = new stdClass;
      $search = null;
			
			
			$url = '/account-dashboard/?page=PAGE';
      $searchParams->sorting = array(
      	'username' => array('value'=>'username', 'name'=>'USERNAME', 'status' => true),
        'mp-score' => array('value'=>'score', 'name'=>'MPS', 'status' => true),
        'mpr' => array('value'=>'rank', 'name'=>'MPR', 'status' => true),
        'previous-mpr' => array('value'=>'previous_rank', 'name'=>'PREVIOUS MPR', 'status' => true),
        'profile' => array('value'=>'', 'name'=>'USER PROFILE', 'status' => false),
      );
      $searchParams->limit = array(10, 25);
        			
			if(isset($_COOKIE["users_options"]) && $_COOKIE["users_options"]) $search = json_decode(stripslashes($_COOKIE["users_options"]));
			if(!$search){
				$search = new stdClass;
	      $search->sort = 'username';
	      $search->order = 'asc';
	      $search->limit = $searchParams->limit[0];
				$search->page = 1;
			}
			
			if(isset($_GET["sort"]) && $_GET["sort"]) $search->sort = trim($_GET["sort"]);
      if(isset($_GET["order"]) && $_GET["order"]) $search->order = trim($_GET["order"]);
      if(isset($_GET["limit"]) && $_GET["limit"]) $search->limit = intval($_GET["limit"]);
			if(isset($_GET["page"]) && $_GET["page"]) $search->page = intval($_GET["page"]);
			
			$_GET["page"] = $search->page;
			
			setcookie("users_options", json_encode($search), 0, "/account-dashboard/");
			
      if ($searchParams->limit && in_array($search->limit, $searchParams->limit))
      {
        $url .= '&limit='.$search->limit;
      }
      if ($search->sort && array_key_exists($search->sort, $searchParams->sorting))
      {
        $searchParams->sorting[$search->sort]['active'] = true;
        $order = $searchParams->sorting[$search->sort]['value'];
        if ($order) $order .= ' ' . ($search->order == 'asc' ? 'ASC' : 'DESC');
        $url .= '&sort='.$search->sort;
        $url .= '&order='.$search->order;
      }
      $GLOBALS["WEB_APPLICATION_CONFIG"]["FJF_BASE_key"] = "username";
			$marketUsers = $this->usersSentimentModel->getRecords("users_market_users", "user_id='USER_ID'", array('USER_ID'=>$user->id), false, 'username, status');

			if($marketUsers){
      	$recordsCount = count($marketUsers);
      	$marketUsersKeys = array_keys($marketUsers);
				$where = " username IN('" . implode("','", $marketUsersKeys) . "')";
				$where .= " AND TS = (SELECT TS FROM TrackingData_UserScores ORDER BY TS DESC LIMIT 1)";
				$params = array();
      	$pages = $this->paginationModel->pages($url, $recordsCount, $search->limit) ;
				$fields = "USERNAME AS username, SCORE AS score, RANK AS rank, PREVIOUS_RANK AS previous_rank";
				$GLOBALS["WEB_APPLICATION_CONFIG"]["FJF_BASE_key"] = "username";
      	$records = $this->usersSentimentModel->getUserScores($where, $params, null, $order, $fields);
				if(!$records) $records = array();
				foreach($marketUsers as $item){
					if(!array_key_exists($item->username, $records)){
						$records[]=(object) array(
							"username" => $item->username,
							"score" => null,
							"rank" => null,
							"previous_rank" => null,
							"status" => $item->status
						);
					}else{
						$records[$item->username]->status = $item->status;
					}
				}
				if($records){
					if($this->paginationModel->limit){
						$limitParams = explode(',', $this->paginationModel->limit);
						if (!isset($limitParams[1])){
							$limitParams[1] = $limitParams[0];
							$limitParams[0] = 0;
						}
						if($search->sort && array_key_exists($search->sort, $searchParams->sorting)){
							$records = $this->usersSentimentModel->sortByOneKey(
								$records,
								$searchParams->sorting[$search->sort]['value'],
								$search->order == 'asc'
							);
						}
						$records = array_slice($records, $limitParams[0], $limitParams[1]);
					}
					$tweeter = $this->twitterModel->getLib();
					$twUsers = $tweeter->get("users/lookup", array("screen_name" => implode(",", $marketUsersKeys)));
					if($twUsers){
						$twUsersNew = array();
						foreach($twUsers as $twUser){
							if(!array_key_exists($twUser->screen_name, $twUsersNew)) $twUsersNew[$twUser->screen_name] = $twUser;
						}
						if(!empty($twUsersNew)){
							foreach($records as $record){
								$record->author_logo = array_key_exists($record->username, $twUsersNew) ? $twUsersNew[$record->username]->profile_image_url : "";
							}
						}
					}
				}
			}
			//test($records);
			
			$hasError = !$this->userModel->checkUserProfile();
      if ($hasError) $status = 'You haven’t filled out your profile yet. Fill out your profile to help us serve you better. <a href="/account-settings/">Click here</a> to get started.';
			
			return $this->displayTemplate("account_dashboard.tpl", array(
        "has_error" => $hasError,
        "status" => $status,
        "header" => $header,
        "records" => $records,
        "search" => $search,
        "search_params" => $searchParams,
        "pages" =>$pages,
      ));
		}
		
	}

?>