<?php

	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/stripe_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/pricing_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/user_model.php");

	class AccountInformation extends FJF_CMD{
		var $sessionModel = null;
		var $userModel = null;

		function __construct(){
			$this->sessionModel = new SessionModel();
			$this->userModel = new UserModel();
		}

		function execute(){
			require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["app_web_path"] . "/includes/header_commands.php");
			$isAjax = !empty($_SERVER['HTTP_X_REQUESTED_WITH']) && strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) == 'xmlhttprequest';
			if($isAjax && !$this->sessionModel->isLoggedUser()){
				return false;
			}
			$this->sessionModel->notLoginRedirect();
			$record = $this->sessionModel->getRecordBy("users", $this->sessionModel->uid);
			if(!$record) FJF_BASE::redirect("/");
			$record->order = $record->subscribe_id ? FJF_BASE_RICH::getRecord(
				"orders",
				"transaction_id = 'SUBSCRIBE_ID'",
				array('SUBSCRIBE_ID' => $record->subscribe_id)
			) : null;
			$tiers = PricingModel::getTiersInfo();
			$paymentTypes = PricingModel::$paymentTypes;
			StripeModel::setApiKey();
			if($isAjax){
				$redirect = "";
				$info = array();
				$action = isset($_POST['action']) ? trim($_POST['action']) : '';
				if($action == 'set_info'){
					$personalFields = array(
	        	"first_name" => "First Name",
	        	"last_name" => "Last Name",
	        	"address" => "Address",
	        	"address2" => "",
	        	"city" => "City",
	        	"zip" => "Zip",
	        	"state" => "",
	        	"country" => "Country",
	        	"tier" => ""
					);
					foreach($personalFields as $field=>$name){
						$data['personal_info'][$field] = isset($_POST[$field]) ? trim($_POST[$field]) : "";
						if($name && !$data['personal_info'][$field]){
							$hasError = true;
	          	$status .=  $name . " is missing.\n";
						}
					}
	        $billingFields = array(
	        	"first_name" => "First Name",
	        	"last_name" => "Last Name",
	        	"address" => "Address",
	        	"address2" => "",
	        	"city" => "City",
	        	"zip" => "Zip",
	        	"state" => "",
	        	"country" => "Country",
	        	"coupon_code" => "",
	        	"payment_type" => ""
					);
					foreach($billingFields as $field => $name){
						$data['billing_info'][$field] = isset($_POST['billing'][$field]) ? trim($_POST['billing'][$field]) : "";
						if($name && !$data['billing_info'][$field]){
							$hasError = true;
	          	$status .=  $name . " is missing.\n";
						}
					}
					
					if($data['personal_info']["tier"] || $data['billing_info']['payment_type']){
						if(!array_key_exists($data['personal_info']["tier"], $tiers)){
							$hasError = true;
							$status .= "Tier is missing.\n"; 
						}
						if(!array_key_exists($data['billing_info']['payment_type'], $paymentTypes)){
		          $hasError = true;
		          $status .= "Pricing Plan is missing.\n";
		        }
					}
					
					$card = isset($_POST['card']) ? trim($_POST['card']) : '';
					if(!$card && !$record->customer_id){
						$hasError = true;
	        	$status .= "Credit Card Information is missing.\n";
					}
					
					$isChangeTier = ($data['billing_info']['payment_type'] && $data['personal_info']['tier']) &&
					($record->tier != $data['personal_info']['tier'] || !$record->order ||
					(isset($record->order) && $record->order->payment_type != $data['billing_info']['payment_type']));
					
					if(!$hasError && !$isChangeTier && $data['billing_info']['coupon_code']){
						$hasError = true;
	        	$status .= "Promotions can only be applied to changes in your tier level.\n";
					}
					
					if(!$hasError){
						$metadata = array();
						foreach(array('first_name', 'last_name', 'address', 'address2', 'city', 'state', 'zip', 'country') as $field){
							if(isset($data['billing_info'][$field])) $metadata[$field] = $data['billing_info'][$field]; 
						}
						try{
							if(!$record->customer_id){
								$data['personal_info']['customer_id'] = StripeModel::createCustomer(
									$card,
									$record->email,
									$metadata
								);
								$record->customer_id = $data['personal_info']['customer_id'];
							}else{
								StripeModel::updateCustomer(
									$record->customer_id,
									$card,
									null, $metadata
								);
							}
						}catch(Exception $e){
							$hasError = true;
							$status .= $e->getMessage() . "\n ";
						}
						
						if(!$hasError && $isChangeTier){
							if($data['billing_info']['coupon_code']){
								$data['coupon'] = $this->getCouponInfo(
									$data['billing_info']['coupon_code'],
									$data['personal_info']['tier'],
									$data['billing_info']['payment_type']
								);
								if(!$data['coupon']){
									$hasError = true;
			          	$status .= "Invalid Coupon Code.\n";
								}	
							}
							if(!$hasError){
								$data['order'] = $data['billing_info'];
								$paymentType = isset($data['billing_info']["payment_type"]) ? $data['billing_info']["payment_type"] : "monthly";
								$data['order']['price'] = $tiers[$data['personal_info']['tier']][$paymentType]['price'];
								$data['order']['discount'] = 0;
								if(isset($data['coupon']['type_off'])){
									if($data['coupon']['type_off'] == 'amount_off'){
										$data['order']['discount'] = $data['coupon']['discount'];
									}elseif($data['coupon']['type_off'] == 'percent_off'){
										$data['order']['discount'] = $data['order']['price'] * $data['coupon']['discount'] / 100;
									}
								}
								$data['order']['total'] = $data['order']['price'] - $data['order']['discount'];
								if($data['order']['total'] < 0) $data['order']['total'] = 0;
								
								if(isset($data['coupon']['trial'])){
									$data['order']['free_trial'] = $data['coupon']['trial'];
								}
	
								if(isset($data['coupon']['coupon_expires'])){
									$data['order']['coupon_expires_date'] = date('Y-m-d H:i:s', $data['coupon']['coupon_expires']);
								}elseif(isset($data['order']['coupon_expires_date'])){
									unset($data['order']['coupon_expires_date']);
								}
								if($record->subscribe_id){
									try{
										$record->cancel_subscribe = StripeModel::cancelCustomerSubscribe($record->customer_id, $record->subscribe_id);
									}catch(Exception $e){
										$hasError = true;
										$status .= $e->getMessage() . "\n ";
									}
									if(!$hasError){
										$record->subscribe_id = "";
										$_SESSION["user"]->tier = 0;
										$_SESSION["user"]->subscribe_id = $record->subscribe_id;
										FJF_BASE_RICH::saveRecord("users", array(
											"id" => $record->id,
											"tier" => 0,
											"subscribe_id" => $record->subscribe_id
										));
									}
								}
								if(!$hasError){
									$record->subscribe_id = "";
									$subscribeData = array(
										"plan" => $tiers[$data['personal_info']['tier']][$paymentType]['plan_id']
									);
									if(isset($data['coupon']['code'])){
										$subscribeData["coupon"] = $data['coupon']['code'];
									}
									if(isset($data['coupon']['trial'])){
										$subscribeData["trial_end"] = $data['coupon']['trial'] ? strtotime('+ ' . $data['coupon']['trial'] * 7 . ' days') : 'now';
									}else{
										$subscribeData["trial_end"] = 'now';
									}
									try{
										$data['personal_info']['subscribe_id'] = StripeModel::subscribeCustomer(
											$record->customer_id,
											$subscribeData
										);
									}catch(Exception $e){
										$hasError = true;
										$status .= $e->getMessage() . "\n ";
									}
								}
								if(!$hasError){
									$data['order']['tier'] = $data['personal_info']['tier'];
									$data['order']['user_id'] = $record->id;
									if($data['personal_info']['subscribe_id']){
										$data['order']['transaction_id'] = $data['personal_info']['subscribe_id'];
									}
									$data['order']['date'] = date('Y-m-d H:i:s');
									$data['order']['id'] = FJF_BASE_RICH::saveRecord("orders", $data['order']);
								}
							}
						}
						if(!$hasError){
							foreach($data['personal_info'] as $key => $item){
								if(isset($_SESSION["user"]->{$key})){
									if($key == 'tier') $item = intval($item);
									$_SESSION["user"]->{$key} = $item;
								}
							}
							$data['personal_info']['id'] = $record->id;
							if(FJF_BASE_RICH::saveRecord("users", $data['personal_info'])){
								$redirect = "/account-information/";
								$status = array("title" => "Your Changes Have Been Saved");
								if(isset($data['order'])){
									$status['message'] = "You have successfully changed your subscription plan.";
									$data['order']['plan'] = array_key_exists($data['order']['tier'], $tiers) ? $tiers[$data['order']['tier']]['name'] : "";
									$data['order']['payment_type'] = array_key_exists($data['order']['payment_type'], $paymentTypes) ? $paymentTypes[$data['order']['payment_type']] : "";
									$data['order']['effective_date'] = date('m/d/Y');
									$data['order']['change_type'] = 'Upgrade';
									if(isset($record->order)){
										$data['order']['old'] = get_object_vars($record->order);
										$data['order']['old']['cancel_subscribe'] = isset($record->cancel_subscribe) ? $record->cancel_subscribe : null;
										$data['order']['old']['plan'] = array_key_exists($data['order']['old']['tier'], $tiers) ? $tiers[$data['order']['old']['tier']]['name'] : "";
										if($data['order']['tier'] == $data['order']['old']['tier']){
											$data['order']['change_type'] = 'Update';
											$data['order']['plan'] = $data['order']['plan'] . ' ' . ucfirst($data['order']['payment_type']);
											$data['order']['old']['plan'] = $data['order']['old']['plan'] . ' ' . ucfirst($data['order']['old']['payment_type']);
										}else{
											$data['order']['change_type'] = $data['order']['tier'] > $data['order']['old']['tier'] ? 'Upgrade' : 'Downgrade';	
										}
										$data['order']['old']['cancellation_date'] = date('m/d/Y');
									}
									if(isset($data['coupon']['trial']) && $data['coupon']['trial']){
										$data['order']['trial'] = $data['coupon']['trial'] . ' week' . ($data['coupon']['trial'] > 1 ? 's' : '');
									}
									if(isset($data['coupon']['coupon_expires'])){
										$data['order']['coupon_expires'] = date('m/d/Y',$data['coupon']['coupon_expires']);
									}
									$data['personal_info']['email'] = $record->email;
									$this->userModel->sendChangeTierMail($data['personal_info'], $data['order']);
									$redirect = "/account-information/confirmation/update/";
									$_SESSION['account-confirmation'] = $data['order'];
								}
							}else{
								$hasError = true;
	            	$status .= "An error occurred, please try again.\n";
							}
						}
						if($_SESSION["user"]->tier != $record->tier){
							$this->userModel->changePendingStatus(
								$record->id,
								$_SESSION["user"]->tier
							);
						}
					}
				}elseif($action == "cancel_subsricption"){
					if(!$record->subscribe_id){
						$hasError = true;
						$status .= "Subscription is missing.\n";
					}
					if(!$record->customer_id){
						$hasError = true;
						$status .= "Customer is missing.\n";
					}
					if(!$hasError){
						try{
							$record->cancel_subscribe = StripeModel::cancelCustomerSubscribe($record->customer_id, $record->subscribe_id);
						}catch(Exception $e){
							$hasError = true;
							$status .= $e->getMessage() . "\n ";
						}
					}
					if(!$hasError){
						$_SESSION["user"]->tier = 0;
						$_SESSION["user"]->subscribe_id = "";
						$_SESSION["user"]->cancelled = 1;
						if(FJF_BASE_RICH::saveRecord("users", array(
							"id" => $record->id,
							"tier" => 0,
							"subscribe_id" => "",
							"cancelled" => 1
						))){
							$this->userModel->changePendingStatus($record->id, 0);
							if(isset($record->order)){
								$data['order']['old'] = get_object_vars($record->order);
								$data['order']['old']['cancel_subscribe'] = isset($record->cancel_subscribe) ? $record->cancel_subscribe : null;
								$data['order']['old']['plan'] = array_key_exists($data['order']['old']['tier'], $tiers) ? $tiers[$data['order']['old']['tier']]['name'] : "";
								$data['order']['old']['cancellation_date'] = date('m/d/Y');
								$this->userModel->sendCancelSubscribeMail(get_object_vars($record), $data['order']);
								$redirect = "/account-information/confirmation/cancel/";
								$_SESSION['account-confirmation'] = $data['order'];
							}
						}
					}
				}elseif($action == 'check_coupon'){
					$data['billing_info']['coupon_code'] = isset($_POST["coupon_code"]) ? trim($_POST["coupon_code"]) : "";
					$data['personal_info']['tier'] = isset($_POST["tier"]) ? trim($_POST["tier"]) : "";
					$data['billing_info']['payment_type'] = isset($_POST["payment_type"]) ? trim($_POST["payment_type"]) : "";
					
					if(!$data['billing_info']['coupon_code']){
						$hasError = true;
						$status .= "Coupon Code is missing.\n"; 
					}
					if(!array_key_exists($data['personal_info']['tier'], $tiers)){
						$hasError = true;
						$status .= "Tier is missing.\n"; 
					}
					if(!array_key_exists($data['billing_info']['payment_type'], $paymentTypes)){
	          $hasError = true;
	          $status .= "Pricing Plan is missing.\n";
	        }
					if(!$hasError){
						if($data['coupon'] = $this->getCouponInfo(
							$data['billing_info']['coupon_code'],
							$data['personal_info']['tier'],
							$data['billing_info']['payment_type']
						)){
							$status = "Success!";
							if(isset($data['coupon']['type_off'])){
								$status .= " - ";
								if($data['coupon']['type_off'] == 'amount_off'){
									$status .=  '$' . $data['coupon']['discount'];
								}elseif($data['coupon']['type_off'] == 'percent_off'){
									$status .= $data['coupon']['discount'] ."%";
									$data['coupon']['discount'] = $tiers[$data['personal_info']['tier']][$data['billing_info']['payment_type']]['price'] * $data['coupon']['discount'] / 100;
								}
								$status .= " off " . $paymentTypes[$data['billing_info']['payment_type']];
							}
							$info['coupon_code'] = $data['billing_info']['coupon_code'];
							$info['discount'] = isset($data['coupon']['discount']) && $data['coupon']['discount'] ? '-$' . number_format($data['coupon']['discount'], 2) : '';
							$info['coupon_expires'] = isset($data['coupon']['coupon_expires']) ? date('F j, Y', $data['coupon']['coupon_expires']) : '';
							$info['trial'] = isset($data['coupon']['trial']) && $data['coupon']['trial'] ? $data['coupon']['trial'] . ' week' . ($data['coupon']['trial'] > 1 ? 's' : '') : '';
						}else{
							$hasError = true;
	          	$status .= "Invalid Coupon Code.\n";
						}
					}
					
				}
				exit(json_encode(array(
					'hasError' => $hasError,
					'status' => $status,
					'info' => $info,
					'redirect' => $redirect
				)));
			}
			
			$header["title"] = "User Account Settings";
			$GLOBALS["WEB_APPLICATION_CONFIG"]["FJF_BASE_key"] = "abbr";
			$states = FJF_BASE_RICH::getRecords("states", "country = 'United States'");
			if($record->customer_id){
				try{
					$customer = StripeModel::getCustomer($record->customer_id);
				}catch(Exception $e){
					$customer = false;
				}
				if($customer) $record->customer = $customer->metadata;
				if($record->subscribe_id){
					try{
						$invoice = StripeModel::getUpcomingInvoice(array(
							"customer" => $record->customer_id,
							"subscription" => $record->subscribe_id
						));
					}catch(Exception $e){
						$invoice = false;
					}
					if($invoice){
						$record->invoice = array(
							"date" => $invoice->date,
							"total" => ($invoice->total ? $invoice->total/100 : 0)
						);
					}
				}
			}
			
			if($tiers){
				foreach($tiers as $key=>$item){
					unset($tiers[$key]['monthly']['plan_id']);
					unset($tiers[$key]['annual']['plan_id']);
					unset($tiers[$key]['trial']);
					unset($tiers[$key]['signals']);
					unset($tiers[$key]['limit']);
				}
			}
			
			$countries = $this->sessionModel->getRecords("countries", "1 ORDER BY position, name");

			$templateParams = array(
        "has_error" => $hasError,
        "status" => $status,
        "header" => $header,
        "states" => $states,
        "tiers" => $tiers,
        "stripe_key" => StripeModel::getPublicKey(),
        "countries" => $countries,
        "record" => $record
      );
			
			return $this->displayTemplate("account_information.tpl", $templateParams);
		}

		function getCouponInfo($code, $tier, $paymentType){
			$result = array();
			if($coupon = FJF_BASE_RICH::getRecord(
      	"promotion_codes",
      	" code = 'CODE_VAL' AND FIND_IN_SET('TIER_VAL', tiers) AND FIND_IN_SET('TYPE_VAL', payment_types) AND status = 1",
      	array(
      		"CODE_VAL" => $code,
      		"TIER_VAL" => $tier,
      		"TYPE_VAL" => $paymentType
				),
      	"code, free_trial, tiers"
			)){
				try{
					$stripeCoupon = StripeModel::getCoupon($coupon->code);
				}catch(Exception $e){
					$stripeCoupon = false;
				}
				if($stripeCoupon && $stripeCoupon->valid){
					$result['code'] = $coupon->code;
					if($stripeCoupon->amount_off){
						$result['type_off'] = 'amount_off';
						$result['discount'] = ($stripeCoupon->amount_off) ? $stripeCoupon->amount_off / 100 : 0;
					}elseif($stripeCoupon->percent_off){
						$result['type_off'] = 'percent_off';
						$result['discount'] = $stripeCoupon->percent_off;
					}
					if(isset($coupon->free_trial)){
						$result['trial'] = $coupon->free_trial;
					}
					if($coupon->tiers){
						$result['tiers'] = explode(',', $coupon->tiers);
					}
					if(isset($stripeCoupon->duration) && $stripeCoupon->duration == 'repeating'){
						$coupon->expires = 'now';
						if(isset($stripeCoupon->duration_in_months) && $stripeCoupon->duration_in_months){
							$months = $stripeCoupon->duration_in_months;
							if($paymentType == 'annual'){
								$months = floor($months / 12) * 12;
								if($months < $stripeCoupon->duration_in_months){
									$months += 12;
								}
							}
							$coupon->expires .= " + " . $months . " months";
						}
						if($coupon->free_trial) $coupon->expires .= " + " . $coupon->free_trial . " weeks";
						$result['coupon_expires'] = strtotime($coupon->expires);
					}
				}
			}
			return $result;
		}
	}

?>