<?php

	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");

	class AccountInformationConfirmation extends FJF_CMD{
		var $sessionModel = null;

		function __construct(){
			$this->sessionModel = new SessionModel();
			$this->sessionModel->notLoginRedirect();
		}

		function execute(){
			require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["app_web_path"] . "/includes/header_commands.php");
			$user = $this->sessionModel->getUser();
			$type = isset($_GET['type']) ? trim($_GET['type']) : '';
			$order = isset($_SESSION['account-confirmation']) ? $_SESSION['account-confirmation'] : null;
			if(!$order || !$type) FJF_BASE::redirect("/account-information/");
			$header["title"] = "User Account Settings";
			unset($_SESSION['account-confirmation']);
			if($type == 'cancel' && $user->cancelled){
				$this->sessionModel->unsetUserSession();
				$header["is_logged_in"] = false;
			}elseif($type == 'update'){
				$header["embed_code"]["head"] = "<script>fbq('track', 'Purchase', {value: '" . number_format($order["total"], 2, ".", "") . "', currency: 'USD'});</script>";
			}
			
			$templateParams = array(
        "has_error" => $hasError,
        "status" => $status,
        "header" => $header,
        "type" => $type,
        "order" => $order
      );
			
			return $this->displayTemplate("account_information_confirmation.tpl", $templateParams);
		}
	}

?>