<?php

	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");

	class AccountInformationEdit extends FJF_CMD{
		var $sessionModel = null;

		function __construct(){
			$this->sessionModel = new SessionModel();
		}

		function execute(){
			require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["app_web_path"] . "/includes/header_commands.php");
			
			$header["title"] = "User Account Settings";
			
			$record = $this->sessionModel->getRecordBy("users", $this->sessionModel->uid);
      $type = isset($_GET['type']) ? trim($_GET['type']) : '';
			if(!$this->sessionModel->uid || !$record || !$type) FJF_BASE::redirect("/");
			$new = new stdClass;
			$new->old_email = $record->email;
			
      if($_SERVER["REQUEST_METHOD"] == "POST"){
				  
				if ($type == 'email'){
  				$new->new_email = isset($_POST["new_email"]) && $_POST["new_email"] ? htmlentities(trim($_POST["new_email"]), ENT_QUOTES) : "";
  				$new->old_email = isset($_POST["old_email"]) && $_POST["old_email"] ? htmlentities(trim($_POST["old_email"]), ENT_QUOTES) : "";
  				$new->confirm_email = isset($_POST["confirm_email"]) && $_POST["confirm_email"] ? htmlentities(trim($_POST["confirm_email"]), ENT_QUOTES) : "";
  				
  				if(!$new->old_email){
  					$hasError = true;
  					$status .= "Current Email is missing.<br />";
  				}elseif($new->old_email != $record->email){
          	$hasError = true;
            $status .= "Current Email is wrong.<br />";
          }elseif(!$new->new_email){
  					$hasError = true;
  					$status .= "New Email is missing.<br />";
  				}elseif(!preg_match("/^.+\@.+\..+$/", $new->new_email)){
  					$hasError = true;
  					$status .= "Invalid New Email format.<br />";
  				}elseif(!$new->confirm_email){
  					$hasError = true;
            $status .= "Verify Email is missing.<br />";
  				}elseif($this->sessionModel->getRecordby("users", $new->new_email, "email")){
  					$hasError = true;
  					$status .= "New Email is already registered with our system.<br />";
  				}elseif($new->confirm_email != $new->new_email){
  					$hasError = true;
            $status .= "Verify Email is wrong.<br />";
  				}else{
  					$record->email = $new->new_email;
  				}
				}elseif($type == 'password'){
  				$new->password_new = isset($_POST["password_new"]) && $_POST["password_new"] ? trim($_POST["password_new"]) : "";
  				$new->password_old = isset($_POST["password_old"]) && $_POST["password_old"] ? trim($_POST["password_old"]) : "";
  				$new->password_confirm = isset($_POST["password_confirm"]) && $_POST["password_confirm"] ? trim($_POST["password_confirm"]) : "";
  				
  				if(!$new->password_old){
  					$hasError = true;
  					$status .= "Current Password is missing.<br />";
  				}elseif($new->password_old != $record->password){
          	$hasError = true;
            $status .= "Current Password is wrong.<br />";
          }elseif(!$new->password_new){
  					$hasError = true;
  					$status .= "New Password is missing.<br />";
  				}elseif(strlen($new->password_new) < 3){
  					$hasError = true;
            $status .= "Password must be at least 3 characters long.<br />";
  				}elseif(!$new->password_confirm){
            $hasError = true;
            $status .= "Verify Password is missing.<br />";
          }elseif($new->password_confirm != $new->password_new){
          	$hasError = true;
            $status .= "Verify Password is wrong.<br />";
          }else{
          	$record->password = $new->password_new;
          }
        }
        if(!$hasError){
          if(!$this->sessionModel->saveRecord("users", get_object_vars($record))){
					 	$hasError = true;
            $status = "Error has occured. Please try again or contact support.";
          }
          else{
          	//FJF_BASE::redirect("/account-information/");
            $status = "Your account info updated successfully.";
          }
				}
      }//POST
			
			$templateParams = array(
        "has_error" => $hasError,
        "status" => $status,
        "header" => $header,
        "record" => $record,
        "new" => $new,
        "type" => $type
      );
			
			return $this->displayTemplate("account_information_edit.tpl", $templateParams);
		}
	}

?>