<?php

	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/user_model.php");

	class AccountPreferences extends FJF_CMD{
		
		var $sessionModel = null;
		var $usersModel = null;

		function __construct(){
			$this->sessionModel = new SessionModel();
			$this->userModel = new UserModel();
		}

		function execute(){
			require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["app_web_path"] . "/includes/header_commands.php");
			
			$header["title"] = "User Account Settings";
			
			$record = $this->sessionModel->getRecordBy("users", $this->sessionModel->uid);
			if(!$this->sessionModel->uid || !$record) FJF_BASE::redirect("/");
			
      if($_SERVER["REQUEST_METHOD"] == "POST"){
				
				$record->is_subscribed = isset($_POST["is_subscribed"]) && $_POST["is_subscribed"] ? intval($_POST["is_subscribed"]) : 0;
				
        if(!$this->sessionModel->saveRecord("users", get_object_vars($record))){
				 	$hasError = true;
          $status = "Error has occured. Please try again or contact support.";
        }else{
          $status = "Your account info updated successfully.";
					if($record->is_subscribed){
						$this->userModel->subscribeToList(get_object_vars($record));
					}else{
						$this->userModel->unsubscribeFromList(get_object_vars($record));
					}
        }
      }//POST
      
     	$backURL = (isset($_SERVER["HTTP_REFERER"]) && $_SERVER["HTTP_REFERER"] != "") ? parse_url($_SERVER["HTTP_REFERER"], PHP_URL_PATH) : "";
			
			$templateParams = array(
        "has_error" => $hasError,
        "status" => $status,
        "header" => $header,
        "back_url" => $backURL,
        "record" => $record
      );
			
			return $this->displayTemplate("account_preferences.tpl", $templateParams);
		}
	}

?>