<?php

	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/photo_model.php");

	class AdminBlogsEdit extends FJF_CMD
	{
		var $sessionModel = null;
		var $photoModel = null;

		function __construct()
		{
			$this->sessionModel = new SessionModel();
			$this->photoModel = new PhotoModel();
		}

		function execute()
		{
			require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["includes_path"] . "/admin_header_commands.php");

			$id = isset($_GET["id"]) && $_GET["id"] > 0 ? intval($_GET["id"]) : 0;

			$header["parent"] = array("blogs" => "Manage Blogs");
			$header["title"] = ($id ? "Edit" : "Add") . " Blog";

			$fields = array();
			$record = $id ? $this->sessionModel->getRecordBy("blogs", $id) : null;

			if($_SERVER["REQUEST_METHOD"] == "POST")
			{
				$action = isset($_POST["action"]) ? trim($_POST["action"]) : "";

				if ($action == "delete_photo" && $id > 0)
				{
					$fileName = (isset($_POST["filename"]) && $_POST["filename"] != "") ? trim($_POST["filename"]) : "";
					$fields["id"] = $id;
					$fields["photo"] = "";
					if ($this->sessionModel->saveRecord("blogs", $fields, "id"))
					{
						@unlink($_SERVER["DOCUMENT_ROOT"] . "/images/blogs/orig/" . $fileName);
					}
					else
					{
						$status = "Error has occured while deleting image.";
					}
					echo $status;
					exit;
				}

				if($id) $fields["id"] = $id;
				$fields["name"] = isset($_POST["name"]) ? addslashes(trim($_POST["name"])) : "";
				$fields["url_title"] = isset($_POST["url_title"]) ? htmlentities(trim($_POST["url_title"]), ENT_QUOTES) : "";
				$fields["author_id"] = (isset($_POST["author_id"]) && intval($_POST["author_id"]) > 0) ? intval($_POST["author_id"]) : 0;
				$fields["description"] = isset($_POST["description"]) ? addslashes(trim($_POST["description"])) : "";

				if(!$fields["name"])
				{
					$hasError = true;
					$status .= "Name is missing.<br />";
				}

				$fields["url_title"] = $fields["url_title"] ? $fields["url_title"] : $this->sessionModel->generateURL(stripslashes($fields["name"]), 0, "blogs");

				if(!$fields["url_title"])
				{
					$hasError = true;
					$status .= "URL is missing.<br />";
				}

				if($fields["author_id"] == 0)
				{
					$hasError = true;
					$status .= "Author is missing.<br />";
				}

				if(!$fields["description"])
				{
					$hasError = true;
					$status .= "Description is missing.<br />";
				}

				$photoOld = (isset($_POST["photo_old"]) && $_POST["photo_old"] != "") ? addslashes(trim($_POST["photo_old"])) : "";
				$fields["photo"] = $photoOld;
				if(isset($_FILES["photo"]['tmp_name']) && $_FILES["photo"]['tmp_name'] != "")
				{
					$fileName = time() . "";
					$uploadResult = $this->photoModel->upload("blogs", $fileName, "photo", false);

					if($uploadResult["error"] != "error_upload_file")
					{
						if($uploadResult["error"])
						{
							$hasError = true;
							$status .= $uploadResult["status"] . "<br />";
						}
						else
						{
							$fields["photo"] = $uploadResult["file"];
						}
					}
				}

				if(!$hasError)
				{
					if($result = $this->sessionModel->saveRecord("blogs", $fields))
					{
						FJF_BASE::redirect("/admin/blogs/");
					}
					else
					{
						$hasError = true;
						$status = "An error occured. Please try again later.";
					}
				}
			}//POST

			$record = (count($fields) > 0) ? (object) $fields : $record;

			$where = "is_admin = 1 AND user_type = 0";
			$authors = $this->sessionModel->getRecords("users", $where, null, null, "id, CONCAT(first_name, ' ', last_name) name");

			$templateParams = array(
        "status" => $status,
        "has_error" => $hasError,
        "header" => &$header,
        "record" => &$record,
        "authors" => $authors
      );

			return $this->displayTemplate("admin_blogs_edit.tpl", $templateParams);
		}

	}
?>