<?php

	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/admin_blogs_model.php");

	class AdminBlogsEntries extends FJF_CMD
	{
		var $sessionModel = null;
		var $adminBlogsModel = null;

		function __construct()
		{
			$this->sessionModel = new SessionModel();
			$this->adminBlogsModel = new AdminBlogsModel();
		}

		function execute()
		{
			require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["includes_path"] . "/admin_header_commands.php");

			$header["title"] = "Manage Blogs Entries";

			if($_SERVER["REQUEST_METHOD"] == "POST")
			{
				$deleteRecords = isset($_POST["delete_records"]) && is_array($_POST["delete_records"]) ? $_POST["delete_records"] : null;
				if(!empty($deleteRecords))
				{
					$deleteRecords = array_map("intval", $deleteRecords);
					if($result = $this->sessionModel->deleteRecords("blogs_entries", "id IN (" . join(",", $deleteRecords) . ")"))
					{
						$status = "Records were deleted successfully.";
					}
					else
					{
						$hasError = true;
						$status = "Error occured while deleting records.";
					}
				}
			}//POST

			$records = $this->adminBlogsModel->getEntries();

			$templateParams = array(
	      "status" => $status,
	      "has_error" => $hasError,
	      "header" => &$header,
	      "records" => &$records
	    );
			return $this->displayTemplate("admin_blogs_entries.tpl", $templateParams);
		}
	}

?>