<?php

	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/admin_blogs_model.php");

	class AdminBlogsEntriesCategories extends FJF_CMD
	{
		var $sessionModel = null;
		var $adminBlogsModel = null;

		function __construct()
		{
			$this->sessionModel = new SessionModel();
			$this->adminBlogsModel = new AdminBlogsModel();
		}

		function execute()
		{
			require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["includes_path"] . "/admin_header_commands.php");

			if($_SERVER["REQUEST_METHOD"] == "POST")
			{
				$deleteRecords = isset($_POST["delete_records"]) && is_array($_POST["delete_records"]) && count($_POST["delete_records"]) > 0 ? join(",", $_POST["delete_records"]) : null;
				if($deleteRecords)
				{
					if($result = $this->sessionModel->deleteRecords("blogs_entries_categories", "id IN (IDS_ARRAY)", array("IDS_ARRAY" => $deleteRecords)))
					{
						$status = "Records were deleted successfully.";
					}
					else
					{
						$hasError = true;
						$status = "Error occured while deleting records.";
					}
				}
			}//POST

			$records = $this->adminBlogsModel->getEntriesCategories();

			$header["title"] = "Manage Blogs Entries Categories";

			$templateParams = array(
        "status" => $status,
        "has_error" => $hasError,
        "header" => &$header,
        "records" => &$records
      );

			return $this->displayTemplate("admin_blogs_entries_categories.tpl", $templateParams);
		}

	}
?>