<?php

	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/admin_blogs_model.php");

	class AdminBlogsEntriesCategoriesEdit extends FJF_CMD
	{
		var $sessionModel = null;
		var $adminBlogsModel = null;

		function __construct()
		{
			$this->sessionModel = new SessionModel();
			$this->adminBlogsModel = new AdminBlogsModel();
		}

		function execute()
		{
			require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["includes_path"] . "/admin_header_commands.php");

			$id = isset($_GET["id"]) ? intval($_GET["id"]) : 0;

			$header["parent"] = array("blogs/categories" => "Manage Blogs Entries Categories");
			$header["title"] = ($id ? "Edit" : "Add") . " Blogs Entries Category";

			$record = $id ? $this->sessionModel->getRecordBy("blogs_entries_categories", $id) : null;

			if($_SERVER["REQUEST_METHOD"] == "POST")
			{
				if($id) $fields["id"] = $id;
				$fields["blog_id"] = (isset($_POST["blog_id"]) && intval($_POST["blog_id"])) ? intval($_POST["blog_id"]) : 0;
				$fields["title"] = isset($_POST["title"]) ? addslashes(trim($_POST["title"])) : "";
				$fields["url_title"] = isset($_POST["url_title"]) ? addslashes(trim($_POST["url_title"])) : "";
				$fields["meta_title"] = isset($_POST["meta_title"]) ? addslashes(trim($_POST["meta_title"])) : "";
				$fields["meta_description"] = isset($_POST["meta_description"]) ? addslashes(trim($_POST["meta_description"])) : "";
				$fields["meta_keywords"] = isset($_POST["meta_keywords"]) ? addslashes(trim($_POST["meta_keywords"])) : "";

				if(!$fields["blog_id"])
				{
					$hasError = true;
					$status .= "Select Blog.<br />";
				}

				if(!$fields["title"])
				{
					$hasError = true;
					$status .= "Title is missing.<br />";
				}

				$fields["url_title"] = $fields["url_title"] ? $fields["url_title"] : $this->sessionModel->generateURL(stripslashes($fields["title"]), 0, "blogs_categories");

				if(!$fields["url_title"])
				{
					$hasError = true;
					$status .= "URL is missing.<br />";
				}

				if(!$hasError)
				{
					if($result = $this->sessionModel->saveRecord("blogs_entries_categories", $fields))
					{
						FJF_BASE::redirect("/admin/blogs/entries_categories/");
					}
					else
					{
						$hasError = true;
						$status = "An error occured. Please try again later.";
					}
				}

				foreach($fields as $key => $value) $record->$key = $value;
			}//POST

			$record->blogs = $this->adminBlogsModel->getBlogs();

			$templateParams = array(
        "status" => $status,
        "has_error" => $hasError,
        "header" => &$header,
        "record" => &$record
      );

			return $this->displayTemplate("admin_blogs_entries_categories_edit.tpl", $templateParams);
		}

	}
?>