<?php

	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/admin_blogs_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/photo_model.php");

	class AdminBlogsEntriesEdit extends FJF_CMD
	{
		var $sessionModel = null;
		var $adminBlogsModel = null;
		var $photoModel = null;

		function __construct()
		{
			$this->sessionModel = new SessionModel();
			$this->adminBlogsModel = new AdminBlogsModel();
			$this->photoModel = new PhotoModel();
		}

		function execute()
		{
			require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["includes_path"] . "/admin_header_commands.php");

			$id = isset($_GET["id"]) ? intval($_GET["id"]) : 0;

			$header["parent"] = array("blogs/entries" => "Manage Blogs Entries");
			$header["title"] = ($id ? "Edit" : "Add") . " Blog Entry";

			$record = $id ? $this->sessionModel->getRecordBy("blogs_entries", $id) : new stdClass;

			if($_SERVER["REQUEST_METHOD"] == "POST")
			{
				$action = isset($_POST["action"]) ? trim($_POST["action"]) : "";
				if($id && $action == "delete_image")
				{
					$fileName = (isset($_POST["filename"]) && $_POST["filename"] != "") ? trim($_POST["filename"]) : "";
					$record->image = "";
					if($this->sessionModel->saveRecord("blogs_entries", get_object_vars($record)))
					{
						$path = $_SERVER["DOCUMENT_ROOT"] . "/images/blogs_entries/";
						@unlink($path . "orig/" . $fileName);
						@unlink($path . "m/" . $fileName);
						@unlink($path . "s/" . $fileName);
						$status = "Image was successfully deleted.";
					}
					else
					{
						$hasError = true;
						$status = "Error has occured while deleting image.";
					}
					$data = "<div class='box_" . ($hasError ? "error" : "success") . "'>" . $status . "</div><br />";
					exit($data);
				}

				if(!$id)
				{
					$record->datetime = date("Y-m-d H:i:s");
				}

				$record->blog_id = isset($_POST["blog_id"]) ? intval($_POST["blog_id"]) : 0;
				$record->user_id = $_SESSION["user"]->id;
				$record->author_id = (isset($_POST["author_id"]) && intval($_POST["author_id"]) > 0) ? intval($_POST["author_id"]) : 0;
				$record->title = isset($_POST["title"]) ? addslashes(trim($_POST["title"])) : "";
				$record->subtitle = isset($_POST["subtitle"]) ? addslashes(trim($_POST["subtitle"])) : "";
				$record->url_title = isset($_POST["url_title"]) ? addslashes(trim($_POST["url_title"])) : "";
				$record->intlink = isset($_POST["intlink"]) ? addslashes(trim($_POST["intlink"])) : "";
				$record->summary = isset($_POST["summary"]) ? addslashes(trim($_POST["summary"])) : "";
				$record->description = isset($_POST["description"]) ? addslashes(trim($_POST["description"])) : "";
				//$record->tags = isset($_POST["tags"]) ? preg_replace("/\s*,\s*/", ",", addslashes(trim($_POST["tags"]))) : "";
				$record->meta_title = isset($_POST["meta_title"]) ? addslashes(trim($_POST["meta_title"])) : "";
				$record->meta_description = isset($_POST["meta_description"]) ? addslashes(trim($_POST["meta_description"])) : "";
				$record->meta_keywords = isset($_POST["meta_keywords"]) ? addslashes(trim($_POST["meta_keywords"])) : "";
				$record->extra_header_tag = isset($_POST["extra_header_tag"]) && $_POST["extra_header_tag"] ? addslashes(trim($_POST["extra_header_tag"])) : "";

				$record->is_featured = isset($_POST["is_featured"]) ? intval($_POST["is_featured"]) : 0;
				$record->status = isset($_POST["status"]) ? intval($_POST["status"]) : 0;
				$record->published = isset($_POST["submit_publish"]) && $_POST["submit_publish"] ? 1 : 0;

				$record->datetime = isset($_POST["datetime"]) && $_POST["datetime"] ? strtotime($_POST["datetime"]) : time();
				$record->datetime = date("Y-m-d H:i:s", $record->datetime);
				
				$record->categories_ids = "";

				if(!$record->blog_id)
				{
					$hasError = true;
					$status .= "Select Blog.<br />";
				}else{
					$field = "categories_" . $record->blog_id . "_ids";
					$record->categories_ids = isset($_POST[$field]) && is_array($_POST[$field]) ? implode(",", $_POST[$field]) : "";
          $field = "blog_category_" . $record->blog_id . "_id";
          $record->blog_category_id = isset($_POST[$field]) ? intval($_POST[$field]) : 0;
				}

				if(!$record->title)
				{
					$hasError = true;
					$status .= "Title is missing.<br />";
				}

				$record->url_title = $record->url_title ? $record->url_title : $this->sessionModel->generateURL(stripslashes($record->title), 0, "blogs_entries");

				if(!$record->url_title)
				{
					$hasError = true;
					$status .= "URL is missing.<br />";
				}
				
				if(!$record->author_id)
				{
					$hasError = true;
					$status .= "Author is missing.<br />";
				}

				if(!$record->summary)
				{
					$hasError = true;
					$status .= "Summary is missing.<br />";
				}
				
				if(!$record->description)
				{
					$hasError = true;
					$status .= "Description is missing.<br />";
				}

				if(isset($_FILES["image"]["name"]) && trim($_FILES["image"]["name"]) != "")
				{
					$this->photoModel->defineThumb("m", 120);
					$image = $this->photoModel->upload("blogs_entries", null, "image", false);
					if(!$image["error"]) $record->image = $image["file"];
					else { $hasError = true; $status = $image["status"]; }
				}

				if(!$hasError)
				{
					if($result = $this->sessionModel->saveRecord("blogs_entries", get_object_vars($record)))
					{
						FJF_BASE::redirect("/admin/blogs/entries/");
					}
					else
					{
						$hasError = true;
						$status = "An error occured. Please try again later.";
					}
				}
			}//POST

			$record->blogs = $this->adminBlogsModel->getBlogs();
			$record->categories = $this->adminBlogsModel->getEntriesCategories();
      $record->blog_categories = $this->adminBlogsModel->getCategories();
			$where = "is_admin = 1 AND user_type = 0";
			$authors = $this->sessionModel->getRecords("users", $where, null, null, "id, CONCAT(first_name, ' ', last_name) name");

			$templateParams = array(
        "status" => $status,
        "has_error" => $hasError,
        "header" => &$header,
        "record" => &$record,
        "authors" => $authors
      );
			return $this->displayTemplate("admin_blogs_entries_edit.tpl", $templateParams);
		}
	}

?>