<?php

	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/pagination_model.php");

	class AdminCmsContent extends FJF_CMD
	{
		var $sessionModel = null;
		var $paginationModel = null;

		function __construct()
		{
			$this->sessionModel = new SessionModel();
			$this->paginationModel = new PaginationModel();
		}

		function execute()
		{
			require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["app_web_path"] . "/includes/admin_header_commands.php");

			$header["title"] = "Manage CMS Content";

			if($_SERVER["REQUEST_METHOD"] == "POST")
			{
				$idToDelete = isset($_POST["id_to_delete"]) ? intval($_POST["id_to_delete"]) : 0;
				if($idToDelete)
				{
					if($this->sessionModel->deleteRecord("cms_content", $idToDelete, "id"))
				  {
				  	$this->sessionModel->deleteRecord("cms_content_revisions", $idToDelete, "item_id");
				  	$status = "Record was successfully deleted.";
				  }
				  else
				  {
				  	$hasError = true;
				  	$status = "Error while deleting record from the database.";
				  }
				}

				$idToApprove = isset($_POST["id_to_approve"]) ? trim($_POST["id_to_approve"]) : '';
				if($idToApprove)
				{
					if($this->sessionModel->updateRecords("cms_content_revisions", "approval=1", "id IN (" . $idToApprove . ")"))
				  {
				  	$status = "Records were successfully approved.";
				  }
				  else
				  {
				  	$hasError = true;
				  	$status = "Error while approving records.";
				  }
				}
			}//POST

			$sortNames = array(
				'date_edited' => 'pr.revision_datetime',
				'id' => 'p.id',
				'user' => 'user_name',
				'date_publish' => 'pr.date_publish',
				'date_expiration' => 'pr.date_expiration',
				'status' => 'p.status',
				'url_title' => 'pr.url_title'
			);

			$sqlParam = array(
				'sort_name' => isset($_GET["sort_name"]) && $_GET["sort_name"] ? trim($_GET["sort_name"]) : "title",
				'sort_order' => isset($_GET["sort_order"]) && $_GET["sort_order"] ? strtolower(trim($_GET["sort_order"])) : "asc",
				'filter' => isset($_GET["filter"]) && $_GET["filter"] ? strtolower(trim($_GET["filter"])) : "none",
				'keyword' => isset($_POST["keyword"]) && trim($_POST["keyword"]) != "" ? trim($_POST["keyword"]) : ""
			);
			$sqlParam['SORT_NAME'] = str_replace(array_keys($sortNames), $sortNames, $sqlParam['sort_name']);
			$sql = " FROM cms_content p";
			$sql .= " LEFT JOIN cms_content_revisions pr ON p.current_id=pr.id";
			$sql .= " LEFT JOIN users u ON pr.user_id=u.id";
			$sql .= " LEFT JOIN users u2 ON p.user_id=u2.id";
			$sql .= " WHERE p.type='page'";
			if($sqlParam['filter'] == 'approval_queue')
			{
				$sql .= " AND IF(p.need_approval=1 AND pr.approval=0, 1, 0)";
			}
			elseif($sqlParam['filter'] == 'publish_expiration_queue')
			{
				$sql .= " AND (pr.date_publish > NOW() OR pr.date_expiration > NOW())";
			}
			if($sqlParam['keyword'] != "")
			{
				$sql .= " AND pr.title LIKE '%keyword%'";
			}

			$sqlc = "SELECT COUNT(p.id) cid" . $sql;

			$SELECT = "SELECT p.*, pr.title, pr.url_title, pr.date_publish, pr.date_expiration, pr.revision_datetime";
			$SELECT .= ", IF(p.need_approval=1 AND pr.approval=0, 1, 0) approval_queue, CONCAT(u.first_name, ' ', u.last_name) user_name";
			$SELECT .= ", CONCAT(u2.first_name, ' ', u2.last_name) editor";
			$SELECT .= ", IF(p.is_locked>0 AND p.is_locked<>" . $this->sessionModel->uid . " AND locked_time > '" . date("Y-m-d H:i:s", time() - 10800) . "', 1, 0) is_locked";
			$sql = $SELECT . $sql . " ORDER BY SORT_NAME sort_order";

			$url = '/admin/cms_content/?page=PAGE&sort_name=' . $sqlParam['sort_name'] . '&sort_order=' . $sqlParam['sort_order'] . '&filter=' . $sqlParam['filter'];

			$recordsCount = ($recordsCount = $this->sessionModel->selectRecords($sqlc, $sqlParam, true)) ? $recordsCount->cid : 0;
			$pages = $this->paginationModel->pages($url, $recordsCount, 25);
			$sql .= " LIMIT " . $this->paginationModel->limit;
			$records = $this->sessionModel->selectRecords($sql, $sqlParam);

			$templateParams = array(
        "status" => $status,
        "has_error" => $hasError,
        "header" => &$header,
        "records" => &$records,
        "pages" => &$pages,
        "sql_param" => &$sqlParam
      );
			return $this->displayTemplate("admin_cms_content.tpl", $templateParams);
		}
	}

?>