<?php

	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");

	class AdminCmsContentBuckets extends FJF_CMD
	{
		var $sessionModel = null;

		function __construct()
		{
			$this->sessionModel = new SessionModel();
		}

		function execute()
		{
			require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["includes_path"] . "/admin_header_commands.php");

			$header["parent"] = array("cms_content" => "Manage CMS Content");
			$header["title"] = "Manage Buckets";

			$pageID = (isset($_GET["page_id"]) && $_GET["page_id"] > 0) ? intval($_GET["page_id"]) : 0;
			if ($pageID == 0)
			{
				FJF_BASE::redirect("/admin/cms_content/");
			}
			
			$wherePrefix = "item_id=" . $pageID;

			if($_SERVER["REQUEST_METHOD"] == "POST")
			{
				$idToDelete = isset($_POST["id_to_delete"]) ? intval($_POST["id_to_delete"]) : 0;
				$move = isset($_POST["move"]) && is_array($_POST["move"]) ? $_POST["move"] : null;
				
				if($idToDelete)
				{
					$record = $this->sessionModel->getRecordBy("cms_content_buckets", $idToDelete);
					if($record && $this->sessionModel->deleteRecord("cms_content_buckets", $idToDelete))
					{
						$this->sessionModel->updateRecords("cms_content_buckets", "position=position-1", $wherePrefix . " AND position>" . $record->position);
						$status = "Record was successfully deleted.";
					}
					else
					{
						$hasError = true;
					  $status = "Error while deleting record from the database.";
					}
				}elseif($move){
          $params["POS_FROM"] = intval($move["from"]);
          $params["POS_TO"] = intval($move["to"]);
          if($this->sessionModel->getRecord("cms_content_buckets", $wherePrefix . " AND position=POS_FROM", $params)
					&& $this->sessionModel->getRecord("cms_content_buckets", $wherePrefix . " AND position=POS_TO", $params)){
	          if($params["POS_FROM"] != $params["POS_TO"]) $this->sessionModel->updateRecords("cms_content_buckets", "position=0", $wherePrefix . " AND position=POS_FROM", $params);
	          if($params["POS_FROM"] < $params["POS_TO"]){
	            $this->sessionModel->updateRecords("cms_content_buckets", "position=position-1", $wherePrefix . " AND position > POS_FROM AND position <= POS_TO", $params);
	          }elseif($params["POS_FROM"] > $params["POS_TO"]){
	            $this->sessionModel->updateRecords("cms_content_buckets", "position=position+1", $wherePrefix . " AND position >= POS_TO AND position < POS_FROM", $params);
	          }
	          if($params["POS_FROM"] != $params["POS_TO"]) $this->sessionModel->updateRecords("cms_content_buckets", "position=POS_TO", $wherePrefix . " AND position=0", $params);
	          return true;
					}else exit("false");
        }
			}//POST

			$records = $this->sessionModel->getRecords("cms_content_buckets", $wherePrefix . " ORDER BY position");

			$templateParams = array(
        "header" => &$header,
        "has_error" => $hasError,
        "status" => $status,
        "page_id" => $pageID,
        "records" => &$records
      );

			return $this->displayTemplate("admin_cms_content_buckets.tpl", $templateParams);
		}

	}
?>