<?php

	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");

	class AdminCmsContentBucketsEdit extends FJF_CMD
	{
		var $sessionModel = null;

		function __construct()
		{
			$this->sessionModel = new SessionModel();
		}

		function execute()
		{
			require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["includes_path"] . "/admin_header_commands.php");

			$pageID = (isset($_GET["page_id"]) && $_GET["page_id"] > 0) ? intval($_GET["page_id"]) : 0;
			if($pageID == 0) FJF_BASE::redirect("/admin/cms_content/");

			$id = (isset($_GET["id"]) && $_GET["id"] > 0) ? intval($_GET["id"]) : 0;
			
			$record = $id ? $this->sessionModel->getRecordBy("cms_content_buckets", $id) : null;
			if($id && !$record) FJF_BASE::redirect("/admin/cms_content/buckets/" . $pageID);

			$header["parent"] = array("cms_content" => "Manage CMS Content", "buckets/" . $pageID => "Manage Buckets");
			if($id) $header["title"] = "Edit Bucket";
			else $header["title"] = "Add Bucket";

			// POST METHOD STARTS
			if ($_SERVER["REQUEST_METHOD"] == "POST")
			{
				$record->item_id = $pageID;
				$record->title = isset($_POST["title"]) ? htmlentities(trim($_POST["title"]), ENT_QUOTES) : "";
				$record->description = isset($_POST["description"]) ? htmlentities(trim($_POST["description"]), ENT_QUOTES) : "";
				$record->bottom_text = isset($_POST["bottom_text"]) ? htmlentities(trim($_POST["bottom_text"])) : "";
				$record->link = isset($_POST["link"]) ? htmlentities(trim($_POST["link"]), ENT_QUOTES) : "";

				if (!$record->title)
				{
					$hasError = true;
					$status .= "Title is missing.<br />";
				}

				if (!$record->description)
				{
					$hasError = true;
					$status .= "Description is missing.<br />";
				}
				
				if (!$record->link)
				{
					$hasError = true;
					$status .= "Link is missing.<br />";
				}else{
					$pos1 = strpos($record->link, "/");
					$pos2 = strpos($record->link, "http://");
					$pos3 = strpos($record->link, "https://");
					if($pos1 === false && $pos2 === false && $pos3 === false){
						$hasError = TRUE;
						$status .= "Invalid format Link.<br />";
					}
				}

				if (!$hasError)
				{
					if ($result = $this->sessionModel->saveRecord("cms_content_buckets", get_object_vars($record)))
					{
						if(!$id) $this->sessionModel->updateRecords("cms_content_buckets", "position=position+1", "item_id=" . $pageID);
						FJF_BASE::redirect("/admin/cms_content/buckets/" . $pageID);
					}
					else
					{
						$hasError = true;
						$status = "Error while updating location info. Please, try again later and contact support.";
					}
				}
			} // /POST

			$templateParams = array(
        "header" => &$header,
        "has_error" => $hasError,
        "status" => $status,
        "record" => &$record,
        "page_id" => $pageID,
        "id" => $id
      );

			return $this->displayTemplate("admin_cms_content_buckets_edit.tpl", $templateParams);
		}
	}

?>