<?php

	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/main_model.php");

	class AdminCmsContentCategories extends FJF_CMD
	{
		var $sessionModel = null;
		var $mainModel = null;

		function __construct()
		{
			$this->sessionModel = new SessionModel();
			$this->mainModel = new MainModel();
		}

		function execute()
		{
			require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["app_web_path"] . "/includes/admin_header_commands.php");

			$header["title"] = "Manage CMS Content Categories";

			if($_SERVER["REQUEST_METHOD"] == "POST")
			{
				$deleteRecords = isset($_POST["delete_records"]) && is_array($_POST["delete_records"]) && count($_POST["delete_records"]) > 0 ? join(",", $_POST["delete_records"]) : null;
				if($deleteRecords)
				{
					if($result = $this->sessionModel->deleteRecords("cms_content_categories", "id IN (IDS_ARRAY)", array("IDS_ARRAY" => $deleteRecords)))
					{
						$this->mainModel->restorePositions("cms_content_categories");
						$status = "Records were deleted successfully.";
					}
					else
					{
						$hasError = true;
						$status = "Error occured while deleting records.";
					}
				}

				$move = isset($_POST["move"]) ? $_POST["move"] : false;
		        if($move)
		        {
					$params = array(
									"POSITION_FROM" => intval($move["from"]),
									"POSITION_TO" => intval($move["to"])
									);
		          	if($params["POSITION_FROM"] != $params["POSITION_TO"]) $this->sessionModel->updateRecords("cms_content_categories", "position=0", "position=POSITION_FROM", $params);
		          	if($params["POSITION_FROM"] < $params["POSITION_TO"])
		          	{
		            	$this->sessionModel->updateRecords("cms_content_categories", "position=position-1", "position > POSITION_FROM AND position <= POSITION_TO ORDER BY position", $params);
		          	}
		          	elseif($params["POSITION_FROM"] > $params["POSITION_TO"])
		          	{
		            	$this->sessionModel->updateRecords("cms_content_categories", "position=position+1", "position >= POSITION_TO AND position < POSITION_FROM ORDER BY position DESC", $params);
		          	}
		          	if($params["POSITION_FROM"] != $params["POSITION_TO"]) $this->sessionModel->updateRecords("cms_content_categories", "position=POSITION_TO", "position=0", $params);
		          	return true;
		        }
			}//POST

			$records = $this->sessionModel->getRecords("cms_content_categories", "1 ORDER BY position");

			$templateParams = array(
        "status" => $status,
        "has_error" => $hasError,
        "header" => &$header,
        "records" => &$records
      );
			return $this->displayTemplate("admin_cms_content_categories.tpl", $templateParams);
		}
	}

?>