<?php

	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/main_model.php");

	class AdminCmsContentCategoriesEdit extends FJF_CMD
	{
		var $sessionModel = null;
		var $mainModel = null;

		function __construct()
		{
			$this->sessionModel = new SessionModel();
			$this->mainModel = new MainModel();
		}

		function execute()
		{
			require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["app_web_path"] . "/includes/admin_header_commands.php");

			$id = isset($_GET["id"]) && $_GET["id"] > 0 ? intval($_GET["id"]) : 0;

			$header["parent"] = array("cms_content_categories" => "Manage CMS Content Categories");
			$header["title"] = ($id ? "Edit" : "Add") . " CMS Content Category";

			$record = $id ? $this->sessionModel->getRecordBy("cms_content_categories", $id) : null;
			if($id && !$record) FJF_BASE::redirect("/admin/cms_content_categories/");

			if($_SERVER["REQUEST_METHOD"] == "POST")
			{
				if(!$id) $record->position = intval($this->mainModel->getMaxPosition("cms_content_categories")) + 1;

				$action = isset($_POST["action"]) ? trim($_POST["action"]) : "";

				$record->name = isset($_POST["name"]) ? addslashes(trim($_POST["name"])) : "";
				$record->full_name = isset($_POST["full_name"]) ? addslashes(trim($_POST["full_name"])) : "";
				$record->url_title = isset($_POST["url_title"]) ? addslashes(trim($_POST["url_title"])) : "";
				//$record->description = isset($_POST["description"]) ? addslashes(trim($_POST["description"])) : "";
				$record->parent_id = isset($_POST["parent_id"]) ? intval($_POST["parent_id"]) : 0;
				$record->status = isset($_POST["status"]) ? intval($_POST["status"]) : 0;

				//if(!$id && $record->name) $record->url_title = $this->sessionModel->generateURL(stripslashes($record->name), 0, "cms_content_categories");

				if(!$record->name)
				{
					$hasError = true;
					$status .= "Name is missing.<br />";
				}

				if(!$record->url_title)
				{
					$hasError = true;
					$status .= "URL Title is missing.<br />";
				}

				//if(!$record->description)
				//{
				//	$hasError = true;
				//	$status .= "Description is missing.<br />";
				//}

				if(!$hasError)
				{
					if($result = $this->sessionModel->saveRecord("cms_content_categories", get_object_vars($record)))
					{
						FJF_BASE::redirect("/admin/cms_content_categories/");
					}
					else
					{
						$hasError = true;
						$status = "An error occured. Please try again later.";
					}
				}
			}//POST

			$records = $this->sessionModel->getRecords("cms_content_categories", "parent_id=0" . ($id ? " AND id<>" . $id : "") . " ORDER BY name");

			$templateParams = array(
	      "status" => $status,
	      "has_error" => $hasError,
	      "header" => &$header,
	      "record" => &$record,
	      "records" => &$records
	    );
			return $this->displayTemplate("admin_cms_content_categories_edit.tpl", $templateParams);
		}
	}

?>