<?php

	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");

	class AdminCmsContentEdit extends FJF_CMD
	{
		var $sessionModel = null;

		function __construct()
		{
			$this->sessionModel = new SessionModel();
		}

		function execute()
		{
			require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["app_web_path"] . "/includes/admin_header_commands.php");

			$id = (isset($_GET["id"]) && $_GET["id"] > 0) ? intval($_GET["id"]) : 0;
			$header["parent"] = array("cms_content" => "Manage CMS Content");
			$header["title"] = ($id ? "Edit" : "Add") . " Entry";

			$cmsContentRecord = $id ? $this->sessionModel->getRecordBy("cms_content", $id) : null;
			if($cmsContentRecord && $cmsContentRecord->is_locked > 0 && $cmsContentRecord->is_locked != $this->sessionModel->uid
			&& strtotime($cmsContentRecord->locked_time) > time() - 1800) FJF_BASE::redirect("/admin/cms_content/");
			$this->sessionModel->lock("cms_content", $id);

			if($cmsContentRecord) $this->sessionModel->saveRecord("cms_content", array("id" => $id, "user_id" => $this->sessionModel->uid, "date_edited" => date("Y-m-d H:i:s")));
			$fields = array();
			$fields2 = array();
			// POST METHOD STARTS
			if($_SERVER["REQUEST_METHOD"] == "POST")
			{
				$cancelModify = isset($_POST["cancelModify"]) ? intval($_POST["cancelModify"]) : 0;
				if($cancelModify){
					$this->sessionModel->unlock("cms_content", $cancelModify);
					FJF_BASE::redirect("/admin/cms_content/");
				}

				if($id) $fields2["id"] = $id;
				else $fields2["type"] = "page";

				$fields["item_id"] = $id ? $id : 0;
				$fields["user_id"] = $this->sessionModel->uid;
				$fields["title"] = isset($_POST["title"]) && $_POST["title"] ? addslashes(trim($_POST["title"])) : "";
				$fields["url_title"] = (isset($_POST["url_title"]) && $_POST["url_title"] != "") ? htmlentities(trim($_POST["url_title"]), ENT_QUOTES) : $fields["title"];
				$fields["url_title"] = $this->generateURL($fields["url_title"], $id);
				$fields["description"] = isset($_POST["description"]) && $_POST["description"] ? trim($_POST["description"]) : "";
				$fields["tags"] = isset($_POST["tags"]) && $_POST["tags"] ? htmlentities(trim($_POST["tags"]), ENT_QUOTES) : "";
				$fields["meta_title"] = isset($_POST["meta_title"]) && $_POST["meta_title"] ? htmlentities(trim($_POST["meta_title"]), ENT_QUOTES) : "";
				$fields["meta_description"] = isset($_POST["meta_description"]) && $_POST["meta_description"] ? htmlentities(trim($_POST["meta_description"]), ENT_QUOTES) : "";
				$fields["meta_keywords"] = isset($_POST["meta_keywords"]) && $_POST["meta_keywords"] ? htmlentities(trim($_POST["meta_keywords"]), ENT_QUOTES) : "";

				$fields["use_date_publish"] = isset($_POST["use_date_publish"]) && $_POST["use_date_publish"] ? true : false;
				$fields["date_publish"] = null;
				if($fields["use_date_publish"])
				{
					$fields["date_publish"] = isset($_POST["date_publish"]) && $_POST["date_publish"] ? strtotime($fields["date_publish"]) : "";
					if(!$fields["date_publish"]) $fields["date_publish"] = time();
					$fields["date_publish"] = date("Y-m-d H:i:s", $fields["date_publish"]);
				}

				$fields["use_date_expiration"] = isset($_POST["use_date_expiration"]) && $_POST["use_date_expiration"] ? true : false;
				$fields["date_expiration"] = null;
				if($fields["use_date_expiration"])
				{
					$fields["date_expiration"] = isset($_POST["date_expiration"]) && $_POST["date_expiration"] ? strtotime($fields["date_expiration"]) : "";
					if(!$fields["date_expiration"]) $fields["date_expiration"] = time();
					$fields["date_expiration"] = date("Y-m-d H:i:s", $fields["date_expiration"]);
				}

				$fields2["color"] = isset($_POST["color"]) ? htmlentities(trim($_POST["color"]), ENT_QUOTES) : "";

				$fields2["status"] = isset($_POST["status"]) && $_POST["status"] ? 1 : 0;
				if($isAdmin == 2)
				{
					$fields2["need_approval"] = isset($_POST["need_approval"]) && $_POST["need_approval"] ? 1 : 0;
				}
				else $fields2["need_approval"] = $cmsContentRecord ? $cmsContentRecord->need_approval : 1;

				$fields["approval"] = isset($_POST["submit_approve"]) && $_POST["submit_approve"] ? 1 : 0;
				$fields["published"] = (isset($_POST["submit_publish"]) && $_POST["submit_publish"]) || $fields["approval"] ? 1 : 0;
				
				$fields["is_index"] = isset($_POST["is_index"]) && $_POST["is_index"] ? true : false;

				if(!$hasError)
				{
					$fields2["user_id"] = $fields["user_id"];
					$fields2["date_edited"] = date("Y-m-d H:i:s");

					$result = $this->sessionModel->saveRecord("cms_content", $fields2);
					if(!$fields["item_id"]) $fields["item_id"] = $result;
					$result = $this->sessionModel->saveRecord("cms_content_revisions", $fields);

					if($result)
					{
						if(!$id || $fields["published"])
						{
							$fields2["id"] = $fields["item_id"];
							$fields2["current_id"] = $result;
							if($fields2["need_approval"] && !$fields["approval"])
							{
								$emails = $this->sessionModel->getRecordBy("site_vars", "new_approval_notification", "name");
								$emails = $emails ? explode(",", $emails->value) : array();
								$emails = array_filter($emails, "strlen");
								if(!empty($emails))
								{
									$mSubject = "New Approval Notification";
									$mMessage = "http://" . $_SERVER["SERVER_NAME"] . "/admin/cms_content/";
									$mHeaders = "From: " . $GLOBALS["WEB_APPLICATION_CONFIG"]["from_name"] . " <" . $GLOBALS["WEB_APPLICATION_CONFIG"]["from_email"] . ">";
									foreach($emails as $email) mail($email, $mSubject, $mMessage, $mHeaders);
								}
							}
							$this->sessionModel->saveRecord("cms_content", $fields2);
						}
						$this->sessionModel->unlock("cms_content", $fields2["id"]);
						FJF_BASE::redirect("/admin/cms_content/");
					}
					else
					{
						$hasError = true;
						$status = "Error while updating record. Please, try again later and contact support.";
					}
				}

			} // /POST

			$sql = "SELECT pr.*, CONCAT(u.first_name, ' ', u.last_name) user";
			$sql .= " FROM cms_content_revisions pr";
			$sql .= " LEFT JOIN users u ON pr.user_id=u.id";
			$sql .= " WHERE item_id=" . $id;
			$sql .= " ORDER BY id DESC";
			$sql .= " LIMIT 20";
			$records = $id ? $this->sessionModel->selectRecords($sql) : null;
			if($cmsContentRecord && $records)
			{
				$record = get_object_vars($cmsContentRecord);
				foreach($records as $r)
				{
					if($r->id == $record["current_id"])
					{
						$record = array_merge(get_object_vars($r), $record);
						break;
					}
				}
			}
			else $record = array();
			$record = array_merge($record, $fields);

			$colors = array("green", "cyan", "pink", "orange", "purple", "red", "blue");
			
			$templateParams = array(
        "status" => $status,
        "has_error" => $hasError,
        "header" => &$header,
        "has_error" => $hasError,
        "records" => &$records,
        "record" => &$record,
        "colors" => &$colors
      );
			return $this->displayTemplate("admin_cms_content_edit.tpl", $templateParams);
		}

		function generateURL($text, $id)
		{
			$table = "cms_content_revisions";
			$field = "url_title";
			$delim = "-";
			$text = trim(preg_replace("/[^" . $delim . "A-Za-z0-9]+/",$delim,strtolower($text)), $delim);

			if ($similarURLs = $this->sessionModel->getRecords($table, $field . " REGEXP '^(" . $text . "|" . $text . $delim . "[[:digit:]]+)$'", null, null, "item_id, " . $field))
			{


				foreach ($similarURLs as $k => $v)
				{
					$n = str_replace(array($text, $delim), "", $v->$field);
					if($id > 0 && $v->item_id == $id) return $v->$field;
					$similarURLs[$k] = $n;
				}
				$similarURLs = array_map("intval", $similarURLs);
				sort($similarURLs, SORT_NUMERIC);
				$text .= $delim . (array_pop($similarURLs) + 1);
			}
			return $text;
		}//generateURL

	}

?>