<?php

	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/global_seo_controller_model.php");

	class AdminGlobalSeoController extends FJF_CMD
	{
		var $sessionModel = null;
		var $globalSeoControllerModel = null;

		function __construct()
		{
			$this->sessionModel = new SessionModel();
			$this->globalSeoControllerModel = new GlobalSeoControllerModel();
		}

		function execute()
		{
			require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["app_web_path"] . "/includes/admin_header_commands.php");

			$header["title"] = "Manage Global SEO Controller Items";

			if($_SERVER["REQUEST_METHOD"] == "POST")
			{
				$idToDelete = isset($_POST["id_to_delete"]) ? intval($_POST["id_to_delete"]) : 0;
				if($idToDelete)
				{
					if($this->globalSeoControllerModel->delete(array($idToDelete)))
				  {
				  	$status = "Record was successfully deleted.";
				  }
				  else
				  {
				  	$hasError = true;
				  	$status = "Error while deleting record from the database.";
				  }
				}
			}//POST

			$records = $this->globalSeoControllerModel->collection();

			$templateParams = array(
			                        "status" => $status,
			                        "has_error" => $hasError,
			                        "header" => &$header,
			                        "records" => &$records
			                        );

			$this->displayTemplate("admin_global_seo_controller.tpl", $templateParams);

			return true;
		}

	}
?>