<?php

	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/global_seo_controller_model.php");

	class AdminGlobalSeoControllerEdit extends FJF_CMD
	{
		var $sessionModel = null;
		var $globalSeoControllerModel = null;

		function __construct()
		{
			$this->sessionModel = new SessionModel();
			$this->globalSeoControllerModel = new GlobalSeoControllerModel();
		}

		function execute()
		{
			require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["app_web_path"] . "/includes/admin_header_commands.php");

			$id = isset($_GET["id"]) ? intval($_GET["id"]) : 0;
			$action = $id ? "Edit" : "Add";
			$header["parent"] = array("global_seo_controller" => "Manage Global SEO Controller Items");
			$header["title"] = $action . " Global SEO Controller Item";


			$formFields = array();

			if($_SERVER["REQUEST_METHOD"] == "POST")
			{
				$formFields["id"] = $id;
				$formFields["text"] = isset($_POST["text"]) ? trim($_POST["text"]) : "";
				$formFields["mask"] = isset($_POST["mask"]) ? trim($_POST["mask"]) : "";
				$formFields["meta_title"] = (isset($_POST["meta_title"]) && $_POST["meta_title"] != "") ? htmlentities(stripslashes(trim($_POST["meta_title"])), ENT_QUOTES, 'UTF-8') : "";
				$formFields["meta_keywords"] = (isset($_POST["meta_keywords"]) && $_POST["meta_keywords"] != "") ? htmlentities(trim($_POST["meta_keywords"]), ENT_QUOTES, 'UTF-8') : "";
				$formFields["meta_description"] = (isset($_POST["meta_description"]) && $_POST["meta_description"] != "") ? htmlentities(trim($_POST["meta_description"]), ENT_QUOTES, 'UTF-8') : "";
				$formFields["extra_header_tags"] = (isset($_POST["extra_header_tags"]) && $_POST["extra_header_tags"] != "") ? stripslashes(trim($_POST["extra_header_tags"])) : "";
				$formFields["pixel_top"] = (isset($_POST["pixel_top"]) && $_POST["pixel_top"] != "") ? stripslashes(trim($_POST["pixel_top"])) : "";
				$formFields["pixel_bottom"] = (isset($_POST["pixel_bottom"]) && $_POST["pixel_bottom"] != "") ? stripslashes(trim($_POST["pixel_bottom"])) : "";
				
				if(!$formFields["text"])
				{
					$hasError = true;
					$status = "Text is empty";
				}

				if(!$formFields["mask"])
				{
					$hasError = true;
					$status = "URL is empty";
				}
				
				if(!$hasError)
				{
					if($this->globalSeoControllerModel->save($formFields))
					{
						FJF_BASE::redirect("/admin/global_seo_controller/");
					}
					else
					{
						$hasError = true;
						$status = "An error occured while saving record.";
					}
				}
			}//POST

			$record = $this->globalSeoControllerModel->text($id);

			$templateParams = array(
			                        "status" => $status,
			                        "has_error" => $hasError,
			                        "header" => &$header,
			                        "has_error" => $hasError,
			                        "records" => &$records,
			                        "record" => &$record
			                        );

			$this->displayTemplate("admin_global_seo_controller_edit.tpl", $templateParams);

			return true;
		}

	}
?>