<?php

	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/file_model.php");

	class AdminHelpdeskRequestsEdit extends FJF_CMD
	{
		var $sessionModel = null;
		var $fileModel = null;
		function __construct()
		{
			$this->sessionModel = new SessionModel();
			$this->fileModel = new FileModel();
		}

		function execute()
		{
			require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["includes_path"] . "/admin_header_commands.php");

			$record = null;

			$priorities = array(3 => "Low", 2 => "Normal", 1 => "Urgent");
			$success = false;
			$hasError = false;
			$status = "";
			$mediaPath = $GLOBALS["WEB_APPLICATION_CONFIG"]["trello"]["media_path"];
			$header["title"] = "Create Help Ticket";

			// POST METHOD STARTS
			if ($_SERVER["REQUEST_METHOD"] == "POST")
			{
				$fields["title"] = isset($_POST["title"]) ? htmlentities(trim($_POST["title"]), ENT_QUOTES) : "";
				$fields["description"] = isset($_POST["description"]) ? htmlentities(trim($_POST["description"]), ENT_QUOTES) : "";
				$fields["priority"] = isset($_POST["priority"]) ? $priorities[$_POST["priority"]]: "";
				$fields["attachments"] = array();

				if(!$fields["title"]){
					$hasError = true;
					$status .= "Title cannot be blank.\n";
				}

				if(isset($_FILES["attachments"]["name"][0]) && $_FILES["attachments"]["name"][0] != "")
				{
					foreach($_FILES['attachments']['tmp_name'] as $key => $tmp_name ){
				    $fileName = substr($_FILES['attachments']['name'][$key], 0, strrpos($_FILES['attachments']['name'][$key], ".")) . "-" . time() . "";
						$imageInfo = $this->fileModel->_upload($mediaPath, $fileName, "attachments", false, 10485760, $key);

						if (!$imageInfo["error"])  $fields["attachments"][] = array("file_name" => $imageInfo["file"], "file_name_orig" => $_FILES['attachments']['name'][$key]);
						else {
							$hasError = true;
							$status .= $imageInfo["status"];
							break;
						}
					}
				}

				if (!$hasError)
				{
					include_once($_SERVER["DOCUMENT_ROOT"] . "/fitch/resources/PHPMailer/class.phpmailer.php");

					$phpMailer = new PHPMailer();
			    $phpMailer->IsSMTP();
			    $phpMailer->SMTPAuth = true;
			    $phpMailer->SMTPSecure = 'ssl';
			    $phpMailer->Host = $GLOBALS["WEB_APPLICATION_CONFIG"]["trello"]["sendgrid_server"];
			    $phpMailer->Port = 465;
			    $phpMailer->Username = $GLOBALS["WEB_APPLICATION_CONFIG"]["trello"]["sendgrid_user"];
			    $phpMailer->Password = $GLOBALS["WEB_APPLICATION_CONFIG"]["trello"]["sendgrid_password"];

			    if(!empty($fields["attachments"]))
					{
						foreach($fields["attachments"] as $attachment)
						{
							$phpMailer->AddAttachment($mediaPath . $attachment["file_name"], $attachment["file_name_orig"]);
						}
					}
			    $phpMailer->SetFrom($GLOBALS["WEB_APPLICATION_CONFIG"]["email_from_setting"]["address"], $GLOBALS["WEB_APPLICATION_CONFIG"]["email_from_setting"]["name"]);
          $phpMailer->AddReplyTo($GLOBALS["WEB_APPLICATION_CONFIG"]["email_from_setting"]["address"], $GLOBALS["WEB_APPLICATION_CONFIG"]["email_from_setting"]["name"]);
          $phpMailer->Subject = $fields["title"];
			    $phpMailer->Body = "<b>Source URL: </b><a href='" . $_SERVER["SERVER_NAME"] . "'>" . $_SERVER["SERVER_NAME"] . "</a><br/>" . $fields["description"] . "<br/><br/><b>Priority: </b>" . $fields["priority"] . "<br/>";
			    $phpMailer->IsHTML(true);

					$phpMailer->ClearAddresses();
					$phpMailer->AddAddress($GLOBALS["WEB_APPLICATION_CONFIG"]["trello"]["board_email"]);
					$hasError = $phpMailer->isError();
					$phpMailer->Send();

					if (!$hasError)
					{
						$success = true;
						$status = "Help Ticket successfully added.";
					}
					else
					{
						$hasError = true;
						$status = "An error occurred while saving record to DB. Please, try again later and contact support.";
					}
				}

				$record = $fields;
			} // /POST
			$templateParams = array(
															"header" => &$header,
															"has_error" => $hasError,
															"status" => $status,
															"success" => $success,
															"record" => &$record,
															"priorities" => $priorities
															);

			$this->displayTemplate("admin_helpdesk_requests_edit.tpl", $templateParams);

			return true;
		}

	}
?>