<?php

	/**
	* Fitch & Josephine Group, LLC, 2010
	*/

	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");

	class AdminMenus extends FJF_CMD
	{
		var $sessionModel = null;

		function __construct()
		{
			$this->sessionModel = new SessionModel();
		}

		function execute()
		{
			require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["includes_path"] . "/admin_header_commands.php");

			$header["title"] = "Content Organizer Controller";

			if($_SERVER["REQUEST_METHOD"] == "POST")
			{
				$idToDelete = isset($_POST["id_to_delete"]) ? intval($_POST["id_to_delete"]) : 0;
				if($idToDelete)
				{
					if($this->sessionModel->deleteRecord("menus", $idToDelete))
				  {
				  	$status = "Record was successfully deleted.";
				  }
				  else
				  {
				  	$hasError = true;
				  	$status = "Error while deleting record from the database.";
				  }
				}
			}//POST

			$records = $this->sessionModel->getRecords("menus", "1 ORDER BY title");

			$templateParams = array(
			                        "status" => $status,
			                        "has_error" => $hasError,
			                        "header" => &$header,
			                        "records" => &$records
			                        );

			$this->displayTemplate("admin_menus.tpl", $templateParams);

			return true;
		}

	}
?>