<?php

	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");

	class AdminMenusEdit extends FJF_CMD{
		var $sessionModel = null;

		function __construct(){
			$this->sessionModel = new SessionModel();
		}

		function execute(){
			require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["includes_path"] . "/admin_header_commands.php");

			$id = isset($_GET["id"]) && $_GET["id"] > 0 ? intval($_GET["id"]) : 0;
			$record = $id ? $this->sessionModel->getRecordBy("menus", $id) : null;
			if($id && !$record) FJF_BASE::redirect("/admin/menus/");
			
			$header["parent"] = array("menus" => "Content Organizer Controller");
			$header["title"] = ($id ? "Edit" : "Add"). " Menu";
			
			if($_SERVER["REQUEST_METHOD"] == "POST"){
				$record->title = isset($_POST["title"]) && $_POST["title"] ? htmlentities(trim($_POST["title"]), ENT_QUOTES) : "";
				$record->items = isset($_POST["items"]) ? stripslashes($_POST["items"]) : "";
				
				if(!unserialize($record->items)) $record->items = "";
				
				if(!$record->title){
					$hasError = true;
					$status .= "Title is empty.<br />";
				}
				
				if(!$hasError){
					if($this->sessionModel->saveRecord("menus", get_object_vars($record))) FJF_BASE::redirect("/admin/menus/");
					else{
						$hasError = true;
						$status = "Error while updating record info. Please, try again later and contact support.";
					}
				}

			}//POST
			
			$links = $this->sessionModel->getRecords("menus_links", "1 ORDER BY title");
			
			$templateParams = array(
        "status" => $status,
        "has_error" => $hasError,
        "header" => $header,
        "record" => $record,
        "links" => $links
      );
			return $this->displayTemplate("admin_menus_edit.tpl", $templateParams);
		}
	}

?>