<?php

	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");

	class AdminMenusLinksEdit extends FJF_CMD{
		var $sessionModel = null;

		function __construct(){
			$this->sessionModel = new SessionModel();
		}

		function execute(){
			require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["includes_path"] . "/admin_header_commands.php");

			$id = (isset($_GET["id"]) && $_GET["id"] > 0) ? intval($_GET["id"]) : 0;
			$header["parent"] = array("menus" => "Content Organizer Controller", "links" => "Manage Links");
			$header["title"] = ($id ? "Edit" : "Add")." External Link";

			$fields = array();
			
			if($_SERVER["REQUEST_METHOD"] == "POST")
			{
				$isAjax = isset($_SERVER['HTTP_X_REQUESTED_WITH']) && ($_SERVER['HTTP_X_REQUESTED_WITH'] == 'XMLHttpRequest');
				if($id) $fields["id"] = $id;
				$fields["title"] = isset($_POST["title"]) && $_POST["title"] ? htmlentities(trim($_POST["title"]), ENT_QUOTES) : "";
				$fields["meta_title"] = isset($_POST["meta_title"]) && $_POST["meta_title"] ? htmlentities(trim($_POST["meta_title"]), ENT_QUOTES) : "";
				$fields["url"] = isset($_POST["url"]) && $_POST["url"] != "" ? trim($_POST["url"]) : "";
				
				$fields["sub_title"] = isset($_POST["sub_title"]) && $_POST["sub_title"] ? htmlentities(trim($_POST["sub_title"]), ENT_QUOTES) : "";
				$fields["description"] = isset($_POST["description"]) && $_POST["description"] ? htmlentities(trim($_POST["description"]), ENT_QUOTES) : "";
				
				if(!$fields["url"])
				{
					$hasError = true;
					$status .= "Url is empty.<br />";
				}
				
				if(!$fields["title"])
				{
					$hasError = true;
					$status .= "Title is empty.<br />";
				}
				
				if(!$hasError)
				{
					$result = $this->sessionModel->saveRecord("menus_links", $fields);
					if($result)
					{
						if(!$isAjax) FJF_BASE::redirect("/admin/menus/links/");
					}
					else
					{
						$hasError = true;
						if(strpos($GLOBALS["WEB_APPLICATION_CONFIG"]["db_error"], 'Duplicate') !== false) $status = "This URL already exists in Menu Items.<br />";
						else $status = "Error while updating record info. Please, try again later and contact support.<br />";
					}
				}
				
				if($isAjax) exit(FJF_BASE::serialize(array("status" => $status, "has_error" => $hasError)));
			}//POST
			
			$record = $id ? $this->sessionModel->getRecordBy("menus_links", $id) : null;
			$record = $record ? $record : array();
			if(is_object($record)) $record = get_object_vars($record);
			$record = array_merge($record, $fields);
			
			$templateParams = array(
	      "status" => $status,
	      "has_error" => $hasError,
	      "header" => &$header,
	      "record" => &$record
	   	);
			return $this->displayTemplate("admin_menus_links_edit.tpl", $templateParams);
		}
	}

?>