<?php

	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");

	class AdminPermissions extends FJF_CMD
	{
		var $sessionModel = null;

		function __construct()
		{
			$this->sessionModel = new SessionModel();
		}

		function execute()
		{
			require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["app_web_path"] . "/includes/admin_header_commands.php");

			$id = isset($_GET["id"]) ? intval($_GET["id"]) : 0;

			$workTable = "admin_permissions";
			$actionName = "Admin Permission";
			$actionNames = "Admin Permissions";

			$adminTools = $this->sessionModel->getFrom("admin_tools", "1 ORDER BY title");

			$fields = array();

			if($_SERVER["REQUEST_METHOD"] == "POST")
			{
				$fields["user_id"] = $id;
				$fields["permissions"] = isset($_POST["permissions"]) && is_array($_POST["permissions"]) ? $_POST["permissions"] : array();
				$fields["permissions"] = join(",", $fields["permissions"]);

				if(!$hasError)
				{
					if($this->sessionModel->saveRecord($workTable, $fields) || $this->sessionModel->saveRecord($workTable, $fields, "user_id"))
					{
						FJF_BASE::redirect("/admin/users/administrators/");
					}
					else
					{
						$hasError = true;
						$status = "Error while saving record. Please, try again later and contact support.";
					}
				}
			}//POST

			$record = $id ? $this->sessionModel->getRecordBy($workTable, $id, "user_id") : null;
			$record = is_object($record) ? get_object_vars($record) : array();
			$record = array_merge($record, $fields);
			$record["permissions"] = isset($record["permissions"]) ? explode(",", $record["permissions"]) : array();
			
			$header["parent"] = array(
				"users/administrators" => "Manage Administrators Users",
				"edit/" . $id => "Modify User Information"
			);
			$header["title"] = "Edit " . $actionName;

			$templateParams = array(
        "header" => &$header,
        "status" => $status,
        "has_error" => $hasError,
        "record" => &$record,
        "work_table" => $workTable,
        "admin_tools" => $adminTools
      );
			return $this->displayTemplate("admin_permissions.tpl", $templateParams);
		}
	}

?>