<?php

  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/pagination_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/main_model.php");

  class AdminPress extends FJF_CMD
  {
    var $sessionModel = null;
    var $paginationModel = null;
		var $mainModel = null;

    function __construct()
    {
      $this->sessionModel = new sessionModel();
      $this->paginationModel = new PaginationModel();
			$this->mainModel = new MainModel();
    }

    function execute()
    {
      require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["includes_path"] . "/admin_header_commands.php");

      $header["title"] = "Manage Press";

      if($_SERVER["REQUEST_METHOD"] == "POST")
      {
        $idToDelete = isset($_POST["id_to_delete"]) ? intval($_POST["id_to_delete"]) : 0;
        if($idToDelete)
        {
          $record = $this->sessionModel->getRecordBy("press", $idToDelete);
          if($record && $this->sessionModel->deleteRecord("press", $idToDelete))
          {
          	$this->mainModel->restorePositions("press", "is_featured=1");
            if ($record->image)
            {  
             @unlink($_SERVER["DOCUMENT_ROOT"] . "/images/press/orig/" . $record->image);
             @unlink($_SERVER["DOCUMENT_ROOT"] . "/images/press/m/" . $record->image);
            }
            $status = "Records were deleted successfully.";
          }
          else
          {
            $hasError = true;
            $status = "Error occured while deleting records.";
          }
        }
      }//POST
      $url = '/admin/press/?page=PAGE';
      $recordsCount = $this->sessionModel->countFrom('press');
      $pages = $recordsCount ? $this->paginationModel->pages($url, $recordsCount, 20) : null;
      $records = $recordsCount ? $this->sessionModel->getRecords('press', '1 ORDER BY id LIMIT '.$this->paginationModel->limit, null, false, 'id, title, url_title, type, is_featured, status') : null;

      $templateParams = array(
        "status" => $status,
        "has_error" => $hasError,
        "header" => $header,
        "records" => $records,
        "pages" =>$pages,
        "records_count" => $recordsCount
      );
      return $this->displayTemplate("admin_press.tpl", $templateParams);
    }

  }
?>