<?php

  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/photo_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/main_model.php");

  class AdminPressEdit extends FJF_CMD
  {
    var $sessionModel = null;
    var $photoModel = null;
		var $mainModel = null;

    function __construct()
    {
      $this->sessionModel = new sessionModel();
      $this->photoModel = new photoModel();
			$this->mainModel = new MainModel();
    }

    function execute()
    {
      require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["includes_path"] . "/admin_header_commands.php");

      $id = isset($_GET["id"]) && $_GET["id"] > 0 ? intval($_GET["id"]) : 0;
			$type = isset($_GET["type"]) ? trim($_GET["type"]) : '';

      $header["parent"] = array("press" => "Manage Press");
      $header["title"] = ($id ? "Edit" : "Add") . " Record";

      $fields = array();
      $record = $id ? $this->sessionModel->getRecordBy("press", $id) : null;

      if($_SERVER["REQUEST_METHOD"] == "POST")
      {
        $action = isset($_POST["action"]) ? trim($_POST["action"]) : "";

        if ($action == "delete_image" && $id > 0)
        {
          $fileName = (isset($_POST["filename"]) && $_POST["filename"] != "") ? trim($_POST["filename"]) : "";
          $fields["id"] = $id;
          $fields["image"] = "";
          if ($this->sessionModel->saveRecord("press", $fields, "id"))
          {
            @unlink($_SERVER["DOCUMENT_ROOT"] . "/images/press/orig/" . $fileName);
            @unlink($_SERVER["DOCUMENT_ROOT"] . "/images/press/m/" . $fileName);
          }
          else
          {
            $status = "Error has occured while deleting image.";
          }
          echo $status;
          exit;
        }

        if($id) $fields["id"] = $id;
        $fields["title"] = isset($_POST["title"]) ? htmlentities(trim($_POST["title"])) : "";
        $fields["url_title"] = isset($_POST["url_title"]) ? htmlentities(trim($_POST["url_title"]), ENT_QUOTES) : "";
        $fields["type"] = isset($_POST["type"]) ? intval($_POST["type"]) : 0;
        $fields["description"] = isset($_POST["description"]) ? addslashes(trim($_POST["description"])) : "";
				$fields["is_featured"] = isset($_POST["is_featured"]) ? intval($_POST["is_featured"]) : 0;
        $fields["status"] = isset($_POST["status"]) ? intval($_POST["status"]) : 0;
        if(!$id) $fields["create_date"] = date('Y-m-d H:i:s');
        
        if(!$fields["title"])
        {
          $hasError = true;
          $status .= "Title is missing.<br />";
        }

        $fields["url_title"] = $fields["url_title"] ? $fields["url_title"] : $this->sessionModel->generateURL(stripslashes($fields["title"]), 0, "press");

        if(!$fields["url_title"])
        {
          $hasError = true;
          $status .= "URL is missing.<br />";
        }

        if(!$fields["description"])
        {
          $hasError = true;
          $status .= "Description is missing.<br />";
        }

        $imageOld = (isset($_POST["image_old"]) && $_POST["image_old"] != "") ? addslashes(trim($_POST["image_old"])) : "";
        $fields["image"] = $imageOld;
        if(isset($_FILES["image"]['tmp_name']) && $_FILES["image"]['tmp_name'] != "")
        {
          $fileName = time() . "";
          $this->photoModel->defineThumb('m', 150, 90);
          $uploadResult = $this->photoModel->upload("press", $fileName, "image", false);

          if($uploadResult["error"] != "error_upload_file")
          {
            if($uploadResult["error"])
            {
              $hasError = true;
              $status .= $uploadResult["status"] . "<br />";
            }
            else
            {
              $fields["image"] = $uploadResult["file"];
            }
          }
        }

        if(!$hasError)
        {
          if($result = $this->sessionModel->saveRecord("press", $fields))
          {
          	if(!$id || $record->is_featured != $fields["is_featured"])
          	{
          		$this->mainModel->restorePositions("press", "is_featured=1");
						}
						$redirect = "/admin/press/" . (($type == 'featured') ? 'featured/' : '');
            FJF_BASE::redirect($redirect);
          }
          else
          {
            $hasError = true;
            $status = "An error occured. Please try again later.";
          }
        }
      }//POST

      $record = (count($fields) > 0) ? (object) $fields : $record;


      $templateParams = array(
                              "status" => $status,
                              "has_error" => $hasError,
                              "header" => $header,
                              "record" => $record,
                              );

      $this->displayTemplate("admin_press_edit.tpl", $templateParams);

      return true;
    }

  }
?>