<?php

  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");

  class AdminPressFeatured extends FJF_CMD
  {
    var $sessionModel = null;

    function __construct()
    {
      $this->sessionModel = new sessionModel();
    }

    function execute()
    {
      require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["includes_path"] . "/admin_header_commands.php");

      $header["parent"] = array("press" => "Manage Press");
      $header["title"] = "Manage Homepage Records";

      if($_SERVER["REQUEST_METHOD"] == "POST")
      {
        $move = isset($_POST["move"]) && is_array($_POST["move"]) ? $_POST["move"] : null;
        if($move){
          $params["POS_FROM"] = intval($move["from"]);
          $params["POS_TO"] = intval($move["to"]);
          if($this->sessionModel->getRecord("press", "is_featured = 1 AND position=POS_FROM", $params)
          && $this->sessionModel->getRecord("press", "is_featured = 1 AND position=POS_TO", $params)){
            if($params["POS_FROM"] != $params["POS_TO"]) $this->sessionModel->updateRecords("press", "position=0", "is_featured = 1 AND position=POS_FROM", $params);
            if($params["POS_FROM"] < $params["POS_TO"]){
              $this->sessionModel->updateRecords("press", "position=position-1", "is_featured = 1 AND position > POS_FROM AND position <= POS_TO", $params);
            }elseif($params["POS_FROM"] > $params["POS_TO"]){
              $this->sessionModel->updateRecords("press", "position=position+1", "is_featured = 1 AND position >= POS_TO AND position < POS_FROM", $params);
            }
            if($params["POS_FROM"] != $params["POS_TO"]) $this->sessionModel->updateRecords("press", "position=POS_TO", "is_featured = 1 AND position=0", $params);
            return true;
          }else exit("false");
        }
      }//POST

      $records = $this->sessionModel->getRecords("press", "is_featured = 1 ORDER BY position", null, false, "id, title, type, position, status");

      $templateParams = array(
        "header" => &$header,
        "has_error" => $hasError,
        "status" => $status,
        "records" => &$records
      );
      return $this->displayTemplate("admin_press_featured.tpl", $templateParams);
    }
  }

?>