<?php

	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/stripe_model.php");

	class AdminPromotionCodes extends FJF_CMD{
		var $sessionModel = null;

		function __construct(){
			$this->sessionModel = new SessionModel();
		}

		function execute(){
			require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["includes_path"] . "/admin_header_commands.php");

			if($_SERVER["REQUEST_METHOD"] == "POST"){
				$deleteRecords = isset($_POST["delete_records"]) && is_array($_POST["delete_records"]) ? implode(",", $_POST["delete_records"]) : null;
				if($deleteRecords){
					if($deleteItems = FJF_BASE_RICH::getRecords(
						"promotion_codes",
						"id IN (IDS_VAL)",
						array("IDS_VAL" => $deleteRecords),
						false, 'id, code'
					)){
						StripeModel::setApiKey();
						foreach($deleteItems as $item){
							$_hasError = false;
							try{
								StripeModel::deleteCoupon($item->code);
							}catch(Exception $e){
								$_hasError = true;
								$hasError = true;
								$status .= $e->getMessage() . "<br/> ";
							}
							if(!$_hasError){
								if(!FJF_BASE_RICH::deleteRecord("promotion_codes", $item->id)){
									$hasError = true;
									$status .= "Error occured while deleting record #".$item->id.".<br/>";
								}
							}
						}
						if(!$hasError){
							$status = "Records were deleted successfully.";
						}
					}
				}
			}//POST

			$records = FJF_BASE_RICH::getRecords("promotion_codes");

			$header["title"] = "Manage Promotion Codes";

			$templateParams = array(
        "status" => $status,
        "has_error" => $hasError,
        "header" => $header,
        "records" => $records
      );

			return $this->displayTemplate("admin_promotion_codes.tpl", $templateParams);
		}

	}
?>