<?php

	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/pagination_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/admin_reports_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/stripe_model.php");

	class AdminReportsRevenue extends FJF_CMD
	{
		var $sessionModel = null;  
		var $paginationModel = null;

		function __construct()
		{
		  $this->sessionModel = new SessionModel();
			$this->paginationModel = new PaginationModel();
		}

		function execute()
		{
			require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["app_web_path"] . "/includes/admin_header_commands.php");

			$url = "/admin/reports/revenue/?page=PAGE";
			$count = 0;
			$pages = null;
			$where = "is_admin = 0";
			$limit = "";
			$params = array();
			$orders = array(
				"id" => "u.id",
				"username" => "u.username",
				"email" => "u.email",
				"first_name" => "u.first_name",
				"last_name" => "u.last_name",
				"tier" => "u.tier",
				"revenue" => "revenue"
			);
			$ordersValues = array_values($orders);
			$export = isset($_REQUEST["button_export"]) ? true : false;
			$filters = array(
				"sort_name" => (isset($_GET["sort_name"]) && array_key_exists($_GET["sort_name"], $orders)) ? $orders[$_GET["sort_name"]] : array_shift($ordersValues),
				"sort_order" => isset($_GET["sort_order"]) && $_GET["sort_order"] ? strtolower(trim($_GET["sort_order"])) : "asc",
				"tier" => isset($_GET["tier"]) && $_GET["tier"] ? $_GET["tier"] : array(),
				"register" => isset($_GET["register"]) && array_key_exists($_GET["register"], AdminReportsModel::$datePeriod) ? $_GET["register"] : "",
				"period" => isset($_GET["period"]) && array_key_exists($_GET["period"], AdminReportsModel::$datePeriod) ? $_GET["period"] : "",
				"coupon_code" => isset($_GET["coupon_code"]) && $_GET["coupon_code"] ? $_GET["coupon_code"] : "",
				"custom_date" => array()
			);
			$url .= '&' . http_build_query(array_filter($filters));
			if($filters["register"]){
			  $customDate = AdminReportsModel::getCustomDate($filters["register"], 'register');
			  if($customDate){
			    $params["DATE_FROM_REGISTER"] = $customDate["date_from"];
			    $params["DATE_TO_REGISTER"] = $customDate["date_to"];
			    $where .= " AND u.date_register >= 'DATE_FROM_REGISTER' AND u.date_register <= 'DATE_TO_REGISTER' ";
			    $filters["custom_date"]["register"] = $customDate;
			  }
			}
			if($filters["period"]){
				$customDate = AdminReportsModel::getCustomDate($filters["period"], 'period');
			  if($customDate){
			    $params["DATE_FROM_PERIOD"] = $customDate["date_from"];
			    $params["DATE_TO_PERIOD"] = $customDate["date_to"];
			    $where .= " AND up.date >= 'DATE_FROM_PERIOD' AND up.date <= 'DATE_TO_PERIOD' ";
			    $filters["custom_date"]["period"] = $customDate;
			  }
			}
			if($filters["tier"] && is_array($filters["tier"])){
				$params["TIERS_VAL"] = implode(',', $filters["tier"]);
				$where .= " AND u.tier IN(TIERS_VAL)";
			}
			if($filters["coupon_code"]){
				$params["COUPON_CODE_VAL"] = $filters["coupon_code"];
				$where .= " AND o.coupon_code = 'COUPON_CODE_VAL'";
			}
			if(!$export){
				$sql = "SELECT COUNT(DISTINCT u.id) cid FROM users u";
				$sql .= " LEFT JOIN orders o ON u.id = o.user_id";
				$sql .= " LEFT JOIN users_payments up ON u.id = up.user_id";
				if($where) $sql .= " WHERE " . $where;
				$count = FJF_BASE_RICH::getCount($sql, $params);
				$pages = $count ? $this->paginationModel->pages($url, $count, 20) : null;
				$limit = $this->paginationModel->limit;
			}
			$order = $filters["sort_name"] . " " . $filters["sort_order"];
			$sql = "SELECT u.id, u.username, u.email, u.first_name, u.last_name, u.tier, SUM(up.revenue) * COUNT(DISTINCT up.id)/COUNT(*) AS revenue FROM users u";
			$sql .= " LEFT JOIN orders o ON u.id = o.user_id";
			$sql .= " LEFT JOIN users_payments up ON u.id = up.user_id";
			if($where) $sql .= " WHERE " . $where;
			$sql .= " GROUP BY u.id";
			$sql .= " ORDER BY " . $filters["sort_name"] . " " . $filters["sort_order"];
			if($limit) $sql .= " LIMIT " . $limit;
			$records = ($export || $count) ? FJF_BASE_RICH::selectRecords($sql, $params) : null;
			if($export) AdminReportsModel::exportRecords($records, 'users-report');

			$header["title"] = "Revenue Report";
			$promotion_codes = FJF_BASE_RICH::getRecords("promotion_codes", "1 ORDER BY title", null, false, "title, code");

			$templateParams = array(
        "header" => $header,
        "status" => $status,
        "has_error" => $hasError,
        "count" => $count,
        "pages" => $pages,
        "filters" => $filters,
        "date_period" => AdminReportsModel::$datePeriod,
        "promotion_codes" => $promotion_codes,
        "records" => $records
      );
			return $this->displayTemplate("admin_reports_revenue.tpl", $templateParams);
		}
	}

?>