<?php

	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");

	class AdminSeoRedirectTool extends FJF_CMD
	{
		var $sessionModel = null;

		function __construct()
		{
			$this->sessionModel = new SessionModel();
		}

		function execute()
		{
			require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["app_web_path"] . "/includes/admin_header_commands.php");

			$header["title"] = "SEO Redirect Tool";

			if($_SERVER["REQUEST_METHOD"] == "POST")
			{
				$idToDelete = isset($_POST["id_to_delete"]) ? intval($_POST["id_to_delete"]) : 0;
				if($idToDelete)
				{
					if($this->sessionModel->deleteRecord("seo_redirect", $idToDelete))
				  {
				  	$status = "Record was successfully deleted.";
				  }
				  else
				  {
				  	$hasError = true;
				  	$status = "Error while deleting record from the database.";
				  }
				}
			}//POST

			$records = $this->sessionModel->getRecords("seo_redirect");

			$templateParams = array(
			                        "status" => $status,
			                        "has_error" => $hasError,
			                        "header" => &$header,
			                        "records" => &$records
			                        );

			$this->displayTemplate("admin_seo_redirect_tool.tpl", $templateParams);

			return true;
		}

	}
?>