<?php

	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");

	class AdminSeoRedirectToolEdit extends FJF_CMD
	{
		var $sessionModel = null;

		function __construct()
		{
			$this->sessionModel = new SessionModel();
		}

		function execute()
		{
			require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["app_web_path"] . "/includes/admin_header_commands.php");

			$id = (isset($_GET["id"]) && $_GET["id"] > 0) ? intval($_GET["id"]) : 0;
			$header["parent"] = array("seo_redirect_tool" => "SEO Redirect Tool");
			$header["title"] = ($id ? "Edit" : "Add") . " Record";

			$fields = array();
			// POST METHOD STARTS
			if($_SERVER["REQUEST_METHOD"] == "POST")
			{
				if($id) $fields["id"] = $id;

				$fields["old_url"] = isset($_POST["old_url"]) && $_POST["old_url"] ? trim($_POST["old_url"]) : "";
				$fields["new_url"] = isset($_POST["new_url"]) && $_POST["new_url"] ? trim($_POST["new_url"]) : "";
				$fields["author"] = isset($_POST["author"]) && $_POST["author"] ? htmlspecialchars(trim($_POST["author"]), ENT_QUOTES) : "";

				$fields["old_url"] = trim(str_replace(array("http://", $_SERVER["SERVER_NAME"]), "", $fields["old_url"]), "/");
				$fields["new_url"] = trim(str_replace(array("http://", $_SERVER["SERVER_NAME"]), "", $fields["new_url"]), "/");

				if(!$fields["old_url"])
				{
					$hasError = true;
					$status .= "Old URL can't be empty.<br />";
				}

				if(!$fields["new_url"])
				{
					$hasError = true;
					$status .= "New URL can't be empty.<br />";
				}

				if(!$hasError)
				{
					$result = $this->sessionModel->saveRecord("seo_redirect", $fields);
					if($result)
					{
						FJF_BASE::redirect("/admin/seo_redirect_tool/");
					}
					else
					{
						$hasError = true;
						$status = "Error while updating record info. Please, try again later and contact support.";
					}
				}

			} // /POST

			$record = $id ? $this->sessionModel->getRecordBy("seo_redirect", $id) : null;
			$record = is_object($record) ? get_object_vars($record) : array();
			$record = array_merge($record, $fields);

			$templateParams = array(
			                        "status" => $status,
			                        "has_error" => $hasError,
			                        "header" => &$header,
			                        "has_error" => $hasError,
			                        "records" => &$records,
			                        "record" => &$record
			                        );

			$this->displayTemplate("admin_seo_redirect_tool_edit.tpl", $templateParams);

			return true;
		}

	}
?>