<?php

	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/admin_users_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/pagination_model.php");

	class AdminUsers extends FJF_CMD
	{
		var $sessionModel = null;  
		var $adminUsersModel = null;
		var $paginationModel = null;

		function __construct()
		{
		  $this->sessionModel = new SessionModel();
			$this->adminUsersModel = new AdminUsersModel();
			$this->paginationModel = new PaginationModel();
		}

		function execute()
		{
			require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["app_web_path"] . "/includes/admin_header_commands.php");

			$mode = isset($_REQUEST["mode"]) ? trim($_REQUEST["mode"]) : "";
			$url = "/admin/users/" . $mode . "/";

			if($_SERVER["REQUEST_METHOD"] == "POST")
			{
				$usersToDelete = isset($_POST["delete_users"]) && is_array($_POST["delete_users"]) && count($_POST["delete_users"]) > 0 ? $_POST["delete_users"] : null;
				if($usersToDelete)
				{
					if(!$this->adminUsersModel->deleteUsers($usersToDelete))
					{
						$hasError = TRUE;
						$status = "Error while deleting user(s) from the database.";
					}
				}
			}//POST

			$sqlWhere = ($mode == "administrators" ? "u.is_admin > 0" : "u.is_admin = 0");

			$keyword = isset($_REQUEST["keyword"]) ? htmlspecialchars(trim($_REQUEST["keyword"]), ENT_QUOTES) : "";
			if($keyword){
				$url .= "keyword/" . $keyword . "/";
				$sqlWhere .= " AND (u.username LIKE '%" . $keyword . "%' OR u.email LIKE '%" . $keyword . "%' OR u.first_name LIKE '%" . $keyword . "%' OR u.last_name LIKE '%" . $keyword . "%')";
			}

			$recordsCount = $this->adminUsersModel->getUsersCount($sqlWhere);
			$pages = $recordsCount ? $this->paginationModel->pages($url . "page/PAGE/", $recordsCount, 30) : null;
			$records = $recordsCount ? $this->adminUsersModel->getUsers($sqlWhere, "u.username", $this->paginationModel->limit) : null;

			$header["title"] = "Manage " . (($mode == 'members')? 'Users' : ucfirst($mode));

			$templateParams = array(
        "header" => &$header,
        "status" => $status,
        "has_error" => $hasError,
        "records_count" => $recordsCount,
        "pages" => $pages,
        "records" => $records
      );
			return $this->displayTemplate("admin_users.tpl", $templateParams);
		}
	}

?>