<?php

	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/admin_users_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/user_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/pricing_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/stripe_model.php");

	class AdminUsersEdit extends FJF_CMD{
		var $sessionModel = null;
		var $adminUsersModel = null;
		var $usersModel = null;

		function __construct(){
		  $this->sessionModel = new SessionModel();
			$this->adminUsersModel = new AdminUsersModel();
			$this->userModel = new UserModel();
		}

		function execute(){
			require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["app_web_path"] . "/includes/admin_header_commands.php");

			$id = isset($_GET["id"]) && $_GET["id"] > 0 ? intval($_GET["id"]) : 0;
			$mode = isset($_REQUEST["mode"]) ? trim($_REQUEST["mode"]) : "";
			$url = "/admin/users/" . $mode . "/";
			$userInfo = $id ? $this->adminUsersModel->getUserInfo($id) : (object) array(
				'id' => null,
				'tier' => 0,
				'customer_id' => '',
				'subscribe_id' => ''
			);

			$order = $userInfo->subscribe_id ? FJF_BASE_RICH::getRecord(
				"orders",
				"transaction_id = 'SUBSCRIBE_ID'",
				array('SUBSCRIBE_ID' => $userInfo->subscribe_id)
			) : null;
			$tiers = PricingModel::getTiersInfo();
			$paymentTypes = PricingModel::$paymentTypes;

			if($_SERVER["REQUEST_METHOD"] == "POST"){
				if($userInfo->id) $fields = get_object_vars($userInfo);
				$fields["password"] = isset($_POST["password"]) && $_POST["password"] ? trim($_POST["password"]) : "";
				$fields["first_name"] = isset($_POST["first_name"]) && $_POST["first_name"] ? htmlspecialchars(trim($_POST["first_name"]), ENT_QUOTES) : "";
				$fields["last_name"] = isset($_POST["last_name"]) && $_POST["last_name"] ? htmlspecialchars(trim($_POST["last_name"]), ENT_QUOTES) : "";
				$fields["gender"] = isset($_POST["gender"]) && $_POST["gender"] == 1 ? 1 : 0;
				$fields["dob"] = isset($_POST["dob"]) && $_POST["dob"] ? trim($_POST["dob"]) : "";
				$fields["address"] = isset($_POST["address"]) && $_POST["address"] ? htmlspecialchars(trim($_POST["address"]), ENT_QUOTES) : "";
				$fields["address2"] = isset($_POST["address2"]) && $_POST["address2"] ? htmlspecialchars(trim($_POST["address2"]), ENT_QUOTES) : "";
				$fields["city"] = isset($_POST["city"]) && $_POST["city"] ? htmlspecialchars(trim($_POST["city"]), ENT_QUOTES) : "";
				$fields["state"] = isset($_POST["state"]) && $_POST["state"] ? htmlspecialchars(trim($_POST["state"]), ENT_QUOTES) : "";
				$fields["zip"] = isset($_POST["zip"]) && $_POST["zip"] ? htmlspecialchars(trim($_POST["zip"]), ENT_QUOTES) : "";
				$fields["is_subscribed"] = isset($_POST["is_subscribed"]) && $_POST["is_subscribed"] == "yes" ? 1 : 0;
				$fields["user_type"] = isset($_POST["user_type"]) ? intval($_POST["user_type"]) : 0;
				$fields["tier"] = isset($_POST["tier"]) ? intval($_POST["tier"]) : 0;
				if(isset($_POST["approved"]) && $_POST["approved"] == "yes")  $fields["approved"] = "";
				$fields["active"] = isset($_POST["active"]) ? intval($_POST["active"]) : 0;
				$fields["banned"] = isset($_POST["banned"]) ? intval($_POST["banned"]) : 0;

				if(isset($_POST["is_admin"])){
					$fields["is_admin"] = intval($_POST["is_admin"]);
					if($fields["is_admin"] > $isAdmin) $fields["is_admin"] = $isAdmin;
					if($fields["is_admin"]){
						$fields["tier"] = 4;
						$fields["user_type"] = 0;
						$fields['cancelled'] = 0;
					}
				}

				if(!$fields["password"]){
					$hasError = true;
					$status .= "Password cannot be blank.<br />";
				}

				if(!$fields["first_name"]){
					$hasError = true;
					$status .= "First Name cannot be blank.<br />";
				}

				if(!$fields["last_name"]){
					$hasError = true;
					$status .= "Last Name cannot be blank.<br />";
				}

			  if(!$userInfo->id){
			  	$fields["username"] = isset($_POST["username"]) && $_POST["username"] ? htmlspecialchars(trim($_POST["username"]), ENT_QUOTES) : "";
					$fields["email"] = isset($_POST["email"]) && $_POST["email"] ? htmlspecialchars(trim($_POST["email"]), ENT_QUOTES) : "";
			  	$fields["date_register"] = date("Y-m-d H:i:s");

					if(!$fields["username"]){
						$hasError = true;
						$status .= "Username cannot be blank.<br />";
					}elseif($this->adminUsersModel->getRecordBy("users", $fields["username"], "username")){
						$hasError = true;
			  		$status = "Username is already registered with our system.";
					}

					if(!$fields["email"]){
						$hasError = true;
						$status .= "Email cannot be blank.<br />";
					}elseif($this->adminUsersModel->getRecordBy("users", $fields["email"], "email")){
						$hasError = true;
			  		$status = "Email address is already registered with our system.";
					}
				}
				
				$data['order']['payment_type'] = isset($_POST["payment_type"]) ? $_POST["payment_type"] : "";
				$data['order']['tier'] = $fields["tier"];
				$isChangeTier = ($data['order']['tier']  != $userInfo->tier || !$order ||
				($order->payment_type != $data['order']['payment_type']));
				$createSubscribe = array_key_exists($data['order']['tier'] , $tiers);
				
				if(!$hasError && $isChangeTier){
					if(!$userInfo->customer_id && ($createSubscribe || $userInfo->subscribe_id)){
						$hasError = true;
						$status .= "Stripe Customer ID is missing.<br/>";
					}
					
					if($createSubscribe && !array_key_exists($data['order']['payment_type'], $paymentTypes)){
	          $hasError = true;
	          $status .= "Pricing Plan is missing.<br/>";
	        }
	        
					if($createSubscribe){
						if($order){
							$orderOld = get_object_vars($order);
							if(isset($orderOld['id'])) unset($orderOld['id']);
							$data['order'] = array_merge($orderOld, $data['order']); 
						}else{
							$billingFields = array(
			        	"first_name" => "First Name",
			        	"last_name" => "Last Name",
			        	"address" => "Address",
			        	"address2" => "",
			        	"city" => "City",
			        	"zip" => "Zip",
			        	"state" => "State"
							);
							foreach($billingFields as $field => $name){
								$data['order'][$field] = isset($fields[$field]) ? trim($fields[$field]) : "";
								if($name && !$data['order'][$field]){
									$hasError = true;
			          	$status .=  $name . " is missing.<br/>";
								}
							}
						}
					}
					
					if(!$hasError){
						StripeModel::setApiKey();
						if($userInfo->subscribe_id){
							try{
								$userInfo->cancel_subscribe = StripeModel::cancelCustomerSubscribe(
									$userInfo->customer_id,
									$userInfo->subscribe_id
								);
							}catch(Exception $e){
								$hasError = true;
								$status .= $e->getMessage() . "<br/> ";
							}
							if(!$hasError){
								$fields['subscribe_id'] = "";
								$fields['tier'] = $data['order']['tier'] == 4 ? 4 : 0;
								FJF_BASE_RICH::saveRecord("users", array(
									"id" => $userInfo->id,
									"tier" => $fields['tier'],
									"subscribe_id" => $fields['subscribe_id']
								));
							}
						}
						
						if(!$hasError && $createSubscribe){
							try{
								$data['order']['transaction_id'] = StripeModel::subscribeCustomer($userInfo->customer_id, array(
										"plan" => $tiers[$data['order']["tier"]][$data['order']['payment_type']]['plan_id'],
										"trial_end" => 'now'
								));
							}catch(Exception $e){
								$hasError = true;
								$status .= $e->getMessage() . "<br/> ";
							}
							if(!$hasError){
								$fields['tier'] = $data['order']['tier'];
								$fields['subscribe_id'] = $data['order']['transaction_id'];
								$fields['cancelled'] = 0;
								$data['order']['price'] = $tiers[$data['order']["tier"]][$data['order']['payment_type']]['price'];
								$data['order']['discount'] = 0;
								$data['order']['total'] = $data['order']['price'] - $data['order']['discount'];
								if($data['order']['total'] < 0) $data['order']['total'] = 0;
								$data['order']['user_id'] = $userInfo->id;
								$data['order']['date'] = date('Y-m-d H:i:s');
								$data['order']['id'] = FJF_BASE_RICH::saveRecord("orders", $data['order']);
							}
						}
					}
				}

				if(!$hasError){
					if($result = $this->adminUsersModel->updateRecord($fields)){
						if($fields["is_subscribed"]){
							$listMember = $this->userModel->getlistMember($fields["email"]);
							if(!$listMember || $listMember['status'] == 'subscribed'){
								$this->userModel->subscribeToList($fields);
							}
						}else{
							$this->userModel->unsubscribeFromList($fields);
						}
						if($userInfo->id && $userInfo->tier != $fields['tier']){
							$this->userModel->changePendingStatus($fields['tier'], $fields['tier']);
						}
						if($isChangeTier){
							if($order){
								$data['order']['old'] = get_object_vars($order);
								$data['order']['old']['cancel_subscribe'] = isset($userInfo->cancel_subscribe) ? $userInfo->cancel_subscribe : null;
								$data['order']['old']['plan'] = array_key_exists($data['order']['old']['tier'], $tiers) ? $tiers[$data['order']['old']['tier']]['name'] : "";
								$data['order']['old']['cancellation_date'] = date('m/d/Y');
							}
							if($createSubscribe){
								$data['order']['plan'] = array_key_exists($data['order']['tier'], $tiers) ? $tiers[$data['order']['tier']]['name'] : "";
								$data['order']['payment_type'] = array_key_exists($data['order']['payment_type'], $paymentTypes) ? $paymentTypes[$data['order']['payment_type']] : "";
								$data['order']['effective_date'] = date('m/d/Y');
								$data['order']['change_type'] = 'Upgrade';
								if(isset($data['order']['old'])){
									if($data['order']['tier'] == $data['order']['old']['tier']){
										$data['order']['change_type'] = 'Update';
										$data['order']['plan'] = $data['order']['plan'] . ' ' . ucfirst($data['order']['payment_type']);
										$data['order']['old']['plan'] = $data['order']['old']['plan'] . ' ' . ucfirst($data['order']['old']['payment_type']);
									}else{
										$data['order']['change_type'] = $data['order']['tier'] > $data['order']['old']['tier'] ? 'Upgrade' : 'Downgrade';	
									}
								}
								$this->userModel->sendChangeTierMail($fields, $data['order']);
							}elseif(isset($data['order']['old']) && $data['order']['old']['cancel_subscribe']){
								$this->userModel->sendCancelSubscribeMail($fields, $data['order']);
							}
						}
						FJF_BASE::redirect($url);
					}else{
						$hasError = true;
						$status = "Error while updating User Information. Please, try again later and contact support.";
					}
				}
				if($hasError){
          $userInfo = (object) $fields;
				}
			}//POST

			$userInfo->order = $order ? $order : new stdClass;
			if(isset($data['order']['payment_type'])){
				$userInfo->order->payment_type = $data['order']['payment_type'];
			}
			$header["parent"] = array("users/" . $mode => "Manage " . (($mode == 'members')? 'Users' : ucfirst($mode)));
			$header["title"] = ($id) ? "Edit User Info" : "Add User";

			$templateParams = array(
        "header" => $header,
        "action" => ($id > 0) ? "modify_user" : "add_user",
        "status" => $status,
        "has_error" => $hasError,
        "user_info" => $userInfo,
        "tier_levels" => $tiers,
        "payment_types" => $paymentTypes
      );
			return $this->displayTemplate("admin_users_edit.tpl", $templateParams);
		}
	}

?>