<?php

  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/alerts_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/users_sentiment_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/twitter_model.php");

  class AjaxAlertDashboardCreate extends FJF_CMD
  {
    var $sessionModel = null;
		var $alertsModel = null;
		var $usersSentimentModel = null;

    function __construct()
    {
      $this->sessionModel = new SessionModel();
			$this->alertsModel = new AlertsModel();
			$this->usersSentimentModel = new UsersSentimentModel();
    }

    function execute()
    {
      require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["app_web_path"] . "/includes/ajax_header_commands.php");
      if(!$this->sessionModel->isLoggedUser()) return null;
			$action = isset($_GET["action"]) ? trim($_GET["action"]) : "";
			$filter['type'] = isset($_GET["type"]) ? trim($_GET["type"]) : "";
			
			$typeInfo = $this->alertsModel->getAlertTypes($filter['type']);
			if(!$typeInfo) return null;
			
			$records = null;
			
			$data['operators'] = $this->alertsModel->getAlertsOperators();
      $data['alertsTimeframes'] = $this->alertsModel->getAlertsTimeframes();

			switch($filter['type']){
		    case 'stocks':
					$data['types'] = $this->alertsModel->getAlertsTypes();
		      break;
		    case 'users':
					$data['tickers'] = array();
					$data['tickers'] = array_merge($this->usersSentimentModel->getDefaultFilterTickers(),$data['tickers']);
					$data['timeframes'] = $this->usersSentimentModel->getTimeframes();
					$data['type'] = "user";
					$data['subtype'] = "tickers";
		      break;
				case 'top_users_returns':
					$data['topUserReturns'] = $this->usersSentimentModel->getTopUserReturns();
					$data['timeframes'] = $this->usersSentimentModel->getTimeframes();
					$data['type'] = "top-user";
					$data['subtype'] = "tickers";
					/*
					$where = "TS = (SELECT TS FROM UserTopTenData_TickerReturns ORDER BY TS DESC LIMIT 1)";
					$fields = 'DISTINCT TICKER AS ticker';
					$data['tickers'] = $this->usersSentimentModel->getTopTenReturns('UserTopTenData_TickerReturns', $where, null, null, 'TICKER', $fields);
					*/
		    	break;
				case 'top_users_rank':
					$data['topMpReturns'] = $this->usersSentimentModel->getTopMpReturns();
					$data['timeframes'] = $this->usersSentimentModel->getTimeframes();
					$data['type'] = "top-mp";
					$data['subtype'] = "tickers";
					/*
					$where = "TS = (SELECT TS FROM UserTopTenData_TickerScore ORDER BY TS DESC LIMIT 1)";
					$fields = 'DISTINCT TICKER AS ticker';
					$data['tickers'] = $this->usersSentimentModel->getTopTenReturns('UserTopTenData_TickerScore', $where, null, null, 'TICKER', $fields);
					*/
		    	break;
				case 'top_sectors_returns':
					$data['topUserReturns'] = $this->usersSentimentModel->getTopUserReturns();
					$data['timeframes'] = $this->usersSentimentModel->getTimeframes();
					$data['type'] = "top-user";
					$data['subtype'] = "sectors";
					$where = "TS = (SELECT TS FROM UserTopTenData_SectorReturns ORDER BY TS DESC LIMIT 1)";
					$fields = 'DISTINCT SECTOR AS sector';
					$data['sectors'] = $this->usersSentimentModel->getTopTenReturns('UserTopTenData_SectorReturns', $where, null, null, 'SECTOR', $fields);
		    	break;
				case 'top_sectors_rank':
					$data['topMpReturns'] = $this->usersSentimentModel->getTopMpReturns();
					$data['timeframes'] = $this->usersSentimentModel->getTimeframes();
					$data['type'] = "top-mp";
					$data['subtype'] = "sectors";
					$where = "TS = (SELECT TS FROM UserTopTenData_SectorScore ORDER BY TS DESC LIMIT 1)";
					$fields = 'DISTINCT SECTOR AS sector';
					$data['sectors'] = $this->usersSentimentModel->getTopTenReturns('UserTopTenData_SectorScore', $where, null, null, 'SECTOR', $fields);
		    	break;
				default:
					return null;
			}

			$header['title'] = 'CREATE NEW ' . $typeInfo['title'] . ' ALERT';
			$header['popup']['title'] = $header['title'];
      $header['popup']['type'] = (isset($_GET["popup_type"]) && $_GET["popup_type"]) ? trim($_GET["popup_type"]) : 'box';
      $header['popup']['url'] = '/ajax/alert/dashboard/create/?type='.$filter['type'].'&popup_type=window';
      $header['popup']['params'] = "{width:722,height:485,name:'".$header['title']."'}";
			$header['popup']['alert_box_type'] = "create";

			
      $templateParams = array(
        "has_error" => $hasError,
        "status" => $status,
        "header" => $header,
        "action" => $action,
        "filter" => $filter,
        "data" => $data,
        "records" => $records
      );

      return $this->displayTemplate("ajax_alert_dashboard_create.tpl", $templateParams);
    }
  }

?>