<?php

  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/alerts_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/users_sentiment_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/twitter_model.php");

  class AjaxAlertDashboardList extends FJF_CMD
  {
    var $sessionModel = null;
		var $alertsModel = null;
		var $usersSentimentModel = null;
		var $twitterModel = null;

    function __construct()
    {
      $this->sessionModel = new SessionModel();
			$this->alertsModel = new AlertsModel();
			$this->usersSentimentModel = new UsersSentimentModel();
			$this->twitterModel = new TwitterModel();
    }

    function execute()
    {
      require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["app_web_path"] . "/includes/ajax_header_commands.php");
      if(!$this->sessionModel->isLoggedUser()) return null;
			$action = isset($_GET["action"]) ? trim($_GET["action"]) : "";
			$filter['type'] = isset($_GET["type"]) ? trim($_GET["type"]) : "";
			$filter['status'] = isset($_GET["status"]) ? trim($_GET["status"]) : "";
			$filter['view_type'] = "";
			
			$typeInfo = $this->alertsModel->getAlertTypes($filter['type']);
			if(!$typeInfo) return null;
			
			$records = null;
			$data['filterTopReturns'] = array();
			$order = "ai.end_date";
			$where = "a.user_id = 'USER_ID_VAL'";
			$params = array(
				'USER_ID_VAL' => $this->sessionModel->uid,
				'NOW_TIME' => date('Y-m-d H:i:s'),
				'TOMORROW_TIME' => date('Y-m-d H:i:s',strtotime('tomorrow'))
			);
			$where .= " AND ((a.status IN(0,1) AND ((ai.end_date > 'NOW_TIME' OR DATEDIFF('TOMORROW_TIME', ai.end_date) = 1) OR (ai.timeframe_id = 10 AND ai.end_date = '0000-00-00 00:00:00')))";
      if($filter['type'] != 'stocks') $where .= "OR (ai.power = 1 AND ai.end_date > 'NOW_TIME')";
			$where .= " OR (a.status IN(2,3) AND DATEDIFF('TOMORROW_TIME', ai.triggered_date) = 1)";
			$where .= ")";
			
			if($filter['status'] !== ""){
				$where .= " AND (a.status = 'STATUS_VAL'";
				$params['STATUS_VAL'] = $filter['status'];
				if($filter['status'] == 1){
					$where .= " AND (ai.end_date >'NOW_TIME' OR (ai.timeframe_id = 10 AND ai.end_date = '0000-00-00 00:00:00'))";
				}elseif($filter['status'] == 3){
					$where .= "OR (a.status = 1 AND ai.end_date <'NOW_TIME' AND ai.timeframe_id <> 10)";
				}
				$where .= ")";
			}
			switch($filter['type']){
		    case 'stocks':
					$filter['view_type'] = "stocks";
					$header['title'] = 'MY STOCK ALERTS';
					$records = $this->alertsModel->getAlerts($where, $params);
		      break;
		    case 'users':
					$filter['view_type'] = "users";
					$header['title'] = 'MY USER ALERTS';
					$where .= " AND a.type = 'TYPE_VAL' AND a.subtype = 'SUBTYPE'";
					$params['TYPE_VAL'] = 'user';
					$params['SUBTYPE'] = 'tickers';
					$records = $this->alertsModel->getMarketUsersAlerts($where, $params, null, $order);
					$records = $this->twitterModel->getUsersInfo($records, false, "usernames");
		      break;
		    case 'top_users_returns':
					$filter['view_type'] = "top_users";
					$header['title'] = 'MY TOP USERS BY RETURNS ALERTS';
					$where .= " AND a.type = 'TYPE_VAL' AND a.subtype = 'SUBTYPE'";
					$params['TYPE_VAL'] = 'top-user';
					$params['SUBTYPE'] = 'tickers';
					$records = $this->alertsModel->getMarketUsersAlerts($where, $params, null, $order);
					$data['filterTopReturns'] = $this->usersSentimentModel->getTopUserReturns();
		    	break;
				case 'top_users_rank':
					$filter['view_type'] = "top_users";
					$header['title'] = 'MY TOP USERS BY MP RANK';
					$where .= " AND a.type = 'TYPE_VAL' AND a.subtype = 'SUBTYPE'";
					$params['TYPE_VAL'] = 'top-mp';
					$params['SUBTYPE'] = 'tickers';
					$records = $this->alertsModel->getMarketUsersAlerts($where, $params, null, $order);
					$data['filterTopReturns'] = $this->usersSentimentModel->getTopMpReturns();
		    	break;
				case 'top_sectors_returns':
					$filter['view_type'] = "top_sectors";
					$header['title'] = 'MY TOP SECTORS BY RETURNS ALERTS';
					$where .= " AND a.type = 'TYPE_VAL' AND a.subtype = 'SUBTYPE'";
					$params['TYPE_VAL'] = 'top-user';
					$params['SUBTYPE'] = 'sectors';
					$records = $this->alertsModel->getMarketUsersAlerts($where, $params, null, $order);
					$data['filterTopReturns'] = $this->usersSentimentModel->getTopUserReturns();
		    	break;
				case 'top_sectors_rank':
					$filter['view_type'] = "top_sectors";
					$header['title'] = 'MY TOP SECTORS BY MP RANK ALERTS';
					$where .= " AND a.type = 'TYPE_VAL' AND a.subtype = 'SUBTYPE'";
					$params['TYPE_VAL'] = 'top-mp';
					$params['SUBTYPE'] = 'sectors';
					$records = $this->alertsModel->getMarketUsersAlerts($where, $params, null, $order);
					$data['filterTopReturns'] = $this->usersSentimentModel->getTopMpReturns();
		    	break;
				default:
					return null;
			}
			if($records){
				$data['operators'] = $this->alertsModel->getAlertsOperators();
      	$data['types'] = $this->alertsModel->getAlertsTypes();
      	$data['timeframes'] = $this->alertsModel->getAlertsTimeframes();
				$data['filterTimeframes'] = $this->usersSentimentModel->getTimeframes();
				$data['defaultTickers'] = $this->usersSentimentModel->getDefaultFilterTickers();
				foreach($records as $item){
					if($item->status == 1 && $item->end_date < $params['NOW_TIME'] && $item->timeframe_id != 10){
						$item->status = 3;
					}
					if(isset($item->type_id_1) && array_key_exists($item->type_id_1, $data['types'])){
						$item->type_1 = $data['types'][$item->type_id_1]->title;
						if($filter['view_type'] != 'stocks'){
							$item->type_1 = str_replace('Crowd ', '', $item->type_1);
						}
					}
					if(isset($item->type_id_2) && array_key_exists($item->type_id_2, $data['types'])){
						$item->type_2 = $data['types'][$item->type_id_2]->title;
						if($filter['view_type'] != 'stocks'){
							$item->type_2 = str_replace('Crowd ', '', $item->type_2);
						}
					}
					if(isset($item->operation_id_1) && array_key_exists($item->operation_id_1, $data['operators'])){
						$item->operation_1 = $data['operators'][$item->operation_id_1]->title;
					}
					if(isset($item->operation_id_2) && array_key_exists($item->operation_id_2, $data['operators'])){
						$item->operation_2 = $data['operators'][$item->operation_id_2]->title;
					}
					if(isset($item->timeframe_id) && array_key_exists($item->timeframe_id, $data['timeframes'])){
						$item->timeframe = $data['timeframes'][$item->timeframe_id]->title;
					}
					if(isset($item->filter_timeframe) && array_key_exists($item->filter_timeframe, $data['filterTimeframes'])){
						$item->filter_timeframe = $data['filterTimeframes'][$item->filter_timeframe]['value'];
					}
					if(isset($item->ticker) && array_key_exists($item->ticker, $data['defaultTickers'])){
						$item->ticker = $data['defaultTickers'][$item->ticker]->short_name;
					}
					if($data['filterTopReturns'] && isset($item->filter_top_returns) && array_key_exists($item->filter_top_returns, $data['filterTopReturns'])){
						$item->filter_top_returns = $data['filterTopReturns'][$item->filter_top_returns];
					}
				}
			}
			$header['title'] = 'MY ' . $typeInfo['title'];
			$header['popup']['title'] = $header['title'];
      $header['popup']['type'] = (isset($_GET["popup_type"]) && $_GET["popup_type"]) ? trim($_GET["popup_type"]) : 'box';
      $header['popup']['url'] = '/ajax/alert/dashboard/list/?type=' . $filter['type'] . '&status=' . $filter['status'] . '&popup_type=window';
      $header['popup']['params'] = "{width:722,height:366,name:'".$header['title']."'}";
			$header['popup']['alert_box_type'] = "list";
			
			//test($records);
			
      $templateParams = array(
        "has_error" => $hasError,
        "status" => $status,
        "header" => $header,
        "action" => $action,
        "filter" => $filter,
        "records" => $records
      );

      return $this->displayTemplate("ajax_alert_dashboard_list.tpl", $templateParams);
    }
  }

?>