<?php

	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/charts_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/pricing_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/memcache_model.php");

	class AjaxChart extends FJF_CMD{
		
		var $sessionModel = null;
		var $chartsModel = null;
		var $memcacheModel = null;

		function __construct(){
			$this->sessionModel = new SessionModel();
			$this->chartsModel = new ChartsModel();
			$this->memcacheModel = new MemcacheModel();
		}

		function execute(){
			$result = array();

			$ticker = isset($_GET["ticker"]) && $_GET["ticker"] ? trim($_GET["ticker"]) : null;
			$data = isset($_GET["data"]) && is_array($_GET["data"]) ? $_GET["data"] : array();
			$interval = isset($_GET["interval"]) && $_GET["interval"] ? trim($_GET["interval"]) : null;
			$tier = $this->sessionModel->isLoggedUser() ? $_SESSION["user"]->tier : 0;
			$tierLimitations = PricingModel::getChartLimit($tier);
			$memcacheKey = $this->memcacheModel->createKey(array(
				'get_chart',
				$ticker,
				$interval,
				implode('_', $data),
				$tier
			));
			$result = $this->memcacheModel->get($memcacheKey);
			if($result === false){
				$result = array();
				if($data){
					$this->chartsModel->logSql("-----------------------------------------------------------------------\nDatetime: " . date("Y-m-d H:i:s") . "\n");
					$total = count($data);
					for($i = 0; $i < $total; $i++){
						$show = ($ticker && ($tierLimitations === null || in_array($data[$i], $tierLimitations)));
						$result[$data[$i]]['records'] = $show ? $this->chartsModel->get($data[$i], $ticker, null, $interval) : array();
						$timeframe = $this->chartsModel->getExtremes();
					  $result[$data[$i]]['timeframe'] = $timeframe ? array(
						  date("Y-m-d H:i:s", $timeframe[0]),
						  date("Y-m-d H:i:s", $timeframe[1])
					  ) : array();
						$result[$data[$i]]['show'] = $show;
	        }
				}
				$this->memcacheModel->set($memcacheKey, $result);
			}
			if(isset($_GET["test"])){
				test($result);
			}

			echo json_encode($result);
			return true;
		}
	}

?>