<?php

  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/alerts_model.php");

  class AjaxDashboardAlertsBox extends FJF_CMD
  {
    var $sessionModel = null;
    var $alertsModel = null;

    function __construct()
    {
      $this->sessionModel = new SessionModel();
      $this->alertsModel = new AlertsModel();
    }

    function execute()
    {
      require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["app_web_path"] . "/includes/header_commands.php");
      if (!$this->sessionModel->isLoggedUser()) return null;
      
      $stockID = (isset($_GET["stock_id"]) && $_GET["stock_id"]) ? trim($_GET["stock_id"]) : '';
			$stock = $stockID ? FJF_BASE_RICH::getRecord("users_stocks", "ticker='ID_VAL' AND user_id='USER_ID' AND status = 1", array(
				'ID_VAL' => $stockID,
				'USER_ID' => $this->sessionModel->uid
			)) : null;
			if(!$stock) return false;
			
      $params['edit'] = (isset($_GET["edit"]) && $_GET["edit"]) ? intval($_GET["edit"]) : 0;
      $header['title'] = ($params['edit'] == 1) ? 'MY STOCK ALERS' : 'STOCK ALERTS';
      $header['popup']['type'] = (isset($_GET["popup_type"]) && $_GET["popup_type"]) ? trim($_GET["popup_type"]) : 'box';
      $header['popup']['url'] = '/ajax/dashboard/alerts-box/?stock_id='.$stockID.'&edit='.$params['edit'].'&popup_type=window';
      $header['popup']['params'] = ($params['edit'] == 1) ? "{width:400,height:594,name:'".$header['title']."'}" : "{width:306,height:255,name:'".$header['title']."'}";
      $header['popup']['reload'] = true;
      
      if(isset($_GET['popup_type']) && $_GET['popup_type'] == 'window'){
	      include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/dashboard_model.php");
				$header['popup']['title'] = DashboardModel::getPopupStockTitle($stock->ticker);
			}
      
			$data = new stdClass;
      $data->operators = $this->alertsModel->getAlertsOperators();
      $data->types = $this->alertsModel->getAlertsTypes();
      $data->timeframes = $this->alertsModel->getAlertsTimeframes();
      
      $where = " a.stock_id = 'STOCK_ID' AND a.user_id=USER_ID AND ";
      $where .= " ((a.status IN(0,1) AND ((ai.end_date > '".date('Y-m-d H:i:s')."' OR DATEDIFF('".date('Y-m-d H:i:s',strtotime('tomorrow'))."', ai.end_date) = 1) OR ai.end_date = '0000-00-00 00:00:00'))";
      $where .= " OR";
      $where .= " (a.status IN(2,3) AND DATEDIFF('".date('Y-m-d H:i:s',strtotime('tomorrow'))."', ai.triggered_date)  = 1 ))";
      $params["STOCK_ID"] = $stockID;
      $params["USER_ID"] = $this->sessionModel->uid;
      //$order = "IF(ai.end_date='0000-00-00 00:00:00', 1, 0), ai.end_date, ai.date";
      $order = "ai.timeframe_id, ai.date";
      $records = $this->alertsModel->getAlerts($where, $params, null, $order);
      if($records){
      	foreach($records as $item){
					if($item->status == 1 && $item->end_date < date('Y-m-d H:i:s') && $item->timeframe_id != 10){
						$item->status = 3;
					}
				}
      }
      
      $templateParams = array(
        "has_error" => $hasError,
        "status" => $status,
        "header" => &$header,
        "records" => $records,
        "params" => $params,
        "data" => $data,
        "stock_id" => $stockID
      );
      return $this->displayTemplate("ajax_dashboard_alerts_box.tpl", $templateParams);
    }
  }

?>