<?php

  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/alerts_model.php");

  class AjaxDashboardEditAlerts extends FJF_CMD
  {
    var $sessionModel = null;
    var $alertsModel = null;

    function __construct()
    {
      $this->sessionModel = new SessionModel();
      $this->alertsModel = new AlertsModel();
    }

    function execute()
    {
      require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["app_web_path"] . "/includes/ajax_header_commands.php");
      if (!$this->sessionModel->isLoggedUser()) return null;
      $user = $this->sessionModel->getUser();
			
      $alertID = (isset($_REQUEST["alert_id"]) && $_REQUEST["alert_id"]) ? intval($_REQUEST["alert_id"]) : 0;
      
      $where = " a.id= ALERT_ID AND a.user_id=USER_ID";
      $params["ALERT_ID"] = $alertID;
      $params["USER_ID"] = $this->sessionModel->uid;
      $record = $this->alertsModel->getAlert($where, $params);
						      
      if($_SERVER["REQUEST_METHOD"] == "POST"){
        $action = isset($_POST["action"]) && $_POST["action"] ? trim($_POST["action"]) : "";
        if($action == 'edit'){
          if(isset($record->status) && in_array($record->status, array(0,2,3))){
            $hasError = true;
						if($record->status == 2){
							$statusType = "triggered";
						}elseif($record->status == 3){
							$statusType = "expired";
						}else{
							$statusType = "frozen";
						}
            $status = 'You cannot modify a ' . $statusType . ' alert.';
            exit(json_encode(array('hasError'=>$hasError, 'status' =>$status)));
          }  
          
          $fileds['alert_id'] = $alertID;
          $fileds['type_id_1'] = isset($_POST["type_id_1"]) && $_POST["type_id_1"] ? intval($_POST["type_id_1"]) : 0;
          $fileds['type_id_2'] = isset($_POST["type_id_2"]) && $_POST["type_id_2"] ? intval($_POST["type_id_2"]) : 0;
          $fileds['operation_id_1'] = isset($_POST["operation_id_1"]) && $_POST["operation_id_1"] ? intval($_POST["operation_id_1"]) : 0;
          $fileds['operation_id_2'] = isset($_POST["operation_id_2"]) && $_POST["operation_id_2"] ? intval($_POST["operation_id_2"]) : 0;
          $fileds['value_1'] = isset($_POST["value_1"]) ? floatval($_POST["value_1"]) : null;
          $fileds['value_2'] = isset($_POST["value_2"]) ? floatval($_POST["value_2"]) : null;
          $fileds['operation'] = isset($_POST["operation"]) && $_POST["operation"] ? intval($_POST["operation"]) : 0;
          $fileds['timeframe_id'] = isset($_POST["timeframe_id"]) && $_POST["timeframe_id"] ? intval($_POST["timeframe_id"]) : 0;
          $fileds['date'] = date('Y-m-d H:i:s');
          $fileds['status'] = 1;

          if ($fileds['operation'] == 2)
          {
            $fileds['type_id_2'] = 0;
            $fileds['operation_id_2'] = 0;
            $fileds['value_2'] = 0;
          }
          /*
          if ($fileds['type_id_1'] == 6)
          {
            $fileds['value_1'] = $this->alertsModel->checkPercentFormat(trim($_POST["value_1"]));
          }
          if ($fileds['type_id_2'] == 6)
          {
            $fileds['value_2'] = $this->alertsModel->checkPercentFormat(trim($_POST["value_2"]));
          }
          */
          if(!$fileds['alert_id'])
          {
            $hasError = true;
            $status .= "Alert ID is missing.";
          }
                    
          if(!$fileds['type_id_1'] || ( $fileds['operation'] != 2 && !$fileds['type_id_2']))
          {
            $hasError = true;
            $status .= "Select Type.\n";
          }
          
          if(!$fileds['operation_id_1'] || ($fileds['operation'] != 2 && !$fileds['operation_id_2']))
          {
            $hasError = true;
            $status .= "Select Operation.\n";
          }
          
          if($fileds['value_1'] === null || ($fileds['operation'] != 2 && $fileds['value_2'] === null))
          {
            $hasError = true;
            $status .= "Value is empty.\n";
          }

          if(!$this->alertsModel->validateAlertOption($fileds['type_id_1'], $fileds['value_1'], $fileds['operation_id_1']))
          {
            $hasError = true;
            $status .= "Value is not valid for this variable.\n";
          }elseif($fileds['operation'] != 2 && !$this->alertsModel->validateAlertOption($fileds['type_id_2'], $fileds['value_2'], $fileds['operation_id_2']))
          {
            $hasError = true;
            $status .= "Value is not valid for this variable.\n";
          }
					elseif($fileds['type_id_1'] && $fileds['type_id_2'] && $fileds['type_id_1'] == $fileds['type_id_2'] && $fileds['operation'] == 1 && !$this->alertsModel->validateAlertOptionsSameTypes($fileds['value_1'], $fileds['value_2'], $fileds['operation_id_1'], $fileds['operation_id_2'])){
						$hasError = true;
            $status .= "Invalid value.\n";
					}
          
          if(!$fileds['timeframe_id'])
          {
            $hasError = true;
            $status .= "Select Timeframe.";
          }
          elseif($fileds['timeframe_id'] != 10 && $this->alertsModel->getEndDate($fileds['timeframe_id']) < date('Y-m-d H:i:s'))
          {
            $hasError = true;
            $status .= "Invalid Timeframe.";
          }
          
          if(!$hasError)
          {
          	$isChanges = $record ? false : true;
          	if($record){
          		if($record->type_id_1 != $fileds['type_id_1'] || $record->type_id_2 != $fileds['type_id_2'] || $record->operation_id_1 != $fileds['operation_id_1']
								|| $record->operation_id_2 != $fileds['operation_id_2'] || floatval($record->value_1) != $fileds['value_1'] || floatval($record->value_2) != $fileds['value_2']
								|| intval($record->operation) != $fileds['operation'] || $record->timeframe_id != $fileds['timeframe_id'])
							{
								$isChanges = true;
							}
          	}
						
						$status = $this->alertsModel->editAlert($fileds, $isChanges);
            
            if(!$status)
            {
              $hasError = true;
              $status = "Error while saving record info. Please, try again later and contact support.";
            }
          }
        }
        elseif($action == 'delete')
        {
          if(!$this->alertsModel->removeAlert($alertID))
          {
          	$hasError = true;
            $status = "Error while deleting record info. Please, try again later and contact support.";
          }else{
          	$this->alertsModel->changeUserAlertPendingStatus($user->id, $user->tier);
          }
        }
        exit(json_encode(array('hasError'=>$hasError, 'status' =>$status)));
      }
      
			$data = new stdClass;  
      $data->operators = $this->alertsModel->getAlertsOperators();
      $data->types = $this->alertsModel->getAlertsTypes();
      $data->timeframes = $this->alertsModel->getAlertsTimeframes();
            
      if ($record) $record->history = $this->alertsModel->getAlertHistory('ai.alert_id= ALERT_ID', $params, null, 'ai.date DESC');
      
      $templateParams = array(
        "has_error" => $hasError,
        "status" => $status,
        "header" => &$header,
        "record" => $record,
        "data" => $data
      );
      return $this->displayTemplate("ajax_dashboard_edit_alerts.tpl", $templateParams);
    }

  }

?>