<?php

  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/alerts_model.php");
  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/sentiment_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/pricing_model.php");

  class AjaxDashboardEditAlertsBox extends FJF_CMD
  {
    var $sessionModel = null;
    var $alertsModel = null;
    var $sentimentModel = null;

    function __construct()
    {
      $this->sessionModel = new SessionModel();
      $this->alertsModel = new AlertsModel();
      $this->sentimentModel = new SentimentModel();
    }

    function execute()
    {
      require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["app_web_path"] . "/includes/ajax_header_commands.php");
      if (!$this->sessionModel->isLoggedUser()) return null;
      $user = $this->sessionModel->getUser();
      
			$isAjax = !empty($_SERVER['HTTP_X_REQUESTED_WITH']) && strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) == 'xmlhttprequest';
      $stockID = (isset($_REQUEST["stock_id"]) && $_REQUEST["stock_id"]) ? trim($_REQUEST["stock_id"]) : '';
			if(!$isAjax){
				$stock = $stockID ? FJF_BASE_RICH::getRecord("users_stocks", "ticker='ID_VAL' AND user_id='USER_ID' AND status = 1", array(
					'ID_VAL' => $stockID,
					'USER_ID' => $this->sessionModel->uid
				)) : null;
				if(!$stock) return false;
			}
      
      if($_SERVER["REQUEST_METHOD"] == "POST")
      {
        $action = isset($_POST["action"]) && $_POST["action"] ? trim($_POST["action"]) : "";
        if ($action == 'add')
        {
        	$fileds['user_id'] = $user->id;
          $fileds['stock_id'] = $stockID;
          $fileds['prediction_id'] = isset($_POST["prediction_id"]) && $_POST["prediction_id"] ? intval($_POST["prediction_id"]) : 0;
          $fileds['status'] = 1;
          $fileds2['type_id_1'] = isset($_POST["type_id_1"]) && $_POST["type_id_1"] ? intval($_POST["type_id_1"]) : 0;
          $fileds2['type_id_2'] = isset($_POST["type_id_2"]) && $_POST["type_id_2"] ? intval($_POST["type_id_2"]) : 0;
          $fileds2['operation_id_1'] = isset($_POST["operation_id_1"]) && $_POST["operation_id_1"] ? intval($_POST["operation_id_1"]) : 0;
          $fileds2['operation_id_2'] = isset($_POST["operation_id_2"]) && $_POST["operation_id_2"] ? intval($_POST["operation_id_2"]) : 0;
          $fileds2['value_1'] = isset($_POST["value_1"]) ? floatval($_POST["value_1"]) : null;
          $fileds2['value_2'] = isset($_POST["value_2"]) ? floatval($_POST["value_2"]) : null;
          $fileds2['operation'] = isset($_POST["operation"]) && $_POST["operation"] ? intval($_POST["operation"]) : 0;
          $fileds2['timeframe_id'] = isset($_POST["timeframe_id"]) && $_POST["timeframe_id"] ? intval($_POST["timeframe_id"]) : 0;
          $fileds2['date'] = date('Y-m-d H:i:s');
          $fileds2['status'] = 0;
          
          if ($fileds2['operation'] == 2)
          {
            $fileds2['type_id_2'] = 0;
            $fileds2['operation_id_2'] = 0;
            $fileds2['value_2'] = 0;
          }
          /*
          if ($fileds2['type_id_1'] == 6)
          {
            $fileds2['value_1'] = $this->alertsModel->checkPercentFormat(trim($_POST["value_1"]));
          }
          if ($fileds2['type_id_2'] == 6)
          {
            $fileds2['value_2'] = $this->alertsModel->checkPercentFormat(trim($_POST["value_2"]));
          }
          */
          if(!$fileds['stock_id']){
          	$hasError = true;
            $status .= "Ticker is missing.\n";
          }
					
          if(!$fileds2['type_id_1'] || ( $fileds2['operation'] != 2 && !$fileds2['type_id_2']))
          {
            $hasError = true;
            $status .= "Select Type.\n";
          }
          
          if(!$fileds2['operation_id_1'] || ($fileds2['operation'] != 2 && !$fileds2['operation_id_2']))
          {
            $hasError = true;
            $status .= "Select Operation.\n";
          }
          
          if($fileds2['value_1'] === null || ($fileds2['operation'] != 2 && $fileds2['value_2'] === null))
          {
            $hasError = true;
            $status .= "Value is empty.\n";
          }

          if(!$this->alertsModel->validateAlertOption($fileds2['type_id_1'], $fileds2['value_1'], $fileds2['operation_id_1']))
          {
            $hasError = true;
            $status .= "Value is not valid for this variable.\n";
          }elseif($fileds2['operation'] != 2 && !$this->alertsModel->validateAlertOption($fileds2['type_id_2'], $fileds2['value_2'], $fileds2['operation_id_2']))
          {
            $hasError = true;
            $status .= "Value is not valid for this variable.\n";
          }
					elseif($fileds2['type_id_1'] && $fileds2['type_id_2'] && $fileds2['type_id_1'] == $fileds2['type_id_2'] && $fileds2['operation'] == 1 && !$this->alertsModel->validateAlertOptionsSameTypes($fileds2['value_1'], $fileds2['value_2'], $fileds2['operation_id_1'], $fileds2['operation_id_2'])){
						$hasError = true;
            $status .= "Invalid value.\n";
					}
          
          if(!$fileds2['timeframe_id'])
          {
            $hasError = true;
            $status .= "Select Timeframe.\n";
          }
          elseif($fileds2['timeframe_id'] != 10 && $this->alertsModel->getEndDate($fileds2['timeframe_id']) < date('Y-m-d H:i:s'))
          {
            $hasError = true;
            $status .= "Invalid Timeframe.";
          }

          if(!$user->tier){
						$hasError = true;
						$status = array(
							"title" => "Your account is no longer valid!",
							"message" => "If you would like to activate your subscription, please enter your credit card information with a valid credit card in User Account Settings.",
						);
	         }elseif(!$this->alertsModel->cheakOpenAlertCount($user->id, PricingModel::getAlertsLimit($user->tier))){
            $hasError = true;
            $status = array(
            	"title" => "Sorry, But You Have Reached Your Limit!",
            	"message" => "You have reached your maximum active daily alert limit. You must either remove an active alert or wait for one or more active alerts to expire or trigger before adding a new alert."
           	);
          }
          
          if(!$hasError)
          {
            $status = $this->alertsModel->addAlert($fileds, $fileds2);
            if(!$status)
            {
              $hasError = true;
              $status = "Error while saving record info. Please, try again later and contact support.";
            }
          }
        }
        exit(json_encode(array('hasError'=>$hasError, 'status' =>$status)));
      }
      $header['title'] = 'CREATE NEW STOCK ALERT';
      $header['popup']['type'] = (isset($_GET["popup_type"]) && $_GET["popup_type"]) ? trim($_GET["popup_type"]) : 'box';
      $header['popup']['url'] = '/ajax/dashboard/edit-alerts-box/?stock_id='.$stockID.'&popup_type=window';
      $header['popup']['params'] = "{width:520,height:404,name:'".$header['title']."'}";
      $header['popup']['reload'] = true;
			
			if(isset($_GET['popup_type']) && $_GET['popup_type'] == 'window'){
	      include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/dashboard_model.php");
				$header['popup']['title'] = DashboardModel::getPopupStockTitle($stock->ticker);
			}
      
			$data = new stdClass;
      $data->operators = $this->alertsModel->getAlertsOperators();
      $data->types = $this->alertsModel->getAlertsTypes();
      $data->timeframes = $this->alertsModel->getAlertsTimeframes();
      $records = array();
      

      $templateParams = array(
        "has_error" => $hasError,
        "status" => $status,
        "header" => &$header,
        "records" => $records,
        "data" => $data,
        "stock_id" => $stockID
      );
      return $this->displayTemplate("ajax_dashboard_edit_alerts_box.tpl", $templateParams);
    }

  }

?>