<?php

  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/stock_charts_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/price_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/users_sentiment_model.php");

  class AjaxDashboardGraphsBox extends FJF_CMD
  {
    var $sessionModel = null;
    var $stockChartsModel = null;
		var $usersSentimentModel = null;

    function __construct()
    {
      $this->sessionModel = new SessionModel();
      $this->stockChartsModel = new StockChartsModel();
			$this->usersSentimentModel = new UsersSentimentModel();
    }

    function execute()
    {
      require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["app_web_path"] . "/includes/ajax_header_commands.php");
			if(!$this->sessionModel->isLoggedUser()) return false;

      $ticker = isset($_GET["stock_id"]) && $_GET["stock_id"] ? trim($_GET["stock_id"]) : null;
			$stockSql = 'SELECT us.id, us.ticker, sd.exchange FROM users_stocks us';
			$stockSql .= ' LEFT JOIN stocks_data sd ON us.ticker = sd.ticker';
			$stockSql .= " WHERE us.ticker='ID_VAL' AND us.user_id='USER_ID' AND us.status = 1";
			$stockParams = array('ID_VAL' => $ticker, 'USER_ID' => $this->sessionModel->uid);
			$stock = $ticker ? FJF_BASE_RICH::selectRecords($stockSql, $stockParams, true) : null;
			if(!$stock) return false;
			$stockID = $stock->id;
      $stock->decimals = PriceModel::getPennyDecimals($stock->exchange);
			$intervals = $this->usersSentimentModel->getIntervals();
			array_unshift($intervals, array("value" => "1D", "interval" => "1 DAY"));

      $header['title'] = 'GRAPHS';
      $header['popup']['type'] = isset($_GET["popup_type"]) && $_GET["popup_type"] ? trim($_GET["popup_type"]) : 'box';
      $header['popup']['url'] = '/ajax/dashboard/graphs-box/?stock_id='.$ticker.'&popup_type=window';
      $header['popup']['params']['col'] = "{width:436,height:621}";
      $header['popup']['params']['row'] = "{width:852,height:360}";

			$row = isset($_GET["row"]) ? intval($_GET["row"]) : null;
			$col = isset($_GET["col"]) ? intval($_GET["col"]) : null;

			if($_SERVER["REQUEST_METHOD"] == 'POST'){
				$json = array(
					"has_error" => false,
	        "status" => ""
				);

				$action = isset($_POST["action"]) ? $_POST["action"] : null;
				if($action == "add" || $action == "edit"){
					if(!$stockID || is_null($row) || is_null($col)){
						$json["has_error"] = true;
						$json["status"] .= "Invalid request parameters.\n";
					}

					if($action == "edit") $chart = isset($_POST["chart"]) && $_POST["chart"] ? $_POST["chart"] : null;
					else $chart = $this->stockChartsModel->getDefaultChart();

					if(!$this->stockChartsModel->setStockChart($stockID, $row, $col, $chart)){
						$json["has_error"] = true;
						$json["status"] = "Saving to DB error.";
					}else{
						$GLOBALS["smartyEngine"]->assign("record", $chart);
						$GLOBALS["smartyEngine"]->assign("row", $row);
						$GLOBALS["smartyEngine"]->assign("col", $col);
						$json["template"] = $this->fetchTemplate("ajax_dashboard_graphs_box_item.tpl", array(
							"header" => $header,
							"types" => $this->stockChartsModel->types,
							"stock" => $stock,
							"intervals" => $intervals
						));
					}
				}else{
					$json["has_error"] = true;
					$json["status"] = "Invalid action.";
				}

				echo json_encode($json);
				return true;
			}//POST


			if(isset($_GET['popup_type']) && $_GET['popup_type'] == 'window'){
	      include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/dashboard_model.php");
				$header['popup']['title'] = DashboardModel::getPopupStockTitle($stock->ticker);
			}

			$records = array();
			FJF_BASE_RICH::db();
			if($tmp = $this->stockChartsModel->getStockCharts($stockID)){
				foreach($tmp as $r => $items){
					if(is_null($row) || $row == $r){
						foreach($items as $c => $item){
							if(is_null($col) || $col == $c){
								if(!isset($tmp[$r])) $tmp[$r] = array();
								$records[$r][$c] = $item;
							}
						}
					}
				}
			}

      $templateParams = array(
        "has_error" => $hasError,
        "status" => $status,
        "header" => &$header,
        "types" => $this->stockChartsModel->types,
        "stock" => $stock,
        "records" => $records,
        "intervals" => $intervals,
        "row" => $row,
        "col" => $col
      );
      return $this->displayTemplate("ajax_dashboard_graphs_box.tpl", $templateParams);
    }
  }

?>