<?php

  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/alerts_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/users_sentiment_model.php");

  class AjaxDashboardTopAlertsBox extends FJF_CMD
  {
    var $sessionModel = null;
    var $alertsModel = null;
		var $usersSentimentModel = null;

    function __construct()
    {
      $this->sessionModel = new SessionModel();
      $this->alertsModel = new AlertsModel();
			$this->usersSentimentModel = new UsersSentimentModel();
    }

    function execute()
    {
      require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["app_web_path"] . "/includes/header_commands.php");
      if (!$this->sessionModel->isLoggedUser()) return null;
      
      $stockID = (isset($_GET["stock_id"]) && $_GET["stock_id"]) ? trim($_GET["stock_id"]) : '';
			$stock = $stockID ? FJF_BASE_RICH::getRecord("users_stocks", "ticker='ID_VAL' AND user_id='USER_ID' AND status = 1", array(
				'ID_VAL' => $stockID,
				'USER_ID' => $this->sessionModel->uid
			)) : null;
			if(!$stock) return false;
			
      $edit = (isset($_GET["edit"]) && $_GET["edit"]) ? intval($_GET["edit"]) : 0;
      $type = (isset($_GET["type"]) && $_GET["type"]) ? trim($_GET["type"]) : '';
      
      $header['title'] = (($edit == 1) ? 'MY ' : '').'TOP USERS';
			if ($type) $header['title'] .= ($type == 'top-mp') ? ' BY MP RANK' : ' BY RETURNS';
      $header['title'] .= ' ALERTS';
      $header['popup']['type'] = (isset($_GET["popup_type"]) && $_GET["popup_type"]) ? trim($_GET["popup_type"]) : 'box';
      $header['popup']['url'] = '/ajax/dashboard/top-alerts-box/?stock_id='.$stockID.'&edit='.$edit.'&popup_type=window'.($type ? '&type='.$type : '');
      $header['popup']['params'] = ($edit == 1) ? "{width:400,height:594,name:'".$header['title']."'}" : "{width:306,height:255,name:'".$header['title']."'}";
      $header['popup']['reload'] = true;
      
      if(isset($_GET['popup_type']) && $_GET['popup_type'] == 'window'){
	      include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/dashboard_model.php");
				$header['popup']['title'] = DashboardModel::getPopupStockTitle($stock->ticker);
			}
      
			$data = new stdClass;
      $data->operators = $this->alertsModel->getAlertsOperators();
      $data->types = $this->alertsModel->getAlertsTypes();
      $data->timeframes = $this->alertsModel->getAlertsTimeframes();
			$data->filterTimeframes = $this->usersSentimentModel->getTimeframes();
			$data->defaultTickers = $this->usersSentimentModel->getDefaultFilterTickers();
			
      $where = " ai.ticker = 'TICKER_VAL' AND a.user_id=USER_ID AND a.subtype='tickers'";
      if($type){
      	$where .= " AND a.type = 'TYPE_VAL'";
			}else{
				$where .= " AND (a.type = 'top-mp' OR a.type = 'top-user')";
			}
      $where .= " AND ((a.status IN(0,1) AND ((ai.end_date > '".date('Y-m-d H:i:s')."' OR DATEDIFF('".date('Y-m-d H:i:s',strtotime('tomorrow'))."', ai.end_date) = 1) OR ai.end_date = '0000-00-00 00:00:00'))";
      $where .= " OR (ai.power = 1 AND ai.end_date > '" . date('Y-m-d H:i:s') . "')";
      $where .= " OR (a.status IN(2,3) AND DATEDIFF('".date('Y-m-d H:i:s',strtotime('tomorrow'))."', ai.triggered_date)  = 1 ))";
      if($type) $params["TYPE_VAL"] = $type;
      $params["USER_ID"] = $this->sessionModel->uid;
			$params["TICKER_VAL"] = $stock->ticker;
      $order = "ai.end_date";
      $records = $this->alertsModel->getMarketUsersAlerts($where, $params, null, $order);
			if($records){
				foreach($records as $item){
					if($item->status == 1 && $item->end_date < date('Y-m-d H:i:s') && $item->timeframe_id != 10){
						$item->status = 3;
					}
					if(array_key_exists($item->type_id_1, $data->types)){
						$item->type_1 = str_replace('Crowd ', '', $data->types[$item->type_id_1]->title);
					}
					if(array_key_exists($item->type_id_2, $data->types)){
						$item->type_2 = str_replace('Crowd ', '', $data->types[$item->type_id_2]->title);
					}
					if(array_key_exists($item->operation_id_1, $data->operators)){
						$item->operation_1 = $data->operators[$item->operation_id_1]->title;
					}
					if(array_key_exists($item->operation_id_2, $data->operators)){
						$item->operation_2 = $data->operators[$item->operation_id_2]->title;
					}
					if(array_key_exists($item->timeframe_id, $data->timeframes)){
						$item->timeframe = $data->timeframes[$item->timeframe_id]->title;
					}
					if(array_key_exists($item->filter_timeframe, $data->filterTimeframes)){
						$item->filter_timeframe = $data->filterTimeframes[$item->filter_timeframe]['value'];
					}
					if(array_key_exists($item->ticker, $data->defaultTickers)){
						$item->ticker = $data->defaultTickers[$item->ticker]->short_name;
					}
					$filterTopReturns = ($item->type == 'top-mp') ? $this->usersSentimentModel->getTopMpReturns() :  $this->usersSentimentModel->getTopUserReturns();
					if(array_key_exists($item->filter_top_returns, $filterTopReturns)){
						$item->filter_top_returns = $filterTopReturns[$item->filter_top_returns];
					}
				}
			}
      $templateParams = array(
        "has_error" => $hasError,
        "status" => $status,
        "header" => $header,
        "records" => $records,
        "data" => $data,
        "edit" => $edit,
        "type" => $type,
        "stock_id" => $stockID
      );
      return $this->displayTemplate("ajax_dashboard_top_alerts_box.tpl", $templateParams);
    }
  }

?>