<?php

  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/alerts_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/users_sentiment_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/sentiment_model.php");

  class AjaxDashboardTopEditAlertsBox extends FJF_CMD
  {
    var $sessionModel = null;
		var $alertsModel = null;
		var $usersSentimentModel = null;
		var $sentimentModel = null;

    function __construct()
    {
      $this->sessionModel = new SessionModel();
			$this->alertsModel = new AlertsModel();
			$this->usersSentimentModel = new UsersSentimentModel();
			$this->sentimentModel = new SentimentModel();
    }

    function execute()
    {
      require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["app_web_path"] . "/includes/ajax_header_commands.php");
      if (!$this->sessionModel->isLoggedUser()) return null;
      $user = $this->sessionModel->getUser();
      
      $stockID = (isset($_REQUEST["stock_id"]) && $_REQUEST["stock_id"]) ? trim($_REQUEST["stock_id"]) : '';
			$stock = $stockID ? FJF_BASE_RICH::getRecord("users_stocks", "ticker='ID_VAL' AND user_id='USER_ID' AND status = 1", array(
				'ID_VAL' => $stockID,
				'USER_ID' => $this->sessionModel->uid
			)) : null;
			if(!$stock) return false;
			$ticker = $stock->ticker;
			$type = (isset($_GET["type"]) && $_GET["type"]) ? trim($_GET["type"]) : 'top-user';
			$header['title'] = ($type == 'top-mp') ? 'CREATE NEW TOP USERS BY MP RANK ALERT' : 'CREATE NEW TOP USERS BY RETURNS ALERT';
      $header['popup']['type'] = (isset($_GET["popup_type"]) && $_GET["popup_type"]) ? trim($_GET["popup_type"]) : 'box';
      $header['popup']['url'] = '/ajax/dashboard/top-edit-alerts-box/?stock_id='.$stockID.'&popup_type=window&type='.$type;
      $header['popup']['params'] = "{width:520,height:584,name:'".$header['title']."'}";
      $header['popup']['reload'] = true;
			
			if(isset($_GET['popup_type']) && $_GET['popup_type'] == 'window'){
	      include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/dashboard_model.php");
				$header['popup']['title'] = DashboardModel::getPopupStockTitle($stock->ticker);
			}
			
			$data = new stdClass;
			switch ($type){
		    case "top-user":
					$data->topUserReturns = $this->usersSentimentModel->getTopUserReturns();
	        break;
		    case "top-mp":
					$data->topMpReturns = $this->usersSentimentModel->getTopMpReturns();
	        break;
				default:
				return null;
			}
			$data->operators = $this->alertsModel->getAlertsOperators();
      $data->timeframes = $this->usersSentimentModel->getTimeframes();
			$data->alertsTimeframes = $this->alertsModel->getAlertsTimeframes();
			

      $templateParams = array(
        "has_error" => $hasError,
        "status" => $status,
        "header" => $header,
        "data" => $data,
        "ticker" => $ticker,
        "type" => $type,
        "subtype" => "tickers",
        "stock_id" => $stockID
      );
      return $this->displayTemplate("ajax_dashboard_top_edit_alerts_box.tpl", $templateParams);
    }
  }

?>