<?php

  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/users_sentiment_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/twitter_model.php");


  class AjaxDashboardTopStatsBox extends FJF_CMD
  {
    var $sessionModel = null;
		var $usersSentimentModel = null;
		var $twitterModel = null;


    function __construct()
    {
      $this->sessionModel = new SessionModel();
			$this->usersSentimentModel = new UsersSentimentModel();
			$this->twitterModel = new TwitterModel();
    }

    function execute()
    {
      require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["app_web_path"] . "/includes/header_commands.php");
      if (!$this->sessionModel->isLoggedUser()) return null;
      
      $stockID = (isset($_GET["stock_id"]) && $_GET["stock_id"]) ? trim($_GET["stock_id"]) : '';
			$stock = $stockID ? FJF_BASE_RICH::getRecord("users_stocks", "ticker='ID_VAL' AND user_id='USER_ID' AND status = 1", array(
				'ID_VAL' => $stockID,
				'USER_ID' => $this->sessionModel->uid
			)) : null;
			if(!$stock) return false;
			
			$data = new stdClass;
      $data->type = (isset($_GET["type"]) && $_GET["type"]) ? trim($_GET["type"]) : 'top-user';
      $data->filter = new stdClass;
			$data->filter->timefarme = (isset($_GET['timeframe'])) ? trim($_GET['timeframe']) : '';
			$data->action = (isset($_GET['action'])) ? trim($_GET['action']) : '';
      $header['title'] = ($data->type == 'top-mp') ? 'TOP 3 MARKET PROPHITS' : 'TOP 3 USERS BY RETURNS';
      $header['popup']['type'] = (isset($_GET["popup_type"]) && $_GET["popup_type"]) ? trim($_GET["popup_type"]) : 'box';
      $header['popup']['url'] = '/ajax/dashboard/top-stats-box/?stock_id='.$stockID.'&popup_type=window&type='.$data->type;
      if ($data->type == 'top-user'){
      	$header['popup']['params'] = "{width:900,height:309,name:'".$header['title']."'}";
			}else{
				$header['popup']['params'] = "{width:900,height:301,name:'".$header['title']."'}";
			}
      $header['popup']['reload'] = true;
      
      if(isset($_GET['popup_type']) && $_GET['popup_type'] == 'window'){
	      include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/dashboard_model.php");
				$header['popup']['title'] = DashboardModel::getPopupStockTitle($stock->ticker);
			}
			
			$tables = array('top-user'=>'TopUsers_TickerReturns' , 'top-mp'=>'TopUsers_TickerScore');
			$table = (array_key_exists($data->type, $tables)) ? $tables[$data->type] : null;
			if(!$table) return false;
			
			$data->filter_timeframes = $this->usersSentimentModel->getFilterTimeframes();
			$data->timeframes = $this->usersSentimentModel->getTimeframes();
			$order = "RANK";
			$limit = 3;
			$params['TICKER_VAL'] = $stock->ticker;
			$fields = 'RANK AS rank, USERNAME AS username, PNL AS pnl,  MP_SCORE AS mps, MP_RANK AS mpr, MP_PREVIOUS_RANK AS prev_mpr, TIME_FRAME AS timeframe';

			$where = "TS = (SELECT TS FROM ".$table." ORDER BY TS DESC LIMIT 1) AND TICKER = 'TICKER_VAL' AND pnl > 0";
			$tmpKeys = array_keys($data->timeframes);
			$filterTimeframe = ($data->filter->timefarme) ? $data->filter->timefarme : array_shift($tmpKeys);
			if ($filterTimeframe){
				$params['TIMEFRAME_VAL'] = $filterTimeframe;
				$where .= " AND TIME_FRAME ='TIMEFRAME_VAL'";
			}
			$records = $this->usersSentimentModel->getTopTenReturns($table, $where, $params, $limit, $order, $fields);
			if ($records){
				if ($data->timeframes){
					$records = $this->twitterModel->getUsersInfo($records, false);
					foreach($records as $key => $item){
						if (array_key_exists($item->timeframe,$data->timeframes)){
							$records[$key]->timeframe = $data->timeframes[$item->timeframe]['value'];
						}
					}
				}
			}
			if (!$records) $records = array();
			if ($count = $limit-count($records)){
				for ($i=0; $i < $count; $i++) {
					$records[] = null;
				}
			}

      
      $templateParams = array(
        "has_error" => $hasError,
        "status" => $status,
        "header" => $header,
        "records" => $records,
        "data" => $data,
        "stock_id" => $stockID
      );
      return $this->displayTemplate("ajax_dashboard_top_stats_box.tpl", $templateParams);
    }
  }

?>