<?php

  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/rest_model.php");

  class AjaxDashboardTweets extends FJF_CMD
  {
    var $sessionModel = null;
    var $restModel = null;

    function __construct()
    {
      $this->sessionModel = new SessionModel();
      $this->restModel = new RestModel();
    }

    function execute()
    {
      require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["app_web_path"] . "/includes/ajax_header_commands.php");
      if (!$this->sessionModel->isLoggedUser()) return null;
      
      $stockID = (isset($_GET["stock_id"]) && $_GET["stock_id"]) ? trim($_GET["stock_id"]) : '';
      $stock = $stockID ? FJF_BASE_RICH::getRecord("users_stocks", "ticker='ID_VAL' AND user_id='USER_ID' AND status = 1", array(
				'ID_VAL' => $stockID,
				'USER_ID' => $this->sessionModel->uid
			)) : null;
			if(!$stock) return false;
			
      $header['title'] = 'TWEETS';
      $header['popup']['type'] = (isset($_GET["popup_type"]) && $_GET["popup_type"]) ? trim($_GET["popup_type"]) : 'box';
      $header['popup']['url'] = '/ajax/dashboard/tweets/?stock_id='.$stockID.'&popup_type=window';
      $header['popup']['params'] = "{width:322,height:642,name:'".$header['title']."'}";
      
			if(isset($_GET['popup_type']) && $_GET['popup_type'] == 'window'){
	      include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/dashboard_model.php");
				$header['popup']['title'] = DashboardModel::getPopupStockTitle($stock->ticker);
			}
			
      $ticker = ($stock && $stock->ticker != "") ? $stock->ticker : null;
      
      $templateParams = array(
        "has_error" => $hasError,
        "status" => $status,
        "header" => &$header,
        "ticker" => &$ticker 
      );
      return $this->displayTemplate("ajax_dashboard_tweets.tpl", $templateParams);
    }
  }

?>