<?php

class AjaxGetBatch extends FJF_CMD{
	
	public $queries = array(
		"ajax/chart" => "ajax_chart"
	);
	
	function parseQuery($query){
		$url = isset($query['url']) ? $query['url'] : null;
		if(!$url) return null;
		
		$url = parse_url($url);
		$path = trim($url['path'], "/");
		if(!array_key_exists($path, $this->queries)) return null;
		
		$data = isset($query['data']) && is_array($query['data']) ? $query['data'] : array();
		if(isset($url['query'])) parse_str($url['query'], $query);
		else $query = array();
		
		$query = array_merge($query, $data);
		$query['cmd'] = $this->queries[$path];
		
		return $query;
	}//parseQuery
	
	function errorHandler($errno, $errstr, $errfile, $errline){
		if(!(error_reporting() & $errno)) return;

    switch($errno){
	    case E_USER_ERROR:
	        echo "<b>ERROR</b>";
	        break;
	
	    case E_USER_WARNING:
	        echo "<b>WARNING</b>";
	        break;
	
	    case E_USER_NOTICE:
	        echo "<b>NOTICE</b>";
	        break;
	
	    default:
	        echo "Unknown error:";
	        break;
    }
		echo " [$errno] $errstr<br />\n in $errfile on line $errline";
		
		return true;
	}
	
	function executeQuery($query){
		$query = $this->parseQuery($query);
		if(!$query) return null;
		
		$cmd = isset($query['cmd']) ? $query['cmd'] : null;
		if(!$cmd) return null;
		
		$_get = $_GET;
		$_GET = $query;
		
		
		ob_start();
		set_error_handler(array($this, "errorHandler"));
		FJF_BASE::process_request($cmd);
		restore_error_handler();
		$result = ob_get_clean();
		
		$_GET = $_get;
		
		return $result;
	}//executeQuery
	
	function execute(){
		
		$batch = isset($_GET["batch"]) && is_array($_GET["batch"]) ? $_GET["batch"] : null;
		foreach($batch as $i => $query){
			$batch[$i] = $this->executeQuery($query);
		}
		
		if(isset($_GET["test"])){
			test($batch);
		}
		echo json_encode($batch);
		return true;
	}
}

?>