<?php

	class AjaxGetSentiment extends FJF_CMD{
		
		function execute(){
			
			$stockID = isset($_GET["stock_id"]) && $_GET["stock_id"] ? trim($_GET["stock_id"]) : null;
			$stock = $stockID ? FJF_BASE_RICH::getRecordBy("users_stocks", $stockID) : null;
			
			$ymd = date("Y-m-d");
			$startTime = $ymd . " 09:30:00";
			$endTime = $ymd . " 16:00:00";
			
			$records = array();
			if($stock){
				
				$sql = "SELECT TICKER, CONVERT_TZ(TS,'GMT','US/Eastern') AS TS, AVERAGE_SENTIMENT AS VALUE";
				$sql .= " FROM SentimentData_Averaged";
				$sql .= " WHERE TICKER = 'TICKER_VAL'";
				$sql .= " AND FREQUENCY = 60 AND WINDOW_SIZE = 60";
				$sql .= " AND TS BETWEEN CONVERT_TZ('MIN_VAL', 'US/Eastern', 'GMT') AND CONVERT_TZ('MAX_VAL', 'US/Eastern', 'GMT')";
				$sql .= " ORDER BY TS";
				
				FJF_BASE_RICH::db("sentiment");
				
				if($tmp = FJF_BASE_RICH::selectRecords($sql, array(
					'TICKER_VAL' => $stock->ticker,
					'MIN_VAL' => $startTime,
					'MAX_VAL' => $endTime
				))){
					foreach($tmp as $item) $records[$item->TS] = floatval($item->VALUE);
				}
				
			}

			$startTime = strtotime($startTime);
			$endTime = strtotime($endTime);
			
			for($i = $startTime; $i <= $endTime; $i += 60){
				$key = date("Y-m-d H:i:00", $i);
				echo $key . "," . ($records && array_key_exists($key, $records) ? $records[$key] : 0) . "\n";
			}
			
			return true;
		}
		
	}
	
?>
