<?php

	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/xignite_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/price_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/memcache_model.php");
	

  class AjaxGetStockFundamentals extends FJF_CMD{
  	
		var $memcacheModel = null;
		
		function __construct(){
			$this->memcacheModel = new MemcacheModel();
		}

    function execute(){
			$stockFundamentals = null;
			FJF_BASE_RICH::db("sentiment");
			
			$ticker = isset($_GET["ticker"]) ? trim($_GET["ticker"]) : "";
			$memcacheKey = $this->memcacheModel->createKey(array('get_stock_fundamentals', $ticker));
			$stockFundamentals = $this->memcacheModel->get($memcacheKey);
			if($stockFundamentals === false){
				$stock = $ticker ? FJF_BASE_RICH::getRecordBy("PricingMaster", $ticker, "TICKER") : null;
				if($stock){
					$stockFundamentals = XigniteModel::getQuote($stock->PRICING_TICKER, $stock->API_NAME);
					if(!$stockFundamentals) $stockFundamentals = new stdClass;
					
					if($fundamentals = XigniteModel::get("xGlobalFundamentals.GetFundamentalList.asmx", array(
						"IdentifierType" => "Symbol",
						"Identifier" => $stock->PRICING_TICKER
					), "Types=LastDividendExDate&Types=LatestFiscalDividendsPerShare&Types=Beta&Types=PERatio&Types=LatestFiscalEPS&Types=LastDividendYield&Types=OneYearHigh&Types=OneYearLow")){
						$list = $fundamentals->getElementsByTagName("Type");
						foreach($list as $item){
							$value = $item->parentNode->getElementsByTagName("Value")->item(0);
							$stockFundamentals->{$item->nodeValue} = $value ? $value->nodeValue : 'n/a';
						}
					}
					
					if($MarketCap = FJF_BASE_RICH::getRecords(
							"FundamentalData_MarketCap"
						, "TICKER='TICKER_VAL' ORDER BY TS DESC LIMIT 1"
						, array('TICKER_VAL' => $ticker)
						, true
						, "VAL"
					)){
						$stockFundamentals->MarketCap = $MarketCap->VAL;
						foreach(array("t" => 1000000000000, "b" => 1000000000, "m" => 1000000) as $l => $v){
							$v = $stockFundamentals->MarketCap / $v;
							if($v > 1){
								$stockFundamentals->MarketCap = number_format($v, 2, '.', ',') . $l;
								break;
							}
						}
						
					}
					$priceValues = array('Open','Close','PreviousClose','Low', 'High', 'OneYearLow', 'OneYearHigh');
					foreach($priceValues as $value){
						if(isset($stockFundamentals->{$value})){
							$stockFundamentals->{$value} = PriceModel::formatPrice($stockFundamentals->{$value}, $stock->EXCHANGE_NAME);
						}
					}
				}
				$this->memcacheModel->set($memcacheKey, $stockFundamentals);
			}
			exit(json_encode($stockFundamentals));
    }
  }

?>