<?php
	
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/memcache_model.php");
	
  class AjaxGetTopTickers extends FJF_CMD{
  	
		var $memcacheModel = null;
		
		function __construct(){
			$this->memcacheModel = new MemcacheModel();
		}

    function execute(){
			$viewMode = isset($_GET['view_mode']) ? $_GET['view_mode'] : null;
			$limit = isset($_GET["limit"]) ? min(intval($_GET["limit"]), 100) : 100;
			$offset = isset($_GET["offset"]) ? intval($_GET["offset"]) : 0;
			if($viewMode == 'MP'){
				$tbl = 'TickerTapeData_MP';
				$valueField = 'SIGNAL_VALUE';
				$changeField = 'SIGNAL_CHANGE';
			}else{
				$tbl = 'TickerTapeData';
				$valueField = 'AVERAGE_SENTIMENT';
				$changeField = 'SENTIMENT_CHANGE';
			}
			$memcacheKey = $this->memcacheModel->createKey(array('get_top_tickers', $tbl, $limit, $offset));
			$records = $this->memcacheModel->get($memcacheKey);
			if($records === false){
				FJF_BASE_RICH::db("sentiment");
				$sql = "SELECT TICKER ticker, " . $valueField . " value, " . $changeField . " change_value";
				$sql .= " FROM " . $tbl;
	      $sql .= " WHERE TS=(SELECT TS FROM " . $tbl . " ORDER BY TS DESC LIMIT 1)";
	      $sql .= " LIMIT " . $offset;
	      $sql .= "," . $limit;
	      $records = FJF_BASE_RICH::selectRecords($sql);
				$this->memcacheModel->set($memcacheKey, $records);
			}
      exit(json_encode($records ? $records : array()));
    }
		
  }

?>