<?php

	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/twitter_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/memcache_model.php");

	ini_set("memory_limit", "128M");

  class AjaxGetTweets extends FJF_CMD{

		var $twitterModel = null;
		var $memcacheModel = null;
		var $lastTime = "";
		var $order = "";
		var $limit = 15;
		var $iteration = 0;
		var $interval = 1;

		function __construct(){
			$this->twitterModel = new TwitterModel();
			$this->memcacheModel = new MemcacheModel();
    }

    function execute(){
			FJF_BASE_RICH::db("sentiment");
			$ticker = isset($_GET["ticker"]) ? trim($_GET["ticker"]) : "";
			$username = isset($_GET["username"]) ? trim($_GET["username"]) : "";
			$this->order = isset($_GET["order"]) && $_GET["order"] == 'ASC' ? "ASC" : "DESC";
			$this->limit = isset($_GET["limit"]) ? min(intval($_GET["limit"]), 50) : 15;
			$this->lastTime = isset($_GET["last_time"]) ? trim($_GET["last_time"]) : "";
			$memcacheKey = $this->memcacheModel->createKey(array(
				'get_tweets',
				$ticker,
				$username,
				$this->order,
				$this->limit,
				$this->lastTime
			));
			$result = $this->memcacheModel->get($memcacheKey);
			if($result === false){
				$records = array();
				if($ticker || $username){
					$params = array();
					$sqlWhere = "";
					$fields = "TWEET_ID, UNIX_TIMESTAMP(TS) AS TS, USERNAME, TWEET, SENTIMENT";
					if($ticker){
						$sqlWhere .= " AND TICKER = 'TICKER_VAL'";
						$params['TICKER_VAL'] = $ticker;
						$fields .= ", MP_SCORE";
					}
					if($username){
						$sqlWhere .= " AND USERNAME = 'USERNAME_VAL'";
						$params['USERNAME_VAL'] = $username;
						$fields .= ", TICKER";
					}

	        if($records = $this->getTweets($sqlWhere, $params, $fields)){
	          foreach($records as $record){
	          	$record->UTS = $record->TS;
							$record->TS = date("Y-m-d H:i:s", $record->TS);
	            $record->TWEET = utf8_encode($record->TWEET);
	            $record->TWEET = preg_replace('%\b(([\w-]+://?|www[.])[^\s()<>]+(?:\([\w\d]+\)|([^[:punct:]\s]|/)))%s', '<a href="$1" title="" target="_blank">$1</a>', $record->TWEET);
	            $record->TWEET = preg_replace('/\@([a-zA-Z0-9_]+)/', '<a href="https://twitter.com/$1" title="" target="_blank">@$1</a>', $record->TWEET);
	            $record->TWEET = preg_replace_callback('/\$([a-zA-Z._]+)/',
	            create_function('$matches',
	            '$lc = substr($matches[1], -1);$matches[1] = ($lc == "." || $lc == "-") ? substr($matches[1], 0, -1) : $matches[1];return \'<a href="/stock/\'.$matches[1].\'/" title="$\'.$matches[1].\'">\'.$matches[0].\'</a>\';')
	            , $record->TWEET);
	          }
	          $records = $this->twitterModel->getUsersInfo($records, false, "USERNAME");
	        }
				}
				$result = array(
	      	"iteration" => $this->iteration,
	      	"last_time" => $this->lastTime,
	      	"tweets" => $records ? $records : array()
				);
				$this->memcacheModel->set($memcacheKey, $result);
			}

			if(isset($_GET["test"])){
				test($result);
			}
      exit(json_encode($result));
    }

		function getLastTime($sqlWhere, $params = array()){
			$params['LAST_VAL'] = $this->lastTime;
			$params['INTERVAL_VAL'] = $this->interval . " HOUR";
			if($params['LAST_VAL']){
				$sql = "SELECT DATE_SUB('LAST_VAL', INTERVAL INTERVAL_VAL) AS last";
			}else{
				FJF_BASE_RICH::executeQuery(
					"SELECT MAX(TS) from SentimentData WHERE 1" . $sqlWhere. " INTO @MOST_RECENT_TS",
					$params
				);
				$sql = "SELECT DATE_SUB(@MOST_RECENT_TS, INTERVAL INTERVAL_VAL) AS last";
			}
			if($date = FJF_BASE_RICH::selectRecords($sql, $params, true)){
				$this->lastTime = $date->last;
			}
			return $this->lastTime;
		}

		function getTweets($sqlWhere, $params, $fields = "*", $records = array()){
			$this->iteration += 1;
			if($this->order == "DESC"){
				$params['LAST_VAL'] = $this->lastTime;
				$params['INTERVAL_VAL'] = $this->interval . " HOUR";
				$this->getLastTime($sqlWhere, $params);
				if($params['LAST_VAL']){
					$where = "TS < 'LAST_VAL' AND TS >= DATE_SUB('LAST_VAL', INTERVAL INTERVAL_VAL)";
				}else{
					$where = "TS >= DATE_SUB(@MOST_RECENT_TS, INTERVAL INTERVAL_VAL)";
				}
			}else{
				$where = "TS >= DATE_SUB(UTC_TIMESTAMP(), INTERVAL 1 MINUTE)";
			}
			$sql = "SELECT ".$fields;
			$sql .= " FROM SentimentDataFrontEnd";
			$sql .= " WHERE " . $where . $sqlWhere;
			$sql .= " ORDER BY TS " . $this->order;
			if($result = FJF_BASE_RICH::selectRecords($sql, $params)){
				$records = array_merge($records, $result);
			}
			if($this->order == "DESC" && ($this->iteration <= 12 && count($records) < $this->limit)){
				$this->interval = $this->interval * 2;
				$records = $this->getTweets($sqlWhere, $params, $fields, $records);
			}
			return $records;
		}
  }

?>