<?php

  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/sentiment_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/memcache_model.php");

  class AjaxGetWordCloudData extends FJF_CMD{
    var $sentimentModel = null;
		var $memcacheModel = null;

    function __construct(){
      $this->sentimentModel = new SentimentModel();
			$this->memcacheModel = new MemcacheModel();
    }

    function execute(){
      $records = array();
      $ticker = (isset($_GET["ticker"]) && $_GET["ticker"]) ? trim($_GET["ticker"]) : "";
      if($ticker != ""){
				$memcacheKey = $this->memcacheModel->createKey(array('get_word_cloud_data', $ticker));
				$records = $this->memcacheModel->get($memcacheKey);
				if($records === false){
					$records = array();
	        $where = " wc.TICKER='TICKER_ID' AND wc.WORD <> ''";
	        $params['TICKER_ID'] = $ticker;
	        $date = $this->sentimentModel->getWordCloudData($where . ' ORDER BY wc.TS DESC LIMIT 1', $params, 'wc.TS AS date');
	        if($date){
	          $params['LAST_DATE'] = $date[0]->date;
	          $where .= " AND wc.TS='LAST_DATE'";
	          $records = $this->sentimentModel->getWordCloudData($where . ' ORDER BY wc.OCCURRENCES DESC LIMIT 20', $params, 'wc.WORD AS text, wc.OCCURRENCES AS weight');
						foreach($records as $record){
							$record->text = utf8_decode($record->text);
						}
	        }
					$this->memcacheModel->set($memcacheKey, $records);
				}
      }
      exit(json_encode($records));
    }
  }

?>