<?php

	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/heatmap_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/price_model.php");

	class AjaxHeatmaps extends FJF_CMD{
		
		function execute(){
			$json = array('has_error' => false, 'status' => '');
			
			$action = isset($_GET['action']) ? $_GET['action'] : null;
			if($action == 'search_exchange'){
				
				$json['records'] = null;
				$q = isset($_GET['q']) ? trim($_GET['q']) : null;
				if($exchanges = HeatmapModel::getExchanges()){
					$json['records'] = array();
					foreach($exchanges as $exchange) if(stripos($exchange, $q) !== false) $json['records'][] = $exchange;
					unset($exchanges);
				}
				
			}//search
			elseif($action == 'get_tree'){
				
				$modes = array('sentiment', 'buzz');
				$mode = isset($_GET['mode']) ? $_GET['mode'] : null;
				if(!$mode) $mode = $modes[0];
				if(!in_array($mode, $modes)){
					$json['has_error'] = true;
					$json['status'] = 'Invalid mode.\n';
				}else{
					
					if(isset($_GET['view_mode'])) HeatmapModel::viewMode($_GET['view_mode']);
					
					$defaultExchange = "NYSE";
					$exchanges = HeatmapModel::getExchanges();
					array_unshift($exchanges, "ALL");
					$exchange = isset($_GET['exchange']) ? $_GET['exchange'] : null;
					if(!$exchange) $exchange = in_array($defaultExchange, $exchanges) ? $defaultExchange : $exchanges[0];
					if(!in_array($exchange, $exchanges)){
						$json['has_error'] = true;
						$json['status'] = 'Invalid exchange.\n';
					}else{
						$tickerIds = (isset($_GET['tickers']) && $_GET['tickers']) ? explode(',', stripslashes($_GET['tickers'])) : null;
						$tickers = $mode == 'sentiment' ? HeatmapModel::getSentimentTickers($exchange, $tickerIds) : HeatmapModel::getBuzzTickers($exchange, $tickerIds);
						$tickers = PriceModel::formatPrices($tickers,2,'PRICE','EXCHANGE');
						$json['tree'] = $tickers ? HeatmapModel::getTree("HEAT MAP: " . strtoupper($mode), $tickers, $mode) : null;
						$time = HeatmapModel::getUnixTS();
						$json['time'] = $time ? 'Last Updated: '.date('F j, Y h:i A', $time) : '';
					}
					
				}
				
			}//refresh
			else{
				$json['has_error'] = true;
				$json['status'] = 'Invalid action.\n';
			}
			
			echo json_encode($json);
			return true;
		}
		
	}
	
?>