<?php

  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/users_sentiment_model.php");

  class AjaxUsersAdd extends FJF_CMD
  {
    var $sessionModel = null;
		var $usersSentimentModel = null;

    function __construct()
    {
      $this->sessionModel = new SessionModel();
			$this->usersSentimentModel = new UsersSentimentModel();
    }

    function execute()
    {
      require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["app_web_path"] . "/includes/ajax_header_commands.php");
      if(!$this->sessionModel->isLoggedUser()){
      	exit(json_encode(array("status"=>'You are not logged.', "hasError" => true)));
      }
      $user = $this->sessionModel->getUser();
			if($_SERVER["REQUEST_METHOD"] == "POST")
      {
        $action = isset($_POST["action"]) && $_POST["action"] ? trim($_POST["action"]) : "";
				$username = isset($_POST["username"]) && $_POST["username"] ? trim($_POST["username"]) : '';
        
        if($action == 'add_user'){
        	if(substr($username, 0, 1) == '@'){
		      	$username = substr($username, 1, strlen($username));
		      }
          if($username == ''){
            $status .= "User is missing.";
            $hasError = true;
					}elseif(!$user->tier){
						$status = array(
							"title" => "Your account is no longer valid!",
							"message" => "If you would like to activate your subscription, please enter your credit card information with a valid credit card in User Account Settings.",
						);
						$hasError = true;
          }elseif(!$this->usersSentimentModel->checkMarketUsersDashboardLimit($user->id, $user->tier)){
            $status = array(
	            	"title" => "Sorry, But You Have Reached Your Limit!",
	            	"message" => "You have reached your maximum limit of users in your user dashboard. You must remove a user before being able to add a new one."
	           	);
            $hasError = true;
          }elseif($this->usersSentimentModel->checkMarketUser($user->id, $username)){
            $status = "You already have added this user to your dashboard.";
            $hasError = true;
          }
          if(!$hasError){
            $fields['username'] = $username;
            $fields['user_id'] = $user->id;
            if($this->usersSentimentModel->addMarketUser($fields)){
              $status = '@'.$username.' added to dashboard.';
            }else{
              $hasError = true;
              $status = "Error while updating record info. Please, try again later and contact support.";
            }
          }
          
        }elseif($action == 'delete_user'){
          if($username == ''){
            $status .= "User is missing.";
            $hasError = true;
          }
          
          if(!$hasError){
            if($this->usersSentimentModel->removeMarketUser($user->id, $username)){
              $status = "success";
							$this->usersSentimentModel->changeUserMarketUserPendingStatus($user->id, $user->tier);
            }else{
              $data = "Error while deleting record info. Please, try again later and contact support.";
            }
          }
        }
      }

			exit(json_encode(array("status"=>$status, "hasError" =>$hasError)));
		}
  }

?>