<?php

	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/charts_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/users_sentiment_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/pricing_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/memcache_model.php");

	class AjaxUsersChart extends FJF_CMD{
		
		var $sessionModel = null;
		var $chartsModel = null;
		var $usersSentimentModel = null;
		var $memcacheModel = null;
		
		function __construct(){
			$this->sessionModel = new SessionModel();
			$this->chartsModel = new ChartsModel();
			$this->usersSentimentModel = new UsersSentimentModel();
			$this->memcacheModel = new MemcacheModel();
		}
		
		function execute(){
			$result = array();

			$username = isset($_GET["username"]) && $_GET["username"] ? trim($_GET["username"]) : null;
			$interval = isset($_GET["interval"]) && $_GET["interval"] ? trim($_GET["interval"]) : null;
			$data = isset($_GET["data"]) && is_array($_GET["data"]) ? $_GET["data"] : array();
			$tier = $this->sessionModel->isLoggedUser() ? $_SESSION["user"]->tier : 0;
			$tierLimitations = PricingModel::getChartLimit($tier);
			$memcacheKey = $this->memcacheModel->createKey(array(
				'get_users_chart',
				$username,
				$interval,
				implode('_', $data),
				$tier
			));
			$result = $this->memcacheModel->get($memcacheKey);
			if($result === false){
				$result = array();
				if($data){
					$total = count($data);
					$fields = 'urs.TS AS max_val , DATE_SUB(urs.TS, INTERVAL INTERVAL_VAL) AS min_val';
					$params['INTERVAL_VAL'] = $interval;
					$dates = $this->usersSentimentModel->getUserRankingsScoresData(null,$params,1,'TS DESC',$fields,true);
					if($dates){
						$timeframe = array($dates->min_val, $dates->max_val);
						for($i = 0; $i < $total; $i++){
							$show = ($username && ($tierLimitations === null || in_array($data[$i], $tierLimitations)));
							$result[$data[$i]]['timeframe'] = $timeframe;
							$result[$data[$i]]['records'] = $show  ? $this->chartsModel->get($data[$i], $username, $timeframe) : array();
							$result[$data[$i]]['show'] = $show;
		        }
					}
				}
				$this->memcacheModel->set($memcacheKey, $result);
			}

			if(isset($_GET["test"])){
				test($result);
			}
			echo json_encode($result);
			return true;
		}
	}
	
?>