<?php

  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/alerts_model.php");
  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/users_sentiment_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/sentiment_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/pricing_model.php");

  class AjaxUsersCreateAlert extends FJF_CMD
  {
    var $sessionModel = null;
    var $alertsModel = null;
		var $usersSentimentModel = null;
		var $sentimentModel = null;

    function __construct()
    {
      $this->sessionModel = new SessionModel();
      $this->alertsModel = new AlertsModel();
			$this->usersSentimentModel = new UsersSentimentModel();
			$this->sentimentModel = new SentimentModel();
    }

    function execute()
    {
      require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["app_web_path"] . "/includes/ajax_header_commands.php");
      if (!$this->sessionModel->isLoggedUser()) return null;
      $user = $this->sessionModel->getUser();
			$alertID = (isset($_REQUEST["alert_id"]) && $_REQUEST["alert_id"]) ? intval($_REQUEST["alert_id"]) : 0;
			$type = isset($_REQUEST['type']) ? $_REQUEST['type'] : '';
			$subtype = isset($_REQUEST['subtype']) ? $_REQUEST['subtype'] : '';
			$username = isset($_REQUEST['username']) ? $_REQUEST['username'] : '';
			$ticker = isset($_GET['ticker']) ? $_GET['ticker'] : '';
			$action = isset($_REQUEST["action"]) && $_REQUEST["action"] ? trim($_REQUEST["action"]) : "";
			$record = new stdClass;
			if ($action == 'edit'){
				$where = " a.id= ALERT_ID AND a.user_id=USER_ID";
	      $params["ALERT_ID"] = $alertID;
	      $params["USER_ID"] = $this->sessionModel->uid;
	      $record = $this->alertsModel->getMarketUsersAlert($where, $params);
				if (!$record) return '';
				$username = $record->usernames;
				$type = $record->type;
				$subtype = $record->subtype;
				$ticker = $record->ticker;
			}

      if($_SERVER["REQUEST_METHOD"] == "POST"){
      	if($action == 'add' || $action == 'edit'){
        	if(isset($record->status) && in_array($record->status, array(0,2,3))){
            $hasError = true;
						if($record->status == 2){
							$statusType = "triggered";
						}elseif($record->status == 3){
							$statusType = "expired";
						}else{
							$statusType = "frozen";
						}
            $status = 'You cannot modify a ' . $statusType . ' alert.';
            exit(json_encode(array('hasError'=>$hasError, 'status' =>$status)));
          }
        	$filterTopReturns = isset($_POST["filter_top_returns"]) && $_POST["filter_top_returns"] ? intval($_POST["filter_top_returns"]) : 0;
					$filterTimeframe = isset($_POST["filter_timeframe"]) && $_POST["filter_timeframe"] ? trim($_POST["filter_timeframe"]) : '';
					$filterTicker = isset($_POST["ticker"]) && $_POST["ticker"] ? trim($_POST["ticker"]) : '';
					$filterSector = isset($_POST["sector"]) && $_POST["sector"] ? trim($_POST["sector"]) : '';
					if ($type == 'top-mp' || $type == 'top-user'){
						$fields = 'DISTINCT  USERNAME AS username';
						$params = array(
							'TIMEFRAME_VAL'=> $filterTimeframe,
							'RANK_VAL' => $filterTopReturns+1
						);
						$order = 'RANK';
						$usernames = array();
						if ($subtype == 'tickers'){
							$params['TICKER_VAL'] = $filterTicker;
							$where = "TIME_FRAME = 'TIMEFRAME_VAL' AND RANK  < 'RANK_VAL' AND TICKER = 'TICKER_VAL'";
							if ($type == 'top-mp'){
								$where .= " AND TS = (SELECT TS FROM TopUsers_TickerScore ORDER BY TS DESC LIMIT 1)";
								$usernames = $this->usersSentimentModel->getTopTenReturns('TopUsers_TickerScore', $where, $params, null, $order, $fields);
							}elseif ($type == 'top-user'){
								$where .= " AND TS = (SELECT TS FROM TopUsers_TickerReturns ORDER BY TS DESC LIMIT 1)";
								$usernames = $this->usersSentimentModel->getTopTenReturns('TopUsers_TickerReturns', $where, $params, null, $order, $fields);
							}
							/*
							if ($filterTicker && !$this->sentimentModel->checkStock($user->id, $filterTicker)){
								$this->sentimentModel->addStock(array('user_id' => $user->id, 'ticker' => $filterTicker));
							}
							*/
						}elseif($subtype == 'sectors'){
							$params['SECTOR_VAL'] = $filterSector;
							$where = "TIME_FRAME = 'TIMEFRAME_VAL' AND RANK  < 'RANK_VAL' AND SECTOR = 'SECTOR_VAL'";
							if ($type == 'top-mp'){
								$where .= " AND TS = (SELECT TS FROM UserTopTenData_SectorScore ORDER BY TS DESC LIMIT 1)";
								$usernames = $this->usersSentimentModel->getTopTenReturns('UserTopTenData_SectorScore', $where, $params, null, $order, $fields);
							}elseif ($type == 'top-user'){
								$where .= " AND TS = (SELECT TS FROM UserTopTenData_SectorReturns ORDER BY TS DESC LIMIT 1)";
								$usernames = $this->usersSentimentModel->getTopTenReturns('UserTopTenData_SectorReturns', $where, $params, null, $order, $fields);
							}
						}
						
						$username = '';
						$usernamesItems = array();
						if ($usernames){
							foreach($usernames as $item){
								$usernamesItems[] = $item->username;
							}
							$username = implode(',', $usernamesItems);
						}
						if($filterSector){
							$where = "SECTOR = 'SECTOR_VAL'";
							if ($usernamesItems) $where .= " AND USERNAME IN('".implode("','", $usernamesItems)."')";
							if ($filterTimeframe) $where .= " AND TIME_FRAME = 'TIMEFRAME_VAL'";
							$params =  array('SECTOR_VAL' => $filterSector, 'TIMEFRAME_VAL' => $filterTimeframe);
							$sectorTickers = $this->usersSentimentModel->getUserSpecificData($where, $params, null, null, 'DISTINCT TICKER AS ticker');
							if ($sectorTickers){
								$sectorTickersItems = array();
								foreach($sectorTickers as $item){
									$sectorTickersItems[] = $item->ticker;
								}
								$filterTicker = implode(',', $sectorTickersItems);
							}
						}
					}
					/*
					elseif ($username){
						$usernamesItems = explode(',', $username);
						foreach($usernamesItems as $item){
		      		if(!$this->usersSentimentModel->checkMarketUser($user->id, $item)){
		      			$this->usersSentimentModel->addMarketUser(array("username"=>$item, "user_id"=>$user->id));
		      		}
						}
	      	}
					*/
        	if ($action == 'add'){
	        	$fileds['user_id'] = $user->id;
						$fileds['type'] = $type;
						$fileds['subtype'] = $subtype;
	          $fileds['prediction_id'] = isset($_POST["prediction_id"]) && $_POST["prediction_id"] ? intval($_POST["prediction_id"]) : 0;
	          $fileds['status'] = 1;
					}else{
						$fileds2['alert_id'] = $alertID;
						$fileds2['triggered_usernames'] = '';
					}
          $fileds2['type_id_1'] = isset($_POST["type_id_1"]) && $_POST["type_id_1"] ? intval($_POST["type_id_1"]) : 0;
          $fileds2['type_id_2'] = isset($_POST["type_id_2"]) && $_POST["type_id_2"] ? intval($_POST["type_id_2"]) : 0;
          $fileds2['operation_id_1'] = isset($_POST["operation_id_1"]) && $_POST["operation_id_1"] ? intval($_POST["operation_id_1"]) : 0;
          $fileds2['operation_id_2'] = isset($_POST["operation_id_2"]) && $_POST["operation_id_2"] ? intval($_POST["operation_id_2"]) : 0;
          $fileds2['value_1'] = isset($_POST["value_1"]) ? floatval($_POST["value_1"]) : null;
          $fileds2['value_2'] = isset($_POST["value_2"]) ? floatval($_POST["value_2"]) : null;
          $fileds2['operation'] = isset($_POST["operation"]) && $_POST["operation"] ? intval($_POST["operation"]) : 0;
          $fileds2['timeframe_id'] = isset($_POST["timeframe_id"]) && $_POST["timeframe_id"] ? intval($_POST["timeframe_id"]) : 0;
          $fileds2['date'] = date('Y-m-d H:i:s');
          $fileds2['status'] = ($action == 'edit') ? 1 : 0;
					$fileds2['usernames'] = $username;
					$fileds2['filter_timeframe'] = $filterTimeframe;
					$fileds2['filter_top_returns'] = $filterTopReturns;
					$fileds2['ticker'] = $filterTicker;
					$fileds2['sector'] = isset($_POST["sector"]) && $_POST["sector"] ? trim($_POST["sector"]) : '';
					$fileds2['power'] = isset($_POST["power"]) && $_POST["power"] ? intval($_POST["power"]) : 0;
					
					if ($fileds2['ticker'] == 2 && $fileds2['usernames']){
						$where = "usd.USERNAME IN('".implode("','",explode(',',$fileds2['usernames']))."')";
						$where .= " AND usd.TS=(SELECT TS FROM UserSpecificData ORDER BY TS DESC LIMIT 1)";
						$where .= " AND usd.TIME_FRAME = 'TIMEFRAME_VAL'";
						$where .= "GROUP BY usd.TS";
						$params = array("TIMEFRAME_VAL" => $fileds2['filter_timeframe']);
						$fields = 'GROUP_CONCAT(DISTINCT usd.TICKER) AS tickers';
						$userTickers = $this->usersSentimentModel->getUserSpecificData($where, $params, null, null, $fields);
						$fileds2['portfolio_tickers'] = ($userTickers) ? $userTickers[0]->tickers : '';
					}else{
						$fileds2['portfolio_tickers'] = '';
					}
          if ($fileds2['operation'] == 2)
          {
            $fileds2['type_id_2'] = 0;
            $fileds2['operation_id_2'] = 0;
            $fileds2['value_2'] = 0;
          }
					
					if (!$fileds2['usernames'])
          {
            $hasError = true;
						$status .= "There are no ";
						if($type == 'top-mp'){
							$status .= "Market Prophits";
						}elseif($type == 'top-user'){
							$status .= "Top Users By Returns";
						}else{
							$status .= "Users";
						}
						if($type != 'user'){
	            $status .= " for this ";
							$status .= ($subtype == 'sectors') ? "sector" : "stock";
							$status .= " at this time.\n";
						}
          }
					
          if(!$fileds2['type_id_1'] || ( $fileds2['operation'] != 2 && !$fileds2['type_id_2']))
          {
            $hasError = true;
            $status .= "Select Type.\n";
          }
          
          if(!$fileds2['operation_id_1'] || ($fileds2['operation'] != 2 && !$fileds2['operation_id_2']))
          {
            $hasError = true;
            $status .= "Select Operation.\n";
          }
          
          if($fileds2['value_1'] === null || ($fileds2['operation'] != 2 && $fileds2['value_2'] === null))
          {
            $hasError = true;
            $status .= "Value is empty.\n";
          }

          if(!$this->alertsModel->validateAlertOption($fileds2['type_id_1'], $fileds2['value_1'], $fileds2['operation_id_1']))
          {
            $hasError = true;
            $status .= "Value is not valid for this variable.\n";
          }elseif($fileds2['operation'] != 2 && !$this->alertsModel->validateAlertOption($fileds2['type_id_2'], $fileds2['value_2'], $fileds2['operation_id_2']))
          {
            $hasError = true;
            $status .= "Value is not valid for this variable.\n";
          }
					elseif($fileds2['type_id_1'] && $fileds2['type_id_2'] && $fileds2['type_id_1'] == $fileds2['type_id_2'] && $fileds2['operation'] == 1 && !$this->alertsModel->validateAlertOptionsSameTypes($fileds2['value_1'], $fileds2['value_2'], $fileds2['operation_id_1'], $fileds2['operation_id_2'])){
						$hasError = true;
            $status .= "Invalid value.\n";
					}
          
          if(!$fileds2['timeframe_id'])
          {
            $hasError = true;
            $status .= "Select Timeframe.\n";
          }
          elseif($fileds2['timeframe_id'] != 10 && $this->alertsModel->getEndDate($fileds2['timeframe_id']) < date('Y-m-d H:i:s'))
          {
            $hasError = true;
            $status .= "Invalid Timeframe.";
          }
					
					if($action == 'add'){
						if(!$user->tier){
							$hasError = true;
							$status = array(
								"title" => "Your account is no longer valid!",
								"message" => "If you would like to activate your subscription, please enter your credit card information with a valid credit card in User Account Settings.",
							);
	          }elseif(!$this->alertsModel->checkOpenMarketUsersAlertCount($user->id, PricingModel::getAlertsLimit($user->tier))){
	            $hasError = true;
	            $status = array(
	            	"title" => "Sorry, But You Have Reached Your Limit!",
	            	"message" => "You have reached your maximum active daily alert limit. You must either remove an active alert or wait for one or more active alerts to expire or trigger before adding a new alert."
	           	);
	          }
					}
					
          if(!$hasError)
          {
          	if ($action == 'add'){
            	$status = $this->alertsModel->addMarketUsersAlert($fileds, $fileds2);
						}else{
							$skipFields = array('status', 'date');
							$isChanges = $this->alertsModel->checkEditAlert($record, $fileds2, $skipFields);
							$status = $this->alertsModel->editMarketUsersAlert($fileds2, $isChanges);
						}
						
            if(!$status)
            {
              $hasError = true;
              $status = "Error while saving record info. Please, try again later and contact support.";
            }
          }
        }elseif($action == 'delete'){
          if(!$this->alertsModel->removeMarketUsersAlert($alertID)){
          	$hasError = true;
            $status = "Error while deleting record info. Please, try again later and contact support.";
          }else{
          	$this->alertsModel->changeUserAlertPendingStatus($user->id, $user->tier);
          }
        }
        exit(json_encode(array('hasError'=>$hasError, 'status' =>$status)));
      }
			if($action == 'edit'){
				$params = array("ALERT_ID" => $alertID);
				$record->history = $this->alertsModel->getMarketUsersAlertHistory('ai.alert_id= ALERT_ID', $params, null, 'ai.date DESC');
			}elseif($action == 'add' && $subtype == 'sectors'){
				$where = " a.subtype = 'SUBTYPE_VAL' AND a.type = 'TYPE_ID' AND a.user_id=USER_ID AND ";
	      $where .= " ((a.status IN(0,1) AND ((ai.end_date > '".date('Y-m-d H:i:s')."' OR DATEDIFF('".date('Y-m-d H:i:s',strtotime('tomorrow'))."', ai.end_date) = 1) OR ai.end_date = '0000-00-00 00:00:00'))";
	      $where .= " OR (ai.power = 1 AND ai.end_date > '" . date('Y-m-d H:i:s') . "')";
	      $where .= " OR (a.status IN(2,3) AND DATEDIFF('".date('Y-m-d H:i:s',strtotime('tomorrow'))."', ai.triggered_date)  = 1 ))";
	      $params = array(
		      "TYPE_ID" => $type,
		      "USER_ID" => $this->sessionModel->uid,
					"SUBTYPE_VAL" => $subtype
				);
	      $record->history = $this->alertsModel->getMarketUsersAlerts($where, $params, null, "ai.end_date");
			}
      $data = (object) array(
      	"topUserReturns" => array(),
      	"topMpReturns" => array(),
      	"tickers" => array(),
      	"sectors" => array(),
			);
      switch ($type){
		    case "top-user":
	        $record->title = 'TOP USERS BY RETURNS ALERT';
					$data->topUserReturns = $this->usersSentimentModel->getTopUserReturns();
	        break;
		    case "top-mp":
	        $record->title = 'TOP USERS BY MP RANK ALERT';
					$data->topMpReturns = $this->usersSentimentModel->getTopMpReturns();
	        break;
		    case "user":
	        $record->title = 'USER ALERT';
	        break;
				default:
				return null;
			}
			
			$header['title'] = ($action == 'edit' ? 'EDIT ' : 'CREATE NEW ') . $record->title;
			
			$data->operators = $this->alertsModel->getAlertsOperators();
      $data->timeframes = $this->usersSentimentModel->getTimeframes();
			$data->alertsTimeframes = $this->alertsModel->getAlertsTimeframes();
			$data->types = $this->alertsModel->getAlertsTypes();
			$data->defaultTickers = $this->usersSentimentModel->getDefaultFilterTickers();
			$data->filterTopReturns = ($type == 'top-mp') ? $data->topMpReturns : $data->topUserReturns;
			
			
			switch ($subtype){
		    case "tickers":
					if ($type == 'user' && $username){
						$where = "usd.USERNAME = 'RECORD_USERNAME' AND usd.TS=(SELECT TS FROM UserSpecificData ORDER BY TS DESC LIMIT 1)";
						$params = array('RECORD_USERNAME'=>$username);
						$fields = 'DISTINCT usd.TICKER AS ticker';
						$data->tickers = $this->usersSentimentModel->getUserSpecificData($where, $params, null, null, $fields);
						if (!$data->tickers) $data->tickers = array();
						$data->tickers = array_merge($this->usersSentimentModel->getDefaultFilterTickers(),$data->tickers);
					}elseif ($type == 'top-mp' && $action != 'edit' && !$ticker){
						$where = "TS = (SELECT TS FROM UserTopTenData_TickerScore ORDER BY TS DESC LIMIT 1)";
						$fields = 'DISTINCT TICKER AS ticker';
						$data->tickers = $this->usersSentimentModel->getTopTenReturns('UserTopTenData_TickerScore', $where, null, null, 'TICKER', $fields);
					}elseif ($type == 'top-user' && $action != 'edit' && !$ticker){
						$where = "TS = (SELECT TS FROM UserTopTenData_TickerReturns ORDER BY TS DESC LIMIT 1)";
						$fields = 'DISTINCT TICKER AS ticker';
						$data->tickers = $this->usersSentimentModel->getTopTenReturns('UserTopTenData_TickerReturns', $where, null, null, 'TICKER', $fields);
					}
					break;
		    case "sectors":
					if ($type == 'top-mp'){
						$where = "TS = (SELECT TS FROM UserTopTenData_SectorScore ORDER BY TS DESC LIMIT 1)";
						$fields = 'DISTINCT SECTOR AS sector';
						$data->sectors = $this->usersSentimentModel->getTopTenReturns('UserTopTenData_SectorScore', $where, null, null, 'SECTOR', $fields);
					}elseif ($type == 'top-user'){
						$where = "TS = (SELECT TS FROM UserTopTenData_SectorReturns ORDER BY TS DESC LIMIT 1)";
						$fields = 'DISTINCT SECTOR AS sector';
						$data->sectors = $this->usersSentimentModel->getTopTenReturns('UserTopTenData_SectorReturns', $where, null, null, 'SECTOR', $fields);
					}
	        break;
			}

			if($record && isset($record->history) && $record->history){
				foreach($record->history as $item){
					if($action == 'add'){
						if($item->status == 1 && $item->end_date < date('Y-m-d H:i:s') && $item->timeframe_id != 10){
							$item->status = 3;
						}
					}
					if(array_key_exists($item->type_id_1, $data->types)){
						$item->type_1 = str_replace('Crowd ', '', $data->types[$item->type_id_1]->title);
					}
					if(array_key_exists($item->type_id_2, $data->types)){
						$item->type_2 = str_replace('Crowd ', '', $data->types[$item->type_id_2]->title);
					}
					if(array_key_exists($item->operation_id_1, $data->operators)){
						$item->operation_1 = $data->operators[$item->operation_id_1]->title;
					}
					if(array_key_exists($item->operation_id_2, $data->operators)){
						$item->operation_2 = $data->operators[$item->operation_id_2]->title;
					}
					if(array_key_exists($item->timeframe_id, $data->alertsTimeframes)){
						$item->timeframe = $data->alertsTimeframes[$item->timeframe_id]->title;
					}
					if(array_key_exists($item->filter_timeframe, $data->timeframes)){
						$item->filter_timeframe = $data->timeframes[$item->filter_timeframe]['value'];
					}
					if(array_key_exists($item->ticker, $data->defaultTickers)){
						$item->ticker = $data->defaultTickers[$item->ticker]->short_name;
					}
					if(array_key_exists($item->filter_top_returns, $data->filterTopReturns)){
						$item->filter_top_returns = $data->filterTopReturns[$item->filter_top_returns];
					}
				}
			}

      $templateParams = array(
        "has_error" => $hasError,
        "status" => $status,
        "header" => &$header,
        "data" => $data,
        "type" => $type,
        "subtype" => $subtype,
        "username" => $username,
        "ticker" => $ticker,
        "action" => $action,
        "alert_id" => $alertID,
        "record" => $record
      );
      return $this->displayTemplate("ajax_users_create_alert.tpl", $templateParams);
    }

  }

?>