<?php

  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/alerts_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/users_sentiment_model.php");

  class AjaxUsersDashboardAlertsBox extends FJF_CMD
  {
    var $sessionModel = null;
		var $alertsModel = null;
		var $usersSentimentModel = null;

    function __construct()
    {
      $this->sessionModel = new SessionModel();
			$this->alertsModel = new AlertsModel();
			$this->usersSentimentModel = new UsersSentimentModel();
    }

    function execute()
    {
      require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["app_web_path"] . "/includes/ajax_header_commands.php");
      if (!$this->sessionModel->isLoggedUser()) return null;
      
      $username = (isset($_GET["username"]) && $_GET["username"]) ? trim($_GET["username"]) : '';
			$type = (isset($_GET["type"]) && $_GET["type"]) ? trim($_GET["type"]) : '';
      $marketUser = $username ? FJF_BASE_RICH::getRecord("users_market_users", "username='USERNAME_VAL' AND user_id='USER_ID' AND status = 1", array(
				'USERNAME_VAL' => $username,
				'USER_ID' => $this->sessionModel->uid
			)) : null;
			if(!$marketUser) return false;
			
      $header['title'] = ($type == 'wider') ? 'MY USER ALERTS' : 'USER ALERTS';
			$header['popup']['title'] = '@'.$username;
      $header['popup']['type'] = (isset($_GET["popup_type"]) && $_GET["popup_type"]) ? trim($_GET["popup_type"]) : 'box';
			$header['popup']['url'] = '/ajax/users/dashboard/alerts-box/?username='.$username.'&popup_type=window&type='.$type;
      if($type == 'wider'){
      	$header['popup']['params'] = "{width:384,height:550,name:'".$header['title']."'}";
      }else{
      	$header['popup']['params'] = "{width:322,height:348,name:'".$header['title']."'}";
      }
			
			$data = new stdClass;
			$data->operators = $this->alertsModel->getAlertsOperators();
      $data->types = $this->alertsModel->getAlertsTypes();
      $data->timeframes = $this->alertsModel->getAlertsTimeframes();
			$data->filterTimeframes = $this->usersSentimentModel->getTimeframes();
			$data->defaultTickers = $this->usersSentimentModel->getDefaultFilterTickers();
      
      $where = " ai.usernames = 'USERNAME_VAL' AND a.type = 'TYPE_VAL' AND a.user_id=USER_ID AND ";
      $where .= " ((a.status IN(0,1) AND ((ai.end_date > '".date('Y-m-d H:i:s')."' OR DATEDIFF('".date('Y-m-d H:i:s',strtotime('tomorrow'))."', ai.end_date) = 1) OR ai.end_date = '0000-00-00 00:00:00'))";
			$where .= " OR (ai.power = 1 AND ai.end_date > '" . date('Y-m-d H:i:s') . "')";
      $where .= " OR (a.status IN(2,3) AND DATEDIFF('".date('Y-m-d H:i:s',strtotime('tomorrow'))."', ai.triggered_date)  = 1 ))";
      $params["TYPE_VAL"] = 'user';
      $params["USER_ID"] = $this->sessionModel->uid;
			$params["USERNAME_VAL"] = $username;
      $order = "ai.end_date";
      $records = $this->alertsModel->getMarketUsersAlerts($where, $params, null, $order);
			if($records){
				foreach($records as $item){
					if($item->status == 1 && $item->end_date < date('Y-m-d H:i:s') && $item->timeframe_id != 10){
						$item->status = 3;
					}
					if(array_key_exists($item->type_id_1, $data->types)){
						$item->type_1 = str_replace('Crowd ', '', $data->types[$item->type_id_1]->title);
					}
					if(array_key_exists($item->type_id_2, $data->types)){
						$item->type_2 = str_replace('Crowd ', '', $data->types[$item->type_id_2]->title);
					}
					if(array_key_exists($item->operation_id_1, $data->operators)){
						$item->operation_1 = $data->operators[$item->operation_id_1]->title;
					}
					if(array_key_exists($item->operation_id_2, $data->operators)){
						$item->operation_2 = $data->operators[$item->operation_id_2]->title;
					}
					if(array_key_exists($item->timeframe_id, $data->timeframes)){
						$item->timeframe = $data->timeframes[$item->timeframe_id]->title;
					}
					if(array_key_exists($item->filter_timeframe, $data->filterTimeframes)){
						$item->filter_timeframe = $data->filterTimeframes[$item->filter_timeframe]['value'];
					}
					if(array_key_exists($item->ticker, $data->defaultTickers)){
						$item->ticker = $data->defaultTickers[$item->ticker]->short_name;
					}
				}
			}

      $templateParams = array(
        "has_error" => $hasError,
        "status" => $status,
        "header" => &$header,
        "username" => $username,
        "type" => $type,
        "records" => $records
      );
      return $this->displayTemplate("ajax_users_dashboard_alerts_box.tpl", $templateParams);
    }
  }

?>