<?php

  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/alerts_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/users_sentiment_model.php");

  class AjaxUsersDashboardCreateAlertsBox extends FJF_CMD
  {
    var $sessionModel = null;
		var $alertsModel = null;
		var $usersSentimentModel = null;

    function __construct()
    {
      $this->sessionModel = new SessionModel();
			$this->alertsModel = new AlertsModel();
			$this->usersSentimentModel = new UsersSentimentModel();
    }

    function execute()
    {
      require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["app_web_path"] . "/includes/ajax_header_commands.php");
      if (!$this->sessionModel->isLoggedUser()) return null;
      
      $username = (isset($_GET["username"]) && $_GET["username"]) ? trim($_GET["username"]) : '';
      $marketUser = $username ? FJF_BASE_RICH::getRecord("users_market_users", "username='USERNAME_VAL' AND user_id='USER_ID' AND status = 1", array(
				'USERNAME_VAL' => $username,
				'USER_ID' => $this->sessionModel->uid
			)) : null;
			if(!$marketUser) return false;
			
      $header['title'] = 'CREATE NEW USER ALERT';
      $header['popup']['title'] = '@'.$username;
      $header['popup']['type'] = (isset($_GET["popup_type"]) && $_GET["popup_type"]) ? trim($_GET["popup_type"]) : 'box';
      $header['popup']['url'] = '/ajax/users/dashboard/create-alerts-box/?username='.$username.'&popup_type=window';
      $header['popup']['params'] = "{width:558,height:550,name:'".$header['title']."'}";
			
			$data = new stdClass;
			$data->operators = $this->alertsModel->getAlertsOperators();
      $data->timeframes = $this->usersSentimentModel->getTimeframes();
			$data->alertsTimeframes = $this->alertsModel->getAlertsTimeframes();
			$where = "usd.USERNAME = 'RECORD_USERNAME' AND usd.TS=(SELECT TS FROM UserSpecificData ORDER BY TS DESC LIMIT 1)";
			$params = array('RECORD_USERNAME'=>$username);
			$fields = 'DISTINCT usd.TICKER AS ticker';
			$data->tickers = $this->usersSentimentModel->getUserSpecificData($where, $params, null, null, $fields);
			if (!$data->tickers) $data->tickers = array();
			$data->tickers = array_merge($this->usersSentimentModel->getDefaultFilterTickers(),$data->tickers);
			

      $templateParams = array(
        "has_error" => $hasError,
        "status" => $status,
        "header" => &$header,
        "username" => $username,
        "type" => "user",
        "subtype" => "tickers",
        "data" => $data
      );
      return $this->displayTemplate("ajax_users_dashboard_create_alerts_box.tpl", $templateParams);
    }
  }

?>