<?php

  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/users_sentiment_model.php");

  class AjaxUsersDashboardStatsBox extends FJF_CMD
  {
    var $sessionModel = null;
		var $usersSentimentModel = null;

    function __construct()
    {
      $this->sessionModel = new SessionModel();
			$this->usersSentimentModel = new UsersSentimentModel();
    }

    function execute()
    {
      require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["app_web_path"] . "/includes/ajax_header_commands.php");
      if (!$this->sessionModel->isLoggedUser()) return null;
      
      $username = (isset($_GET["username"]) && $_GET["username"]) ? trim($_GET["username"]) : '';
      $marketUser = $username ? FJF_BASE_RICH::getRecord("users_market_users", "username='USERNAME_VAL' AND user_id='USER_ID' AND status = 1", array(
				'USERNAME_VAL' => $username,
				'USER_ID' => $this->sessionModel->uid
			)) : null;
			if(!$marketUser) return false;
						
      $header['title'] = 'USER STATS';
			$header['popup']['title'] = '@'.$username;
      $header['popup']['type'] = (isset($_GET["popup_type"]) && $_GET["popup_type"]) ? trim($_GET["popup_type"]) : 'box';
      $header['popup']['url'] = '/ajax/users/dashboard/stats-box/?username='.$username.'&popup_type=window';
      $header['popup']['params'] = "{width:719,height:283,name:'".$header['title']."'}";
			
			$data = new stdClass;
			$data->filter = new stdClass;
			$data->filter->timefarme = (isset($_GET['timeframe'])) ? trim($_GET['timeframe']) : '';
			$data->action = (isset($_GET['action'])) ? trim($_GET['action']) : '';
			$data->filter_timeframes = $this->usersSentimentModel->getFilterTimeframes();
			$data->timeframes = $this->usersSentimentModel->getTimeframes();
			$where = "usd.USERNAME = 'RECORD_USERNAME' AND usd.TS=(SELECT TS FROM UserSpecificData ORDER BY TS DESC LIMIT 1)";
			$params = array('RECORD_USERNAME'=>$username);
			$fields = 'usd.TICKER AS ticker, usd.SECTOR AS sector, usd.PNL AS pnl, usd.TIME_FRAME AS timeframe, usd.TICKER_RETURN_RANK AS return_rank, usd.TICKER_SCORE_RANK AS mpr';
			
			$tmpKeys = array_keys($data->timeframes);
			$filterTimeframe = ($data->filter->timefarme) ? $data->filter->timefarme : array_shift($tmpKeys);
			if ($filterTimeframe){
				$params['FILTER_TIMEFRAME'] = $filterTimeframe;
				$where .= " AND usd.TIME_FRAME='FILTER_TIMEFRAME'";
			}
			$records = $this->usersSentimentModel->getUserSpecificData($where, $params, 0, 'TICKER', $fields);
			
			if ($records && $data->timeframes){
				foreach($records as $key => $item){
					if (array_key_exists($item->timeframe,$data->timeframes)){
						$item->timeframe = $data->timeframes[$item->timeframe]['value'];
					}
				}
			}
			
      $templateParams = array(
        "has_error" => $hasError,
        "status" => $status,
        "header" => &$header,
        "username" => $username,
        "data" => $data,
        "records" => $records
      );
      return $this->displayTemplate("ajax_users_dashboard_stats_box.tpl", $templateParams);
    }
  }

?>