<?php

  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/users_sentiment_model.php");

  class AjaxUsersFilterTickers extends FJF_CMD
  {

		var $usersSentimentModel = null;

    function __construct()
    {
			$this->usersSentimentModel = new UsersSentimentModel();
    }

    function execute()
    {
    	$result = array('html'=>'');
    	$timeframe = isset($_GET["filter_timeframe"]) && $_GET["filter_timeframe"] ? trim($_GET["filter_timeframe"]) : '';
			$topReturns = isset($_GET["filter_top_returns"]) && $_GET["filter_top_returns"] ? intval($_GET["filter_top_returns"]) : 0;
			$username = isset($_GET['username']) ? $_GET['username'] : '';
			$type = isset($_GET['type']) ? $_GET['type'] : '';
			$subtype = isset($_GET['subtype']) ? $_GET['subtype'] : '';
			$limit = isset($_GET['limit']) ? $_GET['limit'] : 15;
			$order = '';
			$fields = '';
			$table = '';
			if ($timeframe || $username || $topReturns){
				$params = array(
					'USERNAME_VAL'=>$username,
					'TIMEFRAME_VAL'=>$timeframe,
					'RANK_VAL'=> $topReturns+1
				);
				if ($type == 'user'){
					$table = "UserSpecificData";
				}elseif ($type == 'top-user' && $subtype == 'tickers'){
					$table = "UserTopTenData_TickerReturns";
				}elseif($type == 'top-user' && $subtype == 'sectors'){
					$table = "UserTopTenData_SectorReturns";
				}elseif($type == 'top-mp' && $subtype == 'tickers'){
					$table = "UserTopTenData_TickerScore";
				}elseif($type == 'top-mp' && $subtype == 'sectors'){
					$table = "UserTopTenData_SectorScore";
				}
				if ($subtype == 'tickers'){
				$fields = "DISTINCT dt.TICKER AS data_id, s.COMPANY_NAME AS company_name, s.EXCHANGE_NAME AS exchange_name";
				$order = 'dt.TICKER';
				}else{
					$fields = "DISTINCT dt.SECTOR AS data_id";
					$order = 'dt.SECTOR';
				}
				$sql = "SELECT ".$fields;
		    $sql .= " FROM ".$table." dt";
		    if ($subtype == 'tickers') $sql .= " LEFT JOIN SecurityMaster s ON dt.TICKER=s.TICKER";
		    $sql .= " WHERE dt.TS=(SELECT TS FROM ".$table." ORDER BY TS DESC LIMIT 1)";
				if ($params['USERNAME_VAL'] && $subtype != 'sectors') $sql .= " AND dt.USERNAME = 'USERNAME_VAL'";
				if ($params['TIMEFRAME_VAL']) $sql .= " AND dt.TIME_FRAME = 'TIMEFRAME_VAL'";
				if ($params['RANK_VAL'] && $params['RANK_VAL'] > 1 ) $sql .= " AND dt.RANK  < 'RANK_VAL'";
	      if ($order) $sql .= " ORDER BY ".$order;
	      if ($limit) $sql .= " LIMIT ".$limit;
	      $this->usersSentimentModel->db("sentiment");
				$records = $this->usersSentimentModel->selectRecords($sql, $params);
				if (!$records) $records = array();
				$count = count($records);
				if ($type == 'user'){
					$default = $this->usersSentimentModel->getDefaultFilterTickers();
					foreach($default as $item){
						$item->data_id = $item->ticker;
					}
					$records = array_merge($records, $default);
				}
				if($records){
					$result['html'] = '<div class="tickers-wrapper scrolling">';
					$result['html'] .= '<table cellpadding="0" cellspacing="0" width="100%">';
					foreach($records as $item){
						$result['html'] .= '<tr data-id="'.$item->data_id.'">';
						if (isset($item->name)){
							$result['html'] .= '<td colspan="3">'.strtoupper($item->name).'</td>';
						}else{
							$result['html'] .= '<td>'.strtoupper($item->data_id).'</td>';
							if (isset($item->company_name)) $result['html'] .= '<td>'.strtoupper($item->company_name).'</td>';
							if (isset($item->exchange_name)) $result['html'] .= '<td>'.strtoupper($item->exchange_name).'</td>';
						}
						$result['html'] .= '</tr>';
					}
					$result['html'] .= '</table>';
					$result['html'] .= '</div>';
					if($limit && $count >= $limit){
						$result['html'] .= '<div class="show-all" onclick="usersAlertaddFilterBox($(this).closest(\'.alerts-filter\').find(\'.bg:not(.filter-selector) select:first\'), 0, 1)">SHOW ALL RESULTS</div>';
					}
				}
			}
    	echo json_encode($result);
    	return true;
		}
  }

?>