<?php

  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/alerts_model.php");
  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/sentiment_model.php");

  class AjaxUsersPredictionAlerts extends FJF_CMD
  {
    var $sessionModel = null;
    var $alertsModel = null;
    var $sentimentModel = null;

    function __construct()
    {
      $this->sessionModel = new SessionModel();
      $this->alertsModel = new AlertsModel();
      $this->sentimentModel = new SentimentModel();
    }

    function execute()
    {
      require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["app_web_path"] . "/includes/ajax_header_commands.php");
      
			$timeframeID = (isset($_REQUEST["timeframe_id"]) && $_REQUEST["timeframe_id"]) ? intval($_REQUEST["timeframe_id"]) : 0;
			if($timeframeID == 10) $timeframeID = 9;
			
			$ticker = (isset($_REQUEST["ticker"]) && $_REQUEST["ticker"]) ? trim($_REQUEST["ticker"]) : "";
      
      if (!$ticker) return "";
      $source = (isset($_REQUEST["source"]) && $_REQUEST["source"]) ? intval($_REQUEST["source"]) : 0;
      
      if($_SERVER["REQUEST_METHOD"] == "POST")
      {
        $fileds['user_id'] = $this->sessionModel->isLoggedUser() ? $this->sessionModel->uid : 0;
        $fileds['date'] = date('Y-m-d H:i:s');
        $fileds['ticker'] = $ticker;
				$fileds['source'] = $source;
				
				$fileds2['timeframes'] = isset($_POST["timeframes"]) && is_array($_POST["timeframes"]) && $_POST["timeframes"] ? $_POST["timeframes"] : 0;
				
				$stock = $this->sentimentModel->getStockPrice(array($fileds['ticker']));
        $fileds['price'] = ($stock && isset($stock[$fileds['ticker']]->Last)) ? $stock[$fileds['ticker']]->Last: 0;
				
        if(!$fileds['price'])
        {
          $hasError = true;
          $status .= "Price is missing.";
        }
        
				$result = null;
        if(!$hasError)
        {
          $result = $this->alertsModel->addUsersAlertPrediction($fileds, $fileds2);
          if(!$result)
          {
            $hasError = true;
            $status = "Error while saving record info. Please, try again later and contact support.";
          }
        }
        
        exit(json_encode(array('hasError'=>$hasError, 'status' =>$status, 'id' => $result)));
      }
      
      $timeframes = $this->alertsModel->getAlertsTimeframes('id<>10 AND id<>11');
			
			if($timeframeID == 6 && time() > strtotime("today 4pm")) $timeframeID = null;
      
      $templateParams = array(
        "has_error" => $hasError,
        "status" => $status,
        "header" => &$header,
        "ticker" => $ticker,
        "timeframe_id" => $timeframeID,
        "timeframes" => $timeframes,
        "source" => $source
      );
      return $this->displayTemplate("ajax_users_prediction_alerts.tpl", $templateParams);
    }
  }

?>