<?php

	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/alerts_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/pricing_model.php");

	class AlertDashboard extends FJF_CMD{
		
		var $sessionModel = null;
		var $alertsModel = null;

		function __construct(){
			$this->sessionModel = new SessionModel();
			$this->sessionModel->notLoginRedirect();
			$this->sessionModel->checkLockedPage();
			$this->alertsModel = new AlertsModel();
		}

		function execute(){
			require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["includes_path"] . "/header_commands.php");

			$user = $this->sessionModel->getUser();
			$action = isset($_GET['action']) ? trim($_GET['action']) : '';
			$header['title'] = "Alert Dashboard";
			$where = "a.user_id = 'USER_ID_VAL'";
			$params = array('USER_ID_VAL' => $this->sessionModel->uid);
			$limit = PricingModel::getAlertsLimit($user->tier);
			$record = array(
				"total_count" => $this->alertsModel->getTotalActiveAlertCount($where, $params),
				"max_count" => $limit !== null ? ' of <span class="count">' . $limit . '</span> Maximum Alerts' : '',
				"tabs" => $this->alertsModel->getAlertTypes(),
			);
			
			$where .= " AND a.status = 1 AND (ai.end_date >'".date('Y-m-d H:i:s')."' OR (ai.timeframe_id = 10 AND ai.end_date = '0000-00-00 00:00:00'))";
			foreach($record['tabs'] as $key => $item){
				$record['tabs'][$key]['count'] = $this->alertsModel->getAlertCountByType($key, $where, $params);
			}
			
			if($action == 'update'){
				exit(json_encode($record));
			}
			
			$templateParams = array(
        "has_error" => $hasError,
        "status" => $status,
        "header" => $header,
        "record" => $record
      );
			return $this->displayTemplate("alert_dashboard.tpl", $templateParams);
		}
	}
	
?>