<?php

	class ApiGetSentiment extends FJF_CMD{
		
		function execute(){
			
			$tickers = array("SPY", "DIA", "QQQ");
			
			$startTime = strtotime("today 09:30:00");
			$endTime = strtotime("today 16:00:00");
			
			$sql = "SELECT TICKER, CONVERT_TZ(TS,'GMT','US/Eastern') AS TS, AVERAGE_SENTIMENT AS VALUE";
			$sql .= " FROM SentimentData_Averaged";
			$sql .= " WHERE TICKER IN('" . implode("','", $tickers) . "')";
			$sql .= " AND FREQUENCY = 60 AND WINDOW_SIZE = 60";
			$sql .= " AND TS BETWEEN CONVERT_TZ('MIN_VAL', 'US/Eastern', 'GMT') AND CONVERT_TZ('MAX_VAL', 'US/Eastern', 'GMT')";
			$sql .= " ORDER BY TS";
			
			FJF_BASE_RICH::db("sentiment");
			$dbRecords = FJF_BASE_RICH::selectRecords($sql, array(
				'MIN_VAL' => date("Y-m-d H:i:s", $startTime),
				'MAX_VAL' => date("Y-m-d H:i:s", $endTime)
			));
			
			if(!FJF_BASE::db_error()){
				if(!$dbRecords) $dbRecords = array();
				
				$data = array_fill_keys($tickers, array());
				foreach($dbRecords as $record){
					$data[$record->TICKER][$record->TS] = $record->VALUE;
				}
					
				foreach($tickers as $ticker){
					$realData = "";
					
					for($i = $startTime; $i <= $endTime; $i += 60){
						$date = date("Y-m-d H:i:00", $i);
						$realData .= $date . "," . (isset($data[$ticker][$date]) ? $data[$ticker][$date] : 0) . "\n";
					}
					
					file_put_contents(
						$GLOBALS["WEB_APPLICATION_CONFIG"]["app_data_path"] . "/sentiment_" . $ticker . ".tsv",
						$realData
					);
					
					unset($realData);
				}
			
				unset($dbRecords);
			}
			
			$sql = "SELECT TICKER, CONVERT_TZ(TS,'GMT','US/Eastern') AS TS, AVERAGE_SIGNAL VALUE";
			$sql .= " FROM TradingSignalData_Averaged";
			$sql .= " WHERE TICKER  IN ('" . implode("','", $tickers) . "')";
			$sql .= " AND FREQUENCY = 60 AND WINDOW_SIZE = 60";
			$sql .= " AND TS BETWEEN CONVERT_TZ('MIN_VAL', 'US/Eastern', 'GMT') AND CONVERT_TZ('MAX_VAL', 'US/Eastern', 'GMT')";
			$sql .= " ORDER BY TS";

			FJF_BASE_RICH::db("sentiment");
			$dbRecords = FJF_BASE_RICH::selectRecords($sql, array(
				'MIN_VAL' => date("Y-m-d H:i:s", $startTime),
				'MAX_VAL' => date("Y-m-d H:i:s", $endTime)
			));
			
			if(!FJF_BASE::db_error()){
				if(!$dbRecords) $dbRecords = array();
				
				$data = array_fill_keys($tickers, array());
				foreach($dbRecords as $record){
					$data[$record->TICKER][$record->TS] = $record->VALUE;
				}
					
				foreach($tickers as $ticker){
					$realData = "";
					
					for($i = $startTime; $i <= $endTime; $i += 60){
						$date = date("Y-m-d H:i:00", $i);
						$realData .= $date . "," . (isset($data[$ticker][$date]) ? $data[$ticker][$date] : 0) . "\n";
					}
					
					file_put_contents(
						$GLOBALS["WEB_APPLICATION_CONFIG"]["app_data_path"] . "/sentiment_" . $ticker . "_MP.tsv",
						$realData
					);
					
					unset($realData);
				}
			
				unset($dbRecords);
			}
			
			exit("Done.");
		}

	}

?>