<?php

	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/blog_model.php");

	class Blog extends FJF_CMD
	{
		var $sessionModel = null;
    var $blogModel = null;

		function __construct()
		{
			$this->sessionModel = new SessionModel();
      $this->blogModel = new BlogModel();
		}

		function execute()
		{
			require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["includes_path"] . "/header_commands.php");
      
			$filter = new stdClass; 
      $filter->categoryTitle = isset($_GET['category_title']) && $_GET['category_title'] ? trim($_GET['category_title']) : '';
      $filter->tagTitle = isset($_GET['tag_title']) && $_GET['tag_title'] ? trim($_GET['tag_title']) : '';
      $filter->userID = isset($_GET['user_id']) && $_GET['user_id'] ? trim($_GET['user_id']) : '';
      $filter->date = isset($_GET['date']) && $_GET['date'] ? trim($_GET['date']) : '';
      $where = 'b.id = 1';
      $params = array();
      if ($filter->tagTitle)
      {
        $tagCategory = $this->blogModel->getBlogEntriesCategory("bec.url_title='URL_TITLE'", array('URL_TITLE'=>$filter->tagTitle), 'bec.id');
        $params['TAG_CATEGORY_ID'] = ($tagCategory)? $tagCategory->id : 0;
        $where .= " AND FIND_IN_SET(TAG_CATEGORY_ID,be.categories_ids)";
      }
      if ($filter->categoryTitle)
      {
        $params['CATEGORY_URL_TITLE'] = $filter->categoryTitle;
        $where .= " AND bc.url_title='CATEGORY_URL_TITLE'";
      }
      if ($filter->date)
      {
        $params['BLOG_ENTRIES_DATE'] = date('Y-m', strtotime($filter->date));
        $where .= " AND DATE_FORMAT(be.datetime, '%Y-%m') = 'BLOG_ENTRIES_DATE'";
      }

			$records = $this->blogModel->getBlogEntries($where, $params);
			$entriesCategories = $this->blogModel->getBlogEntriesCategories('b.id = 1');
			$blogsCategories = $this->blogModel->getBlogsCategories('b.id = 1');
      $blogsArchiveDate = $this->blogModel->getArchiveDate();		
			$header["title"] = "Blog";
			
			$templateParams = array(
        "has_error" => $hasError,
        "status" => $status,
        "header" => &$header,
	      "records" => &$records,
	      "entries_categories" => $entriesCategories,
	      "blogs_categories" => $blogsCategories,
	      "blogs_archive_date" => $blogsArchiveDate,
	      "filter" => $filter
      );
      
			return $this->displayTemplate("blog.tpl", $templateParams);
		}
	}

?>