<?php

	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/user_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/facebook_model.php");

	class ConnectFacebook extends FJF_CMD{
		var $sessionModel = null;
		var $userModel = null;
		var $facebookModel = null;

		function __construct(){
			$this->sessionModel = new SessionModel;
			$this->userModel = new UserModel;
			$this->facebookModel = new FacebookModel;
		}

		function execute(){
			
			$hasError = false;
	    $status = "";
			
			$connection = $this->facebookModel->getLib();
			
			if($connectedUser = $connection->getUser()){
			  try{
			  	
			    $connectedUser = (object) $connection->api('/me');
					
					
					if($this->sessionModel->isLoggedUser()){
						$dbUser = $this->sessionModel->getRecordBy(
							"users",
							$this->sessionModel->uid
						);
					}else{
						$dbUser = $this->sessionModel->getRecord(
							"users",
							"tier <> 0 AND (facebook_id='FACEBOOK_ID' OR email='EMAIL')",
							array('FACEBOOK_ID' => $connectedUser->id, 'EMAIL' => $connectedUser->email)
						);
					}
					
					if(!$dbUser){
						if(!isset($_SESSION['register_data']['personal_info']))
						$_SESSION['register_data']['personal_info'] = array();
						$_SESSION['register_data']['personal_info'] = array_merge(
							$_SESSION['register_data']['personal_info'],
							array(
								"first_name" => $connectedUser->first_name,
				        "last_name" => $connectedUser->last_name,
				        "email" => $connectedUser->email,
				        "facebook_id" => $connectedUser->id,
				        "block_email" => true
							)
						);
						$_SESSION['register_data']['steps']['personal_info'] = false;
						FJF_BASE::redirect('/register/');
						/*
						$dbUser = array(
							"first_name" => $connectedUser->first_name,
			        "last_name" => $connectedUser->last_name,
			        "email" => $connectedUser->email,
			        "facebook_id" => $connectedUser->id
						);
						if($dbUserId = $this->userModel->insertUser($dbUser)){
							$dbUser = $this->sessionModel->getRecordBy("users", $dbUserId);
              $_SESSION['register_success'] = true;
						}else{
	            $hasError = true;
	            $status .= "An error occurred while saving record to DB.\n" . FJF_BASE::db_error();
	          }
						*/
					}
					
					if(!$hasError){
						if($dbUser->facebook_id != $connectedUser->id){
							$dbUser->facebook_id = $connectedUser->id;
							$this->sessionModel->updateRecords("users", "facebook_id=''", "facebook_id='FACEBOOK_ID'", array(
								"FACEBOOK_ID" => $dbUser->facebook_id
							));
							$this->sessionModel->saveRecord("users", array(
								"id" => $dbUser->id,
								"facebook_id" => $dbUser->facebook_id
							));
						}
						
						$hasError = !$this->sessionModel->login($dbUser);
            $status .= $this->sessionModel->status . "\n";
					}
					
			  }catch(FacebookApiException $e){
					$hasError = true;
					$status .= $e->getMessage() . "\n";
			  }
			}
			
			if(isset($_GET["error"])){
				$hasError = true;
				$status .= (isset($_GET["error_description"]) ? $_GET["error_description"] : "Unknown error occurred.") . "\n";
			}
			
			$loginUrl = $connection->getLoginUrl(array(
		  	"scope" => "email"
			));
			if(!$hasError) FJF_BASE::redirect($loginUrl);
			
			/*
			 * save $hasError & $status
			 */
			$_hasError = $hasError;
	    $_status = $status;
			
			require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["app_web_path"] . "/includes/header_commands.php");
			
			/*
			 * restore $hasError & $status
			 */
			$hasError = $_hasError;
	    $status = $_status;
			
			if(!$status){
				$hasError = true;
				$status = isset($_GET["error_description"]) ? $_GET["error_description"] : "Unknown error occurred.";
			}
			
			$this->displayTemplate("connect_facebook.tpl", array(
        "header" => $header,
        "has_error" => $hasError,
        "status" => $status,
        "login_url" => $loginUrl
      ));
		}
	}
	
?>