<?php

	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/user_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/linkedin_model.php");

	class ConnectLinkedin extends FJF_CMD{
		var $sessionModel = null;
		var $userModel = null;
		var $linkedinModel = null;

		function __construct(){
			$this->sessionModel = new SessionModel;
			$this->userModel = new UserModel;
			$this->linkedinModel = new LinkedinModel;
		}

		function execute(){
			
			$hasError = false;
	    $status = "";
			
			$connection = $this->linkedinModel->getLib();
			$connection->setCallbackUrl("http://" . $_SERVER['SERVER_NAME'] . "/connect/linkedin/");
			
      if(isset($_GET["oauth_token"]) && isset($_GET["oauth_verifier"])){
      	if(isset($_SESSION["linkedin_oauth_request"]) && $_SESSION["linkedin_oauth_request"]["token"] === $_GET["oauth_token"]){
      		
					$response = $connection->retrieveTokenAccess($_SESSION["linkedin_oauth_request"]["token"], $_SESSION["linkedin_oauth_request"]["token_secret"], $_GET["oauth_verifier"]);
					unset($_SESSION["linkedin_oauth_request"]);
		      if($response['success'] === true){
		      	
						$_SESSION["linkedin_oauth_access"] = $response["linkedin"];
		        
		        $response = $connection->profile('~:(id,first-name,last-name,email-address)');
	          if($response['success'] === true){
	            $connectedUser = json_decode($response["linkedin"]);
	            
	            if($this->sessionModel->isLoggedUser()){
								$dbUser = $this->sessionModel->getRecordBy(
									"users",
									$this->sessionModel->uid
								);
							}else{
                $dbUser = $this->sessionModel->getRecord(
                  "users",
                  "tier <> 0 AND (linkedin_id='LINKEDIN_ID' OR email='EMAIL')",
                  array('LINKEDIN_ID' => $connectedUser->id, 'EMAIL' => $connectedUser->emailAddress)
                );
							}
							
							if(!$dbUser){
								if(!isset($_SESSION['register_data']['personal_info']))
								$_SESSION['register_data']['personal_info'] = array();
								$_SESSION['register_data']['personal_info'] = array_merge(
									$_SESSION['register_data']['personal_info'],
									array(
										"first_name" => $connectedUser->firstName,
						        "last_name" => $connectedUser->lastName,
						        "linkedin_id" => $connectedUser->id,
						        "email" => $connectedUser->emailAddress,
						        "block_email" => true
									)
								);
								$_SESSION['register_data']['steps']['personal_info'] = false;
								FJF_BASE::redirect('/register/');
								/*
								$dbUser = array(
									"first_name" => $connectedUser->firstName,
					        "last_name" => $connectedUser->lastName,
					        "linkedin_id" => $connectedUser->id,
					        "email" => $connectedUser->emailAddress
								);
								if($dbUserId = $this->userModel->insertUser($dbUser)){
									$dbUser = $this->sessionModel->getRecordBy("users", $dbUserId);
                  $_SESSION['register_success'] = true;
								}else{
			            $hasError = true;
			            $status .= "An error occurred while saving record to DB.\n";
			          }
								*/
							}
							
							if(!$hasError){
								if($dbUser->linkedin_id != $connectedUser->id){
									$dbUser->linkedin_id = $connectedUser->id;
									$this->sessionModel->updateRecords("users", "linkedin_id=''", "linkedin_id='LINKEDIN_ID'", array(
										"LINKEDIN_ID" => $dbUser->linkedin_id
									));
									$this->sessionModel->saveRecord("users", array(
										"id" => $dbUser->id,
										"linkedin_id" => $dbUser->linkedin_id
									));
								}
								
								$hasError = !$this->sessionModel->login($dbUser);
		            $status .= $this->sessionModel->status . "\n";
							}
	            
	          }else{
							$hasError = true;
							$status .= "Error retrieving profile information.\n";
	          } 
		      }else{
						$hasError = true;
						$status .= "Could not verify token.\n";
		      }
      	}else{
      		$hasError = true;
					$status .= "Expired OAuth token.\n";
      	}
			}

			if(isset($_GET["oauth_problem"])){
				$hasError = true;
				$status .= "Access denied.\n";
			}
			
			$loginUrl = null;
			$connection->token = null;
			$response = $connection->retrieveTokenRequest();
			if($response['success'] === true){
				$_SESSION["linkedin_oauth_request"] = array(
					"token" => $response["linkedin"]["oauth_token"],
					"token_secret" => $response["linkedin"]["oauth_token_secret"]
				);
				$loginUrl = LINKEDIN::_URL_AUTH . $_SESSION["linkedin_oauth_request"]["token"];
				if(!$hasError) FJF_BASE::redirect($loginUrl);
			}else{
				$hasError = true;
				$status .= "Request token retrieval failed.\n";
			}
			
			
			/*
			 * save $hasError & $status
			 */
			$_hasError = $hasError;
	    $_status = $status;
			
			require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["app_web_path"] . "/includes/header_commands.php");
			
			/*
			 * restore $hasError & $status
			 */
			$hasError = $_hasError;
	    $status .= $_status;
			
			$this->displayTemplate("connect_linkedin.tpl", array(
        "header" => $header,
        "has_error" => $hasError,
        "status" => $status,
        "login_url" => $loginUrl
      ));
		}
	}
	
?>