<?php

	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/user_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/twitter_model.php");

	class ConnectTwitter extends FJF_CMD{
		var $sessionModel = null;
		var $userModel = null;
		var $twitterModel = null;

		function __construct(){
			$this->sessionModel = new SessionModel;
			$this->userModel = new UserModel;
			$this->twitterModel = new TwitterModel;
		}

		function execute(){
			
			$hasError = false;
	    $status = "";
			
			$connection = $this->twitterModel->getLib();
			
			if(isset($_GET["oauth_token"]) && isset($_GET["oauth_verifier"])){
				if(isset($_SESSION["twitter_oauth_request"]) && $_SESSION["twitter_oauth_request"]["token"] === $_GET["oauth_token"]){
					
					$connection->token = new OAuthConsumer($_SESSION["twitter_oauth_request"]["token"], $_SESSION["twitter_oauth_request"]["token_secret"]);
					unset($_SESSION["twitter_oauth_request"]);
					
					$_SESSION["twitter_oauth_access"] = $connection->getAccessToken($_GET["oauth_verifier"]);
					if($connection->http_code == 200){
						
					  $content = $connection->get("account/verify_credentials");
					  if($connection->http_code == 200){
					  	$connectedUser = $content;
							
							if($this->sessionModel->isLoggedUser()){
								$dbUser = $this->sessionModel->getRecordBy(
									"users",
									$this->sessionModel->uid
								);
							}else{
								$dbUser = $this->sessionModel->getRecord(
                  "users",
                  "tier <> 0 AND twitter_id = 'TWITTER_ID'",
                  array('TWITTER_ID' => $connectedUser->id)
                );
							}
							
							if(!$dbUser){
								list($fname, $lname) = explode(" ", $connectedUser->name . " ");
								if(!isset($_SESSION['register_data']['personal_info']))
								$_SESSION['register_data']['personal_info'] = array();
								$_SESSION['register_data']['personal_info'] = array_merge(
									$_SESSION['register_data']['personal_info'],
									array(
										"first_name" => $fname,
						        "last_name" => $lname,
						        "twitter_id" => $connectedUser->id,
						        "block_email" => false
									)
								);
								$_SESSION['register_data']['steps']['personal_info'] = false;
								FJF_BASE::redirect('/register/');
								/*
								$dbUser = array(
									"first_name" => $fname,
					        "last_name" => $lname,
					        "twitter_id" => $connectedUser->id,
					        "email" => null
								);
								if($dbUserId = $this->userModel->insertUser($dbUser)){
									$dbUser = $this->sessionModel->getRecordBy("users", $dbUserId);
                  $_SESSION['register_success'] = true;
								}else{
			            $hasError = true;
			            $status .= "An error occurred while saving record to DB.\n";
			          }
								*/
							}
							
							if(!$hasError){
								if($dbUser->twitter_id != $connectedUser->id){
									$dbUser->twitter_id = $connectedUser->id;
									$this->sessionModel->updateRecords("users", "twitter_id=''", "twitter_id='TWITTER_ID'", array(
										"TWITTER_ID" => $dbUser->twitter_id
									));
									$this->sessionModel->saveRecord("users", array(
										"id" => $dbUser->id,
										"twitter_id" => $dbUser->twitter_id
									));
								}
								
								$hasError = !$this->sessionModel->login($dbUser);
		            $status .= $this->sessionModel->status . "\n";
							}
					  	
					  }else{
					  	if($content && isset($content->errors)){
					  		foreach($content->errors as $error){
						  		$hasError = true;
									$status .= $error->message . "\n";
								}
					  	}else{
							  $hasError = true;
								$status .= "Could not verify credentials.\n";
					  	}
					  }
						
					}else{
					  $hasError = true;
						$status .= "Could not verify token.\n";
					}
					
				}else{
				  $hasError = true;
					$status .= "Expired OAuth token.\n";
				}
			}
			
			if(isset($_GET["denied"])){
				$hasError = true;
				$status .= "Access denied.\n";
			}
			
			$loginUrl = null;
			$connection->token = null;
			$request_token = $connection->getRequestToken();
			if($connection->http_code == 200){
				$_SESSION["twitter_oauth_request"] = array(
					"token" => $request_token["oauth_token"],
					"token_secret" => $request_token["oauth_token_secret"]
				);
				$loginUrl = $connection->getAuthorizeURL($_SESSION["twitter_oauth_request"]["token"]);
				if(!$hasError) FJF_BASE::redirect($loginUrl);
			}else{
				$hasError = true;
				$status .= "Request token retrieval failed.\n";
			}
			
			
			/*
			 * save $hasError & $status
			 */
			$_hasError = $hasError;
	    $_status = $status;
			
			require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["app_web_path"] . "/includes/header_commands.php");
			
			/*
			 * restore $hasError & $status
			 */
			$hasError = $_hasError;
	    $status .= $_status;
			
			$this->displayTemplate("connect_twitter.tpl", array(
        "header" => $header,
        "has_error" => $hasError,
        "status" => $status,
        "login_url" => $loginUrl
      ));
		}
	}
	
?>