<?php

  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/user_model.php");

  class ForgotPassword extends FJF_CMD
  {
    var $sessionModel = null;
    var $userModel = null;

    function __construct()
    {
      $this->sessionModel = new SessionModel();
      $this->userModel = new UserModel();
    }

    function execute()
    {
      require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["app_web_path"] . "/includes/header_commands.php");
      
      $this->sessionModel->loginRedirect("/");
      
      $header["title"] = "Forgot Password";
      $success = false;
      $email = null;
                  
      if($_SERVER["REQUEST_METHOD"] == "POST")
      {
        $email = (isset($_POST["email"]) && $_POST["email"] != "") ? trim($_POST["email"]) : "";

        if(!$email){
          $hasError = true;
          $status .= "Email is a required field.<br />";
        }elseif(!preg_match("/^.+@.+\..+$/", $email)){
          $hasError = true;
          $status .= "Invalid email format.<br />";
        }
        
        
        if(!$hasError)
        {
          if($user = $this->sessionModel->getRecordBy("users", $email, "email"))
          {
              if ($this->userModel->updateRefreshPassword($user))
              {
                $status = "Email was sent to your email address.";
                $success = true;
              }
              else
              {
                $hasError = true;
                $status = "Error occured while processing your data. Please, contact support.";
              }
          }
          else
          {
            $hasError = true;
            $status = "Your Email Address is not recognized.";
          }
        }

      } // end POST

      $templateParams = array(
        "has_error" => $hasError,
        "status" => $status,
        "header" => &$header,
        "email" => $email,
        "success" => $success
      );
      return $this->displayTemplate("forgot_password.tpl", $templateParams);
    }
  }

?>