<?php

	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/user_model.php");

	class FormFeedback extends FJF_CMD{
		var $sessionModel = null;
    var $userModel = null;

		function __construct(){
			$this->sessionModel = new SessionModel();
      $this->userModel = new UserModel();
		}

		function execute(){
			require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["includes_path"] . "/header_commands.php");
      
      $header["title"] = "Feedback";
      $record = null;
      $success = false;
      
      $topics = array("0"=>"topic of feedback", "1"=>"functionality", "2"=>"user experience", "3"=>"bugs", "4"=>"other");
      
      if($_SERVER["REQUEST_METHOD"] == "POST"){
      	
        $record = new stdClass;
        $record->first_name = (isset($_POST["first_name"]) && $_POST["first_name"] != "") ? htmlspecialchars(trim($_POST["first_name"]), ENT_QUOTES) : "";
        $record->last_name = (isset($_POST["last_name"]) && $_POST["last_name"] != "") ? htmlspecialchars(trim($_POST["last_name"]), ENT_QUOTES) : "";
        $record->email = (isset($_POST["email"]) && $_POST["email"] != "") ? trim($_POST["email"]) : "";
        $record->phone = (isset($_POST["phone"]) && $_POST["phone"] != "") ? htmlspecialchars(trim($_POST["phone"]), ENT_QUOTES) : "";
        $record->topic = (isset($_POST["topic"]) && $_POST["topic"] != "") ? intval($_POST["topic"]) : 0;
        $record->topic_other = (isset($_POST["topic_other"]) && $_POST["topic_other"] != "") ? htmlspecialchars(trim($_POST["topic_other"]), ENT_QUOTES) : "";
        $record->message = (isset($_POST["message"]) && $_POST["message"] != "") ? htmlspecialchars(trim($_POST["message"]), ENT_QUOTES) : "";
        
        if(!$record->first_name){
          $hasError = true;
          $status['first_name'] = "First name is a required field.<br />";
        }
        
        if(!$record->last_name){
          $hasError = true;
          $status['last_name'] = "Last name is a required field.<br />";
        }
        
        if(!$record->email){
          $hasError = true;
          $status['email'] = "Email is a required field.<br />";
        }elseif(!preg_match("/^.+@.+\..+$/", $record->email)){
          $hasError = true;
          $status['email'] = "Invalid email format.<br />";
        }
        
        if(!$record->phone){
          $hasError = true;
          $status['phone'] = "Phone number is a required field.<br />";
        }
        
        if(!$record->topic){
          $hasError = true;
          $status['topic'] = "Topic of feedback is a required field.<br />";
        }elseif(!array_key_exists($record->topic, $topics)){
          $hasError = true;
          $status['topic'] = "Topic of feedback is a required field.<br />";
        }
        
        if($record->topic == 4 && !$record->topic_other){
          $hasError = true;
          $status['topic'] = "Other topic of feedback is a required field.<br />";
        }
        
        if(!$record->message){
          $hasError = true;
          $status['message'] = "Message is a required field.<br />";
        }
        
        if(!$hasError){
          $emails = isset($header["site_vars"]["contact_email"]) ? explode(',',$header["site_vars"]["contact_email"]) : '';
          $mMessage = '<b>First name:</b> '.stripcslashes($record->first_name).'<br/><br/>';
          $mMessage .= '<b>Last name:</b> '.stripcslashes($record->last_name).'<br/><br/>';
          $mMessage .= '<b>Email:</b> '.stripcslashes($record->email).'<br/><br/>';
          $mMessage .= '<b>Phone number:</b> '.stripcslashes($record->phone).'<br/><br/>';
          $mMessage .= '<b>Topic:</b> '.stripcslashes($topics[$record->topic]).'<br/><br/>';
          if($record->topic == 4) $mMessage .= '<b>Other topic:</b> '.stripcslashes($record->topic_other).'<br/><br/>';
          $mMessage .= '<b>Message:</b> '.nl2br(stripcslashes($record->message)).'<br/>';
          $mSubjec = $header["title"];
          $result = false;
          if($emails)
          {
            foreach($emails as $email)
            {
              $result = $this->userModel->sendMail($email, $mMessage, $mSubjec);
            }
          }
          if($result){
            $success = true;
            $status = "Thank you for your feedback.";
          }else{
            $hasError = true;
            $status .= "An error occurred, please try again.<br/>";
          }
        }
      }
            
			$templateParams = array(
        "has_error" => $hasError,
        "status" => $status,
        "header" => $header,
        "topics" => $topics,
        "record" => $record,
        "success" => $success
      );
			return $this->displayTemplate("form_feedback.tpl", $templateParams);
		}
	}
	
?>