<?php

	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/heatmap_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/price_model.php");

	class Heatmaps extends FJF_CMD{
		
		var $sessionModel = null;

		function __construct(){
			$this->sessionModel = new SessionModel();
		}

		function execute(){
			require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["includes_path"] . "/header_commands.php");
			$modes = array('sentiment', 'buzz');
			$mode = isset($_GET['mode']) ? $_GET['mode'] : null;
			if(!$mode) $mode = $modes[0];
			if(!in_array($mode, $modes)) FJF_BASE::redirect("/heat-maps/sentiment/");
			
			$header['title'] = "HEAT MAP: " . strtoupper($mode);
			
			if(isset($_COOKIE['view_mode'])) HeatmapModel::viewMode($_COOKIE['view_mode']);
			
			$defaultExchange = "NYSE";
			$exchanges = HeatmapModel::getExchanges();
			array_unshift($exchanges, "ALL");
			$exchange = isset($_GET['exchange']) ? $_GET['exchange'] : null;
			if(!$exchange) $exchange = in_array($defaultExchange, $exchanges) ? $defaultExchange : $exchanges[0];
			if(!in_array($exchange, $exchanges)) FJF_BASE::redirect("/heat-maps/" . $mode . "/");
			
			$tickers = $mode == 'sentiment' ? HeatmapModel::getSentimentTickers($exchange) : HeatmapModel::getBuzzTickers($exchange);
			$tickers = PriceModel::formatPrices($tickers,2,'PRICE','EXCHANGE');
			$tree = $tickers ? json_encode(HeatmapModel::getTree($header['title'], $tickers, $mode)) : null;
      $time = HeatmapModel::getUnixTS();
			
			$legend = array('-1.0' => '', '-0.5' => '', 0 => '', '0.5' => '', '1.0' => '');
			foreach($legend as $i => $v) $legend[$i] = HeatmapModel::getColor($i);
					
			return $this->displayTemplate("heatmaps.tpl", array(
        "has_error" => $hasError,
        "status" => $status,
        "header" => $header,
        "tree" => $tree,
        "legend" => $legend,
        "exchanges" => $exchanges,
        "exchange" => $exchange,
        "modes" => $modes,
        "mode" => $mode,
        "time" => $time
      ));
		}

	}
	
?>