<?php

	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/pages_model.php");
  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/sentiment_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/users_sentiment_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/twitter_model.php");

	class Homepage extends FJF_CMD
	{
		var $sessionModel = null;
		var $pagesModel = null;
    var $sentimentModel = null;
		var $usersSentimentModel = null;
		var $twitterModel = null;

		function __construct()
		{
			$this->sessionModel = new SessionModel();
			$this->sessionModel->checkLockedPage();
			$this->pagesModel = new PagesModel();
      $this->sentimentModel = new SentimentModel();
			$this->twitterModel = new TwitterModel();
			$this->usersSentimentModel = new UsersSentimentModel();
		}

		function execute()
		{
			require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["app_web_path"] . "/includes/header_commands.php");
			
			$header["title"] = "Homepage";
			if($page = $this->pagesModel->recordBy("homepage")){
				$header["title"] = $page->meta_title ? $page->meta_title : $page->title;
				$header["meta_keywords"] = $page->meta_keywords;
				$header["meta_description"] = $page->meta_description;
			}
			$this->sentimentModel->mode = (isset($_COOKIE['view_mode'])) ? $_COOKIE['view_mode'] : null;
  		$topTrending = $this->sentimentModel->getTopTrending();
			$topTenCategory = ($this->sentimentModel->mode == 'MP') ? 'MP_LAST_TRADING_SIGNAL' : 'CROWD_SENTIMENT_AVERAGED';
			$topSentiments = array(
        "positive" => $this->sentimentModel->getTopTen($topTenCategory, 'TOP'),
        "negative" => $this->sentimentModel->getTopTen($topTenCategory, 'BOTTOM'),
        "category" => $topTenCategory
      );
			$fields = 'RANK AS rank, USERNAME AS username, SCORE AS score';
			$topMp = $this->usersSentimentModel->getTopTenUserScores('TS=(SELECT TS FROM TopTenData_UserScores ORDER BY TS DESC LIMIT 1)', null, 10, 'RANK', $fields);
			$topMp = ($topMp) ? $this->twitterModel->getUsersInfo($topMp, false) : null;
    	$fields = 'title, url_title, type, image';
      $where = "status = 1 AND is_featured = 1 AND create_date < 'NOW_DATE'";
      $where .= " ORDER BY position";
      $params = array("NOW_DATE" => date('Y-m-d H:i:s'));
      $press = FJF_BASE_RICH::getRecords('press', $where, $params, false, $fields);

			$templateParams = array(
        "has_error" => $hasError,
        "status" => $status,
        "header" => $header,
        "top_trending" => $topTrending,
        "top_sentiments" => $topSentiments,
        "top_mp" => $topMp,
        "press" => $press
      );
			return $this->displayTemplate("homepage.tpl", $templateParams);
		}
	}

?>