<?php

	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/pages_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/content_organizer_model.php");

	class Page extends FJF_CMD
	{
		var $sessionModel = null;
		var $pagesModel = null;
		var $contentOrganizerModel = null;

		function __construct()
		{
			$this->sessionModel = new SessionModel();
			$this->pagesModel = new PagesModel();
			$this->contentOrganizerModel = new ContentOrganizerModel();
		}

		function execute()
		{
			require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["includes_path"] . "/header_commands.php");

			$urlTitles = isset($_GET["url_title"]) ? explode("/", trim($_GET["url_title"], "/")) : array();
			$urlTitle = !empty($urlTitles) ? $urlTitles[count($urlTitles)-1] : null;
			$error404 = true;
			
			$record = $this->pagesModel->recordBy(array($urlTitle, 'page'), "pr.url_title,p.type");

			if($record)
			{
				$record->links = $this->sessionModel->selectRecords("SELECT title, link FROM cms_content_links where item_id=" . $record->id);

				$header["title"] = $record->meta_title ? $record->meta_title : $record->title;
				$header["meta_keywords"] = $record->meta_keywords;
				$header["meta_description"] = $record->meta_description;

				$r = isset($header["menus"]) ? $this->contentOrganizerModel->urlTittle2URL($record->url_title, $header["menus"][1]) : "";
				if($r) $record->url_title = $r;
				else $record->url_title = "/" . $record->url_title . "/";
				if("/" . strtolower(join("/", $urlTitles) . "/") == strtolower($record->url_title))
				{
					$error404 = false;
				}
			}

			if(!$error404)
			{
				$templateParams = array(
				                        "has_error" => $hasError,
				                        "status" => $status,
				                        "header" => &$header,
				                        "record" => &$record,
				                        "url_title" => $urlTitle
				                       );

				$this->displayTemplate("page.tpl", $templateParams);
			}
			else
			{
				//FJF_BASE::redirect("/", 301);

				if($records = $this->sessionModel->getRecords("seo_redirect"))
				{
					foreach($records as $item)
					{
						$url = parse_url($_SERVER["REQUEST_URI"]);
						$url = trim($url["path"], "/");
						if($url == $item->old_url) FJF_BASE::redirect((($item->new_url != "") ? "/" . $item->new_url : "") . "/");
					}
				}

				header('HTTP/1.1 404 Not Found');
				$header["title"] = "Page Not Found";
				$record = $this->pagesModel->recordBy(array("page-not-found", 'page'), "pr.url_title,p.type");
				if ($record)
				{
					$header["title"] = $record->meta_title ? $record->meta_title : $record->title;
					$header["meta_keywords"] = $record->meta_keywords;
					$header["meta_description"] = $record->meta_description;
				}
				$templateParams = array(
			                        "record" => &$record,
			                        "header" => &$header
			                       );

				$this->displayTemplate("404error.tpl", $templateParams);

			}
			return true;
		}//execute
	}
?>