<?php

  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");


  class PageLimit extends FJF_CMD{
    var $sessionModel = null;


    function __construct(){
      $this->sessionModel = new SessionModel();
    }

    function execute(){
      $user = $this->sessionModel->isLoggedUser() ? $_SESSION["user"] : null;	
      require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["app_web_path"] . "/includes/header_commands.php");
			$type =  isset($_GET["type"]) ? trim($_GET["type"]) : "";
			$id = isset($_GET["id"]) ? trim($_GET["id"]) : "";
			if($type == 'stock'){
				FJF_BASE_RICH::db("sentiment");
				$stock = $id ? FJF_BASE_RICH::getRecords(
						"PricingMaster"
					, "TICKER='TICKER_VAL' LIMIT 1"
					, array('TICKER_VAL' => $id)
					, true
				) : null;
				if(!$stock) FJF_BASE::redirect("/page-not-found/");
				
	      $header["title"] = $id . " - " . $stock->COMPANY_NAME;
				$message = array(
					"title" => "Sorry, But You Have Reached Your Limit!",
					"body" => "You have reached your daily maximum limit of stock views today. This limit will reset at midnight EST.",
					"redirect" => "/"
				);
				if(!$user){
					$message["body"] = "You have reached your limit of viewing 1 stock per day.  Please sign up for our free trial to get access to our entire site";
				}
			}elseif($type == 'user'){
				include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/twitter_model.php");
				$tweeter = new twitterModel();
				$twUsers = $id ? $tweeter->getLib()->get("users/lookup", array("screen_name" => $id)) : null;
				if(is_array($twUsers) && isset($twUsers[0]) && $twUsers[0]){
					$header["title"] = $twUsers[0]->name . ' @' . $id;
				}else{
					FJF_BASE::redirect("/page-not-found/");
				}
				$message = array(
					"title" => "Sorry, But You Have Reached Your Limit!",
					"body" => "You have reached your daily maximum limit of user views today. This limit will reset at midnight EST.",
					"redirect" => "/"
				);
				if(!$user){
					$message["body"] = "You have reached your limit of viewing 1 Financial Pundit per day.  Please sign up for our free trial to get access to our entire site.";
				}
			}else{
				FJF_BASE::redirect("/page-not-found/");
			}
			
			if(!$user){
				$message["redirect"] = "/register/";
			}elseif($user->tier == 0){
				$message["redirect"] = "/account-information/";
			}
			
			$header["blur"] = true;

      $templateParams = array(
        "has_error" => $hasError,
        "status" => $status,
        "header" => $header,
        "message" => $message
      );
      return $this->displayTemplate("page_limit.tpl", $templateParams);
    }
  }

?>