<?php

  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/pages_model.php");


  class PageLocked extends FJF_CMD{
    var $sessionModel = null;
		var $pagesModel = null;


    function __construct(){
      $this->sessionModel = new SessionModel();
			$this->pagesModel = new PagesModel();
    }

    function execute(){
      $user = $this->sessionModel->getUser();	
      require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["app_web_path"] . "/includes/header_commands.php");
			$type =  isset($_GET["type"]) ? trim($_GET["type"]) : "";
			
			$message = array(
				"title" => "Your account is no longer valid!",
				"body" => "If you would like to activate your subscription, please enter your credit card information with a valid credit card in User Account Settings.",
				"redirect" => "/account-information/"
			);
			
			$record = array();
			
			if($type == 'stock'){
				$id = isset($_GET["id"]) ? trim($_GET["id"]) : "";
				FJF_BASE_RICH::db("sentiment");
				$stock = $id ? FJF_BASE_RICH::getRecords(
						"PricingMaster"
					, "TICKER='TICKER_VAL' LIMIT 1"
					, array('TICKER_VAL' => $id)
					, true
				) : null;
				if(!$stock) FJF_BASE::redirect("/page-not-found/");
				
	      $header["title"] = $id . " - " . $stock->COMPANY_NAME;
			}elseif($type == 'user'){
				$id = isset($_GET["id"]) ? trim($_GET["id"]) : "";
				include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/twitter_model.php");
				$tweeter = new twitterModel();
				$twUsers = $id ? $tweeter->getLib()->get("users/lookup", array("screen_name" => $id)) : null;
				if(is_array($twUsers) && isset($twUsers[0]) && $twUsers[0]){
					$header["title"] = $twUsers[0]->name . ' @' . $id;
				}else{
					FJF_BASE::redirect("/page-not-found/");
				}
			}elseif($type == 'homepage'){
				$header["title"] = "Homepage";
				if($page = $this->pagesModel->recordBy("homepage")){
					$header["title"] = $page->meta_title ? $page->meta_title : $page->title;
					$header["meta_keywords"] = $page->meta_keywords;
					$header["meta_description"] = $page->meta_description;
				}
				$fields = 'title, url_title, type, image';
	      $where = "status = 1 AND is_featured=1";
	      $where .= " AND create_date < 'NOW_DATE'";
	      $where .= " ORDER BY position";
	      $params = array("NOW_DATE"=>date('Y-m-d H:i:s'));
	      $record['press'] = $this->sessionModel->getRecords('press', $where, $params, false, $fields);
			}elseif($type == 'heatmaps'){
				$header["title"] = "HEAT MAP";
			}elseif($type == 'top_ten'){
				$header["title"] = "TOP 10 STOCKS";
			}elseif($type == 'users_top_ten'){
				$header["title"] = "TOP TEN MARKET PROPHITS";
			}elseif($type == 'users_top_ten_returns'){
				$header["title"] = "TOP TEN TICKER AND SECTOR RANKS BY USER";
			}elseif($type == 'dashboard'){
				$header["title"] = "STOCK DASHBOARD";
			}elseif($type == 'account_dashboard'){
				$header["title"] = "USER DASHBOARD";
			}elseif($type == 'alert_dashboard'){
				$header["title"] = "ALERT DASHBOARD";
			}else{
				FJF_BASE::redirect("/page-not-found/");
			}
			
			$header["blur"] = true;

      $templateParams = array(
        "has_error" => $hasError,
        "status" => $status,
        "header" => $header,
        "message" => $message,
        "record" => $record
      );
      return $this->displayTemplate("page_locked.tpl", $templateParams);
    }
  }

?>