<?php

  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");

  class PressDetails extends FJF_CMD{
    var $sessionModel = null;

    function __construct(){
      $this->sessionModel = new SessionModel();
    }

    function execute(){
      require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["includes_path"] . "/header_commands.php");
      $type = (isset($_GET['type']) && $_GET['type'] != '') ? intval($_GET['type']) : 0;
      $urlTitle = (isset($_GET['url_title']) && $_GET['url_title'] != '') ? trim($_GET['url_title']) : '';
      $fields = 'title, description, image';
      $where = "status = 1 AND type = 'INFO_TYPE'";
      $where .= " AND create_date < 'NOW_DATE'";
      $where .= " AND url_title = 'URL_TITLE'";
      $where .= " LIMIT 1";
      $params['INFO_TYPE'] = $type;
      $params['NOW_DATE'] = date('Y-m-d H:i:s');
      $params['URL_TITLE'] = $urlTitle;
      $record = $this->sessionModel->getRecords('press', $where, $params, true, $fields);
      if(!$record) {
       $url = ($type == 1) ? '/news/' : '/press/';
        FJF_BASE::redirect($url);
      }
			$header['title'] = $record->title;
			
      $templateParams = array(
        "has_error" => $hasError,
        "status" => $status,
        "header" => $header,
        "record" => $record,
        "type" => $type
      );
      return $this->displayTemplate("press_details.tpl", $templateParams);
    }
  }
  
?>