<?php

  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/user_model.php");

  class RefreshPassword extends FJF_CMD
  {
    var $sessionModel = null;
    var $userModel = null;

    function __construct()
    {
      $this->sessionModel = new SessionModel();
      $this->userModel = new UserModel();
    }

    function execute()
    {
      require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["includes_path"] . "/header_commands.php");

      $this->sessionModel->loginRedirect("/");
      
      $header["title"] = "Reset Password";
      $record = null;
      $success = false;
      $password = null;
      
      $id = isset($_GET["id"]) ? trim($_GET["id"]) : "";
      $refreshPassword = substr($id, 0, 8);
      $id = FJF_BASE::decrypt(substr($id, 8), "refresh-password");

      $record = $id && $refreshPassword ? $this->sessionModel->getRecord(
        "users",
        "id=" . intval($id) . " AND refresh_password='REFRESH_PASSWORD'",
        array("REFRESH_PASSWORD" => $refreshPassword)
      ) : null;
      
      if(!$record)
      {
        $hasError = true;
        $status = "Invalid reset password code.";
      }
      elseif($_SERVER["REQUEST_METHOD"] == "POST")
      {

        $password = isset($_POST["password"]) ? trim($_POST["password"]) : "";
        $passwordConfirm = isset($_POST["password_confirm"]) ? trim($_POST["password_confirm"]) : "";
        

        if($password == ""){
          $hasError = true;
          $status['password'] = "Password is a required field.";
        }elseif($password != $passwordConfirm){
          $hasError = true;
          $status['password_confirm'] = "Your passwords don't match.<br />";
        }elseif(strlen($password) < 3){
          $hasError = true;
          $status['password'] = "Your password is too short.<br />";
        }
        
        if(!$hasError)
        {
          if($result = $this->userModel->updatePassword(array( 'id' => $record->id, 'password' => $password, "refresh_password" => '')))
          {
            
            //FJF_BASE::redirect("/login/");  
            $status = "Password successfully reset";
            $success = true;
          }
          else
          {
            $hasError = true;
            $status = "An error occurred, please try again.";
          }
        }
      }//POST

      $templateParams = array(
        "has_error" => $hasError,
        "status" => $status,
        "header" => &$header,
        "password" => $password,
        "success" => $success
      );
      return $this->displayTemplate("refresh_password.tpl", $templateParams);
    }
  }
?>
