<?php

	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/user_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/stripe_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/pricing_model.php");

	class Register extends FJF_CMD{
		
		var $sessionModel = null;
		var $userModel = null;

		function __construct(){
			$this->sessionModel = new SessionModel();
			$this->userModel = new UserModel();
		}

		function execute(){
			require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["includes_path"] . "/header_commands.php");
			$isAjax = !empty($_SERVER['HTTP_X_REQUESTED_WITH']) && strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) == 'xmlhttprequest';
			if($isAjax && $this->sessionModel->isLoggedUser()){
				return false;
			}else{
				$this->sessionModel->loginRedirect("/");
			}
			
			$tiers = PricingModel::getTiersInfo();
			$paymentTypes = PricingModel::$paymentTypes;
			
			$GLOBALS["WEB_APPLICATION_CONFIG"]["FJF_BASE_key"] = "abbr";
			$states = FJF_BASE_RICH::getRecords("states");
			
			$data = isset($_SESSION['register_data']) ? $_SESSION['register_data'] : array(
				"steps" => array("1"=> false, "2" => false, "3" => false, "4" => false)
			);
				
			$codeUrl = 	isset($_GET['code']) ? trim($_GET['code']) : "";
			$couponCode = isset($data['billing_info']["coupon_code"]) ? trim($data['billing_info']["coupon_code"]) : "";
			if($codeUrl && !$couponCode){
				if($coupon = FJF_BASE_RICH::getRecord(
        	"promotion_codes",
        	"url_title = 'URL_CODE_VAL' AND status = 1",
        	array(
        		"URL_CODE_VAL" => $codeUrl
					),
        	"code"
				)){
					$data['billing_info']["coupon_code"] = $coupon->code;
				}
			}
			
			if($isAjax){
				$action = isset($_POST['action']) ? trim($_POST['action']) : '';
				
				if($action == 'set_tier'){
					$tier = isset($_POST['tier']) ? trim($_POST['tier']) : '';
					if(!array_key_exists($tier, $tiers)){
						$hasError = true;
						$status .= "Plan is missing.\n"; 
					}else{
						$data['order']['tier'] = $tier;
						$data['order']['plan'] = $tiers[$tier]['name'];
						$data['order']['trial'] = isset($data['personal_info']['id']) ? "" : $tiers[$tier]['trial'];
						if(isset($data['coupon']['tiers'])){
							if(!in_array($tier, $data['coupon']['tiers'])){
								unset($data['coupon']);
								if(isset($data['billing_info']["coupon_code"])){
									$data['billing_info']["coupon_code"] = "";
								}
							}
						}
					}
					$data['steps']['order'] = !$hasError;
				}elseif($action == 'set_personal_info'){
					$isSocialConnect = (
						(isset($data['personal_info']["facebook_id"]) && $data['personal_info']["facebook_id"]) ||
						(isset($data['personal_info']["twitter_id"]) && $data['personal_info']["twitter_id"]) ||
						(isset($data['personal_info']["linkedin_id"]) && $data['personal_info']["linkedin_id"])
					) ? true : false;
	        $data['personal_info']["first_name"] = isset($_POST["first_name"]) ? trim($_POST["first_name"]) : "";
	        $data['personal_info']["last_name"] = isset($_POST["last_name"]) ? trim($_POST["last_name"]) : "";
					$data['personal_info']["address"] = isset($_POST["address"]) ? trim($_POST["address"]) : "";
					$data['personal_info']["address2"] = isset($_POST["address2"]) ? trim($_POST["address2"]) : "";
					$data['personal_info']["city"] = isset($_POST["city"]) ? trim($_POST["city"]) : "";
					$data['personal_info']["zip"] = isset($_POST["zip"]) ? trim($_POST["zip"]) : "";
					$data['personal_info']["country"] = isset($_POST["country"]) ? trim($_POST["country"]) : "";
					$data['personal_info']["state"] = isset($_POST["state"]) ? trim($_POST["state"]) : "";
	        $data['personal_info']["email"] = isset($_POST["email"]) ? trim($_POST["email"]) : "";
	        $data['personal_info']["password"] = isset($_POST["password"]) && !$isSocialConnect ? trim($_POST["password"]) : "";
	        $data['personal_info']["password_confirm"] = isset($_POST["password_confirm"]) && !$isSocialConnect ? trim($_POST["password_confirm"]) : "";
	        $data['personal_info']["accept"] = isset($_POST["accept"]) ? intval($_POST["accept"]) : 0;
	        $data['personal_info']["is_subscribed"] = isset($_POST["is_subscribed"]) ? intval($_POST["is_subscribed"]) : 0;
	
	        if(!$data['personal_info']["first_name"]){
	          $hasError = true;
	          $status .= "First Name  is missing.\n";
	        }
	        
	        if(!$data['personal_info']["last_name"]){
	          $hasError = true;
	          $status .= "Last Name  is missing.\n";
	        }
					
					if(!$data['personal_info']["address"]){
	          $hasError = true;
	          $status .= "Address 1  is missing.\n";
	        }
					
					if(!$data['personal_info']["city"]){
	          $hasError = true;
	          $status .= "City  is missing.\n";
	        }
	        
					if(!$data['personal_info']["zip"]){
	          $hasError = true;
	          $status .= "Zip  is missing.\n";
	        }
	        
	        if(!$data['personal_info']["country"]){
	          $hasError = true;
	          $status .= "Country is missing.\n";
	        }
	        
	        if(($data['personal_info']["country"] == "US" || $data['personal_info']["country"] == "Canada") && !$data['personal_info']["state"]){
	        	$hasError = true;
	          $status .= "State is missing.\n";
	        }else{
	        	$data['personal_info']["state_name"] = (array_key_exists($data['personal_info']["state"], $states)) ? $states[$data['personal_info']["state"]]->name : $data['personal_info']["state"];
	        }
					
					if(!$isSocialConnect && isset($data['personal_info']["block_email"])){
						unset($data['personal_info']["block_email"]);
					}
	                
	        if(!$data['personal_info']["email"]){
	          $hasError = true;
	          $status .= "Email  is missing.\n";
	        }elseif(!preg_match("/^.+@.+\..+$/", $data['personal_info']["email"])){
	          $hasError = true;
	          $status .= "Invalid email format.\n";
	        }elseif($user = FJF_BASE_RICH::getRecordBy("users", $data['personal_info']["email"], "email")){
	        	if($user->cancelled){
	        		$data['personal_info']['id'] = $user->id;
	        		$data['personal_info']['customer_id'] = $user->customer_id;
	        	}else{
	          	$hasError = true;
	          	$status .= "This email is already registered with other account.\n";
						}
	        }else{
	        	if(isset($data['personal_info']['id'])) unset($data['personal_info']['id']);
						if(isset($data['personal_info']['customer_id'])) unset($data['personal_info']['customer_id']);
	        }
					
					if(!$isSocialConnect){
		        if(!$data['personal_info']["password"]){
		          $hasError = true;
		          $status .= "Password  is missing.\n";
		        }elseif($data['personal_info']["password"] != $data['personal_info']["password_confirm"]){
		          $hasError = true;
		          $status .= "Your passwords don't match.\n";
		        }elseif(strlen($data['personal_info']["password"]) < 3){
		          $hasError = true;
		          $status .= "Your password is too short.\n";
		        }
	        }
	        
	        if(!isset($_SESSION["captcha_keystring"]) || !isset($_POST["captcha"]) || $_POST["captcha"] != $_SESSION["captcha_keystring"]){
	          $hasError = true;
	          $status .= "Invalid verification code.\n";
	        }
	        
	        if(!$data['personal_info']["accept"]){
	          $hasError = true;
	          $status .= "Please, accept the Terms of Service.\n";
	        }

					$data['steps']['personal_info'] = !$hasError;
				}elseif($action == 'set_billing_info'){
	        $data['billing_info']["first_name"] = isset($_POST["first_name"]) ? trim($_POST["first_name"]) : "";
	        $data['billing_info']["last_name"] = isset($_POST["last_name"]) ? trim($_POST["last_name"]) : "";
					$data['billing_info']["address"] = isset($_POST["address"]) ? trim($_POST["address"]) : "";
					$data['billing_info']["address2"] = isset($_POST["address2"]) ? trim($_POST["address2"]) : "";
					$data['billing_info']["city"] = isset($_POST["city"]) ? trim($_POST["city"]) : "";
					$data['billing_info']["zip"] = isset($_POST["zip"]) ? trim($_POST["zip"]) : "";
					$data['billing_info']["state"] = isset($_POST["state"]) ? trim($_POST["state"]) : "";
					$data['billing_info']["country"] = isset($_POST["billing_country"]) ? trim($_POST["billing_country"]) : "";
					$data['billing_info']["coupon_code"] = isset($_POST["coupon_code"]) ? trim($_POST["coupon_code"]) : "";
					$data['billing_info']["cc_type"] = isset($_POST["cc_type"]) ? trim($_POST["cc_type"]) : "";
					$data['billing_info']["cc_number"] = isset($_POST["cc_number"]) ? trim($_POST["cc_number"]) : "";
					$data['billing_info']["cc_exp_date"] = isset($_POST["cc_exp_date"]) ? trim($_POST["cc_exp_date"]) : "";
					$data['billing_info']["cc_cvv"] = isset($_POST["cc_cvv"]) ? trim($_POST["cc_cvv"]) : "";
					$data['billing_info']["card"] = isset($_POST["card"]) ? trim($_POST["card"]) : "";
										
					if(!$data['billing_info']["first_name"]){
	          $hasError = true;
	          $status .= "First Name  is missing.\n";
	        }
	        
	        if(!$data['billing_info']["last_name"]){
	          $hasError = true;
	          $status .= "Last Name  is missing.\n";
	        }
					
					if(!$data['billing_info']["address"]){
	          $hasError = true;
	          $status .= "Address 1  is missing.\n";
	        }
					
					if(!$data['billing_info']["city"]){
	          $hasError = true;
	          $status .= "City  is missing.\n";
	        }
	        
					if(!$data['billing_info']["zip"]){
	          $hasError = true;
	          $status .= "Zip  is missing.\n";
	        }
	        
	        if(!$data['billing_info']["country"]){
	          $hasError = true;
	          $status .= "Country is missing.\n";
	        }
	        
	        if(($data['billing_info']["country"] == "US" || $data['billing_info']["country"] == "Canada") && !$data['billing_info']["state"]){
	        	$hasError = true;
	          $status .= "State is missing.\n";
	        }else{
	        	$data['billing_info']["state_name"] = (array_key_exists($data['billing_info']["state"], $states)) ? $states[$data['billing_info']["state"]]->name : $data['billing_info']["state"];
	        }
	        
					if($data['billing_info']["coupon_code"]){
						if(!isset($data['coupon']['code']) || $data['billing_info']["coupon_code"] != $data['coupon']['code']){
							$hasError = true;
	          	$status .= "Please validate Coupon Code.\n";
							if(isset($data['coupon']['code'])) unset($data['coupon']);
						}
					}elseif(isset($data['coupon'])){
						unset($data['coupon']);
					}
					
					if(!$data['billing_info']["cc_type"]){
	          $hasError = true;
	          $status .= "Credit Card Type  is missing.\n";
	        }
					
					if(!$data['billing_info']["cc_number"]){
	          $hasError = true;
	          $status .= "Credit Card Number  is missing.\n";
	        }else{
	        	$data['billing_info']["cc_number"] = "xxxx-" . substr($data['billing_info']["cc_number"], -4);
	        }
					
					if(!$data['billing_info']["cc_exp_date"]){
	          $hasError = true;
	          $status .= "Expiration  is missing.\n";
	        }
	        
	        if(!$data['billing_info']["cc_cvv"]){
	          $hasError = true;
	          $status .= "CVV  is missing.\n";
	        }
					
					$data['steps']['billing_info'] = !$hasError;
				}elseif($action == 'set_payment_type'){
					
					$data['order']['payment_type'] = isset($_POST["payment_type"]) ? trim($_POST["payment_type"]) : "";
					
					if(!array_key_exists($data['order']['payment_type'], $paymentTypes)){
	          $hasError = true;
	          $status .= "Pricing Plan is missing.\n";
						$data['steps']['billing_info'] = false;
	        }else{
	        	if(isset($data['coupon']['payment_types'])){
							if(!in_array($data['order']['payment_type'], $data['coupon']['payment_types'])){
								unset($data['coupon']);
								if(isset($data['billing_info']["coupon_code"])){
									$data['billing_info']["coupon_code"] = "";
								}
							}
						}
	        }

				}elseif($action == 'set_coupon'){
					
					$data['billing_info']["coupon_code"] = isset($_POST["coupon_code"]) ? trim($_POST["coupon_code"]) : "";
					
					if(!$data['billing_info']["coupon_code"]){
						$hasError = true;
	          $status .= "Coupon Code is missing.\n";
					}
					
					if(!isset($data['order']['payment_type']) || !$data['order']['payment_type']){
						$hasError = true;
	          $status .= "Pricing Plan is missing.\n";
					}
					if(!$hasError){
	        	$coupon = FJF_BASE_RICH::getRecord(
		        	"promotion_codes",
		        	" code = 'CODE_VAL' AND FIND_IN_SET('TIER_VAL', tiers) AND FIND_IN_SET('TYPE_VAL', payment_types) AND status = 1",
		        	array(
		        		"CODE_VAL" => $data['billing_info']["coupon_code"],
		        		"TIER_VAL" => $data['order']['tier'],
		        		"TYPE_VAL" => $data['order']['payment_type']
							),
		        	"code, free_trial, tiers, payment_types"
						);
						if(!$coupon){
	          	$hasError = true;
	          	$status .= "Invalid Coupon Code.\n";
						}
					}
					if(!$hasError){
						try{
							StripeModel::setApiKey();
							$stripeCoupon = StripeModel::getCoupon($coupon->code);
						}catch(Exception $e){
							$hasError = true;
							$status .= $e->getMessage() . "\n ";
						}
					}
					if(!$hasError){
						if(!$stripeCoupon || !$stripeCoupon->valid){
							$hasError = true;
	          	$status .= "Invalid Coupon Code.\n";
						}else{
							$data['coupon']['code'] = $coupon->code;
							$status = "Success! - ";
							if($stripeCoupon->amount_off){
								$data['coupon']['type_off'] = 'amount_off';
								$data['coupon']['discount'] = ($stripeCoupon->amount_off) ? $stripeCoupon->amount_off / 100 : 0;
								$status .=  '$'.number_format($data['coupon']['discount'], 2);
							}elseif($stripeCoupon->percent_off){
								$data['coupon']['type_off'] = 'percent_off';
								$data['coupon']['discount'] = $stripeCoupon->percent_off;
								$status .= $data['coupon']['discount'] ."%";
							}
							$status .= " off " . $paymentTypes[$data['order']["payment_type"]];
							if(isset($coupon->free_trial)){
								$data['coupon']['trial'] = $coupon->free_trial;
							}elseif(isset($data['coupon']['trial'])){
								unset($data['coupon']['trial']);
							}
							if($coupon->tiers){
								$data['coupon']['tiers'] = explode(',', $coupon->tiers);
							}elseif(isset($data['coupon']['tiers'])){
								unset($data['coupon']['tiers']);
							}
							if($coupon->payment_types){
								$data['coupon']['payment_types'] = explode(',', $coupon->payment_types);
							}elseif(isset($data['coupon']['payment_types'])){
								unset($data['coupon']['payment_types']);
							}
							$coupon->expires = 0;
							if(isset($stripeCoupon->duration) && $stripeCoupon->duration == 'repeating'){
								$coupon->expires = 'now';
								if(isset($stripeCoupon->duration_in_months) && $stripeCoupon->duration_in_months){
									$months = $stripeCoupon->duration_in_months;
									if($data['order']['payment_type'] == 'annual'){
										$months = floor($months / 12) * 12;
										if($months < $stripeCoupon->duration_in_months){
											$months += 12;
										}
									}
									$coupon->expires .= " + " . $months . " months";
								}
								if($coupon->free_trial) $coupon->expires .= " + " . $coupon->free_trial . " weeks";
								$coupon->expires = strtotime($coupon->expires);
							}
							if($coupon->expires){
								$data['coupon']['coupon_expires'] = $coupon->expires;
							}elseif(isset($data['coupon']['coupon_expires'])){
								unset($data['coupon']['coupon_expires']);
							}
						}
					}
					if($hasError){
						if(isset($data['coupon'])) unset($data['coupon']);
						$data['steps']['billing_info'] = false;
					}
					
				}

				if(isset($data['order']['tier'])){
					$paymentTypesKeys = array_keys($paymentTypes);
					$data['order']['payment_type'] = isset($data['order']['payment_type']) ? $data['order']['payment_type'] : array_shift($paymentTypesKeys);
					$data['order']['price'] = $tiers[$data['order']['tier']][$data['order']['payment_type']]['price'];
					foreach($paymentTypes as $key => $item){
						$data['order'][$key . '_price'] = $tiers[$data['order']['tier']][$key]['price'];
					}
					$data['order']['discount'] = 0;
					if(isset($data['coupon']['type_off'])){
						if($data['coupon']['type_off'] == 'amount_off'){
							$data['order']['discount'] = $data['coupon']['discount'];
						}elseif($data['coupon']['type_off'] == 'percent_off'){
							$data['order']['discount'] = $data['order']['price'] * $data['coupon']['discount'] / 100;
						}
					}
					$data['order']['total'] = $data['order']['price'] - $data['order']['discount'];
					if($data['order']['total'] < 0) $data['order']['total'] = 0;
					if(isset($data['coupon']['trial'])){
						$data['order']['trial'] = $data['coupon']['trial'] ? $data['coupon']['trial'] . ' week' . ($data['coupon']['trial'] > 1 ? 's' : '') : "";
						$data['order']['free_trial'] = $data['coupon']['trial'];
					}else{
						$data['order']['trial'] = isset($data['personal_info']['id']) ? "" : $tiers[$data['order']['tier']]['trial'];
						if(isset($data['order']['free_trial'])) unset($data['order']['free_trial']);
					}
					if(isset($data['coupon']['coupon_expires'])){
						$data['order']['coupon_expires'] = date('m/d/Y',$data['coupon']['coupon_expires']);
						$data['order']['coupon_expires_date'] = date('Y-m-d H:i:s', $data['coupon']['coupon_expires']);
					}else{
						if(isset($data['order']['coupon_expires_date'])) unset($data['order']['coupon_expires_date']);
						$data['order']['coupon_expires'] = "";
					}
				}
				
				if($action == 'register'){
					$fields = $data['personal_info'];
					$fields['tier'] = $data['order']['tier'];
					$order = array_merge($data['order'], $data['billing_info']);
					$removeFields = array('password_confirm', 'accept', 'state_name', 'cc_type', 'cc_number', 'cc_exp_date', 'cc_cvv', 'trial', 'plan', 'card', 'block_email', 'coupon_expires');
					foreach($paymentTypes as $key => $item){
						$removeFields[] = $key . '_price';
					}
					foreach($removeFields as $key){
						if(array_key_exists($key, $fields)){
							unset($fields[$key]);
						}
						if(array_key_exists($key, $order)){
							unset($order[$key]);
						}
					}
					$paymentType = isset($data['order']['payment_type']) ? $data['order']['payment_type'] : "";
					if(!isset($tiers[$data['order']['tier']][$paymentType]['plan_id'])){
						$hasError = true;
						$status .= "Stripe Plan is missing\n ";
					}
					StripeModel::setApiKey();
					if(!$hasError){
						$card = isset($data['billing_info']['card']) ? trim($data['billing_info']['card']) : '';
						$metadata = array();
						foreach(array('first_name', 'last_name', 'address', 'address2', 'city', 'state', 'zip', 'country') as $field){
							if(isset($order[$field])) $metadata[$field] = $order[$field]; 
						}
						try{
							if(isset($fields['customer_id']) && $fields['customer_id']){
								StripeModel::updateCustomer(
									$fields['customer_id'],
									$card,
									null, $metadata
								);
							}else{
								$fields['customer_id'] = StripeModel::createCustomer(
									$card,
									$fields['email'],
									$metadata
								);
							}
						}catch(Exception $e){
							$hasError = true;
							$status .= $e->getMessage() . "\n ";
						}
					}
					if(!$hasError){
						try{
							$subscribeData = array(
								"plan" => $tiers[$data['order']['tier']][$paymentType]['plan_id']
							);
							if(isset($data['coupon']['code'])){
								$subscribeData["coupon"] = $data['coupon']['code'];
							}
							if(isset($data['coupon']['trial'])){
								$subscribeData["trial_end"] = $data['coupon']['trial'] ? strtotime('+ ' . $data['coupon']['trial'] * 7 . ' days') : 'now';
							}elseif(isset($fields['id'])){
								$subscribeData["trial_end"] = 'now';
							}
							$fields['subscribe_id'] = StripeModel::subscribeCustomer($fields['customer_id'], $subscribeData);
						}catch(Exception $e){
							$hasError = true;
							$status .= $e->getMessage() . "\n ";
						}
					}
					if(!$hasError){
						if($userId = $this->userModel->addUser($fields)){
							$order['user_id'] = isset($fields['id']) ? $fields['id'] : $userId;
							$order['transaction_id'] = $fields['subscribe_id'];
							$order['date'] = date('Y-m-d H:i:s');
							$data['order']['confirmation_id'] = FJF_BASE_RICH::saveRecord("orders", $order);
							$mMessage = '<p>' . ucfirst($data['personal_info']['first_name']) . ',</p>';
							$mMessage .= '<h3>Thank You for signing up for the <span style="color:#24AAE1">Market Prophit - ' . $data['order']['plan'] . '</span>. Below is a summary of your purchase:</h3>';
							$mMessage .= '<table width="100%">';
							$mMessage .= '<tr>';
							$mMessage .= '<td colspan="2">';
							$mMessage .= '<h4 style="color:#24AAE1">Confirmation #' . $data['order']['confirmation_id'] . '</h4>';
							$mMessage .= '<td>';
							$mMessage .= '</tr>';
							$mMessage .= '<tr>';
							$mMessage .= '<td valign="top">';
							$mMessage .= '<h4 style="color:#24AAE1">Personal Information</h4>';
							$mMessage .= '<span>' . ucfirst($data['personal_info']['first_name']) . ' ' . ucfirst($data['personal_info']['last_name']) . '</span><br/>';
							$mMessage .= '<span>' . $data['personal_info']['address'] . '</span><br/>';
							$mMessage .= '<span>' . $data['personal_info']['address2'] . '</span><br/>';
							$mMessage .= '<span>' . $data['personal_info']['city'] . ', ' . $data['personal_info']['state_name'] . ', ' . $data['personal_info']['zip'] . '</span><br/>';
							$mMessage .= '<span>' . $data['personal_info']['country'] . '</span><br/>';
							$mMessage .= '<span><a href="mailto:' . $data['personal_info']['email'] . '">' . $data['personal_info']['email'] . '</a></span><br/>';
							$mMessage .= '<h4 style="color:#24AAE1">Payment Information</h4>';
							$mMessage .= '<span>Credit Card Type: ' . ucfirst($data['billing_info']['cc_type']) . '</span><br/>';
							$mMessage .= '<span>Credit Card Number: ' . $data['billing_info']['cc_number'] . '</span><br/>';
							$mMessage .= '<span>' . ucfirst($data['billing_info']['first_name']) . ' ' . ucfirst($data['billing_info']['last_name']) . '</span><br/>';
							$mMessage .= '<span>' . $data['billing_info']['address'] . '</span><br/>';
							$mMessage .= '<span>' . $data['billing_info']['address2'] . '</span><br/>';
							$mMessage .= '<span>' . $data['billing_info']['city'] . ', ' . $data['billing_info']['state_name'] . ', ' . $data['billing_info']['zip'] . '</span><br/>';
							$mMessage .= '<span>' . $data['billing_info']['country'] . '</span><br/>';
							$mMessage .= '</td>';
							$mMessage .= '<td valign="top">';
							$mMessage .= '<h4  style="color:#24AAE1">Order Summary</h4>';
							$mMessage .= '<span>Your Selected Tier:</span>';
							$mMessage .= '<table width="100%">';
							$mMessage .= '<tr>';
							$mMessage .= '<td style="color:#24AAE1">' . $data['order']['plan'] . '</td>';
							$mMessage .= '<td></td>';
							$mMessage .= '</tr>';
							$mMessage .= '<tr>';
							$mMessage .= '<td>' . $paymentTypes[$data['order']["payment_type"]] . '</td>';
							$mMessage .= '<td style="color:#24AAE1">$' . number_format($data['order']['price'], 2) . '</td>';
							$mMessage .= '</tr>';
							if($data['order']['discount']){
								$mMessage .= '<tr>';
								$mMessage .= '<td>Coupon Code</td>';
								$mMessage .= '<td style="color:#24AAE1">-$' . number_format($data['order']['discount'], 2) . '</td>';
								$mMessage .= '</tr>';
							}
							if($data['order']['coupon_expires']){
								$mMessage .= '<tr>';
								$mMessage .= '<td>Coupon Code Promotion Expires</td>';
								$mMessage .= '<td style="color:#24AAE1">' . $data['order']['coupon_expires'] . '</td>';
								$mMessage .= '</tr>';
							}
							if($data['order']['trial']){
								$mMessage .= '<tr>';
								$mMessage .= '<td>Free Trial</td>';
								$mMessage .= '<td style="color:#24AAE1">' . $data['order']['trial'] . '</td>';
								$mMessage .= '</tr>';
							}
							$mMessage .= '<tr>';
							$mMessage .= '<td>Total</td>';
							$mMessage .= '<td style="color:#24AAE1">$' . number_format($data['order']['total'], 2) . '</td>';
							$mMessage .= '</tr>';
							$mMessage .= '</table>';
							$mMessage .= '</td>';
							$mMessage .= '</tr>';
							$mMessage .= '</table>';
							$this->userModel->sendMail(
								array($fields['email'], $fields['first_name'] . " " . $fields['last_name']),
								$mMessage,
								$GLOBALS["WEB_APPLICATION_CONFIG"]["company_name"]." Receipt"
							);
							$mailChimpData["list_id"] = $GLOBALS["WEB_APPLICATION_CONFIG"]['mailchimp']['all_users_list_id'];
							$mailChimpData["first_name"] = $data['personal_info']['first_name'];
							$mailChimpData["last_name"] = $data['personal_info']['last_name'];
							$mailChimpData["email"] = $fields['email'];
							//$this->userModel->subscribeToList($mailChimpData);
	            //$status .= "You have successfully registered!<br/>Please, check your email for the verification message and follow the instructions to verify your account and begin using MarketProphit!<br/><br/>";
	            //$status .= 'NOTE: The confirmation email might go to your SPAM folder in your mail program. Please check that folder if you do not find the confirmation email in your inbox.<br/>';
	            //$status .= 'Please also add <a href="mailto:'.$GLOBALS["WEB_APPLICATION_CONFIG"]["email_from_setting"]["address"].'">"'.$GLOBALS["WEB_APPLICATION_CONFIG"]["email_from_setting"]["address"].'"</a> to your address book.';
	            if(isset($fields['id']) && $fields['id']){
	            	$this->userModel->changePendingStatus($fields['id'], $fields['tier']);
	            }
	          }else{
	            $hasError = true;
	            $status .= "An error occurred, please try again.\n";
	          }
          }
					
					if(!$hasError){
						unset($_SESSION['register_data']);
					}
				}else{
					$_SESSION['register_data'] = $data;
				}
				
				exit(json_encode(array(
					'hasError' => $hasError,
					'status' => $status,
					'data' => $data
				)));
			}
			
			$countries = $this->sessionModel->getRecords("countries", "1 ORDER BY position, name");
			
			$header['title'] = "Registration Page";
			
			$templateParams = array(
        "has_error" => $hasError,
        "status" => $status,
        "header" => $header,
        "tiers" => $tiers,
        "states" => $states,
        "countries" => $countries,
        "stripe_key" => StripeModel::getPublicKey()
      );
			return $this->displayTemplate("register.tpl", $templateParams);
		}
	}
	
?>