<?php

  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/alerts_model.php");
  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/sentiment_model.php");
  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/user_model.php");

  class ScriptCheckAlerts extends FJF_CMD{

    var $alertsModel = null;
    var $sentimentModel = null;
    var $userModel = null;

    function __construct(){
      $this->alertsModel = new AlertsModel();
      $this->sentimentModel = new SentimentModel();
      $this->userModel = new UserModel();
    }

    function execute(){
      //sleep(20);
      $alertsTime = (object) array(
				'time' => time(),
				'current_date' => date('Y-m-d H:i:s')
			);
      $where = "(ai.end_date >= 'CURRENT_DATE'";
      $where .= " OR (ai.timeframe_id = 10 AND ai.end_date = '0000-00-00 00:00:00'))";
      $where .= " AND a.status = 1";
      $alertsFields = "a.stock_id AS ticker, a.id, a.info_id, ai.type_id_1, ai.operation_id_1, ai.value_1, ai.operation, ai.type_id_2, ai.operation_id_2, ai.value_2, ai.timeframe_id";
      $alertsFields .= ", u.first_name, u.last_name, u.email, IF(ai.end_date < 'END_DATE' AND ai.timeframe_id <> 10, 1, 0) AS expired";
      $records = $this->alertsModel->getAlerts($where, array(
				"CURRENT_DATE" => date('Y-m-d H:i:00', $alertsTime->time),
				"END_DATE" => date('Y-m-d H:i:00', $alertsTime->time + 60)
			), null, null, $alertsFields);
      $info = array();

      if($records){
        foreach($records as $item){
           $info['tickers'][] = $item->ticker;
           if($item->type_id_1) $info['types'][] = $item->type_id_1;
           if($item->type_id_2) $info['types'][] = $item->type_id_2;
        }
        if($info){
          $info['tickers'] = array_unique($info['tickers']);
          $info['types'] = array_unique($info['types']);
          $alertsData = $this->sentimentModel->getDataForAlerts($info);
          /*FOR TEST
          echo('Data from DB');
          echo('<pre>');
          print_r($alertsData);
          echo('</pre>');
          END FOR TEST*/
          $alertsOperators = $this->alertsModel->getAlertsOperators();
          $alertsTypes = $this->alertsModel->getAlertsTypes();
          $alertsTimeframes = $this->alertsModel->getAlertsTimeframes();
          //$alertsData['time'] = (isset($alertsData['time']) && $alertsData['time'] != '') ? $alertsData['time'] : 'now';
          foreach($records as $item){
          	$fields2 = array();
						$result = false;
            if(array_key_exists($item->ticker, $alertsData)){
              $data = $alertsData[$item->ticker];
              $value = $this->alertsModel->getAlertTypeValue($item->type_id_1, $data);
              $result = $this->alertsModel->getAlertTriggered($value, $item->operation_id_1, $item->value_1);
              if($item->operation != 2){
                $value = $this->alertsModel->getAlertTypeValue($item->type_id_2, $data);
                $result2 = $this->alertsModel->getAlertTriggered($value, $item->operation_id_2, $item->value_2);
                $result = ($item->operation == 1) ? ($result && $result2) : ($result || $result2);
              }
              //var_dump($item);
              //var_dump($result);
              /*FOR TEST
              $mMessage = stripcslashes($item->first_name).' '.stripcslashes($item->last_name).'. ' ;
              $mMessage .= "Your ";
              $mMessage .= (array_key_exists($item->type_id_1, $alertsTypes)) ? $alertsTypes[$item->type_id_1]->title.' ' : '';
              $mMessage .= (array_key_exists($item->operation_id_1, $alertsOperators)) ? $alertsOperators[$item->operation_id_1]->title.' ' : '';
              $mMessage .= ($item->type_id_1 == 6) ? number_format($item->value_1, 2).'% ' : number_format($item->value_1, 2). ' ';
              if ($item->operation != 2)
              {
                $mMessage .= ($item->operation == 1) ? 'and ' : 'or ';
                $mMessage .= (array_key_exists($item->type_id_2, $alertsTypes)) ? $alertsTypes[$item->type_id_2]->title.' ' : '';
                $mMessage .= (array_key_exists($item->operation_id_2, $alertsOperators)) ? $alertsOperators[$item->operation_id_2]->title.' ' : '';
                $mMessage .= ($item->type_id_2 == 6) ? number_format($item->value_2, 2).'% ' : number_format($item->value_2, 2). ' ';
              }
              $mMessage .= (array_key_exists($item->timeframe_id, $alertsTimeframes)) ? $alertsTimeframes[$item->timeframe_id]->title.' ' : '';
              $mMessage .= "alert for ".stripcslashes($item->ticker)." was <b>".($result? 'TRUE' : 'FALSE')."</b> at ".date('F j, Y, g:i A', $alertsTime->time).". ";
              echo('<pre>');
              echo($mMessage);
              echo('</pre>');
              END FOR TEST*/
              if($result){
                if($fields = $this->alertsModel->getRecordBy("alerts_info",$item->info_id)){
                  $fields = get_object_vars($fields);
                  unset($fields['id']);
                  $fields['triggered_value'] = ($result) ? 1 : 0;
                  $fields['triggered_date'] = $alertsTime->current_date;
                  $fields['date'] = $fields['triggered_date'];
                  $fields['status'] = 2;
                  if($infoID = $this->alertsModel->saveRecord("alerts_info", $fields)){
                    $fields2['id'] = $item->id;
                    $fields2['info_id'] = $infoID;
										$fields2['status'] = $fields['status'];
                    if($this->alertsModel->saveRecord("alerts", $fields2)){
	                    $mTo = $item->email;
	                    $mSubjec = "Your alert was triggered.";
	                    $mMessage = stripcslashes($item->first_name).' '.stripcslashes($item->last_name).',<br/><br/>' ;
	                    $mMessage .= "Your ";
	                    $mMessage .= '"';
	                    $mMessage .= (array_key_exists($item->type_id_1, $alertsTypes)) ? $alertsTypes[$item->type_id_1]->title.' ' : '';
	                    $mMessage .= (array_key_exists($item->operation_id_1, $alertsOperators)) ? $alertsOperators[$item->operation_id_1]->title.' ' : '';
	                    $mMessage .= ($item->type_id_1 == 6) ? number_format($item->value_1, 2).'%' : number_format($item->value_1, 2);
	                    if($item->operation != 2){
	                      $mMessage .= ($item->operation == 1) ? ' and ' : ' or ';
	                      $mMessage .= (array_key_exists($item->type_id_2, $alertsTypes)) ? $alertsTypes[$item->type_id_2]->title.' ' : '';
	                      $mMessage .= (array_key_exists($item->operation_id_2, $alertsOperators)) ? $alertsOperators[$item->operation_id_2]->title.' ' : '';
	                      $mMessage .= ($item->type_id_2 == 6) ? number_format($item->value_2, 2).'%' : number_format($item->value_2, 2);
	                    }
	                    $mMessage .= '" ';
	                    $mMessage .= (array_key_exists($item->timeframe_id, $alertsTimeframes)) ? 'in time-frame "'.$alertsTimeframes[$item->timeframe_id]->title.'" ' : '';
	                    $mMessage .= "alert for ".stripcslashes($item->ticker)." was triggered on ".date('F j, Y \a\t g:i A', $alertsTime->time).". ";
	                    $mMessage .= 'Please visit <a href="http://'.$_SERVER["SERVER_NAME"].'/dashboard/?ticker='.stripcslashes($item->ticker).'&tab=alerts" title="'.$GLOBALS["WEB_APPLICATION_CONFIG"]["company_name"].'" style="color:#0080FF; font-weight: bold;">'.$GLOBALS["WEB_APPLICATION_CONFIG"]["company_name"].'</a> to manage your alerts.<br/>';
	                    $mMessage .= "<br/><br/>";
	                    $mMessage .= "Sincerely,";
	                    $mMessage .= "<br/>";
	                    $mMessage .= $GLOBALS["WEB_APPLICATION_CONFIG"]["company_name"];
	                    if(FJF_SERVER == "live") $this->userModel->sendMail($mTo, $mMessage, $mSubjec);
                    }
                  }
                }
              }
            }
						if(!$result && $item->expired){
							if($fields = $this->alertsModel->getRecordBy("alerts_info",$item->info_id)){
								$fields = get_object_vars($fields);
                unset($fields['id']);
                $fields['triggered_value'] = ($result) ? 1 : 0;
                $fields['triggered_date'] = $alertsTime->current_date;
                $fields['date'] = $fields['triggered_date'];
                $fields['status'] = 3;
                if($infoID = $this->alertsModel->saveRecord("alerts_info", $fields)){
                  $fields2['id'] = $item->id;
                  $fields2['info_id'] = $infoID;
                  $fields2['status'] = $fields['status'];
                  $this->alertsModel->saveRecord("alerts", $fields2);
								}
							}
						}
          }
        }
      }
      exit('Done');
    }
  }

?>