<?php

  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/alerts_model.php");
  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/sentiment_model.php");

  class ScriptCheckPredictions extends FJF_CMD
  {

    var $alertsModel = null;
    var $sentimentModel = null;

    function __construct()
    {
      $this->alertsModel = new AlertsModel();
      $this->sentimentModel = new SentimentModel();
    }

    function execute()
    {
    	$params['CURRENT_DATE'] = date('Y-m-d H:i');
    	$where = "DATE_FORMAT(apt.end_date, '%Y-%m-%d %H:%i') = 'CURRENT_DATE' AND correct = '0'";
    	$records = $this->alertsModel->getPredictionTimeframes($where, $params);
    	if ($records)
    	{
     		foreach($records as $item)
     	 	{
     	  	$stockPrices = ($item->ticker) ? $this->sentimentModel->getStockPrice(array($item->ticker)) : null;
     	  	$fileds['current_price'] = ($stockPrices && isset($stockPrices[$item->ticker]->Last)) ? floatval($stockPrices[$item->ticker]->Last) : 0;
     	  	if ($fileds['current_price'] && $item->price)
     	  	{
          	$fileds['id'] = $item->id;
          	$fileds['correct'] = (($fileds['current_price'] > $item->price && $item->prediction == 1) 
          	|| ($fileds['current_price'] < $item->price && $item->prediction == 0)) ? 1 : 2;
          	$this->alertsModel->saveRecord("alerts_predictions_timeframes", $fileds);
        	} 
       	}
     	}
		 	$records = $this->alertsModel->getUsersPredictionTimeframes($where, $params);
			if ($records)
     	{
      	foreach($records as $item)
       	{
       		$stockPrices = ($item->ticker) ? $this->sentimentModel->getStockPrice(array($item->ticker)) : null;
        	$fileds['current_price'] = ($stockPrices && isset($stockPrices[$item->ticker]->Last)) ? floatval($stockPrices[$item->ticker]->Last) : 0;
        	if ($fileds['current_price'] && $item->price)
        	{
          	$fileds['id'] = $item->id;
          	$fileds['correct'] = (($fileds['current_price'] > $item->price && $item->prediction == 1) 
          	|| ($fileds['current_price'] < $item->price && $item->prediction == 0)) ? 1 : 2;
          	$this->alertsModel->saveRecord("market_users_alerts_predictions_timeframes", $fileds);
        	} 
       	}
     	}
			exit('Done');
    }
  }

?>