<?php

  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/alerts_model.php");
  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/sentiment_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/users_sentiment_model.php");
  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/user_model.php");

  class ScriptCheckUsersAlerts extends FJF_CMD
  {

    var $alertsModel = null;
    var $sentimentModel = null;
		var $usersSentimentModel = null;
    var $userModel = null;

    function __construct()
    {
      $this->alertsModel = new AlertsModel();
      $this->sentimentModel = new SentimentModel();
			$this->usersSentimentModel = new usersSentimentModel();
      $this->userModel = new UserModel();
    }

    function execute()
    {
			$alertsTime = (object) array(
				'time' => time(),
				'current_date' => date('Y-m-d H:i:s')
			);
      $where = "(ai.end_date >= 'CURRENT_DATE'";
      $where .= " OR (ai.timeframe_id = 10 AND ai.end_date = '0000-00-00 00:00:00'))";
      $where .= " AND a.status = 1";
      $alertsFields = "a.id, a.info_id, a.type, a.subtype, ai.type_id_1, ai.operation_id_1, ai.value_1, ai.operation, ai.type_id_2, ai.operation_id_2, ai.value_2, ai.timeframe_id";
      $alertsFields .= ", ai.ticker, ai.portfolio_tickers, ai.usernames, ai.triggered_usernames, ai.sector, ai.filter_top_returns, ai.filter_timeframe, ai.power";
      $alertsFields .= ", a.user_id, u.first_name, u.last_name, u.email, IF(ai.end_date < 'END_DATE' AND ai.timeframe_id <> 10, 1, 0) AS expired";
      $records = $this->alertsModel->getMarketUsersAlerts($where, array(
				"CURRENT_DATE" => date('Y-m-d H:i:00', $alertsTime->time),
				"END_DATE" => date('Y-m-d H:i:00', $alertsTime->time + 60)
			), null, null, $alertsFields);

      if($records){
				$alertsTitles = $this->usersSentimentModel->getUsersAlertsTitles();
				$alertsTopUserReturns = $this->usersSentimentModel->getAlertTopUserReturns();
				$alertsTopMpReturns = $this->usersSentimentModel->getAlertTopMpReturns();
				$alertsFilterTimeframes = $this->usersSentimentModel->getFilterTimeframes();
				$alertsDefaultTickers = $this->usersSentimentModel->getDefaultFilterTickers();
								
        foreach($records as $item){
        	$alertResult = false;
        	$fields2 = array();
        	if($item->type_id_1 == 1 || $item->type_id_2 == 1){
        		$itemUsernames = explode(',', $item->usernames);
        		$triggeredUsernames = explode(',', $item->triggered_usernames);
        		$activeUsernames = array_diff($itemUsernames, $triggeredUsernames);
        		if(!$activeUsernames) continue;
        		
        		$info = array(
        			"tickers" => ($item->subtype == 'tickers') ? $item->ticker : '',
        			"usernames" => implode(',', $activeUsernames),
        			"sector" => ($item->subtype == 'sectors') ? $item->sector : '',
        			"time" => $alertsTime->current_date,
						);
						if($info['tickers'] == 2){
							$info['tickers'] = $item->portfolio_tickers;
        		}
						if($alertsDataTmp = $this->usersSentimentModel->getDataForAlerts($info)){
							$alertsData = array();
							foreach($alertsDataTmp as $itemTmp){
								$alertsData[$itemTmp->username][] = $itemTmp;
							}
							foreach($alertsData as $userKey=>$userData){
								$userIndex = 0;
								if($itemUsernames){
									foreach($itemUsernames as $key=>$indexItem){
										if($indexItem == $userKey){
											$userIndex = $key + 1;
											break;
										}
									}
								}
								foreach($userData as $data){
		              $result = $this->alertsModel->getAlertTriggered($data->sentiment, $item->operation_id_1, $item->value_1);
		              if($item->operation != 2){
		                $result2 = $this->alertsModel->getAlertTriggered($data->sentiment, $item->operation_id_2, $item->value_2);
		                $result = ($item->operation == 1) ? ($result && $result2) : ($result || $result2);
		              }
		              //var_dump($item);
		              //var_dump($result);
		              /*FOR TEST
		              $alertsTopReturns = ($item->type == 'top-mp') ? $alertsTopMpReturns : $alertsTopUserReturns;
									if ($item->ticker){
										$item->ticker = implode(', ',explode(',',$item->ticker));
									}
									if ($data->sentiment){
										$sentimentValues = explode(',',$data->sentiment);
										if (isset($sentimentValues[0])) $data->sentiment = $sentimentValues[0];
										unset($sentimentValues);
									}
		              $mMessage = stripcslashes($item->first_name).' '.stripcslashes($item->last_name).',<br/><br/>' ;
		              $mMessage .= "Your ";
									$mMessage .= (array_key_exists($item->type, $alertsTitles)) ? strtoupper($alertsTitles[$item->type])." ": '';
									if ($item->type != 'user'){
										$mMessage .= ($data->ticker) ? "for ".stripcslashes($data->ticker)." " : '';
										$mMessage .= ($item->sector) ? "in ".strtoupper(stripcslashes($item->sector)).", " : '';
										$mMessage .= ($item->filter_top_returns && array_key_exists($userIndex,$alertsTopReturns)) ? "from the ".$alertsTopReturns[$userIndex]." ": '';
										$mMessage .= ($data->username || $item->filter_timeframe) ? "from " : '';
										$mMessage .= (array_key_exists($item->filter_timeframe,$alertsFilterTimeframes)) ? strtoupper($alertsFilterTimeframes[$item->filter_timeframe])." ": '';
									}elseif($data->username){
										$mMessage .= "from ";
									}
									$mMessage .= ($data->username) ? "@".stripcslashes($data->username)." ": '';
									if ($item->type == 'user'){
										$mMessage .= "for ".(array_key_exists($item->ticker,$alertsDefaultTickers) ? strtoupper($alertsDefaultTickers[$item->ticker]->name) : stripcslashes($item->ticker))." ";
									}
									$mMessage = substr($mMessage, 0, -1).", ";
									$mMessage .= "was triggered on ".date('F j, Y \a\t g:i A', $alertsTime->time)." ";
									$mMessage .= "and had ".($data->sentiment > 0 ? "POSITIVE" : "NEGATIVE" )." sentiment.";
		              $mMessage .= "<br/><br/>";
		              $mMessage .= "Sincerely,";
		              $mMessage .= "<br/>";
		              $mMessage .= $GLOBALS["WEB_APPLICATION_CONFIG"]["company_name"];
		              echo('<pre>');
		              echo($mMessage);
		              echo('</pre>');
		              END FOR TEST*/
		              if($result){
		              	$fields =  $this->alertsModel->getRecordBy("market_users_alerts_info",$item->info_id);
		                if($fields){
		                  $fields =  get_object_vars($fields);
		                  unset($fields['id']);
											$triggeredUsernames[] = $userKey;
											$triggeredUsernames = array_filter($triggeredUsernames);
											$fields['triggered_usernames'] = implode(',', $triggeredUsernames);
		                  $fields['triggered_value'] = 1;
		                  $fields['triggered_date'] = date('Y-m-d H:i:s', $alertsTime->time);
		                  $fields['date'] = $fields['triggered_date'];
		                  $fields['status'] = 2;
		                }
		                if($fields && $infoID = $this->alertsModel->saveRecord("market_users_alerts_info", $fields)){
		                	$fields2['status'] = (count($itemUsernames) == count($triggeredUsernames)) ? 2 : 1;
		                  $fields2['id'] = $item->id;
		                  $fields2['info_id'] = $infoID;
		                  if($this->alertsModel->saveRecord("market_users_alerts", $fields2)){
		                  	$alertsTopReturns = ($item->type == 'top-mp') ? $alertsTopMpReturns : $alertsTopUserReturns;
												if($item->ticker){
													$item->ticker = implode(', ',explode(',',$item->ticker));
												}
												if($data->sentiment){
													$sentimentValues = explode(',',$data->sentiment);
													if (isset($sentimentValues[0])) $data->sentiment = $sentimentValues[0];
													unset($sentimentValues);
												}
		                    $mTo = $item->email;
		                    $mSubjec = "Your alert was triggered.";
		                    $mMessage = stripcslashes($item->first_name).' '.stripcslashes($item->last_name).',<br/><br/>' ;
					              $mMessage .= "Your ";
												$mMessage .= (array_key_exists($item->type, $alertsTitles)) ? strtoupper($alertsTitles[$item->type])." ": '';
												if($item->type != 'user'){
													$mMessage .= ($data->ticker) ? "for ".stripcslashes($data->ticker)." " : '';
													$mMessage .= ($item->sector) ? "in ".strtoupper(stripcslashes($item->sector)).", " : '';
													$mMessage .= ($item->filter_top_returns && array_key_exists($userIndex,$alertsTopReturns)) ? "from the ".$alertsTopReturns[$userIndex]." ": '';
													$mMessage .= ($data->username || $item->filter_timeframe) ? "from " : '';
													$mMessage .= (array_key_exists($item->filter_timeframe,$alertsFilterTimeframes)) ? strtoupper($alertsFilterTimeframes[$item->filter_timeframe])." ": '';
												}elseif($data->username){
													$mMessage .= "from ";
												}
												$mMessage .= ($data->username) ? "@".stripcslashes($data->username)." ": '';
												if($item->type == 'user'){
													$mMessage .= "for ".(array_key_exists($item->ticker,$alertsDefaultTickers) ? strtoupper($alertsDefaultTickers[$item->ticker]->name) : stripcslashes($item->ticker))." ";
												}
												$mMessage = substr($mMessage, 0, -1).", ";
												$mMessage .= "was triggered on ".date('F j, Y \a\t g:i A', $alertsTime->time)." ";
												$mMessage .= "and had ".($data->sentiment > 0 ? "POSITIVE" : "NEGATIVE" )." sentiment.";
					              $mMessage .= "<br/><br/>";
					              $mMessage .= "Sincerely,";
					              $mMessage .= "<br/>";
					              $mMessage .= $GLOBALS["WEB_APPLICATION_CONFIG"]["company_name"];
		                    if(FJF_SERVER == "live") $this->userModel->sendMail($mTo, $mMessage, $mSubjec);
												$alertResult = true;
												break;
		                  }
		                }
		              }
	              }
              }
            }
					}
					
					if(!$alertResult && $item->expired){
          	$fields =  $this->alertsModel->getRecordBy("market_users_alerts_info",$item->info_id);
            if($fields){
            	$fields2['status'] = 3;
              $fields =  get_object_vars($fields);
              unset($fields['id']);
							$fields['triggered_date'] = $alertsTime->current_date;
              $fields['date'] = $fields['triggered_date'];
              $fields['status'] = $fields2['status'];
              if($infoID = $this->alertsModel->saveRecord("market_users_alerts_info", $fields)){
                $fields2['id'] = $item->id;
                $fields2['info_id'] = $infoID;
								$this->alertsModel->saveRecord("market_users_alerts", $fields2);
							}
						}
          }
      	}
      }
    	exit('Done');
    }
  }

?>