<?php

	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/pages_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/blog_model.php");

	class ScriptCreateSitemap extends FJF_CMD{

		var $pagesModel = null;
		var $blogModel = null;
		var $content = "";
		var $serverURL = "";
		var $lastMod = "";

		function __construct(){
			$this->pagesModel = new PagesModel();
			$this->blogModel = new BlogModel();
			$this->serverURL = $_SERVER["SERVER_NAME"];
			$this->lastMod = date("Y-m-d");
		}

		function execute(){
			
			error_reporting(E_ALL);
			ini_set("display_errors", "1");			
			ini_set("memory_limit", "256M");
			set_time_limit(0);

			$pages = array(
				"/" => array("url" => "/", "priority" => "0.8", "changefreq" => "weekly"),
				"top-ten" => array("url" => "/top-ten/", "priority" => "0.7", "changefreq" => "weekly"),
				"users/top-ten" => array("url" => "/users/top-ten/", "priority" => "0.7", "changefreq" => "weekly"),
				"users/top-ten-returns" => array("url" => "/top-ten/", "priority" => "0.7", "changefreq" => "weekly"),
				"heat-maps" => array("url" => "/heat-maps/", "priority" => "0.7", "changefreq" => "weekly"),
				"heat-maps/sentiment" => array("url" => "/heat-maps/sentiment/", "priority" => "0.7", "changefreq" => "weekly"),
				"heat-maps/buzz" => array("url" => "/heat-maps/buzz/", "priority" => "0.7", "changefreq" => "weekly"),
				"news" => array("url" => "/news/", "priority" => "0.6", "changefreq" => "weekly"),
				"press" => array("url" => "/press/", "priority" => "0.6", "changefreq" => "weekly"),
				"blog" => array("url" => "/blog/", "priority" => "0.6", "changefreq" => "weekly"),
				"about" => array("url" => "/about/", "priority" => "0.6", "changefreq" => "monthly"),
				"company" => array("url" => "/about/company/", "priority" => "0.6", "changefreq" => "monthly"),
				"who-we-are" => array("url" => "/about/who-we-are/", "priority" => "0.6", "changefreq" => "monthly"),
				"how-to" => array("url" => "/about/how-to/", "priority" => "0.6", "changefreq" => "monthly"),
				"research" => array("url" => "/about/research/", "priority" => "0.6", "changefreq" => "monthly"),
				"testimonials" => array("url" => "/about/testimonials/", "priority" => "0.6", "changefreq" => "monthly"),
				"about/testimonials/submit" => array("url" => "/about/testimonials/submit/", "priority" => "0.5", "changefreq" => "monthly"),
				"feedback" => array("url" => "/feedback/", "priority" => "0.6", "changefreq" => "monthly"),
				"contact-us" => array("url" => "/contact-us/", "priority" => "0.6", "changefreq" => "monthly"),
				"pricing" => array("url" => "/pricing/", "priority" => "0.6", "changefreq" => "monthly"),
				"login" => array("url" => "/login/", "priority" => "0.5", "changefreq" => "monthly"),
				"register" => array("url" => "/register/", "priority" => "0.5", "changefreq" => "monthly"),
				"forgot-password" => array("url" => "/forgot-password/", "priority" => "0.5", "changefreq" => "monthly"),
			);

			if($cmsPages = $this->pagesModel->records()){
				foreach($cmsPages as $page){
					if($page->url_title && !array_key_exists($page->url_title, $pages)){
						$pages[$page->url_title] = array(
							"url" => "/" . $page->url_title . "/",
							"priority" => "0.5",
							"changefreq" => "monthly"
						);
					}
				}
			}

			if($blogPages = $this->blogModel->getBlogEntries(null, null, null, null, "be.url_title")){
				foreach($blogPages as $page){
					$key = "blog/" . $page->url_title;
					if($page->url_title && !array_key_exists($key, $pages)){
						$pages[$key] = array(
							"url" => "/" . $key . "/",
							"priority" => "0.5",
							"changefreq" => "monthly"
						);
					}
				}
			}

			if($pressPages = FJF_BASE_RICH::getRecords(
				"press",
				"status = 1",
				null, false, "url_title, type"
			)){
				foreach($pressPages as $page){
					$key = ($page->type  ? "news" : "press") . "/" . $page->url_title;
					if($page->url_title && !array_key_exists($key, $pages)){
						$pages[$key] = array(
							"url" => "/" . $key . "/",
							"priority" => "0.5",
							"changefreq" => "monthly"
						);
					}
				}
			}
			
			$mainContent = "";
			foreach($pages as $page){
				$mainContent .= $this->addUrl($page["url"], $page["priority"], $page["changefreq"]);
			}
			
			$this->saveSitemap($mainContent, "1");
			
			$pages2 = array();

			if($stockUrls = FJF_BASE_RICH::getRecords(
				"stocks_sitemap_urls",
				"",
				null, false, "url"
			)){
				foreach($stockUrls as $page2){
					$key = $page2->url;
					$pages2[$key] = array(
						"url" => "/" . $key . "/",
						"priority" => "0.7",
						"changefreq" => "always"
					);
				}
			}

			$urlCount = 0;
			$totalCount = 1;
			$mainContent = "";
			foreach($pages2 as $page){
				$mainContent .= $this->addUrl($page["url"], $page["priority"], $page["changefreq"]);
				$urlCount ++;
				
				if($urlCount == 10000)
				{
					$totalCount ++;
					$this->saveSitemap($mainContent, $totalCount);
					$urlCount = 0;
					$mainContent = "";
				}				
			}			
			
			$this->saveSitemapIndex($totalCount);

			exit("Done");
		}

		function addUrl($url, $priority, $changefreq = 'monthly'){
			$url = trim($url, " /");
			if($url) $url .= "/";
			$content = "  <url>\n";
			$content .= "    <loc>http://" . $this->serverURL ."/" . $url . "</loc>\n";
			$content .= "    <lastmod>" . $this->lastMod . "</lastmod>\n";
			$content .= "    <changefreq>" . $changefreq . "</changefreq>\n";
			$content .= "    <priority>" . $priority . "</priority>\n";
			$content .= "  </url>\n";
			return $content;
		}

		function saveSitemap($mainContent, $i){
			if($mainContent){
				$cacheFile = $_SERVER["DOCUMENT_ROOT"] . "/sitemaps/sitemap_" . $i . ".xml.gz";
				$content = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
				$content .= "<urlset xmlns=\"http://www.sitemaps.org/schemas/sitemap/0.9\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://www.sitemaps.org/schemas/sitemap/0.9 http://www.sitemaps.org/schemas/sitemap/0.9/sitemap.xsd\">\n";
				$content .= $mainContent;
				$content .= "</urlset>\n";
				if($fp = gzopen($cacheFile, 'w9')){
					gzwrite($fp, $content);
					gzclose($fp);
					return true;
				}
			}
			return false;
		}
		
		function saveSitemapIndex($count){
			$cacheFile = $_SERVER["DOCUMENT_ROOT"] . "/sitemap.xml";
			$content = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
			$content .= "<sitemapindex xmlns=\"http://www.sitemaps.org/schemas/sitemap/0.9\">\n";
			for($i = 1; $i <= $count; $i++)
			{
				$content .= "<sitemap>\n";
				$content .= "  <loc>http://" . $this->serverURL ."/sitemaps/sitemap_" . $i . ".xml.gz</loc>\n";
				$content .= "  <lastmod>" . $this->lastMod . "</lastmod>\n";
				$content .= "</sitemap>\n";
			}
			$content .= "</sitemapindex>\n";
			return @file_put_contents($cacheFile, $content);
		}
		


	}
?>