<?php

	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/stripe_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/user_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/pricing_model.php");

	class ScriptStripeWebhooks extends FJF_CMD{
		
		var $userModel = null;
		
		function __construct(){
      $this->userModel = new UserModel();
    }
		
		function execute(){
			StripeModel::setApiKey();

			if($_SERVER["REQUEST_METHOD"] == "HEAD"){
				exit;
			}

			if($_SERVER["REQUEST_METHOD"] == "POST"){
				$webhookResponse = json_decode(file_get_contents("php://input"));

				//$webhookLogFile = $_SERVER["DOCUMENT_ROOT"] . "/data/webhook.log";
				//file_put_contents($webhookLogFile, "DATE: " . date("Y-m-d H:i:s") . " \n-----------------\n", FILE_APPEND);
				//file_put_contents($webhookLogFile, print_r($webhookResponse, 1) . "\n-----------------\n", FILE_APPEND);
				
				if($webhookResponse->type == "invoice.payment_failed"){
					if($user = FJF_BASE_RICH::getRecord(
						"users",
						"customer_id = 'CUSTOMER_ID_VAL'",
						array(
							"CUSTOMER_ID_VAL" => $webhookResponse->data->object->customer
						)
					)){
						if($user->tier != 0 && $user->subscribe_id == $webhookResponse->data->object->subscription){
							$hasError = false;
							if($user->subscribe_id){
								try{
									StripeModel::cancelCustomerSubscribe($user->customer_id, $user->subscribe_id);
								}catch(Exception $e){
									$hasError = true;
								}
							}
							if(!$hasError){
								if(FJF_BASE_RICH::saveRecord("users", array(
									"id" => $user->id,
									"tier" => 0,
									"subscribe_id" => ""
								))){
									$this->userModel->changePendingStatus($user->id, 0);
									$tiers = PricingModel::getTiersInfo();
									$user->plan = array_key_exists($user->tier, $tiers) ? $tiers[$user->tier]['name'] : "";
									$mMessage = '<table width="100%">';
									$mMessage .= '<tr>';
									$mMessage .= '<td>';
									$mMessage .= '<p>' . ucfirst($user->first_name) . ',</p>';
									$mMessage .= '<p>We attempted to charge your credit card on ' . date('m/d/Y', $webhookResponse->data->object->date) . ' but the transaction did not go through. ';
									$mMessage .= 'Your subscription to ' . $GLOBALS["WEB_APPLICATION_CONFIG"]["company_name"] . ' - ' . $user->plan . ' has been cancelled. ';
									$mMessage .= 'If you would like to continue to use the ' . $GLOBALS["WEB_APPLICATION_CONFIG"]["company_name"] . ' product, please register again using a valid credit card. ';
									$mMessage .= 'Note: if you use the same email for registration, the information in your dashboards will be preserved.</p>';
									$mMessage .= '<p>We hope you come back and sign up again!</p>';
									$mMessage .= '<td>';
									$mMessage .= '</tr>';
									$mMessage .= '<tr>';
									$mMessage .= '<td>';
									$mMessage .= '<br/><span>Sincerely,</span><br/>';
									$mMessage .= '<span>' . $GLOBALS["WEB_APPLICATION_CONFIG"]["company_name"] . '</span>';
									$mMessage .= '<td>';
									$mMessage .= '</tr>';
									$mMessage .= '</table>';
									
									$this->userModel->sendMail(
										array($user->email, $user->first_name . ' ' . $user->last_name),
										$mMessage,
										"Credit Card Processing Error"
									);
								}
							}
						}
					}
				}
			}
			exit;
		}
	}

?>