<?php

  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/alerts_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/users_sentiment_model.php");

  class ScriptUpdatePowerAlerts extends FJF_CMD
  {

    var $alertsModel = null;
		var $usersSentimentModel = null;

    function __construct()
    {
      $this->alertsModel = new AlertsModel();
			$this->usersSentimentModel = new usersSentimentModel();
    }

    function execute()
    {
      $where = "ai.timeframe_id = 11 AND ai.power = 1";
      $alertDefaultFields = array("type", "subtype");
      $fields = "ai.alert_id, ai.type_id_1, ai.operation_id_1, ai.value_1, ai.operation, ai.type_id_2, ai.operation_id_2, ai.value_2";
			$fields .= ", ai.usernames, ai.filter_timeframe, ai.filter_top_returns, ai.ticker, ai.sector";
      foreach($alertDefaultFields as $item){
      	$fields .= ", a.".$item;
      }
      $records = $this->alertsModel->getMarketUsersAlerts($where, null, null, null, $fields);
			if ($records){
				foreach($records as $record){
					$alertFields = get_object_vars($record);
					foreach($alertDefaultFields as $item){
						unset($alertFields[$item]);
					}
					if ($record->type == 'top-mp' || $record->type == 'top-user'){
						$fields = 'DISTINCT  USERNAME AS username';
						$params = array(
							'TIMEFRAME_VAL'=> $record->filter_timeframe,
							'RANK_VAL' => $record->filter_top_returns+1
						);
						$order = 'RANK';
						$usernames = array();
						if ($record->subtype == 'tickers'){
							$params['TICKER_VAL'] = $record->ticker;
							$where = "TIME_FRAME = 'TIMEFRAME_VAL' AND RANK  < 'RANK_VAL' AND TICKER = 'TICKER_VAL'";
							if ($record->type == 'top-mp'){
								$where .= " AND TS = (SELECT TS FROM TopUsers_TickerScore ORDER BY TS DESC LIMIT 1)";
								$usernames = $this->usersSentimentModel->getTopTenReturns('TopUsers_TickerScore', $where, $params, null, $order, $fields);
							}elseif ($record->type == 'top-user'){
								$where .= " AND TS = (SELECT TS FROM TopUsers_TickerReturns ORDER BY TS DESC LIMIT 1)";
								$usernames = $this->usersSentimentModel->getTopTenReturns('TopUsers_TickerReturns', $where, $params, null, $order, $fields);
							}
						}elseif($record->subtype == 'sectors'){
							$params['SECTOR_VAL'] = $record->sector;
							$where = "TIME_FRAME = 'TIMEFRAME_VAL' AND RANK  < 'RANK_VAL' AND SECTOR = 'SECTOR_VAL'";
							if ($record->type == 'top-mp'){
								$where .= " AND TS = (SELECT TS FROM UserTopTenData_SectorScore ORDER BY TS DESC LIMIT 1)";
								$usernames = $this->usersSentimentModel->getTopTenReturns('UserTopTenData_SectorScore', $where, $params, null, $order, $fields);
							}elseif ($record->type == 'top-user'){
								$where .= " AND TS = (SELECT TS FROM UserTopTenData_SectorReturns ORDER BY TS DESC LIMIT 1)";
								$usernames = $this->usersSentimentModel->getTopTenReturns('UserTopTenData_SectorReturns', $where, $params, null, $order, $fields);
							}
						}
						$username = '';
						$usernamesItems = array();
						if ($usernames){
							foreach($usernames as $item){
								$usernamesItems[] = $item->username;
							}
							$username = implode(',', $usernamesItems);
						}
						$alertFields['usernames'] = $username;
						if($record->sector){
							$filterTicker = '';
							$where = "SECTOR = 'SECTOR_VAL'";
							if ($usernamesItems) $where .= " AND USERNAME IN('".implode("','", $usernamesItems)."')";
							if ($record->filter_timeframe) $where .= " AND TIME_FRAME = 'TIMEFRAME_VAL'";
							$params =  array('SECTOR_VAL' => $record->sector, 'TIMEFRAME_VAL' => $record->filter_timeframe);
							$sectorTickers = $this->usersSentimentModel->getUserSpecificData($where, $params, null, null, 'DISTINCT TICKER AS ticker');
							if ($sectorTickers){
								$sectorTickersItems = array();
								foreach($sectorTickers as $item){
									$sectorTickersItems[] = $item->ticker;
								}
								$filterTicker = implode(',', $sectorTickersItems);
							}
							$alertFields['ticker'] = $filterTicker;
						}
					}
					if ($alertFields['ticker'] == 2 && $alertFields['usernames']){
						$where = "usd.USERNAME IN('".implode("','",explode(',',$alertFields['usernames']))."')";
						$where .= " AND usd.TS=(SELECT TS FROM UserSpecificData ORDER BY TS DESC LIMIT 1)";
						$where .= " AND usd.TIME_FRAME = 'TIMEFRAME_VAL'";
						$where .= "GROUP BY usd.TS";
						$params = array("TIMEFRAME_VAL" => $alertFields['filter_timeframe']);
						$fields = 'GROUP_CONCAT(DISTINCT usd.TICKER) AS tickers';
						$userTickers = $this->usersSentimentModel->getUserSpecificData($where, $params, null, null, $fields);
						$alertFields['portfolio_tickers'] = ($userTickers) ? $userTickers[0]->tickers : '';
					}
					$alertFields['triggered_usernames'] = '';
					$alertFields['timeframe_id'] = 11;
					$alertFields['status'] = 1;
					$alertFields['power'] = 1;
					$alertFields['date'] = date('Y-m-d H:i:s');
					$this->alertsModel->editMarketUsersAlert($alertFields);
				}
			}
			exit('Done');
    }
  }

?>