<?php

	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/stripe_model.php");

  class ScriptUpdateUsersPayments extends FJF_CMD
  {
    function execute()
    {
			$users = FJF_BASE_RICH::getRecords("users", "customer_id <> ''", null, false, "id, customer_id");
			if($users){
				StripeModel::setApiKey();
				foreach($users as $key => $item){
					$data = array(
						"customer" => $item->customer_id,
						"created" => array(
							"gte" => strtotime("- 1 day"),
							"lte" => time()
						)
					);
					if($charges = StripeModel::getAllChargesData($data)){
						$fields = array(
							"user_id" => $item->id,
							"customer_id" => $item->customer_id,
							"revenue" => 0,
							"date" => date('Y-m-d H:i:s')
						);
						foreach($charges as $charge){
							if($charge->paid){
								if($charge->amount){
									$fields["revenue"] += $charge->amount/100;
								}
								if($charge->amount_refunded){
									$fields["revenue"] -= $charge->amount_refunded/100;
								}
							}
						}
						FJF_BASE_RICH::saveRecord("users_payments", $fields);
					}
				}
				
			}
			exit('Done');
    }
  }

?>