<?php

  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/xignite_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/price_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/users_sentiment_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/sentiment_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/twitter_model.php");

  class Stock extends FJF_CMD{
    var $sessionModel = null;
		var $usersSentimentModel = null;
		var $sentimentModel = null;
		var $twitterModel = null;

    function __construct(){
      $this->sessionModel = new SessionModel();
			$this->usersSentimentModel = new UsersSentimentModel();
			$this->sentimentModel = new SentimentModel();
			$this->twitterModel = new TwitterModel();
    }

    function execute(){
      $user = $this->sessionModel->isLoggedUser() ? $_SESSION["user"] : null;
      require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["app_web_path"] . "/includes/header_commands.php");
			$isAjax = !empty($_SERVER['HTTP_X_REQUESTED_WITH']) && strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) == 'xmlhttprequest';
			
			FJF_BASE_RICH::db("sentiment");
			
			$ticker = isset($_GET["ticker"]) ? trim($_GET["ticker"]) : "";
			$stock = $ticker ? FJF_BASE_RICH::getRecords(
					"PricingMaster"
				, "TICKER='TICKER_VAL' LIMIT 1"
				, array('TICKER_VAL' => $ticker)
				, true
			) : null;
			
			if(!$stock) FJF_BASE::redirect("/");
			if(!$isAjax){
				$this->sessionModel->checkLockedPage("/stock/" . $ticker . "/locked/");
				FJF_BASE_RICH::db();
				$this->sentimentModel->checkStocksPage($ticker, $user);
				FJF_BASE_RICH::db("sentiment");
			}
			
			$data = new stdClass;
			$data->filter = new stdClass;
			$data->filter_timeframes = $this->usersSentimentModel->getFilterTimeframes();
			$data->timeframes = $this->usersSentimentModel->getTimeframes();
			$data->filter->timeframes = (isset($_POST['timeframes'])) ? $_POST['timeframes'] : null;
			$data->filter->type = (isset($_POST['filter_type'])) ? $_POST['filter_type'] : null;
			$tables = array('users'=>'TopUsers_TickerReturns' , 'site'=>'TopUsers_TickerScore');
			$order = "RANK";
			$limit = 3;
			$params['TICKER_VAL'] = $ticker;
			$fields = 'RANK AS rank, USERNAME AS username, PNL AS pnl,  MP_SCORE AS mps, MP_RANK AS mpr, MP_PREVIOUS_RANK AS prev_mpr, TIME_FRAME AS timeframe';
			if($data->filter->type && isset($tables[$data->filter->type])){
				$tables = array($data->filter->type => $tables[$data->filter->type]);
			}
			foreach($tables as $type=>$table){
				$where = "TS = (SELECT TS FROM ".$table." ORDER BY TS DESC LIMIT 1) AND TICKER = 'TICKER_VAL' AND pnl > 0";
				$tmpKeys = array_keys($data->timeframes);
				$filterTimeframe = ($data->filter->timeframes && isset($data->filter->timeframes[$type])) ? $data->filter->timeframes[$type] : array_shift($tmpKeys);
				if ($filterTimeframe){
					$params['TIMEFRAME_VAL'] = trim($filterTimeframe);
					$where .= " AND TIME_FRAME ='TIMEFRAME_VAL'";
				}
				$stock->stats[$type] = $this->usersSentimentModel->getTopTenReturns($table, $where, $params, $limit, $order, $fields);
				if ($stock->stats[$type]){
					if ($data->timeframes){
						$stock->stats[$type] = $this->twitterModel->getUsersInfo($stock->stats[$type], false);
						foreach($stock->stats[$type] as $key => $item){
							if (array_key_exists($item->timeframe,$data->timeframes)){
								$stock->stats[$type][$key]->timeframe = $data->timeframes[$item->timeframe]['value'];
							}
						}
					}
				}
				if (!$stock->stats[$type]) $stock->stats[$type] = array();
				if ($count = $limit-count($stock->stats[$type])){
					for ($i=0; $i < $count; $i++) {
						$stock->stats[$type][] = null;
					}
				}
			}
			
			if ($isAjax){
				$GLOBALS["smartyEngine"]->assign("type", $data->filter->type);
				echo json_encode(array(
					'hasError' => $hasError,
					'status' => $status,
					'data' => $this->fetchTemplate("stock_users_tables.tpl", array(
	          "stock" => $stock
         	))
				));
				return true;
			}

			$decimals = PriceModel::getPennyDecimals($stock->EXCHANGE_NAME);
			$stock->decimals = ($decimals !== null) ? $decimals : 2;
      $ticker = strtoupper($ticker);
			$header["title"] = "$" . $ticker . " stock price, sentiment, and buzz";
			$header["meta_description"] = "Get real time and historical stock sentiment and buzz charts for $" . $ticker . ". Get real time prices. Find top financial pundits in social media for $" . $ticker . ".";
						
			$data->intervals = $this->usersSentimentModel->getIntervals();
			array_unshift($data->intervals, array("value" => "1D", "interval" => "1 DAY"));

      $templateParams = array(
        "has_error" => $hasError,
        "status" => $status,
        "header" => $header,
        "stock" => $stock,
        "data" => $data
      );
      return $this->displayTemplate("stock.tpl", $templateParams);
    }
  }

?>