<?php

  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/users_sentiment_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/twitter_model.php");
	
  class UsersDetails extends FJF_CMD{
  	
    var $sessionModel = null;
		var $usersSentimentModel = null;
		var $twitterModel = null;

    function __construct(){
      $this->sessionModel = new SessionModel();
			$this->usersSentimentModel = new UsersSentimentModel();
			$this->twitterModel = new TwitterModel();
    }

    function execute(){
			$user = $this->sessionModel->isLoggedUser() ? $_SESSION["user"] : null;
      require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["app_web_path"] . "/includes/header_commands.php");
			$data = new stdClass;
      $data->timeframes = $this->usersSentimentModel->getTimeframes();
			$username = (isset($_GET['username'])) ? trim($_GET['username']) : '';
			$data->filter = new stdClass;
			$data->filter->timeframe = (isset($_POST['timeframe'])) ? trim($_POST['timeframe']) : '';
			$isAjax = !empty($_SERVER['HTTP_X_REQUESTED_WITH']) && strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) == 'xmlhttprequest';
      $record = null;
			
			if(!$isAjax){
				$this->sessionModel->checkLockedPage("/users/details/" . $username . "/locked/");
				$this->usersSentimentModel->checkMarketUsersPage($username, $user);
			}
			
			if($username){
				$where = "us.USERNAME = 'RECORD_USERNAME' AND us.TS = (SELECT TS FROM TrackingData_UserScores ORDER BY TS DESC LIMIT 1)";
				$params = array('RECORD_USERNAME'=>$username);
				$fields = 'us.SCORE, us.RANK,us.PREVIOUS_RANK';
				$userScore = $this->usersSentimentModel->getUserScores($where, $params, null, null, $fields, true);
				//if (!$userScore) FJF_BASE::redirect("/page-not-found/");
				$record =  (object) array(
					"username" => $username,
					"mps" => ($userScore && isset($userScore->SCORE)) ? $userScore->SCORE : 'N/A',
					"mpr" => ($userScore && isset($userScore->RANK)) ? $userScore->RANK : 'N/A',
					"prev_mpr" => ($userScore && isset($userScore->PREVIOUS_RANK)) ? $userScore->PREVIOUS_RANK : 'N/A'
				);
				$recordCount = 13;
				$where = "usd.USERNAME = 'RECORD_USERNAME' AND usd.TS=(SELECT TS FROM UserSpecificData ORDER BY TS DESC LIMIT 1)";
				$params = array('RECORD_USERNAME'=>$username);
				$fields = 'usd.TICKER AS ticker, usd.SECTOR AS sector, usd.PNL AS pnl, usd.TIME_FRAME AS timeframe, usd.TICKER_RETURN_RANK AS return_rank, usd.TICKER_SCORE_RANK AS mpr';
				$tmpKeys = array_keys($data->timeframes);
				$filterTimeframe = ($data->filter->timeframe) ? $data->filter->timeframe : array_shift($tmpKeys);
				if ($filterTimeframe){
					$params['FILTER_TIMEFRAME'] = $filterTimeframe;
					$where .= " AND usd.TIME_FRAME='FILTER_TIMEFRAME'";
				}
				$recordData = $this->usersSentimentModel->getUserSpecificData($where, $params, 0, 'TICKER', $fields);
				if (!$recordData) $recordData = array();
				if ($count = $recordCount-count($recordData)){
					for ($i=0; $i < $count; $i++) {
						array_push($recordData, null);
					}
				}
				$record->data = $recordData;
			}
			/*
			else{
				FJF_BASE::redirect("/page-not-found/");
			}
			*/

			$tweeter = $this->twitterModel->getLib();
			$twUsers = $username ? $tweeter->get("users/lookup", array("screen_name" => $username)) : null;
			if(is_array($twUsers) && isset($twUsers[0]) && $twUsers[0]){
				$record->author = isset($twUsers[0]->name) ? $twUsers[0]->name : $record->username;
				$record->author_logo = isset($twUsers[0]->profile_image_url) ? $twUsers[0]->profile_image_url : "";
			}
			$data->filter_timeframes = $this->usersSentimentModel->getFilterTimeframes();
			$data->timeframes = $this->usersSentimentModel->getTimeframes();
			if(!$data->timeframes) $data->timeframes = array();
			$data->intervals = $this->usersSentimentModel->getIntervals();
			
			if($isAjax){
				echo json_encode(array(
					'hasError' => $hasError,
					'status' => $status,
					'data' => $this->fetchTemplate("users_details_table.tpl", array(
	          "record" => $record,
        		"data" => $data
         	))
				));
				return true;
			}
			
			if($username) $username = '@' . $username;
			$header["title"] = '';
			if(isset($record->author)) $header["title"] = $record->author.' ';
			$header["title"] .= $username;
			$header["meta_description"] = "Find out how " . $username . " ranks and scores based on his or her social media commentary. Get historical performance and track record of pundits' stock market predictions.";
			
      return $this->displayTemplate("users_details.tpl", array(
        "header" => $header,
        "record" => $record,
        "data" => $data
      ));
    }

  }

?>