<?php

  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/users_sentiment_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/twitter_model.php");

  class UsersTopTen extends FJF_CMD{
  	
    var $sessionModel = null;
		var $usersSentimentModel = null;
		var $twitterModel = null;

    function __construct(){
      $this->sessionModel = new SessionModel();
			$this->usersSentimentModel = new UsersSentimentModel();
			$this->twitterModel = new TwitterModel();
    }

    function execute(){
      require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["app_web_path"] . "/includes/header_commands.php");
      
      $header["title"] = "Top Ten Market Prophits";

			$where = 'TS = ( SELECT TS FROM TopTenData_UserScores ORDER BY TS DESC LIMIT 1)';
			$fields = 'RANK AS rank, USERNAME AS username, TICKERS AS tickers, SCORE AS mps, PREVIOUS_RANK AS prev_mpr';
			$GLOBALS["WEB_APPLICATION_CONFIG"]["FJF_BASE_key"] = "username";
			$records = $this->usersSentimentModel->getTopTenUserScores($where, null, 10, 'RANK', $fields);
			
			if($records){
				foreach($records as $item){
					if($item->tickers){
						$tickers = explode(', ',$item->tickers);
						sort($tickers);
						$links = array();
						foreach($tickers as $ticker){
							$links[] = '<a href="/stock/'.trim($ticker).'/">'.trim($ticker).'</a>';
						}
						$item->tickers = implode(', ', $links);
					}
				}
				$records = $this->twitterModel->getUsersInfo($records);
			}
      return $this->displayTemplate("users_top_ten.tpl", array(
        "header" => $header,
        "records" => $records
      ));
    }

  }

?>