<?php

  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/session_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/users_sentiment_model.php");
	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/twitter_model.php");

  class UsersTopTenReturns extends FJF_CMD{
  	
    var $sessionModel = null;
		var $usersSentimentModel = null;
		var $twitterModel = null;

    function __construct(){
      $this->sessionModel = new SessionModel();
			$this->usersSentimentModel = new UsersSentimentModel();
			$this->twitterModel = new TwitterModel();
    }

    function execute(){
      require_once($GLOBALS["WEB_APPLICATION_CONFIG"]["app_web_path"] . "/includes/header_commands.php");
      
      $header["title"] = "Top Ten Ticker and Sector Ranks by User";
			$records = array();
			$info = array();
			$userNames = array();
			$isAjax = !empty($_SERVER['HTTP_X_REQUESTED_WITH']) && strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) == 'xmlhttprequest';
			$data = new stdClass;
			$data->filter = new stdClass;
			$data->filter->tickers = (isset($_POST['tickers'])) ? $_POST['tickers'] : null;
			$data->filter->sectors = (isset($_POST['sectors'])) ? $_POST['sectors'] : null;
			$data->filter->type = (isset($_POST['filter_type'])) ? $_POST['filter_type'] : null;
			$data->filter->subtype = (isset($_POST['filter_subtype'])) ? $_POST['filter_subtype'] : null;
			$data->timeframes = $this->usersSentimentModel->getFilterTimeframes();
			$data->timeframesValues = $this->usersSentimentModel->getTimeframes();
			$data->topUserReturns = $this->usersSentimentModel->getTopUserReturns();
			$data->topMpReturns = $this->usersSentimentModel->getTopMpReturns();
			
			$tables['tickers']['users_returns'] = array(
				"name" => "UserTopTenData_TickerReturns ttr",
				"fields" => "CLASSIFIER_RANK AS rank, RANK AS return_rank, TICKER AS ticker, PNL AS return_val, USERNAME AS username, MP_SCORE AS mps, MP_RANK AS mpr, MP_PREVIOUS_RANK AS prev_mpr, TIME_FRAME AS timeframe",
				"where" => "PNL > 0"
			);
			$tables['tickers']['site_returns'] = array(
				"name" => "UserTopTenData_TickerScore ttr",
				"fields" => "CLASSIFIER_RANK AS rank, RANK AS return_rank, TICKER AS ticker, SCORE AS return_val, USERNAME AS username, MP_SCORE AS mps, MP_RANK AS mpr, MP_PREVIOUS_RANK AS prev_mpr, TIME_FRAME AS timeframe",
				"where" => "SCORE > 0"
			);
			$tables['sectors']['users_returns'] = array(
				"name" => "UserTopTenData_SectorReturns ttr",
				"fields" => "CLASSIFIER_RANK AS rank, RANK AS return_rank, SECTOR AS sector, TICKERS AS tickers, PNL AS return_val, USERNAME AS username, MP_SCORE AS mps, MP_RANK AS mpr, MP_PREVIOUS_RANK AS prev_mpr, TIME_FRAME AS timeframe",
				"where" => "PNL > 0"
			);
			$tables['sectors']['site_returns'] = array(
				"name" => "UserTopTenData_SectorScore ttr",
				"fields" => "CLASSIFIER_RANK AS rank, RANK AS return_rank, SECTOR AS sector, TICKERS AS tickers, SCORE AS return_val, USERNAME AS username, MP_SCORE AS mps, MP_RANK AS mpr, MP_PREVIOUS_RANK AS prev_mpr, TIME_FRAME AS timeframe",
				"where" => "SCORE > 0"
			);
			
			if($data->filter->type && $data->filter->subtype && isset($tables[$data->filter->type][$data->filter->subtype])){
				$tables = array(
					$data->filter->type => array(
						$data->filter->subtype => $tables[$data->filter->type][$data->filter->subtype]
					)
				);
			}
			
			$order = "ttr.CLASSIFIER_RANK, ttr.RANK";
			$limit = 0;
			foreach ($tables as $name=>$type){
				if($type){
					foreach($type as $key=>$item){
						if ($item){
							$params = array();
							$where = 'ttr.TS = (SELECT TS FROM '.$item['name'].' ORDER BY TS DESC LIMIT 1)';
							if(isset($item['where'])) $where .= "AND ".$item['where'];
							$timeframe = isset($data->filter->{$name}[$key]['timeframe']) ? trim($data->filter->{$name}[$key]['timeframe']) : null;
							$rank = isset($data->filter->{$name}[$key]['rank']) ? intval($data->filter->{$name}[$key]['rank']) : null;
							if(!$timeframe && $data->timeframesValues && is_array($data->timeframesValues)){
								$tmpKeys = array_keys($data->timeframesValues);
								$timeframe = array_shift($tmpKeys);
							}
							if ($timeframe){
								$where .= " AND ttr.TIME_FRAME = 'TIMEFRAME_VAL'";
								$params["TIMEFRAME_VAL"] = $timeframe;
							}
							if (!$rank){
								if ($key == 'users_returns'){
									if($data->topUserReturns && is_array($data->topUserReturns)){
										$tmpKeys = array_keys($data->topUserReturns);
										$rank = array_shift($tmpKeys);
									}
								}elseif($key == 'site_returns'){
									if($data->topMpReturns && is_array($data->topMpReturns)){
										$tmpKeys = array_keys($data->topMpReturns);
										$rank = array_shift($tmpKeys);
									}
								}
							}
							if ($rank){
								$where .= " AND ttr.RANK  < 'RANK_VAL'";
								$params["RANK_VAL"] = $rank+1;
							}
							$info[$name][$key] = $this->usersSentimentModel->getTopTenReturns($item['name'], $where, $params, $limit, $order, $item['fields']);
							if ($info[$name][$key]){
								foreach($info[$name][$key] as $item){
									if(isset($item->username) && !in_array($item->username, $userNames)){
										$userNames[] = $item->username;
									}
									$item->empty = false;
								}
							}
						}
					}
				}
			}
			if ($info){
				$tweeter = $this->twitterModel->getLib();
				$twUsers = $userNames ? $tweeter->get("users/lookup", array("screen_name" => implode(",", $userNames))) : null;
				$twUsersNew = array();
				if($twUsers){
					foreach($twUsers as $twUser){
						if(!array_key_exists($twUser->screen_name, $twUsersNew)) $twUsersNew[$twUser->screen_name] = $twUser;
					}
				}
				foreach ($info as $name=>$type){
					if($type){
						foreach($type as $key=>$items){
							if ($items){
								foreach($items as $item){
									if ($item && isset($item->rank) && $item->rank){
										$item->timeframe = array_key_exists($item->timeframe , $data->timeframesValues) ? $data->timeframesValues[$item->timeframe]['value'] : '';
										$item->author_logo = array_key_exists($item->username, $twUsersNew) ? $twUsersNew[$item->username]->profile_image_url : "";
										if($name == 'sectors' && isset($item->tickers) && $item->tickers){
											$tickers = explode(', ',$item->tickers);
											sort($tickers);
											$links = array();
											foreach($tickers as $ticker){
												$links[] = '<a href="/stock/'.trim($ticker).'/">'.trim($ticker).'</a>';
											}
											$item->tickers = implode(', ', $links);
										}
										$records[$name][$key][$item->rank][] = $item;
									}
								}
							}
						}
					}
				}
				$countLimit = 10;
				foreach ($records as $name=>$type){
					foreach($type as $key=>$items){
						if (!$items) $items = array();
						$recordType = array(
							(object) array('empty' => true)
						);
						if ($countDiff = $countLimit - count($items)){
							for ($i=0; $i < $countDiff; $i++) {
								array_push($items, $recordType);
							}
							$records[$name][$key] = $items;
						}
						$filterRank = isset($data->filter->{$name}[$key]['rank']) ? intval($data->filter->{$name}[$key]['rank']) : null;
						if ($filterRank && $items){
							foreach($items as $rank=>$item){
								if ($item){
									$recordCount = count($item);
									if ($filterRank > $recordCount){
										$count = $filterRank-$recordCount;
										$lastItem = isset($item[$recordCount-1]) ? $item[$recordCount-1] : null;
										if($lastItem){
											$recordData = array();
											//if (isset($lastItem->rank)) $recordData['rank'] = $lastItem->rank;
											//if (isset($lastItem->return_val)) $recordData['return_val'] = $lastItem->return_val;
											if (isset($lastItem->sector)) $recordData['sector'] = $lastItem->sector;
											if (isset($lastItem->ticker)) $recordData['ticker'] = $lastItem->ticker;
											if (isset($lastItem->tickers)) $recordData['tickers'] = $lastItem->tickers;
											//if (isset($lastItem->return_rank)) $recordData['return_rank'] = $lastItem->return_rank;
											$recordData['empty'] = true;
											for ($i=0; $i < $count; $i++){
												if (isset($recordData['return_rank'])){
													$recordData['return_rank'] ++;
												}
												$records[$name][$key][$rank][] = (object)$recordData;
											}
										}
									}
								}
							}
						}
					}
				}
				unset($info);
			}
			if ($isAjax){
				$records = isset($records[$data->filter->type][$data->filter->subtype]) ? $records[$data->filter->type][$data->filter->subtype] : null;
				$GLOBALS["smartyEngine"]->assign("type", $data->filter->type);
				$GLOBALS["smartyEngine"]->assign("subtype", $data->filter->subtype);
				$GLOBALS["smartyEngine"]->assign("data", $records);
				echo json_encode(array(
					'hasError' => $hasError,
					'status' => $status,
					'data' => $this->fetchTemplate("users_top_ten_returns_tables.tpl", array())
				));
				return true;
			}
				
      return $this->displayTemplate("users_top_ten_returns.tpl", array(
        "header" => $header,
        "records" => $records,
        "data" => $data
      ));
    }

  }

?>