<?php


	foreach($formFields as $field => $fieldParams)
	{
		$default = array_key_exists("default", $fieldParams) ? $fieldParams["default"] : '';
		if($fieldParams["type"] == "image")
		{
			$fields[$field] =  isset($_POST[$field . "_old"]) ? $_POST[$field . "_old"] : $default;
			
			include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/photo_model.php");
			$this->photoModel = new PhotoModel();
			
			$defaultThumbs = false;
			if($fieldParams["thumbs"] === true) $defaultThumbs = true;
			else
			{
				foreach($fieldParams["thumbs"] as $thumb)
				{
					$thumb = explode(",", str_replace(" ", "", $thumb));
					$this->photoModel->defineThumb($thumb[0], $thumb[1], isset($thumb[2]) ? $thumb[2] : $thumb[1]);
				}
			}
			
			$file = $this->photoModel->upload(isset($fieldParams["folder"]) ? $fieldParams["folder"] : $workTable, null, $field, $defaultThumbs);
			if(!$fields[$field] && array_key_exists("required", $fieldParams) || $file["error"] != "error_invalid_file")
			{
				if($file["error"])
				{
					$hasError = true;
					$status .= ($status ? "<br />" : "") . $file["status"];
				}
				else $fields[$field] = $file["file"];
			}
			
			continue;
		}//image
		
		elseif($fieldParams["type"] == "video")
		{
			$fields[$field] =  isset($_POST[$field . "_old"]) ? $_POST[$field . "_old"] : $default;
			
			include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/video_model.php");
			$this->videoModel = new VideoModel();
			
			$file = $this->videoModel->upload(null, $field);
			if(!$fields[$field] && array_key_exists("required", $fieldParams) || $file["error"] != "error_invalid_file")
			{
				if($file["error"])
				{
					$hasError = true;
					$status = $file["status"];
				}
				else
				{
					$fields[$field] = rtrim($file["file"], "." . $file["extension"]);
					$fields["flixcloud_id"] = $file["flixcloud_id"];
					$fields["extension"] = $file["extension"];
				}
			}
			
			continue;
		}//video
		
		if($fieldParams["type"] == "file")
		{
			$fields[$field] =  isset($_POST[$field . "_old"]) ? $_POST[$field . "_old"] : $default;
			
			include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/file_model.php");
			$this->fileModel = new FileModel();
			
			$file = $this->fileModel->upload(isset($fieldParams["folder"]) ? $fieldParams["folder"] : $workTable, null, $field);
			if(!$fields[$field] && array_key_exists("required", $fieldParams) || $file["error"] != "error_invalid_file")
			{
				if($file["error"])
				{
					$hasError = true;
					$status .= ($status ? "<br />" : "") . $file["status"];
				}
				else $fields[$field] = $file["file"];
			}
			
			continue;
		}//file
		
		$fields[$field] = $default;
		if(isset($_POST[$field]))
		{
			if(is_array($_POST[$field])) $fields[$field] =  join(",", $_POST[$field]);
			elseif(trim($_POST[$field]) != "")
			{
				$value = trim($_POST[$field]);
				$fields[$field] = $fieldParams["type"] == "editor" ? addslashes($value) : htmlspecialchars($value, ENT_QUOTES);
				if($fieldParams["type"] == "text_list") $fields[$field] = join(",", array_unique(array_filter(array_map("trim", explode(",", $fields[$field])), "strlen")));
			}
		}
		
		if(isset($fieldParams["generate"]))
		{
			$fields[$field] = $fields[$field] ? $fields[$field] : $fields[$fieldParams["generate"]];
			$fields[$field] = $this->sessionModel->generateURL($fields[$field], $id, $workTable, $field);
		}
	}
	
	$required = array();
	foreach($formFields as $field => $fieldParams)
	{
		if(array_key_exists("required", $fieldParams) && !$fields[$field])
		{
			$required[] = array_key_exists("name", $fieldParams) ? $fieldParams["name"] : ucfirst($field);
		}
	}
				
	if(!empty($required))
	{
		$hasError = true;
		$status .= ($status ? "<br />" : "") . "Required fields are missing: " . join(", ", $required) . ".";
	}


?>