<?php

	////
	// this acts as a generic class for all models (not abstract)
	//
	class FJF_BASE_RICH
	{
		public $status = "";

		public static function db($db = null){
			FJF_BASE::set_db($db);
		}//db

		public function error($message = "")
		{
			$this->status = $message;
			return false;
		}//error

		public function success($message = "")
		{
			$this->status = $message;
			return true;
		}//success

		public function status()
		{
			$message = $this->status;
			$this->status = "";
			return $message;
		}//success

		public static function getRecordInfo($table = "", $recordID = 0, $primaryKey = "id")
		{
			return FJF_BASE_RICH::getRecord($table, "PRIMARY_KEY='RECORD_ID'", array("PRIMARY_KEY" => $primaryKey, "RECORD_ID" => $recordID));
		} // /getRecordInfo()
		public static function getRecordBy($q="",$w=0,$e="id"){return FJF_BASE_RICH::getRecordInfo($q,$w,$e);}


		public static function getRecord($table = "", $where = "", $whereParams = null)
		{
			$record = null;

			if (FJF_BASE::db_open() && $table != "")
			{
				$record = FJF_BASE::db_get_one($table, FJF_BASE::replace_params($where, $whereParams));
				FJF_BASE::db_close();
			}

			return $record;
		} // /getRecord()


		public static function getRecords($table = "", $where = "", $whereParams = null, $returnOne = false, $select = "*")
		{
			$sql = "SELECT " . $select . " FROM " . $table . ($where ? " WHERE " . $where : "");
			return FJF_BASE_RICH::selectRecords($sql, $whereParams, $returnOne);
		} // /getRecords()

		public static function getFrom($table = "", $where = "", $whereParams = null, $returnOne = false, $select = "*")
		{
			return FJF_BASE_RICH::getRecords($table, $where, $whereParams, $returnOne, $select);
		} // /getFrom()

		public static function countFrom($table = "", $where = "", $whereParams = null)
		{
			$sql = "SELECT COUNT(id) cid FROM " . $table . ($where ? " WHERE " . $where : "");
			return FJF_BASE_RICH::getCount($sql, $whereParams);
		} // /countFrom()

		public static function getCount($sql, $whereParams = null, $f = "cid")
		{
			return ($result = FJF_BASE_RICH::selectRecords($sql, $whereParams, true)) ? $result->$f : 0;
		} // /getCount()

		public static function selectRecords($sql, $whereParams = null, $returnOne = false)
		{
			$result = null;

			if (FJF_BASE::db_open() && $sql != "")
			{
				if(($result = FJF_BASE::db_get_many(FJF_BASE::replace_params($sql, $whereParams))) && $returnOne) $result = $result[0];
				FJF_BASE::db_close();
			}

			return $result;
		} // /selectRecords()


		public static function saveRecord($table = "", $data, $key = "id", $key2 = null)
		{
			$result = null;

			if (FJF_BASE::db_open())
			{
				if(isset($data[$key]))
				{
					$result = FJF_BASE::db_update($table, $data, $key . "='" . FJF_BASE::db_escape($data[$key]) . "'" . ($key2 ? " AND " . $key2 . "='" . FJF_BASE::db_escape($data[$key2]) . "'" : ""));
				}else
				{
					$result = FJF_BASE::db_insert($table, $data, $key);
				}
				FJF_BASE::db_close();
			}

			return $result;
		} // /saveRecord()

		public static function replaceRecord($table, $data)
		{
			$result = null;

			if (FJF_BASE::db_open())
			{
				$result = FJF_BASE::db_replace($table, $data);
				FJF_BASE::db_close();
			}

			return $result;
		} // /replaceRecord()

		public static function deleteRecord($table = "", $recordID = 0, $primaryKey = "id")
		{
			return FJF_BASE_RICH::deleteRecords($table, "PRIMARY_KEY='RECORD_ID'", array("PRIMARY_KEY" => $primaryKey, "RECORD_ID" => $recordID));
		} // /deleteRecord()

		public static function deleteRecords($table = "", $where, $whereParams = null)
		{
			$result = null;

			if (FJF_BASE::db_open() && $table != "")
			{
				$result = FJF_BASE::db_execute(FJF_BASE::replace_params("DELETE FROM " . $table . " WHERE " . $where, $whereParams));
				FJF_BASE::db_close();
			}

			return $result;
		} // /deleteRecords()

		public static function updateRecords($table = "", $set, $where = "1", $whereParams = null)
		{
			$result = null;

			if (FJF_BASE::db_open() && $table != "")
			{
				$result = FJF_BASE::db_execute(FJF_BASE::replace_params("UPDATE " . $table . " SET " . $set . " WHERE " . $where, $whereParams));
				FJF_BASE::db_close();
			}

			return $result;
		} // /updateRecords()

		public static function executeQuery($sql, $whereParams = null)
		{
			$result = null;

			if (FJF_BASE::db_open() && $sql != "")
			{
				$result = FJF_BASE::db_execute(FJF_BASE::replace_params($sql, $whereParams));
				FJF_BASE::db_close();
			}

			return $result;
		} // /executeQuery()

		function parseXML($xml)
		{
			$xml = new SimpleXMLElement($xml);

			if($xml === false) return false;

			function parseXML($xml)
			{
				if(strlen(trim($xml.""))) $xml = $xml."";
				if(is_object($xml) && $xml->children())
				{
					$result = null;
					foreach($xml as $key => $value)
					{
						if(!isset($result[$key])) $result[$key] = parseXML($value);
						else
						{
							if(!isset($result[$key][0])) $result[$key] = array($result[$key]);
							$result[$key][] = parseXML($value);
						}
					}
					return $result;
				}
				return trim($xml."");
			}//parseXML

			return parseXML($xml);
		}//parseXML

		public static function generateURL($text, $id, $table, $field = "url_title", $delim = "-")
		{
			$text = trim(preg_replace("/[^" . $delim . "A-Za-z0-9]+/",$delim,strtolower($text)), $delim);
			if($similarURLs = FJF_BASE_RICH::getRecords($table, $field . " REGEXP '^(" . $text . "|" . $text . $delim . "[[:digit:]]+)$'", null, null, "id, " . $field))
			{
				foreach($similarURLs as $k => $v)
				{
					$n = str_replace(array($text, $delim), "", $v->$field);
					//if($id > 0 && $v->id == $id) return $text .= $delim . $n;
					if($id > 0 && $v->id == $id) return $v->$field;
					$similarURLs[$k] = $n;
				}
				$similarURLs = array_map("intval", $similarURLs);
				sort($similarURLs, SORT_NUMERIC);
				$text .= $delim . (array_pop($similarURLs) + 1);
			}
			return $text;
		}//generateURL


	}
?>