<?php
	/**
	* Web Application Command Definition
	*/

	abstract class FJF_CMD
	{
		/** main command logic */
		public abstract function execute();

		/** checks for ajax requests. return true - if the page was requested via ajax **/
		public function isAjax()
		{
			return (isset($_SERVER['HTTP_X_REQUESTED_WITH']) && ($_SERVER['HTTP_X_REQUESTED_WITH'] == 'XMLHttpRequest'));
		}

		/** displays smarty template */
		protected function displayTemplate($template, $params)
		{
			if (file_exists($GLOBALS["WEB_APPLICATION_CONFIG"]["templates_path"]))
			{
				FJF_BASE::log("Displaying template '$template'", __METHOD__);
				if(is_array($params)) $params["cmd"] = $GLOBALS["REQUEST_CONTAINER"]["cmd"];
				$GLOBALS["smartyEngine"]->assign("parameters", $params);
				$GLOBALS["smartyEngine"]->display($template);
			} else
			{
				FJF_BASE::log("Template '$template' doesn't exist", __METHOD__);
			}
		}


		/** publishes smarty template */
		protected function publishTemplate($publishFilePath, $template, $params)
		{
			if (file_exists($GLOBALS["WEB_APPLICATION_CONFIG"]["templates_path"]))
			{
				FJF_BASE::log("Fetching template '$template'", "publishTemplate");
				$GLOBALS["smartyEngine"]->assign("parameters", $params);

				$file = $GLOBALS["smartyEngine"]->fetch($template);

				if($fp = @fopen($publishFilePath, "w"))
				{

					$result = @fputs($fp,$file);
					if($result)
					{
						return true;
					} else
					{
						FJF_BASE::log("Cannot write to '$publishFilePath'", "publishTemplate");
					}

					@flose($fp);

				} else
				{
					FJF_BASE::log("File '$publishFilePath' is not writable", "publishTemplate");
				}

			} else
			{
				FJF_BASE::log("Template '$template' doesn't exist", "publishTemplate");
			}
		} // end publishTemplates
		
		/** fetch smarty template */
    protected function fetchTemplate($template, $params)
    {
      if (file_exists($GLOBALS["WEB_APPLICATION_CONFIG"]["templates_path"]))
      {
        FJF_BASE::log("Displaying template '$template'", __METHOD__);
        if(is_array($params)) $params["cmd"] = $GLOBALS["REQUEST_CONTAINER"]["cmd"];
        $GLOBALS["smartyEngine"]->assign("parameters", $params);
        return $GLOBALS["smartyEngine"]->fetch($template);
      } else
      {
        FJF_BASE::log("Template '$template' doesn't exist", __METHOD__);
      }
    }

	}
?>