<?php

	/*
	* SMARTY FUNCTIONS DEFINITION
	*/

	$smartyEngine->register_block("is_admin","smarty_is_admin");
	$smartyEngine->register_block("not_admin","smarty_not_admin");
	$smartyEngine->register_function("percent_from","smarty_percent_from");
	$smartyEngine->register_function("random","smarty_random");
	$smartyEngine->register_function("display_stars","smarty_display_stars");
	$smartyEngine->register_function("phptojs","php_to_js");
	$smartyEngine->register_function("seo_controller","smarty_seo_controller");
	$smartyEngine->register_function("time_left","smarty_time_left");
	$smartyEngine->register_function("age","smarty_age");
	$smartyEngine->register_function("seccondstotime","smarty_seccondstotime");
  $smartyEngine->register_function("state_drop_down","smarty_state_drop_down");
  $smartyEngine->register_function("province_drop_down","smarty_province_drop_down");
	$smartyEngine->register_function("months_drop_down", "smarty_months_drop_down");
	$smartyEngine->register_modifier("price_format", "smarty_price_format");
	$smartyEngine->register_modifier("convert_to_percent", "smarty_convert_to_percent");

	/*
	* /SMARTY FUNCTIONS DEFINITION
	*/
	
	
	////
	// returns number
	//
	function smarty_price_format($price, $exchange = '', $decimals = 2)
	{
		$pennyExchanges = $GLOBALS["WEB_APPLICATION_CONFIG"]["penny_exchanges"]["exchanges"];
		$pennyDecimals = $GLOBALS["WEB_APPLICATION_CONFIG"]["penny_exchanges"]["decimals"];
		$exchanges =  array_merge($pennyExchanges, array_keys($pennyExchanges));
		$decimals = (in_array(strtoupper($exchange), $exchanges)) ? $pennyDecimals : $decimals;
		return number_format($price, $decimals, '.', ' ');
	}
	
	function smarty_convert_to_percent($value)
	{
		$result = floatval($value)*100;
		return $result;
	}


	function smarty_is_admin($params, $content, &$smarty, &$repeat)
	{
		$_content = preg_replace("/\<[Aa][^\>]*\>/", '<span title="Access Denied"><img src="/img/admin/lock.png" alt="" title="" width="7" height="10" /> ', $content);
		$_content = preg_replace("/\<\/[Aa]\>/", "</span>", $_content);
		$isAdmin = isset($_SESSION["user"]) && $_SESSION["user"] ? $_SESSION["user"]->is_admin : 0;
		$tool = isset($params["tool"]) ? $params["tool"] : $smarty->_tpl_vars["web_config"][$smarty->_tpl_vars["parameters"]["cmd"]]["tool_id"];
		return !$isAdmin || ($tool && $isAdmin == 1 && !in_array($tool, $_SESSION["user"]->permissions)) ? $_content : $content;
	}// end function smarty_is_admin



	function smarty_not_admin($params, $content, &$smarty, &$repeat)
	{
		$isAdmin = isset($_SESSION["user"]) && $_SESSION["user"] ? $_SESSION["user"]->is_admin : 0;
		$tool = isset($params["tool"]) ? $params["tool"] : $smarty->_tpl_vars["web_config"][$smarty->_tpl_vars["parameters"]["cmd"]]["tool_id"];
		return !$isAdmin || ($tool && $isAdmin == 1 && !in_array($tool, $_SESSION["user"]->permissions)) ? $content : "";
	}// end function smarty_not_admin



	function smarty_percent_from($params)
	{
		$from = $params["from"];
		$value = $params["value"];

		if ($from > 0)
		{
			$result = $value / ($from / 100);
		}
		else
		{
			$result = 0;
		}

		//$return = sprintf("%01.2f", $result);
		$return = round($result);

		return $return;

		//return sprintf("%01.2f", $result);
	} // end function smarty_percent_from



	////
	// returns random number
	//
	function smarty_random($params)
	{
		$randomNumber = "";

		$min = (array_key_exists("min", $params) && intval($params["min"]) >= 0) ? intval($params["min"]) : 0;
		$max = (array_key_exists("max", $params) && intval($params["max"]) > 0) ? intval($params["max"]) : 10000;

		$randomNumber = rand($min, $max);

		return $randomNumber;
	}


	////
	// returns html
	//
	function smarty_display_stars($params)
	{
		$rate = floatval($params["rate"]);

		$empty = '<img id="star5" src="/img/stars/star_medium_empty.gif" width="18" height="19" alt="" title="" />';
		$half = '<img id="star4" src="/img/stars/star_medium_half.gif" width="18" height="19" alt="" title="" />';
		$full = '<img id="star1" src="/img/stars/star_medium_full.gif" width="18" height="19" alt="" title="" />';

		if($rate >= 0 && $rate < 0.5) $html = $empty . $empty . $empty . $empty . $empty;
		if($rate >= 0.5 && $rate <= 0.75) $html = $half . $empty . $empty . $empty . $empty;
		if($rate > 0.75 && $rate < 1.5) $html = $full . $empty . $empty . $empty . $empty;
		if($rate >= 1.5 && $rate <= 1.75) $html = $full . $half . $empty . $empty . $empty;
		if($rate > 1.75 && $rate < 2.5) $html = $full . $full . $empty . $empty . $empty;
		if($rate >= 2.5 && $rate <= 2.75) $html = $full . $full . $half . $empty . $empty;
		if($rate > 2.75 && $rate < 3.5) $html = $full . $full . $full . $empty . $empty;
		if($rate >= 3.5 && $rate <= 3.75) $html = $full . $full . $full . $half . $empty;
		if($rate > 3.75 && $rate < 4.5) $html = $full . $full . $full . $full . $empty;
		if($rate >= 4.5 && $rate <= 4.75) $html = $full . $full . $full . $full . $half;
		if($rate > 4.75 && $rate <= 5) $html = $full . $full . $full . $full . $full;

		return $html;
	}//smarty_display_stars


	function php_to_js($params)
	{
		if(!isset($params["var"]) || !isset($params["value"])) return false;
		$var = $params["var"];
		$value = $params["value"];

		$patterns[] = "/\\\/";
		$patterns[] = "/\'/";
		$patterns[] = "/\r\n/";
		$patterns[] = "/\n/";
		$replacements[] = "\\\\\\";
		$replacements[] = "\'";
		$replacements[] = "\\r\\n";
		$replacements[] = "\\n";

		return "<script>" . $var . "=unserialize('" . preg_replace($patterns, $replacements, FJF_BASE::serialize($value)) . "');</script>";
	}//php_to_js

	function smarty_seo_controller($params, &$smarty)
	{
		$function = '@list($result["id"], $result["mask"], $result["text"]';
		$function .= ', $result["meta_title"], $result["meta_keywords"], $result["meta_description"], $result["extra_header_tags"], $result["pixel_top"], $result["pixel_bottom"]';
		$function .= ') = explode("\t", $v);';
		$function .= 'return $result;';
		
		$data = file($GLOBALS["WEB_APPLICATION_CONFIG"]["app_web_path"] . "/includes/global_seo_controller.txt");
		$data = array_map("trim", $data);
		$data = array_map(create_function('$v', $function), $data);

		$request = preg_replace("/\#.+$/", "", $_SERVER["REQUEST_URI"]);
		$request = explode("?", $request);
		$url = trim($request[0], "/");

		$pattern = array("/", "*");
		$replacement = array("\/", "[^\/]+");

		foreach($data as $item)
		{
			$mask = addslashes(trim($item["mask"], "/"));
			$regExp = "/^" . str_replace($pattern, $replacement, $mask) . "$/";
			if($mask == "*") $item["is_main"] = true;
			if(preg_match($regExp, $url)) break;
		}
		$item["footer_text"] = &$item["text"];
		
		$find = array("\\n", "\\t");
		$replace = array("\n", "\t");
		
		$item["extra_header_tags"] = str_replace($find, $replace, $item["extra_header_tags"]);
		$item["pixel_top"] = str_replace($find, $replace, $item["pixel_top"]);
		$item["pixel_bottom"] = str_replace($find, $replace, $item["pixel_bottom"]);
			
		return $smarty->assign("seo_controller", $item);
	}//smarty_seo_controller


	function smarty_time_left($params)
	{
		$arr = time_left_arr($params["date"]);
		$age = $arr["y"] ? $arr["y"] . " Year" . ($arr["y"] > 1 ? "s" : "") : "";
		$age .= ($age ? " " : "") . ($arr["m"] ? $arr["m"] . " Month" . ($arr["m"] > 1 ? "s" : "") : "");
		$age .= ($age ? " " : "") . ($arr["d"] ? $arr["d"] . " Day" . ($arr["d"] > 1 ? "s" : "") : "");
		$age .= ($age ? " " : "") . ($arr["h"] ? $arr["h"] . " Hour" . ($arr["h"] > 1 ? "s" : "") : "");
		//$age .= ($age ? " " : "") . ($arr["i"] ? $arr["i"] . " Minute" . ($arr["i"] > 1 ? "s" : "") : "");
		//$age .= ($age ? " " : "") . ($arr["s"] ? $arr["s"] . " Second" . ($arr["s"] > 1 ? "s" : "") : "");

		return $age ? $age : "Less Than 1 Hour";
	}//end function smarty_time_left

	function smarty_age($params)
	{
		$arr = time_left_arr($params["date"]);
		return $arr["y"];
	}//smarty_age

	function time_left_arr($start)
	{
		$current = time_to_arr(time());
		$start = time_to_arr(strtotime($start));


		if(!isset($GLOBALS["days_in_a_previous_month"]))
		{
			/*start at 0 some as 12*/
			$mnt = array(31, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30);
			if($current["m"] - 1 == 2 && ($current["y"]%400 == 0 || $current["y"]%4 == 0 && $current["y"]%100 != 0)) $mnt[2] = 29;
			$GLOBALS["days_in_a_previous_month"] = $mnt[$current["m"] - 1];
		}

		$times = array(
										"s" => array(60, "i"),
										"i" => array(60, "h"),
										"h" => array(24, "d"),
										"d" => array($GLOBALS["days_in_a_previous_month"], "m"),
										"m" => array(12, "y")
										);

		foreach($current as $k => $v) $arr[$k] = $v - $start[$k];
		foreach($arr as $k => $v) if($v < 0) $arr[$times[$k][1]]--;
		foreach($arr as $k => $v) if($v < 0) $arr[$k] += $times[$k][0];
		return $arr;
	}//time_left_arr

	function time_to_arr($time)
	{
		list($arr["y"], $arr["m"], $arr["d"], $arr["h"], $arr["i"], $arr["s"]) = explode("-", date("Y-m-d-H-i-s", $time));
		return array_map("intval", $arr);
	}//time_to_arr

	function smarty_seccondstotime($params){
		$t = ltrim(date("H:i:s", mktime(0, 0, intval($params["s"]))), "0:");
		return $t ? $t : "0";
	}//smarty_seccondstotime
	
	  function smarty_state_drop_down($params){
    $statesContainer = array(
                              "AK" => "Alaska",
                              "AL" => "Alabama",
                              "AR" => "Arkansas",
                              "AZ" => "Arizona",
                              "CA" => "California",
                              "CO" => "Colorado",
                              "CT" => "Connecticut",
                              "DC" => "District of Columbia",
                              "DE" => "Delaware",
                              "FL" => "Florida",
                              "GA" => "Georgia",
                              "HI" => "Hawaii",
                              "IA" => "Iowa",
                              "ID" => "Idaho",
                              "IL" => "Illinois",
                              "IN" => "Indiana",
                              "KS" => "Kansas",
                              "KY" => "Kentucky",
                              "LA" => "Louisiana",
                              "MA" => "Massachusetts",
                              "MD" => "Maryland",
                              "ME" => "Maine",
                              "MI" => "Michigan",
                              "MN" => "Minnesota",
                              "MO" => "Missouri",
                              "MS" => "Mississippi",
                              "MT" => "Montana",
                              "NC" => "North Carolina",
                              "ND" => "North Dakota",
                              "NE" => "Nebraska",
                              "NH" => "New Hampshire",
                              "NJ" => "New Jersey",
                              "NM" => "New Mexico",
                              "NV" => "Nevada",
                              "NY" => "New York",
                              "OH" => "Ohio",
                              "OK" => "Oklahoma",
                              "OR" => "Oregon",
                              "PA" => "Pennsylvania",
                              "RI" => "Rhode Island",
                              "SC" => "South Carolina",
                              "SD" => "South Dakota",
                              "TN" => "Tennessee",
                              "TX" => "Texas",
                              "UT" => "Utah",
                              "VA" => "Virginia",
                              "VT" => "Vermont",
                              "WA" => "Washington",
                              "WI" => "Wisconsin",
                              "WV" => "West Virginia",
                              "WY" => "Wyoming",
                              "NU" => "Non-US"
                              );

    $fieldName = (array_key_exists("field_name", $params) && trim($params["field_name"]) != "") ? trim($params["field_name"]) : "state";
    $multiple = (array_key_exists("multiple", $params) && trim($params["multiple"]) != "") ? $params["multiple"] : false;
    $selected_state = (array_key_exists("selected_state", $params) && trim($params["selected_state"]) != "") ? $params["selected_state"] : "";
    $selected_state = ($selected_state != null && is_string($selected_state))?preg_split("/[\s]*[,][\s]*/", $selected_state): $selected_state;
    $attr = (array_key_exists("attr", $params) && trim($params["attr"]) != "") ? $params["attr"] : false;

    $statesData = '<select name="'.$fieldName .(($multiple)?'[]':'');
    $statesData .= '" class="input_select" ';
    $statesData .=  (($multiple)?'multiple="multiple" size="10" ':'');
    $statesData .=  ' style="width:220px;" ';
    $statesData .=  ($attr ? $attr : '') . '>' . "\n";
    $statesData .= '<option value="">State</option>' . "\n";

    foreach($statesContainer as $key => $value){
      $statesData .= '<option value="' . $key . '"';
      if($selected_state && is_array($selected_state)){
        $statesData .= ( in_array($key, $selected_state)) ? " selected='selected'" : "";
      }
      else{
        $statesData .= ( $selected_state == $key) ? " selected='selected'" : "";
      }
      $statesData .= '>' . $value . '</option>' . "\n";
    }
    $statesData .= '</select>' . "\n";
    return $statesData;
  }
  
  function smarty_province_drop_down($params){
    $provincesContainer = array(
			"AB" => "Alberta",
			"BC" => "British Columbia",
			"MB" => "Manitoba",
			"NB" => "New Brunswick",
			"NL" => "Newfoundland and Labrador",
			"NS" => "Nova Scotia",
			"ON" => "Ontario",
			"PE" => "Prince Edward Island",
			"QC" => "Quebec",
			"SK" => "Saskatchewan",
			"NT" => "Northwest Territories",
			"NU" => "Nunavut",
			"YT" => "Yukon",
		);

    $fieldName = (array_key_exists("field_name", $params) && trim($params["field_name"]) != "") ? trim($params["field_name"]) : "province";
    $multiple = (array_key_exists("multiple", $params) && trim($params["multiple"]) != "") ? $params["multiple"] : false;
    $selected_province = (array_key_exists("selected_province", $params) && trim($params["selected_province"]) != "") ? $params["selected_province"] : "";
    $selected_province = ($selected_province != null && is_string($selected_province))?preg_split("/[\s]*[,][\s]*/", $selected_province): $selected_province;
		$w = (array_key_exists("width_select", $params) && intval($params["width_select"])) ? intval($params["width_select"]) : 0;
		$class = (array_key_exists("class", $params) && trim($params["class"]) != "") ? $params["class"] : false;
		$attr = (array_key_exists("attr", $params) && trim($params["attr"]) != "") ? $params["attr"] : false;
    $provincesData = '<select id="' . $fieldName;
    $provincesData .= '" name="'.$fieldName .(($multiple)?'[]':'');
    $provincesData .= '" class="input_select'. (($class)?' '.$class : '') .'" ';
    $provincesData .=  (($multiple)?'multiple="multiple" size="10" ':'');
    $provincesData .=  ' style="width:' . ($w ? $w : 220) . 'px;" ';
		$provincesData .=  ($attr ? $attr : '') . '>' . "\n";
    $provincesData .= '<option value="">Province</option>' . "\n";

    foreach($provincesContainer as $key => $value){
      $provincesData .= '<option value="' . $key . '"';
      if($selected_province && is_array($selected_province)){
        $provincesData .= ( in_array($key, $selected_province)) ? " selected='selected'" : "";
      }
      else{
        $provincesData .= ( $selected_province == $key) ? " selected='selected'" : "";
      }
      $provincesData .= '>' . $value . '</option>' . "\n";
    }
    $provincesData .= '</select>' . "\n";

    return $provincesData;
  }//smarty_province_drop_down
  
    ////
  // Months Drop-Down
  // @param array $formFields - form fields hashmap (POST/GET)
  // @return string
  //
  function smarty_months_drop_down($params)
  {
    //months data
    $monthsContainer = array(
    	"01" => "January",
    	"02" => "February",
    	"03" => "March",
    	"04" => "April",
    	"05" => "May",
    	"06" => "June",
    	"07" => "July",
    	"08" => "August",
    	"09" => "September",
    	"10" => "October",
    	"11" => "November",
    	"11" => "December"
		);

    $fieldName = (array_key_exists("field_name", $params) && trim($params["field_name"]) != "") ? trim($params["field_name"]) : "month";

    $monthsData = '<select id="' . $fieldName . '" name="' . $fieldName . '">'. "\n";
    $monthsData .= '<option value="">Month</option>' . "\n";

    foreach ($monthsContainer as $key => $value)
    {
      $monthsData .= '<option value="' . $key . '"';
      $monthsData .= (array_key_exists("selected_month", $params) && $params["selected_month"] == $key) ? " selected='selected'" : "";
      $monthsData .= '>' . $value . '</option>' . "\n";
    }
    $monthsData .= '</select>' . "\n";

    return $monthsData;
  }

?>
