<?php

	class AdminBlogsModel extends FJF_BASE_RICH
	{

		function getBlogs($where = null, $whereParams = null, $order = null, $limit = null)
		{
			$sql = "";
			$sql .= "SELECT b.*";
			$sql .= ", COUNT(e.id) entries_count";
			$sql .= " FROM blogs b";
			$sql .= " LEFT JOIN blogs_entries e ON b.id = e.blog_id";
			if ($_SESSION["user"]->is_admin < 2) $sql .= " WHERE b.admins_ids RLIKE '[[:<:]]" . $_SESSION["user"]->id . "[[:>:]]'";
			else $sql .= " WHERE 1";
			if($where) $sql .= " AND " . $where;
			$sql .= " GROUP BY b.id";
			$sql .= " ORDER BY " . ($order ? $order : "b.name");
			if($limit) $sql .= " LIMIT " . $limit;
			return $result = $this->selectRecords($sql, $whereParams);
		}//getBlogs
		
		function getCategories($where = null, $whereParams = null, $order = null, $limit = null)
		{
			$sql = "SELECT c.id, c.blog_id, c.title, c.url_title";
			$sql .= ", c.meta_title, c.meta_description, c.meta_keywords";
			$sql .= ", b.name blog_name";
			$sql .= " FROM blogs_categories c";
			$sql .= " LEFT JOIN blogs b ON b.id = c.blog_id";
			if ($_SESSION["user"]->is_admin < 2) $sql .= " WHERE b.admins_ids RLIKE '[[:<:]]" . $_SESSION["user"]->id . "[[:>:]]'";
			else $sql .= " WHERE 1";
			if($where) $sql .= " AND " . $where;
			$sql .= " GROUP BY c.id";
			$sql .= " ORDER BY " . ($order ? $order : "c.title");
			if($limit) $sql .= " LIMIT " . $limit;
			return $result = $this->selectRecords($sql, $whereParams);
		}//getCategories

		function getEntries($where = null, $whereParams = null, $order = null, $limit = null)
		{
			$sql = "";
			$sql .= "SELECT e.*";
			$sql .= ", b.name blog_name, b.url_title blog_url";
			$sql .= ", CONCAT(u.first_name, ' ', u.last_name) username";
			$sql .= " FROM blogs_entries e";
			$sql .= " LEFT JOIN blogs b ON e.blog_id=b.id";
			$sql .= " LEFT JOIN users u ON e.user_id=u.id";
			if ($_SESSION["user"]->is_admin < 2) $sql .= " WHERE b.admins_ids RLIKE '[[:<:]]" . $_SESSION["user"]->id . "[[:>:]]'";
			else $sql .= " WHERE 1";
			if($where) $sql .= " AND " . $where;
			$sql .= " GROUP BY e.id";
			$sql .= " ORDER BY " . ($order ? $order : "e.datetime DESC");
			if($limit) $sql .= " LIMIT " . $limit;
			return $result = $this->selectRecords($sql);
		}//getEntries
		
		function getEntriesCategories($where = null, $whereParams = null, $order = null, $limit = null)
		{
			$sql = "SELECT c.id, c.blog_id, c.title, c.url_title";
			$sql .= ", c.meta_title, c.meta_description, c.meta_keywords";
			$sql .= ", b.name blog_name";
			$sql .= " FROM blogs_entries_categories c";
			$sql .= " LEFT JOIN blogs b ON b.id = c.blog_id";
			if ($_SESSION["user"]->is_admin < 2) $sql .= " WHERE b.admins_ids RLIKE '[[:<:]]" . $_SESSION["user"]->id . "[[:>:]]'";
			else $sql .= " WHERE 1";
			if($where) $sql .= " AND " . $where;
			$sql .= " GROUP BY c.id";
			$sql .= " ORDER BY " . ($order ? $order : "c.title");
			if($limit) $sql .= " LIMIT " . $limit;
			return $result = $this->selectRecords($sql, $whereParams);
		}//getEntriesCategories

	}

?>