<?php
  class AdminReportsModel extends FJF_BASE_RICH
  {
                        
	   static $datePeriod = array(
	   	"today" => "today", 
	   	"yesterday" => "yesterday", 
	   	"this_week" => "this week",
	   	"last_week" => "last week",  
	   	"this_month" => "this month", 
	   	"last_month" => "last month", 
	   	"this_year" => "this year",
	   	"last_year" => "last year",
	   	"custom" => "custom"
	  );
                            
     static function getCustomDate($period, $name){
      $params = array();
      if($period){
      	$dateFrom = null;
        $dateTo = null;
        switch($period){
          case "today":
            $dateFrom = date("Y-m-d")." 00:00:00";
            $dateTo = date("Y-m-d")." 23:59:59";
            break;
          case "yesterday":
            $dateFrom = date("Y-m-d", mktime(0, 0, 0, date("m"), date("d")-1, date("Y")))." 00:00:00";
            $dateTo = date("Y-m-d", mktime(0, 0, 0, date("m"), date("d")-1, date("Y")))." 23:59:59";
            break;
          case "this_week":
            $dateFrom = date("Y-m-d", strtotime('this week'))." 00:00:00";
            $dateTo = date("Y-m-d")." 23:59:59";
            break;
          case "last_week":
            $dateFrom = date("Y-m-d", strtotime('last week'))." 00:00:00";
            $dateTo = date("Y-m-d", strtotime('last Sunday'))." 23:59:59";
            break;
          case "this_month":
            $dateFrom = date("Y-m-d", mktime(0, 0, 0, date("m"), 1, date("Y")))." 00:00:00";
            $dateTo = date("Y-m-d")." 23:59:59";
            break;
          case "last_month":
            $dateFrom = date("Y-m-d", mktime(0, 0, 0, date("m")-1, 1, date("Y")))." 00:00:00";
            $dateTo = date("Y-m-d", mktime(0, 0, 0, date("m"), 0, date("Y")))." 23:59:59";
            break;
          case "this_year":
            $dateFrom = date("Y-m-d", mktime(0, 0, 0, 1, 1, date("Y")))." 00:00:00";
            $dateTo = date("Y-m-d")." 23:59:59";
            break;
          case "last_year":
            $dateFrom = date("Y-m-d", mktime(0, 0, 0, 1, 1, date("Y")-1))." 00:00:00";
            $dateTo = date("Y-m-d", mktime(0, 0, 0, 12, 31, date("Y")-1))." 23:59:59";
            break;
          default:
            $dateFrom = isset($_REQUEST["custom_date"][$name]["date_from"]) && $_REQUEST["custom_date"][$name]["date_from"] ? strtotime($_REQUEST["custom_date"][$name]["date_from"]) : "";
            $dateTo = isset($_REQUEST["custom_date"][$name]["date_to"]) && $_REQUEST["custom_date"][$name]["date_to"] ? strtotime($_REQUEST["custom_date"][$name]["date_to"]) : "";
            $dateFrom = $dateFrom ? date("Y-m-d", $dateFrom). " 00:00:00" : null;
            $dateTo = $dateTo ? date("Y-m-d", $dateTo). " 23:59:59" : null;
        }
        $params = array("date_from" => $dateFrom, "date_to" => $dateTo);
      }
      return $params;
     }
                            
     static function exportRecords($records, $name = "records"){
       if($records){
        header('Content-type: application/csv');
        header('Content-Disposition: attachment; filename="'.$name.'-' . date("YmdHis") . '.csv"');
        $csv = array();
        foreach($records as $i => $record){
          $record = get_object_vars($record);
          $q = "{%QUOTE%}";
          if(!$i){
            $names = array_keys($record);
            foreach($names as $key => $value){
            	$names[$key] = ucwords(str_replace('_',' ',$value));
            }
            $csv[] = $q . implode($q . "," . $q, $names) . $q;
          }
          $csv[] = htmlspecialchars_decode($q . implode($q . "," . $q, $record) . $q, ENT_QUOTES);
        }
				//$csv[] = $q . implode($q . "," . $q, array('Total:', count($records))) . $q;
        exit(implode("\n", str_replace(array('"', $q), array('""', '"'), $csv)));
       }
       return null;
     }
  }
?>