<?php

  class AlertsModel extends FJF_BASE_RICH
  {
        
    function addAlert($fields, $fields2)
    {
      $result = false;
      if ($alertID = $this->saveRecord("alerts", $fields))
      {
        $fields2['alert_id'] = $alertID;
        $fields2['end_date'] = (isset($fields2['timeframe_id'])) ? $this->getEndDate($fields2['timeframe_id']) : "0000-00-00 00:00:00";
        if ($infoID = $this->saveRecord("alerts_info", $fields2))
        {
          if($this->updateRecords("alerts", "info_id=".$infoID,"id=".$alertID))
          {
            $result = $alertID;
          }
        }
      }
      return $result;
    }
    
    function editAlert($fields, $isChanges = true)
    {
    	if(!$isChanges) return true;
      $result = false;
      $fields['end_date'] = (isset($fields['timeframe_id'])) ? $this->getEndDate($fields['timeframe_id']) : "0000-00-00 00:00:00";
      if (($infoID = $this->saveRecord("alerts_info", $fields)) && isset($fields['alert_id']))
      {
        if($this->updateRecords("alerts", "status=1, info_id=".$infoID,"id=".$fields['alert_id']))
        {
          $result = true;
        }
      }
      return $result;
    }
		
		function checkEditAlert($record, $fields, $skip = array()){
			$result = true;
			if ($record && is_array($fields)){
				$result = false;
				foreach($record as $key=>$value){
					if (isset($fields[$key]) && !in_array($key, $skip) && $fields[$key] != $value){
						$result = true;
						break;
					}
				}
			}
			return $result;
		}
    
    function getEndDate($timeframeID)
    {
      switch ($timeframeID) {
        case 1:
            $date = date('Y-m-d H:i:s', strtotime('+ 1 minute'));
            break;
        case 2:
            $date = date('Y-m-d H:i:s', strtotime('+ 5 minute'));
            break;
        case 3:
            $date = date('Y-m-d H:i:s', strtotime('+ 15 minute'));
            break;
        case 4:
            $date = date('Y-m-d H:i:s', strtotime('+ 30 minute'));
            break;
        case 5:
            $date = date('Y-m-d H:i:s', strtotime('+ 60 minute'));
            break;
        case 6:
            $date = date('Y-m-d H:i:s', strtotime('today') + 16 * 60 *60);
            break;
        case 7:
            $date = date('Y-m-d H:i:s', strtotime('tomorrow') + 16 * 60 * 60);
            break;
        case 8:
            $date = date('Y-m-d H:i:s', strtotime('+ 1 week'));
            break;
        case 9:
            $date = date('Y-m-d H:i:s', strtotime('+ 1 month'));
            break;
				case 11:
            $date = date('Y-m-d H:i:s', strtotime('tomorrow') + 8 * 60 * 60 - 60);
            break;
        default:
          $date = "0000-00-00 00:00:00";
      }
      return $date;
    }
    
    function removeAlert($id)
    {
      $result = false;
      if ($result = $this->deleteRecord("alerts", $id))
      {
        $this->deleteRecords("alerts_info", "alert_id=ALERT_ID", array("ALERT_ID" => $id));
      }
      return $result;
    }
    
    function getAlerts($where = null, $params = null, $limit = null, $order = null, $fields = null)
    {
      $sql = "SELECT ". ($fields ? $fields :"a.id, a.info_id, ai.type_id_1, ai.operation_id_1, ai.value_1, ai.operation, ai.type_id_2, ai.operation_id_2, ai.value_2, ai.timeframe_id, ai.end_date, a.stock_id, a.prediction_id, a.status");
      $sql .= " FROM alerts a";
      $sql .= " LEFT JOIN alerts_info ai ON a.info_id = ai.id";
      $sql .= " LEFT JOIN users u ON a.user_id = u.id";
      $sql .= " WHERE 1 ";
      $sql .= ($where) ? " AND ".$where : '';
      if ($order) $sql .= " ORDER BY ".$order;
      if ($limit) $sql .= " LIMIT ".$limit;
			$records = $this->selectRecords($sql, $params);
      return $records;
    }
    
    function getAlert($where = null, $params = null, $fields = null, $order = null)
    {
      $record = $this->getAlerts($where, $params, 1, $order, $fields);
      return ($record) ? $record[0] : null;
    }
    
    function getAlertsCount($where = null, $params = null, $fields  = null)
    {
      $result =  $this->getAlerts($where, $params, null, null, ($fields ? $fields :'COUNT(a.id) AS count'));
      return ($result) ? $result[0]->count : 0;
    }
    
    function getAlertHistory($where = null, $params = null, $limit = null, $order = null, $fields = null)
    {
      $sql = "SELECT ". ($fields ? $fields :"ai.*");
      $sql .= " FROM alerts_info ai";
      $sql .= " WHERE 1 ";
      $sql .= ($where) ? " AND ".$where : '';
      if ($order) $sql .= " ORDER BY ".$order;
      if ($limit) $sql .= " LIMIT ".$limit;
      $records = $this->selectRecords($sql, $params);
      return $records;
    }
    
    function getAlertsOperators($where = null, $params = null, $limit = null, $order = null, $fields = null)
    {
      $sql = "SELECT ". ($fields ? $fields :"ao.id, ao.title");
      $sql .= " FROM alerts_operators ao";
      $sql .= " WHERE 1 ";
      $sql .= ($where) ? " AND ".$where : '';
      if ($order) $sql .= " ORDER BY ".$order;
      if ($limit) $sql .= " LIMIT ".$limit;
      $GLOBALS["WEB_APPLICATION_CONFIG"]["FJF_BASE_key"] = "id";
      $records = $this->selectRecords($sql, $params);
      return $records;
    }
    
    function getAlertsTypes($where = null, $params = null, $limit = null, $order = null, $fields = null)
    {
      $sql = "SELECT ". ($fields ? $fields :"at.id, at.title");
      $sql .= " FROM alerts_types at";
      $sql .= " WHERE 1 ";
      $sql .= ($where) ? " AND ".$where : '';
      if ($order) $sql .= " ORDER BY ".$order;
      if ($limit) $sql .= " LIMIT ".$limit;
      $GLOBALS["WEB_APPLICATION_CONFIG"]["FJF_BASE_key"] = "id";
      $records = $this->selectRecords($sql, $params);
      return $records;
    }

    function getAlertsTimeframes($where = null, $params = null, $limit = null, $order = null, $fields = null)
    {
      $sql = "SELECT ". ($fields ? $fields :"atf.id, atf.title, atf.show");
      $sql .= " FROM alerts_timeframes atf";
      $sql .= " WHERE 1 ";
			if(time() > strtotime("today 4pm")) $sql .= " AND atf.id<>6";
      $sql .= ($where) ? " AND ".$where : '';
      if ($order) $sql .= " ORDER BY ".$order;
      if ($limit) $sql .= " LIMIT ".$limit;
      $GLOBALS["WEB_APPLICATION_CONFIG"]["FJF_BASE_key"] = "id";
      $records = $this->selectRecords($sql, $params);
      return $records;
    }
    
    function addAlertPrediction($fields, $fields2)
    {
      $result = false;
      if ($predictionID = $this->saveRecord("alerts_predictions", $fields))
      {
        if (is_array($fields2) && isset($fields2['timeframes']) && $fields2['timeframes'])
        {
          $record = array();
          $record['prediction_id'] = $predictionID;
          foreach ($fields2['timeframes'] as $id => $value)
          {
            $record['timeframe_id'] = $id;
            $record['end_date'] = $this->getEndDate($id);
            $record['prediction'] = $value;
            $this->saveRecord("alerts_predictions_timeframes", $record);
          }
        }
        $result = $predictionID;
      }
      return $result;
    }
    
    function getPredictionTimeframes($where = null, $params = null, $limit = null, $order = null, $fields = null)
    {
      $sql = "SELECT ". ($fields ? $fields :"apt.id, apt.prediction, ap.price, ap.ticker");
      $sql .= " FROM alerts_predictions_timeframes apt";
      $sql .= " LEFT JOIN alerts_predictions ap ON apt.prediction_id = ap.id";
      $sql .= " WHERE apt.correct = 0 ";
      $sql .= ($where) ? " AND ".$where : '';
      if ($order) $sql .= " ORDER BY ".$order;
      if ($limit) $sql .= " LIMIT ".$limit;
      $records = $this->selectRecords($sql, $params);
      return $records;
    }
    
    function cheakOpenAlertCount($userId, $limit = 100){
    	if($limit === null) return true;
      $count = $this->getTotalActiveAlertCount("a.user_id = 'USER_ID'", array('USER_ID' => $userId));
      return intval($count) < $limit;
    }
		
		function validateAlertOption($type, $value, $operation){
			if(($type < 3 || $type == 8 || $type == 11  || $type == 12  || $type == 15) && (($value > 1 || $value < -1) || ($value == 1 && ($operation == 2 || $operation == 4)) || ($value == -1 && ($operation == 3 || $operation == 5)))) return false;
			elseif(($type == 3 || $type == 10 || $type == 13 || $type == 17) && (($value > 2 || $value < -2) || ($value == -2 && ($operation == 3 || $operation == 5)) || ($value == 2 && ($operation == 2 || $operation == 4)))) return false;
			elseif(($type == 4 || $type == 5) && ($value < 0 || ($value == 0 && ($operation == 3 || $operation == 5)))) return false;
      //elseif($type == 6 && (($value < -100  || $value > 100) || ($value == -100 && ($operation == 3 || $operation == 5)) || ($value == 100 && ($operation == 2 || $operation == 4)))) return false;
			else return true;
		}
		
		function validateAlertOptionsSameTypes($value1, $value2, $operation1, $operation2){
			if($value1 != $value2 && $operation1 == $operation2 && $operation1 == 1)return false;
      elseif($value1 < $value2 && ($operation1 == 3 || $operation1 == 5) && ($operation2 == 2 || $operation2 == 4)) return false;
			elseif($value1 > $value2 && ($operation1 == 2 || $operation1 == 4) && ($operation2 == 3 || $operation2 == 5)) return false;
			elseif($value1 == $value2 && ($operation1 == 2 || $operation1 == 3) && ($operation2 == 2 || $operation2 == 3) && ($operation1 != $operation2)) return false;
      elseif($value1 < $value2 && ($operation1 == 1) && ($operation2 == 2 || $operation2 == 4)) return false;
      elseif($value1 > $value2 && ($operation1 == 2 || $operation1 == 4) && ($operation2 == 1)) return false;
      elseif($value1 > $value2 && ($operation1 == 1) && ($operation2 == 3 || $operation2 == 5)) return false;
      elseif($value1 < $value2 && ($operation1 == 3 || $operation1 == 5) && ($operation2 == 1)) return false;
			else return true;
		}
    
    function checkPercentFormat($value = null){
      $value = floatval($value);
      if($value){
        //$lc = substr($value, -1);
        //$value = $lc == "%" ? floatval(substr($value, 0, strlen($value) - 1)) / 100 : floatval($value);
        $value = $value / 100;
      }
      return $value;
    }
    
    function getAlertTypeValue($id, $data){
       switch ($id) {
        case 1:
            $key = 'sentiment';
            break;
        case 2:
            $key = 'sentiment_avg';
            break;
        case 3:
            $key = 'sentiment_change';
            break;
        case 4:
            $key = 'buzz';
            break;
        case 5:
            $key = 'price';
            break;
        case 6:
            $key = 'percent_change';
            break;
        case 7:
            $key = 'z_score';
            break;
        case 8:
            $key = 'moving_average_sentiment';
            break;
        case 9:
            $key = 'moving_average_z_score';
            break;
        case 10:
            $key = 'since_open';
            break;
				case 11:
            $key = 'mp_sentiment';
            break;
        case 12:
            $key = 'mp_sentiment_avg';
            break;
        case 13:
            $key = 'mp_sentiment_change';
            break;
        case 14:
						$key = 'mp_moving_average_z_score';
            break;
        case 15:
            $key = 'mp_moving_average_sentiment';
            break;
        case 16:
            $key = 'mp_z_score';
            break;
        case 17:
            $key = 'mp_since_open';
            break;
        default:
           $key = '';
      }
      $result = (array_key_exists($key, $data)) ? $data[$key] : null;
      return $result;
    }
    
    function getAlertTriggered($value1, $operation, $value2){
      $result = false;
      if(is_string($value1)){
        $values = explode(',', $value1);
        if ($values){
          foreach($values as $item){
            $result = $this->checkAlertValue($item, $operation, $value2);
            if ($result) break;
          }
        }
      }else{
        $result = $this->checkAlertValue($value1, $operation, $value2);
      }
      return $result;
    }
    
    function checkAlertValue($value1, $operation, $value2){
      $result = false;
      if ($operation && $value1 !== null && $value2 !== null)
      {
        switch ($operation) {
          case 1:
              $result = ($value1 == $value2);
              break;
          case 2:
              $result = ($value1 > $value2);
              break;
          case 3:
              $result = ($value1 < $value2);
              break;
          case 4:
              $result = ($value1 >= $value2);
              break;
          case 5:
              $result = ($value1 <= $value2);
              break;
        }
      }
      return $result;
    }
		/* Market Users Alert */		
		function addMarketUsersAlert($fields, $fields2)
    {
      $result = false;
      if ($alertID = $this->saveRecord("market_users_alerts", $fields))
      {
        $fields2['alert_id'] = $alertID;
        $fields2['end_date'] = (isset($fields2['timeframe_id'])) ? $this->getEndDate($fields2['timeframe_id']) : "0000-00-00 00:00:00";
        if ($infoID = $this->saveRecord("market_users_alerts_info", $fields2))
        {
          if($this->updateRecords("market_users_alerts", "info_id=".$infoID,"id=".$alertID))
          {
            $result = $alertID;
          }
        }
      }
      return $result;
    }
    
    function editMarketUsersAlert($fields, $isChanges = true)
    {
    	if(!$isChanges) return true;
      $result = false;
      $fields['end_date'] = (isset($fields['timeframe_id'])) ? $this->getEndDate($fields['timeframe_id']) : "0000-00-00 00:00:00";
      if (($infoID = $this->saveRecord("market_users_alerts_info", $fields)) && isset($fields['alert_id']))
      {
        if($this->updateRecords("market_users_alerts", "status=1, info_id=".$infoID,"id=".$fields['alert_id']))
        {
          $result = true;
        }
      }
      return $result;
    }
    
    function removeMarketUsersAlert($id)
    {
      $result = false;
      if ($result = $this->deleteRecord("market_users_alerts", $id))
      {
        $this->deleteRecords("market_users_alerts_info", "alert_id=ALERT_ID", array("ALERT_ID" => $id));
      }
      return $result;
    }
    
    function getMarketUsersAlerts($where = null, $params = null, $limit = null, $order = null, $fields = null)
    {
      $sql = "SELECT ". ($fields ? $fields :"a.id, a.type, a.subtype, a.info_id, ai.type_id_1, ai.operation_id_1, ai.value_1, ai.operation, ai.type_id_2, ai.operation_id_2, ai.value_2, ai.timeframe_id, ai.end_date, ai.usernames, ai.triggered_usernames, ai.filter_timeframe, ai.filter_top_returns, ai.ticker, ai.sector, ai.power, a.prediction_id, a.status");
      $sql .= " FROM market_users_alerts a";
      $sql .= " LEFT JOIN market_users_alerts_info ai ON a.info_id = ai.id";
      $sql .= " LEFT JOIN users u ON a.user_id = u.id";
      $sql .= " WHERE 1 ";
      $sql .= ($where) ? " AND ".$where : '';
      if ($order) $sql .= " ORDER BY ".$order;
      if ($limit) $sql .= " LIMIT ".$limit;
			//test(array($params, $sql, FJF_BASE::replace_params($sql, $params)));
			//test(FJF_BASE::replace_params($sql, $params));
      $records = $this->selectRecords($sql, $params);
      return $records;
    }
    
    function getMarketUsersAlert($where = null, $params = null, $fields = null, $order = null)
    {
      $record = $this->getMarketUsersAlerts($where, $params, 1, $order, $fields);
      return ($record) ? $record[0] : null;
    }
    
    function getMarketUsersAlertsCount($where = null, $params = null, $fields  = null)
    {
      $result =  $this->getMarketUsersAlerts($where, $params, null, null, ($fields ? $fields :'COUNT(a.id) AS count'));
      return ($result) ? $result[0]->count : 0;
    }
    
    function getMarketUsersAlertHistory($where = null, $params = null, $limit = null, $order = null, $fields = null)
    {
      $sql = "SELECT ". ($fields ? $fields :"ai.*");
      $sql .= " FROM market_users_alerts_info ai";
      $sql .= " WHERE 1 ";
      $sql .= ($where) ? " AND ".$where : '';
      if ($order) $sql .= " ORDER BY ".$order;
      if ($limit) $sql .= " LIMIT ".$limit;
      $records = $this->selectRecords($sql, $params);
      return $records;
    }
		
		function checkOpenMarketUsersAlertCount($userId, $limit = 100){
			if($limit === null) return true;
      $count = $this->getTotalActiveAlertCount("a.user_id = 'USER_ID'", array('USER_ID' => $userId));
      return intval($count) < $limit;
    }
		
		function addUsersAlertPrediction($fields, $fields2)
    {
      $result = false;
      if ($predictionID = $this->saveRecord("market_users_alerts_predictions", $fields))
      {
        if (is_array($fields2) && isset($fields2['timeframes']) && $fields2['timeframes'])
        {
          $record = array();
          $record['prediction_id'] = $predictionID;
          foreach ($fields2['timeframes'] as $id => $value)
          {
            $record['timeframe_id'] = $id;
            $record['end_date'] = $this->getEndDate($id);
            $record['prediction'] = $value;
            $this->saveRecord("market_users_alerts_predictions_timeframes", $record);
          }
        }
        $result = $predictionID;
      }
      return $result;
    }
		
		function getUsersPredictionTimeframes($where = null, $params = null, $limit = null, $order = null, $fields = null)
    {
      $sql = "SELECT ". ($fields ? $fields :"apt.id, apt.prediction, ap.price, ap.ticker");
      $sql .= " FROM market_users_alerts_predictions_timeframes apt";
      $sql .= " LEFT JOIN market_users_alerts_predictions ap ON apt.prediction_id = ap.id";
      $sql .= " WHERE apt.correct = 0";
      $sql .= ($where) ? " AND ".$where : '';
      if ($order) $sql .= " ORDER BY ".$order;
      if ($limit) $sql .= " LIMIT ".$limit;
      $records = $this->selectRecords($sql, $params);
      return $records;
    }
		/* END Market Users Alert */
		
		function getAlertCountByType($type, $where = '1', $params = array()){
			$result = null;
			switch($type){
		    case 'stocks':
					$result = $this->getAlertsCount($where, $params);
		      break;
		    case 'users':
					$where .= " AND a.type = 'TYPE_VAL' AND a.subtype = 'SUBTYPE'";
					$params['TYPE_VAL'] = 'user';
					$params['SUBTYPE'] = 'tickers';
					$result = $this->getMarketUsersAlertsCount($where, $params);
		      break;
		    case 'top_users_returns':
					$where .= " AND a.type = 'TYPE_VAL' AND a.subtype = 'SUBTYPE'";
					$params['TYPE_VAL'] = 'top-user';
					$params['SUBTYPE'] = 'tickers';
					$result = $this->getMarketUsersAlertsCount($where, $params);
		    	break;
				case 'top_users_rank':
					$where .= " AND a.type = 'TYPE_VAL' AND a.subtype = 'SUBTYPE'";
					$params['TYPE_VAL'] = 'top-mp';
					$params['SUBTYPE'] = 'tickers';
					$result = $this->getMarketUsersAlertsCount($where, $params);
		    	break;
				case 'top_sectors_returns':
					$where .= " AND a.type = 'TYPE_VAL' AND a.subtype = 'SUBTYPE'";
					$params['TYPE_VAL'] = 'top-user';
					$params['SUBTYPE'] = 'sectors';
					$result = $this->getMarketUsersAlertsCount($where, $params);
		    	break;
				case 'top_sectors_rank':
					$where .= " AND a.type = 'TYPE_VAL' AND a.subtype = 'SUBTYPE'";
					$params['TYPE_VAL'] = 'top-mp';
					$params['SUBTYPE'] = 'sectors';
					$result = $this->getMarketUsersAlertsCount($where, $params);
		    	break;
			}
			return $result;
		}
		
		function getTotalActiveAlertCount($where = '1', $params = array()){
			$where .= " AND a.status = 1 AND (ai.end_date >'".date('Y-m-d H:i:s')."' OR (ai.timeframe_id = 10 AND ai.end_date = '0000-00-00 00:00:00'))";
			return $this->getTotalAlertCount($where, $params);
		}

		function getTotalAlertCount($where = '1', $params = array()){
			$result = 0;
			$result += $this->getAlertsCount($where, $params);
			$result += $this->getMarketUsersAlertsCount($where, $params);
			return $result;
		}

		function getAlertTypes($key = null){
			$types = array(
				"stocks" => array(
					"title" => "Stocks"
				),
				"users" => array(
					"title" => "Users"
				),
				"top_users_returns" => array(
					"title" => "Top Users by Returns"
				),
				"top_users_rank" => array(
					"title" => "Top Users by MP Rank"
				),
				"top_sectors_returns" => array(
					"title" => "Top Sectors by Returns"
				),
				"top_sectors_rank" => array(
					"title" => "Top Sectors by MP Rank"
				),
			);
			if($key){
				$types = array_key_exists($key, $types) ? $types[$key] : array();
			}
			return $types;
		}
		
		function changeAlertPendingStatus($where = '1', $params = array(), $limit = 100){
			$totalActive = $this->getTotalActiveAlertCount($where, $params);
			$totalPending = $this->getTotalAlertCount($where . ' AND a.status = 0', $params);
			$count = 0;
			if($limit === null){
				$status = 1;
				$count = $totalPending;
				$where = $where . " AND a.status = 0";
			}elseif($totalActive > $limit){
				$status = 0;
				$count = $totalActive - $limit;
				$where = $where . " AND a.status = 1 AND (ai.end_date >'".date('Y-m-d H:i:s')."' OR (ai.timeframe_id = 10 AND ai.end_date = '0000-00-00 00:00:00'))";
			}elseif($totalActive < $limit && $totalPending){
				$status = 1;
				$count = $limit - $totalActive;
				$where = $where . " AND a.status = 0";
			}
			if($count){
				$sql = "(";
				$sql .= "SELECT a.id, ai.date, 'alerts' AS table_name";
      	$sql .= " FROM alerts a";
     		$sql .= " LEFT JOIN alerts_info ai ON a.info_id = ai.id";
      	//$sql .= " LEFT JOIN users u ON a.user_id = u.id";
      	$sql .= ($where) ? " WHERE " . $where : '';
				$sql .= ") UNION (";
				$sql .= "SELECT a.id, ai.date, 'market_users_alerts' AS table_name";
      	$sql .= " FROM market_users_alerts a";
      	$sql .= " LEFT JOIN market_users_alerts_info ai ON a.info_id = ai.id";
      	//$sql .= " LEFT JOIN users u ON a.user_id = u.id";
      	$sql .= ($where) ? " WHERE " . $where : '';
				$sql .= ")";
				$sql .= " ORDER BY date DESC";
				$sql .= " LIMIT " . $count;
				if($records = $this->selectRecords($sql, $params)){
					$data = array();
					foreach($records as $item){
						$data[$item->table_name][] = $item->id;
					}
					foreach($data as $table => $items){
						if($items){
							$this->updateRecords($table, "status = 'STATUS_VAL'", "id IN(IDS_VAL)", array(
								"STATUS_VAL" => $status,
								"IDS_VAL" => implode(',', $items)
							));
						}
					}
				}
			}
			return $count;
		}

		function changeUserAlertPendingStatus($userId, $tier = 1){
			include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/pricing_model.php");
			return $this->changeAlertPendingStatus(
				"a.user_id = 'USER_ID_VAL'",
				array("USER_ID_VAL" => $userId),
				PricingModel::getAlertsLimit($tier)
			);
			
		}
  }
?>