<?php

include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/users_sentiment_model.php");

class ChartsModel{

	var $usersSentimentModel = null;
	private $type = '';
	private $limit = null;
	private $interval = null;
	private $extremes = null;

	function __construct(){
		$this->usersSentimentModel = new UsersSentimentModel();
	}
	
	function setType($interval){
		$this->type = '';
		$this->interval = $interval;
		$this->limit = null;
		if($interval){
			if($interval == '1 HOUR'){
				$this->type = 'real_time';
			}elseif($interval == '1 MINUTE'){
				$this->type = 'real_time';
				$this->interval = '5 MINUTE';
			}elseif($interval == '1 DAY'){
				$this->type = 'day';
			}elseif($intervals = $this->usersSentimentModel->getIntervals()){
				foreach($intervals as $item){
					if($item['interval'] == $interval){
						$this->type = 'historical';
						//$this->limit = $item['limit'];
						break;
					}
				}
			}
		}
		return $this->type;
	}

	function getExtremes(){
		return $this->extremes;
	}//getExtremes

	function setExtremes($extremes = null, $title = ""){
		$this->extremes = null;
		if($extremes){
			$this->extremes = $extremes;
		}elseif($this->type){
			$dates = null;
			FJF_BASE_RICH::db("sentiment");
			if($this->type == 'historical'){
				$sql = "SELECT MAX(TRADE_DATE) FROM TradeDates INTO @TS_MAX";
				FJF_BASE_RICH::executeQuery($sql);
				$dates = FJF_BASE_RICH::selectRecords(
					'SELECT @TS_MAX AS max_val, DATE_SUB(@TS_MAX, INTERVAL INTERVAL_VAL) AS min_val',
					array('INTERVAL_VAL' => $this->interval),
					true
				);
				if($title){
					$this->logSql("\nHistorical " . $title . " - " . $this->interval . "\n");
					$this->logSql($sql . "\n");
					$this->logSql('SELECT @TS_MAX AS max_val, DATE_SUB(@TS_MAX, INTERVAL INTERVAL_VAL) AS min_val' . "\n");
				}
			}elseif($this->type == 'day'){
				FJF_BASE_RICH::executeQuery("SET @SOD_EST = DATE(CONVERT_TZ(UTC_TIMESTAMP(), 'GMT','US/Eastern'))");
				FJF_BASE_RICH::executeQuery("SET @SOD_EST = CONVERT_TZ(TIMESTAMP(@SOD_EST), 'US/Eastern', 'GMT')");
				FJF_BASE_RICH::executeQuery("SET @EOD_EST = DATE_ADD(@SOD_EST, INTERVAL 1 DAY)");
				$dates = FJF_BASE_RICH::selectRecords(
					"SELECT CONVERT_TZ(@EOD_EST, 'GMT','US/Eastern') AS max_val, CONVERT_TZ(@SOD_EST, 'GMT','US/Eastern') AS min_val",
					null, true
				);
				if($title){
					$this->logSql("\nHistorical " . $title . " - " . $this->interval . "\n");
					$this->logSql("SET @SOD_EST = DATE(CONVERT_TZ(UTC_TIMESTAMP(), 'GMT','US/Eastern'))" . "\n");
					$this->logSql("SET @SOD_EST = CONVERT_TZ(TIMESTAMP(@SOD_EST), 'US/Eastern', 'GMT')" . "\n");
					$this->logSql("SET @EOD_EST = DATE_ADD(@SOD_EST, INTERVAL 1 DAY)" . "\n");
					$this->logSql("SELECT CONVERT_TZ(@EOD_EST, 'GMT','US/Eastern') AS max_val, CONVERT_TZ(@SOD_EST, 'GMT','US/Eastern') AS min_val" . "\n");
				}
			}elseif($this->type == 'real_time'){
				$sql = "SELECT UTC_TIMESTAMP() INTO @TS_MAX";
				FJF_BASE_RICH::executeQuery($sql);
				$dates = FJF_BASE_RICH::selectRecords(
					"SELECT CONVERT_TZ(@TS_MAX,'GMT','US/Eastern') AS max_val, CONVERT_TZ(DATE_SUB(@TS_MAX, INTERVAL INTERVAL_VAL),'GMT','US/Eastern') AS min_val",
					array('INTERVAL_VAL' => $this->interval),
					true
				);
				if($title){
					$this->logSql("\nRealtime " . $title . " - " . $this->interval . "\n");
					$this->logSql($sql . "\n");
					$this->logSql("SELECT CONVERT_TZ(@TS_MAX,'GMT','US/Eastern') AS max_val, CONVERT_TZ(DATE_SUB(@TS_MAX, INTERVAL INTERVAL_VAL),'GMT','US/Eastern') AS min_val" . "\n");
				}
			}
			if($dates){
				$this->extremes = array(
					strtotime($dates->min_val),
					min(strtotime($dates->max_val), time())
				);
			}
		}
		return $this->extremes;
	}

	function fillWithZeros($values = null, $extremes = null){
		if(!$extremes) $extremes = $this->getExtremes();
		$result = array();
		if($values){
			$total = count($values);
			for($i = 0; $i < $total; $i++){
				$values[$values[$i][0]] = $values[$i][1];
				unset($values[$i]);
			}
		}
		$tmp = ceil($extremes[0]/60)*60;
		$extremes[0] = ($extremes[0] == $tmp) ? $extremes[0] + 60 : $tmp;
		do{
			$date = date("Y-m-d H:i:00", $extremes[0]);
			$result[] = array($date, $values && array_key_exists($date, $values) ? $values[$date] : 0);
			$extremes[0] += 60;
		}while($extremes[0] <= $extremes[1]);
		unset($values);

		return $result;
	}//fillWithZeros

	function selectRecords($sql, $params, $reverse = false){
		$result = array();
		FJF_BASE_RICH::db("sentiment");
		$records = FJF_BASE_RICH::selectRecords($sql, $params);
		if($records != null){
			foreach($records as $record){
				$result[] = array(
					((is_numeric($record->TS)) ? date("Y-m-d H:i:00", $record->TS) : $record->TS),
					floatval($record->VALUE)
				);
			}
			if($reverse) $result = array_reverse($result);
		}
		unset($records);
		return $result;
	}//selectRecords

	private $availableData = array(
		"sentiment" => "Sentiment",
		"mp-sentiment" => "MpSentiment",
		"zscore" => "ZScore",
		"mp-zscore" => "MpZScore",
		"buzz" => "Buzz",
		"tweetvolume" => "TweetVolume",
		"price" => "Price",
		"moving-average-sentiment" => "MovingAverageSentiment",
		"mp-moving-average-sentiment" => "MpMovingAverageSentiment",
		"moving-average-zscore" => "MovingAverageZScore",
		"mp-moving-average-zscore" => "MpMovingAverageZScore",
		"user-score" => "UserScore",
		"user-rank" => "UserRank"
	);

	function logSql($str){
		//file_put_contents($_SERVER["DOCUMENT_ROOT"] . "/data/sql_log/chart.log", $str, FILE_APPEND);
		return true;
	}

	function get($data, $ticker, $extremes = null, $interval = null){
		$this->setType($interval);
		if($extremes) $this->setExtremes($extremes);
		$data = array_key_exists($data, $this->availableData) ? $this->availableData[$data] : null;
		return $data ? $this->{"get" . $data}($ticker) : null;
	}//get

	function getSentiment($ticker){
		$sql = "";
		$params = array('TICKER_VAL' => $ticker, 'INTERVAL_VAL' => $this->interval);
		$this->setExtremes(null, 'Crowd Sentiment');
		if($this->type == 'historical'){
			$sql .= "SELECT";
			$sql .= " TS, AVERAGE_SENTIMENT AS VALUE";
			$sql .= " FROM SentimentData_Averaged";
			$sql .= " WHERE";
			$sql .= " TICKER = 'TICKER_VAL'";
			$sql .= " AND FREQUENCY = 86400";
			$sql .= " AND WINDOW_SIZE = 34200";
			$sql .= " AND TS > DATE_SUB(@TS_MAX, INTERVAL INTERVAL_VAL)";
		}elseif($this->type == "day"){
			$sql .= "SELECT";
			$sql .= " CONVERT_TZ(TS,'GMT','US/Eastern') AS TS, AVERAGE_SENTIMENT AS VALUE";
			$sql .= " FROM SentimentData_Averaged";
			$sql .= " WHERE";
			$sql .= " TICKER = 'TICKER_VAL'";
			$sql .= " AND FREQUENCY = 60";
			$sql .= " AND WINDOW_SIZE = 60";
			$sql .= " AND TS >= @SOD_EST";
			$sql .= " AND TS < @EOD_EST";
		}elseif($this->type == "real_time"){
			$sql .= "SELECT";
			$sql .= " CONVERT_TZ(TS,'GMT','US/Eastern') AS TS, AVERAGE_SENTIMENT AS VALUE";
			$sql .= " FROM SentimentData_Averaged";
			$sql .= " WHERE";
			$sql .= " TICKER = 'TICKER_VAL'";
			$sql .= " AND FREQUENCY = 60";
			$sql .= " AND WINDOW_SIZE = 60";
			$sql .= " AND TS > DATE_SUB(@TS_MAX, INTERVAL INTERVAL_VAL)";
		}
		$this->logSql($sql . "\n");
		$records = $sql ? $this->selectRecords($sql, $params) : array();
		if ($this->type != 'historical') $records = $this->fillWithZeros($records, $this->getExtremes());
		return $records;
	}//getSentiment

	function getMpSentiment($ticker){
		$sql = "";
		$params = array('TICKER_VAL' => $ticker, 'INTERVAL_VAL' => $this->interval);
		$this->setExtremes(null, 'MP Signal');
		if($this->type == 'historical'){
			$sql .= "SELECT";
			$sql .= " TS, AVERAGE_SIGNAL AS VALUE";
			$sql .= " FROM TradingSignalData_Averaged";
			$sql .= " WHERE";
			$sql .= " TICKER = 'TICKER_VAL'";
			$sql .= " AND FREQUENCY = 86400";
			$sql .= " AND WINDOW_SIZE = 34200";
			$sql .= " AND TS > DATE_SUB(@TS_MAX, INTERVAL INTERVAL_VAL)";
		}elseif($this->type == "day"){
			$sql .= "SELECT";
			$sql .= " CONVERT_TZ(TS,'GMT','US/Eastern') AS TS, SIGNAL_VALUE AS VALUE";
			$sql .= " FROM TradingSignalData";
			$sql .= " WHERE";
			$sql .= " TICKER = 'TICKER_VAL'";
			$sql .= " AND TS >= @SOD_EST";
			$sql .= " AND TS < @EOD_EST";
		}elseif($this->type == "real_time"){
			$sql .= "SELECT";
			$sql .= " CONVERT_TZ(TS,'GMT','US/Eastern') AS TS, SIGNAL_VALUE AS VALUE";
			$sql .= " FROM TradingSignalData";
			$sql .= " WHERE";
			$sql .= " TICKER = 'TICKER_VAL'";
			$sql .= " AND TS > DATE_SUB(@TS_MAX, INTERVAL INTERVAL_VAL)";
		}
		$this->logSql($sql . "\n");
		$records = $sql ? $this->selectRecords($sql, $params) : array();
		return $records;

	}//getMpSentiment

	function getMovingAverageSentiment($ticker){
		$sql = "";
		$params = array('TICKER_VAL' => $ticker, 'INTERVAL_VAL' => $this->interval);
		$this->setExtremes(null, 'Crowd Sentiment - Moving Average');
		if($this->type == 'historical'){
			$sql .= "SELECT";
			$sql .= " TS, MOVING_AVERAGE AS VALUE";
			$sql .= " FROM MovingAverageData_Sentiment";
			$sql .= " WHERE";
			$sql .= " TICKER = 'TICKER_VAL'";
			$sql .= " AND FREQUENCY = 86400";
			$sql .= " AND WINDOW_SIZE = 2419200";
			$sql .= " AND TS > DATE_SUB(@TS_MAX, INTERVAL INTERVAL_VAL)";
		}elseif($this->type == "day"){
			$sql .= "SELECT";
			$sql .= " CONVERT_TZ(TS,'GMT','US/Eastern') AS TS, MOVING_AVERAGE AS VALUE";
			$sql .= " FROM MovingAverageData_Sentiment";
			$sql .= " WHERE";
			$sql .= " TICKER = 'TICKER_VAL'";
			$sql .= " AND FREQUENCY = 60";
			$sql .= " AND WINDOW_SIZE = 1800";
			$sql .= " AND TS >= @SOD_EST";
			$sql .= " AND TS < @EOD_EST";
		}elseif($this->type == "real_time"){
			$sql .= "SELECT";
			$sql .= " CONVERT_TZ(TS,'GMT','US/Eastern') AS TS, MOVING_AVERAGE AS VALUE";
			$sql .= " FROM MovingAverageData_Sentiment";
			$sql .= " WHERE";
			$sql .= " TICKER = 'TICKER_VAL'";
			$sql .= " AND FREQUENCY = 60";
			$sql .= " AND WINDOW_SIZE = 1800";
			$sql .= " AND TS > DATE_SUB(@TS_MAX, INTERVAL INTERVAL_VAL)";
		}
		$this->logSql($sql . "\n");
		$records = $sql ? $this->selectRecords($sql, $params) : array();
		return $records;

	}//getMovingAverageSentiment

	function getMpMovingAverageSentiment($ticker){
		$sql = "";
		$params = array('TICKER_VAL' => $ticker, 'INTERVAL_VAL' => $this->interval);
		$this->setExtremes(null, 'MP Signal - Moving Average');
		if($this->type == 'historical'){
			$sql .= "SELECT";
			$sql .= " TS, MOVING_AVERAGE AS VALUE";
			$sql .= " FROM MovingAverageData_TradingSignal";
			$sql .= " WHERE";
			$sql .= " TICKER = 'TICKER_VAL'";
			$sql .= " AND FREQUENCY = 86400";
			$sql .= " AND WINDOW_SIZE = 2419200";
			$sql .= " AND TS > DATE_SUB(@TS_MAX, INTERVAL INTERVAL_VAL)";
		}elseif($this->type == "day"){
			$sql .= "SELECT";
			$sql .= " CONVERT_TZ(TS,'GMT','US/Eastern') AS TS, MOVING_AVERAGE AS VALUE";
			$sql .= " FROM MovingAverageData_TradingSignal";
			$sql .= " WHERE";
			$sql .= " TICKER = 'TICKER_VAL'";
			$sql .= " AND FREQUENCY = 1";
			$sql .= " AND WINDOW_SIZE = 1800";
			$sql .= " AND TS >= @SOD_EST";
			$sql .= " AND TS < @EOD_EST";
		}elseif($this->type == "real_time"){
			$sql .= "SELECT";
			$sql .= " CONVERT_TZ(TS,'GMT','US/Eastern') AS TS, MOVING_AVERAGE AS VALUE";
			$sql .= " FROM MovingAverageData_TradingSignal";
			$sql .= " WHERE";
			$sql .= " TICKER = 'TICKER_VAL'";
			$sql .= " AND FREQUENCY = 1";
			$sql .= " AND WINDOW_SIZE = 1800";
			$sql .= " AND TS > DATE_SUB(@TS_MAX, INTERVAL INTERVAL_VAL)";
		}
		$this->logSql($sql . "\n");
		$records = $sql ? $this->selectRecords($sql, $params) : array();
		return $records;
	}//getMpMovingAverageSentiment

	function getZScore($ticker){
		$sql = "";
		$params = array('TICKER_VAL' => $ticker, 'INTERVAL_VAL' => $this->interval);
		$this->setExtremes(null, 'Crowd Sentiment - Z-Score');
		if($this->type == 'historical'){
			$sql .= "SELECT";
			$sql .= " TS, Z_SCORE AS VALUE";
			$sql .= " FROM SentimentData_Z_Score";
			$sql .= " WHERE";
			$sql .= " TICKER = 'TICKER_VAL'";
			$sql .= " AND FREQUENCY = 86400";
			$sql .= " AND WINDOW_SIZE = 2419200";
			$sql .= " AND TS > DATE_SUB(@TS_MAX, INTERVAL INTERVAL_VAL)";
		}elseif($this->type == "day"){
			$sql .= "SELECT";
			$sql .= " CONVERT_TZ(TS,'GMT','US/Eastern') AS TS, Z_SCORE AS VALUE";
			$sql .= " FROM SentimentData_Z_Score";
			$sql .= " WHERE";
			$sql .= " TICKER = 'TICKER_VAL'";
			$sql .= " AND FREQUENCY = 60";
			$sql .= " AND WINDOW_SIZE = 1800";
			$sql .= " AND TS >= @SOD_EST";
			$sql .= " AND TS < @EOD_EST";
		}elseif($this->type == "real_time"){
			$sql .= "SELECT";
			$sql .= " CONVERT_TZ(TS,'GMT','US/Eastern') AS TS, Z_SCORE AS VALUE";
			$sql .= " FROM SentimentData_Z_Score";
			$sql .= " WHERE";
			$sql .= " TICKER = 'TICKER_VAL'";
			$sql .= " AND FREQUENCY = 60";
			$sql .= " AND WINDOW_SIZE = 1800";
			$sql .= " AND TS > DATE_SUB(@TS_MAX, INTERVAL INTERVAL_VAL)";
		}
		$this->logSql($sql . "\n");
		$records = $sql ? $this->selectRecords($sql, $params) : array();
		return $records;
	}//getZScore

	function getMpZScore($ticker){
		$sql = "";
		$params = array('TICKER_VAL' => $ticker, 'INTERVAL_VAL' => $this->interval);
		$this->setExtremes(null, 'MP Signal - Z-Score');
		if($this->type == 'historical'){
			$sql = "SELECT";
			$sql .= " TS, Z_SCORE AS VALUE";
			$sql .= " FROM TradingSignalData_Z_Score";
			$sql .= " WHERE";
			$sql .= " TICKER = 'TICKER_VAL'";
			$sql .= " AND FREQUENCY = 86400";
			$sql .= " AND WINDOW_SIZE = 2419200";
			$sql .= " AND TS > DATE_SUB(@TS_MAX, INTERVAL INTERVAL_VAL)";
		}elseif($this->type == "day"){
			$sql .= "SELECT";
			$sql .= " CONVERT_TZ(TS,'GMT','US/Eastern') AS TS, Z_SCORE AS VALUE";
			$sql .= " FROM TradingSignalData_Z_Score";
			$sql .= " WHERE";
			$sql .= " TICKER = 'TICKER_VAL'";
			$sql .= " AND FREQUENCY = 1";
			$sql .= " AND WINDOW_SIZE = 1800";
			$sql .= " AND TS >= @SOD_EST";
			$sql .= " AND TS < @EOD_EST";
		}elseif($this->type == "real_time"){
			$sql .= "SELECT";
			$sql .= " CONVERT_TZ(TS,'GMT','US/Eastern') AS TS, Z_SCORE AS VALUE";
			$sql .= " FROM TradingSignalData_Z_Score";
			$sql .= " WHERE";
			$sql .= " TICKER = 'TICKER_VAL'";
			$sql .= " AND FREQUENCY = 1";
			$sql .= " AND WINDOW_SIZE = 1800";
			$sql .= " AND TS > DATE_SUB(@TS_MAX, INTERVAL INTERVAL_VAL)";
		}
		$this->logSql($sql . "\n");
		$records = $sql ? $this->selectRecords($sql, $params) : array();
		return $records;
	}//getZScore

	function getMovingAverageZScore($ticker){
		$sql = "";
		$params = array('TICKER_VAL' => $ticker, 'INTERVAL_VAL' => $this->interval);
		$this->setExtremes(null, 'Crowd Sentiment - Z-Score - Moving Average');
		if($this->type == 'historical'){
			$sql .= "SELECT";
			$sql .= " TS, MOVING_AVERAGE AS VALUE";
			$sql .= " FROM MovingAverageData_Z_Score";
			$sql .= " WHERE";
			$sql .= " TICKER = 'TICKER_VAL'";
			$sql .= " AND FREQUENCY = 86400";
			$sql .= " AND WINDOW_SIZE = 2419200";
			$sql .= " AND TS > DATE_SUB(@TS_MAX, INTERVAL INTERVAL_VAL)";
		}elseif($this->type == "day"){
			$sql .= "SELECT";
			$sql .= " CONVERT_TZ(TS,'GMT','US/Eastern') AS TS, MOVING_AVERAGE AS VALUE";
			$sql .= " FROM MovingAverageData_Z_Score";
			$sql .= " WHERE";
			$sql .= " TICKER = 'TICKER_VAL'";
			$sql .= " AND FREQUENCY = 60";
			$sql .= " AND WINDOW_SIZE = 1800";
			$sql .= " AND TS >= @SOD_EST";
			$sql .= " AND TS < @EOD_EST";
		}elseif($this->type == "real_time"){
			$sql .= "SELECT";
			$sql .= " CONVERT_TZ(TS,'GMT','US/Eastern') AS TS, MOVING_AVERAGE AS VALUE";
			$sql .= " FROM MovingAverageData_Z_Score";
			$sql .= " WHERE";
			$sql .= " TICKER = 'TICKER_VAL'";
			$sql .= " AND FREQUENCY = 60";
			$sql .= " AND WINDOW_SIZE = 1800";
			$sql .= " AND TS > DATE_SUB(@TS_MAX, INTERVAL INTERVAL_VAL)";
		}
		$this->logSql($sql . "\n");
		$records = $sql ? $this->selectRecords($sql, $params) : array();
		return $records;
	}//getMovingAverageZScore

	function getMpMovingAverageZScore($ticker)
	{
		$sql = "";
		$params = array('TICKER_VAL' => $ticker, 'INTERVAL_VAL' => $this->interval);
		$this->setExtremes(null, 'MP Signal - Z-Score - Moving Average');
		if($this->type == 'historical'){
			$sql .= "SELECT";
			$sql .= " TS, MOVING_AVERAGE AS VALUE";
			$sql .= " FROM MovingAverageData_TradingSignal_Z_Score";
			$sql .= " WHERE";
			$sql .= " TICKER = 'TICKER_VAL'";
			$sql .= " AND FREQUENCY = 86400";
			$sql .= " AND WINDOW_SIZE = 2419200";
			$sql .= " AND TS > DATE_SUB(@TS_MAX, INTERVAL INTERVAL_VAL)";
		}elseif($this->type == "day"){
			$sql .= "SELECT";
			$sql .= " CONVERT_TZ(TS,'GMT','US/Eastern') AS TS, MOVING_AVERAGE AS VALUE";
			$sql .= " FROM MovingAverageData_TradingSignal_Z_Score";
			$sql .= " WHERE";
			$sql .= " TICKER = 'TICKER_VAL'";
			$sql .= " AND FREQUENCY= 1";
			$sql .= " AND WINDOW_SIZE = 1800";
			$sql .= " AND TS >= @SOD_EST";
			$sql .= " AND TS < @EOD_EST";
		}elseif($this->type == "real_time"){
			$sql = "SELECT";
			$sql .= " CONVERT_TZ(TS,'GMT','US/Eastern') AS TS, MOVING_AVERAGE AS VALUE";
			$sql .= " FROM MovingAverageData_TradingSignal_Z_Score";
			$sql .= " WHERE";
			$sql .= " TICKER = 'TICKER_VAL'";
			$sql .= " AND FREQUENCY = 1";
			$sql .= " AND WINDOW_SIZE = 1800";
			$sql .= " AND TS > DATE_SUB(@TS_MAX, INTERVAL INTERVAL_VAL)";
		}
		$this->logSql($sql . "\n");
		$records = $sql ? $this->selectRecords($sql, $params) : array();
		return $records;
	}//getMovingAverageZScore

	function getBuzz($ticker){
		$sql = "";
		$params = array('TICKER_VAL' => $ticker, 'INTERVAL_VAL' => $this->interval);
		$this->setExtremes(null, 'Buzz');
		if($this->type == 'historical'){
			$sql .= "SELECT";
			$sql .= " TS, BUZZ AS VALUE";
			$sql .= " FROM TweetBuzzData";
			$sql .= " WHERE";
			$sql .= " TICKER = 'TICKER_VAL'";
			$sql .= " AND FREQUENCY = 86400";
			$sql .= " AND WINDOW_SIZE = 86400";
			$sql .= " AND HISTORICAL_WINDOW_SIZE = 1209600";
			$sql .= " AND TS > DATE_SUB(@TS_MAX, INTERVAL INTERVAL_VAL)";
		}elseif($this->type == "day"){
			$sql .= "SELECT";
			$sql .= " CONVERT_TZ(TS,'GMT','US/Eastern') AS TS, BUZZ AS VALUE";
			$sql .= " FROM TweetBuzzData";
			$sql .= " WHERE";
			$sql .= " TICKER = 'TICKER_VAL'";
			$sql .= " AND FREQUENCY = 60";
			$sql .= " AND WINDOW_SIZE = 60";
			$sql .= " AND HISTORICAL_WINDOW_SIZE = 604800";
			$sql .= " AND TS >= @SOD_EST";
			$sql .= " AND TS < @EOD_EST";
		}elseif($this->type == "real_time"){
			$sql .= "SELECT";
			$sql .= " CONVERT_TZ(TS,'GMT','US/Eastern') AS TS, BUZZ AS VALUE";
			$sql .= " FROM TweetBuzzData";
			$sql .= " WHERE";
			$sql .= " TICKER = 'TICKER_VAL'";
			$sql .= " AND FREQUENCY = 60";
			$sql .= " AND WINDOW_SIZE = 60";
			$sql .= " AND HISTORICAL_WINDOW_SIZE = 604800";
			$sql .= " AND TS > DATE_SUB(@TS_MAX, INTERVAL INTERVAL_VAL)";
		}
		$this->logSql($sql . "\n");
		$records = $sql ? $this->selectRecords($sql, $params) : array();
		if ($this->type != 'historical') $records = $this->fillWithZeros($records, $this->getExtremes());
		return $records;
	}//getBuzz

	function getTweetVolume($ticker){
		$sql = "";
		$params = array('TICKER_VAL' => $ticker, 'INTERVAL_VAL' => $this->interval);
		$this->setExtremes(null, 'Tweet Volume');
		if($this->type == 'historical'){
			$sql .= "SELECT";
			$sql .= " TS, VOLUME AS VALUE";
			$sql .= " FROM TweetVolumeData";
			$sql .= " WHERE";
			$sql .= " TICKER = 'TICKER_VAL'";
			$sql .= " AND FREQUENCY = 86400";
			$sql .= " AND WINDOW_SIZE = 86400";
			$sql .= " AND TS > DATE_SUB(@TS_MAX, INTERVAL INTERVAL_VAL)";
		}elseif($this->type == "day"){
			$sql .= "SELECT";
			$sql .= " CONVERT_TZ(TS,'GMT','US/Eastern') AS TS, VOLUME AS VALUE";
			$sql .= " FROM TweetVolumeData";
			$sql .= " WHERE";
			$sql .= " TICKER = 'TICKER_VAL'";
			$sql .= " AND FREQUENCY = 60";
			$sql .= " AND WINDOW_SIZE = 60";
			$sql .= " AND TS >= @SOD_EST";
			$sql .= " AND TS < @EOD_EST";
		}elseif($this->type == "real_time"){
			$sql .= "SELECT";
			$sql .= " CONVERT_TZ(TS,'GMT','US/Eastern') AS TS, VOLUME AS VALUE";
			$sql .= " FROM TweetVolumeData";
			$sql .= " WHERE";
			$sql .= " TICKER = 'TICKER_VAL'";
			$sql .= " AND FREQUENCY = 60";
			$sql .= " AND WINDOW_SIZE = 60";
			$sql .= " AND TS > DATE_SUB(@TS_MAX, INTERVAL INTERVAL_VAL)";
		}
		$this->logSql($sql . "\n");
		$records = $sql ? $this->selectRecords($sql, $params) : array();
		if ($this->type != 'historical') $records = $this->fillWithZeros($records, $this->getExtremes());
		return $records;
	}//getTweetVolume

	function getPrice($ticker){
		$records = array();
		include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/xignite_model.php");
		FJF_BASE_RICH::db('sentiment');
		if($stock = FJF_BASE_RICH::getRecords(
				"PricingMaster"
			, "TICKER='TICKER_VAL' LIMIT 1"
			, array('TICKER_VAL' => $ticker)
			, true
			, "PRICING_TICKER, API_NAME"
		)){
			if($this->type == 'historical'){
				$extremes = $this->setExtremes();
				$values = XigniteModel::getHistoricalQuotes(
					$stock->PRICING_TICKER,
					$extremes[0] + 86400,
					$extremes[1]
				);
				if($values){
					ksort($values);
					foreach($values as $date=>$last){
						$records[] = array($date, $last);
					}
					if($this->limit) $records = array_slice($records, -$this->limit);
				}
			}else{
				if($this->interval == '5 MINUTE'){
					$this->interval = '21 MINUTE';
				}
				$extremes = $this->setExtremes();
				$last = isset($_GET['last_price']) ? floatval($_GET['last_price']) : null;

	      $min = XigniteModel::getTicksMinTime();
	      $max = XigniteModel::getTicksMaxTime();

				$startTime = $last === null ? $min : $extremes[0];
				$endTime = min($extremes[1], $max);

				$values = XigniteModel::getTicks(
					$stock->PRICING_TICKER,
					$stock->API_NAME,
					$startTime,
					$extremes[1]
				);
				$lastPrice = null;
	      if($extremes[0] < $min || $extremes[1] > $max)
	      {
	      	if($lastPrice = XigniteModel::getQuote($stock->PRICING_TICKER,$stock->API_NAME))
	        {
	        	$lastPriceTime = strtotime($lastPrice->Date . " " . $lastPrice->Time);
	        	$lastClose = ($lastPriceTime < $min) ? $lastPrice->Last : $lastPrice->PreviousClose;
	          if($extremes[0] < $min){
		          $date = $extremes[0];
		          do{
		            $values[date("Y-m-d H:i:00", $date)] = $lastClose;
		            $date += 60;
		          }while($date < $min);
						}
						if($extremes[1] > $max){
		          $date = $max;
		          do{
		            $date += 60;
		            $values[date("Y-m-d H:i:00", $date)] = $lastPrice->Last;
		          }while($date < $extremes[1]);
						}
	        }
	      }

	      if ($last === null){
	      	if (!$lastPrice) $lastPrice = XigniteModel::getQuote($stock->PRICING_TICKER,$stock->API_NAME);
					if ($lastPrice)
					$last = ($lastPrice->Close == $lastPrice->Last) ? $lastPrice->Last : $lastPrice->PreviousClose;
					if ($startTime < $extremes[0]){
						do{
							$date = date("Y-m-d H:i:00", $startTime);
							$last = $values && array_key_exists($date, $values) ? $values[$date] : $last;
							$startTime += 60;
						}while($startTime <= $extremes[0]);
					}
				}
	      $startTime = $extremes[0];
				do{
					$date = date("Y-m-d H:i:00", $startTime);
					$last = $values && array_key_exists($date, $values) ? $values[$date] : $last;
					$records[] = array($date, $last);
					$startTime += 60;
				}while($startTime <= $extremes[1]);
			}
		}
		return $records;
	}//getPrice

	function getUserScore($username){
		$records = array();
		$extremes = $this->getExtremes();
		if($extremes){
			$params = array(
				"USERNAME_VAL" => $username,
				"MIN_VAL" => $extremes[0],
				"MAX_VAL" => $extremes[1]
			);
			$sql = "SELECT TS, SCORE AS VALUE";
			$sql .= " FROM UserRankings_UserScores";
			$sql .= " WHERE USERNAME='USERNAME_VAL'";
			$sql .= " AND TS > 'MIN_VAL' AND TS <= 'MAX_VAL'";
			$sql .= " ORDER BY TS";
			$records = $this->selectRecords($sql, $params);
		}
		return $records;
	}//getScore

	function getUserRank($username){
		$records = array();
		$extremes = $this->getExtremes();
		if($extremes){
			$params = array(
				"USERNAME_VAL" => $username,
				"MIN_VAL" => $extremes[0],
				"MAX_VAL" => $extremes[1]
			);
			$sql = "SELECT TS, RANK AS VALUE";
			$sql .= " FROM UserRankings_UserScores";
			$sql .= " WHERE USERNAME='USERNAME_VAL'";
			$sql .= " AND TS > 'MIN_VAL' AND TS <= 'MAX_VAL'";
			$sql .= " ORDER BY TS";
			$records = $this->selectRecords($sql, $params);
		}
		return $records;
	}//getRank

}

?>