<?php

class ContentOrganizerModel{
	
	var $request_uri;
	
	function __construct(){
		$this->request_uri = trim(parse_url($_SERVER["REQUEST_URI"], PHP_URL_PATH), "/");
		$this->request_uri = $this->request_uri ? "/" . $this->request_uri . "/" : "";
	}
	
	function updateMenuLinks($parent, $items, $links){
		$auto = $links === true;
		if($items){
			foreach($items as $k => $v){
				if(isset($links[$items[$k]["id"]]) || $auto){
					if($auto){
						if(!isset($items[$k]["url"])) $items[$k]["url"] = "";
						$items[$k]["url_title"] = $items[$k]["url"];
						if(!isset($items[$k]["title"])) $items[$k]["title"] = "";
						$items[$k]["meta_title"] = $items[$k]["title"];
					}else{
						$items[$k]["url"] = "";
						$items[$k]["title"] = $links[$items[$k]["id"]]->title;
						$items[$k]["sub_title"] = $links[$items[$k]["id"]]->sub_title;
						$items[$k]["description"] = $links[$items[$k]["id"]]->description;
						$items[$k]["url_title"] = $links[$items[$k]["id"]]->url;
						$items[$k]["meta_title"] = isset($links[$items[$k]["id"]]->meta_title) ? $links[$items[$k]["id"]]->meta_title : "";
					}
					
					if(strpos($items[$k]["url_title"], "http://") === 0 || strpos($items[$k]["url_title"], "https://") === 0 || strpos($items[$k]["url_title"], "/") === 0){
						$items[$k]["url"] = $items[$k]["url_title"];
					}else{
						$items[$k]["url"] = ($parent && $parent["url"] ? "/" . trim($parent["url"], "/") : "") . "/" . trim($items[$k]["url_title"], "/");
						if(strpos($items[$k]["url_title"], "#") === false) $items[$k]["url"] .= "/";
					}
					
					$items[$k]["active"] = $this->request_uri && strpos($this->request_uri, $items[$k]["url"]) === 0;
				}else $items[$k] = null;
				
				if($items[$k]["items"]){
					$items[$k]["items"] = $this->updateMenuLinks($items[$k], $items[$k]["items"], $links);
					foreach($items[$k]["items"] as $item){
						if($item["active"]){
							$items[$k]["active"] = true;
							break;
						}
					}
					
					foreach($items[$k]["items"] as $i1 => $item1) foreach($items[$k]["items"] as $i2 => $item2){
						if($item1["active"] && $item2["active"]){
							if(strpos($item1["url"], $item2["url"]) === 0){
								$items[$k]["items"][$i2]["active"] = false;
								$items[$k]["items"][$i1]["active"] = true;
							}else{
								$items[$k]["items"][$i1]["active"] = false;
								$items[$k]["items"][$i2]["active"] = true;
							}
						}
					}
					
				}
				$items = array_filter($items, "is_array");
				if(empty($items)) $items = null;
			}
		}
		return $items;
	}//updateMenuLinks
	
	function urlTittle2URL($url, $items){
		$item = $this->getMenuItem($url, $items);
		return $item ? $item["url"] : false;
	}//urlTittle2URL
	
	function getMenuItem($url, $items){
		if(is_array($items)) foreach($items as $item){
			if(isset($item["url_title"]) && strtolower(trim($item["url_title"], "/")) == strtolower($url)) return $item;
			else if(isset($item["items"])){
				if($r = $this->getMenuItem($url, $item["items"])) return $r;
			}
		}
		return false;
	}//getMenuItem
	
}

?>