<?php

	class FileModel extends FJF_BASE_RICH
	{
		private $messagesReplace = array();
		public $messages = array(
			"error_upload_file" => "Error: Invalid file.",
			"error_max_file_size" => "Error: File size is too large. Maximum file size allowed is VAR_MAX_FILE_SIZE bytes.",
			"error_forbidden_file_type" => "Error: Forbidden file type. Allowed extensions are VAR_ALLOWED_EXT.",
			"error_invalid_file" => "Error: File name cannot be blank.",
			"error_move_file" => "Error: Cannot move the file. Probably, read/write permission problem."
		);
		
		function _upload($folder = null, $newFileName = null, $fieldName = "file", $ALLOWED_EXT = null, $maxFileSize = 10485760, $multipleItemKey = null)
		{
			if(!$folder) $folder = $_SERVER["DOCUMENT_ROOT"] . "/files/";
			
			$error = false;
			$status = "";

      if($multipleItemKey === 0 || intval($multipleItemKey) > 0){
        $fileName = isset($_FILES[$fieldName]['name'][$multipleItemKey]) ? $_FILES[$fieldName]['name'][$multipleItemKey] : '';
        $fileType = isset($_FILES[$fieldName]['type'][$multipleItemKey]) ? $_FILES[$fieldName]['type'][$multipleItemKey] : '';
        $tempName = isset($_FILES[$fieldName]['tmp_name'][$multipleItemKey]) ? $_FILES[$fieldName]['tmp_name'][$multipleItemKey] : '';
        $fileSize = isset($_FILES[$fieldName]['size'][$multipleItemKey]) ? $_FILES[$fieldName]['size'][$multipleItemKey] : '';
      }
      else{
  			$fileName = isset($_FILES[$fieldName]['name']) ? $_FILES[$fieldName]['name'] : '';
  			$fileType = isset($_FILES[$fieldName]['type']) ? $_FILES[$fieldName]['type'] : '';
  			$tempName = isset($_FILES[$fieldName]['tmp_name']) ? $_FILES[$fieldName]['tmp_name'] : '';
  			$fileSize = isset($_FILES[$fieldName]['size']) ? $_FILES[$fieldName]['size'] : '';
			}
			$maxFileSize = isset($_POST['max_size']) ? $_POST['max_size'] : $maxFileSize;

			$extension = strtolower(preg_replace("/.+\./","",$fileName));
			$newFileName = ($newFileName ? $newFileName : time()) . "." . $extension;
			$destinationFile = $folder . $newFileName;
			
			$this->messagesReplace["VAR_MAX_FILE_SIZE"] = $maxFileSize;
			$this->messagesReplace["VAR_FILE_NAME"] = $newFileName;
			if(is_array($ALLOWED_EXT)) $this->messagesReplace["VAR_ALLOWED_EXT"] = join(", ", $ALLOWED_EXT);
			
			if(trim($fileName) == "") $error = "error_invalid_file";
			elseif(is_array($ALLOWED_EXT) && !in_array($extension, $ALLOWED_EXT)) $error = "error_forbidden_file_type";
			elseif(!is_uploaded_file($tempName)) $error = "error_upload_file";
			elseif($fileSize > $maxFileSize) $error = "error_max_file_size";
			elseif(!@move_uploaded_file($tempName, $destinationFile) || (@chmod($destinationFile, 0777) && false)) $error = "error_move_file";
			@unlink($tempName);

			if($error) $status = $this->message($error);

			return array("error" => $error, "status" => $status, "file" => $newFileName, "file_type" => $fileType, "extension" => $extension);
		} // /upload()
		
		function upload($folder, $newFileName = null, $fieldName = "file", $ALLOWED_EXT = null, $maxFileSize = 10485760)
		{
			$filesPath = preg_replace("/\/+$/","",$_SERVER["DOCUMENT_ROOT"]) . "/files/" . $folder . "/";
			return $this->_upload($filesPath, $newFileName, $fieldName, $ALLOWED_EXT, $maxFileSize);
		}//upload
		
		public function message($m)
		{
			return isset($this->messages[$m]) ? str_replace(array_keys($this->messagesReplace), $this->messagesReplace, $this->messages[$m]) : "";
		}//message
		
	} // end class PhotoModel
?>