<?php

class GlobalSeoControllerModel
{
	public $all = null;
	private $file = null;

	function __construct()
	{
		$this->file = $GLOBALS["WEB_APPLICATION_CONFIG"]["app_web_path"] . "/includes/global_seo_controller.txt";
		$this->all();
	}

	function all()
	{
		if(!$this->all)
		{
			$this->all = array_map("trim", file($this->file));
			/*
			$f = '@list($a["id"], $a["mask"], $a["text"]';
			$f .= ', $a["meta_title"], $a["meta_keywords"], $a["meta_description"], $a["extra_header_tags"], $a["pixel_top"], $a["pixel_bottom"]';
			$f .= ') = explode("\t", $v);';
			$f .= 'return $a;';
			$this->all = array_map(create_function('$v', $f), $this->all());
			*/
			$find = array("\\n", "\\t");
			$replace = array("\n", "\t");
			$tmp = array();
			foreach($this->all() as $v){
				$a = array();
				@list($a["id"], $a["mask"], $a["text"], $a["meta_title"], $a["meta_keywords"], $a["meta_description"], $a["extra_header_tags"], $a["pixel_top"], $a["pixel_bottom"]) = explode("\t", $v);
				$a["extra_header_tags"] = str_replace($find, $replace, $a["extra_header_tags"]);
				$a["pixel_top"] = str_replace($find, $replace, $a["pixel_top"]);
				$a["pixel_bottom"] = str_replace($find, $replace, $a["pixel_bottom"]);
				$tmp[] = $a;
			}
			$this->all = $tmp;
		}
		return $this->all;
	}//all

	function collection()
	{
		foreach($this->all() as $item) $result[$item["id"]] = $item;
		ksort($result);
		return $result;
	}//collection

	function text($id)
	{
		$result = array(
										"id" => null,
										"text" => null,
										"mask" => array(),
										"meta_title" => null,
										"meta_keywords" => null,
										"meta_description" => null,
										"extra_header_tags" => null,
										"pixel_top" => null,
										"pixel_bottom" => null
										);
		if($id > 0)
		{
			foreach($this->all() as $item)
			{
				if($item["id"] == $id)
				{
					$result["id"] = $id;
					$result["text"] = $item["text"];
					$result["mask"][] = $item["mask"] . "\n";
					$result["meta_title"] = $item["meta_title"];
					$result["meta_keywords"] = $item["meta_keywords"];
					$result["meta_description"] = $item["meta_description"];
					$result["extra_header_tags"] = $item["extra_header_tags"];
					$result["pixel_top"] = $item["pixel_top"];
					$result["pixel_bottom"] = $item["pixel_bottom"];
				}
			}
			if($result["id"]) sort($result["mask"]);
		}
		return $result["id"] ? $result : null;
	}//text

	function save($data)
	{
		if(!$data["id"]) $data["id"] = $this->id();
		if($data["id"] == 1)
		{
			$id = (count($this->all) - 1);
			$this->all[$id]["text"] = $data["text"];
			$this->all[$id]["meta_title"] = $data["meta_title"];
			$this->all[$id]["meta_keywords"] = $data["meta_keywords"];
			$this->all[$id]["meta_description"] = $data["meta_description"];
			$this->all[$id]["extra_header_tags"] = $data["extra_header_tags"];
			$this->all[$id]["pixel_top"] = $data["pixel_top"];
			$this->all[$id]["pixel_bottom"] = $data["pixel_bottom"];
		}
		else
		{
			$this->_delete($data["id"]);
			$mask = $data["mask"];
			foreach(array_filter(array_map("trim", explode("\n", $mask)), "strlen") as $item)
			{
				$data["mask"] = $item;
				array_unshift($this->all, $data);
			}
		}
		return $this->_save();
	}//save

	function _save()
	{
		/*
		$f = 'return $v["id"]."\t".$v["mask"]."\t".$v["text"]';
		$f .= '."\t".$v["meta_title"]."\t".$v["meta_keywords"]."\t".$v["meta_description"]."\t".$v["extra_header_tags"]."\t".$v["pixel_top"]."\t".$v["pixel_bottom"]';
		$f .= ';';
		$result = array_map(create_function('$v', $f), $this->all());
		*/
		
		$find = array("\r", "\n", "\t");
		$replace = array("", "\\n", "\\t");
		
		$result = array();
		foreach($this->all() as $v){
			$s = $v["id"];
			$s .= "\t";
			$s .= $v["mask"];
			$s .= "\t";
			$s .= $v["text"];
			$s .= "\t";
			$s .= $v["meta_title"];
			$s .= "\t";
			$s .= $v["meta_keywords"];
			$s .= "\t";
			$s .= $v["meta_description"];
			$s .= "\t";
			$s .= str_replace($find, $replace, $v["extra_header_tags"]);
			$s .= "\t";
			$s .= str_replace($find, $replace, $v["pixel_top"]);
			$s .= "\t";
			$s .= str_replace($find, $replace, $v["pixel_bottom"]);
			$result[] = $s;
		}
		return file_put_contents($this->file, join("\n", $result));
	}//_save

	function _delete($id)
	{
		return $this->all = array_filter($this->all(), create_function('$v', 'return $v["id"] == 1 || $v["id"] != ' . $id . ';'));
	}//_delete

	function delete($id)
	{
		if(!is_array($id)) $id = array($id);
		foreach($id as $v) $this->_delete($v);
		return $this->_save();
	}//delete

	function id()
	{
		$ids = array();
		foreach($this->all() as $item) $ids[] = $item["id"];
		return max($ids)+1;
	}//id


}

?>