<?php
	class MainModel extends FJF_BASE_RICH
	{
		////
		// returns page max position
		//
		function getMaxPosition($tableName = "", $where = "")
		{
			FJF_BASE::log("", __METHOD__);

			$position = 0;

			if (FJF_BASE::db_open() && trim($tableName) != "")
			{
				$sql = "SELECT MAX(position) AS max_position FROM " . $tableName;
				if ($where != "")
				{
					$sql = $sql . " WHERE " . $where;
				}
				$result = FJF_BASE::db_get_many($sql);

				if (is_array($result) && is_object($result[0]) && $result[0]->max_position > 0)
				{
					$position = $result[0]->max_position;
					unset($result);
				}
				FJF_BASE::db_close();

			}

			return $position;
		} // /getMaxPosition()



		////
		// changes  position
		//
		function changePosition($tableName = "", $id = 0, $position = 0, $mode = "", $where = "")
		{
			FJF_BASE::log("Params:[]", __METHOD__);
			if($id > 0 && $position > 0 && ($mode == "move_up" || $mode == "move_down") && $tableName != "")
			{
				if($mode == "move_up" && $position == 1)
				{
					return true;
				}

				$maxPosition = $this->getMaxPosition($tableName, $where);

				if($mode == "move_down" && $position == $maxPosition)
				{
					return true;
				}

				$oldPosition = $position;
				$newPosition = ($mode == "move_up") ? $oldPosition - 1 : $oldPosition + 1;

				if(FJF_BASE::db_open())
				{
					$sql = "UPDATE " . $tableName . " SET position=" . $oldPosition  . " WHERE position=" . $newPosition;
					if ($where != "")
					{
						$sql = $sql . " AND " . $where;
					}
					$result = FJF_BASE::db_execute($sql);

					if($result)
					{
						$sql = "UPDATE " . $tableName . " SET position=" . $newPosition . " WHERE id='" . FJF_BASE::db_escape($id) . "'";
						$result = FJF_BASE::db_execute($sql);

						if($result)
						{
							FJF_BASE::db_close();
							return true;
						}
					}

					FJF_BASE::db_close();
				}

			}

			return false;
		} // /changePosition()


		////
		// restores positions
		//
		function restorePositions($tableName = "", $where = "")
		{
			FJF_BASE::log("", __METHOD__);

			$position = 0;

			if (FJF_BASE::db_open() && trim($tableName) != "")
			{
				$sql = "SELECT id FROM " . $tableName;
				if ($where != "")
				{
					$sql .= " WHERE " . $where;
				}
				$sql .= " ORDER BY position";
				$records = FJF_BASE::db_get_many($sql);
				if (is_array($records) && count($records) > 0)
				{
					$positionID = 1;
					foreach ($records as $record)
					{
						$sql = "UPDATE " . $tableName . " SET position='" . $positionID . "' WHERE id='" . $record->id . "'";
						$result = FJF_BASE::db_execute($sql);
						$positionID++;
					}
					unset($records);
				}

				FJF_BASE::db_close();

			}

			return $position;
		} // /restorePositions()
	}
?>