<?php

	class MemcacheModel{
		
		var $memcache = null;
		private $settings = null;
		
		function __construct(){
			include_once FJF_ROOT . '/settings_memcache.php';
			$this->settings = $GLOBALS["WEB_APPLICATION_CONFIG"]["memcache"];
			$this->memcache = memcache_connect(
				$this->settings["host"],
				$this->settings["port"]
			);
		}
		
		function createKey($key){
			if(is_object($key)) $key = get_object_vars($key);
			if(is_array($key)) $key = implode('_', $key);
			return $key;
		}
		
		function set($key, $value, $expire = null, $flag = null){
			if(!$this->memcache) return false;
			if(is_array($value) || is_object($value)) $value = serialize($value);
			if($expire === null) $expire = $this->settings["expire"];
			if($flag !== null) $flag = is_bool($value) || is_numeric($value) ? false : MEMCACHE_COMPRESSED;
			return memcache_set($this->memcache, $key, $value, $flag, $expire);
		}
		
		function get($key){
			if(!$this->memcache) return false;
			$value = memcache_get($this->memcache, $key);
			if($value && @unserialize($value) !== false) $value = unserialize($value);
			return $value;
		}
		
		function delete($key){
			if(!$this->memcache) return false;
			return memcache_delete($this->memcache, $key);
		}
		
	 
	}

?>