<?php

	class PagesModel extends FJF_BASE_RICH
	{
		
		function records($where = "", $params = null, $order = null, $limit = null)
		{
			$sql = "";
			$sql .= "SELECT p.id, p.color, pr.title, pr.url_title, pr.description, pr.meta_title, pr.meta_keywords, pr.meta_description, p.type, p.template, pr.is_index";
			$sql .= " FROM cms_content_revisions pr";
			$sql .= " LEFT JOIN cms_content p ON pr.item_id=p.id";
			$sql .= " WHERE p.current_id=pr.id AND p.status=1 AND pr.published=1";
			$sql .= " AND (pr.use_date_publish=0 OR pr.date_publish<'CURRENT_DATE')";
			$sql .= " AND (pr.use_date_expiration=0 OR pr.date_expiration>'CURRENT_DATE')";
			$sql .= " AND (p.need_approval=0 OR pr.approval=1)";
			
			$sql .= $where ? " AND (" . $where . ")" : "";
			$sql .= " ORDER BY " . ($order ? $order : "pr.title");
			if($limit) $sql .= " LIMIT " . $limit;
			
			if(!is_array($params)) $params = array();
			$params["CURRENT_DATE"] = date('Y-m-d H:i:s');
			
			$result = $this->selectRecords($sql, $params);
			return $result;
		}//records
		
		function recordsBy($val = "", $key = "p.center_id", $order = null, $limit = null)
		{
			if(!is_array($val)) $val = array($val);
			$key = explode(",", $key);
			$params = array();
			$where = array();
			foreach($val as $i => $v)
			{
				$params["SEARCH_KEY_" . $i . "_"] = $key[$i];
				$params["SEARCH_VAL"] = $v;
				$where[] = "SEARCH_KEY_" . $i . "_='SEARCH_VAL_" . $i . "_'";
			}
			$where = join(" AND ", $where);
			
			$result = $this->records($where, $params);
			return $result;
		}//recordsBy
		
		function record($where = "", $params = null, $order = null)
		{
			$result = $this->records($where, $params, $order, 1);
			return $result ? $result[0] : $result;
		}//record
		
		function recordBy($val = "", $key = "pr.url_title")
		{
			if(!is_array($val)) $val = array($val);
			$key = explode(",", $key);
			$params = array();
			$where = array();
			foreach($val as $i => $v)
			{
				$params["SEARCH_KEY_" . $i . "_"] = $key[$i];
				$params["SEARCH_VAL_" . $i . "_"] = $v;
				$where[] = "SEARCH_KEY_" . $i . "_='SEARCH_VAL_" . $i . "_'";
			}
			$where = join(" AND ", $where);
			
			$result = $this->record($where, $params);
			return $result;
		}//recordBy
		
	}
?>