<?php


class PaginationModel
{
	public $shift = 0;
	public $page = 1;
	public $count = 0;
	public $pages = null;
	public $limit = 0;
	public $first_page = "&lt;&lt;";
	public $last_page = "&gt;&gt;";
	public $prev_page = "&lt;";
	public $next_page = "&gt;";
	
	function __construct()
	{
		$this->page = isset($_REQUEST["page"]) ? intval($_REQUEST["page"]) : 1;
	}
	
	function pages($url = "#", $recordsCount = 0, $resultsPerPage = 2, $pn = true, $fl = true, $d = 2, $dd = 2, $ddd = 1)
	{
		$this->count = ceil($recordsCount / $resultsPerPage);
		
		$URL = null;
		if($this->page > $this->count && $this->count > 0) $URL = str_replace("PAGE", $this->count, $url);
		if($this->page < 1) $URL = str_replace("PAGE", 1, $url);
		if($URL) FJF_BASE::redirect($URL);
		
		if($this->count > 1)
		{
			$this->pages = array();
			if($this->page - 1 < $d) $d = $d*2-$this->page+1;
			elseif($this->count - $this->page < $d) $d = $d*2-$this->count+$this->page;
			
			for($i = 1; $i <= $this->count; $i++)
			{
				if(abs($i - $this->page) <= $d || ($i % 10 == 0 && abs($i - $this->page) <= 10*$dd) || ($i % 100 == 0 && abs($i - $this->page) <= 100*$ddd))
				{
					$page["page"] = $i;
					$page["PAGE"] = $i;
					$page["active"] = $i == $this->page ? true : false;
					$page["url"] = str_replace("PAGE", $page["PAGE"], $url);
					$this->pages[] = $page;
				}
			}
			
			if($pn)
			{
				if($this->page > 1)
				{
					$page["page"] = $this->prev_page;
					$page["PAGE"] = $this->page - 1;
					$page["active"] = false;
					$page["url"] = str_replace("PAGE", $page["PAGE"], $url);
					array_unshift($this->pages, $page);
				}
				if($this->page < $this->count)
				{
					$page["page"] = $this->next_page;
					$page["PAGE"] = $this->page + 1;
					$page["active"] = false;
					$page["url"] = str_replace("PAGE", $page["PAGE"], $url);
					array_push($this->pages, $page);
				}
			}
			
			if($fl)
			{
				if($this->page > 1)
				{
					$page["page"] = $this->first_page;
					$page["PAGE"] = 1;
					$page["active"] = false;
					$page["url"] = str_replace("PAGE", 1, $url);
					array_unshift($this->pages, $page);
				}
				if($this->page < $this->count)
				{
					$page["page"] = $this->last_page;
					$page["PAGE"] = $this->count;
					$page["active"] = false;
					$page["url"] = str_replace("PAGE", $page["PAGE"], $url);
					array_push($this->pages, $page);
				}
			}
		}
		
		$this->limit = ($this->page - 1)*$resultsPerPage+$this->shift . "," . $resultsPerPage;
		
		return $this->pages;
	}//pages
	
}


?>