<?php

class PricingModel{
	
	static $paymentTypes = array(
		"monthly" => "Monthly Price",
		"annual" => "Annual Price"
	);
	
	static function getTiersInfo(){
		$tiers = self::getTiers();
		if(isset($tiers[0])) unset($tiers[0]);
		if(isset($tiers[4])) unset($tiers[4]);
		return $tiers;
	}
	
	static function getTiers(){
		return $tiers = array(
			0 => array(
				"name" => "Locked",
				"limit" => array(
					"pages" => 1,
					"dashboards" => 0,
					"alerts" => 0,
					"charts" => null,
					"locked_pages" => array(
						"dashboard" => "/dashboard/locked/",
						"account_dashboard" => "/account-dashboard/locked/",
						"alert_dashboard" => "/alert-dashboard/locked/"
					)
				)
			),
			1 => array(
				"name" => "Basic Plan",
				"monthly" => array(
					"plan_id" => "basic_plan_monthly",
					"price" => 30
				),
				"annual" => array(
					"plan_id" => "basic_plan_annual",
					"price" => 325
				),
				"trial" => "2 weeks",
				"signals" => array(
					"crowd_sentiment" => true,
					"mp_sentiment" => false,
					"buzz" => true
				),
				"limit" => array(
					"pages" => $GLOBALS["WEB_APPLICATION_CONFIG"]["tier_levels"][1],
					"dashboards" => 10,
					"alerts" => 10,
					"charts" => array(
						"price",
						"sentiment",
						"moving-average-sentiment",
						"zscore",
						"moving-average-zscore",
						"buzz",
						"tweetvolume",
					  "user-score",
						"user-rank"
					)
				)
			),
			2 => array(
				"name" => "Active Plan",
				"monthly" => array(
					"plan_id" => "active_plan_monthly",
					"price" => 50
				),
				"annual" => array(
					"plan_id" => "active_plan_annual",
					"price" => 540
				),
				"trial" => "2 weeks",
				"signals" => array(
					"crowd_sentiment" => true,
					"mp_sentiment" => true,
					"buzz" => true
				),
				"limit" => array(
					"pages" => $GLOBALS["WEB_APPLICATION_CONFIG"]["tier_levels"][2],
					"dashboards" => 30,
					"alerts" => 30,
					"charts" => null
				)
			),
			3 => array(
				"name" => "Pro Plan",
				"monthly" => array(
					"plan_id" => "pro_plan_monthly",
					"price" => 150
				),
				"annual" => array(
					"plan_id" => "pro_plan_annual",
					"price" => 1620
				),
				"trial" => "2 weeks",
				"signals" => array(
					"crowd_sentiment" => true,
					"mp_sentiment" => true,
					"buzz" => true
				),
				"limit" => array(
					"pages" => $GLOBALS["WEB_APPLICATION_CONFIG"]["tier_levels"][3],
					"dashboards" => null,
					"alerts" => null,
					"charts" => null
				)
			),
			4 => array(
				"name" => "Unlimited",
				"limit" => array(
					"pages" => null,
					"dashboards" => null,
					"alerts" => null,
					"charts" => null
				)
			)
		);
	}

	static function getPagesLimit($key = null){
		$result = array();
		if($info = self::getTiers()){
			foreach($info as $level => $item){
				$result[$level] = isset($item["limit"]["pages"]) ? $item["limit"]["pages"] : null;
			}
		}
		if($key !== null){
			$result = array_key_exists($key, $result) ? $result[$key] : 0;
		}
		return $result;
	}
	
	static function getDashboardsLimit($key = null){
		$result = array();
		if($info = self::getTiers()){
			foreach($info as $level => $item){
				$result[$level] = isset($item["limit"]["dashboards"]) ? $item["limit"]["dashboards"] : null;
			}
		}
		if($key !== null){
			$result = array_key_exists($key, $result) ? $result[$key] : 0;
		}
		return $result;
	}
	
	static function getAlertsLimit($key = null){
		$result = array();
		if($info = self::getTiers()){
			foreach($info as $level => $item){
				$result[$level] = isset($item["limit"]["alerts"]) ? $item["limit"]["alerts"] : null;
			}
		}
		if($key !== null){
			$result = array_key_exists($key, $result) ? $result[$key] : 0;
		}
		return $result;
	}
	
	static function getChartLimit($key = null){
		$result = array();
		if($info = self::getTiers()){
			foreach($info as $level => $item){
				$result[$level] = isset($item["limit"]["charts"]) ? $item["limit"]["charts"] : null;
			}
		}
		if($key !== null){
			$result = array_key_exists($key, $result) ? $result[$key] : array();
		}
		return $result;
	}
	
	static function isLockedPage($key, $cmd){
		$result = false;
		if($info = self::getTiers()){
			if(isset($info[$key]["limit"]["locked_pages"]) && is_array($info[$key]["limit"]["locked_pages"])){
				if(array_key_exists($cmd, $info[$key]["limit"]["locked_pages"])){
					$result = $info[$key]["limit"]["locked_pages"][$cmd];
				}
			}
		}
		return $result;
	}
	
}

?>