<?php
  include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/rest_model.php");

  class SentimentModel extends FJF_BASE_RICH
  {
    var $restModel = null;
		var $mode = null;
    
    function getStocks($key, $limit)
    {
      $records = null;
      $params['SEARCH_KEY'] = $key;
      if ($key != '')
      {
        $sql = "SELECT s.TICKER AS ticker, s.COMPANY_NAME AS company_name, EXCHANGE_NAME AS exchange_name";
        $sql .= " FROM SecurityMaster s";
        $sql .= " WHERE s.TICKER='SEARCH_KEY' OR s.TICKER LIKE '%SEARCH_KEY%' OR s.COMPANY_NAME LIKE '%SEARCH_KEY%'";
        $sql .= " ORDER BY CASE WHEN s.TICKER='SEARCH_KEY' THEN 1 WHEN s.TICKER LIKE 'SEARCH_KEY%' THEN 2 WHEN s.TICKER LIKE '%SEARCH_KEY%' THEN 3 WHEN s.TICKER LIKE 'SEARCH_KEY%' THEN 4 WHEN s.COMPANY_NAME LIKE '%SEARCH_KEY%' THEN 5 END";
        if ($limit > 0) $sql .= " LIMIT " . $limit;
        $this->db("sentiment");
				$records = $this->selectRecords($sql,$params);
        $this->db();
      }
      return $records;
    }
    
    function checkStock($userID, $tickerID)
    {
      $prams['USER_ID'] = $userID;
      $prams['TICKER_ID'] = $tickerID;
      $result = $this->getRecords("users_stocks", "user_id='USER_ID' AND ticker='TICKER_ID'", $prams, true, 'id');
      return ($result) ? $result->id : false;
    }
    
    function addStock($fields)
    {
      $result = $this->saveRecord("users_stocks", $fields);
      if ($result && isset($fields['ticker']) && $fields['ticker'] != "")
      {
        $this->refreshStocksData(array($fields['ticker']));
      }
      return $result;
    }
    
    function removeStock($id){
    	$result = false;
			if($stock = FJF_BASE_RICH::getRecordBy("users_stocks", $id)){
				$result = $this->deleteRecord("users_stocks", $id);
			}
      return $result;
    }
    
    function getUserTickers($where = null, $params = null, $limit = null, $order = null, $fields = null)
    {
      $sql = "SELECT ".($fields ? $fields :"us.id, us.ticker");
      $sql .= " FROM users_stocks us";
      $sql .= " WHERE 1";
      $sql .= ($where) ? " AND ".$where : '';
      if ($order) $sql .= " ORDER BY ".$order;
      if ($limit) $sql .= " LIMIT ".$limit;
      $records = $this->selectRecords($sql, $params);
      return $records;
    }
    
    function getUserTicker($where = null, $params = null, $fields = null, $order = null)
    {
      $record = $this->getUserTickers($where, $params, 1, $order, $fields);
      return ($record) ? $record[0] : null;
    }
    
    function getUserStock($where = null, $params = null, $fields = null, $order = null)
    {
      $record = $this->getUserStocks($where, $params, 1, $order, $fields);
      return ($record) ? $record[0] : null;
    }
    
    function getUserStocks($where = null, $params = null, $limit = null, $order = null, $fields = null)
    {
      $records = null;
      $userTickers = $this->getUserTickers("us.user_id='USER_ID'", $params, null, null, 'us.ticker');
      if ($userTickers)
      {
        $tickerIds = array();
        foreach($userTickers as $item)
        {
          $tickerIds[] = $item->ticker;
        }
        if ($this->refreshStocksData($tickerIds))
        {
          $sql = "SELECT ".($fields ? $fields :"us.id, us.ticker, sd.exchange, sd.company, sd.sentiment, sd.price, sd.percent_change, sd.buzz");
          $sql .= " FROM users_stocks us";
          $sql .=" LEFT JOIN stocks_data sd";
          $sql .= " ON us.ticker = sd.ticker";
          $sql .= " WHERE 1";
          $sql .= ($where) ? " AND ".$where : '';
          if ($order) $sql .= " ORDER BY ".$order;
          if ($limit) $sql .= " LIMIT ".$limit;
          $records = $this->selectRecords($sql, $params);
        }
      }
      return $records;
    }
    
    function getUserStocksCount($where = null, $params = null)
    {
    	$sql = "SELECT COUNT(us.id) AS cid";
      $sql .= " FROM users_stocks us";
      if($where) $sql .= " WHERE " . $where;
      return $this->getCount($sql, $params);
    }
            
    function getWordCloudData($where = null, $params = null, $fields = null)
    {
      $sql = "SELECT ".($fields ? $fields :"wc.*");
      $sql .= " FROM WordCloudData wc";
      if($where) $sql .= " WHERE " . $where;
      $this->db("sentiment");
      $records = $this->selectRecords($sql, $params);
      $this->db();
      return $records;
    }
    
    function getStocksInfo($where = null, $params = null, $limit = null, $order = null, $fields = null)
    {
      $sql = "SELECT ".($fields ? $fields :"s.*");
      $sql .= " FROM SecurityMaster s";
      $sql .= " WHERE 1";
      $sql .= ($where) ? " AND ".$where : '';
      if ($order) $sql .= " ORDER BY ".$order;
      if ($limit) $sql .= " LIMIT ".$limit;
			$this->db("sentiment");
      $records = $this->selectRecords($sql, $params);
			$this->db();
      return $records;
    }
        
    function getStocksData($where = null, $params = null, $limit = null, $order = null, $fields = null)
    {
      $sql = "SELECT ".($fields ? $fields :"sd.*");
      $sql .= " FROM stocks_data sd";
      $sql .= " WHERE 1";
      $sql .= ($where) ? " AND ".$where : '';
      if ($order) $sql .= " ORDER BY ".$order;
      if ($limit) $sql .= " LIMIT ".$limit;
      $records = $this->selectRecords($sql, $params);
      return $records;
    }
        
    function refreshStocksData($tickers)
    {
      if ($tickers && is_array($tickers) && $tickers)
      {
        $tickerIds = implode("','", $tickers);
        $GLOBALS["WEB_APPLICATION_CONFIG"]["FJF_BASE_key"] = "ticker";
        $existsTickers = $this->getStocksData("sd.ticker IN('" . $tickerIds . "')", null, null, null, 'sd.ticker');
        if ($existsTickers == null) $existsTickers = array();
        $sentimentsData = $this->getSentimentsData($tickers);
        $priceData = $this->getStockPrice($tickers);
        $fileds = array();
        if ($sentimentsData)
        {
          foreach($sentimentsData as $item)
          {
            $fileds[$item->ticker]['ticker'] = (isset($item->ticker) && $item->ticker) ? $item->ticker : '';
            $fileds[$item->ticker]['company'] = (isset($item->company) && $item->company) ? $item->company : '';
            $fileds[$item->ticker]['sentiment'] = (isset($item->sentiment) && $item->sentiment) ? $item->sentiment : 0;
						$fileds[$item->ticker]['mp_sentiment'] = (isset($item->mp_sentiment) && $item->mp_sentiment) ? $item->mp_sentiment : 0;
            $fileds[$item->ticker]['buzz'] = (isset($item->buzz) && $item->buzz) ? $item->buzz : 0;
						$fileds[$item->ticker]['exchange'] = (isset($item->exchange) && $item->exchange) ? $item->exchange : '';
          }
        }
        if ($priceData)
        {
          foreach($priceData as $item)
          {
            $fileds[$item->Symbol]['ticker'] = (isset($item->Symbol) && $item->Symbol) ? $item->Symbol : '';
            $fileds[$item->Symbol]['price'] = (isset($item->Last) && $item->Last) ? $item->Last : 0;
            $fileds[$item->Symbol]['percent_change'] = (isset($item->PercentChange) && $item->PercentChange) ? $item->PercentChange : 0;
          }
        }
        foreach ($fileds as $key => $record)
        {
          $record['date_update'] = date("Y-m-d H:i:s");
          if (array_key_exists($key, $existsTickers))
          {
            $this->saveRecord('stocks_data',$record,'ticker');
          }
          else
          {
            $this->saveRecord('stocks_data',$record);
          }
        }
      }
      return true;
    }
    
    function getSentimentsData($tickers)
    {
      $records = array();
      $time = strtotime(date("Y-m-d H:i:00", strtotime('-1 minute')));
      if ($tickers && is_array($tickers))
      {
        $tickerIds = implode("','", $tickers);
        $sql = "SELECT sm.TICKER AS ticker, sm.COMPANY_NAME AS company, sm.EXCHANGE as exchange, sd.AVERAGE_SENTIMENT AS sentiment, bd.BUZZ AS buzz, msd.SIGNAL_VALUE AS mp_sentiment";
        $sql .= " FROM  SecurityMaster sm";

        $sql .= " LEFT JOIN SentimentData_Averaged sd";
        $sql .= " ON sd.TICKER = sm.TICKER AND sd.TS = FROM_UNIXTIME(".$time.") AND sd.WINDOW_SIZE = 60";
        $sql .= " LEFT JOIN TweetBuzzData bd";
        $sql .= " ON bd.TICKER = sm.TICKER AND bd.TS = FROM_UNIXTIME(".$time.") AND bd.WINDOW_SIZE = 60";
				$sql .= " LEFT JOIN TradingSignalData_Last msd";
        $sql .= " ON msd.TICKER = sm.TICKER AND msd.TS = FROM_UNIXTIME(".$time.") AND msd.WINDOW_SIZE = 60 AND msd.FREQUENCY = 60";
        
        $sql .= " WHERE sm.TICKER IN('" . $tickerIds . "')";
        $sql .= " GROUP BY sm.TICKER";
        //test($sql);
        $this->db("sentiment");
        $records = $this->selectRecords($sql);
        $this->db();
      }
      return $records;
    }

    function getStockPrice($tickers)
    {
      $results = array();
      if ($tickers && is_array($tickers))
      {
				$this->db("sentiment");
				if($stocks = FJF_BASE_RICH::getRecords(
						"PricingMaster"
					, "FIND_IN_SET(TICKER, 'TICKERS_LIST')"
					, array('TICKERS_LIST' => implode(",", $tickers))
					, null
					, "TICKER, PRICING_TICKER, API_NAME"
				)){
					include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/xignite_model.php");
					if ($records = XigniteModel::getQuotes($stocks))
					{
  					foreach($stocks as $item)
            {
              foreach ($records as $price)
              {
                if ($item->PRICING_TICKER == $price->Symbol)
                {
                  $results[$item->TICKER] = $price;
                  $results[$item->TICKER]->Symbol = $item->TICKER;
                  break;
                }
              }
            }
          }
				}
				$this->db();
      }
      return $results;
    }
    
    function getStockPriceForMinute($tickers)
    {
      $results = array();
      if ($tickers && is_array($tickers))
      {
        $this->db("sentiment");
        if($stocks = FJF_BASE_RICH::getRecords(
            "PricingMaster"
          , "FIND_IN_SET(TICKER, 'TICKERS_LIST')"
          , array('TICKERS_LIST' => implode(",", $tickers))
          , null
          , "TICKER, PRICING_TICKER, API_NAME"
        )){
          include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/xignite_model.php");
          $startTime = strtotime(date('Y-m-d H:i:00'));
          $endTime = $startTime + 60;
          if ($endTime != $startTime && $startTime > XigniteModel::getTicksMinTime() && $endTime < XigniteModel::getTicksMaxTime())
          {
            foreach($stocks as $item)
            {
              $results[$item->TICKER] = null;
              if ($record = XigniteModel::getTicks($item->TICKER, $item->API_NAME, $startTime, $endTime, 'Second'))
              {
                $results[$item->TICKER] = array_unique($record);
              }
            }
          }
        }
        $this->db();
      }
      return $results;
    }
    
    function getTopTrending()
    {
      $topTrending = array('topics' => null, 'stocks' => null);
      $records = array();
			/*
			if ($this->mode == 'MP'){
				$topTenCategory = 'MP_LAST_TRADING_SIGNAL';
      	$topTenFields = 'TICKER, BUZZ, SIGNAL_VALUE AVERAGE_SENTIMENT';
			}else{
				$topTenCategory = 'CROWD_SENTIMENT_AVERAGED';
      	$topTenFields = 'TICKER, BUZZ, AVERAGE_SENTIMENT';
			}
      $topTen[0] = $this->getTopTen($topTenCategory, 'TOP', $topTenFields);
			$topTen[1] = $this->getTopTen($topTenCategory, 'BOTTOM', $topTenFields);
			foreach($topTen as $item){
				if ($item) $records = array_merge($records, $item);
			}
			*/
			if($this->mode == 'MP'){
				$sql = "SELECT TICKER, BUZZ, SIGNAL_VALUE AVERAGE_SENTIMENT";
				$sql .= " FROM TickerCloudData_MP";
				$sql .= " WHERE TS=(SELECT TS FROM TickerCloudData_MP ORDER BY TS DESC LIMIT 1)";
				$this->db("sentiment");
	      $records = $this->selectRecords($sql);
	      $this->db();
			}else{
	      $sql = "SELECT TICKER, BUZZ, AVERAGE_SENTIMENT";
				$sql .= " FROM TickerCloudData_Crowd";
				$sql .= " WHERE TS=(SELECT TS FROM TickerCloudData_Crowd ORDER BY TS DESC LIMIT 1)";
				$this->db("sentiment");
	      $records = $this->selectRecords($sql);
	      $this->db();
			}

      if ($records)
      {
        foreach($records as $item)
        {
          if($item->BUZZ && $item->TICKER)
          {
            $info = new stdClass;
            $info->weight = number_format($item->BUZZ, 10, '.', '');
            $info->text = '<a href="/stock/' . $item->TICKER . '/"';
            if($item->AVERAGE_SENTIMENT > 0) $info->text .= ' data-color="#04BE00"';
            elseif($item->AVERAGE_SENTIMENT < 0) $info->text .= ' data-color="#FF0000"';
						elseif($item->AVERAGE_SENTIMENT == 0) $info->text .= ' data-color="#ADADAD"';
            $info->text .= '>' . $item->TICKER . '</a>';
            $info->text = utf8_encode($info->text);
						if(!is_array($topTrending['stocks'])) $topTrending['stocks'] = array();
            $topTrending['stocks'][] = $info;
          }
        }
      }

      if($dates = $this->getWordCloudData(
        "wc.TICKER IN ('QQQ','DJI','SPY') AND wc.WORD <> '' ORDER BY wc.TS DESC LIMIT 3", null, 'DISTINCT wc.TICKER, wc.TS'
      )){
        
        $params = array();
        foreach($dates as $i => $date){
          $dates[$i] = "wc.TS='TS_" . $i . "_VAL' AND wc.TICKER='TICKER_" . $i . "_VAL'";
          $params['TICKER_' . $i . '_VAL'] = $date->TICKER;
          $params['TS_' . $i . '_VAL'] = $date->TS;
        }
        
        $topTrending['topics'] = $this->getWordCloudData(
          "wc.WORD <> '' AND (" . implode(" OR ", $dates) . ") GROUP BY wc.WORD ORDER BY weight DESC LIMIT 15",
          $params,
          'wc.WORD AS text, SUM(wc.OCCURRENCES) AS weight'
        );
      }
      return $topTrending;
    }

    function getDataForAlerts($info)
    {
    	$fileds = array('time' => '');
      if ($info && is_array($info))
      {
        $sentimentsData = $this->getSentimentsDataForAlerts($info);
				$mpSentimentsData = $this->getMpSentimentsDataForAlerts($info);
        $lastPriceData = (in_array(5,$info['types']) || in_array(6,$info['types'])) ? $this->getStockPrice($info['tickers']) : null;
        $priceData = (in_array(5,$info['types']) || in_array(6,$info['types'])) ? $this->getStockPriceForMinute($info['tickers']) : null;
        if ($sentimentsData)
        {
          $fileds['time'] = (isset($sentimentsData[0]->time) && $sentimentsData[0]->time) ? $sentimentsData[0]->time : '';
          foreach($sentimentsData as $item)
          {
            $fileds[$item->ticker]['sentiment'] = (isset($item->sentiment) && $item->sentiment) ? $item->sentiment : null;
            $fileds[$item->ticker]['sentiment_avg'] = (isset($item->sentiment_avg) && $item->sentiment_avg) ? $item->sentiment_avg : null;
            $fileds[$item->ticker]['sentiment_change'] = (isset($item->sentiment_change) && $item->sentiment_change) ? $item->sentiment_change : null;
            $fileds[$item->ticker]['buzz'] = (isset($item->buzz) && $item->buzz) ? $item->buzz : null;
            $fileds[$item->ticker]['moving_average_z_score'] = (isset($item->moving_average_z_score) && $item->moving_average_z_score) ? $item->moving_average_z_score : null;
            $fileds[$item->ticker]['moving_average_sentiment'] = (isset($item->moving_average_sentiment) && $item->moving_average_sentiment) ? $item->moving_average_sentiment : null;
            $fileds[$item->ticker]['z_score'] = (isset($item->z_score) && $item->z_score) ? $item->z_score : null;
            $fileds[$item->ticker]['since_open'] = (isset($item->since_open) && $item->since_open) ? $item->since_open : null;
          }
        }
				if ($mpSentimentsData)
        {
          if (!$fileds['time']) $fileds['time'] = (isset($mpSentimentsData[0]->time) && $mpSentimentsData[0]->time) ? $mpSentimentsData[0]->time : '';
          foreach($mpSentimentsData as $item)
          {
						$fileds[$item->ticker]['mp_sentiment'] = (isset($item->mp_sentiment) && $item->mp_sentiment) ? $item->mp_sentiment : null;
            $fileds[$item->ticker]['mp_sentiment_avg'] = (isset($item->mp_sentiment_avg) && $item->mp_sentiment_avg) ? $item->mp_sentiment_avg : null;
            $fileds[$item->ticker]['mp_sentiment_change'] = (isset($item->mp_sentiment_change) && $item->mp_sentiment_change) ? $item->mp_sentiment_change : null;
            $fileds[$item->ticker]['mp_moving_average_z_score'] = (isset($item->mp_moving_average_z_score) && $item->mp_moving_average_z_score) ? $item->mp_moving_average_z_score : null;
            $fileds[$item->ticker]['mp_moving_average_sentiment'] = (isset($item->mp_moving_average_sentiment) && $item->mp_moving_average_sentiment) ? $item->mp_moving_average_sentiment : null;
            $fileds[$item->ticker]['mp_z_score'] = (isset($item->mp_z_score) && $item->mp_z_score) ? $item->mp_z_score : null;
            $fileds[$item->ticker]['mp_since_open'] = (isset($item->mp_since_open) && $item->mp_since_open) ? $item->mp_since_open : null;
          }
        }
        if ($lastPriceData)
        {
          foreach($lastPriceData as $item)
          {
            $fileds[$item->Symbol]['price'] = (isset($item->Last) && $item->Last) ? $item->Last : null;
            $fileds[$item->Symbol]['percent_change'] = (isset($item->PercentChange) && $item->PercentChange) ? $item->PercentChange : null;
          }
        }
        if ($priceData)
        {
          foreach($priceData as $ticker=>$item)
          {
            if($item) 
            {
              $fileds[$ticker]['price'] = implode(",",$item);
              if (isset($lastPriceData[$ticker]->PreviousClose) && $lastPriceData[$ticker]->PreviousClose)
              {
                $percentChanges = array();
                foreach($item as $price)
                {
                  $percentChanges[] = round(100*($price - $lastPriceData[$ticker]->PreviousClose)/$lastPriceData[$ticker]->PreviousClose, 3);
                }
                $fileds[$ticker]['percent_change'] = implode(",",$percentChanges);
              }
            }
          }
        }
      }
      return $fileds;
    }

    function getSentimentsDataForAlerts($info)
    {
      $records = array();
      if ($info && is_array($info))
      {
        $tickerIds = implode("','", $info['tickers']);
        $fields = '';
        $leftJoin = '';
        //$info['types'] = array(1,2,3,4,5,6,7,8,9,10,11,12,13,13,15,16,17);
        if (in_array(1,$info['types'])){
          $fields .= ' GROUP_CONCAT(FORMAT(S.SENTIMENT,8)) AS sentiment,';
          $leftJoin .= " LEFT JOIN SentimentData AS S";
          $leftJoin .= " ON (A.TICKER = S.TICKER AND S.TS BETWEEN DATE_SUB(A.TS, INTERVAL 1 MINUTE) AND A.TS)";
        }
        if (in_array(2,$info['types'])){
          $fields .= ' A.AVERAGE_SENTIMENT AS sentiment_avg,';
        }
        if (in_array(4,$info['types'])){
          $fields .= ' C.BUZZ AS buzz,';
          $leftJoin .= " LEFT JOIN TweetBuzzData AS C";
          $leftJoin .= " ON ( A.TICKER = C.TICKER AND A.TS = C.TS AND C.FREQUENCY = A.FREQUENCY AND C.WINDOW_SIZE = A.WINDOW_SIZE AND C.HISTORICAL_WINDOW_SIZE = 604800)";
        }
        if (in_array(3,$info['types'])){
          $fields .= ' IFNULL(D.SENTIMENT_CHANGE, A.AVERAGE_SENTIMENT) AS sentiment_change,';
          $leftJoin .= " LEFT JOIN SentimentData_PeriodicChanges AS D";
          $leftJoin .= " ON (A.TICKER = D.TICKER AND A.TS = D.TS AND A.FREQUENCY = D.FREQUENCY AND A.WINDOW_SIZE = D.WINDOW_SIZE)";
        }
        if (in_array(9,$info['types'])){
          $fields .= ' G.MOVING_AVERAGE AS moving_average_z_score,';
          $leftJoin .=" LEFT JOIN MovingAverageData_Z_Score AS G";
          $leftJoin .=" ON (A.TICKER = G.TICKER AND A.TS = G.TS AND A.FREQUENCY = G.FREQUENCY AND G.WINDOW_SIZE = 1800)";
        }
        if (in_array(8,$info['types'])){
          $fields .= ' E.MOVING_AVERAGE AS moving_average_sentiment,';
          $leftJoin .=" LEFT JOIN MovingAverageData_Sentiment AS E";
          $leftJoin .=" ON (A.TICKER = E.TICKER AND A.TS = E.TS AND A.FREQUENCY = E.FREQUENCY AND E.WINDOW_SIZE = 1800)";
        }
        if (in_array(7,$info['types'])){
          $fields .= ' F.Z_SCORE AS z_score,';
          $leftJoin .=" LEFT JOIN SentimentData_Z_Score AS F";
          $leftJoin .=" ON (A.TICKER = F.TICKER AND A.TS = F.TS AND A.FREQUENCY = F.FREQUENCY AND F.WINDOW_SIZE = 1800)";
        }
        if (in_array(10,$info['types'])){
          $fields .= ' I.SENTIMENT_CHANGE AS since_open,';
          $leftJoin .=" LEFT JOIN SentimentData_MarketOpenChanges AS I";
          $leftJoin .=" ON (A.TICKER = I.TICKER AND A.TS = I.TS AND A.FREQUENCY = I.FREQUENCY AND A.WINDOW_SIZE = I.WINDOW_SIZE)";
        }
        
        if ($fields) $fields = ", ".substr($fields, 0, -1); 
        $sql = "SELECT A.TICKER AS ticker, CONVERT_TZ(A.TS,'GMT','US/Eastern') AS time".$fields;
        $sql .= " FROM  SentimentData_Averaged AS A";
        if ($leftJoin) $sql .= $leftJoin;
        $sql .= " WHERE A.WINDOW_SIZE=60 AND A.FREQUENCY=60 AND A.TS = @TS";
        $sql .= " AND A.TICKER IN('" . $tickerIds . "')";
        $sql .= " GROUP BY A.TICKER";
        $sql .= " ORDER BY A.TICKER";
       	$this->db("sentiment");
        FJF_BASE_RICH::executeQuery("SELECT TS FROM SentimentData_Averaged ORDER BY TS DESC LIMIT 1 INTO @TS");
        FJF_BASE_RICH::executeQuery("SET SESSION group_concat_max_len = 2048");
        $records = $this->selectRecords($sql);
				$this->db();
      }
      return $records;
    }

		function getMpSentimentsDataForAlerts($info)
    {
      $records = array();
      if ($info && is_array($info))
      {
      	$tickerIds = implode("','", $info['tickers']);
        $fields = '';
        $leftJoin = '';
        //$info['types'] = array(11,12,13,14,15,16,17);
        if (in_array(11,$info['types'])){
          $fields .= ' GROUP_CONCAT(FORMAT(A.SIGNAL_VALUE,8)) AS mp_sentiment,';
        }
        if (in_array(15,$info['types'])){
          $fields .= ' GROUP_CONCAT(FORMAT(B.MOVING_AVERAGE,8)) AS mp_moving_average_sentiment,';
					$leftJoin .= " LEFT JOIN MovingAverageData_TradingSignal AS B";
          $leftJoin .= " ON (A.TS = B.TS AND B.FREQUENCY = 1 AND B.WINDOW_SIZE = 1800 AND A.TICKER = B.TICKER)";
        }
				if (in_array(16,$info['types'])){
          $fields .= ' GROUP_CONCAT(FORMAT(C.Z_SCORE,8)) AS mp_z_score,';
          $leftJoin .=" LEFT JOIN TradingSignalData_Z_Score AS C";
          $leftJoin .=" ON (A.TS = C.TS AND C.FREQUENCY = 1 AND C.WINDOW_SIZE = 1800 AND A.TICKER = C.TICKER)";
        }
				if (in_array(14,$info['types'])){
          $fields .= ' GROUP_CONCAT(FORMAT(D.MOVING_AVERAGE,8)) AS mp_moving_average_z_score,';
          $leftJoin .=" LEFT JOIN MovingAverageData_TradingSignal_Z_Score AS D";
          $leftJoin .=" ON (A.TS = D.TS AND D.FREQUENCY = 1 AND D.WINDOW_SIZE = 1800 AND A.TICKER = D.TICKER)";
        }
				if (in_array(12,$info['types'])){
          $fields .= ' E.AVERAGE_SIGNAL AS mp_sentiment_avg,';
					$leftJoin .= " LEFT OUTER JOIN TradingSignalData_Averaged AS E";
          $leftJoin .= " ON (E.TS = @TS_LOWER_BOUND AND E.FREQUENCY = 60 AND E.WINDOW_SIZE = 60 AND A.TICKER = E.TICKER)";
        }
        if (in_array(13,$info['types'])){
          $fields .= ' F.SIGNAL_CHANGE AS mp_sentiment_change,';
					$leftJoin .= " LEFT OUTER JOIN TradingSignalData_PeriodicChanges AS F";
          $leftJoin .= " ON (F.TS = @TS_LOWER_BOUND AND F.FREQUENCY = 60 AND F.WINDOW_SIZE = 60 AND A.TICKER = F.TICKER)";
        }
        if (in_array(17,$info['types'])){
          $fields .= ' G.CHANGE_FROM_OPEN AS mp_since_open,';
					$leftJoin .= " LEFT OUTER JOIN TradingSignalData_MarketOpenChanges AS G";
          $leftJoin .= " ON (G.TS = @TS_LOWER_BOUND AND G.FREQUENCY = 60 AND G.WINDOW_SIZE = 60 AND A.TICKER = G.TICKER)";
        }
        if ($fields){
        	$fields = ", ".substr($fields, 0, -1);
				}else{
					return $records;
				} 
        $sql = "SELECT A.TICKER AS ticker, CONVERT_TZ(A.TS,'GMT','US/Eastern') AS time".$fields;
        $sql .= " FROM  TradingSignalData AS A";
        if ($leftJoin) $sql .= $leftJoin;
        $sql .= " WHERE A.TS >= @TS_LOWER_BOUND AND A.TS < @TS_UPPER_BOUND";
        $sql .= " AND A.TICKER IN('" . $tickerIds . "')";
        $sql .= " GROUP BY A.TICKER";
        $sql .= " ORDER BY A.TICKER";
        $this->db("sentiment");
        FJF_BASE_RICH::executeQuery("SELECT MAX(TS) AS LAST_TS FROM SentimentData_Averaged INTO @TS_LOWER_BOUND");
      	FJF_BASE_RICH::executeQuery('SET @TS_UPPER_BOUND = DATE_ADD(@TS_LOWER_BOUND, INTERVAL 1 MINUTE)');
				FJF_BASE_RICH::executeQuery("SET SESSION group_concat_max_len = 2048");
        $records = $this->selectRecords($sql);
        FJF_BASE_RICH::executeQuery('SET @TS_LOWER_BOUND = NULL');
				FJF_BASE_RICH::executeQuery('SET @TS_UPPER_BOUND = NULL');
				$this->db();
      }
      return $records;
    }
		
    function getTopTen($category, $slice ='TOP', $fields = null)
    {
    	$table = ($this->mode == 'MP') ? 'RankingData_Summarized_MP' : 'RankingData_Summarized_Crowd';
    	$default = "TS, CATEGORY, SLICE, TICKER, COMPANY_NAME, RANK, BUZZ";
			$default .= ($this->mode == 'MP') ? ', SIGNAL_VALUE AS AVERAGE_SENTIMENT, SIGNAL_CHANGE AS SENTIMENT_CHANGE' : ', AVERAGE_SENTIMENT, SENTIMENT_CHANGE';
      $sql = "";
      $sql .= "SELECT " .($fields ? $fields : $default);
      $sql .= " FROM ".$table;
      $sql .= " WHERE TS = (SELECT TS FROM ".$table." WHERE CATEGORY = 'CATEGORY_VAL' ORDER BY TS DESC LIMIT 1)";
      $sql .= " AND CATEGORY = 'CATEGORY_VAL' AND SLICE = 'SLICE_VAL'";
      $sql .= " ORDER BY RANK";
      $params = array('CATEGORY_VAL' => $category,'SLICE_VAL' => $slice);
      $this->db("sentiment");
      $records = $this->selectRecords($sql, $params);
      $this->db();
      return $records;
    }

		function checkStocksPage($ticker, $user = null){
			$result = false;
			if($GLOBALS["WEB_APPLICATION_CONFIG"]["allow_google_access"]){
				$crawlers = array('google');
				$pattern = '/(' . implode('|', $crawlers) .')/i';
				if(preg_match($pattern, strtolower($_SERVER['HTTP_USER_AGENT']))){
				  return true;
				}
				if(isset($_SERVER['HTTP_REFERER'])){
					$referer = parse_url($_SERVER['HTTP_REFERER']);
					if(array_key_exists('host', $referer) && strpos($referer['host'], 'google.') !== false){
						return true;
					}
				}
			}
			if($user){
				$result = $this->checkStockRequestsLimit(
					$user->username, $ticker, $user->tier
				);
			}else{
				$savedTicker = isset($_COOKIE['saved_ticker']) ? trim($_COOKIE['saved_ticker']) : "";
				if(!$savedTicker){
					setcookie('saved_ticker',$ticker, time() + 86400, '/'); // 1 day
					$_COOKIE['saved_ticker'] = $ticker;
				}
				$result = (!$savedTicker || ($ticker == $savedTicker));
			}
			if(!$result){
				FJF_BASE::redirect("/stock/" . $ticker . "/limit/");
			}
			return true;
		}

		function checkStockRequestsLimit($username, $ticker, $tier = 1){
			if($onDashbord = FJF_BASE_RICH::getRecords(
				"users_stocks us LEFT JOIN users u ON us.user_id = u.id",
				"u.username = 'USERNAME_VAL' AND us.ticker = 'TICKER_VAL' AND us.status = 1",
				array('USERNAME_VAL' => $username, 'TICKER_VAL' => $ticker),
				true, "us.id"
			)){
				return true;
			}
			include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/pricing_model.php");
			$limits = PricingModel::getPagesLimit();
			if(array_key_exists($tier, $limits)){
				if($request = FJF_BASE_RICH::getRecords(
					"stocks_requests",
					"username = 'USERNAME_VAL' AND ticker = 'TICKER_VAL' AND DATE(date) = 'DATE_VAL'",
					array('USERNAME_VAL' => $username, 'TICKER_VAL' => $ticker, 'DATE_VAL' => date('Y-m-d')),
					true, "id"
				)){
					return true;
				}else{
					$countRequests = ($limits[$tier] !== null) ? FJF_BASE_RICH::countFrom(
						"stocks_requests",
						"username = 'USERNAME_VAL' AND DATE(date) = 'DATE_VAL'",
						array('USERNAME_VAL' => $username, 'DATE_VAL' => date('Y-m-d'))
					) : 0;
					if($limits[$tier] === null || $countRequests < $limits[$tier]){
						FJF_BASE_RICH::saveRecord("stocks_requests", array(
							"username" => $username,
							"ticker" => $ticker,
							"date" => date('Y-m-d H:i:s')
						));
						return true;
					}
				}
			}
			return false;
		}

		function checkStockDashboardLimit($userId, $tier = 1){
			include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/pricing_model.php");
			$limits = PricingModel::getDashboardsLimit();
			if(array_key_exists($tier, $limits)){
				$count = ($limits[$tier] !== null) ? FJF_BASE_RICH::countFrom(
					"users_stocks",
					"user_id = 'USER_ID_VAL'",
					array('USER_ID_VAL' => $userId)
				) : 0;
				if($limits[$tier] === null || $count < $limits[$tier]){
					return true;
				}
			}
			return false;
		}
		
		function changeStockPendingStatus($where = '1', $params = array(), $limit = 100){
			$totalActive = $this->getUserStocksCount($where . ' AND us.status = 1', $params);
			$totalPending = $this->getUserStocksCount($where . ' AND us.status = 0', $params);
			$count = 0;
			if($limit === null){
				$status = 1;
				$count = $totalPending;
				$where = $where . " AND us.status = 0";
			}elseif($totalActive > $limit){
				$status = 0;
				$count = $totalActive - $limit;
				$where = $where . " AND us.status = 1";
			}elseif($totalActive < $limit && $totalPending){
				$status = 1;
				$count = $limit - $totalActive;
				$where = $where . " AND us.status = 0";
			}
			if($count){
				if($records = $this->getUserTickers($where, $params, $count, 'us.id DESC', 'us.id')){
					$data = array();
					foreach($records as $item){
						$data[] = $item->id;
					}
					if($data){
						$this->updateRecords('users_stocks', "status = 'STATUS_VAL'", "id IN(IDS_VAL)", array(
							"STATUS_VAL" => $status,
							"IDS_VAL" => implode(',', $data)
						));
					}
				}
			}
			return $count;
		}

		function changeUserStockPendingStatus($userId, $tier = 1){
			include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/pricing_model.php");
			return $this->changeStockPendingStatus(
				"us.user_id = 'USER_ID_VAL'",
				array("USER_ID_VAL" => $userId),
				PricingModel::getDashboardsLimit($tier)
			);
			
		}

  }
?>