<?php

class StockChartsModel{
	
	var $types = array(
		"sentiment_real_time" => "Sentiment - Real Time",
		"sentiment_day" => "Sentiment - Historical",
		"zscore_real_time" => "Sentiment Z-Score - Real Time",
		"zscore_day" => "Sentiment Z-Score - Historical",
		"buzz_real_time" => "Buzz - Real Time",
		"buzz_day" => "Buzz - Historical",
		"price_real_time" => "Price - Real Time",
		"price_day" => "Price - Historical"
		//"tweet_volume_real_time" => "Tweet Volume - Real Time",
		//"tweet_volume_day" => "Tweet Volume - Historical"
	);
	private $max_rows = 2;
	private $max_cols = 2;
	
	function getDefaultChart(){
		$tmpKeys = array_keys($this->types);
		return array_shift($tmpKeys);
	}//getDefaultChart
	
	function getDefaultCharts(){
		return array(
			array($this->getDefaultChart(), null),
			array(null, null)
		);
	}//getDefaultCharts
	
	function getStockCharts($stockId){
		$charts = null;
		$record = FJF_BASE_RICH::getRecordBy("users_stocks_charts", $stockId, "stock_id");
		if($record && $record->charts) $charts = json_decode($record->charts);
		if(!$charts) $charts = $this->getDefaultCharts();
		return $charts;
	}//getStockCharts
	
	function setStockChart($stockId, $row, $col, $chart){
		$row = $row % $this->max_rows;
		$col = $col % $this->max_cols;
		$charts = $this->getStockCharts($stockId);
		for($r = 0; $r <= $row; $r++){
			if(!array_key_exists($r, $charts)) $charts[$r] = array(null, null);
		}
		$charts[$row][$col] = $chart;
		return $this->saveStockCharts($stockId, $charts);
	}//setStockChart
	
	private function saveStockCharts($stockId, $charts){
		return FJF_BASE_RICH::replaceRecord("users_stocks_charts", array(
			"stock_id" => $stockId,
			"charts" => json_encode($charts)
		));
	}//saveStockCharts
	
}

?>