<?php

class ToptenModel{
	
	private static $viewMode = "";
	
	static function viewMode($mode){
		ToptenModel::$viewMode = $mode;
	}//viewMode
	
	private static function __getRecords($categoryVal, $sliceVal = ""){
		if(ToptenModel::$viewMode == 'MP'){
			if($categoryVal == 'CROWD_SENTIMENT_AVERAGED') $categoryVal = 'MP_LAST_TRADING_SIGNAL';
			elseif($categoryVal == 'CROWD_SENTIMENT_CHANGE') $categoryVal = 'MP_TRADING_SIGNAL_CHANGE';
			$tbl = "RankingData_Summarized_MP";
			$fld = "SIGNAL_VALUE AVERAGE_SENTIMENT, SIGNAL_CHANGE SENTIMENT_CHANGE";
		}else{
			$tbl = "RankingData_Summarized_Crowd";
			$fld = "AVERAGE_SENTIMENT, SENTIMENT_CHANGE";
		}
		
		$sql = "";
		$sql .= "SELECT TS, CATEGORY, SLICE, TICKER, COMPANY_NAME, RANK, BUZZ, CHANGE_FROM_OPEN";
		$sql .= ", PRICING_TICKER, PROXY_TICKER_FLAG, API_NAME, DELAYED_FLAG, EXCHANGE";
		$sql .= ", " . $fld;
		$sql .= " FROM " . $tbl;
		$sql .= " WHERE TS = (SELECT TS FROM " . $tbl . " WHERE CATEGORY = 'CATEGORY_VAL' ORDER BY TS DESC LIMIT 1)";
		$sql .= " AND CATEGORY = 'CATEGORY_VAL' AND SLICE = 'SLICE_VAL'";
		$sql .= " ORDER BY RANK";
		$sql .= " LIMIT 10";
		
		FJF_BASE_RICH::db('sentiment');
		$records = FJF_BASE_RICH::selectRecords($sql, array(
      'CATEGORY_VAL' => $categoryVal,
      'SLICE_VAL' => strtoupper($sliceVal) != 'TOP' ? 'BOTTOM' : 'TOP'
		));
		FJF_BASE_RICH::db();
		if(!$records) $records = array();
		return array_pad($records, 10, null);
	}//__getRecords
	
	private static function __updateQuotes($records){
		if($records){
			$uniq = array();
			foreach($records as $record) if($record) $uniq[$record->PRICING_TICKER] = $record;
			if($uniq){
				include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/xignite_model.php");
				if($data = XigniteModel::getQuotes($uniq)) foreach($data as $row) foreach($records as $record){
					if($record && $record->PRICING_TICKER == $row->Symbol){
						$record->PRICE = $row->Last;
						$record->PERCENT_CHANGE = $row->PercentChange;
					}
				}
			}
			unset($uniq, $data);
		}
	}//__updateQuotes
	
	static function getSentimentTop(){
		$records = ToptenModel::__getRecords('CROWD_SENTIMENT_AVERAGED', 'TOP');
		ToptenModel::__updateQuotes($records);
		return $records;
	}//getSentimentTop
	
	static function getSentimentBottom(){
		$records = ToptenModel::__getRecords('CROWD_SENTIMENT_AVERAGED', 'BOTTOM');
		ToptenModel::__updateQuotes($records);
		return $records;
	}//getSentimentBottom
	
	static function getSentimentChangeTop(){
		$records = ToptenModel::__getRecords('CROWD_SENTIMENT_CHANGE', 'TOP');
		ToptenModel::__updateQuotes($records);
		return $records;
	}//getSentimentChangeTop
	
	static function getSentimentChangeBottom(){
		$records = ToptenModel::__getRecords('CROWD_SENTIMENT_CHANGE', 'BOTTOM');
		ToptenModel::__updateQuotes($records);
		return $records;
	}//getSentimentChangeBottom
	
	static function getTweetBuzzTop(){
		$records = ToptenModel::__getRecords('TWEET_BUZZ', 'TOP');
		ToptenModel::__updateQuotes($records);
		return $records;
	}//getTweetBuzzTop
	
	static function getTweetBuzzBottom(){
		$records = ToptenModel::__getRecords('TWEET_BUZZ', 'BOTTOM');
		ToptenModel::__updateQuotes($records);
		return $records;
	}//getTweetBuzzBottom
	
	static function get($keys){
		$data = array();
		foreach($keys as $key){
			$data[$key] = call_user_func(array("ToptenModel", "get" . $key));
		}
		
		$all = array();
		foreach($data as $records){
			if($records) $all = array_merge($all, $records);
		}
		
		ToptenModel::__updateQuotes($all);
		
		return $data;
	}//get
	
}

?>
