<?php

	class TwitterModel{
		var $lib;
		
		function getLib(){
			if(!$this->lib){
				include_once FJF_ROOT . '/settings_twitter.php';
				require_once FJF_ROOT . '/resources/twitteroauth/twitteroauth.php';
				$this->lib = new TwitterOAuth(
					$GLOBALS["WEB_APPLICATION_CONFIG"]["twitter"]["consumer_key"],
					$GLOBALS["WEB_APPLICATION_CONFIG"]["twitter"]["consumer_secret"],
					$GLOBALS["WEB_APPLICATION_CONFIG"]["twitter"]["access_token"],
					$GLOBALS["WEB_APPLICATION_CONFIG"]["twitter"]["access_token_secret"]
				);
			}
			return $this->lib;
		}
		
		function getUsersInfo($records, $useKeys = true, $field = 'username'){
			if($records && is_array($records)){
				$marketUsers = array();
				if($useKeys){
					$marketUsers = array_keys($records);
				}else{
					foreach($records as $item){
						$marketUsers[] = isset($item->{$field}) ? $item->{$field} : null;
					}
					$marketUsers = array_unique($marketUsers);
				}
				$twUsers = array();
				if($marketUsers){
					$marketUsers = array_chunk($marketUsers, 100);
					foreach($marketUsers as $users){
						$twUsersPart = $this->getLib()->get("users/lookup", array("screen_name" => implode(",", $users)));
						if($twUsersPart && is_array($twUsersPart)){
							$twUsers = array_merge($twUsers, $twUsersPart);
						}
					}
				}
				$twUsersNew = array();
				if($twUsers && is_array($twUsers)){
					foreach($twUsers as $twUser){
						if(!array_key_exists($twUser->screen_name, $twUsersNew)){
							$twUsersNew[strtolower($twUser->screen_name)] = $twUser;
						}
					}
				}
				foreach($records as $record){
					$username = isset($record->{$field}) ? strtolower($record->{$field}) : "";
					$record->author_logo = ($username && array_key_exists($username, $twUsersNew)) ? $twUsersNew[$username]->profile_image_url : "/img/main/bg_username_link_big.png";
					$record->author = ($username && array_key_exists($username, $twUsersNew)) ? $twUsersNew[$username]->name : $username;
				}
			}
			return $records;
		}
		
		////
   // returns time ago
   //
   function timeAgo($datetimeStr, $shortNotation = false){
     $datetime = new DateTime('@'.strtotime($datetimeStr));
     $interval = date_create('now')->diff($datetime);
     if($v = $interval->y >= 1) return $shortNotation ? $interval->y.'y' : $this->pluralize($interval->y, 'year');
     if($v = $interval->m >= 1) return $shortNotation ? $interval->m.'m' : $this->pluralize($interval->m, 'month');
     if($v = $interval->d >= 1) return $shortNotation ? $interval->d.'d' : $this->pluralize($interval->d, 'day');
     if($v = $interval->h >= 1) return $shortNotation ? $interval->h.'h' : $this->pluralize($interval->h, 'hour');
     if($v = $interval->i >= 1) return $shortNotation ? $interval->i.'m' : $this->pluralize($interval->i, 'minute');
     return $shortNotation ? $interval->s.'s' : $this->pluralize($interval->s, 'second');
   }
   
   function pluralize($count, $text){
     return $count.' '.$text.($count == 1 ? '' : 's');
   }
	 
	}

?>