<?php

	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["app_web_path"] . "/resources/mailchimp-api/MailChimp.php");

  class UserModel extends FJF_BASE_RICH
  {
  	var $mailChimp = null;

  	function __construct()
		{
			$this->mailChimp = new MailChimp($GLOBALS["WEB_APPLICATION_CONFIG"]['mailchimp']['api_key']);
		}

    ////
    // returns random string A-Za-z and optionally with numbers 0-9
    //
    function getRandString($stringLength, $includeNumbers = true)
    {
      $allowedChars = array();
      // 65-90 : A-Z, 97-122 : a-z
      $i = 64;
      while($i++ < 122) if(!($i > 90 && $i < 97)) $allowedChars[] = chr($i);
      if($includeNumbers) for($i = 0; $i <= 9; $i++) $allowedChars[] = $i;
      $num = count($allowedChars);
      $string = '';
      while($stringLength-- > 0) $string .= $allowedChars[mt_rand(0,$num-1)];
      return $string;
    }//getRandString

    function getRandInt($number, $table = null, $name = null)
    {
      $value = substr(number_format(time() * rand(),0,'',''),0,$number);
      if ($table != null && $name != null)
      {
        if ($this->getRecords($table, $name."='".$value."'", null, true, 'id'))
        {
          $this->getRandInt($number, $table, $name);
        }
      }
      return $value;
    }

    function updatePassword($data){
      $result = null;
      if($data && is_array($data) && array_key_exists('id',$data)){
        $result = $this->saveRecord("users", $data);
      }
      return $result;
    }//updatePassword

    function updateRefreshPassword($user){
      $result = null;
      if($user){
        $rp = $this->getRandString(8);
        $result = $this->saveRecord("users", array("id" => $user->id, "refresh_password" => $rp));
        if($result)
        {
          $link = "http://" . $_SERVER["SERVER_NAME"] . "/reset-password/" . $rp . urlencode(urlencode(FJF_BASE::encrypt($user->id, "refresh-password"))) . "/";
          //$mMessage = "Dear " . $user->first_name . ",<br/>";
          //$mMessage .= "<br/>";
          $mMessage = "Please click here to reset your password:<br/>";
          $mMessage .= "<br/>";
          $mMessage .= "<a href='" . $link . "'>" . $link . "</a><br/>";
          $mMessage .= "<br/>";
          $mMessage .= $GLOBALS["WEB_APPLICATION_CONFIG"]["company_name"] ." Team<br/>";
          $mTo = array($user->email, $user->first_name . " " . $user->last_name );
          if(!$this->sendMail($mTo, $mMessage, "Forgot Password")) return false;
        };
      }
      return $result;
    }//updateRefreshPassword

    function insertUser($user){
    	if(!isset($user['username'])) $user['username'] = $user['email'];
      if(!isset($user['id'])) $user['date_register'] = date("Y-m-d H:i:s");
      $user['is_admin'] = 0;
      $user['user_type'] = 1;
      $user['active'] = 1;
			$user['cancelled'] = 0;
      return $result = $this->saveRecord('users', $user);
    }//insertUser

    function addUser($user){
      $user['approved'] = $this->getRandString(8);
      unset($user['accept']);
      $result = $this->insertUser($user);
      if($result){
        $mTo =  array($user["email"], $user["first_name"]." ".$user["last_name"]);
        $mSubject = "Welcome to ".$GLOBALS["WEB_APPLICATION_CONFIG"]["company_name"]."! Verify your ".$GLOBALS["WEB_APPLICATION_CONFIG"]["company_name"]." account.";
        $mMessage = "Welcome to ".$GLOBALS["WEB_APPLICATION_CONFIG"]["company_name"]." ".$user["first_name"]." ".$user["last_name"]."!<br/><br/>";
        $mMessage .= "You're almost ready to begin exploring the powerful features of ".$GLOBALS["WEB_APPLICATION_CONFIG"]["company_name"].".<br/>";
        $mMessage .= "To complete your registration process, please verify your email address by clicking on the link below:<br/>";
        $mMessage .= "<br/>";
        $mMessage .= '<a href="http://'.$_SERVER["SERVER_NAME"].'/verify/'.$user['approved'].'/" title="">http://'.$_SERVER["SERVER_NAME"].'/verify/'.$user['approved'].'/</a>'."<br/>";
        $mMessage .= "<br/><br/>";
        $mMessage .= "Sincerely,<br/>";
        $mMessage .=  $GLOBALS["WEB_APPLICATION_CONFIG"]["company_name"];
        $mMessage .= "<br/><br/>";
        $mMessage .= '<i style="color:#989898;font-size: 10px;">Extracting the market signal from social media noise. Financial Big Data analytics for every investor.</i>';
        $this->sendMail($mTo, $mMessage, $mSubject);
      }
      return $result;
    }//addUsers

    function addApprovedUser($user){
    	$rp = $this->getRandString(8);
			$user["password"] = $this->getRandString(8);
			$user["refresh_password"] = $rp;
      if($result = $this->insertUser($user)){
      	$link = "http://" . $_SERVER["SERVER_NAME"] . "/reset-password/" . $rp . urlencode(urlencode(FJF_BASE::encrypt($result, "refresh-password"))) . "/";
        $mTo =  array($user["email"], $user["first_name"]." ".$user["last_name"]);
        $mSubject = "Welcome to ".$GLOBALS["WEB_APPLICATION_CONFIG"]["company_name"]."!";
        $mMessage = "Welcome to ".$GLOBALS["WEB_APPLICATION_CONFIG"]["company_name"]." ".$user["first_name"]." ".$user["last_name"]."!<br/><br/>";
        $mMessage .= "You're almost ready to begin exploring the powerful features of ".$GLOBALS["WEB_APPLICATION_CONFIG"]["company_name"].".<br/>";
        $mMessage .= "To complete your registration process, please click here to reset your password:<br/>";
        $mMessage .= "<br/>";
        $mMessage .= "<a href='" . $link . "'>" . $link . "</a><br/>";
        $mMessage .= "<br/><br/>";
        $mMessage .= "Sincerely,<br/>";
        $mMessage .=  $GLOBALS["WEB_APPLICATION_CONFIG"]["company_name"];
        $mMessage .= "<br/><br/>";
        $mMessage .= '<i style="color:#989898;font-size: 10px;">Extracting the market signal from social media noise. Financial Big Data analytics for every investor.</i>';
        $this->sendMail($mTo, $mMessage, $mSubject);
      }
      return $result;
    }

    function sendMail($mTo, $mMessage, $mSubject = null, $useSMTP = true){
      $result = null;
      if (!$mSubject) $mSubject = $GLOBALS["WEB_APPLICATION_CONFIG"]["company_name"];
      if($mTo){

      	$emailTemplate = $GLOBALS["WEB_APPLICATION_CONFIG"]["templates_path"] . "/emails/template.tpl";
      	if (@file_exists($emailTemplate) && $emailTemplate != "")
				{
					$html = file_get_contents($emailTemplate);
          $search = array("%%%CONTENT%%%", "%%%SERVER_NAME%%%", "%%%COMPANY_NAME%%%");
          $replace = array($mMessage, $_SERVER["SERVER_NAME"], $GLOBALS["WEB_APPLICATION_CONFIG"]["company_name"]);
					$mMessage = str_replace($search, $replace, $html);
				}

      	include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["lib_path"] . "/phpmailer/class.phpmailer.php");
        $phpMailer = new PHPMailer();
				$phpMailer->Mailer = "mail";
				if($useSMTP){
					$phpMailer->IsSMTP();
					$phpMailer->Mailer = "smtp";
					$phpMailer->SMTPDebug = 0;
					$phpMailer->SMTPAuth = true;
					$phpMailer->SMTPSecure = "tls";
					$phpMailer->Host = "smtp.gmail.com";
					$phpMailer->Port = 587;
					$phpMailer->Username = $GLOBALS["WEB_APPLICATION_CONFIG"]["email_user_setting"]["username"];
					$phpMailer->Password = $GLOBALS["WEB_APPLICATION_CONFIG"]["email_user_setting"]["password"];
				}
				if (!is_array($mTo)){
					$mTo = explode('<', $mTo);
					$mTo[1] = (isset($mTo[1])) ? str_replace('>', '', $mTo[1]) : '';
				}
        $phpMailer->AddAddress($mTo[0], $mTo[1]);
        $phpMailer->From = $GLOBALS["WEB_APPLICATION_CONFIG"]["email_from_setting"]["address"];
        $phpMailer->FromName = $GLOBALS["WEB_APPLICATION_CONFIG"]["email_from_setting"]["name"];
        $phpMailer->Subject = $mSubject;
        $phpMailer->Body = $mMessage;
				$phpMailer->IsHTML(true);
        $result = $phpMailer->Send();
			  return $result;
      }
      return $result;
    }//sendMail

    function checkUserProfile($id = null){
      if ($id == null) $id = isset($_SESSION["userid"]) ? FJF_BASE::decrypt($_SESSION["userid"], "userid") : 0;
      $params['USER_ID'] = $id;
      $fields = array('u.first_name','u.last_name', 'u.dob',
                       'us.race', array('us.education', 'us.education_other'), 'us.income', 'us.investable_assets', 'us.investor_type', 'us.self_directed', 'us.trade_often',
                       'us.trade_length', array('us.investment_style', 'us.investment_style_other'), array('us.invest_in', 'us.invest_in_other'), 'us.trade', 'us.holding_period',
                       array('us.investment_ideas', 'us.investment_ideas_other'), array('us.broker', 'us.broker_other_bank', 'us.broker_other_online', 'us.broker_other'));
      $sql = "SELECT u.id FROM users u";
      $sql .= " LEFT JOIN users_settings us ON u.id=us.user_id";
      $sql .= " WHERE u.id = 'USER_ID'";
      if ($fields){
        foreach($fields as $item)
        {
          if (is_array($item)){
            $subSql = '';
            foreach($item as $subItem)
            {
              $subSql .= $subItem." <> '' OR ";
            }
            $sql .= " AND (".substr($subSql,0, -3).")";

          }else{
            $sql .= " AND ".$item." <> ''";
          }
        }
      }
      //test($sql);
      $record = $this->selectRecords($sql, $params, true);
      return ($record) ? true  : false;
    }

		function subscribeToList($record, $options = array()){
			$result = false;
			if(!isset($record['email'])) return $result;
			$default = array(
				'id' => isset($record['list_id']) ? $record['list_id'] : $GLOBALS["WEB_APPLICATION_CONFIG"]['mailchimp']['list_id'],
				'email' => array('email' => $record['email']),
        'merge_vars' => array(
        	'FNAME' => isset($record['first_name']) ? $record['first_name'] : '',
        	'LNAME' => isset($record['last_name']) ? $record['last_name'] : ''
        ),
				'double_optin' => false,
        'update_existing' => true,
        'replace_interests' => false,
        'send_welcome' => false
			);
			$result = $this->mailChimp->call('lists/subscribe', array_merge($default, $options));
			return (!$result || isset($result['error'])) ? false : true;
		}

		function getlistMember($email){
			$member = $this->mailChimp->call('lists/member-info', array(
				'id' => $GLOBALS["WEB_APPLICATION_CONFIG"]['mailchimp']['list_id'],
				'emails' => array(array('email' => $email))
			));
			return (isset($member['data']) && $member['data']) ? $member['data'][0] : null;
		}

		function unsubscribeFromList($record, $options = array()){
			$result = false;
			if(!isset($record['email'])) return $result;
			if($this->getlistMember($record['email'])){
				$default = array(
					'id' => $GLOBALS["WEB_APPLICATION_CONFIG"]['mailchimp']['list_id'],
					'email' => array('email' => $record['email']),
					'delete_member' => true,
	        'send_goodbye' => false,
	        'send_notify' => false
				);
				$result = $this->mailChimp->call('lists/unsubscribe', array_merge($default, $options));
			}
			return (!$result || isset($result['error'])) ? false : true;
		}
		
		function changePendingStatus($userId, $tier){
			include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/alerts_model.php");
			include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/sentiment_model.php");
			include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/users_sentiment_model.php");
			$alertsModel = new AlertsModel();
			$sentimentModel = new SentimentModel();
			$usersSentimentModel = new UsersSentimentModel();
			return array(
				"alerts" => $alertsModel->changeUserAlertPendingStatus($userId, $tier),
				"stocks" => $sentimentModel->changeUserStockPendingStatus($userId, $tier),
				"market_usres" => $usersSentimentModel->changeUserMarketUserPendingStatus($userId, $tier)
			);
		}
		
		function sendChangeTierMail($user, $order){
			$mMessage = '<table width="100%">';
			$mMessage .= '<tr>';
			$mMessage .= '<td>';
			$mMessage .= '<p>' . ucfirst($user['first_name']) . ',</p>';
			$mMessage .= '<p>This is to confirm your ' . $GLOBALS["WEB_APPLICATION_CONFIG"]["company_name"] . ' Subscription - Tier ' . $order['change_type'] . '. ';
			if(isset($order['old'])){
				$mMessage .= 'You have ' . strtolower($order['change_type']) . 'd from ' . $GLOBALS["WEB_APPLICATION_CONFIG"]["company_name"] . ' - ' . $order['old']['plan'] . ' to ' . $GLOBALS["WEB_APPLICATION_CONFIG"]["company_name"] . ' - ' . $order['plan'] . '. ';
				$mMessage .= 'Your existing Tier: ' . $GLOBALS["WEB_APPLICATION_CONFIG"]["company_name"] . ' - ' . $order['old']['plan'] . ' has been cancelled and you have subscribed to your new Tier: ' . $GLOBALS["WEB_APPLICATION_CONFIG"]["company_name"] . ' - ' . $order['plan'] . '. ';
			}else{
				$mMessage .= 'You have subscribed to your new Tier: ' . $GLOBALS["WEB_APPLICATION_CONFIG"]["company_name"] . ' - ' . $order['plan'] . '. ';
			}
			$mMessage .= 'Your confirmation details are below:</p>';
			$mMessage .= '<td>';
			$mMessage .= '</tr>';
			if(isset($order['old'])){
				$mMessage .= '<tr>';
				$mMessage .= '<td>';
				$mMessage .= '<h4 style="color:#24AAE1">Cancellation Details:</h4>';
				$mMessage .= '<span>Confirmation No: ' . $order['old']['id'] . '</span><br/>';
				$mMessage .= '<span>' . $GLOBALS["WEB_APPLICATION_CONFIG"]["company_name"] . ' - ' . $order['old']['plan'] . '</span><br/>';
				$mMessage .= '<span>Cancellation Date: ' . $order['old']['cancellation_date'] . '</span><br/>';
				if($order['old']['cancel_subscribe']){
					$mMessage .= '<span>Refund Amount: $' . number_format($order['old']['cancel_subscribe']['amount'], 2) . '</span><br/>';
				}
				$mMessage .= '<td>';
				$mMessage .= '</tr>';
			}
			$mMessage .= '<tr>';
			$mMessage .= '<td>';
			$mMessage .= '<h4 style="color:#24AAE1">Subscription Details:</h4>';
			$mMessage .= '<span>Confirmation No: ' . $order['id'] . '</span><br/>';
			$mMessage .= '<span>' . $GLOBALS["WEB_APPLICATION_CONFIG"]["company_name"] . ' - ' . $order['plan'] . '</span><br/>';
			$mMessage .= '<span>Effective Date: ' . $order['effective_date'] . '</span><br/>';
			$mMessage .= '<span>' . $order['payment_type'] . ': $' . number_format($order['price'], 2) . '</span><br/>';
			if(isset($order['coupon_expires'])){
				$mMessage .= '<span>Coupon Code Promotion Expires: ' . $order['coupon_expires'] . '</span><br/>';
			}
			if(isset($order['trial'])){
				$mMessage .= '<span>Free Trial: ' . $order['trial'] . '</span><br/>';
			}
			if($order['discount']){
				$mMessage .= '<span>Coupon Code: -$' . number_format($order['discount'], 2) . '</span><br/>';
				$mMessage .= '<span>Total : $' . number_format($order['total'], 2) . '</span><br/>';
			}
			$mMessage .= '<td>';
			$mMessage .= '</tr>';
			$mMessage .= '<tr>';
			$mMessage .= '<td>';
			$mMessage .= '<br/><span>Sincerely,</span><br/>';
			$mMessage .= '<span>' . $GLOBALS["WEB_APPLICATION_CONFIG"]["company_name"] . '</span>';
			$mMessage .= '<td>';
			$mMessage .= '</tr>';
			$mMessage .= '</table>';
			return $this->sendMail(
				array($user['email'], $user['first_name'] . ' ' . $user['last_name']),
				$mMessage,
				$GLOBALS["WEB_APPLICATION_CONFIG"]["company_name"] . " Subscription - Tier " . $order['change_type']
			);
		}

		function sendCancelSubscribeMail($user, $order){
			$mMessage = '<table width="100%">';
			$mMessage .= '<tr>';
			$mMessage .= '<td>';
			$mMessage .= '<p>' . ucfirst($user['first_name']) . ',</p>';
			$mMessage .= '<p>We are sorry to see you go! We hope you come back in the future and try ' . $GLOBALS["WEB_APPLICATION_CONFIG"]["company_name"] . ' again. ';
			$mMessage .= 'Please let us know through the contact form why you chose to cancel. ';
			$mMessage .= 'You can submit your comments here:</p>';
			$mMessage .= '<td>';
			$mMessage .= '</tr>';
			$mMessage .= '<tr>';
			$mMessage .= '<td>';
			$mMessage .= '<a href="http://' . $_SERVER["SERVER_NAME"] . '/contact-us/" title="Submit Comments">Submit Comments</a>';
			$mMessage .= '</td>';
			$mMessage .= '</tr>';
			$mMessage .= '<tr>';
			$mMessage .= '<td>';
			$mMessage .= '<p>Your cancellation details are below:</p>';
			$mMessage .= '<span>Confirmation No: ' . $order['old']['id'] . '</span><br/>';
			$mMessage .= '<span>' . $GLOBALS["WEB_APPLICATION_CONFIG"]["company_name"] . ' - ' . $order['old']['plan'] . '</span><br/>';
			$mMessage .= '<span>Cancellation Date: ' . $order['old']['cancellation_date'] . '</span><br/>';
			if($order['old']['cancel_subscribe']){
				$mMessage .= '<span>Refund Amount: $' . number_format($order['old']['cancel_subscribe']['amount'], 2) . '</span><br/>';
			}
			$mMessage .= '<td>';
			$mMessage .= '</tr>';
			$mMessage .= '<tr>';
			$mMessage .= '<td>';
			$mMessage .= '<br/><span>Sincerely,</span><br/>';
			$mMessage .= '<span>' . $GLOBALS["WEB_APPLICATION_CONFIG"]["company_name"] . '</span>';
			$mMessage .= '<td>';
			$mMessage .= '</tr>';
			$mMessage .= '</table>';
			
			return $this->sendMail(
				array($user['email'], $user['first_name'] . ' ' . $user['last_name']),
				$mMessage,
				$GLOBALS["WEB_APPLICATION_CONFIG"]["company_name"] . " Subscription Cancellation"
			);
		}

}

?>