<?php

  class UsersSentimentModel extends FJF_BASE_RICH
  {
  	
		function checkMarketUser($userID, $username)
    {
      $prams['USER_ID'] = $userID;
      $prams['USERNAME_VAL'] = $username;
      $result = $this->getRecords("users_market_users", "user_id='USER_ID' AND username='USERNAME_VAL'", $prams, true, 'id');
      return ($result) ? $result->id : false;
    }
    
    function addMarketUser($fields)
    {
      $result = $this->saveRecord("users_market_users", $fields);
      return $result;
    }
    
    function removeMarketUser($userID, $username){
    	$result = false;
    	if($id = $this->checkMarketUser($userID, $username)){
				$result = $this->deleteRecord("users_market_users", $id);
			}
      return $result;
    }
		
		function getMarketUsers($where = null, $params = null, $limit = null, $order = null, $fields = null){
      $sql = "SELECT ".($fields ? $fields :"umu.id, umu.username");
      $sql .= " FROM users_market_users umu";
      $sql .= " WHERE 1";
      $sql .= ($where) ? " AND ".$where : '';
      if ($order) $sql .= " ORDER BY ".$order;
      if ($limit) $sql .= " LIMIT ".$limit;
      $records = $this->selectRecords($sql, $params);
      return $records;
    }
		
		function getMarketUsersCount($where = null, $params = null){
    	$sql = "SELECT COUNT(umu.id) AS cid";
      $sql .= " FROM users_market_users umu";
      if($where) $sql .= " WHERE " . $where;
      return $this->getCount($sql, $params);
    }
		
  	function getTopTenUserScores($where = null, $params = null, $limit = null, $order = null, $fields = null)
  	{
      $sql = "SELECT ".($fields ? $fields :"tus.*");
      $sql .= " FROM TopTenData_UserScores tus";
      $sql .= " WHERE 1";
      $sql .= ($where) ? " AND ".$where : '';
      if ($order) $sql .= " ORDER BY ".$order;
      if ($limit) $sql .= " LIMIT ".$limit;
			$this->db("sentiment");
      $records = $this->selectRecords($sql, $params);
      $this->db();
      return $records;
    }
		
		function getTopTenReturns($table, $where = null, $params = null, $limit = null, $order = null, $fields = null)
  	{
      $sql = "SELECT ".($fields ? $fields :"*");
      $sql .= " FROM ".$table;
      $sql .= " WHERE 1";
      $sql .= ($where) ? " AND ".$where : '';
      if ($order) $sql .= " ORDER BY ".$order;
      if ($limit) $sql .= " LIMIT ".$limit;
			//print_r($params);
			//print_r($sql);
			$this->db("sentiment");
      $records = $this->selectRecords($sql, $params);
      $this->db();
      return $records;
    }
		
		function getUserScores($where = null, $params = null, $limit = null, $order = null, $fields = null, $returnOne = false)
  	{
      $sql = "SELECT ".($fields ? $fields :"us.*");
      $sql .= " FROM TrackingData_UserScores us";
      $sql .= " WHERE 1";
      $sql .= ($where) ? " AND ".$where : '';
      if ($order) $sql .= " ORDER BY ".$order;
      if ($limit) $sql .= " LIMIT ".$limit;
			$this->db("sentiment");
      $records = $this->selectRecords($sql, $params, $returnOne);
      $this->db();
      return $records;
    }
		
		function getUserSpecificData($where = null, $params = null, $limit = null, $order = null, $fields = null, $returnOne = false)
  	{
      $sql = "SELECT ".($fields ? $fields :"usd.*");
      $sql .= " FROM UserSpecificData usd";
      $sql .= " WHERE 1";
      $sql .= ($where) ? " AND ".$where : '';
      if ($order) $sql .= " ORDER BY ".$order;
      if ($limit) $sql .= " LIMIT ".$limit;
			$this->db("sentiment");
      $records = $this->selectRecords($sql, $params, $returnOne);
      $this->db();
      return $records;
    }
		
		function getUserRankingsScoresData($where = null, $params = null, $limit = null, $order = null, $fields = null, $returnOne = false)
  	{
      $sql = "SELECT ".($fields ? $fields :"urs.*");
      $sql .= " FROM UserRankings_UserScores urs";
      $sql .= " WHERE 1";
      $sql .= ($where) ? " AND ".$where : '';
      if ($order) $sql .= " ORDER BY ".$order;
      if ($limit) $sql .= " LIMIT ".$limit;
			$this->db("sentiment");
      $records = $this->selectRecords($sql, $params, $returnOne);
      $this->db();
      return $records;
    }
		
		function getIntervals()
		{
			$records = array(
				"1" => array("value" => "5D", "interval" => "1 WEEK", "limit" => 5),
				"2" => array("value" => "2WK", "interval" => "2 WEEK", "limit" => 10),
				"3" => array("value" => "1M", "interval" => "1 MONTH", "limit" => 20),
				"4" => array("value" => "3M", "interval" => "3 MONTH", "limit" => 60),
				"5" => array("value" => "6M", "interval" => "6 MONTH", "limit" => 120),
				"6" => array("value" => "1Y", "interval" => "1 YEAR", "limit" => 240),
				"7" => array("value" => "2Y", "interval" => "2 YEAR", "limit" => 480),
				"8" => array("value" => "5Y", "interval" => "5 YEAR", "limit" => 1200)
			);
			return $records;
		}
		
		function getTimeframes()
		{
			$records = array(
				"ONE_WEEK" => array("value" => "1 Week", "sort" => 1),
				"TWO_WEEKS" => array("value" => "2 Weeks", "sort" => 2),
				"THREE_WEEKS" => array("value" => "3 Weeks", "sort" => 3),
				"FOUR_WEEKS" => array("value" => "1 Month", "sort" => 4)
			);
			return $records;
		}
		
		function getFilterTimeframes()
		{
			$records = array(
				 0 => "Filter Timeframe",
				"ONE_WEEK" => "Last 1 Week",
				"TWO_WEEKS" => "Last 2 Weeks",
				"THREE_WEEKS" => "Last 3 Weeks",
				"FOUR_WEEKS" => "Last Month"
			);
			return $records;
		}
		
		function getTopUserReturns()
		{
			$records = array(
			 1 => "Top User by Returns",
			 2 => "Top 2 Users by Returns",
			 3 => "Top 3 Users by Returns",
			);
			return $records;
		}
		
		function getTopMpReturns()
		{
			$records = array(
			 1 => "Top Market Prophit",
			 2 => "Top 2 Market Prophits",
			 3 => "Top 3 Market Prophits",
			);
			return $records;
		}
		
		function getAlertTopUserReturns()
		{
			$records = array(
			 1 => "TOP USER BY RETURNS",
			 2 => "2nd TOP USER BY RETURNS",
			 3 => "3rd TOP USER BY RETURNS",
			);
			return $records;
		}
		
		function getAlertTopMpReturns()
		{
			$records = array(
			 1 => "TOP MARKET PROPHIT",
			 2 => "2nd TOP MARKET PROPHIT",
			 3 => "3rd TOP MARKET PROPHIT",
			);
			return $records;
		}
		
		function getUsersAlertsTitles(){
			$records = array(
			 "user" => "USER ALERT",
			 "top-user" => "TOP USERS BY RETURNS ALERT",
			 "top-mp" => "TOP USERS BY MP RANK ALERT"
			);
			return $records;
		}
		
		function getDefaultFilterTickers()
		{
			$records = array(
				"1" =>(object) array('ticker'=>'1', 'name'=>'Any Stock', 'short_name'=>"Any<br/>Stock"),
				"2" =>(object) array('ticker'=>'2', 'name'=>'Any Stock in Portfolio', 'short_name'=>'Any in Portfolio')
			);
			return $records;
		}
		
		function getDataForAlerts($info)
    {
      $records = array();
      if ($info && is_array($info) && isset($info['time']))
      {
        $sql = "SELECT GROUP_CONCAT(FORMAT(A.SENTIMENT,8)) AS sentiment, A.USERNAME AS username, A.TICKER AS ticker";
        $sql .= " FROM  SentimentDataFrontEnd AS A";
				$sql .= " LEFT JOIN SecurityMaster AS B ON A.TICKER=B.TICKER";
				$sql .= " WHERE A.TS BETWEEN DATE_SUB(CONVERT_TZ('INFO_TIME', 'US/Eastern', 'GMT'), INTERVAL 1 MINUTE) AND CONVERT_TZ('INFO_TIME', 'US/Eastern', 'GMT')";
        if(isset($info['tickers']) && $info['tickers'] && $info['tickers'] != 1) $sql .= " AND A.TICKER IN('".implode("','",explode(',',$info['tickers']))."')";
        if(isset($info['usernames'])) $sql .= " AND A.USERNAME IN('".implode("','",explode(',',$info['usernames']))."')";
				if(isset($info['sector']) && $info['sector']) $sql .= " AND B.SECTOR = 'SECTOR_VAL'";
        $sql .= " GROUP BY A.USERNAME, A.TICKER";
        $this->db("sentiment");
        $records = $this->selectRecords($sql, array(
        	"INFO_TIME"=>$info['time'],
        	"SECTOR_VAL"=>$info['sector']
				));
        $this->db();
      }
      return $records;
    }
		
		function getAlertsTime(){
			$sql = "SELECT DATE_FORMAT(TS, '%Y-%m-%d %H:%i:00') AS time, CONVERT_TZ(DATE_FORMAT(TS, '%Y-%m-%d %H:%i:00'),'GMT','US/Eastern') AS eastern_time FROM SentimentDataFrontEnd";
			$sql .= " ORDER BY TS DESC LIMIT 1";
			$this->db("sentiment");
      $records = $this->selectRecords($sql, null, true);
      $this->db();
			return $records;
		}
		
		function sortByOneKey($array, $key, $asc = true){
	    if(is_array($array)){
	    	$result = array();
		    $values = array();
		    foreach ($array as $id => $value){
		    	if(is_object($value)){
		    		$values[$id] = isset($value->{$key}) ? $value->{$key} : '';
					}else{
						$values[$id] = isset($value[$key]) ? $value[$key] : '';
					}
		    }
		    if($asc){
		    	asort($values);
		    }else{
		    	arsort($values);
		    }
		    foreach ($values as $key => $value){
		    	$result[$key] = $array[$key];
		    }
		    return $result;
			}
			return $array;
		}
		
		function checkMarketUsersPage($marketUser, $user = null){
			$result = false;
			if($user){
				$result = $this->checkMarketUsersRequestsLimit(
					$user->username, $marketUser, $user->tier
				);
			}else{
				$savedMarketUser = isset($_COOKIE['saved_market_user']) ? trim($_COOKIE['saved_market_user']) : "";
				if(!$savedMarketUser){
					setcookie('saved_market_user', $marketUser, time() + 86400, '/'); // 1 day
					$_COOKIE['saved_market_user'] = $marketUser;
				}
				$result = (!$savedMarketUser || ($marketUser == $savedMarketUser));
			}
			if(!$result){
				FJF_BASE::redirect("/users/details/" . $marketUser . "/limit/");
			}
			return true;
		}
		
		function checkMarketUsersRequestsLimit($username, $marketUser, $tier = 1){
			if($onDashbord = FJF_BASE_RICH::getRecords(
				"users_market_users umu LEFT JOIN users u ON umu.user_id = u.id",
				"u.username = 'USERNAME_VAL' AND umu.username = 'MARKET_USER_VAL' AND umu.status = 1",
				array('USERNAME_VAL' => $username, 'MARKET_USER_VAL' => $marketUser),
				true, "umu.id"
			)){
				return true;
			}
			include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/pricing_model.php");
			$limits = PricingModel::getPagesLimit();
			if(array_key_exists($tier, $limits)){
				if($request = FJF_BASE_RICH::getRecords(
					"market_users_requests",
					"username = 'USERNAME_VAL' AND market_user = 'MARKET_USER_VAL' AND DATE(date) = 'DATE_VAL'",
					array('USERNAME_VAL' => $username, 'MARKET_USER_VAL' => $marketUser, 'DATE_VAL' => date('Y-m-d')),
					true, "id"
				)){
					return true;
				}else{
					$countRequests = ($limits[$tier] !== null) ? FJF_BASE_RICH::countFrom(
						"market_users_requests",
						"username = 'USERNAME_VAL' AND DATE(date) = 'DATE_VAL'",
						array('USERNAME_VAL' => $username, 'DATE_VAL' => date('Y-m-d'))
					) : 0;
					if($limits[$tier] === null || $countRequests < $limits[$tier]){
						FJF_BASE_RICH::saveRecord("market_users_requests", array(
							"username" => $username,
							"market_user" => $marketUser,
							"date" => date('Y-m-d H:i:s')
						));
						return true;
					}
				}
			}
			return false;
		}
		
		function checkMarketUsersDashboardLimit($userId, $tier = 1){
			include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/pricing_model.php");
			$limits = PricingModel::getDashboardsLimit();
			if(array_key_exists($tier, $limits)){
				$count = ($limits[$tier] !== null) ? FJF_BASE_RICH::countFrom(
					"users_market_users",
					"user_id = 'USER_ID_VAL'",
					array('USER_ID_VAL' => $userId)
				) : 0;
				if($limits[$tier] === null || $count < $limits[$tier]){
					return true;
				}
			}
			return false;
		}
		
		function changeMarketUserPendingStatus($where = '1', $params = array(), $limit = 100){
			$totalActive = $this->getMarketUsersCount($where . ' AND umu.status = 1', $params);
			$totalPending = $this->getMarketUsersCount($where . ' AND umu.status = 0', $params);
			$count = 0;
			if($limit === null){
				$status = 1;
				$count = $totalPending;
				$where = $where . " AND umu.status = 0";
			}elseif($totalActive > $limit){
				$status = 0;
				$count = $totalActive - $limit;
				$where = $where . " AND umu.status = 1";
			}elseif($totalActive < $limit && $totalPending){
				$status = 1;
				$count = $limit - $totalActive;
				$where = $where . " AND umu.status = 0";
			}
			if($count){
				if($records = $this->getMarketUsers($where, $params, $count, 'umu.id DESC', 'umu.id')){
					$data = array();
					foreach($records as $item){
						$data[] = $item->id;
					}
					if($data){
						$this->updateRecords('users_market_users', "status = 'STATUS_VAL'", "id IN(IDS_VAL)", array(
							"STATUS_VAL" => $status,
							"IDS_VAL" => implode(',', $data)
						));
					}
				}
			}
			return $count;
		}

		function changeUserMarketUserPendingStatus($userId, $tier = 1){
			include_once($GLOBALS["WEB_APPLICATION_CONFIG"]["models_path"] . "/pricing_model.php");
			return $this->changeMarketUserPendingStatus(
				"umu.user_id = 'USER_ID_VAL'",
				array("USER_ID_VAL" => $userId),
				PricingModel::getDashboardsLimit($tier)
			);
			
		}

	}
	
?>