{strip}
{include file="site_top.tpl"}
	{assign var=version value="20140313"}
	{include file="site_charts_src.tpl"}
	<link type="text/css" rel="stylesheet" href="/styles/account_dashboard.css?v={$version}" />
	<script language="javascript" type="text/javascript" src="/js/jquery.tablesorter.js"></script>
	<script src="/js/stylized_select.js?v={$version}" type="text/javascript"></script>
	<script type="text/javascript" src="/js/users.js?v={$version}"></script>
	<script type="text/javascript" src="/js/users_dashboard.js?v={$version}"></script>
	

 <div class="section">
    <h3 class="main-heading alt">USER DASHBOARD</h3>
    
    <div id="twocolumns" class="twocolumns-dashboard">
      <div class="dashboard">
      	{include file="site_warning.tpl"}
        {if $parameters.has_error}
          <div class="warning">
            <img src="/img/main/bg-warning.png" width="48" height="48" alt="Warning" title="Warning" /><h3>{$parameters.status|stripslashes}</h3>
          </div>
        {/if}
        <div class="top-menu">
          <div class="box alt" id="search-box">
            <span class="blank"><input type="text" name="key" id="search-key" value="" /></span>
            <span><a href="javascript:void(0);" id="search-add" class="add">ADD NEW USER</a></span>
            <div id="search-list"></div>
          </div>
          <div class="box right">
            {if $parameters.pages}
	            <div class="pages">
	              {foreach from=$parameters.pages item=item}
	                {if $item.page=='&lt;&lt;'}
	                  <a href="{$item.url}" class="first"></a>
	                {elseif $item.page=='&lt;'}
	                  <a href="{$item.url}" class="prev"></a> 
	                {/if}
	              {/foreach}
	              <ul>
	                {foreach from=$parameters.pages item=item}
	                  {if is_numeric($item.page)}
	                    <li>
	                      <a href="{$item.url}" {if $item.active}class="active"{/if}>
	                        {$item.page}
	                      </a>
	                    </li>
	                  {/if}
	                {/foreach}
	              </ul>
	              {foreach from=$parameters.pages item=item}
	                {if $item.page=='&gt;'}
	                  <a href="{$item.url}" class="next"></a>
	                {elseif $item.page=='&gt;&gt;'}
	                  <a href="{$item.url}" class="last"></a> 
	                {/if}
	              {/foreach}
	            </div>
	          {/if}
            {if $parameters.search_params->limit}
              <div class="view">
                <select name="limit" class="custom">
                  {foreach from=$parameters.search_params->limit item=item}
                    <option value="{$item}" {if $item == $parameters.search->limit}selected="selected"{/if}>{$item}</option>
                  {/foreach}
                </select>
              </div>
              <em>VIEW PER PAGE</em>
            {/if}
          </div>
        </div>
        
        <div id="account-dashboard" class="dtbl">
        	
        	{if $parameters.records}
        		{if $parameters.search_params->sorting}
							<div class="dtbl-header">
	              {foreach name=header from=$parameters.search_params->sorting item=item key=key}
	                <div data-sort="{$key}" class="dtbl-col col-{$smarty.foreach.header.index}">
	                  {if $item.status == true}
	                  	<a href="javascript:void(0);" {if isset($item.active) && $item.active == true} class="active {$parameters.search->order}"{/if}>
	                  		{$item.name}&nbsp;
	                  		{if isset($item.active) && $item.active == true && $parameters.search->order== 'asc'}
	                  			<span>&#9650;</span>
	                  		{else}
	                  			<span>&#9660;</span>
	                  		{/if}
	                  	</a>
	                  {else}
	                  	{$item.name}
	                  {/if}
	                </div>
	              {/foreach}
							</div>
            {/if}
            {foreach name=records from=$parameters.records item=item}
		        	<div data-username="{$item->username|escape}" class="dtbl-item{if $item->status == 0} pending{/if}" style="z-index:{math equation="x-y" y=$smarty.foreach.records.index x=$smarty.foreach.records.total}">
		        		<div>
		        			<div class="dtbl-row">
				        		<div class="dtbl-col col-0">
				        			<a href="https://twitter.com/{$item->username|escape}/" target="_blank" title="@{$item->username|escape}" class="username">
												<img src="{if $item->author_logo}{$item->author_logo}{else}/img/main/bg_username_link.png{/if}" height="27" width="27" title="@{$item->username|escape}" alt="@{$item->username|escape}"/>
												&nbsp;@{$item->username|escape}
											</a>
				        		</div>
				        		<div class="dtbl-col col-1">{if $item->score}{$item->score|number_format:3}{else}<span class="empty">N/A</span>{/if}</div>
				        		<div class="dtbl-col col-2">{if $item->rank}{$item->rank|number_format}{else}<span class="empty">N/A</span>{/if}</div>
				        		<div class="dtbl-col col-3">{if $item->previous_rank}{$item->previous_rank|number_format}{else}<span class="empty">N/A</span>{/if}</div>
				        		<div class="dtbl-col col-4">
				        			<a href="/users/details/{$item->username|escape}/" class="userpage">USER PAGE</a>
				        		</div>
				        		<div class="dtbl-col col-5">
				        			<a href="javascript:void(0);" class="dtbl-tab summary" data-type="summary"></a>
				        		</div>
				        		<div class="dtbl-col col-6">
				        			<a href="javascript:void(0);" class="dtbl-tab alerts" data-type="alerts"></a>
				        		</div>
				        		<div class="dtbl-col col-7">
				        			<a href="javascript:void(0);" class="dtbl-tab remove"></a>
				        		</div>
				        	</div>
			        		<div class="dtbl-content-wrap">
			        			<div class="dtbl-content">
			        				{*include file="tmp_account_dashboard_tabs.tpl"*}
			        			</div>
			        			<div class="c"></div>
			        		</div>
			        	</div>
		        	</div>
	        	{/foreach}
					{else}
	          <div class="message">
	              <p>You have no users added to your dashboard.</p>
	          </div>
	        {/if}
        	
        </div>
        
        <div class="top-menu">
          <div class="box right">
          {if $parameters.pages}
	            <div class="pages">
	              {foreach from=$parameters.pages item=item}
	                {if $item.page=='&lt;&lt;'}
	                  <a href="{$item.url}" class="first"></a>
	                {elseif $item.page=='&lt;'}
	                  <a href="{$item.url}" class="prev"></a> 
	                {/if}
	              {/foreach}
	              <ul>
	                {foreach from=$parameters.pages item=item}
	                  {if is_numeric($item.page)}
	                    <li>
	                      <a href="{$item.url}" {if $item.active}class="active"{/if}>
	                        {$item.page}
	                      </a>
	                    </li>
	                  {/if}
	                {/foreach}
	              </ul>
	              {foreach from=$parameters.pages item=item}
	                {if $item.page=='&gt;'}
	                  <a href="{$item.url}" class="next"></a>
	                {elseif $item.page=='&gt;&gt;'}
	                  <a href="{$item.url}" class="last"></a> 
	                {/if}
	              {/foreach}
	            </div>
	          {/if}
            {if $parameters.search_params->limit}
              <div class="view">
                <select name="limit" class="custom">
                  {foreach from=$parameters.search_params->limit item=item}
                    <option value="{$item}" {if $item == $parameters.search->limit}selected="selected"{/if}>{$item}</option>
                  {/foreach}
                </select>
              </div>
              <em>VIEW PER PAGE</em>
            {/if}
            <span><a href="javascript:void(0);" onclick="scrollTopDiv('twocolumns')" style="width:107px;border-right:0;text-align:center;">BACK TO TOP</a></span>
          </div>
        </div>
      </div>
    </div>
  </div>
{include file="site_bottom.tpl"}
{/strip}