{strip}
{include file="site_top.tpl"}
	{assign var=version value="20140313"}
  {include file="site_charts_src.tpl"}
  <script type="text/javascript" src="/js/jquery.tagcanvas.min.js"></script>
  <script type="text/javascript" src="/js/date-functions.min.js"></script>
  <script src="/js/stylized_select.js" type="text/javascript"></script>
  <script type="text/javascript" src="/js/users.js?v={$version}"></script>
  <script type="text/javascript" src="/js/dashboard.js?v={$version}"></script>
  <script src="/js/cmd_heatmaps.js?v={$version}" type="text/javascript"></script>

 <div class="section">
    <h3 class="main-heading alt">
    	{$parameters.header.title|upper}
    	{*****if $parameters.user}, {$parameters.user->first_name|stripslashes|upper} {$parameters.user->last_name|stripslashes|upper}{/if****}
    </h3>

    <div id="twocolumns" class="twocolumns-dashboard">
      <div class="dashboard">
      	{include file="site_warning.tpl"}
      	{if $parameters.has_error}
          <div class="warning">
            <img src="/img/main/bg-warning.png" width="48" height="48" alt="Warning" title="Warning" />
            <h3>{$parameters.status|stripslashes}</h3>
          </div>
        {/if}
        <div class="top-menu">
          <div class="box alt" id="search-box">
            <span class="blank"><input type="text" name="key" id="search-key" value="" /></span>
            <span><a href="javascript:void(0);" id="search-add" class="add">ADD NEW STOCK</a></span>
            <div id="search-list"></div>
          </div>
          <div class="box right">
            <span><a href="/dashboard/?type=heat" class="heat {if $parameters.type == 'heat'}active{/if}">HEAT MAP</a></span>
            <span><a href="/dashboard/?type=list" class="list-view {if $parameters.type == 'list'}active{/if}">LIST VIEW</a></span>
          </div>
          <div class="box space">
          	{if $parameters.pages}
	            <div class="pages">
	              {foreach from=$parameters.pages item=item}
	                {if $item.page=='&lt;&lt;'}
	                  <a href="{$item.url}" class="first">first</a>
	                {elseif $item.page=='&lt;'}
	                  <a href="{$item.url}" class="prev">previous</a>
	                {/if}
	              {/foreach}
	              <ul>
	                {foreach from=$parameters.pages item=item}
	                  {if is_numeric($item.page)}
	                    <li>
	                      <a href="{$item.url}" {if $item.active}class="active"{/if}>
	                        {$item.page}
	                      </a>
	                    </li>
	                  {/if}
	                {/foreach}
	              </ul>
	              {foreach from=$parameters.pages item=item}
	                {if $item.page=='&gt;'}
	                  <a href="{$item.url}" class="next">next</a>
	                {elseif $item.page=='&gt;&gt;'}
	                  <a href="{$item.url}" class="last">last</a>
	                {/if}
	              {/foreach}
	            </div>
	          {/if}
            {if $parameters.search_params->limit}
              <div class="view">
                <select name="limit" class="custom">
                  {foreach from=$parameters.search_params->limit item=item}
                    <option value="{$item}" {if $item == $parameters.search->limit}selected="selected"{/if}>{$item}</option>
                  {/foreach}
                </select>
              </div>
              <em>VIEW PER PAGE</em>
            {/if}
          </div>
        </div>
        <div id="dashboard-nowtime">Last Updated: {$parameters.time|date_format:"%B %e, %Y %I:%M %p"}</div>
        <div class="dashboard-view-mode" data-view-mode="{$smarty.cookies.view_mode}">
		    	Currently Displaying: {if $smarty.cookies.view_mode eq "MP"}Market Prophits{else}Crowd{/if}
		    </div>

        {if $parameters.records}
          {if $parameters.type == 'list'}
            {if $parameters.search_params->sorting}
              <table class="titles" cellspacing="0" cellpadding="0">
              	<tr>
  	              {foreach from=$parameters.search_params->sorting item=item key=key}
  	                <td class="{$key}">
  	                  {if $item.status == true}
  	                  	<a href="javascript:void(0);" {if isset($item.active) && $item.active == true} class="active {$parameters.search->order}"{/if}>
  	                  		{$item.name}
  	                  	</a>
  	                  {else}
  	                  	<em>{$item.name}</em>
  	                  {/if}
  	                </td>
  	              {/foreach}
  	            </tr>
              </table>
              <div class="c"></div>
            {/if}
            {foreach from=$parameters.records item=item}
              <div class="stock{if $item->status == 0} pending{/if}" id="stock_{$item->ticker|escape}" data-stock-id="{$item->id|escape}" data-stock="{$item->ticker|escape}" data-ticker="{$item->ticker|stripslashes}">
                <div class="top-bar">
                  <div class="ticker">
                    <a href="/stock/{$item->ticker|stripslashes|urlencode|urlencode}/">{$item->ticker|stripslashes|truncate:8:"...":true}</a>
                  </div>
                  <div class="company">
                    <a href="/stock/{$item->ticker|stripslashes}/" title="{$item->company|stripslashes|escape}">{$item->company|stripslashes|truncate:33:"...":true}</a>
                  </div>
                  <div class="price">
                    <p>{$item->price|price_format:$item->exchange}</p>
                  </div>
                  <div class="price-change">
                    <em class="{if $item->percent_change > 0}up{elseif $item->percent_change < 0}down{else}simple{/if}">{$item->percent_change|number_format:2}%</em>
                  </div>
                  <div class="sentiment">
                    <em class="{if $item->sentiment > 0}up{elseif $item->sentiment < 0}down{else}simple{/if}">{$item->sentiment|number_format:6}</em>
                  </div>
                  <div class="buzz">
                    <em class="{if $item->buzz > 1}up{elseif $item->buzz < 1}down{else}simple{/if}">{$item->buzz|number_format:2}</em>
                  </div>
                  <div class="show">
                    <a href="javascript:void(0);" onclick="showStockData(this);" id="show" class="icon">show</a>
                  </div>
                  <div class="alerts">
                    <a href="javascript:void(0);" onclick="showStockData(this);" id="alerts" class="icon">alerts</a>
                  </div>
                  <div class="graphs">
                    <a href="javascript:void(0);" onclick="showStockData(this);" id="graphs" class="icon">graphs</a>
                  </div>
                  <div class="close">
                    <a href="javascript:void(0);" onclick="openDeleteStockWindow(this);" id="close" class="icon">close</a>
                  </div>
                </div>
                <div class="stock-data"></div>
              </div>
            {/foreach}
          {else}
            <script src="/fitch/resources/Jit/jit.js" type="text/javascript"></script>
            <script type="text/javascript">
              $(function(){ldelim}
                heatmap({$parameters.records});
              {rdelim});
            </script>

            <div id="heatmap" data-view-mode="{$smarty.cookies.view_mode|escape}" data-mode="{$parameters.mode|escape}" data-exchange="{$parameters.exchange|escape}" data-tickers="{$parameters.ticker_ids|escape}"></div>
            <div id="heatmap-legend">
              {if $smarty.get.mode eq "buzz"}
                <div class="label">Size:</div>
                <div class="value">
                  Buzz
                </div>
              {/if}
              <div class="label">Sentiment</div>
              {foreach from=$parameters.legend key=value item=color}
                <div class="box" style="background:{$color};">{$value}</div>
              {/foreach}
            </div>
          {/if}
        {else}
          <div class="message">
            {if $parameters.type == 'list'}
              <p>You have no stocks added to your dashboard.</p>
            {else}
              <p>There is currently no buzz in your portfolio of stocks.</p>
            {/if}
          </div>
        {/if}

        <div class="top-menu">
          <div class="box right">
            <span><a href="/dashboard/?type=heat" class="heat {if $parameters.type == 'heat'}active{/if}">HEAT MAP</a></span>
            <span><a href="/dashboard/?type=list" class="list-view {if $parameters.type == 'list'}active{/if}">LIST VIEW</a></span>
          </div>
           <div class="box space">
          	{if $parameters.pages}
	            <div class="pages">
	              {foreach from=$parameters.pages item=item}
	                {if $item.page=='&lt;&lt;'}
	                  <a href="{$item.url}" class="first">first</a>
	                {elseif $item.page=='&lt;'}
	                  <a href="{$item.url}" class="prev">previous</a>
	                {/if}
	              {/foreach}
	              <ul>
	                {foreach from=$parameters.pages item=item}
	                  {if is_numeric($item.page)}
	                    <li>
	                      <a href="{$item.url}" {if $item.active}class="active"{/if}>
	                        {$item.page}
	                      </a>
	                    </li>
	                  {/if}
	                {/foreach}
	              </ul>
	              {foreach from=$parameters.pages item=item}
	                {if $item.page=='&gt;'}
	                  <a href="{$item.url}" class="next">next</a>
	                {elseif $item.page=='&gt;&gt;'}
	                  <a href="{$item.url}" class="last">last</a>
	                {/if}
	              {/foreach}
	            </div>
	          {/if}
            {if $parameters.search_params->limit}
              <div class="view">
                <select name="limit" class="custom">
                  {foreach from=$parameters.search_params->limit item=item}
                    <option value="{$item}" {if $item == $parameters.search->limit}selected="selected"{/if}>{$item}</option>
                  {/foreach}
                </select>
              </div>
              <em>VIEW PER PAGE</em>
              <a class="back" href="javascript:void(0);" onclick="scrollTopDiv('twocolumns')">BACK TO TOP</a>
            {/if}
          </div>
        </div>
      </div>
    </div>
  </div>
{include file="site_bottom.tpl"}
{/strip}