{strip}
{include file="site_top.tpl"}
<script src="/js/cmd_pricing.js"></script>

<div class="section">
  <h3 class="main-heading">{$parameters.header.title|escape|upper}</h3>
  <div id="twocolumns" class="twocolumns-dashboard">
  	{include file="site_warning.tpl"}
    <div class="cover">&nbsp;</div>
    
    <div class="page register">
      
      <ul class="white-box">
      	<li>Find out whats buzzing in social media about the stocks you care about</li>
      	<li>Get the pulse of the sentiment of social media financial-related chatter</li>
      	<li>View not only what the "Crowd" is saying but also the "Market Prophits"</li>
      	<li>Track your favorite stocks as well as your favorite financial pundits in powerful dashboards</li>
      	<li>Get alerts on the stocks and sectors of interest to you</li>
      </ul>
      
      <div class="h40"></div>

			<table class="custom-table">
	    	<thead>
	    		<th class="white">Choose Your Package</th>
	    		{if $parameters.tiers}
	    			{foreach from=$parameters.tiers item=item}
	    				<th class="blue">{$item.name|escape}</th>
	    			{/foreach}
	    		{/if}
	    	</thead>
	    	<tbody>
	    		<tr class="odd">
	    			<td class="blue">Monthly Price</td>
	    			{if $parameters.tiers}
	      			{foreach from=$parameters.tiers item=item}
	      				<td class="white">${$item.monthly.price|escape}/month</td>
	      			{/foreach}
	      		{/if}
	    		</tr>
	    		<tr class="even">
	    			<td class="blue">Annual Price</td>
	    			{if $parameters.tiers}
	      			{foreach from=$parameters.tiers item=item}
	      				<td class="white">${$item.annual.price|escape}/year</td>
	      			{/foreach}
	      		{/if}
	    		</tr>
	    		<tr class="odd">
	    			<td class="blue">Free Trial Period</td>
	    			{if $parameters.tiers}
	      			{foreach from=$parameters.tiers item=item}
	      				<td class="white">{$item.trial|escape}</td>
	      			{/foreach}
	      		{/if}
	    		</tr>
	    		<tr class="even">
	    			<td class="blue">"Crowd" Sentiment Signals</td>
	    			{if $parameters.tiers}
	      			{foreach from=$parameters.tiers item=item}
	      				<td class="white">
	      					{if $item.signals.crowd_sentiment}<span class="mark"></span>{/if}
	      				</td>
	      			{/foreach}
	      		{/if}
	    		</tr>
	    		<tr class="odd">
	    			<td class="blue">"Market Prophit" Sentiment Signals</td>
	    			{if $parameters.tiers}
	      			{foreach from=$parameters.tiers item=item}
	      				<td class="white">
	      					{if $item.signals.mp_sentiment}<span class="mark"></span>{/if}
	      				</td>
	      			{/foreach}
	      		{/if}
	    		</tr>
	    		<tr class="even">
	    			<td class="blue">Buzz Signal</td>
	    			{if $parameters.tiers}
	      			{foreach from=$parameters.tiers item=item}
	      				<td class="white">
	      					{if $item.signals.buzz}<span class="mark"></span>{/if}
	      				</td>
	      			{/foreach}
	      		{/if}
	    		</tr>
	    		<tr class="odd">
	    			<td class="blue"># of Stocks Per Day</td>
	    			{if $parameters.tiers}
							{foreach from=$parameters.tiers item=item}
								<td class="white">
									{if $item.limit.pages === null}Unlimited{else}{$item.limit.pages|escape}{/if}
								</td>
							{/foreach}
						{/if}
	    		</tr>
	    		<tr class="even">
	    			<td class="blue"># of Stocks in Dashboard</td>
	    			{if $parameters.tiers}
							{foreach from=$parameters.tiers item=item}
								<td class="white">
									{if $item.limit.dashboards === null}Unlimited{else}{$item.limit.dashboards|escape}{/if}
								</td>
							{/foreach}
						{/if}
	    		</tr>
	    		<tr class="odd">
	    			<td class="blue"># of Users Per Day</td>
	    			{if $parameters.tiers}
							{foreach from=$parameters.tiers item=item}
								<td class="white">
									{if $item.limit.pages === null}Unlimited{else}{$item.limit.pages|escape}{/if}
								</td>
							{/foreach}
						{/if}
	    		</tr>
	    		<tr class="even">
	    			<td class="blue"># of Users in Dashboard</td>
	    			{if $parameters.tiers}
							{foreach from=$parameters.tiers item=item}
								<td class="white">
									{if $item.limit.dashboards === null}Unlimited{else}{$item.limit.dashboards|escape}{/if}
								</td>
							{/foreach}
						{/if}
	    		</tr>
	    		<tr class="odd">
	    			<td class="blue"># of Total Daily Active Alerts</td>
	    			{if $parameters.tiers}
							{foreach from=$parameters.tiers item=item}
								<td class="white">
									{if $item.limit.alerts === null}Unlimited{else}{$item.limit.alerts|escape}{/if}
								</td>
							{/foreach}
						{/if}
	    		</tr>
	    		<tr class="even">
	    			<td></td>
	    			<td><a href="javascript:void(0);" class="button-link" title="Select">Sign Up</a></td>
	    			<td><a href="javascript:void(0);" class="button-link" title="Select">Sign Up</a></td>
	    			<td><a href="javascript:void(0);" class="button-link" title="Select">Sign Up</a></td>
	    		</tr>
	    	</tbody>
	    </table>

    </div>
    
  </div>
</div>

{include file="site_bottom.tpl"}
{/strip}