{strip}
{include file="site_top.tpl"}
<script type="text/javascript" src="https://js.stripe.com/v1/"></script>
<script type="text/javascript">Stripe.setPublishableKey('{$parameters.stripe_key|escape}');</script>
<link rel="stylesheet" type="text/css" href="/styles/dropkick.css" />
<script src="/js/jquery.dropkick.js?v=20140103"></script>
<script src="/js/jquery.payment.js"></script>
<script src="/js/cmd_register.js?v=201510091"></script>

{capture name=order_box}
	<div class="order-box">
		<div class="order-header">
			Order Summary
		</div>
		<div class="order-content">
			<span class="title">Your Selected Tier:</span>
			<table>
				<tr>
					<td class="blue" data-order-info="plan"></td>
					<td>
						<a href="javascript:void(0);" data-step="1" class="button-link small">Change</a>
					</td>
				</tr>
				<tr class="print-hide">
					<td colspan="2" class="border"><div></div></td>
				</tr>
				<tr class="print-hide">
					<td>
						<input name="payment_type" value="monthly" type="radio" id="pt1" class="dismiss"/>
						<label for="pt1">Monthly Price</label>
					</td>
					<td class="blue">
						$<span data-order-info="monthly_price"></span>
					</td>
				</tr>
				<tr class="print-hide">
					<td colspan="2" class="dotted"><div></div></td>
				</tr>
				<tr class="print-hide">
					<td>
						<input name="payment_type" value="annual" type="radio" id="pt2" class="dismiss"/>
						<label for="pt2">Annual Price</label>
					</td>
					<td class="blue">
						$<span data-order-info="annual_price"></span>
					</td>
				</tr>
				<tr class="print">
					<td><span class="first-up" data-order-info="payment_type"></span> Price</td>
					<td class="blue">$<span data-order-info="price">0</span></td>
				</tr>
				<tr class="print-hide">
					<td colspan="2" class="border"><div></div></td>
				</tr>
				<tr>
					<td>Coupon Code</td>
					<td class="blue">-$<span data-order-info="discount">0</span></td>
				</tr>
				<tr>
					<td>Coupon Code Promotion Expires</td>
					<td class="blue" data-order-info="coupon_expires"></td>
				</tr>
				<tr>
					<td>Free Trial</td>
					<td class="blue" data-order-info="trial"></td>
				</tr>
				<tr class="print-hide">
					<td colspan="2" class="border"><div></div></td>
				</tr>
				<tr>
					<td>Total</td>
					<td class="blue" >$<span data-order-info="total">0</span></td>
				</tr>
			</table>
		</div>
	</div>
{/capture}

<div class="section">
  <h3 class="main-heading">{$parameters.header.title|escape|upper}</h3>
  <div id="twocolumns" class="twocolumns-dashboard">
  	{include file="site_warning.tpl"}
    <div class="cover">&nbsp;</div>
    
    <div class="page register">
    	<div class="header">
    		<ul>
    			<li class="first active" data-step="1">Select A Tier</li>
    			<li data-step="2">Create Account</li>
    			<li data-step="3">Billing Information</li>
    			<li class="last" data-step="4">Confirmation</li>
    		</ul>
    		<div class="bar">
    			<div class="line" style="width: 25%;">
    				<div class="button">
    					<span class="prev"></span>
    					<span class="next"></span>
    				</div>
    			</div>
    		</div>
    	</div>
      <div class="container">
      	<div>
      		<table class="custom-table">
		      	<thead>
		      		<th class="white">Choose Your Package</th>
		      		{if $parameters.tiers}
		      			{foreach from=$parameters.tiers item=item}
		      				<th class="blue">{$item.name|escape}</th>
		      			{/foreach}
		      		{/if}
		      	</thead>
		      	<tbody>
		      		<tr class="odd">
		      			<td class="blue">Monthly Price</td>
		      			{if $parameters.tiers}
			      			{foreach from=$parameters.tiers item=item}
			      				<td class="white">${$item.monthly.price|escape}/month</td>
			      			{/foreach}
			      		{/if}
		      		</tr>
		      		<tr class="even">
		      			<td class="blue">Annual Price</td>
		      			{if $parameters.tiers}
			      			{foreach from=$parameters.tiers item=item}
			      				<td class="white">${$item.annual.price|escape}/year</td>
			      			{/foreach}
			      		{/if}
		      		</tr>
		      		<tr class="odd">
		      			<td class="blue">Free Trial Period</td>
		      			{if $parameters.tiers}
			      			{foreach from=$parameters.tiers item=item}
			      				<td class="white">{$item.trial|escape}</td>
			      			{/foreach}
			      		{/if}
		      		</tr>
		      		<tr class="even">
		      			<td class="blue">"Crowd" Sentiment Signals</td>
		      			{if $parameters.tiers}
			      			{foreach from=$parameters.tiers item=item}
			      				<td class="white">
			      					{if $item.signals.crowd_sentiment}<span class="mark"></span>{/if}
			      				</td>
			      			{/foreach}
			      		{/if}
		      		</tr>
		      		<tr class="odd">
		      			<td class="blue">"Market Prophit" Sentiment Signals</td>
		      			{if $parameters.tiers}
			      			{foreach from=$parameters.tiers item=item}
			      				<td class="white">
			      					{if $item.signals.mp_sentiment}<span class="mark"></span>{/if}
			      				</td>
			      			{/foreach}
			      		{/if}
		      		</tr>
		      		<tr class="even">
		      			<td class="blue">Buzz Signal</td>
		      			{if $parameters.tiers}
			      			{foreach from=$parameters.tiers item=item}
			      				<td class="white">
			      					{if $item.signals.buzz}<span class="mark"></span>{/if}
			      				</td>
			      			{/foreach}
			      		{/if}
		      		</tr>
		      		<tr class="odd">
			    			<td class="blue"># of Stocks Per Day</td>
			    			{if $parameters.tiers}
									{foreach from=$parameters.tiers item=item}
										<td class="white">
											{if $item.limit.pages === null}Unlimited{else}{$item.limit.pages|escape}{/if}
										</td>
									{/foreach}
								{/if}
			    		</tr>
			    		<tr class="even">
			    			<td class="blue"># of Stocks in Dashboard</td>
			    			{if $parameters.tiers}
									{foreach from=$parameters.tiers item=item}
										<td class="white">
											{if $item.limit.dashboards === null}Unlimited{else}{$item.limit.dashboards|escape}{/if}
										</td>
									{/foreach}
								{/if}
			    		</tr>
			    		<tr class="odd">
			    			<td class="blue"># of Users Per Day</td>
			    			{if $parameters.tiers}
									{foreach from=$parameters.tiers item=item}
										<td class="white">
											{if $item.limit.pages === null}Unlimited{else}{$item.limit.pages|escape}{/if}
										</td>
									{/foreach}
								{/if}
			    		</tr>
			    		<tr class="even">
			    			<td class="blue"># of Users in Dashboard</td>
			    			{if $parameters.tiers}
									{foreach from=$parameters.tiers item=item}
										<td class="white">
											{if $item.limit.dashboards === null}Unlimited{else}{$item.limit.dashboards|escape}{/if}
										</td>
									{/foreach}
								{/if}
			    		</tr>
			    		<tr class="odd">
			    			<td class="blue"># of Total Daily Active Alerts</td>
			    			{if $parameters.tiers}
									{foreach from=$parameters.tiers item=item}
										<td class="white">
											{if $item.limit.alerts === null}Unlimited{else}{$item.limit.alerts|escape}{/if}
										</td>
									{/foreach}
								{/if}
			    		</tr>
		      		<tr class="even">
		      			<td></td>
		      			<td><a href="javascript:void(0);" class="button-link" title="Select">Select</a></td>
		      			<td><a href="javascript:void(0);" class="button-link" title="Select">Select</a></td>
		      			<td><a href="javascript:void(0);" class="button-link" title="Select">Select</a></td>
		      		</tr>
		      	</tbody>
		      </table>
      	</div>
      	<div>
      		<div class="wrap">
	      		<div class="part">
					    <form action="" method="post" id="form-personal-info">
					      <fieldset>
					          <h4>Get Started - Create Your Account</h4>
					          <div class="row">
					          	<select name="country" id="country">
												<option value="" selected>Country</option>
												{foreach from=$parameters.countries item=item}
													<option value="{$item->name}">
														{$item->name|escape}
													</option>
												{/foreach}
											</select>
											<div class="c"></div>
					          </div>
					          <div class="row">
					         	 <input type="text" class="text" placeholder="first name" name="first_name" value="" />
					          </div>
					          <div class="row">
					          	<input type="text" class="text" placeholder="last name" name="last_name" value="" />
					          </div>
					          <div class="row">
					         		<input type="text" class="text" placeholder="address 1" name="address" value="" />
					          </div>
					          <div class="row">
					          	<input type="text" class="text" placeholder="address 2" name="address2" value="" />
					          </div>
					          <div class="row">
					          	<input type="text" class="text" placeholder="city" name="city" value="" />
					          </div>
					          <div class="row">
					          	{state_drop_down field_name="us_ship_states" selected_state=$state|stripslashes attr='data-state-country="US"'}
											{province_drop_down field_name="canada_ship_states" selected_province=$state|escape attr='data-state-country="Canada"'}
					          	<input type="text" class="text" placeholder="zip" name="zip" value="" style="width: 147px;" />
					          </div>
					          <div class="row">
					          	<input type="text" class="text" placeholder="email" name="email" value="" />
					          </div>
					          <div class="row">
					          	<input type="password" class="text" placeholder="password" name="password" value="" />
					          </div>
					          <div class="row">
					          	<input type="password" class="text" placeholder="confirm password" name="password_confirm" value="" />
					          </div>
					          <div class="row">
					          	<input type="text" class="text" placeholder="verification code" name="captcha" id="captcha" value="" style="width: 240px;" />
					            <img width="90" height="40" class="captcha" alt="captcha" title="Click to refresh." src="/fitch/resources/captcha/index.php?t={$smarty.now}" onclick="this.src='/fitch/resources/captcha/index.php?t='+(new Date()).getTime();" />
					          </div>
					          <div class="row">
					            <input type="checkbox" id="accept" name="accept" value="1" />
					            <label for="accept">I read and accept the Market Prophit <a href="/terms-of-service/">Terms of Service</a></label>
					          </div>
					          <div class="row">
					            <input type="checkbox" id="is_subscribed" name="is_subscribed" value="1" />
					            <label for="is_subscribed">I want to receive e-mail updates from Market Prophit</label>
					          </div>
						        <div class="row">
					          	<a href="javascript:void(0);" class="button-link" data-step="1" title="Previous">Previous</a>
					          	<a href="javascript:void(0);" class="button-link next" title="Next">Next</a>
					          	<input type="submit" name="submit" style="display: none;" />
					          </div>
					          <h5><span>Or Register Using</span></h5>
					          <a href="/connect/twitter/" class="connect twitter">Twitter</a>
					          <a href="/connect/facebook/" class="connect facebook">Facebook</a>
					          <a href="/connect/linkedin/" class="connect linked-in">Linkedin</a>
					      </fieldset>
					    </form>
	      		</div>
	      		<div class="part">
	      			{$smarty.capture.order_box}
	      		</div>
      		</div>
      	</div>
      	<div>
      		<div class="wrap">
	      		<div class="part">
					    <form action="" method="post" id="form-billing-info">
					    	<input type="hidden" name="card" />
					      <fieldset>
					          <h4>Billing Information</h4>
					          <div class="row">
					            <input type="checkbox" id="use-personal-info" name="use_personal_info" value="1" />
					            <label for="use-personal-info">Billing Information is same as Personal Information</label>
					          </div>
					          <div class="row">
					          	<select name="billing_country" id="billing_country">
												<option value="" selected>Country</option>
												{foreach from=$parameters.countries item=item}
													<option value="{$item->name}">
														{$item->name|escape}
													</option>
												{/foreach}
											</select>
											<div class="c"></div>
					          </div>
					          <div class="row">
					         	 <input type="text" class="text" placeholder="first name" name="first_name" value="" />
					          </div>
					          <div class="row">
					          	<input type="text" class="text" placeholder="last name" name="last_name" value="" />
					          </div>
					          <div class="row">
					         		<input type="text" class="text" placeholder="address 1" name="address" value="" />
					          </div>
					          <div class="row">
					          	<input type="text" class="text" placeholder="address 2" name="address2" value="" />
					          </div>
					          <div class="row">
					          	<input type="text" class="text" placeholder="city" name="city" value="" />
					          </div>
					          <div class="row">
					          	{state_drop_down field_name="us_billing_state" selected_state=$state|stripslashes attr='data-billing-state-country="US"'}
											{province_drop_down field_name="canada_billing_state" selected_province=$state|escape attr='data-billing-state-country="Canada"'}
					          	<input type="text" class="text" placeholder="zip" name="zip" value="" style="width: 147px;" />
					          </div>
					          <h4>Coupon Code</h4>
					          <div class="row">
					          	<input type="text" class="text" placeholder="coupon code" name="coupon_code" value="" style="width: 218px;" />
					          	<a href="javascript:void(0);" class="button-link text-button">Validate</a>
					          </div>
					          <h4>Payment Options</h4>
					          <div class="row">
					          	<input name="cc_type" value="visa" type="radio" id="e1" class="dismiss">
											<label for="e1"><img src="/img/main/ico-visa.png" width="40" height="25" alt="Visa" title="Visa" /></label>
											<input name="cc_type" value="mastercard" type="radio" id="e2" class="dismiss">
											<label for="e2"><img src="/img/main/ico-mc.png" width="40" height="25" alt="MasterCard" title="MasterCard" /></label>
											<input name="cc_type" value="discover" type="radio" id="e4" class="dismiss">
											<label for="e4"><img src="/img/main/ico-discover.png" width="40" height="25" alt="Discover" title="Discover" /></label>
											<input name="cc_type" value="amex" type="radio" id="e5" class="dismiss">
											<label for="e5"><img src="/img/main/ico-amexpress.png" width="40" height="25" alt="Amex" title="Amex" /></label>
					          </div>
					          <div class="row">
					          	<input type="text" class="text" placeholder="credit card number" name="cc_number" value="" />
					          </div>
					          <div class="row">
					          	<input type="text" class="text" placeholder="mm/yyyy" name="cc_exp_date" value="" style="width: 140px;margin-right: 22px;" />
					          	<input type="text" class="text" placeholder="cvv" name="cc_cvv" value="" style="width: 140px;" />
					          </div>
					          <div class="row">
					          	<a href="javascript:void(0);" class="button-link" data-step="2" title="Previous">Previous</a>
					          	<a href="javascript:void(0);" class="button-link next" title="Next">Next</a>
					          	<input type="submit" name="submit" style="display: none;" />
					          </div>
					      </fieldset>
					    </form>
	      		</div>
	      		<div class="part">
	      			{$smarty.capture.order_box}
	      		</div>
      		</div>
      	</div>
      	<div>
      		<div class="wrap print">
	      		<h4 class="top">
		    			Thank You for signing up for the <span class="blue">Market Prophit - <span data-order-info="plan"></span></span>. Below is a summary of your purchase:
		    		</h4>
		    		<h4>Confirmation #<span data-order-info="confirmation_id"></h4>
	    		</div>
      		<div class="wrap">
	      		<div class="part">
	      			<h4>Personal Information</h4>
	      			<p><span data-personal-info="first_name"></span> <span data-personal-info="last_name"></span></p>
	      			<p><span data-personal-info="address"></span></p>
	      			<p><span data-personal-info="address2"></span></p>
	      			<p><span data-personal-info="city"></span>, <span data-personal-info="state_name"></span>, <span data-personal-info="zip"></span></p>
	      			<p><span data-personal-info="country"></span></p>
	      			<p><span data-personal-info="email"></span></p>
	      			<div class="h50"></div>
	      			<h4>Payment Information</h4>
	      			<p>Credit Card Type: <span data-billing-info="cc_type"></span></p>
	      			<p>Credit Card Number: <span data-billing-info="cc_number"></span></p>
	      			<p><span data-billing-info="first_name"></span> <span data-billing-info="last_name"></span></p>
	      			<p><span data-billing-info="address"></span></p>
	      			<p><span data-billing-info="address2"></span></p>
	      			<p><span data-billing-info="city"></span>, <span data-billing-info="state_name"></span>, <span data-billing-info="zip"></span></p>
	      			<p><span data-billing-info="country"></span></p>
	      			<div class="row">
		          	<a href="javascript:void(0);" class="button-link" data-step="3" title="Previous">Previous</a>
		          	<a href="javascript:void(0);" class="button-link purchase" title="Purchase">Purchase</a>
		          </div>
      			</div>
	      		<div class="part">
	      			{$smarty.capture.order_box}
	      		</div>
	      		<div class="row print print-remove">
	      			<div class="h60"></div>
		        	<a href="javascript:void(0);" class="button-link" onclick="window.print();" title="Print">Print</a>
	          </div>
      		</div>
      	</div>
     </div>
    </div>
    
  </div>
</div>

{include file="site_bottom.tpl"}
{/strip}