{strip}

	{if $parameters.tables}
    {foreach name=tables from=$parameters.tables key=key item=table}
      <div class="table-item">
        <h3>{$table.title}</h3>
        {if $table.records}
          <table cellpadding="0" cellspacing="0" style="border-collapse:collapse;" class="sorting">
            <thead>
              <tr>
                <th class="ticker">
                  TICKER<br /><span></span>
                </th>
                <th class="name">
                  NAME<br /><span></span>
                </th>
                <th class="sentiment">
                  SENTIMENT<br /><span></span>
                </th>
                <th class="recent">
                  RECENT<br />SENTIMENT<br />CHANGE<br /><span></span>
                </th>
                <th class="since-open">
                  SENTIMENT<br />CHANGE<br />SINCE<br />OPEN<br /><span></span>
                </th>
                <th class="buz">
                  BUZZ<br /><span></span>
                </th>
                <th class="price">
                  PRICE<br /><span></span>
                </th>
                <th class="change">
                  PRICE<br />CHANGE<br />(%)<br /><span></span>
                </th>
              </tr>
            </thead>
            <tbody>
            	{foreach from=$table.records item=item}
            		{if $item}
                  <tr>
                    <td class="ticker">
                    	<a href="/stock/{$item->TICKER|escape|urlencode|urlencode}/">
                    		{$item->TICKER}
                    	</a>
                    	{if $item->PROXY_TICKER_FLAG}
                    		&nbsp;*
                    	{/if}
                    	{if $item->DELAYED_FLAG}
                    		&nbsp;**
                    	{/if}
                    	{if !isset($item->PRICE)}
                    		&nbsp;***
                    	{/if}
                    </td>
                    <td class="name" width="100" style="padding:0 5px;">
                    	<div title="{$item->COMPANY_NAME|escape}" style="white-space:nowrap;text-overflow:ellipsis;overflow:hidden;width:inherit;">
                    		{$item->COMPANY_NAME|escape}
                    	</div>
                    </td>
                    <td class="sentiment{if $item->AVERAGE_SENTIMENT > 0} up{elseif $item->AVERAGE_SENTIMENT < 0} down{/if}">
                    	{$item->AVERAGE_SENTIMENT|string_format:"%.4f"}
                    </td>
                    <td class="recent{if $item->SENTIMENT_CHANGE > 0} up{elseif $item->SENTIMENT_CHANGE < 0} down{/if}">
                    	{$item->SENTIMENT_CHANGE|string_format:"%.4f"}
                    </td>
                    <td class="since-open{if $item->CHANGE_FROM_OPEN > 0} up{elseif $item->CHANGE_FROM_OPEN < 0} down{/if}">
                    	{$item->CHANGE_FROM_OPEN|string_format:"%.4f"}
                    </td>
                    <td class="buzz{if $item->BUZZ > 1} up{elseif $item->BUZZ < 1} down{/if}">
                    	{$item->BUZZ|string_format:"%.2f"}
                    </td>
                    <td class="price">
                    	{if isset($item->PRICE)}
                    		{$item->PRICE|price_format:$item->EXCHANGE}
                    	{else}
                    		&nbsp;
                    	{/if}
                    </td>
                    <td class="change{if $item->PERCENT_CHANGE > 0} up{elseif $item->PERCENT_CHANGE < 0} down{/if}">
                    	{if isset($item->PERCENT_CHANGE)}
                    		{$item->PERCENT_CHANGE|string_format:"%.2f"}
                    	{else}
                    		&nbsp;
                    	{/if}
                    </td>
                  </tr>
                {else}
                	<tr>
                    <td class="ticker">&nbsp;</td>
                    <td class="name">&nbsp;</td>
                    <td class="sentiment">&nbsp;</td>
                    <td class="recent">&nbsp;</td>
                    <td class="since-open">&nbsp;</td>
                    <td class="buzz">&nbsp;</td>
                    <td class="price">&nbsp;</td>
                    <td class="change">&nbsp;</td>
                  </tr>
                {/if}
              {/foreach}
            </tbody>  
          </table>
       	{else}
       		<p>There are no records found.</p>
        {/if}
      </div>
    {/foreach}
    <p>
    	<br />
    	NOTE: for tickers labeled with an *, a proxy ticker was used for the price.  You can find which proxy ticker was used by going to the stock page for that ticker.
    	<br />
    	NOTE: for tickers labeled with a **, the quote is delayed 15 mins.
    	<br />
    	NOTE: for tickers labeled with a ***, there currently is no price available.
    </p>
  {/if}

{/strip}