function initDashboard(){
	var navLinks = $('.alert-dashboard-nav li');
	var navContent = $('.alert-dashboard-content > div');
	navLinks.click(function(){
		var index = navLinks.index(this);
		navLinks.removeClass('active').eq(index).addClass('active');
		navContent.hide().eq(index).show();
		redraw();
	});
	
	navContent.each(function(){
		var filters = $('.alert-dashboard-box-filter li', this);
		filters.click(function(){
			var index = filters.index(this);
			filters.removeClass('active').eq(index).addClass('active');
		});
	});
	
	navLinks.first().click();
	
	$('.alert-dashboard-box.list').each(function(){
		var box = $(this);
		$.get('/ajax/alert/dashboard/list/',{type: $(this).attr('data-type'), status: 1}, function(data){
	  	if(data) box.html(data).slideDown('slow');
	  });
	});
	
	$('.alert-dashboard-box.create').each(function(){
		updateAlertCreateBox(this);
	});
}

function redraw(){
	$('.alert-dashboard-tscroll:visible').each(function(){
		var This =$(this), api = This.data('jsp');
		if(api) api.reinitialise();
		else This.jScrollPane({contentWidth: '0px'});
	});
}
/* SORT TABLE FUNCTIONS*/
function initSortTable(box){
	box = $(box);
	var table = $('.alert-dashboard-tbody', box);
	var thTable = $('th', table);
	var wrap = table.closest('.alert-dashboard-tscroll');
	if(table.length){
		var headers = {};
		thTable.each(function(i, item){
			var item = $(item);
			if(!item.hasClass('sortable')){
				headers[i] = {sorter:false}
			}
		});
		table.tablesorter({
			textExtraction: dataExtraction,
			widgets: ["zebra"],
			headers:headers,
			cssAsc: 'desc',
			cssDesc: 'asc',
			cssHeader: 'sortable',
			cssChildRow: 'expand-child'
		});
		var header = table.clone();
		var thHeader = $('th', header);
		$('tbody', header).remove();
		header.removeClass('alert-dashboard-tbody').addClass('alert-dashboard-thead');
		wrap.before(header);
		thHeader.click(function(){
			var index = thHeader.index($(this));
			var item = $(thTable.get(index));
			if(item.hasClass('sortable')){
				item.click();
				thHeader.removeClass('desc asc');
				var className = item.attr('class');
				if(item.hasClass('desc')){
					className = className.replace("desc", "asc");
				}else if(item.hasClass('asc')){
					className = className.replace("asc", "desc");
				}else{
					className = 'asc';
				}
				$(this).addClass(className);
			}
		});
		$('thead', table).hide();
		addSpaceToSortTable(table);
		table.bind("sortStart",function(){ 
	    startSortTable(this);
	    $(this).trigger("update");
		}).bind("sortEnd",function(){
			endSortTable(this);
		});
	}
	redraw();
}

function addSpaceToSortTable(table){
	table = $(table);
	var space = '<tr class="alert-dashboard-tspace"><td colspan="10"></td></tr>';
	table.find('tr').each(function(index){
		var row = $(this);
		if(!row.next().hasClass('expand-child')){
			row.after(space);
		}
	});
}

function startSortTable(table){
	table = $(table);
	var rows = table.find('tr.alert-dashboard-tspace');
	if(rows.length) rows.remove();
	return true;
}
function endSortTable(table){
	addSpaceToSortTable(table);
	return true;
}
/*END SORT TABLE FUNCTIONS*/

function updateAlertCount(){
	$.get('/alert-dashboard/',{action: 'update'},function(data){
		$('[data-alert-count="max_count"]').html(data.max_count);
		$('[data-alert-count="total_count"]').html(data.total_count);
		$.each(data.tabs, function(key, item){
			$('[data-alert-count="' + key + '"]').html(item.count);
		});
  }, 'json');
}

function initFilter(box){
	box = $(box);
	var filter = $('.alert-dashboard-box-filter li', box);
	filter.click(function(){
		if($(this).hasClass('active')) return false;
		filter.removeClass('active');
		$(this).addClass('active');
		updateAlertList(box);
		updateAlertCount();
	});
}

function updateAlertList(box){
	box = $(box);
	if(box.data('busy')) return;
	box.data('busy', true);
	var params = {
		action: 'update',
		type: $(box).attr('data-type'),
		status: $('.alert-dashboard-box-filter li.active', box).attr('data-alert-filter-active')
	}
	$.get('/ajax/alert/dashboard/list/', params, function(data){
  	if(data){
  		box.find('.alert-dashboard-box-content').replaceWith(data);
  		initSortTable(box);
  	}else{
  		box.find('.alert-dashboard-box-content').html('');
  	}
  	redraw();
  	box.data('busy', false);
  });
}

function updateAlertCreateBox(box){
	box = $(box);
	if(box.data('busy')) return;
	box.data('busy', true);
	$.get('/ajax/alert/dashboard/create/',{type: box.attr('data-type')}, function(data){
  	if(data){
  		box.html(data).slideDown('slow');
  		box.find('.scrolling').jScrollPane();
			makeCustomSelect(box.find(".custom"));
  	}
  	box.data('busy', false);
  });
}

function getAlertTypeParams(type){
	var params = {}
	if(type == 'users'){
		params.type = 'user';
		params.subtype = 'tickers';
	}else if(type == 'top_users_returns'){
		params.type = 'top-user';
		params.subtype = 'tickers';
	}else if(type == 'top_users_rank'){
		params.type = 'top-mp';
		params.subtype = 'tickers';
	}else if(type == 'top_sectors_returns'){
		params.type = 'top-user';
		params.subtype = 'sectors';
	}else if(type == 'top_sectors_rank'){
		params.type = 'top-mp';
		params.subtype = 'sectors';
	}
	return params;
}

function openEditAlertDashboardWindow(type, alert_id){
	var params = getAlertTypeParams(type);
	$.extend(params, {alert_id: alert_id, action:'edit'});
  var url = (type == 'stocks') ? '/ajax/dashboard/edit-alerts/' : '/ajax/users/create-alert/';
	openAjaxWindow(url,params);
}

function openDeleteAlertDashboardWindow(type, alert_id){
  var html = '<h3>DELETE ALERT</h3>';
  html += '<p>Are you sure you want to delete this alert?</p>';
  html += '<div class="line"></div>';
  html += '<a href="javascript:void(0);" onclick="deleteAlertDashboard(\''+type+'\', \''+alert_id+'\');">OK</a>';
  html += '<a href="javascript:void(0);" onclick="hidePopup();">CANCEL</a>';
  showMessageCustom(html);
  return false;
}

function deleteAlertDashboard(type, alert_id){
	var url = (type == 'stocks') ? '/ajax/dashboard/edit-alerts/' : '/ajax/users/create-alert/';
  $.post(url, {action: "delete", alert_id: alert_id}, function(data){
	  if(data.hasError == false){
		 updateAlertList($('.alert-dashboard-box.list:visible'));
		 updateAlertCount();
	  }else{
	    showErrorMessage(data.status);
	  }
	  hidePopup();
  },'json');
  return false;
}

function editAlert(stockID){
	var frm = $('.new-alert').find('#edit-alert-form');
	editAlertDashboard(frm, '/ajax/dashboard/edit-alerts/');
	return false;
}
function editUsersAlert(frm){
	editAlertDashboard(frm, '/ajax/users/create-alert/');
	return false;
}

function editAlertDashboard(frm, url){
	if(!validateAlertFrom(frm)) return showErrorMessage('Value is not valid for this variable.');
	var frm = $(frm);
  var params = frm.serialize();
  params += '&action=edit';
	$.post(url, params, function(data){
	  if(data.hasError == false){
		 updateAlertList($('.alert-dashboard-box.list:visible'));
		 updateAlertCount();
		 hidePopup();
	  }else{
	    showErrorMessage(data.status);
	  }
  },'json');
}

function saveNewAlertDashboard(frm, url, message){
	var frm = $(frm); 
	var params = frm.serialize();
  params += '&action=add';
	message = message || 'Your alert has been created.';
	$.post(url, params, function(data){
		if(data.hasError) return showErrorMessage(data.status);
		updateAlertList($('.alert-dashboard-box.list:visible'));
		updateAlertCreateBox($('.alert-dashboard-box.create:visible'));
		updateAlertCount();
		showMessage(message);
	},'json');
  return false;
}

var savePredictionDashboardCallback;
function openPredictionAlertDashboardWindow(type, frm){
	if(!validateAlertFrom(frm)) return showErrorMessage('Value is not valid for this variable.');
	var frm = $(frm);
	var url = (type == 'stocks') ? '/ajax/dashboard/edit-alerts-box/' : '/ajax/users/create-alert/';
	var ticker = frm.find('[name=ticker]').val();
	if(typeof ticker === "undefined") ticker = frm.find('[name=stock_id]').val();
	var power = frm.find('[name=power]').is(':checked');
	if(typeof ticker !== "undefined" && ticker !== '2' && ticker !== '1' && ticker != '' && (typeof power === "undefined" || !power)){
		savePredictionDashboardCallback = function(predictionId){
		  frm.find('[name=prediction_id]').val(predictionId);
			saveNewAlertDashboard(frm, url, 'Thank you for your prediction.');
		};
  	openAjaxWindow((type == 'stocks') ? '/ajax/dashboard/prediction-alerts/' : '/ajax/users/prediction-alerts/', {
			ticker: ticker,
			source: 1,
			timeframe_id: frm.find('select[name=timeframe_id]').val()
		});
	}else{
		saveNewAlertDashboard(frm, url);
	}
}

function saveUsersPrediction(frm){
	savePredictionDashboard(frm, '/ajax/users/prediction-alerts/');
	return false;
}

function savePrediction(frm){
	savePredictionDashboard(frm, '/ajax/dashboard/prediction-alerts/');
	return false;
}

function savePredictionDashboard(frm, url){
	var frm = $(frm);
  var require = frm.find('.box.require');
  if(require.length != require.find('input[type=radio]:checked').length){
    return showErrorMessage('Please make the prediction for the timeframe you set for the alert');
  }
  $.post(url, frm.serialize(), function(data){
  	if (data.hasError) return showErrorMessage(data.status);
    hidePopup();
    if(savePredictionDashboardCallback) savePredictionDashboardCallback(data.id);
   }, 'json');
}

function searchDashboard(key, list, box, type){
	this.key = $(key);
	this.list = $(list);
	this.box = $(box);
	this.type = type || 'stock';
}

searchDashboard.prototype = {
	type: '',
	list: null,
	key: null,
	ajax: null,
	id: null,
	callback: null,
	show: function(){
		var This = this;
		$('body').bind('click', This.onclick);
		var api = This.list.find('div.search-wrapper').data('jsp');
  	if(api) api.destroy();
  	This.key.focus();
   	This.list.fadeIn('fast', function(){
  		This.list.find('div.search-wrapper').jScrollPane();
  		This.list.find('tr').click(function(){
  			This.id = $(this).attr('data-id');
  			This.key.val((This.type == 'user' ? '@' : '')+This.id);
        This.run();
      });
      This.list.find('.show-all').attr('onclick','').unbind('click').click(function(){
      	if(This.ajax == null){
					This.search(100);
				}
      });
    });
	},
  hide: function(){
  	var This = this;
  	$('body').unbind('click', This.onclick);
  	This.list.fadeOut('fast');
  },
  onclick: function(event){
  	if(!$(event.target).closest('.search-list').length) $(event.target).closest('.search-list').hide();
  },
	move: function(step){
  	var This = this;
		if(!step) step = 1;
		var list = This.list.find('tr'), total = list.length, current;
		if(total){
			current = list.filter('.active');
			current = list
				.removeClass('active')
				.eq(((current.length ? list.index(current) : (step > 0 ? -1 : total)) + total + step) % total)
				.addClass('active');
			var api = This.list.find('div.search-wrapper').data('jsp');
			if(api) api.scrollToElement(current);
		}
	},
	go: function(){
		var active = this.list.find('tr.active');
		if(active.length){
		  var This = this;
		  This.id = active.attr('data-id');
		  This.key.val((This.type == 'user' ? '@' : '')+This.id);
		  This.run();
		}
		return active.length > 0;
	},
	run: function(){
    var This = this;
    if(This.id){
    	This.box.val(This.id);
      if(typeof This.callback == 'function') This.callback();
      This.hide();
    }else{
    	This.search();
    }
    return true;
  },
  search: function(limit){
  	var This = this;
  	var key = This.key.val();
  	if(!key) return This.hide();
  	if(This.ajax) This.ajax.abort();
  	var url = This.type == 'user' ? '/ajax/search/user/' : '/ajax/search/stock/';
	  This.ajax = $.get(url, {key: key, limit: limit || 10}, function(data){
    	This.ajax = null;
    	This.id = null;
    	if(data.match){
    		This.id = data.match;
    		This.run();
    	}
      if(!data.html) return This.hide();
      This.list.empty().html(data.html);
     	This.show();
    }, 'json');
  }
};

function initSearchDashboard(box){
	box = $(box);
	$('[data-search]', box).each(function(){
		var item = $(this);
		item.addClass('search-box');
		var value = item.find('input[type="text"]');
		var list = $('<div class="search-list"><div>');
		var key = value.clone();
		key.attr('name', '');
		value.hide();
		item.append(key).append(list);
		var search = new searchDashboard(key, list, value, item.attr('data-search'));
		search.onclick = function(event){
    	if(!search.list.find(event.target).length) search.hide();
		}
		if(item.closest('.alerts-filter').length){
			search.callback = function(){
	    	alertAddFilterBox(item);
			}
		}
		var prev = '', val;
		key.keyup(function(e){
			if(e.keyCode == 13){
				if(!search.go()) search.run();
				return false;
			}else if(e.keyCode == 40) search.move(1);
			else if(e.keyCode == 38) search.move(-1);
			else{
				$('tr.active', list).removeClass('active');
				val = key.val();
				if(val != prev){
					prev = val;
					if(search.ajax == null){
						search.search();
					}
				}
			}
		});
	});
}
/* FILTER FUNCTIONS */
function alertFilterChange(select, limit){
	var select = $(select);
	limit = limit || 15;
	if(select.length > 0){
		select.each(function(){
			var item = $(this);
			if(item.is('select')){
				item.selectbox("detach");
				item.selectbox({
			  	contentWidth: '0px',
					onChange: function(val, inst){
						usersAlertaddFilterBox(inst.input, limit);
					},
					onOpen: function(inst){
						var options = $('#sbOptions_'+inst.uid);
				    var jsp = options.data('jsp');
				    if(jsp) {
				    	jsp.destroy();
				    	options = $('#sbOptions_'+inst.uid);
				    }
				    options.css({height: 'auto', overflowY: 'auto'});
				    options.jScrollPane({contentWidth: '0px'});
					}
				});
			}
		});
		alertAddFilterBox(select, limit);
	}
}

function alertAddFilterBox(item, limit, open){
	item = $(item);
	limit = limit || 15;
	open = open || false;
	var filters = item.closest('.alerts-filter');
	var data = {
		limit: limit,
		username: item.closest('form').find('input[name="username"]').val(),
		type: item.closest('form').find('input[name="type"]').val(),
		subtype: item.closest('form').find('input[name="subtype"]').val(),
	};
	filters.find('.bg:not(.filter-selector) select').each(function(){
		data[$(this).attr('name')] = $(this).attr('value');
	});
	var wrap = filters.find('.alerts-filter-tickers-box');
	if (wrap.length > 0){
		$.get('/ajax/users/filter-tickers/',data,function(response){
			if (response.html){
				wrap.html(response.html);
				var scrolling = wrap.find('.scrolling');
				if (scrolling.length > 0){
					var jsp = scrolling.data('jsp');
			    if(jsp) jsp.reinitialise();
			    else scrolling.jScrollPane();
		   	}
		   	wrap.find('tr[data-id]').click(function(){
		   		var This = $(this);
		   		var id = This.attr('data-id');
		   		var item = This.closest('.alerts-filter').find('.filter-selector .sbOptions a[rel="'+id+'"]');
		   		if(item.length){
			   		item.click();
			   		This.closest('.alerts-filter').find('.alerts-filter-tickers-box').slideUp();
			   		wrap.find('tr[data-id]').removeClass('active');
			   		This.addClass('active');
		   		}else{
		   			var select = This.closest('.alerts-filter').find('select');
		   			select.prepend('<option value="'+id+'">'+id+'</option>');
		   			select.selectbox("detach");
		   			makeCustomSelect(select);
		   			This.click();
		   		}
		   	});
		   	var value = filters.find('.filter-selector select').val();
		   	var selected = wrap.find('tr[data-id="'+value+'"]');
		   	if (selected.length > 0) selected.click();
		   	if(open) filters.find('.filter-selector .sbToggle').click();
			}
		}, 'json');
	}
}

function usersAlertaddFilterBox(item, limit, open){
	limit = limit || 500;
	alertAddFilterBox(item, limit, open);
}

function usersAlertFilterChange(select, limit){
	alertFilterChange(select, limit);
}
/* END FILTER FUNCTIONS */