$(function(){
	$('select').dropkick({ 
		open: function(){
			var options = $(this).find('.dk_options');
			options.css({height: 'auto', overflowY: 'auto'});
			var jsp = options.data('jsp');
			if(jsp) jsp.reinitialise();
			else options.jScrollPane({enableKeyboardNavigation: false});
			options.addClass('scrolling');
		},
		scroll: function(){
			var options = $(this).find('.dk_options');
			var jsp = options.data('jsp');
			if (jsp){
				var option = $('li.dk_option_current',options);
				jsp.scrollToElement(option);
			}
		}
	});
	
	$('input[type="radio"].dismiss').screwDefaultButtons({
      image:  "url(/img/main/ico-radio.png)",
      width: 13,
      height: 13
  });
  
  $('[name=country]').change(function(){
		var country = $(this).val();
		var other = true;
		$.each($('[data-billing-state-country]'), function(i){
			var item = $(this);
			if(item.attr('data-billing-state-country') == country){
				if(country == "Canada") {
					$("#state_label").show().html("Province");
				}else{
					$("#state_label").show().html("State");
				}
				item.attr('name', 'state');
				other = false;
				item.show();
				item.parent().show();
			}else{
				item.attr('name', '');
				item.hide();
				item.parent().hide();
			}
		});
		if(other){
			$("#state_label").hide();
		}
	});
	
	$('#country_ship').change(function(){
		var countryShip = $(this).val();
		var shipOther = true;
		$.each($('[data-shipping-state-country]'), function(i){
			var item = $(this);
			if(item.attr('data-shipping-state-country') == countryShip){
				if(countryShip == "Canada") {
					$("#ship_state_label").show().html("Province");
				}else{
					$("#ship_state_label").show().html("State");
				}
				item.attr('name', 'billing[state]');
				shipOther = false;
				item.show();
				item.parent().show();
			}else{
				item.attr('name', '');
				item.hide();
				item.parent().hide();
			}
		});
		if(shipOther){
			$("#ship_state_label").hide();
		}
	});
	
	$('[name=country]').change();
	$('#country_ship').change();
  
});

function submitForm(){
	hidePopup();
	$('#account_information_form').submit();
}

$(function(){
	var frm = $('#account_information_form'),
			btn = $('.submit', frm),
			tierInfo;
			
			
	function init(){
		$('[name="billing[cc_exp_date]"]', frm).payment('formatCardExpiry');
		$('[name="billing[cc_cvv]"]', frm).payment('formatCardCVC');
		$('[name="billing[cc_number]"]', frm).payment('formatCardNumber').blur(function(){
			$('[name="billing[cc_type]"]', frm).filter('[value="' + $.payment.cardType($(this).val()) + '"]').screwDefaultButtons("check");
		});
		setTierInfo();
		showPrices();
		showOrderInfo();
	}		
	
	init();
		
	function setTierInfo(){
		tierInfo = {
			id: $('[name="tier"]:checked', frm).val(),
			type: $('[name="billing[payment_type]"]:checked', frm).val()
		};
	}
	
	function isChangeTier(){
		//if(typeof tierInfo.id === 'undefined') return true;
		if(tierInfo.id != $('[name="tier"]:checked', frm).val()) return true;
		else if (tierInfo.type != $('[name="billing[payment_type]"]:checked', frm).val()) return true;
		return false;
	}
	
	function showMessageWindow(status, hasError){
		hasError = hasError || false;
		if(hasError){
			showErrorMessage(status);
		}else{
			showMessage(status);
		}
	}
	
	function setData(params, callback){
		var loading = showLoading();
		$.post(window.location.href, params, function(respons){
			btn.removeAttr('disabled');
			loading.data('close')();
			if(respons.hasError){
				showMessageWindow(respons.status, respons.hasError);
			}else{
				if(respons.status){
					var messageCallback = respons.redirect ? function(){
						window.location.href = respons.redirect;
					} : null;
					showMessage(respons.status, messageCallback);
				}
				if(typeof callback === 'function') callback();
			}
		}, 'json');
	}
	
	function showPrices(){
		var tier = $('[name="tier"]', frm).filter(':checked').val();
		var tiersInfo = $.parseJSON(tiers);
		if(typeof tiersInfo !== 'undefined'){
			$.each(tiersInfo, function(i, item){
				if(i == tier){
					$('[data-order-info="annual-price"]', frm).html('$' + number_format(item.annual.price, 2, '.', ','));
					$('[data-order-info="monthly-price"]', frm).html('$' + number_format(item.monthly.price, 2, '.', ','));
					return false;
				}
			})
		}
	}
	
	function showOrderInfo(info){
		info = info || false;
		if(info){
			$.each(info, function(key, value){
				$('[data-order-info=' + key + ']', frm).html(value);
			})
		}
		$('[data-order-info]', frm).each(function(){
	  	var item = $(this);
	  	var wraps = $('.order_' + item.attr('data-order-info'), frm);
	  	if(!wraps.length) return;
	  	if(item.html() == ''){
	  		wraps.hide();
	  	}else{
	  		wraps.show();
	  	}
	  });
	}
	
	function value(name){
		return (''+frm.find('[name="' + name + '"]').val()).replace(/^\s+|\s+$/g, '');
	}
	
	$('[name="tier"], [name="billing[payment_type]"]', frm).change(function(){
		showPrices();
		showOrderInfo({
			'coupon_code': '',
			'discount': '',
			'coupon_expires': '',
			'trial': ''
		});
		$('.button-link.text-button', frm).closest('.row').find('p').remove();
		$('.order_invoice', frm).hide();
	});
	
	$('[name="use_personal_info"]', frm).change(function(){
		if($(this).is(':checked')){
			var fields = ['country', 'first_name', 'last_name', 'address', 'address2', 'city', 'state', 'zip'];
			$.each(fields, function(i, name){
				var value = $('[name="'+name+'"]', frm).val();
				var item = $('[name="billing['+name+']"]', frm);
				item.val(value);
				if(item.is('select')){
					item.dropkick('setValue', value);
				}
			});
		}
	});
	
	btn.click(function(){
		if(isChangeTier()){
			var title = 'Are you sure you want to change your selected tier?';
			var body = '<p>Upgrades to your tier will result in additional charges.</p>';
			body += '<a onclick="submitForm();" href="javascript:void(0);">Yes</a>';
			body += '<a onclick="hidePopup();" href="javascript:void(0);">No</a>';
			showPopup(title, body);
		}else{
			frm.submit();
		}
		return false;
	});
		
	frm.submit(function(){
		var errors = [] ,month, year, exp, isCC = false;
		
		function validate(){

			if(!value('first_name')) errors.push('First Name is missing.');
			if(!value('last_name')) errors.push('Last Name is missing.');
			if(!value('address')) errors.push('Address 1 is missing.');
			if(!value('city')) errors.push('City is missing.');
			var val = value('country');
			if(!val) errors.push('Country is missing.');
			if(!value('zip')) errors.push('ZIP is missing.');
			else if(val == 'US'){
				if(!value('zip').match(/\d{5}-\d{4}$|^\d{5}$/)) errors.push('Invalid ZIP format.');
			}else if(val == 'Canada'){
				if(!value('zip').match(/^[ABCEGHJKLMNPRSTVXYabceghjklmnprstvxy]{1}\d{1}[A-Za-z]{1}( *|-)\d{1}[A-Za-z]{1}\d{1}$/)) errors.push('Invalid ZIP format.');
			}
			if(!value('state')) errors.push((val == 'Canada' ? 'Province' : 'State') + ' is missing.');
			if(!value('tier')) errors.push('Tier is missing.');
			
			if(!value('billing[payment_type]')) errors.push('Pricing Plan is missing.');
			if(!value('billing[first_name]')) errors.push('Billing First Name is missing.');
			if(!value('billing[last_name]')) errors.push('Billing Last Name is missing.');
			if(!value('billing[address]')) errors.push('Billing Address 1 is missing.');
			if(!value('billing[city]')) errors.push('Billing City is missing.');
			var val = value('billing[country]');
			if(!val) errors.push('Billing Country is missing.');
			if(!value('billing[zip]')) errors.push('Billing ZIP is missing.');
			else if(val == 'US'){
				if(!value('billing[zip]').match(/\d{5}-\d{4}$|^\d{5}$/)) errors.push('Invalid Billing ZIP format.');
			}else if(val == 'Canada'){
				if(!value('billing[zip]').match(/^[ABCEGHJKLMNPRSTVXYabceghjklmnprstvxy]{1}\d{1}[A-Za-z]{1}( *|-)\d{1}[A-Za-z]{1}\d{1}$/)) errors.push('Invalid Billing ZIP format.');
			}
			if(!value('billing[state]')) errors.push('Billing ' + (val == 'Canada' ? 'Province' : 'State') + ' is missing.');
			
			if(isCC){
				if(!value('billing[cc_number]')) errors.push('Credit Card Number is missing.');
				//else if(!$.payment.validateCardNumber(value('cc_number'))) errors.push('Invalid Credit Card Number format.');
				else if(!Stripe.validateCardNumber(value('billing[cc_number]'))) errors.push('Invalid Credit Card Number format.');
				else $('[name="billing[cc_type]"]', frm).filter('[value="' + $.payment.cardType(value('billing[cc_number]')) + '"]').screwDefaultButtons("check");
				if(!value('billing[cc_exp_date]')) errors.push('Expiration is missing.');
				else if(!$.payment.validateCardExpiry($('[name="billing[cc_exp_date]"]', frm).payment('cardExpiryVal'))) errors.push('Invalid Expiration format.');
				else{
					exp = value('billing[cc_exp_date]').split('/');
					month = trim(exp[0]);
					year = trim(exp[1]);
					if(year.length < 4) year = '20'+year;
					if(!Stripe.validateExpiry(month, year)) errors.push('Expiration is invalid.');
				}
				if(!value('billing[cc_cvv]')) errors.push('CVV is missing.');
				//else if(!$.payment.validateCardCVC(value('cc_cvv'))) errors.push('Invalid CVV format.');
				else if(!Stripe.validateCVC(value('billing[cc_cvv]'))) errors.push('Invalid CVV format.');
			}
			if(!isChangeTier()){
				if(value('billing[coupon_code]')) errors.push('Promotions can only be applied to changes in your tier level.');
			}
			
			if(errors.length > 0){
				errors = errors.join("<br/>");
				return false;
			}
			return true;
		}
		
		function submitData(){
			var fields = frm.serializeArray();
	    fields.push({name: 'action', value:'set_info'});
	    setData(fields, function(){
	    	setTierInfo();
	    });
		}
		
		if(value('billing[cc_number]') ||
			value('billing[cc_exp_date]') ||
			$('[name="billing[cc_type]"]:checked', frm).val() ||
			value('billing[cc_cvv]')
		){
			isCC = true;
		}

		if(!validate()){
			showMessageWindow(errors, true);
		}else{
			btn.attr("disabled", "disabled");
			if(isCC){
				Stripe.createToken({
		    	name: value('billing[first_name]')+' '+value('billing[last_name]'),
		    	number: value('billing[cc_number]'),
		    	cvc: value('billing[cc_cvv]'),
		    	exp_month: month,
		    	exp_year: year
		    }, function(status, response){
		    	if(response.error){
		    		btn.removeAttr("disabled");
	    			if(response.error.message == "Your card was declined."){
	        		response.error.message = "We are sorry but your credit card has been declined. Please update the fields below and try again.";
	        	}
	        	showMessageWindow(response.error.message, true);
	        }else{
	        	$('[name=card]', frm).val(response.id);
	        	submitData();
	      	}
		    });
	    }else{
	    	submitData();
	    }
		}
		return false;
	});
	
	$('.button-link.text-button', frm).click(function(){
		var link = $(this), errors = [];
				
		function validate(){
			if(!value('tier')) errors.push('Tier is missing.');
			if(!value('billing[payment_type]')) errors.push('Pricing Plan is missing.');
			if(!isChangeTier()){
				errors.push('Promotions can only be applied to changes in your tier level.');
			}else{
				if(!value('billing[coupon_code]')) errors.push('Coupon Code is missing.');	
			}
			if(errors.length > 0){
				errors = errors.join("<br/>");
				return false;
			}
			return true;
		}
		
		if(link.data("disabled")) return false;
		link.closest('.row').find('p').remove();
		if(!validate()){
			showMessageWindow(errors, true);
		}else{
			var params = {
				action: "check_coupon",
				coupon_code: $('[name="billing[coupon_code]"]', frm).val(),
				tier: $('[name="tier"]:checked', frm).val(),
				payment_type: $('[name="billing[payment_type]"]:checked', frm).val()
			};
			link.data("disabled", true);
			$.post(window.location.href, params, function(respons){
				if(respons.hasError){
					showMessageWindow(respons.status, respons.hasError);
				}else{
					if(respons.status){
						link.after('<p>' + respons.status + '</p>');
					}
					showOrderInfo(respons.info);
				}
				link.data("disabled", false);
			}, 'json');
		}
	});
	
});

$(function(){
	$('#cancel-subsricption').click(function(){
		var title = 'Are you sure you want to cancel your subscription?';
		var body = '<a onclick="cancelSubsricption();" href="javascript:void(0);">Yes</a>';
		body += '<a onclick="hidePopup();" href="javascript:void(0);">No</a>';
		showPopup(title, body);
		return false;
	});
});

function showPopup(title, body, callback){
	var data = '<h3>' + title + '</h3>';
	data += '<div class="line"></div>'
	if(body) data += body;
	hidePopup();
	showMessageCustom(data, callback);
}

function cancelSubsricption(){
	hidePopup();
	var loading = showLoading();
	$.post(window.location.href, {action: "cancel_subsricption"}, function(respons){
		loading.data('close')();
		if(respons.hasError){
			showErrorMessage(respons.status);
		}else{
			var title = 'We\'re sorry to see you go';
			var body = '<p>We hope you come back. Please let us know through the contact form why you chose to cancel.</p>';
			var callback = respons.redirect ? function(){
				window.location.href = respons.redirect;
			} : null;
			showPopup(title, body, callback);
			$('.subsricption-info').hide();
			$('[name="tier"]').screwDefaultButtons("uncheck");
			$('[name="billing[payment_type]"]').screwDefaultButtons("uncheck");
		}
	}, 'json');
}

