function openSlideshow(){
	var content = $('.slider-wrap').clone();
	var slider = $('#slider', content);
	slider.anythingSlider({
      expand: true,
      autoPlay: true,
      autoPlayLocked: true,
      pauseOnHover: false,
      resumeDelay: 0, 
      delay: 5000,      // How long between slideshow transitions in AutoPlay mode (in milliseconds) 
      animationTime: 1000,       // How long the slideshow transition takes (in milliseconds) 
      playRtl: false,
      buildArrows: true,      // If true, builds the forwards and backwards buttons 
      buildNavigation: false,      // If true, builds a list of anchor links to link to each panel 
      buildStartStop: true,
    })
    .anythingSliderFx({
    // '.selector' : [ 'caption', 'distance/size', 'time', 'easing' ]
    // 'distance/size', 'time' and 'easing' are optional parameters
    '.caption-top'    : [ 'caption-Top', '50px' ],
    '.caption-right'  : [ 'caption-Right', '130px', '1000', 'easeOutBounce' ],
    '.caption-bottom' : [ 'caption-Bottom', '50px' ],
    '.caption-left'   : [ 'caption-Left', '130px', '1000', 'easeOutBounce' ]
  });
  var anythingSlider = slider.data('AnythingSlider');
	openPopup(content, false, 'sildeshow-popup', function(){
		anythingSlider.startStop(false);
	});
}
function updateWordCloud(){
  $.get('/ajax/get/top_trending/?view_mode='+VIEW_MODE, function(data){
    if(data){
      if (data.stocks.length > 0){
        $('#top_trending_stocks').html('');
        tagCloud("#top_trending_stocks", data.stocks);
      }
      if (data.topics.length > 0){
        $('#top_trending_topics').html('');
        tagCloud("#top_trending_topics", data.topics);
      }
    }
  }, 'json');
  return true;
}//updateWordCloud

function updateTopTen(){
	var wrap = $('#top-ten-sentiments');
	if (wrap.length){
    $.get(
    	'/ajax/get/top_ten/',
	    {category: wrap.attr('data-category'), mode: wrap.attr('data-view-mode')},
	    function(data){
	      if(data){
	        var wrapper, section;
	        var  html = '';
	        $.each( data, function( key, value ) {
	        	section = wrap.find('.wrap.'+key);
	          wrapper = section.find('table');
	          wrapper.html('');
	          html = '';
	          if (value.length > 0){
	          	section.show();
	            $.each( value, function( key, value ) {
	              html += '<tr>';
	              html += '<td width="1" class="fs12">'+(key < 9 ? '0'+(key+1) : (key+1))+'.</td>';
	              html += '<td class="left"><a href="/stock/'+value.TICKER+'/">'+value.TICKER+'</a></td>';
	              html += '<td class="right fs12 '+(value.AVERAGE_SENTIMENT < 0 ? 'red' : (value.AVERAGE_SENTIMENT > 0 ? 'green' : 'blue'))+'">';
	              html += (isNaN(parseFloat(value.AVERAGE_SENTIMENT)) ? 'N/A' : parseFloat(value.AVERAGE_SENTIMENT).toFixed(3));
	              html += '</td>';
	              html += '</tr>';
	            });
	            wrapper.html(html);
	          }else{
	          	section.hide();
	          }
	        });
	        if (wrap.find('.wrap:visible').length == 1){
	        	wrap.find('.wrap:visible').css('border', 'none');
	        }else{
	        	wrap.find('.wrap:visible').css('border', '');
	        }
	      }
	    },
	    'json'
	  );
  }
  return true;
}//updateTopTen

$(function(){
	var timeout, delay = 60000;
	
	function update(){
	  if(timeout){
	    clearTimeout(timeout);
	    timeout = null;
	  }
	  updateWordCloud();
	  updateTopTen();
	  timeout = setTimeout(update, delay);
	}
	timeout = setTimeout(update, delay);
	
	updateFunctions.push(function(){
  	$('.dispaly-type h3').text('Currently Displaying: '+(VIEW_MODE == 'MP' ? 'Market Prophits' : 'Crowd'));
  	update();
  });
});