$(function(){
	$('select').dropkick({ 
		open: function(){
			var options = $(this).find('.dk_options');
			options.css({height: 'auto', overflowY: 'auto'});
			var jsp = options.data('jsp');
			if(jsp) jsp.reinitialise();
			else options.jScrollPane({enableKeyboardNavigation: false});
			options.addClass('scrolling');
		},
		scroll: function(){
			var options = $(this).find('.dk_options');
			var jsp = options.data('jsp');
			if (jsp){
				var option = $('li.dk_option_current',options);
				jsp.scrollToElement(option);
			}
		}
	});
	 
  $('.order-box').each(function(i){
  	var box = $(this);
  	var items = $('[name=payment_type]', box);
  	items.attr('name', 'payment_type_' + i).addClass('order-payment-type');
  	if(items.length > 0){
  		$.each(items, function(){
  			var itemId = $(this).attr('id');
  			$(this).attr('id', itemId + '_' + i)
  			$('[for=' + itemId + ']').attr('for', itemId + '_' + i);
  		});
  	}
  });
  
  $('input[type="radio"].dismiss').screwDefaultButtons({
      image:  "url(/img/main/ico-radio.png)",
      width: 13,
      height: 13
  });
  
  $('[name=country]').change(function(){
		var country = $(this).val();
		$.each($('[data-state-country]'), function(i){
			var item = $(this);
			if(item.attr('data-state-country') == country){
				item.attr('name', 'state');
				item.show();
				item.parent().show();
			}else{
				item.attr('name', '');
				item.hide();
				item.parent().hide();
			}
		});
	});
	$('[name=country]').change();
	
	$('[name=billing_country]').change(function(){
		var country = $(this).val();
		$.each($('[data-billing-state-country]'), function(i){
			var item = $(this);
			if(item.attr('data-billing-state-country') == country){
				item.attr('name', 'state');
				item.show();
				item.parent().show();
			}else{
				item.attr('name', '');
				item.hide();
				item.parent().hide();
			}
		});
	});
	$('[name=billing_country]').change();
  
});

$(function(){
	var register = $('.register'),
			headers = $('.header li', register),
			bar = $('.header .bar', register),
			button = $('.button', bar),
			count = headers.length,
			wraps = $('.container > div', register),
			data = {},
			btn = null,
			personalFrm = $('#form-personal-info', register),
			billingFrm = $('#form-billing-info', register),
			isSocialConnect = null,
			index = 0;
	if(count){
		init();
		$('.next', button).click(function(){
			if(index < count){
				if(setIndex(index+1)) move();
			}
			return false;
		});
		$('.prev', button).click(function(){
			if(index > 1){
				if(setIndex(index-1)) move();
			}
			return false;
		});
		$('[data-step]').click(function(){
			var step = $(this).attr('data-step');
			if(step > 0 && step <= count){
				if(setIndex(step)) move();
			}
		});
	}
	
	function init(){
		setData({action: 'init-data'}, function(){
			if(setIndex(count, true)){
					move();
				}
		});
	}
	
	function move(){
		$('.line', bar).animate({width: parseInt(index/count * 100) + '%'}, 1000);
		headers.removeClass('active');
		$(headers.get(index-1)).addClass('active');
		if(index == 1){
			button.addClass('next').removeClass('prev');
		}else if(index == count){
			button.addClass('prev').removeClass('next');
		}else{
			button.removeClass('prev').removeClass('next');
		}
		wraps.hide();
		$(wraps.get(index-1)).fadeIn(1000);
		register.removeClass('purchase');
	}
	
	function setIndex(value, offAlert){
		var result = false;
		offAlert = offAlert || false; 
		value = parseInt(value);
		if((typeof data.order === 'undefined' ||
			typeof data.steps === 'undefined' ||
			typeof data.steps.order === 'undefined' ||
			data.steps.order == false
		) && value > 1){
			if(!offAlert) showMessageWindow('Please select plan.');
			if(index != 1){
				index = 1;
				move();
			}
		}else if((typeof data.personal_info === 'undefined' ||
			typeof data.steps === 'undefined' ||
			typeof data.steps.personal_info === 'undefined' ||
			data.steps.personal_info == false
		) && value > 2){
			if(!offAlert) showMessageWindow('Please provide personal information.');
			if(index != 2){
				index = 2;
				move();
			}
		}else if((typeof data.billing_info === 'undefined' ||
			typeof data.steps === 'undefined' ||
			typeof data.steps.billing_info === 'undefined' ||
			data.steps.billing_info == false
		) && value > 3){
			if(!offAlert) showMessageWindow('Please provide billing information.');
			if(index != 3){
				index = 3;
				move();
			}
		}else{
			index = value;
			result = true;
		}
		return result;
	}
	
	function showMessageWindow(status, hasError){
		hasError = hasError || true;
		if(hasError){
			showErrorMessage(status);
		}else{
			showMessage(status);
		}
	}
	
	function setData(params, callback){
		callback = callback || function(){
			if(setIndex(index +1)){
					move();
				}
		};
		var loading = showLoading();
		$.post(window.location.href, params, function(respons){
			loading.data('close')();
			data = respons.data;
			updateOrder();
			if(respons.hasError){
				showMessageWindow(respons.status);
			}else if(typeof callback === 'function'){
				callback();
			}
		}, 'json');
	}
	
	function updateOrderInfo(){
		if(typeof data.order !== 'undefined'){
			$.each(data.order, function(name, value){
				if(name == 'discount' || name == 'trial' || name == 'coupon_expires'){
					var wrap = $('[data-order-info="'+name+'"]', register).closest('tr');
					if(value) wrap.show();
					else wrap.hide();
				}
				if(name == 'payment_type'){
					$.each($('.order-payment-type', register).filter('[value="' + value + '"]'), function(){
						$(this).screwDefaultButtons("check");
					});
					value = capitalize(value);
				}
				if(name.indexOf('price') >= 0 || name == 'total' || name == 'discount'){
					value = number_format(value, 2, '.', ',');
				}
				$('[data-order-info="'+name+'"]', register).html(value);
			});
		}
	}
	
	function updateOrder(){
		updateOrderInfo();
		isSocialConnect = false;
		if(typeof data.personal_info !== 'undefined'){
			$.each(data.personal_info, function(name, value){
				$('[data-personal-info="'+name+'"]', register).html(value);
				var item = $('[name="'+name+'"]', personalFrm);
				item.val(value);
				if(item.is('select')){
					item.dropkick('setValue', value);
				}
				if((name == 'facebook_id' ||
					name == 'twitter_id' ||
					name == 'linkedin_id'
				) && value){
					isSocialConnect = true;
				}
			});
			if(isSocialConnect && typeof data.personal_info.block_email !== 'undefined' && data.personal_info.block_email){
				$('[name="email"]', personalFrm).attr('readonly', 'readonly');
			}else{
				$('[name="email"]', personalFrm).removeAttr('readonly');
			}
		}
		if(isSocialConnect){
			$('[name="password"], [name="password_confirm"]', personalFrm).closest('.row').hide();
		}else{
			$('[name="password"], [name="password_confirm"]', personalFrm).closest('.row').show();
		}
		if(typeof data.billing_info !== 'undefined'){
			$.each(data.billing_info, function(name, value){
				$('[data-billing-info="'+name+'"]', register).html(value);
				if(name == 'cc_number') return;
				//else if(name == 'state') name = 'billing_state';
				else if(name == 'country') name = 'billing_country';
				var item = $('[name="'+name+'"]', billingFrm);
				if(item.is('select')){
					item.val(value);
					item.dropkick('setValue', value);
				}else if(item.length > 1){
					item.filter('[value="' + value + '"]').screwDefaultButtons("check");
				}else{
					item.val(value);
				}
				if(name == 'coupon_code' && !value){
					item.closest('.row').find('p').remove();
				}
			});
		}
		if(btn && typeof btn !== 'undefined'){
			btn.data("disabled", false);
			btn = null;
		}
	}
	
	$('.custom-table .button-link').click(function(){
		if($(this).data("disabled")) return false;
		var tier = $('.custom-table .button-link').index(this) + 1;
		btn = $('.custom-table .button-link');
		btn.data("disabled", true);
		setData({action: 'set_tier',tier: tier});
	});
	
	personalFrm.submit(function(){
		var errors = [];
		
		function validate(){
			function value(name){
				return (''+personalFrm.find('[name="' + name + '"]').val()).replace(/^\s+|\s+$/g, '');
			}
			if(!value('first_name')) errors.push('First Name is missing.');
			if(!value('last_name')) errors.push('Last Name is missing.');
			if(!value('address')) errors.push('Address 1 is missing.');
			if(!value('city')) errors.push('City is missing.');
			var val = value('country');
			if(!val) errors.push('Country is missing.');
			if(!value('zip')) errors.push('ZIP is missing.');
			else if(val == 'US'){
				if(!value('zip').match(/\d{5}-\d{4}$|^\d{5}$/)) errors.push('Invalid ZIP format.');
			}else if(val == 'Canada'){
				if(!value('zip').match(/^[ABCEGHJKLMNPRSTVXYabceghjklmnprstvxy]{1}\d{1}[A-Za-z]{1}( *|-)\d{1}[A-Za-z]{1}\d{1}$/)) errors.push('Invalid ZIP format.');
			}
			if(!value('state')) errors.push((val == 'Canada' ? 'Province' : 'State') + ' is missing.');
			if(!value('email')) errors.push('Email is missing.');
			else if(!value('email').match(/^.+\@.+\..+$/)) errors.push('Invalid Email format.');
			if(!isSocialConnect){
				if(!value('password')) errors.push('Password is missing.');
				else if(value('password') != value('password_confirm')) errors.push('Your passwords don\'t match.');
				else if(value('password').length < 3)  errors.push('Your password is too short.');
			}
			if(!value('captcha')) errors.push('Verification Code is missing.');
			if(!$('[name="accept"]', personalFrm).is(':checked')) errors.push('Please, accept the Terms of Service.');
			
			if(errors.length > 0){
				errors = errors.join("<br/>");
				return false;
			}
			return true;
		}
		
		if(!validate()){
			showMessageWindow(errors);
		}else{
			var fields = personalFrm.serializeArray();
			fields.push({name: 'action', value:'set_personal_info'});
			btn = $('.button-link.next', personalFrm);
			btn.data("disabled", true);
			setData(fields);
		}
		return false;
	});
	
	$('.button-link.next', personalFrm).click(function(){
		if($(this).data("disabled")) return false;
		personalFrm .submit();
	});
	
	$('[name="cc_exp_date"]', billingFrm).payment('formatCardExpiry');
	$('[name="cc_cvv"]', billingFrm).payment('formatCardCVC');
	$('[name="cc_number"]', billingFrm).payment('formatCardNumber').blur(function(){
		$('[name="cc_type"]', billingFrm).filter('[value="' + $.payment.cardType($(this).val()) + '"]').screwDefaultButtons("check");
	});
	
	billingFrm.submit(function(){
		var errors = [] ,month, year, exp;
		
		function value(name){
			return (''+billingFrm.find('[name="' + name + '"]').val()).replace(/^\s+|\s+$/g, '');
		}
		
		function validate(){
			if(!value('first_name')) errors.push('First Name is missing.');
			if(!value('last_name')) errors.push('Last Name is missing.');
			if(!value('address')) errors.push('Address 1 is missing.');
			if(!value('city')) errors.push('City is missing.');
			var val = value('billing_country');
			if(!val) errors.push('Country is missing.');
			if(!value('zip')) errors.push('ZIP is missing.');
			else if(val == 'US'){
				if(!value('zip').match(/\d{5}-\d{4}$|^\d{5}$/)) errors.push('Invalid ZIP format.');
			}else if(val == 'Canada'){
				if(!value('zip').match(/^[ABCEGHJKLMNPRSTVXYabceghjklmnprstvxy]{1}\d{1}[A-Za-z]{1}( *|-)\d{1}[A-Za-z]{1}\d{1}$/)) errors.push('Invalid ZIP format.');
			}
			if(!value('state')) errors.push((val == 'Canada' ? 'Province' : 'State') + ' is missing.');
			if(!value('cc_number')) errors.push('Credit Card Number is missing.');
			//else if(!$.payment.validateCardNumber(value('cc_number'))) errors.push('Invalid Credit Card Number format.');
			else if(!Stripe.validateCardNumber(value('cc_number'))) errors.push('Invalid Credit Card Number format.');
			else $('[name="cc_type"]', billingFrm).filter('[value="' + $.payment.cardType(value('cc_number')) + '"]').screwDefaultButtons("check");
			
			if(!value('cc_exp_date')) errors.push('Expiration is missing.');
			else if(!$.payment.validateCardExpiry($('[name="cc_exp_date"]', billingFrm).payment('cardExpiryVal'))) errors.push('Invalid Expiration format.');
			else{
				exp = value('cc_exp_date').split('/');
				month = trim(exp[0]);
				year = trim(exp[1]);
				if(year.length < 4) year = '20'+year;
				if(!Stripe.validateExpiry(month, year)) errors.push('Expiration is invalid.');
			}
			
			if(!value('cc_cvv')) errors.push('CVV is missing.');
			//else if(!$.payment.validateCardCVC(value('cc_cvv'))) errors.push('Invalid CVV format.');
			else if(!Stripe.validateCVC(value('cc_cvv'))) errors.push('Invalid CVV format.');

			if(errors.length > 0){
				errors = errors.join("<br/>");
				return false;
			}
			return true;
		}
		
		if(!validate()){
			showMessageWindow(errors);
		}else{
			btn = $('.button-link.next', billingFrm);
			btn.data("disabled", true);
			Stripe.createToken({
	    	name: value('first_name')+' '+value('last_name'),
	    	number: value('cc_number'),
	    	cvc: value('cc_cvv'),
	    	exp_month: month,
	    	exp_year: year
	    }, function(status, response){
    		if(response.error){
    			btn.data("disabled", false);
        	if(response.error.message == "Your card was declined."){
        		response.error.message = "We are sorry but your credit card has been declined. Please update the fields below and try again.";
        	}
        	showMessageWindow(response.error.message);
        }else{
        	$('[name=card]', billingFrm).val(response.id);
        	var fields = billingFrm.serializeArray();
					fields.push({name: 'action', value:'set_billing_info'});
					setData(fields);
      	}
	    });
		}
		return false;
	});
	
	$('.button-link.next', billingFrm).click(function(){
		if($(this).data("disabled")) return false;
		billingFrm.submit();
	});
	
	$('[name="use_personal_info"]', billingFrm).change(function(){
		if($(this).is(':checked') && typeof data.personal_info !== 'undefined'){
			$.each(data.personal_info, function(name, value){
				//if(name == 'state') name = 'billing_state';
				if(name == 'country') name = 'billing_country';
				var item = $('[name="'+name+'"]', billingFrm);
				item.val(value);
				if(item.is('select')){
					item.dropkick('setValue', value);
				}
			});
		}
	});
	
	var paymentTypeRadio = $('.order-payment-type', register).closest('.styledRadio');
	paymentTypeRadio.click(function(){
		if($(this).data("disabled")) return false;
		paymentTypeRadio.data("disabled", true);
		var type = $(this).closest('.order-box').find('.order-payment-type').filter(':checked').val();
		$.post(window.location.href, {action: 'set_payment_type',payment_type: type}, function(respons){
			data = respons.data;
			updateOrderInfo();
			paymentTypeRadio.data("disabled", false);
			if(respons.hasError){
				showMessageWindow(respons.status);
			}
		}, 'json');
	});
	
	$('.button-link.text-button', billingFrm).click(function(){
		var link = $(this);
		if(link.data("disabled")) return false;
		var code = $('[name="coupon_code"]', billingFrm).val();
		link.closest('.row').find('p').remove();
		if(!code){
			showMessageWindow('Coupon Code is missing.');
		}else{
			link.data("disabled", true);
			$.post(window.location.href, {action: 'set_coupon', coupon_code: code}, function(respons){
				data = respons.data;
				updateOrderInfo();
				link.data("disabled", false);
				if(respons.status){
					link.after('<p>' + respons.status + '</p>');
				}
			}, 'json');
		}
	});
	
	$('.purchase', register).click(function(){
		if($(this).data("disabled")) return false;
		var prefix = "";
		switch(data.order.tier){
	  	case '1':
	  		prefix = 'basic_';
	    	break;
	    case '2':
	    	prefix = 'active_';
	      break;
	    case '3':
	    	prefix = 'pro_';
	      break;
		}
		try{
			__adroll.record_user({"adroll_segments": prefix + "conversion"});    
		}catch(err){}
		if(setIndex(count)){
			btn = $(this);
			btn.data("disabled", true);
			setData({action: 'register'}, function(){
				try{
					fbq('track', 'Purchase', {value: parseFloat(data.order.total).toFixed(2), currency: 'USD'});
				}catch(err){}
				move();
				register.addClass('purchase');
				data = {};
			});
		}
	});
	
});