function BatchApi(){}
BatchApi.prototype = {
	queries: [],
	interval: null,
	push: function(query){
		this.queries.push(query);
		cmdStockBatchApiReady();
		return this.queries.length -1;
	},
	execute: function(index){
		index = index || null;
		var This = this, execute = function(){
			This.execute();
		};

		if(This.interval && index == null) setTimeout(execute, This.interval);
		if(!This.queries.length) return;

		var data = {batch: []}, query, queries = This.queries, redraw = false, indexs = [];
		if (index != null){
			queries = [This.queries[index]];
			redraw = true
		}
		for(var i = 0, l = queries.length; i < l; i++){
			query = {url: queries[i].url, data: null};
			if(queries[i].data){
				query.data = typeof(queries[i].data) == 'function' ? queries[i].data(redraw) : queries[i].data;
			}
			if(!query.data) continue;
			var add = true;
			$.each(data.batch,function(j, value){
				if (JSON.stringify(value) == JSON.stringify(query)){
					add = false;
					indexs[j].push(i);
					return false;
				}
			});
			if(add){
				data.batch.push(query);
				indexs.push([i]);
			}
		}

		$.get('/ajax/get/batch/', data, function(response){
			for(var i = 0, l = indexs.length; i < l; i++){
				response[i] = $.parseJSON(response[i]);
				if(response[i]){
					$.each(indexs[i], function(j,value){
						queries[value].callback(response[i]);
					});
				}
			}
		}, 'json');

	}//execute
}//BatchApi

function addToDashboard(ticker){
	if(notLoginRedirect()) return false;
  $.post('/dashboard/', {action: "add_stock", id: ticker}, function(data){
  	if(data.hasError){
  		showErrorMessage(data.data);
  	}else{
  		showMessage('Stock successfully added.');
  	}
	}, 'json');
}//addToDashboard

function makePrediction(ticker){
  openPredictionWindow({ticker: ticker, source: 2}, function(id){
  	hidePopup();
  	showMessage('Thank you for your prediction.');
  });
}

$(function(){
	var container = $("#dashboard_stock_details_wordcloud");
	$.get('/ajax/get/word-cloud-data/?ticker='+container.attr('data-ticker'), function(data){
		if(data) tagCloud(container, data);
	}, 'json');
});

$(function(){
	var container = $('#stock-price'), interval = 60000;
	if(!container.length) return;

	function update(){
		timeout();
		setStockPrice();
		setStockFundamentals();
	}
	
	function setStockPrice(){
		$.get('/ajax/get/real-quote/?ticker='+container.attr('data-ticker'), function(response){
			if(!response) return;
			var content = '';
			content += response.Last.toFixed(container.attr('data-decimals')) + '&nbsp;';
			if(typeof response.Change != 'undefined'){
				content += '<span class="' + (response.PercentChange < 0 ? 'red' : response.PercentChange > 0 ? 'green' : '') + '">';
				if(response.PercentChange < 0) content += '&#8595;';
        else if(response.PercentChange > 0) content += '&#8593;';
				content += response.Change.toFixed(2);
				if(typeof response.PercentChange != 'undefined') content += ' (' + response.PercentChange.toFixed(2) + '%)';
				content += '</span>&nbsp;';
			}
			content += response.Time
			container.html(content);

		}, 'json');
	}
	
	function setStockFundamentals(){
		$.get('/ajax/get/stock-fundamentals/?ticker='+container.attr('data-ticker'), function(response){
			if(!response) return;
			var content = '';
			content += '<tr><td class="dt">Prev Close:</td><td class="dd">'+response.PreviousClose+'</td></tr>';
			content += '<tr><td class="dt">Open:</td><td class="dd">'+response.Open+'</td></tr>';
			content += '<tr><td class="dt">1y Target Est:</td><td class="dd">n/a</td></tr>';
			content += '<tr><td class="dt">Beta:</td><td class="dd">'+response.Beta+'</td></tr>';
			content += '<tr><td class="dt">Next Earnings Date:</td><td class="dd">n/a</td></tr>';
			content += '<tr><td class="dt">Day’s Range:</td><td class="dd">'+response.Low+'-'+response.High+'</td></tr>';
			content += '<tr><td class="dt">52wk Range:</td><td class="dd">'+response.OneYearLow+'-'+response.OneYearHigh+'</td></tr>';
			content += '<tr><td class="dt">Volume:</td><td class="dd">'+response.Volume+'</td></tr>';
			content += '<tr><td class="dt">Avg Vol (3m):</td><td class="dd">n/a</td></tr>';
			content += '<tr><td class="dt">Market Cap:</td><td class="dd">'+(response.MarketCap ? response.MarketCap : '')+'</td></tr>';
			content += '<tr><td class="dt">P/E (ttm):</td><td class="dd">'+response.PERatio+'</td></tr>';
			content += '<tr><td class="dt">EPS (ttm):</td><td class="dd">'+response.LatestFiscalEPS+'</td></tr>';
			content += '<tr><td class="dt">Ex Dividend Date:</td><td class="dd">'+response.LastDividendExDate+'</td></tr>';
			content += '<tr><td class="dt">Dividend Per Share:</td><td class="dd">'+response.LatestFiscalDividendsPerShare+'</td></tr>';
			content += '<tr><td class="dt">Div&amp;Yield:</td><td class="dd">'+response.LastDividendYield+'</td></tr>';
			$('#stock-fundamentals').html(content);
		}, 'json');
	}
	
	function timeout(){
		setTimeout(update, interval);
	}

  update();
});

var chartsByPosition = [];

var cmdStockBatchApi = new BatchApi();
cmdStockBatchApi.interval = 60000; //1minute
//cmdStockBatchApi.interval = 3600000; //1 hour

var cmdStockBatchApiCounter = 0;
function cmdStockBatchApiReady(){
	cmdStockBatchApiCounter++;
	if(cmdStockBatchApiCounter == 18)
	cmdStockBatchApi.execute();
}//cmdStockBatchApiReady

function getStockTicker(){
	return $('#chartSet').attr('data-ticker');
}//getStockTicker

function chartWrapper(container){
	this.container = $(container);
}//chartWrapper
chartWrapper.prototype = {
	container: null,
	chart: null,
	limit: null,
	interval: ' ',
	index: null,
	draw: function(options){
		Highcharts.setOptions({global: {useUTC: false}});
	  this.chart = new Highcharts.Chart($.extend(true, getDefaultChartOptions(), options || {}, {
	  	chart: {
	  		renderTo: this.container.get(0),
	  		events: {
	  			selection: function(event){
	  				var chart = this;
	  				var id = $(chart.container).parent().attr('id').replace(/[^\d]+/g, '');
    				$.each(['top','bottom'], function(){
    					if(event.xAxis) chartZoom(chartsByPosition[id+'.'+this].chart, event.xAxis[0].min, event.xAxis[0].max);
      				else{
      					event.preventDefault();
      					chartResetZoom(chartsByPosition[id+'.'+this].chart);
      				}
    				});
    			}
	  		}
	  	}
	  }));
	  showChartLegend(this.chart);
	},//draw
	setData: function(data, index){
		setChartData(this.chart, data, index);
		this.cut(this.limit);
	},
	removeData: function(){
		removeChartData(this.chart);
	},
	cut: function(minutes){
		this.limit = minutes;
		cutChart(this.chart, this.limit);
	},
	cutByOptions: function(){
	  var This = this;
	  var set = This.container.attr('id').replace('chartSet', '').replace('Bottom', '.top').replace('Top', '.bottom')+'';
	  var options = This.container.parent().find('.options a');
    This.limit = parseInt(options.filter('.active').attr('total'), 10);
    options.click(function(){
      var a = $(this);
      var time = parseInt(a.attr('total'), 10);
      This.cut(time);
      options.removeClass('active');
      a.addClass('active');
      var setChart = (set in chartsByPosition) ? chartsByPosition[set] : null;
      var setOptions = (setChart)  ? setChart.container.parent().find('.options a') : null ;
      if (setOptions){
        setChart.cut(time);
        var setA = setOptions.filter('a[total='+time+']');
        setOptions.removeClass('active');
        setA.addClass('active');
      }
    });
 },
 changeInterval: function(){
 	var This = this;
 	var set = This.container.attr('id').replace('chartSet', '').replace('Bottom', '.top').replace('Top', '.bottom')+'';
  var options = This.container.parent().find('.options a');
  This.interval = options.filter('.active').attr('data-interval');
  options.click(function(){
    This.interval = $(this).attr('data-interval');
    This.removeData();
    cmdStockBatchApi.execute(This.index);
    options.removeClass('active');
    $(this).addClass('active');
    var setChart = (set in chartsByPosition) ? chartsByPosition[set] : null;
    var setOptions = (setChart)  ? setChart.container.parent().find('.options a') : null ;
    if (setOptions){
    	setChart.interval = This.interval;
      setChart.removeData();
      cmdStockBatchApi.execute(setChart.index);
      var setA = setOptions.filter("a[data-interval='"+This.interval+"']");
      setOptions.removeClass('active');
      setA.addClass('active');
    }
  });

 }
};

var cmdStockBatchCallbacks = [];
/*
 * Chart Set 1.top
 */
$(function(){

	var container = $('#chartSet1Top');
	if(!container.length) return;

	var ch, options;

	cmdStockBatchCallbacks['1.top'] = function(response){
		var index = 0;
		$.each(response, function(i, value){
			ch.setData(value,index);
			++index;
		});
	}
  ch = new chartWrapper(container);
  chartsByPosition['1.top'] = ch;
  ch.interval = "1 HOUR";
  ch.draw({
  	chart: {
  		marginLeft: 55,
  		marginRight: 5,
  		marginTop: 25,
			events: {
				load: cmdStockBatchApiReady
			}
		},
		title: {
		  text: 'SENTIMENT',
      align: 'left',
      x: 12,
      y: 0,
      style: {color: '#767575', fontSize: '8px', fontFamily: '"FranklinGothicITCbyBT-Bk"'}
		},
		plotOptions: {
    	series: {
    		marker: {
	      	enabled: true
	      }
    	}
    },
   	legend: {
			enabled: true,
			margin: 6,
			y: 1,
			padding: 6,
			borderRadius: 8,
			width: 220,
			itemWidth: 110,
			itemStyle: {
				fontSize: '8px',
				textTransform: 'uppercase'
			}
		},
		navigation: {
      buttonOptions: {
      	y: 5
      }
    },
		series: [{
      name: 'Crowd Sentiment',
      data: [],
      color: '#1A5488'
    },{
      name: 'MP Sentiment',
      data: [],
      color: '#AF4742'
    },{
      name: 'Crowd Moving Avg',
      data: [],
      color: '#88a644'
    },{
      name: 'MP Moving Avg',
      data: [],
      color: '#44a0a6'
    }]
  });
  ch.cutByOptions();

});
$(function(){

	var container = $('#chartSet1Top');
	if(!container.length) return;

	var first = true;
	var ch = chartsByPosition['1.top'];

	ch.index = cmdStockBatchApi.push({
		url: '/ajax/chart/?data[]=sentiment&data[]=mp-sentiment&data[]=moving-average-sentiment&data[]=mp-moving-average-sentiment&ticker='+getStockTicker(),
		data: function(redraw){
			var interval = (first || redraw) ? ch.interval : "1 MINUTE";
			if(first) first = false;
			return {interval: interval};
		},
		callback: function(response){
			cmdStockBatchCallbacks['1.top'](response);
		}
	});

});

/*
 * Chart Set 2.top
 */

$(function(){

	var ch, container = $('#chartSet2Top');
	if(!container.length) return;

	cmdStockBatchCallbacks['2.top'] = function(response){
		var index = 0;
		$.each(response, function(i, value){
			ch.setData(value,index);
			++index;
		});
		//chartSetFullDayExtremes(ch.chart);
		chartSetHistoricalExtremes(ch.chart);
	}

  ch = new chartWrapper(container);
  chartsByPosition['2.top'] = ch;
  ch.draw({
  	chart: {
  		marginLeft: 55,
  		marginRight: 5,
  		marginTop: 25,
			events: {
				load: cmdStockBatchApiReady
			}
		},
		title: {
      text: 'SENTIMENT',
      align: 'left',
      x: 12,
      y: 0,
      style: {color: '#767575', fontSize: '8px', fontFamily: '"FranklinGothicITCbyBT-Bk"'}
    },
		legend: {
			enabled: true,
			margin: 6,
			y: 1,
			padding: 6,
			borderRadius: 8,
			width: 220,
			itemWidth: 110,
			itemStyle: {
				fontSize: '8px',
				textTransform: 'uppercase'
			}
		},
		navigation: {
      buttonOptions: {
      	y: 5
      }
    },
		series: [{
      name: 'Crowd Sentiment',
      data: [],
      color: '#1A5488'
    },{
      name: 'MP Sentiment',
      data: [],
      color: '#AF4742'
    },{
      name: 'Crowd Moving Avg',
      data: [],
      color: '#88a644'
    },{
      name: 'MP Moving Avg',
      data: [],
      color: '#44a0a6'
    }]
  });
  ch.changeInterval();

});
$(function(){

	var container = $('#chartSet2Top');
	if(!container.length) return;

	var first = true;
	var ch = chartsByPosition['2.top'];

	ch.index = cmdStockBatchApi.push({
		url: '/ajax/chart/?data[]=sentiment&data[]=mp-sentiment&data[]=moving-average-sentiment&data[]=mp-moving-average-sentiment&ticker='+getStockTicker(),
		data: function(redraw){
			var interval = (first || redraw) ? ch.interval : "1 MINUTE";
			var data = (interval != ch.interval && ch.interval != '1 DAY') ? null : {interval: interval};
			if(first) first = false;
			return data;
		},
		callback: function(response){
			cmdStockBatchCallbacks['2.top'](response);
		}
	});

});



/*
 * Chart Set 3.top
 */
$(function(){

	var ch, options, container = $('#chartSet3Top');
	if(container.length){

		cmdStockBatchCallbacks['3.top'] = function(response){
			var index = 0;
			$.each(response, function(i, value){
				ch.setData(value,index);
				++index;
			});
		}

	  ch = new chartWrapper(container);
	  chartsByPosition['3.top'] = ch;
		ch.interval = "1 HOUR";
	  ch.draw({
	  	chart: {
	  		marginLeft: 55,
  			marginRight: 5,
  			marginTop: 25,
				events: {
					load: cmdStockBatchApiReady
				}
			},
			title: {
        text: 'SENTIMENT Z-SCORE',
        align: 'left',
        x: 12,
        y: 0,
        style: {color: '#767575', fontSize: '8px', fontFamily: '"FranklinGothicITCbyBT-Bk"'}
      },
			plotOptions: {
	    	series: {
	    		marker: {
		      	enabled: true
		      }
	    	}
			},
			legend: {
				enabled: true,
				margin: 6,
				y: 1,
				padding: 6,
				borderRadius: 8,
				width: 220,
				itemWidth: 110,
				itemStyle: {
					fontSize: '8px',
					textTransform: 'uppercase'
				}
			},
			navigation: {
	      buttonOptions: {
	      	y: 5
	      }
	    },
			series: [{
	      name: 'Crowd Z-Score',
	      data: [],
	      color: '#1A5488'
	    },{
	      name: 'MP Z-Score',
	      data: [],
	      color: '#AF4742'
	    },{
	      name: 'Crowd Moving Avg',
	      data: [],
	      color: '#88a644'
	    },{
	      name: 'MP Moving Avg',
	      data: [],
	      color: '#44a0a6'
	    }]
	  });
	  ch.cutByOptions();
	}

});
$(function(){

	var container = $('#chartSet3Top');
	if(!container.length) return;

	var first = true;
	var ch = chartsByPosition['3.top'];

	ch.index = cmdStockBatchApi.push({
		url: '/ajax/chart/?data[]=zscore&data[]=mp-zscore&data[]=moving-average-zscore&data[]=mp-moving-average-zscore&ticker='+getStockTicker(),
		data: function(redraw){
			var interval = (first || redraw) ? ch.interval : "1 MINUTE";
			if(first) first = false;
			return {interval: interval};
		},
		callback: function(response){
			cmdStockBatchCallbacks['3.top'](response);
		}
	});

});

/*
 * Chart Set 4.top
 */
$(function(){

	var ch, container = $('#chartSet4Top');
	if(container.length){

		cmdStockBatchCallbacks['4.top'] = function(response){
			var index = 0;
			$.each(response, function(i, value){
				ch.setData(value,index);
				++index;
			});
			//chartSetFullDayExtremes(ch.chart);
			chartSetHistoricalExtremes(ch.chart);
		}

	  ch = new chartWrapper(container);
	  chartsByPosition['4.top'] = ch;
	  ch.draw({
	  	chart: {
	  		marginLeft: 55,
  			marginRight: 5,
  			marginTop: 25,
				events: {
					load: cmdStockBatchApiReady
				}
			},
			title: {
        text: 'SENTIMENT Z-SCORE',
        align: 'left',
        x: 12,
        y: 0,
        style: {color: '#767575', fontSize: '8px', fontFamily: '"FranklinGothicITCbyBT-Bk"'}
      },
			legend: {
				enabled: true,
				margin: 6,
				y: 1,
				padding: 6,
				borderRadius: 8,
				width: 220,
				itemWidth: 110,
				itemStyle: {
					fontSize: '8px',
					textTransform: 'uppercase'
				}
			},
			navigation: {
	      buttonOptions: {
	      	y: 5
	      }
	    },
			series: [{
	      name: 'Crowd Z-Score',
	      data: [],
	      color: '#1A5488'
	    },{
	      name: 'MP Z-Score',
	      data: [],
	      color: '#AF4742'
	    },{
	      name: 'Crowd Moving Avg',
	      data: [],
	      color: '#88a644'
	    },{
	      name: 'MP Moving Avg',
	      data: [],
	      color: '#44a0a6'
	    }]
	  });
	  ch.changeInterval();
	}

});
$(function(){

	var container = $('#chartSet4Top');
	if(!container.length) return;

	var first = true;
	var ch = chartsByPosition['4.top'];

	ch.index = cmdStockBatchApi.push({
		url: '/ajax/chart/?data[]=zscore&data[]=mp-zscore&data[]=moving-average-zscore&data[]=mp-moving-average-zscore&ticker='+getStockTicker(),
		data: function(redraw){
			var interval = (first || redraw) ? ch.interval : "1 MINUTE";
			var data = (interval != ch.interval && ch.interval != '1 DAY') ? null : {interval: interval};
			if(first) first = false;
			return data;
		},
		callback: function(response){
			cmdStockBatchCallbacks['4.top'](response);
		}
	});

});

/*
 * Chart Set 5.top
 */
$(function(){

	var ch, options, container = $('#chartSet5Top');
	if(container.length){

		cmdStockBatchCallbacks['5.top'] = function(response){
			ch.setData(response.buzz);
			ch.setData(response.tweetvolume, 1);
		}
	  ch = new chartWrapper(container);
	  chartsByPosition['5.top'] = ch;
		ch.interval = "1 HOUR";
	  ch.draw({
	  	chart: {
	  		marginLeft: 55,
	  		marginRight: 5,
	  		marginTop: 25,
				events: {
					load: cmdStockBatchApiReady
				}
			},
			title: {
        text: 'BUZZ',
        align: 'left',
        x: 12,
        y: 0,
        style: {color: '#767575', fontSize: '8px', fontFamily: '"FranklinGothicITCbyBT-Bk"'}
      },
      yAxis: {
	    	labels: {
          formatter: function(){
            return this.value.toFixed(1);
          }
        }
	    },
			plotOptions: {
	    	series: {
	    		marker: {
		      	enabled: true
		      }
	    	}
	    },
			legend: {
				enabled: true,
				margin: 6,
				y: 1,
				padding: 6,
				borderRadius: 8,
				itemStyle: {
					fontSize: '8px',
					textTransform: 'uppercase'
				}
			},
			navigation: {
	      buttonOptions: {
	      	y: 5
	      }
	    },
			series: [{
        name: 'BUZZ',
        data: [],
        color: '#1A5488'
      },{
        name: 'Tweet Volume',
        data: [],
        color: '#AF4742'
      }]
	  });
	  ch.cutByOptions();
	}

});
$(function(){

	var container = $('#chartSet5Top');
	if(!container.length) return;

	var first = true;
	var ch = chartsByPosition['5.top'];

	ch.index = cmdStockBatchApi.push({
		url: '/ajax/chart/?data[]=buzz&data[]=tweetvolume&ticker='+getStockTicker(),
		data: function(redraw){
			var interval = (first || redraw) ? ch.interval : "1 MINUTE";
			if(first) first = false;
			return {interval: interval};
		},
		callback: function(response){
			cmdStockBatchCallbacks['5.top'](response);
		}
	});

});

/*
 * Chart Set 6.top
 */
$(function(){

	var ch, container = $('#chartSet6Top');
	if(container.length){

		cmdStockBatchCallbacks['6.top'] = function(response){
			ch.setData(response.buzz);
			ch.setData(response.tweetvolume, 1);
			//chartSetFullDayExtremes(ch.chart);
			chartSetHistoricalExtremes(ch.chart);
		}

	  ch = new chartWrapper(container);
	  chartsByPosition['6.top'] = ch;
	  ch.draw({
	  	chart: {
	  		marginLeft: 55,
	  		marginRight: 5,
	  		marginTop: 25,
				events: {
					load: cmdStockBatchApiReady
				}
			},
			title: {
        text: 'BUZZ',
        align: 'left',
        x: 12,
        y: 0,
        style: {color: '#767575', fontSize: '8px', fontFamily: '"FranklinGothicITCbyBT-Bk"'}
      },
      yAxis: {
	    	labels: {
          formatter: function(){
            return this.value.toFixed(1);
          }
        }
	    },
			legend: {
				enabled: true,
				margin: 6,
				y: 1,
				padding: 6,
				borderRadius: 8,
				itemStyle: {
					fontSize: '8px',
					textTransform: 'uppercase'
				}
			},
			navigation: {
	      buttonOptions: {
	      	y: 5
	      }
	    },
			series: [{
        name: 'BUZZ',
        data: [],
        color: '#1A5488'
      },{
        name: 'Tweet Volume',
        data: [],
        color: '#AF4742'
      }]
	  });
	  ch.changeInterval();
	}

});
$(function(){

	var container = $('#chartSet6Top');
	if(!container.length) return;

	var first = true;
	var ch = chartsByPosition['6.top'];

	ch.index = cmdStockBatchApi.push({
		url: '/ajax/chart/?data[]=buzz&data[]=tweetvolume&ticker='+getStockTicker(),
		data: function(redraw){
			var interval = (first || redraw) ? ch.interval : "1 MINUTE";
			var data = (interval != ch.interval && ch.interval != '1 DAY') ? null : {interval: interval};
			if(first) first = false;
			return data;
		},
		callback: function(response){
			cmdStockBatchCallbacks['6.top'](response);
		}
	});

});

/*
 * Price Charts
*/

/*
 * Chart Set 1.bottom
 * Chart Set 3.bottom
 * Chart Set 5.bottom
 */
$(function(){

	var containers = $('#chartSet1Bottom,#chartSet3Bottom,#chartSet5Bottom');
	if(!containers.length) return;

	function createChart(container, onload){
		var ch, options;
		var decimals = $('#stock-price').attr('data-decimals');
		container = $(container);
		if(container.length){
		  ch = new chartWrapper(container);
		  chartsByPosition[container.attr('id').replace('chartSet', '').replace('Bottom', '.bottom')] = ch;
		  ch.draw({
		  	chart: {
		  		marginLeft: 55,
	  			marginRight: 5,
	  			marginTop: 25,
					events: {
						load: onload
					}
				},
				title: {
          text: 'PRICE',
          align: 'left',
          x: 12,
          y: 0,
          style: {color: '#767575', fontSize: '8px', fontFamily: '"FranklinGothicITCbyBT-Bk"'}
        },
				plotOptions: {
		    	series: {
		    		marker: {
			      	enabled: true
			      }
		    	}
		    },
		    navigation: {
		      buttonOptions: {
		      	y: 5
		      }
		    },
		    yAxis: {
		    	labels: {
	          formatter: function(){
	            return this.value.toFixed(decimals);
	          }
	        }
		    },
				tooltip: {
		    	valueDecimals: decimals
		    }
		  });

		}
		ch.cutByOptions();
		return ch;
	}//createChart

	cmdStockBatchCallbacks['odd.bottom'] = function(response){
		$.each(charts, function(){
			this.setData(response);
		});
	}

	var charts = [], counter = 0;

	containers.each(function(){

		charts.push(createChart(this, function(){
			if(++counter == containers.length) cmdStockBatchApiReady();
		}));

	});

});
$(function(){

	var containers = $('#chartSet1Bottom,#chartSet3Bottom,#chartSet5Bottom');
	if(!containers.length) return;

	var first = true;
	var lastPrice = null;

	cmdStockBatchApi.push({
		url: '/ajax/chart/?data[]=price&ticker='+getStockTicker(),
		data: function(redraw){
			var data = {};
			if(lastPrice !== null) data.last_price = lastPrice;
			data.interval = (first || redraw) ? "1 HOUR" : "1 MINUTE";
			if(first) first = false;
			return data;
		},
		callback: function(response){
			var lastDate = 0;
	    lastPrice = null;
	  	if (response.price.timeframe[1]){
	  		lastDate = mysqlstrtotime(response.price.timeframe[1]).getTime() - 1200000;
	  	}
      $.each(response.price.records, function(){
      	if (mysqlstrtotime(this[0]).getTime() <= lastDate){
        	lastPrice = this[1];
      	}
      });
			cmdStockBatchCallbacks['odd.bottom'](response.price);
		}
	});

});
/*
 * Chart Set 2.bottom
 * Chart Set 4.bottom
 * Chart Set 6.bottom
 */
$(function(){

	var containers = $('#chartSet2Bottom,#chartSet4Bottom,#chartSet6Bottom');
	if(!containers.length) return;

	function createChart(container, onload){
		var ch, container = $(container);
		var decimals = $('#stock-price').attr('data-decimals');
		if(container.length){

		  ch = new chartWrapper(container);
		  chartsByPosition[container.attr('id').replace('chartSet', '').replace('Bottom', '.bottom')] = ch;
		  ch.draw({
		  	chart: {
		  		marginLeft: 55,
	  			marginRight: 5,
	  			marginTop: 25,
					events: {
						load: onload
					}
				},
				title: {
          text: 'PRICE',
          align: 'left',
          x: 12,
          y: 0,
          style: {color: '#767575', fontSize: '8px', fontFamily: '"FranklinGothicITCbyBT-Bk"'}
        },
        navigation: {
		      buttonOptions: {
		      	y: 5
		      }
		    },
		    yAxis: {
		    	labels: {
	          formatter: function(){
	            return this.value.toFixed(decimals);
	          }
	        }
		    },
				tooltip: {
					valueDecimals: decimals
				}
		  });

		}
		ch.changeInterval();
		return ch;
	}//createChart
	/*
	cmdStockBatchCallbacks['even.bottom'] = function(response){
		$.each(charts, function(){
			this.setData(response);
			//chartSetFullDayExtremes(this.chart);
			chartSetHistoricalExtremes(this.chart);
		});
	}
	var charts = [], counter = 0;

	containers.each(function(){

		charts.push(createChart(this, function(){
			if(++counter == containers.length) cmdStockBatchApiReady();
		}));

	});
 	*/
 	var charts = [], counter = 0;

	containers.each(function(){
		var chart = createChart(this, function(){
			if(++counter == containers.length) cmdStockBatchApiReady();
		});
		cmdStockBatchCallbacks[$(this).attr('id').replace('chartSet', '').replace('Bottom', '.bottom')] = function(response){
			chart.setData(response);
			chartSetHistoricalExtremes(chart.chart);
		}
		charts.push(chart);
	});

});
$(function(){

	var containers = $('#chartSet2Bottom,#chartSet4Bottom,#chartSet6Bottom');
	if(!containers.length) return;
	containers.each(function(){
		var first = true;
		var lastPrice = null;
		var set = $(this).attr('id').replace('chartSet', '').replace('Bottom', '.bottom');
		var ch = chartsByPosition[set];
		ch.index = cmdStockBatchApi.push({
			url: '/ajax/chart/?data[]=price&ticker='+getStockTicker(),
			data: function(redraw){
				var data = {};
				if(lastPrice !== null) data.last_price = lastPrice;
				data.interval = (first || redraw) ? ch.interval : "1 MINUTE";
				if(data.interval != ch.interval && ch.interval != '1 DAY') data = null;
				if(first) first = false;
				return data;
			},
			callback: function(response){
				var lastDate = 0;
		    lastPrice = null;
		  	if (response.price.timeframe[1]){
		  		lastDate = mysqlstrtotime(response.price.timeframe[1]).getTime() - 1200000;
		  	}
        $.each(response.price.records, function(){
        	if (mysqlstrtotime(this[0]).getTime() <= lastDate){
          	lastPrice = this[1];
        	}
        });
				cmdStockBatchCallbacks[set](response.price);
			}
		});
	});
});
/*
 * END Price Charts
*/
$(function(){

	function collapseBox(link, event){
		event.preventDefault();
		var collapsed = link.data('collapsed');
		link.data('collapsed', !collapsed);
		if(!collapsed){
		  link.next().slideUp('default', function(){
        link.addClass('close');
      });
		}else{
			link.removeClass('close');
		  link.next().slideDown('default');
		}
	}

	$('.stockdetails .control').click(function(event){
		event.preventDefault();
		var links = $(this).parent().find('.cut'), collapsed = links.eq(0).data('collapsed');
		links.each(function(){
			var link = $(this);
			if(link.data('collapsed') == collapsed) collapseBox(link, event);
		});
	});
	$('.stockdetails .cut-close').click(function(event){
		event.preventDefault();
		var link = $(this).closest('.cut'), collapsed = link.data('collapsed');
		if(link.data('collapsed') == collapsed) collapseBox(link, event);
	});

});


/*
 * Print and Export Charts
 */
$(function(){

 $('ul.social a.export').click(function(){
   var interval = 2000;
   var close = true;
   var myTimer;
   var type = {'JPEG image':'image/jpeg','PNG image':'image/png','PDF document':'application/pdf', 'SVG vector image':'image/svg+xml'};
   var wrapper = $(this).parent();
   var html = '<div class="export-type">';
   $.each( type, function( key, value ) {
    html += '<a href="javascript:void(0);" data-export-type="'+value+'">Download '+key+'</a>';
   });
   html += '</div>';
   wrapper.append(html)
   var remove = function(event){
      if (close) $('div.export-type', wrapper).fadeOut().remove();
   }
   $('div.export-type', wrapper).fadeIn(400, function(){
    myTimer = setTimeout(remove, interval);
    $(this).hover(
      function(){
        close = false;
      },
      function(){
        clearTimeout(myTimer);
        close = true;
        myTimer = setTimeout(remove, interval);
       }
    );
    $('.export-type a', wrapper).click(function(){
      var set = $(this).closest('ul').attr('data-chart-set');
      var charts = [];
      var options = {
      	type: $(this).attr('data-export-type'),
      	url: '/highcharts-server/'
      };
      if (set+'.top' in chartsByPosition) charts.push(chartsByPosition[set+'.top']);
      if (set+'.bottom' in chartsByPosition) charts.push(chartsByPosition[set+'.bottom']);
      if (charts.length > 0) exportCharts(charts, options);
      close = true;
      remove();
    });
   });
 });

  $('ul.social a.print').click(function(){
    var set = $(this).closest('ul').attr('data-chart-set');
    var charts = [];
    if (set+'.top' in chartsByPosition) charts.push(chartsByPosition[set+'.top']);
    if (set+'.bottom' in chartsByPosition) charts.push(chartsByPosition[set+'.bottom']);
    if (charts.length > 0) printCharts(charts);
  });
});
