var updateFunctions = [];
var isLoggedIn = false;

function notLoginRedirect(){
	if(!isLoggedIn){
		window.location.href = '/register/';
		return true;
	}
	return false;
}

$(function(){
	
	isLoggedIn = $('#header .nav .logged').length > 0;
	
	var wrap = $('#header .dash ul .displaying');
	if(wrap.length) (function(){
		
		function update(value){
			$('[data-view-mode]').attr('data-view-mode', value);
			VIEW_MODE = value;
			$.each(updateFunctions, function(i, item){
				item();
			})
		}
		
		function off(){
			wrap.removeClass('on');
			setCookieCustom('view_mode', '', 365, '/');
			update('');
			return false;
		}
		
		function on(){
			wrap.addClass('on');
			setCookieCustom('view_mode', 'MP', 365, '/');
			update('MP');
			return false;
		}
		
		wrap.find('a:eq(0)').click(off);
		wrap.find('a:eq(1)').click(on);
		wrap.find('.button').click(function(){
			if(wrap.is('.on')) off();
			else on();
		});
		
	})();
	
});
$(function(){
  
  $('.learn-more').click(function(){
    $(this).toggleClass('active');
    $('.drop').slideToggle('slow');
  });
  
  $('.nav li.expanded').hover(
  	function(){
  		var item = $(this);
  		var timer = setTimeout(function(){
  			var openSubnav = item.data('openSubnav');
  			if(!openSubnav){
  				item.find('.subnav').slideDown();
  				item.data('openSubnav', true);
  			}
  		},500);
  		item.data('timer', timer);
  	},
  	function(){
  		var openSubnav = $(this).data('openSubnav');
  		$(this).find('.subnav').slideUp();
  		$(this).data('openSubnav', false);
  		var openSubnavTimer = $(this).data('timer');
  		if (openSubnavTimer) clearTimeout(openSubnavTimer);
  	}
  );
  
  $('.dash li:not(.last)').hover(
   	function(){
			$(this).find('em').show();
		},
		function(){
			$(this).find('em').hide();
  });
  $('.dash li.last a').hover(
   	function(){
   		var wrap = $(this).closest('li');
   		if ($(this).hasClass('left')){
   			wrap.find('em.left').show();
   		}else{
				wrap.find('em.right').show();
			}
		},
		function(){
			var wrap = $(this).closest('li');
   		if ($(this).hasClass('left')){
   			wrap.find('em.left').hide();
   		}else{
				wrap.find('em.right').hide();
			}
  });
  
  $('.scrolling').jScrollPane();
  //$(".custom").selectbox();
  makeCustomSelect(".custom");
});

$(document).ready(function(){
  $('#header .dash').animate({
    top: '0',
    }, 1000, function() {
  });
  $('.graphs-switch .box').css('display','none');

  var imgWarning = $('.warning img');
  if (imgWarning.length > 0){
  	$.each(imgWarning, function(){
  		warning($(this));
  	});
  }
  function warning(item){
		item.animate({
	    	opacity: 0
	    }, 400, function(){
	    	item.animate({opacity: 1}, 400, function(){warning(item);});
			}
	  );
	}
});

$(function(){
	var wrap = $('#header .index'),
			interval = 60000;
	function update(){
		timeout();
		$.get('/api/get_quotes/',{action: 'get_html'}, function(data){
			if(!data.html) return;
			$('.common', wrap).remove();
			wrap.append(data.html);
		}, 'json');
	}
	function timeout(){
		setTimeout(update, interval);
	}
  timeout();
});

// Open Pop Up
var popupCloseWindow = false;

function openPopup(content, hideClose, className, callback){
	var duration = 700;
	var popup = $('<div class="simplePopup"><div class="simplePopupOverlay"></div><div class="simplePopupMain"><div class="simplePopupContent"><div class="simplePopupContentInner"></div></div></div></div>');
	var main = $('.simplePopupMain', popup);
	className = className || false;
	hideClose = hideClose || false;
	
	if(className){
		main.addClass(className);
	}
	if(!hideClose){
		main.prepend('<a href="javascript:void(0);" title="close" class="simplePopupClose">close</a>');
		$('.simplePopupClose', popup).click(close);
	}
		
	$('.simplePopupOverlay', popup).click(function(event) {
    if(!$(event.target).closest('.simplePopupMain').length) close();
  });
  
  function close(){
  	$(window).unbind('resize', popup.data('update'));
		popup.fadeOut(duration, function(){
			popup.remove();
			if(typeof callback === 'function'){
	    	callback();
	    }
		});
  }
  popup.data('close', close);
	
	var contentWrapper = $('.simplePopupContent', popup), contentInner = $('.simplePopupContentInner', popup);
	contentInner.append(content);
	
	popup.data('update', function(){
		var speed = 'fast';
		var c = $('.simplePopupMain', popup);
		var h = contentInner.innerHeight();
		contentWrapper.stop(true, false).animate({height: h}, speed);
		h = c.height() + h - contentWrapper.innerHeight();
		c.stop(true, false).animate({
			left: (Math.max(0, $(window).width() - c.width()) / 2),
			top: Math.max(0, ($(window).height() - h) / 2 - 30) + $(window).scrollTop()
		}, speed);
	});
	
	popup.data('prepare', function(){
		$('.scrolling', popup).jScrollPane();
    makeCustomSelect($(".custom", popup));
    $('input:checkbox:not(.dismiss), input:radio:not(.dismiss)', popup).screwDefaultButtons({
      image:  "url(/img/main/іco-checkbox.png)",
      width:    22,
      height:   19,
      selectAll:  "#selectAll"
    });
    $('.prediction input:radio.dismiss', popup).screwDefaultButtons({
      image:  "url(/img/main/ico-prediction-up.png)",
      width:    11,
      height:   11,
      selectAll:  "#selectAll"
    });
    makeRedCheckbox($('.power-check', popup));
    usersAlertPowerChange($('.alerts-power > span', popup));
    usersAlertFilterChange($('.alerts-filter.filter-popup .bg:not(.filter-selector) select', popup));
	});
	
	$(window).bind('resize', popup.data('update'));
	popup.hide().appendTo('body').fadeIn(duration);
	popup.data('prepare')();
	popup.data('update')();
	return popup;
}//simplePopup

function hidePopup(reload){
	reload = reload || false;
	$('.simplePopup .simplePopupOverlay').click();
	if(popupCloseWindow) window.close();
  if(reload) location.reload();
}

// End Open Pop Up

function openAjaxWindow(url, params) {
  var url = url || window.location.pathname;
  var params = params || '';
  $.ajax({
    type: "GET",
    data: params,
    url: url,
    success: function(data) {
      openPopup(data, false);
    }
  }); 
}

function showMessage(content, callback, button){
  var title = '';
	var message = '';
	button = button || 'OK';
	if(typeof content == 'string'){
		message = content.replace(/\n/g, "<br />");
	}else{
		if(typeof content.message !== 'undefined') message = content.message.replace(/\n/g, "<br />");
		if(typeof content.title !== 'undefined') title = content.title;
	}
  var html = '';
  if(title){
  	html += '<h3>' + title + '</h3>';
		html += '<div class="line"></div>';
	}
	if(message){
  	html += '<p>' + message + '</p>';
 	}
  html += '<a href="javascript:void(0);" onclick="hidePopup();">' + button + '</a>';
  return showMessageCustom(html, callback);
}//showMessage

function showErrorMessage(content, callback, button){
	var title = 'Errors';
	var message = '';
	button = button || 'OK';
	if(typeof content == 'string'){
		message = content.replace(/\n/g, "<br />");
	}else{
		if(content.message.length) message = content.message.replace(/\n/g, "<br />");
		if(content.title.length) title = content.title;
	}
  var html = '<div class="warning-msg">';
  if(title){
  	html += '<h3>' + title + '</h3>';
		html += '<div class="line"></div>';
	}
	if(message){
  	html += '<p>' + message + '</p>';
 	}
  html += '</div>';
  html += '<a href="javascript:void(0);" onclick="$(this).closest(\'.simplePopup\').find(\'.simplePopupOverlay\').click();">' + button + '</a>';
  return showMessageCustom(html, callback);
}//showErrorMessage

function showMessageCustom(content, callback){
  var html = '<div class="account-msg">';
  html += content;
  html += '</div>';
  return openPopup(html, false, 'account-popup', callback);
}//showMessageCustom

function showLoading(){
	var item = openPopup('');
	$('.simplePopupContent', item).remove();
	$('.simplePopupClose', item).hide();
	$('.simplePopupMain', item).append('<div style="width: 100px;"><img width="100" src="/img/main/loading.gif" alt="Loading" title="Loading"></div>');
	item.data('update')();
	return item;
}//showLoading

function scrollTopDiv(id){
  $('html, body').animate({scrollTop:$('#'+id).offset().top - 50}, 'slow');
  return false;
}

function getUrlParts(url){
  // url contains your data.
  var qs = url.indexOf("?");
      if(qs==-1) return {};
      var fr = url.indexOf("#");
      var q="";
      q = (fr==-1)? url.substr(qs+1) : url.substr(qs+1, fr-qs-1);
  var parts=q.split("&");
  var vars={};
  for(var i=0;i<parts.length; i++){
  var p = parts[i].split("=");
          if(p[1]){
  vars[decodeURIComponent(p[0])] = decodeURIComponent(p[1]);
          }else{
              vars[decodeURIComponent(p[0])] = "";
          }
  }
  // vars contain all the variables in an array.
  return vars;
}



function openWindow(url, params){
  params = $.extend({width: 600, height: 450, personalbar: 0, toolbar: 0, scrollbars: 1, resizable: 1}, params || {})
  params.left = screen.width > params.width ? Math.round((screen.width - params.width)/2) : 0;
  params.top = screen.height > params.height ? Math.round((screen.height - params.height)/2) : 0;
  
  var specs = [];
  $.each(params, function(key){
  	specs.push(key + '=' + this);
  })
  var popup = window.open(url, '_blank', specs.join(','));
}

function escapeHtml(a){return(a||'').replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#039;");}
function mysqlstrtotime(a){var b=a.split(/[- :]/);return new Date(b[0],b[1]-1,b[2],b[3],b[4],b[5]);}
function unixtotime(a){var b=parseInt(a)*1000;return new Date(b);}
	
function loadTweets(container, order, callback){
	container = $(container);
	order = order != 'ASC' ? 'DESC' : 'ASC';
	var prevId = container.find('[tweet-id]:'+(order == 'DESC' ? 'last' : 'first')).attr('tweet-id');
	if (typeof prevId === 'undefined') order = 'DESC';
	
	if(!container.data('timeout')){
		container.data('timeout', true);
		function loadTweetsTimeout(){
			setTweetsTimeout();
			if(container.data('busy')) return;
			container.data('busy', true);
			loadTweets(container, 'ASC', function(){
				container.data('busy', false);
			});
		}
		function setTweetsTimeout(){
			setTimeout(loadTweetsTimeout, 60000);
		}
		container.data('busy', true);
		callback = function(){
			container.data('busy', false);
		};
		setTweetsTimeout();
	}
	var oldTweets = $('ul.list li', container);
	if(oldTweets.length > 0){
	  oldTweets.each(function(){
	    var link = $(this).find('a.date_link');
	    var seconds = link.attr('rel')
	    if(seconds){
	    	link.find('em.date').text(timeSince(unixtotime(seconds)));
	    }
	  });
	}
	$.get('/ajax/get/tweets/', {
		ticker: container.attr('tweets-ticker'),
		username: container.attr('tweets-username'),
		limit: container.attr('tweets-limit'),
		//mps: container.attr('tweets-mps'),
		//show_ticker: container.attr('tweets-show-ticker'),
		last_time: container.attr('tweets-last-time'),
		//prev_id: prevId,
		order: order
	}, function(data){
		container.attr('tweets-last-time', data.last_time);
		if(data.tweets.length){
			var items = $();
			
			$.each(data.tweets, function(){
				var score = (typeof this.MP_SCORE !== 'undefined') ? parseFloat(this.MP_SCORE).toFixed(3) : null;
				var tweet = $(
					'<li tweet-id="'+this.TWEET_ID+'">'
					+'<table cellpadding="0" cellspacing="0" width="100%"><tr><td valign="top" width="35">'
					+(typeof this.author_logo !== 'undefined' ? '<a href="https://twitter.com/'+escapeHtml(this.USERNAME)+'" title="'+escapeHtml(this.USERNAME)+'" target="_blank">'
					+'<img src="'+this.author_logo+'" width="32" height="32" alt="@'+escapeHtml(this.USERNAME)+'" title="@'+escapeHtml(this.USERNAME)+'" /></a>' : '')
					+'</td><td valign="top">'
					+'<a href="https://twitter.com/'+escapeHtml(this.USERNAME)+'" title="'+escapeHtml(this.USERNAME)+'" target="_blank"><h4>'+escapeHtml(this.author)+'&nbsp;</h4>&nbsp;'
					+'<span class="username">@'+escapeHtml(this.USERNAME)+'</span></a>'
					+'<a href="https://twitter.com/'+escapeHtml(this.USERNAME)+'/status/'+this.TWEET_ID+'" title="'+unixtotime(this.UTS).dateFormat("g:iA - j M y")
						+'" rel="'+this.UTS+'" target="_blank" class="date_link">'
					+'<em class="date">'+timeSince(unixtotime(this.UTS))+'</em>'
					+'</a></td>'
					+(typeof this.TICKER !== 'undefined' ? '<td rowspan="2" width="42" align="center"><a class="ticker" href="/stock/'+escapeHtml(this.TICKER)+'/" title="'+escapeHtml(this.TICKER)+'">'+escapeHtml(this.TICKER)+'</a></td>' : '')
					+'<td valign="top" rowspan="2"><div class="op"><div style="top:'+Math.round((1 - this.SENTIMENT) * 50)+'%;"></div></div></td>'
					+(score === null ? '' : '<td rowspan="2" width="42" align="center" class="'+(isNaN(score) ? 'blue' : (score < 0 ? 'red' : 'green'))+'">'+(isNaN(score) ? 'NR' : score)+'</td>')
					+'</tr><tr><td valign="top" colspan="2">'
					+'<p>'+this.TWEET+'</p>'
					+'<script type="text/javascript" src="//platform.twitter.com/widgets.js"></script>'
					+'<p><a href="https://twitter.com/intent/tweet?in_reply_to='+this.TWEET_ID+'">Reply</a>'
			    +'&nbsp;&nbsp;<a href="https://twitter.com/intent/retweet?tweet_id='+this.TWEET_ID+'">Retweet</a>'
			    +'&nbsp;&nbsp;<a href="https://twitter.com/intent/favorite?tweet_id='+this.TWEET_ID+'">Favorite</a></p>'
					+'</td></tr></table>'
					+'</li>'
				).hide();
				$('.list', container)[order == 'DESC' ? 'append' : 'prepend'](tweet);
				items = items.add(tweet);
			});
			
			var api = container.data('jsp');
			if(api){
				var counter = items.length;
				items.css('opacity', 0).slideDown('slow', function(){
					if(!--counter){
						items.animate({opacity: 1});
						api.reinitialise();
					}
				});
			}else{
				items.fadeIn();
				container.addClass('scrolling').jScrollPane({contentWidth: '0px'}).bind('jsp-scroll-y', function(event, scrollPositionY, isAtTop, isAtBottom){
					if(isAtBottom){
						if(container.data('busy')) return;
						container.data('busy', true);
						loadTweets(container, 'DESC', function(){
							container.data('busy', false);
						});
					}
				});
			}
		}
		if(callback) callback();
	}, 'json');
}//loadTweets

$(function(){
	$('[tweets-ticker]').each(function(){
		loadTweets(this);
	});
});

$(function(){
  var container;
  var wrapper = $('.stripe .line');
  if(!wrapper.length) return;
  var interval = 60000;
  var timeout = null;
  var wrapperWidth = wrapper.innerWidth();
  var containerWidth = 0;
  var containerLeft = 0;
  var prev = new Date(), pxPerSec = 100, stopped = false;
  var requestAnimationFrame = window.requestAnimationFrame || window.mozRequestAnimationFrame
    || window.webkitRequestAnimationFrame || window.msRequestAnimationFrame
    || function(callback){ setTimeout(callback, 1000 / 60);};
    
  function get(){
  	if(timeout) clearTimeout(timeout);
    timeout = setTimeout(get, interval);
    $.get('/ajax/get/top-tickers/?view_mode='+VIEW_MODE, function(records){
      if(!records.length) return false;
      wrapper.html('');
      wrapper.append('<ul class="line-data"></ul>');
      container = wrapper.find('.line-data');
      $.each(records, function(i){
        var value = parseFloat(this.value).toFixed(3);
        var change = parseFloat(this.change_value).toFixed(3);
        container.append(
          '<li><a href="/stock/'+encodeURIComponent(encodeURIComponent(this.ticker))+'/">'
          + this.ticker  
          + '</a> <span class="'
          + ( value > 0 ? 'up' : value < 0 ? 'down' : '')
          + '">' + value + '</span>'
          + ' <span class="'
          + ( change > 0 ? 'up' : change < 0 ? 'down' : '')
          + '"> (' + change + ')</span>'
          + '</li>'
        );
      });
      /*
      if (getInternetExplorerVersion() > 8){
      	container.find('li').css('padding','11px 5px 9px 5px');
      }
      */
      show();
    }, 'json');
    return false;
  }
    
  function show(){
    containerWidth = 0;
    container = container.first();
    container.find('li').each(function(){
      containerWidth += $(this).outerWidth();
    });
    containerLeft = (containerWidth < wrapperWidth) ? wrapperWidth : containerWidth;
    wrapper.append(container.data('left', 0).clone().css('left', containerLeft).data('left', containerLeft));
    container = wrapper.find('ul').hide().css('visibility', 'visible').fadeIn('slow');
    container.hover(function(){
      stopped = true;
    }, function(){
      stopped = false;
    });
    move();
  }
  
  function move(){
    var current = new Date(), dif = current - prev;
    prev = current;
    requestAnimationFrame(move);
    if(stopped) return;
    if (container.length > 0){
      container.each(function(){
        var c = $(this), left = c.data('left');
        left -= dif * pxPerSec / 1000;
        if(left <= -containerLeft) left += containerLeft * 2;
        c.data('left', Math.round(left)).css('left', Math.round(left));
      });
    }
  }//move
  
  get();
  updateFunctions.push(function(){
  	$('.index .sentiment p').text((VIEW_MODE == 'MP' ? 'MP' : 'CROWD')+' SENTIMENT');
  	get();
  });
  return true;
});

function tagCloud(container, data){
	container = $(container);
	var id = (new Date()).getTime() + '-' + Math.round(Math.random() * 1000);
	var width = container.innerWidth();
	var height = container.innerHeight();
	var canvas = $('<canvas id="tagCloud-' + id + '-canvas" width="'+width+'" height="'+height+'"></canvas>').css({
		background: '#fff'
	}).appendTo(container);
	var tagsId = 'tagCloud-' + id + '-tags';
	var tags = $('<div id="'+tagsId+'"></div>').hide().appendTo(container);
	var ul = $('<ul></ul>').appendTo(tags);
	
	var totalWeight = 0;
	$.each(data, function(){
		this.weight = parseFloat(this.weight);
		totalWeight += this.weight;
		if (this.text !== null){
			ul.append($('<li></li>').html(
				$(this.text.indexOf('<') === 0 ? this.text : '<a href="javascript:void(0);">'+this.text+'</a>').attr('data-weight', this.weight)
			));
		}
	});
	
	ul.find('a').each(function(){
		this.style.color = $(this).attr('data-color') || '#24AAE1';
	});
	
	if(!canvas.tagcanvas({
		weight: true,
		weightMode: 'size',
		weightFrom: 'data-weight',
		weightSize: 1,//(height / 10) / (totalWeight / data.length),
		weightSizeMin: 20,
		weightSizeMax: 50,
		textColour: null,
		zoom: 1.0,
		wheelZoom: false,
		freezeActive: true
	}, tagsId)) container.hide();
	
}//tagCloud

var topSearchStockObj = {
  inited: false,
  list: null,
  key: null,
  ajax: null,
  id: null,
  type: 'stock',
  init: function(){
    var This = this;
    if(This.inited) return;
    This.inited = true;
    This.key = $('#top-search-key');
    This.list = $('#top-search-list').hover(function(){
      This.list.find('tr').removeClass('active');
    });
  },
  reinit: function(){
    this.inited = false;
    this.init();
  },
  show: function(){
    var This = this;
    $('body').bind('click', This.onclick);
    var api = This.list.find('div.search-wrapper').data('jsp');
    if(api) api.destroy();
    This.key.focus();
    This.list = $('#top-search-list');
    This.list.fadeIn('fast', function(){
      This.list.find('div.search-wrapper').jScrollPane();
      This.list.find('tr').click(function(){
        This.id = $(this).attr('data-id');
        This.key.attr('value',(This.type == 'user' ? '@' : '')+This.id);
        This.run();
      });
    });
  },
  hide: function(){
    var This = this;
    $('body').unbind('click', This.onclick);
    This.reinit();
    This.list.fadeOut('fast');
  },
  onclick: function(event){
    if(!$(event.target).closest('#top-search-list').length) topSearchStockObj.hide();
  },
  move: function(step){
    var This = this;
    if(!step) step = 1;
    var list = This.list.find('tr'), total = list.length, current;
    if(total){
      current = list.filter('.active');
      current = list
        .removeClass('active')
        .eq(((current.length ? list.index(current) : (step > 0 ? -1 : total)) + total + step) % total)
        .addClass('active');
      var api = This.list.find('div.search-wrapper').data('jsp');
      if(api) api.scrollToElement(current);
    }
  },
  go: function(){
    var active = this.list.find('tr.active');
    if(active.length){
      var This = this;
      var id = active.attr('data-id');
      if (This.id != null && This.id == id){
        This.run();
      }else{
        This.id = active.attr('data-id');
        This.key.attr('value',(This.type == 'user' ? '@' : '')+This.id);
      }
    }
    return active.length > 0;
  },
  run: function(){
    var This = this;
    if (This.id){
      window.location.assign(((This.type == 'stock') ? '/stock/' : '/users/details/')+encodeURIComponent(encodeURIComponent(This.id))+'/');
    }else{
      This.search();
    }
    return true;
  },
  search: function(limit){
    var This = this;
    This.id = null;
    This.init();
    var key = This.key.val();
    if(!key){
    	This.hide();
    	return;
    }
    This.type = (key.substring(0, 1) == '@') ? 'user' : 'stock';
    if(!key) return;
    if(This.ajax) This.ajax.abort();
    This.ajax = $.ajax({
      data: {key: key, limit: limit || 10, type: 'show'},
      url: (This.type == 'stock') ? '/ajax/search/stock/' : '/ajax/search/user/',
      success: function(data){
        This.ajax = null;
        if(!data.html){
        	This.hide();
        	return true;
        }
        if (data.match) This.id = data.match;
        This.list.empty().html(data.html);
        This.show();
      },
	    dataType: 'json'
    });
  }
};//topSearchStockObj

function topSearch(limit){
	if(topSearchStockObj.ajax == null){
  	topSearchStockObj.search(limit);
 	}
  return false;
}//topSearchStock

function topSearchRun(){
  topSearchStockObj.run();
  return false;
}//topSearchStock

$(function(){
  var prev = '', val, search = $('#top-search-key');
  search.keyup(function(e){
    if(e.keyCode == 13){
      if(!topSearchStockObj.go()) topSearchStockObj.run();
    }else if(e.keyCode == 40)topSearchStockObj.move(1);
    else if(e.keyCode == 38) topSearchStockObj.move(-1);
    else{
      $('#top-search-list tr.active').removeClass('active');
      val = search.val();
      if(val != prev){
        prev = val;
        topSearch();
      }
    }
  });
});

function getURLParameter(url,name) {
    return decodeURIComponent(
        (url.match(RegExp("[?|&]"+name+'=(.+?)(&|$)'))||[,null])[1]
    );  
}//getURLParameter

function timeSince(date) {

    var seconds = Math.floor((new Date() - date) / 1000);

    var interval = Math.floor(seconds / 31536000);

    if (interval >= 1) {
        return interval + "y";
    }
    interval = Math.floor(seconds / 2592000);
    if (interval >= 1) {
        return interval + "m";
    }
    interval = Math.floor(seconds / 86400);
    if (interval >= 1) {
        return interval + "d";
    }
    interval = Math.floor(seconds / 3600);
    if (interval >= 1) {
        return interval + "h";
    }
    interval = Math.floor(seconds / 60);
    if (interval >= 1) {
        return interval + "m";
    }
    return Math.floor(seconds) + "s";
}

function makeCustomSelect(This, disable){
	This = $(This);
	disable = disable || false;
	This.selectbox({onOpen: function(inst){
			var options = $('#sbOptions_'+inst.uid);
	    var jsp = options.data('jsp');
	    if(jsp){
	    	jsp.destroy();
	    	options = $('#sbOptions_'+inst.uid);
	    }
	    options.css({height: 'auto', overflowY: 'auto'});
	    options.jScrollPane({contentWidth: '0px'});
		}
	});
	if(disable) This.selectbox("disable");
}

function makeRedCheckbox(This){
	stylizedRadioCheckbox(This);
	/*
	$(This).screwDefaultButtons({
    checked:  "url(/img/main/bg_power-check_active.png)",
    unchecked:  "url(/img/main/bg_power-check.png)",
    width:    12,
    height:   11
    //selectAll:  "#selectAll"
  });
  */
}

function stylizedRadioCheckbox(input){
	$(input).filter('input[type=radio],input[type=checkbox]').each(function(){
    var input = $(this);
    if(input.data('stylized')) return;
    
    var stylized = {};
    stylized.click = function(){
    	if(input.is('[type=checkbox]')){
	        input.attr('checked', input.is(':checked') ? false : true).change();
	    }else if(!input.is(':checked')) input.attr('checked', true).change();
    }
    stylized.update = function(){
	    if(input.is('[type=radio]')){
	        $('input[type=radio][name="'+input.attr('name')+'"]').each(function(){
	            var e = $(this), s = e.data('stylized');
	            if(s) s.element[e.is(':checked') ? 'addClass' : 'removeClass']('checked');
	        });
	    }else stylized.element[input.is(':checked') ? 'addClass' : 'removeClass']('checked');
    }
    stylized.element = $('<div></div>').click(stylized.click).addClass(input.is('[type=radio]') ? 'inputRadio' : 'inputCheckbox').addClass(input.attr('class'));
    input.closest('label').click(function(){return !stylized.element.is(":hover");});
    $('label[for="'+input.attr('id')+'"]').click(function(e) {
    	e.preventDefault();
    	stylized.click();
		});
    input.data('stylized', stylized).change(stylized.update).hide().after(stylized.element);
    stylized.update();
	});
}//stylizedRadioCheckbox

/* CHARTS FUNCTIONS */
function getDefaultChartOptions(){
	return {
			credits: false,
	    chart: {
				type: 'spline',
				marginTop: 20,
				marginRight: 5,
				marginLeft: 55,
				zoomType: 'x',
				spacingBottom: 2,
				resetZoomButton: {
					position: {x: -14, y: 24},
          relativeTo: 'chart',
          theme: {
          	style: {fontSize: '8px'},
          	padding: 1
          }
        }
	    },
	    xAxis: {
	      type: 'datetime',
	      offset: 5,
	      dateTimeLabelFormats: {
					minute: '%I:%M%p', hour: '%I:%M%p'
				}
	    },
	    yAxis: {
	    	title: false,
	    	labels: {
          formatter: function(){
            return this.value.toFixed(2);
          }
        },
	      plotLines: [{
	        value: 0,
	        width: 1,
	        color: '#808080'
	      }]
	    },
	    title: false,
	    tooltip: {
	    	enabled: true,
	    	valueDecimals: 4,
	    	followPointer: true,
	    	headerFormat: '<span style="font-size: 9px">{point.key}</span><br/>',
	    	style: {fontSize: '9px'},
	    	dateTimeLabelFormats: {
	    		second: '%A, %b %e, %I:%M:%S%p',
					minute: '%A, %b %e, %I:%M%p',
					hour: '%A, %b %e, %I:%M%p',
					day:"%A, %b %e, %Y",
			    week:"%A, %b %e, %Y",
			    month:"%A, %b %e, %Y",
			    year:"%A, %b %e, %Y"
				}
	    },
	    legend: false,
	    exporting: {
	    	url: '/highcharts-server/'
	    },
	    navigation: {
        buttonOptions: {
          verticalAlign: 'top',
          height: 18,
          widht: 20,
          y: 15
        }
      },
	    plotOptions: {
	    	series: {
	    		color: '#1A5488',
	    		shadow: false,
	    		lineWidth: 1,
	    		marker:{
          	enabled: false,
          	radius: 2,
		      	symbol: 'circle',
            states:{
              hover:{
              	enabled: true
              }
            }
          }
	    	}
	    },
	    series: [{
	      name: 'Value',
	      data: []
	    }]
	};
}//getDefaultChartOptions

function getFullDayChartExtremes(){
	var extremes = {min: DateEST(), max: DateEST()};
	extremes.min.setHours(0);
	extremes.min.setMinutes(0);
	extremes.min.setSeconds(0);
	extremes.min.setMilliseconds(0);
	extremes.min = extremes.min.getTime();
	extremes.max.setHours(23);
	extremes.max.setMinutes(59);
	extremes.max.setSeconds(59);
	extremes.max.setMilliseconds(999);
	extremes.max = extremes.max.getTime();
	return extremes;
}//getFullDayChartExtremes

function chartSetFullDayExtremes(chart){
  if(isChartZoom(chart)){ return false;}
  var extremes = getFullDayChartExtremes();
  chart.xAxis[0].setExtremes(extremes.min, extremes.max);
}//chartSetFullDayExtremes

function chartSetHistoricalExtremes(chart){
	if(isChartZoom(chart)){ return false;}
  var container = $(chart.container);
  var timeframe = container.data('timeframe');
	if(timeframe){
		var extremes = getFullDayChartExtremes();
  	chart.xAxis[0].setExtremes(timeframe[0], extremes.max);
 	}
}//chartSetFullDayExtremes

function chartZoom(chart, min, max){
	var container = $(chart.container);
	if(!container.data('markers'))
  {
    var series = chart.series;
    var markers = []
    $.each(series, function(i, item){
      var status = item.options.marker.enabled;
      if (status == false){
        item.options.marker.enabled = true;
        if(typeof item.stateMarkerGraphic != 'undefined' && item.stateMarkerGraphic != null)
          item.stateMarkerGraphic = item.stateMarkerGraphic.destroy();
      }
      markers[i] = status;
    });
    container.data('markers', markers);
  }
	if(!container.data('extremes')) container.data('extremes', chart.xAxis[0].getExtremes());
	chart.xAxis[0].setExtremes(min, max);
	if(typeof chart.resetZoomButton != 'undefined') chart.resetZoomButton.show();
}//chartZoom

function chartResetZoom(chart){
	var container = $(chart.container);
	var extremes = container.data('extremes');
	if(extremes){
		container.data('extremes', null);
		if(container.data('markers'))
    {
      var series = chart.series;
      $.each(container.data('markers'), function(i, item){
        if(item == false){
          series[i].options.marker.enabled = false;
          $.each(series[i].data, function (i, point){
            if(point.graphic){
              point.graphic = point.graphic.destroy();
            }
          });
        }
      });
      container.data('markers', null);
    }
		chart.xAxis[0].setExtremes(extremes.min, extremes.max);
		if(typeof chart.resetZoomButton != 'undefined') chart.resetZoomButton.hide();
	}
}//chartResetZoom

function setChartData(chart, data, index){
	index = index || 0;
	var series = chart.series[index];
	var visible = series.visible;
	var timeframe = $(chart.container).data('timeframe');
	var newTimeframe = [];
	$.each(data.timeframe,function(i, value){
		newTimeframe[i]=mysqlstrtotime(value).getTime();
	});
	if (timeframe && (newTimeframe[1]-newTimeframe[0]) <= 1260000){
		newTimeframe[0] = timeframe[0];
	}
	$(chart.container).data('timeframe', newTimeframe);
	if(!visible) series.show();
	$.each(data.records, function(){
		var id = index + ',' + this[0];
		var point = chart.get(id);
		var option = {
			id: id,
			x: mysqlstrtotime(this[0]).getTime(),
			y: this[1]
		};
		if(point){
			point.update(option, false);
		}else{
			series.addPoint(option, false);
		}
	});
	chart.redraw();
	if(!data.show){
		series.hide();
		if(typeof  series.legendItem !== 'undefined'){
			$(series.legendItem.parentGroup.element).bind("click", function(){
				if(!data.show){
					series.hide();
				}
			});
		}
	}else{
		series.show();
	}
	showChartLegend(chart);
	if(!visible) series.hide();
}//setChartData

function showChartLegend(chart){
	return true;
	var showLegend = false;
	if(chart.legend.options){
		$.each(chart.series, function(i, item){
			if(item.data.length > 0){
				showLegend = true;
			}
		});
		if(showLegend){
			chart.legend.group.show();
      chart.legend.box.show();
      chart.legend.display = true;
		}else{
			chart.legend.group.hide();
      chart.legend.box.hide();
      chart.legend.display = false;
		}
	}
	return showLegend;
}// showChartLegend

function cutChart(chart, minutes){
  if(isChartZoom(chart)){ return false;}
  var timeframe = $(chart.container).data('timeframe');
  if(timeframe && minutes){
  	$(chart.container).data('cutLimit', minutes);
    var max = timeframe[1];
    chart.xAxis[0].setExtremes(max - minutes * 60000, max);
  }
}//cutChart

function isChartZoom(chart){
  var extremes = $(chart.container).data('extremes');
  if(extremes) return true;
  else return false;
}

function removeChartData(chart){
	$.each(chart.series, function(i, item) {
		item.setData([]);
	});
}

/* END CHARTS FUNCTIONS */
/* ALERT FUNCTIONS */

function usersAlertFilterChange(select, limit){
	var select = $(select);
	limit = limit || 15;
	if (select.length > 0){
		select.selectbox("detach");
		select.selectbox({
	  	contentWidth: '0px',
			onChange: function(val, inst){
				usersAlertaddFilterBox(inst.input, limit);
			},
			onOpen: function(inst){
				var options = $('#sbOptions_'+inst.uid);
		    var jsp = options.data('jsp');
		    if(jsp) {
		    	jsp.destroy();
		    	options = $('#sbOptions_'+inst.uid);
		    }
		    options.css({height: 'auto', overflowY: 'auto'});
		    options.jScrollPane({contentWidth: '0px'});
			}
		});
		usersAlertaddFilterBox(select, limit);
	}
}

function usersAlertaddFilterBox(item, limit, open){
	item = $(item);
	limit = limit || 0;
	open = open || false;
	var filters = item.closest('.alerts-filter');
	var data = {
		limit: limit,
		username: item.closest('form').find('input[name="username"]').val(),
		type: item.closest('form').find('input[name="type"]').val(),
		subtype: item.closest('form').find('input[name="subtype"]').val(),
	};
	filters.find('.bg:not(.filter-selector) select').each(function(){
		data[$(this).attr('name')] = $(this).attr('value');
	});
	var wrap = filters.find('.alerts-filter-tickers-box');
	if (wrap.length > 0){
		$.get('/ajax/users/filter-tickers/',data,function(response){
			if (response.html){
				wrap.html(response.html);
				var scrolling = wrap.find('.scrolling');
				if (scrolling.length > 0){
					var jsp = scrolling.data('jsp');
			    if(jsp) jsp.reinitialise();
			    else scrolling.jScrollPane();
		   	}
		   	wrap.find('tr[data-id]').click(function(){
		   		var This = $(this);
		   		var id = This.attr('data-id');
		   		This.closest('.alerts-filter').find('.filter-selector .sbOptions a[rel="'+id+'"]').click();
		   		This.closest('.alerts-filter').find('.alerts-filter-tickers-box').slideUp();
		   		wrap.find('tr[data-id]').removeClass('active');
		   		This.addClass('active');
		   	});
		   	var value = filters.find('.filter-selector select').val();
		   	var selected = wrap.find('tr[data-id="'+value+'"]');
		   	/*if (selected.length == 0) selected = wrap.find('tr[data-id]').first();
		   	selected.click();*/
		   	if (selected.length > 0) selected.click();
		   	if(open) filters.find('.filter-selector .sbToggle').click();
			}
		}, 'json');
	}
}

function usersAlertPowerChange(This){
	var This = $(This).find('input[name="power"]');
	var select = This.closest('form').find('select[name="timeframe_id"]');
	if (This.is(':checked')){
		select.prepend("<option value='11'>24 HOURS</option>");
		select.val(11);
		select.selectbox("detach");
		makeCustomSelect(select, true);
	}else{
		select.find('option[value="11"]').remove();
		select.selectbox("detach");
		makeCustomSelect(select);
	}
}

function validateAlertFrom(frm){
	var frm = $(frm);
	var operation_main = $('[name=operation]', frm).val();
	var type_1 = $('[name=type_id_1]', frm).val(), type_2 = $('[name=type_id_2]', frm).val();
	var operation_1 = $('[name=operation_id_1]', frm).val(), operation_2 = $('[name=operation_id_2]', frm).val();
	var value_1 = $('[name=value_1]', frm).val(), value_2 = $('[name=value_2]', frm).val();
	var result = true;
	function validateAlertOption(index){
		var type = $('[name=type_id_'+index+']', frm).val(), operation = $('[name=operation_id_'+index+']', frm).val(), value = $('[name=value_'+index+']', frm).val();
		if(value == '') return false;
		value = parseFloat(value);
		if((type < 3 || type == 8 || type == 11  || type == 12  || type == 15) && ((value > 1 || value < -1) || (value == 1 && (operation == 2 || operation == 4)) || (value == -1 && (operation == 3 || operation == 5)))) return false;
    else if((type == 3 || type == 10 || type == 13 || type == 17) && ((value > 2 || value < -2) || (value == -2 && (operation == 3 || operation == 5)) || (value == 2 && (operation == 2 || operation == 4)))) return false;
    else if((type == 4 || type == 5) && (value < 0 || (value == 0 && (operation == 3 || operation == 5)))) return false;
    //else if(type == 6 && ((value < -100  || value > 100) || (value == -100 && (operation == 3 || operation == 5)) || (value == 100 && (operation == 2 || operation == 4)))) return false;
    else return true;
	}
	function validateAlertOptionsSameTypes(value1, value2, operation1, operation2){
		if(value1 && value2 && operation1 && operation2){
			if(value1 != value2 && operation1 == operation2 && operation1 == 1) return false;
			else if(value1 < value2 && (operation1 == 3 || operation1 == 5) && (operation2 == 2 || operation2 == 4)) return false;
			else if(value1 > value2 && (operation1 == 2 || operation1 == 4) && (operation2 == 3 || operation2 == 5)) return false;
			else if(value1 == value2 && (operation1 == 2 || operation1 == 3) && (operation2 == 2 || operation2 == 3) && (operation1 != operation2)) return false;
			else if(value1 < value2 && (operation1 == 1) && (operation2 == 2 || operation2 == 4)) return false;
      else if(value1 > value2 && (operation1 == 2 || operation1 == 4) && (operation2 == 1)) return false;
      else if(value1 > value2 && (operation1 == 1) && (operation2 == 3 || operation2 == 5)) return false;
      else if(value1 < value2 && (operation1 == 3 || operation1 == 5) && (operation2 == 1)) return false;
			else return true;
		}
		return false;
	}
	if (!validateAlertOption(1)) result = false;
	if (operation_main != 2 && !validateAlertOption(2)) result = false;
	if( result == true && type_1 == type_2 && operation_main == 1) return validateAlertOptionsSameTypes(value_1, value_2, operation_1, operation_2);
	return result;
}

function initAlertForm(){
	$('.custom').live("change", function(){
		var Select = $(this);
		$('.sbHolder .sbOptions li a', Select.parent()).removeClass('selected').filter(':eq('+$(':selected', Select).index()+')').addClass('selected');
	});
	$('input[name="value_1"], input[name="value_2"], select[name="type_id_1"], select[name="type_id_2"]').live('change', function(){
		var frm = $(this).closest('form');
		var thisName = $(this).attr('name');
		var index = parseInt(thisName.charAt(thisName.length - 1));
		if(index == 1 || index == 2) setPriceChangeFormat(index);
		function setPriceChangeFormat(index){
			var type = $('[name=type_id_'+index+']', frm).val();
			var value = parseFloat($('[name=value_'+index+']', frm).val());
			var input = $('[name=value_'+index+']', frm);
			if(type == 6){
			 //if (value <= 1) input.val(value * 100);
			 if (input.parent().find('span.percentage').length == 0) input.after('<span class="percentage">%</span>');
			}else{
			  input.parent().find('span.percentage').remove();
			}
		}
	});
	$('.edit-alert .wrap select[name="operation"]').live('change', function(){
    var frm = $(this).closest('form');
    var value = $(this).val();
    if (value == 2){
      $('.wrap .row.second', frm).hide();
      $('.comb', frm).addClass('small');
    }else{
      $('.wrap .row.second', frm).show();
      $('.comb', frm).removeClass('small');
      $('.wrap .row.second', frm).find('a.sbFocus').click();
    }
    var popup = $(this).closest('.simplePopup'); 
    if(popup.length) popup.data('update')();
  });
  $('.alerts-filter.filter-popup .filter-selector .sbToggle, .alerts-filter.filter-popup .filter-selector .sbSelector').live('click',function(){
  	var filterBox = $(this).closest('.alerts-filter');
  	var tickersBox = filterBox.find('.alerts-filter-tickers-box');
  	if (tickersBox.find('.tickers-wrapper').length > 0){
	  	filterBox.find('.filter-selector .sbOptions').css('visibility', 'hidden');
	  	tickersBox.slideToggle();
	  	var scrolling = tickersBox.find('.scrolling');
			if (scrolling.length > 0){
				var jsp = scrolling.data('jsp');
		    if(jsp) jsp.reinitialise();
		    else scrolling.jScrollPane();
	   	}
  	}
  });
  $('body').click(function(event){
   	if(!$(event.target).closest('.alerts-filter-tickers-box, .bg.filter-selector').length)
   		$('.alerts-filter-tickers-box').slideUp();
 	});
}
$(function(){
	initAlertForm();
});
/*END ALERT FUNCTIONS*/

function ajaxFilterReloadInfo(This, wrap, callback){
	This = $(This);
	wrap = $(wrap);
	var form = This.closest('form');
	var url = document.URL;
	if (form.attr('action')){
		url = form.attr('action');
	}
	var data = form.serialize();
	if (data && wrap.length > 0){
		$.post(url, data, function(response){
			if (!response.hasError){
				wrap.html(response.data);
				wrap.find('.scrolling').each(function(i){
					var jsp = $(this).data('jsp');
			    if(jsp) jsp.destroy();
			    $(this).jScrollPane();
				});
				if (typeof callback === 'function'){
					callback();
				}
			}else{
				showErrorMessage(response.status);
			}
		}, 'json');
	}
}

function getInternetExplorerVersion(){
  var rv = -1;
  var ua = navigator.userAgent;
  var re  = new RegExp("MSIE ([0-9]{1,}[\.0-9]{0,})");
  if (re.exec(ua) != null) 
    rv = parseFloat( RegExp.$1 );
  if (!!ua.match(/Trident.+rv:11\./))
  	rv = 11;
  return rv;
}

function DateToEST(date){
	if(!date) date = new Date();
	var offset;
	if(typeof UTC_OFFSET != 'undefined') offset = UTC_OFFSET;
	else offset = date.getTimezoneOffset() < Math.max((new Date(date.getFullYear(), 0, 1)).getTimezoneOffset(), (new Date(date.getFullYear(), 6, 1)).getTimezoneOffset()) ? -4 : -5;
  return new Date(date.getTime() - (date.getTimezoneOffset() * 60000) - (offset * 3600000));
}//DateToEST

function DateEST(){
	var date = new Date();
	var offset;
	if(typeof UTC_OFFSET != 'undefined') offset = UTC_OFFSET;
	else offset = date.getTimezoneOffset() < Math.max((new Date(date.getFullYear(), 0, 1)).getTimezoneOffset(), (new Date(date.getFullYear(), 6, 1)).getTimezoneOffset()) ? -4 : -5;
  return new Date(date.getTime() + (date.getTimezoneOffset() * 60000) + (offset * 3600000));
}//DateEST

var dataExtraction = function(node){
	node = $(node);
	var result = node.text();
	var number = result.replace(",", "").replace(" ", "").replace("%", "");
	if (typeof node.attr("rel") !== 'undefined'){
  	result = node.attr("rel");
  }else if($.isNumeric(number)){
  	result = parseFloat(number).toString();
  }else if(result == 'N/A'){
  	result = '';
  }
  return result;
}

function number_format(number, decimals, dec_point, thousands_sep){
  number = (number + '')
    .replace(/[^0-9+\-Ee.]/g, '');
  var n = !isFinite(+number) ? 0 : +number,
    prec = !isFinite(+decimals) ? 0 : Math.abs(decimals),
    sep = (typeof thousands_sep === 'undefined') ? ',' : thousands_sep,
    dec = (typeof dec_point === 'undefined') ? '.' : dec_point,
    s = '',
    toFixedFix = function (n, prec) {
      var k = Math.pow(10, prec);
      return '' + (Math.round(n * k) / k)
        .toFixed(prec);
    };
  // Fix for IE parseFloat(0.55).toFixed(0) = 0;
  s = (prec ? toFixedFix(n, prec) : '' + Math.round(n))
    .split('.');
  if (s[0].length > 3) {
    s[0] = s[0].replace(/\B(?=(?:\d{3})+(?!\d))/g, sep);
  }
  if ((s[1] || '')
    .length < prec) {
    s[1] = s[1] || '';
    s[1] += new Array(prec - s[1].length + 1)
      .join('0');
  }
  return s.join(dec);
}
function trim(s){return String(s).replace(/^\s+/, '').replace(/\s+$/, '');}
function capitalize(s){return s[0].toUpperCase() + s.slice(1);}
function setCookieCustom(c_name,value,expiredays,domain){var exdate=new Date();exdate.setDate(exdate.getDate()+expiredays);
document.cookie=c_name+"="+escape(value)+((typeof expiredays == "undefined") ? "" : "; expires="+exdate.toGMTString())+(domain?"; path="+domain:"");}
function getCookieCustom(c_name){if(document.cookie.length>0){c_start=document.cookie.indexOf(c_name + "=");
if(c_start!=-1){c_start=c_start + c_name.length+1;c_end=document.cookie.indexOf(";",c_start);
if(c_end==-1) c_end=document.cookie.length;return unescape(document.cookie.substring(c_start,c_end).replace(/\+/g, " "));}}return"";}