var itemType;
var itemID;
var stockData;
var popupType = 'box';
var reloadPage = false;

$(document).ready(function() {

 openDashboardTab();

 $('.dashboard .top-menu .view select').change(function() {
   var url = document.URL;
   var name = $(this).attr('name');
   var value = $(this).val();
   var queryParameters = getUrlParts(url);
   queryParameters[name] = value;
   queryParameters['page'] = 1;
   location.search = $.param(queryParameters);
 });

 $('.dashboard .titles a').click(function() {
   var url = document.URL;
   var queryParameters = getUrlParts(url);
   var orderType = $(this).hasClass('asc') ? 'desc' : 'asc'
   var orderName = $(this).parent().attr('class');
   queryParameters['sort'] = orderName;
   queryParameters['order'] = orderType;
   queryParameters['page'] = 1;
   location.search = $.param(queryParameters);
 });
 /*
  if (popupType != 'box')
  {
    $('.alerts-box.small .alert').click(function(){
      $(this).toggleClass('active');
      if ($(this).hasClass('active'))
      {
        showEditAlertWindow(this);
      }
    });
  }
  */
});

function showStockData(rel){
  var item = $(rel);
  var wrapper = item.parent();
  var stock = item.parent().parent().parent();
  if(stock.hasClass('pending')) return false;
  itemType = item.attr('id');
  itemID = stock.attr('id').replace('stock_', '');
  var isActive = wrapper.hasClass("active");
  stockData = stock.find('.stock-data');
  var result = false;
  if(isActive){
    wrapper.removeClass('active');
    stock.removeClass('active');
    stockData.slideUp('slow',function(){$(this).empty();});
  }else{
    stock.find('.top-bar > div.active').removeClass('active');
    wrapper.addClass('active');
    stock.addClass('active');
    stockData.empty();
    getStockData();
  }
  return false;
}

function getStockData()
{
  if (itemType != null)
  {
    var params = '?stock_id='+itemID;
    switch(itemType)
    {
      case 'show':
        getMainDataBox('/ajax/dashboard/summary-info/'+params);
        break;
      case 'alerts':
        getMainDataBox('/ajax/dashboard/alerts-info/'+params);
        break;
      case 'graphs':
        getMainDataBox('/ajax/dashboard/graphs-info/'+params);
        break;
      default:
        return false;
    }
  }
  return true;
}

function getMainDataBox(url)
{
  $.ajax({
    type: "GET",
    url: url,
    success: function(data){
      stockData.html(data).slideDown('slow');
    }
  });
  return false;
}

function getStockDataItems()
{
  if (itemType != null)
  {
    var params = '?stock_id='+itemID;
    switch(itemType)
    {
      case 'show':
        openBox('#tweets', "/ajax/dashboard/tweets/"+params);
        openBox('#cloud-box', "/ajax/dashboard/cloud-box/"+params);
        openBox('#fund-box', "/ajax/dashboard/fund-box/"+params);
        openBox('#alerts-box', "/ajax/dashboard/alerts-box/"+params);
        openBox('#top-user-alerts-box', "/ajax/dashboard/top-alerts-box/"+params);
        openBox('#graphs-data-box', '/ajax/dashboard/graphs-box/'+params+'&row=0&col=0');
        openBox('#top-user-stats-box', "/ajax/dashboard/top-stats-box/"+params+'&type=top-user');
        openBox('#top-mp-stats-box', "/ajax/dashboard/top-stats-box/"+params+'&type=top-mp');
        break;
      case 'alerts':
        openBox('#alerts-box', "/ajax/dashboard/alerts-box/"+params+'&edit=1');
        openBox('#edit-alerts-box', "/ajax/dashboard/edit-alerts-box/"+params);
        openBox('#top-user-alerts-box', "/ajax/dashboard/top-alerts-box/"+params+'&edit=1&type=top-user');
        openBox('#top-user-edit-alerts-box', "/ajax/dashboard/top-edit-alerts-box/"+params+'&type=top-user');
        openBox('#top-mp-alerts-box', "/ajax/dashboard/top-alerts-box/"+params+'&edit=1&type=top-mp');
        openBox('#top-mp-edit-alerts-box', "/ajax/dashboard/top-edit-alerts-box/"+params+'&type=top-mp');
        break;
      case 'graphs':
        openBox('#graphs-data-box', '/ajax/dashboard/graphs-box/'+params);
        break;
      default:
        return false;
    }
  }
  return true;
}

function openBox(rel, url)
{
  $.ajax({
    type: "GET",
    url: url,
    success: function(data){
      var box = stockData.find(rel);
      box.html(data);
      box.find('.scrolling').jScrollPane();
      makeCustomSelect(box.find(".custom"));
			box.find('select:visible').each(function(){
				if(!$(this).is('.skip_stylize')) new StylizedSelect(this);
			});
			box.find('.select').click(function(){
		    var options = $('.options', this);
		    options.css({height: 'auto', overflowY: 'auto'});
		    var jsp = options.data('jsp');
		    if(jsp) jsp.reinitialise();
		    else options.jScrollPane({contentWidth: '0px'});
		  });
      box.find('[tweets-ticker]').each(function(){loadTweets(this);});
      graphsSwitchInit();
      box.find(".graphs-data .graphs-box:odd").css("border-right", "none");
    }
  });
}

function graphsSwitchInit(){
	$('.graphs-switch .switch').each(function(){
		var e = $(this);
		var box = e.next();
		if(!e.data('graphsSwitchInit')){
			e.data('graphsSwitchInit', true);
			var active = box.find('.active');
			if (active.length == 0)
			{
			  active = box.find('li:first').addClass('.active');
			}
			e.text(active.text());
			box.find('a').click(function(){e.text($(this).text());});
			e.click(function(){
		    box.slideToggle('fast', function(){
		      if(!$(this).is(':hidden')) $(this).jScrollPane();
		    });
		  });
		}
	});
}//graphsSwitchInit
$(graphsSwitchInit);

function openDeleteStockWindow(rel)
{
  var stock = $(rel).parent().parent().parent();
  var itemID = stock.attr('data-stock-id');
  var name = stock.find('.top-bar div.company p').text();
  var html = '<h3>DELETE '+name+'</h3>';
  html += '<div class="line"></div>';
  html += '<p>Are you sure you want to delete this ticker?</p>';
  html += '<a href="javascript:void(0);" onclick="deleteStock(\''+itemID+'\');">OK</a>';
  html += '<a href="javascript:void(0);" onclick="hidePopup();">CANCEL</a>';
  showMessageCustom(html);
  return false;
}

function openDeleteAlertWindow(rel)
{
  var alert = $(rel).closest('.alert');
  var itemID = alert.attr('id');
  var html = '<h3>DELETE ALERT</h3>';
  html += '<div class="line"></div>';
  html += '<p>Are you sure you want to delete this alert?</p>';
  html += '<a href="javascript:void(0);" onclick="deleteAlert(\''+itemID+'\');">OK</a>';
  html += '<a href="javascript:void(0);" onclick="hidePopup();">CANCEL</a>';
  showMessageCustom(html);
  return false;
}

function showEditAlertWindow(rel)
{
  var item = $(rel);
  var itemID = item.attr('id').replace('alert_', '');
  var url = '/ajax/dashboard/edit-alerts/';
  var params = "&alert_id="+itemID;
  openAjaxWindow(url, params);
  return false;
}

function openEditAlertWindow(rel)
{
  var item = $(rel).closest('.alert');
  showEditAlertWindow(item);
  return false;
}

function editAlert(stockID){
  stockData = (popupType != 'box') ? $('.stock-data') : $('#stock_'+stockID).find('.stock-data');
  var form = $('.new-alert').find('#edit-alert-form');
  var data = form.serialize();
  data += '&action=edit';
  $.ajax({
      type: "POST",
      data: data,
      url: '/ajax/dashboard/edit-alerts/',
      dataType: 'json',
      success: function(data){
        if(data.hasError == false){
          if(reloadPage == true){
            location.reload();
          }else{
            var params = '?stock_id='+stockID;
            var alertsBoxs = stockData.find('.alerts-box.small');
            if(alertsBoxs.length == 0){
              params += '&edit=1';
            }
            openBox('#alerts-box', "/ajax/dashboard/alerts-box/"+params);
          }
          hidePopup();
        }else{
          showErrorMessage(data.status);
        }
      }
    });
  return false;
}
function deleteAlert(id){
  var item = $('#'+id);
  var data = '&action=delete';
  data += '&alert_id='+item.attr('id').replace('alert_','');
  $.ajax({
      type: "POST",
      data: data,
      url: '/ajax/dashboard/edit-alerts/',
      dataType: 'json',
      success: function(data){
      	hidePopup();
        if(data.hasError == false){
        	var row = item.closest('[data-stock]');
        	if(row.length > 0){
        		if(row.find('.alert-tab').length > 0){
	        		stockData = row;
		      		openBox(
		      			'#alerts-box',
		      			"/ajax/dashboard/alerts-box/?stock_id=" + row.attr('data-stock') + "&edit=1"
		      		);
	      		}else{
	      			location.reload();
	      		}
		      }else{
		      	var body = item.closest('.scrolling');
	          item.remove();
	          var jsp = body.data('jsp');
			    	if(jsp) jsp.reinitialise();
			    	else body.jScrollPane();
        	}
        }else{
          showErrorMessage(data.status);
        }
      }
    });
  return false;
}

function validateAlert(stockID){
	var frm = $((popupType != 'box' ? '' : '#stock_'+stockID+' ')+'.stock-data #add-alert-form');
	return validateAlertFrom(frm);
}

function saveNewAlert(stockID, data)
{
	//stockData = (popupType != 'box') ? $('.stock-data') : $('#stock_'+stockID).find('.stock-data');
	//var form = stockData.find('#add-alert-form');
	//form.find('[name=prediction_id]').val(predictionId);
	//var data = form.serialize();
	data += '&action=add';
	$.ajax({
    type: "POST",
    data: data,
    url: '/ajax/dashboard/edit-alerts-box/',
    dataType: 'json',
    success: function(data){
      if(data.hasError) return showErrorMessage(data.status);
      if (reloadPage == true){
        popupCloseWindow = true;
      	showMessage('Thank you for your prediction.');
      	//location.reload();
      }else if(popupType != 'overlay'){
        showMessage('Thank you for your prediction.');
        itemID  = stockID;
        itemType = 'alerts';
        getStockDataItems();
      }else if(popupType == 'overlay'){
        showMessage('Thank you for your prediction.');
      }
    }
  });
  return false;
}

function openCreateAlertWindow(ticker){
	if(notLoginRedirect()) return false;
  var url = '/ajax/dashboard/edit-alerts-box/?stock_id='+ticker+'&popup_type=overlay';
	openAjaxWindow(url);
}//openCreateAlertWindow

function openPredictionAlertWindow(stockID){
	if(!validateAlert(stockID)) return showErrorMessage('Value is not valid for this variable.');
	var data = $((popupType != 'box' ? '' : '#stock_'+stockID+' ')+'.stock-data #add-alert-form:visible').serialize();
	openPredictionWindow({
		ticker: stockID,
		source: 1,
		timeframe_id: $((popupType != 'box' ? '' : '#stock_'+stockID+' ')+'.stock-data #add-alert-form select[name=timeframe_id]').val()
	}, function(predictionId){
	  data += '&prediction_id='+predictionId;
		saveNewAlert(stockID, data);
	});
}//openPredictionAlertWindow

var savePredictionCallback;
function openPredictionWindow(options, callback){
	savePredictionCallback = callback;
  var url = '/ajax/dashboard/prediction-alerts/?';
  if(options.ticker) url += '&ticker='+options.ticker;
  if(options.timeframe_id) url += '&timeframe_id='+options.timeframe_id;
  if(options.source) url += '&source='+options.source;
  openAjaxWindow(url);
}//openPredictionWindow

function savePrediction(frm){
	var frm = $(frm || '.prediction #prediction-form');
  var require = frm.find('.box.require');
  if(require.length != require.find('input[type=radio]:checked').length){
    return showErrorMessage('Please make the prediction for the timeframe you set for the alert');
  }

  $.ajax({
    type: "POST",
    data: frm.serialize(),
    url: '/ajax/dashboard/prediction-alerts/',
    dataType: 'json',
    success: function(data){
      if(data.hasError) return showErrorMessage(data.status);
      hidePopup();
      if(savePredictionCallback) savePredictionCallback(data.id);
    }
  });
}//savePrediction

var searchStockObj = {
	inited: false,
	list: null,
	key: null,
	ajax: null,
	id: null,
	init: function(){
		var This = this;
		if(This.inited) return;
		This.inited = true;
		This.key = $('#search-key');
		This.list = $('#search-list').hover(function(){
			This.list.find('tr').removeClass('active');
		});
	},
	reinit: function(){
		this.inited = false;
		this.init();
	},
	show: function(){
		var This = this;
		$('body').bind('click', This.onclick);
		var api = This.list.find('div.search-wrapper').data('jsp');
  	if(api) api.destroy();
  	This.key.focus();
  	This.list = $('#search-list');
  	This.list.fadeIn('fast', function(){
  		This.list.find('div.search-wrapper').jScrollPane();
  		This.list.find('tr').click(function(){
        This.id = $(this).attr('data-id');
        This.key.attr('value',This.id);
        This.run();
      });
    });
	},
  hide: function(){
  	var This = this;
  	$('body').unbind('click', This.onclick);
  	This.reinit();
  	This.list.fadeOut('fast');
  },
  onclick: function(event){
    if(!$(event.target).closest('#search-list').length) searchStockObj.hide();
  },
	move: function(step){
  	var This = this;
		if(!step) step = 1;
		var list = This.list.find('tr'), total = list.length, current;
		if(total){
			current = list.filter('.active');
			current = list
				.removeClass('active')
				.eq(((current.length ? list.index(current) : (step > 0 ? -1 : total)) + total + step) % total)
				.addClass('active');
			var api = This.list.find('div.search-wrapper').data('jsp');
			if(api) api.scrollToElement(current);
		}
	},
	go: function(){
		var active = this.list.find('tr.active');
		if(active.length){
		  var This = this;
		  This.id = active.attr('data-id');
		  This.key.attr('value',This.id);
		  This.run();
		}
		return active.length > 0;
	},
	run: function(){
    var This = this;
    if(This.id){
      addStock(This.id);
    }else{
    	This.search();
    }
    return true;
  },
  search: function(limit){
  	var This = this;
  	This.init();
  	var key = This.key.val();
  	if(!key){
    	This.hide();
    	return;
    }
  	if(This.ajax) This.ajax.abort();
	  This.ajax = $.ajax({
	    data: {key: key, limit: limit || 10},
	    url: '/ajax/search/stock/',
	    success: function(data){
	    	This.ajax = null;
	    	This.id = data.match ? data.match : null;
	      if(!data.html){
        	This.hide();
        	return true;
        }
	      This.list.empty().html(data.html);
	     	This.show();
	    },
	    dataType: 'json'
	  });
  }
};//searchStockObj
function searchStock(limit){
	if(searchStockObj.ajax == null){
		searchStockObj.search(limit);
	}
  return false;
}//searchStock


$(function(){

	var prev = '', val, search = $('#search-key');

	search.keyup(function(e){
		if(e.keyCode == 13){
			if(!searchStockObj.go()) searchStockObj.run();
		}else if(e.keyCode == 40) searchStockObj.move(1);
		else if(e.keyCode == 38) searchStockObj.move(-1);
		else{
			$('#search-list tr.active').removeClass('active');
			val = search.val();
			if(val != prev){
				prev = val;
				searchStock();
			}
		}
	});
	$('#search-add').click(function(){
		searchStockObj.run();
	});

});

function addStock(id)
{
  $('#search-list').slideUp('fast');
  if (id != '')
  {
    $.ajax({
      type: "POST",
      data: { action: "add_stock", id: id},
      dataType: 'json',
      url: '/dashboard/',
      success: function(data){
        if(data.hasError){
        	showErrorMessage(data.data);
        }else{
          location.reload();
        }
      }
    });
  }
  return false;
}


function deleteStock(itemID){
  var id = itemID.replace('stock_', '');
  if(id != ''){
    $.ajax({
      type: "POST",
      data: { action: "delete_stock", id: id},
      url: '/dashboard/',
      success: function(data){
        if(data == 'success'){
        	$('#'+itemID).remove();
        	location.reload();
        }else{
        	hidePopup();
          showErrorMessage(data);
        }
      }
    });
  }
  return false;
}

function addStockChart(item){
	if(item.data('busy')) return;
	item.data('busy', true);
	var stock_id = item.attr('data-stock-id'), row = item.attr('data-row'), col = item.attr('data-col');
	$.ajax('/ajax/dashboard/graphs-box/?stock_id='+stock_id+'&row='+row+'&col='+col, {
		dataType: 'json',
		type: 'post',
		data: {action: 'add'},
		success: function(response){
			item.data('busy', false);
			if(response.has_error) showErrorMessage(response.status);
			else{
				var fix = prepareAutoResizeGraphsInPopupFix(item);
				item.replaceWith(response.template);
				graphsSwitchInit();
				autoResizeGraphsInPopupFix(fix);
			}
		}
	});
}//addStockChart

function editStockChart(item, chart){
	if(chart == item.attr('data-chart') || item.data('busy')) return;
	item.data('busy', true);
	var stock_id = item.attr('data-stock-id'), row = item.attr('data-row'), col = item.attr('data-col');
	$.ajax('/ajax/dashboard/graphs-box/?stock_id='+stock_id+'&row='+row+'&col='+col, {
		dataType: 'json',
		type: 'post',
		data: {action: 'edit', chart: chart},
		success: function(response){
			item.data('busy', false);
			if(response.has_error) showErrorMessage(response.status);
			else{
				var fix = prepareAutoResizeGraphsInPopupFix(item);
				item.replaceWith(response.template);
				graphsSwitchInit();
				autoResizeGraphsInPopupFix(fix);
			}
		}
	});
}//editStockChart

var dashboardCharts = [];

function drawChartForDay(container, parameters, options){
	Highcharts.setOptions({global: {useUTC: false}});
	var chart, first = true, interval = 60000, lastPrice = null, timeout;
	var chartIntervals = $(container).closest('.graphs-box').find('.options a');

	var update = function(add){
		if(!$.contains(document, container)) return;
		var chartInterval = chartIntervals.filter('.active').attr('data-interval');
		add = (add === false) ? false : true;
		var updateInterval = (first || !add) ? chartInterval : '1 MINUTE';
		if(first) first = false;
		if(!add) clearTimeout(timeout);
		if(chartInterval != '1 DAY' && updateInterval != chartInterval) return false;
		timeout = setTimeout(update, interval);
		var data = {interval : updateInterval};
		if(lastPrice !== null) data.last_price = lastPrice;
		$.get('/ajax/chart/', $.extend(data, parameters), function(response){
			$.each(parameters.data, function(i){
			  if (this == 'price'){
			    var lastDate = 0;
			    lastPrice = null;
			  	if (response.price.timeframe[1]){
			  		lastDate = mysqlstrtotime(response.price.timeframe[1]).getTime() - 1200000;
			  	}
          $.each(response.price.records, function(){
          	if (mysqlstrtotime(this[0]).getTime() <= lastDate){
            	lastPrice = this[1];
          	}
          });
			  }
				setChartData(chart, response[this], i);
			});
			chartSetHistoricalExtremes(chart);
		}, 'json');
	}//update
	var set = $(container).attr('id');
	chart = new Highcharts.Chart($.extend(true, getDefaultChartOptions(), {
		chart: {
		  resetZoomButton: {
        position: {x: -14, y: 20},
      },
		  renderTo: container,
			events: {
				selection: function(event){
				    var chart = this;
				    var id = $(chart.container).parent().attr('id').replace('top', '').replace('bottom', '');
				    $.each(['top','bottom'], function(){
				      var setId = id+this;
				      if (setId in dashboardCharts){
                if(event.xAxis) chartZoom(dashboardCharts[setId], event.xAxis[0].min, event.xAxis[0].max);
                else{
                  event.preventDefault();
                  chartResetZoom(dashboardCharts[setId]);
                }
              }
            });
          }
			}
		},
		navigation: {
      buttonOptions: {
        y: 0
      }
    }
	}, options || {}));
	showChartLegend(chart);
	update();
	dashboardCharts[set] = chart;
	$(container).data('update', update);
	changeInterval(chart);
}//drawChartForDay

function changeInterval(chart){
  var id = $(chart.container).parent().attr('id').replace('top', '').replace('bottom', '');
  var options = $(chart.container).closest('.graphs-box').find('.options a');
  options.click(function(){
    var interval = $(this).attr('data-interval');;
    $.each(['top','bottom'], function(){
      var setId = id+this;
      if (setId in dashboardCharts){
      	var container = $('#'+setId);
        var options = container.closest('.graphs-box').find('.options a');
        var a = options.filter('[data-interval="'+interval+'"]');
        var update = container.data('update');
        if(a.length > 0 && update){
        	options.removeClass('active');
          a.addClass('active');
          removeChartData(dashboardCharts[setId]);
          update(false);
        }
      }
    });
  });
}

function drawChartForRealTime(container, parameters, options){
	Highcharts.setOptions({global: {useUTC: false}});
	var chart, first = true, interval = 60000, lastPrice = null;

	function update(){
		if(!$.contains(document, container)) return;
		setTimeout(update, interval);
		var chartInterval;
		if(first){
			first = false;
			chartInterval =  '1 HOUR';
		}else{
			chartInterval =  '1 MINUTE';
		}
		var data = {interval : chartInterval};
		if (lastPrice !== null) data.last_price = lastPrice;
		$.get('/ajax/chart/', $.extend(data, parameters), function(response){
			$.each(parameters.data, function(i){
			  if (this == 'price'){
			  	var lastDate = 0;
			  	lastPrice = null;
			  	if (response.price.timeframe[1]){
			  		lastDate = mysqlstrtotime(response.price.timeframe[1]).getTime() - 1200000;
			  	}
          $.each(response.price.records, function(){
          	if (mysqlstrtotime(this[0]).getTime() <= lastDate){
            	lastPrice = this[1];
          	}
          });
        }
				setChartData(chart, response[this], i);
			});
			var limit = $(chart.container).data('cutLimit');
			if (limit) cutChart(chart, limit);
		}, 'json');
	}
	var set = $(container).attr('id');
  var chart = new Highcharts.Chart($.extend(true, getDefaultChartOptions(), {
		chart: {
		  resetZoomButton: {
        position: {x: -14, y: 20},
      },
		  renderTo: container,
			events: {
        selection: function(event){
            var chart = this;
            var id = $(chart.container).parent().attr('id').replace('top', '').replace('bottom', '');
            $.each(['top','bottom'], function(){
              var setId = id+this;
              if (setId in dashboardCharts){
                if(event.xAxis) chartZoom(dashboardCharts[setId], event.xAxis[0].min, event.xAxis[0].max);
                else{
                  event.preventDefault();
                  chartResetZoom(dashboardCharts[setId]);
                }
              }
            });
          }
      }
		},
    navigation: {
      buttonOptions: {
        y: 0
      }
    }
	}, options));
	showChartLegend(chart);
	update();
	dashboardCharts[set] = chart;
	cutByOptions(chart);

}//drawChartForRealTime

function cutByOptions(chart){
  var id = $(chart.container).parent().attr('id').replace('top', '').replace('bottom', '');
  var options = $(chart.container).closest('.graphs-box').find('.options a');
  var minutes = options.filter('.active').attr('total');
  if (minutes) $(chart.container).data('cutLimit', parseInt(minutes, 10));
  options.click(function(){
    var limit = $(this).attr('total');
    $.each(['top','bottom'], function(){
      var setId = id+this;
      if (setId in dashboardCharts){
        var options = $(dashboardCharts[setId].container).closest('.graphs-box').find('.options a');
        var a = options.filter('[total="'+limit+'"]');
        if(a.length > 0){
          cutChart(dashboardCharts[setId], parseInt(limit, 10));
          options.removeClass('active');
          a.addClass('active');
        }
      }
    });
  });
}

function drawChartSentimentDay(container, ticker){
	drawChartForDay(container, {data: ['sentiment', 'mp-sentiment', 'moving-average-sentiment', 'mp-moving-average-sentiment'], ticker: ticker}, {
		legend: {
			enabled: true,
			margin: 6,
			y: 0,
			padding: 6,
			borderRadius: 8,
			width: 220,
			itemWidth: 110,
			itemStyle: {
				fontSize: '8px',
				textTransform: 'uppercase'
			}
		},
		exporting:{
	    chartOptions:{
	      title: {
				  text: 'SENTIMENT',
		      align: 'left',
		      x: 12,
		      y: 2,
		      style: {color: '#767575', fontSize: '8px', fontFamily: '"FranklinGothicITCbyBT-Bk"'}
				}
	    }
    },
		series: [{
      name: 'Crowd Sentiment',
      data: [],
      color: '#1A5488'
    },{
      name: 'MP Sentiment',
      data: [],
      color: '#AF4742'
    },{
      name: 'Crowd Moving Avg',
      data: [],
      color: '#88a644'
    },{
      name: 'MP Moving Avg',
      data: [],
      color: '#44a0a6'
    }]
  });
}//drawChartSentimentDay

function drawChartSentimentRealTime(container, ticker){
	drawChartForRealTime(container, {data: ['sentiment', 'mp-sentiment', 'moving-average-sentiment', 'mp-moving-average-sentiment'], ticker: ticker}, {
		legend: {
			enabled: true,
			margin: 6,
			y: 0,
			padding: 6,
			borderRadius: 8,
			width: 220,
			itemWidth: 110,
			itemStyle: {
				fontSize: '8px',
				textTransform: 'uppercase'
			}
		},
		exporting:{
	    chartOptions:{
	      title: {
				  text: 'SENTIMENT',
		      align: 'left',
		      x: 12,
		      y: 2,
		      style: {color: '#767575', fontSize: '8px', fontFamily: '"FranklinGothicITCbyBT-Bk"'}
				}
	    }
    },
		plotOptions: {
      series: {
        marker: {
          enabled: true
        }
      }
    },
		series: [{
      name: 'Crowd Sentiment',
      data: [],
      color: '#1A5488'
    },{
      name: 'MP Sentiment',
      data: [],
      color: '#AF4742'
    },{
      name: 'Crowd Moving Avg',
      data: [],
      color: '#88a644'
    },{
      name: 'MP Moving Avg',
      data: [],
      color: '#44a0a6'
    }]
  });
}//drawChartSentimentRealTime

function drawChartZscoreDay(container, ticker){
	drawChartForDay(container, {data: ['zscore', 'mp-zscore', 'moving-average-zscore', 'mp-moving-average-zscore'], ticker: ticker}, {
		legend: {
			enabled: true,
			margin: 6,
			y: 0,
			padding: 6,
			borderRadius: 8,
			width: 220,
			itemWidth: 110,
			itemStyle: {
				fontSize: '8px',
				textTransform: 'uppercase'
			}
		},
		exporting:{
	    chartOptions:{
	      title: {
				  text: 'SENTIMENT Z-SCORE',
		      align: 'left',
		      x: 12,
		      y: 2,
		      style: {color: '#767575', fontSize: '8px', fontFamily: '"FranklinGothicITCbyBT-Bk"'}
				}
	    }
    },
		series: [{
      name: 'Crowd Z-Score',
      data: [],
      color: '#1A5488'
    },{
      name: 'MP Z-Score',
      data: [],
      color: '#AF4742'
    },{
      name: 'Crowd Moving Avg',
      data: [],
      color: '#88a644'
    },{
      name: 'MP Moving Avg',
      data: [],
      color: '#44a0a6'
    }]
  });
}//drawChartZscoreDay

function drawChartZscoreRealTime(container, ticker){
	drawChartForRealTime(container, {data: ['zscore', 'mp-zscore', 'moving-average-zscore', 'mp-moving-average-zscore'], ticker: ticker}, {
		legend: {
			enabled: true,
			margin: 6,
			y: 0,
			padding: 6,
			borderRadius: 8,
			width: 220,
			itemWidth: 110,
			itemStyle: {
				fontSize: '8px',
				textTransform: 'uppercase'
			}
		},
		exporting:{
	    chartOptions:{
	      title: {
				  text: 'SENTIMENT Z-SCORE',
		      align: 'left',
		      x: 12,
		      y: 2,
		      style: {color: '#767575', fontSize: '8px', fontFamily: '"FranklinGothicITCbyBT-Bk"'}
				}
	    }
    },
		plotOptions: {
      series: {
        marker: {
          enabled: true
        }
      }
    },
		series: [{
      name: 'Crowd Z-Score',
      data: [],
      color: '#1A5488'
    },{
      name: 'MP Z-Score',
      data: [],
      color: '#AF4742'
    },{
      name: 'Crowd Moving Avg',
      data: [],
      color: '#88a644'
    },{
      name: 'MP Moving Avg',
      data: [],
      color: '#44a0a6'
    }]
  });
}//drawChartZscoreRealTime

function drawChartPriceDay(container, ticker){
	var decimals = $(container).closest('.graph-item').attr('data-decimals');
	var options = {
		exporting:{
	    chartOptions:{
	      title: {
				  text: 'PRICE',
		      align: 'left',
		      x: 12,
		      y: 2,
		      style: {color: '#767575', fontSize: '8px', fontFamily: '"FranklinGothicITCbyBT-Bk"'}
				}
	    }
	  }
	};
	if(decimals != ''){
		var options = {
			yAxis: {
	    	labels: {
	        formatter: function(){
	          return this.value.toFixed(decimals);
	        }
	      }
	    },
	    tooltip: {
	    	valueDecimals: decimals
	    }
		};
	}
	drawChartForDay(container, {data: ['price'], ticker: ticker}, options);
}//drawChartPriceDay

function drawChartPriceRealTime(container, ticker){
	var decimals = $(container).closest('.graph-item').attr('data-decimals');
	var options = {
		plotOptions: {
      series: {
        marker: {
          enabled: true
        }
      }
   },
    exporting:{
	    chartOptions:{
	      title: {
				  text: 'PRICE',
		      align: 'left',
		      x: 12,
		      y: 2,
		      style: {color: '#767575', fontSize: '8px', fontFamily: '"FranklinGothicITCbyBT-Bk"'}
				}
	    }
    }
	};
	if(decimals != ''){
		$.extend(options,{
			yAxis: {
	    	labels: {
	        formatter: function(){
	          return this.value.toFixed(decimals);
	        }
	      }
	    },
			tooltip: {
	    	valueDecimals: decimals
	    }
		});
	}
	drawChartForRealTime(container, {data: ['price'], ticker: ticker}, options);
}//drawChartPriceRealTime

function drawChartBuzzDay(container, ticker){
	drawChartForDay(container, {data: ['buzz', 'tweetvolume'], ticker: ticker}, {
		legend: {
			enabled: true,
			margin: 6,
			y: 0,
			padding: 6,
			borderRadius: 8,
			itemStyle: {
				fontSize: '8px',
				textTransform: 'uppercase'
			}
		},
		yAxis: {
    	labels: {
        formatter: function(){
          return this.value.toFixed(1);
        }
      }
    },
		exporting:{
	    chartOptions:{
	      title: {
				  text: 'BUZZ',
		      align: 'left',
		      x: 12,
		      y: 2,
		      style: {color: '#767575', fontSize: '8px', fontFamily: '"FranklinGothicITCbyBT-Bk"'}
				}
	    }
    },
		series: [{
      name: 'BUZZ',
      data: [],
      color: '#1A5488'
    },{
      name: 'Tweet Volume',
      data: [],
      color: '#AF4742'
    }]
  });
}//drawChartBuzzDay

function drawChartBuzzRealTime(container, ticker){
	drawChartForRealTime(container, {data: ['buzz', 'tweetvolume'], ticker: ticker}, {
		legend: {
			enabled: true,
			margin: 6,
			y: 0,
			padding: 6,
			borderRadius: 8,
			itemStyle: {
				fontSize: '8px',
				textTransform: 'uppercase'
			}
		},
		yAxis: {
    	labels: {
        formatter: function(){
          return this.value.toFixed(1);
        }
      }
    },
		exporting:{
	    chartOptions:{
	      title: {
				  text: 'BUZZ',
		      align: 'left',
		      x: 12,
		      y: 2,
		      style: {color: '#767575', fontSize: '8px', fontFamily: '"FranklinGothicITCbyBT-Bk"'}
				}
	    }
    },
		plotOptions: {
      series: {
        marker: {
          enabled: true
        }
      }
    },
		series: [{
      name: 'BUZZ',
      data: [],
      color: '#1A5488'
    },{
      name: 'Tweet Volume',
      data: [],
      color: '#AF4742'
    }]
  });
}//drawChartBuzzRealTime

function drawChartTweetVolumeRealTime(container, ticker){
	drawChartForRealTime(container, {data: ['tweetvolume'], ticker: ticker});
}//drawChartTradingVolumeRealTime

function drawChartTweetVolumeDay(container, ticker){
	drawChartForDay(container, {data: ['tweetvolume'], ticker: ticker});
}//drawChartTradingVolumeDay

function showStockChart(container){
	var charts = {
		sentiment_real_time: drawChartSentimentRealTime,
		sentiment_day: drawChartSentimentDay,
		zscore_real_time: drawChartZscoreRealTime,
		zscore_day: drawChartZscoreDay,
		buzz_real_time: drawChartBuzzRealTime,
		buzz_day: drawChartBuzzDay,
		price_real_time: drawChartPriceRealTime,
		price_day: drawChartPriceDay,
		tweet_volume_real_time: drawChartTweetVolumeRealTime,
		tweet_volume_day: drawChartTweetVolumeDay
	};
	var chart = container.attr('data-chart');
	if(chart && typeof charts[chart] == 'function') charts[chart](container.find('.chart').get(0), container.attr('data-ticker'));
}//showStockChart

var autoResizeGraphsInPopupStatus;
function autoResizeGraphsInPopup(){
	autoResizeGraphsInPopupStatus = true;
	var cols = 0, rows, charts, w, start;
	var boxs = $('div.chart, .graphs-box div.blank');
	rows = $('.graph-items-row').each(function(){
		cols = Math.max(cols, $('.graph-item', this).length);
	}).length;

	boxs.each(function(){
		var container = $(this);
		container.data('size', {width: container.width(), height: container.height()})
	});

	w = $(window);
	start = {width: w.width(), height: w.height()};

	w.resize(function(){
		var dif = {width: (w.width() - start.width) / cols, height: (w.height() - start.height) / rows};
		boxs.each(function(){
			var e = $(this), size = e.data('size'), width = Math.floor(size.width + dif.width), height = Math.floor(size.height + dif.height);
			e.css({width: width, height: height});
			var label = e.closest('.graphs-box').find('.chart-label');
			if (label.length > 0)
			{
  			if (width < 335){
  			  label.hide();
  			}else if(label.is(':hidden')){
  			  label.show();
  			}
			}
		});
	});

}//autoResizeGraphsInPopup

function prepareAutoResizeGraphsInPopupFix(item){
	if(!autoResizeGraphsInPopupStatus) return;

	var fix = {parent: item.parent()};

	fix.parent.find('div.chart').each(function(){
		var div = $(this), size = div.data('size');
		if(size){
			fix.data = size;
			fix.css = {
				width: div.css('width'),
				height: div.css('height')
			};
		}
	});

	return fix;
}//prepareAutoResizeGraphsInPopupFix

function autoResizeGraphsInPopupFix(fix){
	if(!autoResizeGraphsInPopupStatus) return;

	fix.parent.find('div.chart').each(function(){
		var div = $(this);
		if(!div.data('size')) div.data('size', fix.data).css(fix.css);
	});

}//autoResizeGraphsInPopupFix

/*PRINT AND EXPORT CHARTS */
function printCharts(charts) {
  var origDisplay = [],
      origParent = [],
      body = $('body'),
      childNodes = document.body.childNodes;

  // hide all body content
  Highcharts.each(childNodes, function (node, i) {
	  if (node.nodeType === 1) {
	    origDisplay[i] = node.style.display;
	    node.style.display = "none";
	  }
  });

  // put the charts back in
  $.each(charts, function (i, chart) {
		var container = chart.container;
	  origParent[i] = container.parent();
	  container.css({width: container.width(), height: container.height()});
	  body.append(container);
  });

  // print
  window.print();

  // allow the browser to prepare before reverting
  setTimeout(function () {
	  // put the chart back in
    $.each(charts, function (i, chart) {
  		var container = chart.container;
  		container.css({width: '', height: ''});
      origParent[i].append(container);
    });

	  // restore all body content
    Highcharts.each(childNodes, function (node, i) {
        if (node.nodeType === 1) {
            node.style.display = origDisplay[i];
        }
    });
  }, 500);
}//printCharts

Highcharts.getSVG = function(charts) {
  var svgArr = [],
      top = 0,
      width = 0;

  $.each(charts, function(i, item) {
	  var chart = item.chart
	  var svg = chart.getSVG();
	  svg = svg.replace('<svg', '<g transform="translate(0,' + top + ')" ');
	  svg = svg.replace('</svg>', '</g>');

	  top += chart.chartHeight;
	  width = Math.max(width, chart.chartWidth);

	  svgArr.push(svg);
  });

  return '<svg height="'+ top +'" width="' + width + '" version="1.1" xmlns="http://www.w3.org/2000/svg">' + svgArr.join('') + '</svg>';
};

/* FUNCTION WITH LOG */
Highcharts.exportCharts = function(charts, options) {
  var form,
      svg = Highcharts.getSVG(charts);

  // merge the options
  options = Highcharts.merge(Highcharts.getOptions().exporting, options);

  // create the form
  form = Highcharts.createElement('form', {
      method: 'post',
      action: options.url
  }, {
      display: 'none'
  }, document.body);

  // add the values
  Highcharts.each(['filename', 'type', 'width', 'svg'], function(name) {
      Highcharts.createElement('input', {
          type: 'hidden',
          name: name,
          value: {
              filename: options.filename || 'chart',
              type: options.type,
              width: options.width,
              svg: svg
          }[name]
      }, null, form);
  });
  //console.log(svg); return;
  // submit
  form.submit();
  options.svg = svg;
  delete options.buttons;
	$.post('/exporting_log/', $.param(options));
  // clean up
  form.parentNode.removeChild(form);

};

/* ORIGINAL FUNCTION
Highcharts.exportCharts = function(charts, options) {
  var form,
      svg = Highcharts.getSVG(charts);

  // merge the options
  options = Highcharts.merge(Highcharts.getOptions().exporting, options);
  // create the form
  form = Highcharts.createElement('form', {
      method: 'post',
      action: options.url
  }, {
      display: 'none'
  }, document.body);

  // add the values
  Highcharts.each(['filename', 'type', 'width', 'svg'], function(name) {
      Highcharts.createElement('input', {
          type: 'hidden',
          name: name,
          value: {
              filename: options.filename || 'chart',
              type: options.type,
              width: options.width,
              svg: svg
          }[name]
      }, null, form);
  });
  //console.log(svg); return;
  // submit
  form.submit();

  // clean up
  form.parentNode.removeChild(form);
};
*/

function exportCharts(charts, options) {
  Highcharts.exportCharts(charts, options);
}//exportCharts
/* END PRINT AND EXPORT CHARTS */

$(function(){
	var tickers = $('.stock'), interval = 60000;
	if(!tickers.length) return;

	function update(){
		updateTimeout();
		var SymbolsArr = [];
		$(tickers).each(function(){
			SymbolsArr.push($(this).attr('data-ticker'));
		});
		var symbols = SymbolsArr.join(',');
		var viewMode = $('.dashboard-view-mode').attr('data-view-mode');
		$.get('/ajax/get/dashboard-data/?tickers='+encodeURIComponent(symbols),{view_mode : viewMode}, function(response){

			$('#dashboard-nowtime').html('Last Updated: '+response.time);
			if(!response.items) return;

			$(response.items).each(function(){
				var item = this;
				var dataTicker = item.ticker;
				var dataTickerBox = $('[data-ticker="'+dataTicker+'"].stock');
				item.price = item.price;//parseFloat(item.price);//.toFixed(2);
				$('.price', dataTickerBox).html('<p>'+item.price+'</p>');
				item.percent_change = parseFloat(item.percent_change).toFixed(2);
			  $('.price-change', dataTickerBox).html('<em class="' + (item.percent_change < 0 ? 'down' : item.percent_change > 0 ? 'up' : 'simple') + '">'+item.percent_change+'%</em>');
				item.sentiment = parseFloat(item.sentiment).toFixed(6);
				$('.sentiment', dataTickerBox).html('<em class="' + (item.sentiment < 0 ? 'down' : item.sentiment > 0 ? 'up' : 'simple') + '">'+item.sentiment+'</em>');
				item.buzz = parseFloat(item.buzz).toFixed(2);
				$('.buzz', dataTickerBox).html('<em class="' + (item.buzz < 1 ? 'down' : item.buzz > 1 ? 'up' : 'simple') + '">'+item.buzz+'</em>');
			});

		}, 'json');

	}

	var timeout = null;
	function updateTimeout(){
		if(timeout) clearTimeout(timeout);
		timeout = setTimeout(update, interval);
	}
  updateFunctions.push(function(){
  	$('.dashboard-view-mode').text('Currently Displaying: '+(VIEW_MODE == 'MP' ? 'Market Prophits' : 'Crowd'));
  	update();
  });
  updateTimeout();

});


function updateDashboardFundamentals(ticker){
	if(!ticker) return;
	var interval = 60000;
	var container = $('.company-fundamentals[data-ticker="'+ticker+'"]');
	if(!container.length) return;

	function update(){
		timeout();
		$.get('/ajax/get/stock-fundamentals/?ticker='+ticker, function(response){
			if(!response) return;
			var content = '';
			content += '<tr>';
			content += '<td class="h4">Prev Close:</td><td class="p">'+response.PreviousClose+'</td>';
			content += '<td class="h4">Day’s Range:</td><td class="p">'+response.Low+'-'+response.High+'</td>';
			content += '</tr>';
			content += '<tr>';
			content += '<td class="h4">Open:</td><td class="p">'+response.Open+'</td>';
			content += '<td class="h4">52wk Range:</td><td class="p">'+response.OneYearLow+'-'+response.OneYearHigh+'</td>';
			content += '</tr>';
			content += '<tr>';
			content += '<td class="h4">Ex Dividend Date:</td><td class="p">'+response.LastDividendExDate+'</td>';
			content += '<td class="h4">Volume:</td><td class="p">'+response.Volume+'</td>';
			content += '</tr>';
			content += '<tr>';
			content += '<td class="h4">Dividend Per Share:</td><td class="p">'+response.LatestFiscalDividendsPerShare+'</td>';
			content += '<td class="h4">Avg Vol (3m):</td><td class="p">n/a</td>';
			content += '</tr>';
			content += '<tr>';
			content += '<td class="h4">1y Target Est:</td><td class="p">n/a</td>';
			content += '<td class="h4">Market Cap:</td><td class="p">'+(response.MarketCap ? response.MarketCap : '')+'</td>';
			content += '</tr>';
			content += '<tr>';
			content += '<td class="h4">Beta:</td><td class="p">'+response.Beta+'</td>';
			content += '<td class="h4">P/E (ttm):</td><td class="p">'+response.PERatio+'</td>';
			content += '</tr>';
			content += '<tr>';
			content += '<td class="h4">Next Earnings Date:</td><td class="p">n/a</td>';
			content += '<td class="h4">EPS (ttm):</td><td class="p">'+response.LatestFiscalEPS+'</td>';
			content += '</tr>';
			content += '<tr>';
			content += '<td class="h4">&nbsp;</td><td class="p">&nbsp;</td>';
			content += '<td class="h4">Div&amp;Yield:</td><td class="p">'+response.LastDividendYield+'</td>';
			content += '</tr>';
			container.html(content);
		}, 'json');
	}
	
	function timeout(){
		setTimeout(update, interval);
	}
	
  update();
}

function openDashboardTab()
{
   var url = window.location.href;
   var tabName = getURLParameter(url, 'tab');
   var ticker = getURLParameter(url, 'ticker');
   var link;
   if (tabName != 'null' && ticker != 'null')
   {
    switch(tabName)
    {
      case 'alerts':
      link = $('[data-ticker='+ticker+'].stock').find('#alerts.icon');
      if (link.length > 0) showStockData(link);
      default:
        return false;
    }
   }
   return false;
}
