$(function(){
	
	var info = {
    t1: [{type: 1, title: 'Price', file: 'ticks_SPY', container: "container1"},
         {type: 2, title: 'Sentiment', file: 'sentiment_SPY', container: "container4"}],
    t2: [{type: 1, title: 'Price', file: 'ticks_DIA', container: "container2"},
         {type: 2, title: 'Sentiment', file: 'sentiment_DIA', container: "container5"}],
    t3: [{type: 1, title: 'Price', file: 'ticks_QQQ', container: "container3"},
         {type: 2, title: 'Sentiment', file: 'sentiment_QQQ', container: "container6"}]
	};
	
	var stopRefresh = false;

	function getOptions(){return {
    credits: false,
    chart: {zoomType: 'x', spacingRight: 30, borderWidth: 1, borderRadius: 0, marginLeft: 55},
    title: {text: ''},
    subtitle: {
      text: document.ontouchstart === undefined ?
          'Click and drag in the plot area to zoom in' :
          'Drag your finger over the plot to zoom in'
    },
    xAxis: {
      type: 'datetime',
      offset: 5,
      maxZoom: 900000, // 15 min
      title: {text: null},
      gridLineWidth: 1,
      dateTimeLabelFormats: {
				minute: '%I:%M%p', hour: '%I:%M%p'
			},
			tickInterval: 1800000, // 30 min
			maxPadding: 0,
			minPadding: 0
    },
    yAxis: {
      title: {text: null}, 
      lineWidth: 1
    },
    tooltip: {
    	shared: true,
    	dateTimeLabelFormats: {
				minute: '%A, %b %e, %I:%M%p',
				hour: '%A, %b %e, %I:%M%p'
			}
		},
    legend: {enabled: false},
    exporting: {
    	url: '/highcharts-server/'
    },
    plotOptions: {
      area: {
        fillOpacity : 0.15,
        lineWidth: 1,
        marker: {enabled: false, states: {hover: {enabled: true, radius: 5}}},
        shadow: false,
        states: {hover: {lineWidth: 1}},
        threshold: null
      }
    }
  }};//getOptions
  
  function chartZoom(chart, min, max){
  	stopRefresh = true;
  	var container = $(chart.container);
  	if(!container.data('extremes')) container.data('extremes', chart.xAxis[0].getExtremes());
  	chart.xAxis[0].setExtremes(min, max);
  	if(typeof chart.resetZoomButton != 'undefined') chart.resetZoomButton.show();
  }//chartZoom
  
  function chartResetZoom(chart){
  	stopRefresh = false;
  	var container = $(chart.container);
  	var extremes = container.data('extremes');
  	if(extremes){
  		container.data('extremes', null);
  		chart.xAxis[0].setExtremes(extremes.min, extremes.max);
  		if(typeof chart.resetZoomButton != 'undefined') chart.resetZoomButton.hide();
  	}
  }//chartResetZoom
    
	function displayCharts($info){
	  $.each($info, function(i, item){
	  	var file = (item.type == 2 && VIEW_MODE == 'MP') ? item.file+'_MP' : item.file;
	    $.get("/data/"+file+".tsv", function(data){
	      if(!data) return;
        var seriesData = [], extremes = null, lastDate = null;
        $.each(data.split(/\n/g), function(i, line){
	        var date, price, t;
          line = line.split(/,/g);
          if(isNaN(line)){
            t = line[0].split(/[- :]/);
            date = (new Date(t[0], t[1]-1, t[2], t[3], t[4], t[5])).getTime();
            price = parseFloat(line[1]);
            if(!extremes){
            	extremes = {min: new Date(date), max: new Date(date)};
            	extremes.min.setHours(9);
            	extremes.min.setMinutes(30);
            	extremes.min.setSeconds(0);
            	extremes.min.setMilliseconds(0);
            	extremes.min = extremes.min.getTime();
            	extremes.max.setHours(16);
            	extremes.max.setMinutes(0);
            	extremes.max.setSeconds(0);
            	extremes.max.setMilliseconds(0);
            	extremes.max = extremes.max.getTime();
            }
            if($.type(date) === "number" && $.type(price) === 'number'){
              seriesData.push([date,price]);
              lastDate = date;
            }
          }
        });//$.each(data)
        
        var container = $('#'+item.container), chart;
        container.data('latestUpdate', new Date());
        var chart = container.data('chart');
        if(chart){
        	chart.series[0].setData(seriesData);
        }else{
	        var options = $.extend(true, getOptions(), {
	        	title: {text: item.title},
	        	series: [{type: 'area', name: 'Value', color: '#1A5488', data: seriesData}],
	        	tooltip: {valueDecimals: (item.type == 2) ? 3 : 2},
	        	xAxis: extremes,
	        	yAxis: {
	        		min: (item.type == 2) ? -1 : null,
			        max: (item.type == 2) ? 1 : null,
			        labels: {formatter: function() { return this.value.toFixed(((item.type == 2) ? 3 : 2)); }}
	        	}
	        });
	        options.chart.renderTo = item.container;
	        options.chart.events = {
      			selection: function(event){
      				$.each($info, function(){
      					var c = $('#'+this.container).data('chart');
      					if(event.xAxis) chartZoom(c, event.xAxis[0].min, event.xAxis[0].max);
	      				else{
	      					event.preventDefault();
	      					chartResetZoom(c);
	      				}
      				});
      			}
	      	};
	      	chart = new Highcharts.Chart(options);
	        container.data('chart', chart);
	      }
	      if(lastDate){
	        lastDate = new Date(lastDate);
	        var day = lastDate.getDate();
	        var months = new Array('January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December');
          var month = months[lastDate.getMonth()];
          var year = lastDate.getFullYear();
          container.find('div.date').remove();
	        container.append('<div class="date">'+month+" "+day+", "+year+'</div>');
	      }  
	    });//$.get()
	  });//$.each($info)
	  return true;
	}//displayCharts
	
	var timeout, delay = 60000;
			
	isDST = function(date){
		if(!date) date = new Date();
		return date.getTimezoneOffset() < Math.max((new Date(date.getFullYear(), 0, 1)).getTimezoneOffset(), (new Date(date.getFullYear(), 6, 1)).getTimezoneOffset());
	}//isDST
	
	function isValidTimeFrame($info){
		var item = $info[0];
		
		var utcOffset = isDST() ? -4 : -5;
		
    var min = new Date();
    min.setUTCHours(9 - utcOffset);
		min.setUTCMinutes(30);
		min.setUTCSeconds(0);
		min.setUTCMilliseconds(0);
		min = min.getTime() - delay;
		
		var max = new Date();
    max.setUTCHours(16 - utcOffset);
		max.setUTCMinutes(0);
		max.setUTCSeconds(0);
		max.setUTCMilliseconds(0);
		max = max.getTime() + delay;
		
		var container = $('#'+item.container);
    var latestUpdate = container.data('latestUpdate');
    if(!latestUpdate) return true;
    
    if(min <= latestUpdate && latestUpdate <= max) return true;
		
    var date = (new Date()).getTime();
		if(min <= date && date <= max) return true;
    
		return false;
	}//isValidTimeFrame
	
	function updateCharts(){
		if(stopRefresh) return true;
		var activeTab = $('#menu-tabs li.active').attr('class').split(' ');
		var items = info[activeTab[0]];
		if(isValidTimeFrame(items)) displayCharts(items);
		return true;
	}//updateCharts
	
	Highcharts.setOptions({global: {useUTC: false}});
  
  $('#menu-tabs li').click(function(){
    $('#menu-tabs-content div.tab-content').hide();
    $('#menu-tabs li').removeClass('active');
    $(this).addClass('active');
    $('#menu-tabs-content div.' + this.className.slice(0,2)).fadeIn(500, function(){stopRefresh = false;updateCharts()});
    return false;
  }).filter('.t1').click();
  
  function update(){
    if(timeout){
      clearTimeout(timeout);
      timeout = null;
    }
    updateCharts();
    timeout = setTimeout(update, delay);
  }
  timeout = setTimeout(update, delay);
  updateFunctions.push(function(){
  	$.each(info, function(index, items){
  		$.each(items, function(i, item){
  			var container = $('#'+item.container);
  			var chart = container.data('chart');
  			container.data('latestUpdate', null);
  			if(chart){
  				chart.series[0].setData([]);
  			}
  		})
  	});
  	update();
  });
});