var StylizedMultiSelect = function(e){
	var This = this;
	This.target = $(e);
	if(This.target.data('stylized')) return;
	This.target.data('stylized', This);
	This.options = $('option', This.target);
	This.elements = {
		select: $('<div class="multiselect"></div>'),
		options: $('<div class="options"></div>')
	};
	
	This.onchange = function(event){
		This.target.change();
	};
	
	This.target.css({position: 'absolute', visibility: 'hidden', left: 0, top: 0});
	This.elements.select.addClass(This.target.attr('class')).append(This.elements.options);
	var i, newOption, option, t;
	for(i = 0; i < This.options.length; i++){
		option = This.options.eq(i);
		newOption = $('<div class="option'+(option.attr('selected') ? ' selected' : '')+'"></div>').data('index', i).click(This.optionclick);
		t = option.text();
		if(t) newOption.text(t);
		else newOption.html('&nbsp;');
		This.elements.options.append(newOption);
	}
	
	var options = $('.option', This.elements.options);
	options.click(function(e){
		var index = $(e.target).data('index');
		var option = $(this);
		
		if(e.ctrlKey && option.is('.selected')){
			option.removeClass('selected');
			This.options.eq(index).removeAttr('selected');
			return This.onchange();
		}
		
		if(!e.ctrlKey){
			options.removeClass('selected');
			This.options.removeAttr('selected');
		}
		
		option.addClass('selected');
		This.options.eq(index).attr('selected', 'selected');
		This.onchange();
	});
	if(options.disableTextSelect) options.disableTextSelect();
	
	
	
	This.target.before(This.elements.select);
	//var width = parseInt(This.target.css('width'))+parseInt(This.elements.select.css('padding-left'))+parseInt(This.elements.select.css('padding-right'));
	var width = parseInt(This.target.css('width'));
	This.elements.select.css('width', width);
	
	var size = parseInt(This.target.attr('size') || 1);
	This.elements.options.css('height', size * parseInt($('.option', This.elements.options).css('height')));
	
}//StylizedMultiSelect

var StylizedSelect = function(e){
	var This = this;
	This.target = $(e);
	if(This.target.is('[multiple=multiple]')) return new StylizedMultiSelect(e);
	if(This.target.data('stylized')) return;
	This.target.data('stylized', This);
	This.options = $('option', This.target);
	This.elements = {
		select: $('<div class="select"></div>'),
		value: $('<div class="value"></div>'),
		options: $('<div class="options"></div>')
	};
	
	This.opened = false;
	This.open = function(){
		This.elements.select.addClass('focus');
		$('div.select').css('z-index', 0);
		This.elements.select.css('z-index', 1);
		$('select').each(function(i,e){e=$(e);
			var s = e.data('stylized');
			if(s && s.opened) s.close();
		});
		$('.option', This.elements.options)
			.removeClass('selected')
			.eq(This.selectedIndex()).addClass('selected');
		This.opened = true;
		This.elements.options.show();
		var maxH = 135;//$(window).height()/3;
		if(This.elements.options.outerHeight() > maxH) This.elements.options.css({height: maxH, overflowY: 'scroll'});
		else This.elements.options.css({height: 'auto', overflowY: 'auto'});
	};
	This.close = function(){
		This.elements.select.removeClass('focus');
		This.opened = false;
		This.elements.options.hide();
		This.elements.options.css({height: 'auto', overflowY: 'auto'});
	};
	This.selectclick = function(){
		if(!This.target.attr('disabled')){
			if(This.opened) This.close();
			else This.open();
		}
		return false;
	};
	
	This.selectedIndex = function(){
		return This.target.get(0).selectedIndex;
	};
	This.optionclick = function(event){
		if ($(event.target).data('disabled')) return;
		var change = $(event.target).data('index') != This.selectedIndex();
		This.options.eq($(event.target).data('index')).attr('selected', 'selected');
		This.text();
		if(change) This.onchange();
	};
	This.optionmouseover = function(event){
		$('.option', This.elements.options).removeClass('selected');
		$(event.target).addClass('selected');
	};
	This.onchange = function(event){
		//if(typeof This.target.get(0).onchange == 'function'){
			//This.target.get(0).onchange(This);
		//}
		This.target.change();
	};
	This.value = function(){
		return This.target.val();
	};
	This.text = function(){
		This.elements.value.text(This.options.eq(This.selectedIndex()).text());
	};
	This.target.css({position: 'absolute', visibility: 'hidden', left: 0, top: 0});
	This.elements.select.addClass(This.target.attr('class'))
		.append(This.elements.value, This.elements.options)
		.click(This.selectclick);
	$(document).click(This.close);
	var i, newOption, option, t;
	for(i = 0; i < This.options.length; i++){
		option = This.options.eq(i);
		newOption = $('<div class="option"></div>')
			.text(option.text() || '')
			.data('index', i)
			.data('disabled', option.attr('disabled') == 'disabled' ? true : false)
			.click(This.optionclick)
			.mouseover(This.optionmouseover);
		t = option.text();
		if(t) newOption.text(option.text());
		else newOption.html('&nbsp;');
		This.elements.options.append(newOption);
	}
	var minW = $('<div class="c"></div>');
	This.elements.options.append(minW);
	This.text();
	This.target.before(This.elements.select);
	//var width = parseInt(This.target.css('width'))+parseInt(This.elements.select.css('padding-left'))+parseInt(This.elements.select.css('padding-right'));
	//var width = parseInt(This.target.css('width'));
	var width = This.target.outerWidth();
	//var width = 112;
	This.elements.select.css('width', width);
	//This.elements.value.css('width', width);
	minW.css('width', parseInt(This.elements.select.css('width'))+parseInt(This.elements.select.css('padding-left'))+parseInt(This.elements.select.css('padding-right')));
	if(This.elements.select.length > 1) This.elements.select.each(function(i){$(this).css('z-index', This.elements.select.length-i);});
}//StylizedSelect

function StylizeSelects(){
	$('select:visible').each(function(){
		if(!$(this).is('.skip_stylize')) new StylizedSelect(this);
	});
}
$(StylizeSelects);