$(function(){
	$('[tweets-username]').each(function(){
		loadTweets(this);
	});
	$('.select').click(function(){
    var options = $('.options', this);
    options.css({height: 'auto', overflowY: 'auto'});
    var jsp = options.data('jsp');
    if(jsp) jsp.reinitialise();
    else options.jScrollPane({contentWidth: '0px'});
    options.addClass('scrolling');
  });
});

/* Users Alert*/

function openCreateUsersAlertWindow(params){
	if(notLoginRedirect()) return false;
	params = params || {};
	params = $.extend(params,{action:'add'});
  var url = '/ajax/users/create-alert/';
	openAjaxWindow(url,params);
}//openCreateTopUsersAlertWindow

function openEditUsersAlertWindow(params){
	params = params || {};
	$.extend( params,{action:'edit'});
  var url = '/ajax/users/create-alert/';
	openAjaxWindow(url,params);
}//openEditTopUsersAlertWindow
var openDeleteUsersAlertCallback;
function openDeleteUsersAlertWindow(rel, callback)
{
	//callback = callback || false;
	openDeleteUsersAlertCallback = callback;
  var alert = $(rel).closest('[data-alert]');
  var itemID = alert.attr('data-alert');
  var html ='<h3>DELETE ALERT</h3>';
  html +='<p>Are you sure you want to delete this alert?</p>';
  html +='<a href="javascript:void(0);" onclick="deleteUsersAlert(\''+itemID+'\');">OK</a>';
  html +='<a href="javascript:void(0);" onclick="closeDeleteUsersAlertWindow();">CANCEL</a>';
  showMessageCustom(html);
  return false;
}
function closeDeleteUsersAlertWindow(){
	hidePopup();
  if (typeof openDeleteUsersAlertCallback === 'function'){
  	openDeleteUsersAlertCallback();
  	openDeleteUsersAlertCallback = false;
  }
}
function editUsersAlert(frm)
{
  var frm = $(frm);
  var data = frm.serialize();
  data += '&action=edit';
  $.ajax({
      type: "POST",
      data: data,
      url: '/ajax/users/create-alert/',
      dataType: 'json',
      success: function(data){
        if(data.hasError == false){
        	var id = frm.find('input[name="alert_id"]').attr('value');
        	if (typeof id !== "undefined"){
	          var row = $('[data-alert="'+id+'"]').closest('[data-username]');
			      if (row.length > 0) {
			      	if (row.find('#alerts-box-edit').length > 0){
			      		getRowDataItems('alerts', row);
			      	}else{
			      		hidePopup();
			      		location.reload();
			      	}
			      }else{
			      	row = $('[data-alert="'+id+'"]').closest('[data-stock]');
			      	if (row.length > 0){
				      	if (row.find('.alert-tab').length > 0){
				      		itemID  = row.attr('data-stock');
			        		itemType = 'alerts';
			        		stockData = row;
				      		getStockDataItems();
				      	}else{
				      		hidePopup();
				      		location.reload();
				      	}
				      }
			      }
		      }
          hidePopup();
        }else{
          showErrorMessage(data.status);
        }
      }
    });
  return false;
}
function deleteUsersAlert(id)
{
  var item = $('[data-alert="'+id+'"]');
  $.ajax({
      type: "POST",
      data: {action: "delete", alert_id: id},
      url: '/ajax/users/create-alert/',
      dataType: 'json',
      success: function(data){
        if(data.hasError == false){
        	if(item.closest('[data-username]').length > 0){
        		var row = item.closest('[data-username]');
        		if(row.find('#alerts-box-edit').length > 0){
			      	getRowDataItems('alerts', row);
			      }else{
			      	hidePopup();
			      	location.reload();
		      	}
		      }else if(item.closest('[data-stock]').length > 0){
		      	stockData = item.closest('[data-stock]');
		      	if(stockData.find('.alert-tab').length > 0){
		      		openBox(
		      			'#top-user-alerts-box',
		      			"/ajax/dashboard/top-alerts-box/?stock_id=" + stockData.attr('data-stock') + '&edit=1&type=top-user'
		      		);
	        		openBox(
	        			'#top-mp-alerts-box',
	        			"/ajax/dashboard/top-alerts-box/?stock_id=" + stockData.attr('data-stock') + '&edit=1&type=top-mp'
	        		);
        		}else{
        			hidePopup();
			      	location.reload();
        		}
        	}else{
		    		var body = item.closest('.scrolling');
	          item.remove();
	          var jsp = body.data('jsp');
			    	if(jsp) jsp.reinitialise();
			    	else body.jScrollPane();
		    	}
        }else{
          showErrorMessage(data.status);
        }
        closeDeleteUsersAlertWindow();
      }
    });
  return false;
}

function validateUsersAlert(frm){
	return validateAlertFrom(frm);
}

function saveNewUsersAlert(frm, data, message)
{
	var frm = $(frm); 
	data += '&action=add';
	message = message || 'Your alert has been created.';
	$.ajax({
    type: "POST",
    data: data,
    url: '/ajax/users/create-alert/',
    dataType: 'json',
    success: function(data){
      if(data.hasError) return showErrorMessage(data.status);
      var row = frm.closest('[data-username]');
      if (row.length > 0){
      	if (row.find('#alerts-box-edit').length > 0){
      		getRowDataItems('alerts', row);
      	}else{
      		hidePopup();
      		location.reload();
      	}
      }else{
      	row = frm.closest('[data-stock]');
      	if (row.length > 0){
	      	if (row.find('.alert-tab').length > 0){
	      		itemID  = row.attr('data-stock');
        		itemType = 'alerts';
        		stockData = row;
	      		getStockDataItems();
	      	}else{
	      		hidePopup();
	      		location.reload();
	      	}
	      }
      }
      showMessage(message);
    }
  });
  return false;
}

function openPredictionUsersAlertWindow(frm){
	var frm = $(frm);
	if(!validateUsersAlert(frm)) return showErrorMessage('Value is not valid for this variable.');
	var data = frm.serialize();
	var ticker = frm.find('[name=ticker]').val();
	var power = frm.find('[name=power]').is(':checked');
	if (typeof ticker !== "undefined" && ticker !== '2' && ticker !== '1' && !power){
		openUsersPredictionWindow({
			ticker: ticker,
			source: 1,
			timeframe_id: frm.find('select[name=timeframe_id]').val()
		}, function(predictionId){
		  data += '&prediction_id='+predictionId;
			saveNewUsersAlert(frm, data, 'Thank you for your prediction.');
		});
	}else{
		saveNewUsersAlert(frm, data);
	}
}//openPredictionUsersAlertWindow

var saveUsersPredictionCallback;
function openUsersPredictionWindow(options, callback){
	saveUsersPredictionCallback = callback;
  var url = '/ajax/users/prediction-alerts/';
  openAjaxWindow(url,options);
}//openUsersPredictionWindow

function saveUsersPrediction(frm){
	var frm = $(frm || '.prediction #prediction-form');
  var require = frm.find('.box.require');
  if(require.length != require.find('input[type=radio]:checked').length){
    return showErrorMessage('Please make the prediction for the timeframe you set for the alert');
  }
  $.ajax({
    type: "POST",
    data: frm.serialize(),
    url: '/ajax/users/prediction-alerts/',
    dataType: 'json',
    success: function(data){
      if (data.hasError) return showErrorMessage(data.status);
      hidePopup();
      if(saveUsersPredictionCallback) saveUsersPredictionCallback(data.id);
    }
  });
}//saveUsersPrediction

/* END Users Alert */

function addMarketUser(username, reload){
	if(notLoginRedirect()) return false;
	reload = reload || false;
	var params = {action: 'add_user', username: username};
	$.post('/ajax/users/add/', params, function(data){
		if (!data.hasError && reload == true){
	    location.reload();
	    return false;
	  }
	  if(data.hasError){
	  	showErrorMessage(data.status)
	  }else{
	  	showMessage(data.status);
	  }
	}, 'json');
}

function deleteMarketUser(username, reload)
{
	reload = reload || false;
  var params = {action: 'delete_user', username: username};
  $.post('/ajax/users/add/', params, function(data){
		if (!data.hasError && reload == true){
	    location.reload();
	    return false;
	  }
	  if(data.hasError){
	  	showErrorMessage(data.status)
	  }else{
	  	showMessage(data.status);
	  }
	}, 'json');
  return false;
}

function usersChartWrapper(container){
	this.container = $(container);
}//usersChartWrapper
usersChartWrapper.prototype = {
	container: null,
	chart: null,
	limit: null,
	draw: function(options){
		Highcharts.setOptions({global: {useUTC: false}});
	  this.chart = new Highcharts.Chart($.extend(true, getDefaultChartOptions(), options || {}, {
	  	chart: {
	  		renderTo: this.container.get(0),
	  		events: {
	  			selection: function(event){
	  				if(event.xAxis) chartZoom(this, event.xAxis[0].min, event.xAxis[0].max);
	  				else{
	  					event.preventDefault();
	  					chartResetZoom(this);
	  				}
    			}
	  		}
	  	}
	  }));
	  showChartLegend(this.chart);
	},//draw
	setData: function(data, index){
		setChartData(this.chart, data, index);
		this.setExtremes();
	},
	removeData: function(){
		removeChartData(this.chart);
	},
	cut: function(minutes){
		this.limit = minutes;
		cutChart(this.chart, this.limit);
	},
	setExtremes: function(){
		var timeframe = $(this.chart.container).data('timeframe');
	  if(timeframe){
	    this.chart.xAxis[0].setExtremes(timeframe[0], timeframe[1]);
	  }
	}
};

function drawUsersChart(ch, parameters){
	$.get('/ajax/users/chart/', parameters, function(response){
		$.each(parameters.data, function(i){
			ch.setData(response[this], i);
		})
	}, 'json');
	return true;
}

/* Chart 
*/
function drawUsersDashboardChart(This){
	var container = $(This);
	var username = container.attr('data-chart-username');
	var subtitle = container.attr('data-chart-subtitle');
	var options = {
		title:false,
		chart:{
			marginLeft: 75,
  		marginRight: 75,
			marginTop: 35,
			marginBottom: 55
		},
		exporting:{
	    chartOptions:{
	      title: {
				  text: 'MP SCORE AND RANK'
				  	+(subtitle ? ' '+subtitle : '')
				  	+(username ? ' @'+username : ''),
		      align: 'left',
		      x: 12,
		      y: 6,
		      style: {color: '#595959', fontSize: '9px', fontFamily: '"FranklinGothicITCbyBT-Bk"'}
				}
	    }
  	}
	};
	drawUsersDetailsChart(This, options)
}

function drawUsersDetailsChart(container, options){
	var container = $(container);
	var intervals = container.parent().find('.options a');
	if(!intervals.length) return;
	var username = container.attr('data-chart-username');
	options = $.extend({
  	chart: {
  		marginLeft: 75,
  		marginRight: 75,
  		marginTop: 55,
  		marginBottom: 55
		},
		title: {
		  text: 'MP SCORE AND RANK',
      align: 'left',
      x: 12,
      y: 6,
      style: {color: '#595959', fontSize: '14px', fontFamily: '"FranklinGothicITCbyBT-Bk"'}
		},
		exporting:{
	    chartOptions:{
	      title: {
				  text: 'MP SCORE AND RANK'+(username ? ' @'+username : ''),
		      align: 'left',
		      x: 12,
		      y: 6,
		      style: {color: '#595959', fontSize: '14px', fontFamily: '"FranklinGothicITCbyBT-Bk"'}
				}
	    }
  	},
    xAxis: {
    	minTickInterval: 86400000, // 1 day
    },
    yAxis: [{
    	title:{
	      text: 'MP Score',
	      style: {color: '#2e7dd7'}
      },
    	labels: {
        formatter: function(){
          return Highcharts.numberFormat(this.value, 2);
        }
      },
      plotLines: [{
        value: 0,
        width: 1,
        color: '#808080'
      }]
    },{
    	title:{
	      text: 'MP Rank',
	      style: {color: '#8abb20'}
      },
      min: 0,
      opposite: true,
      reversed: true,
    	labels: {
        formatter: function(){
          return Highcharts.numberFormat(this.value, 0);
        }
      },
      plotLines: [{
        value: 0,
        width: 1,
        color: '#808080'
      }]
    }],
		plotOptions: {
    	series: {
    		marker: {
	      	enabled: true,
	      	symbol: null,
	      	radius: 4
	     },
				events: {
	        legendItemClick: function(event){
	        	var yAxis = event.target.chart.yAxis;
	        	if (this.visible){
	        		this.hide();
	        	}else{
	        		this.show();
	        	}
	        	$.each(yAxis, function(){
	        		if (this.hasVisibleSeries){
		        		this.axisTitle.show();
		        	}else{
		        		this.axisTitle.hide();
	        		}
	        	});
	        	return false;
					}
	      }
			}
    },
    tooltip: {
    	xDateFormat: '%A, %b %e, %Y'
    },
   	legend: {
			enabled: true,
			margin: 2,
			padding: 8,
			borderRadius: 10,
			itemStyle: {
				fontSize: '10px'
			}
		},
		navigation: {
      buttonOptions: {
      	y: 5
      }
    },
		series: [{
      name: 'MP Score',
      data: [],
      color: '#2e7dd7',
      lineWidth: 2
    },{
      name: 'MP Rank',
      data: [],
      yAxis: 1,
      color: '#8abb20',
      lineWidth: 2,
      tooltip: {
      	valueDecimals: 0
      }
    }]
  },options || {});
	var ch = new usersChartWrapper(container);
	ch.draw(options);
	
	var params = {username: username, data: ['user-score', 'user-rank']};
  intervals.click(function(){
  	intervals.removeClass('active');
  	$(this).addClass('active');
  	var interval = $(this).attr('data-interval');
  	if (typeof interval != 'undefined'){
  		ch.removeData();
  		drawUsersChart(ch, $.extend(params,{interval: interval}));
  	}
  });
  intervals.first().click();
}
/*
 * END Chart
 */