$(function(){
	$('.dashboard .top-menu .view select').change(function(){
  	var url = document.URL;
  	var name = $(this).attr('name');
  	var value = $(this).val();
		var queryParameters = getUrlParts(url);
  	queryParameters[name] = value;
  	queryParameters['page'] = 1;
  	location.search = $.param(queryParameters);
	});
 
	$('.dtbl-header .dtbl-col a').click(function(){
		var url = document.URL;
   	var queryParameters = getUrlParts(url);
   	var orderType = $(this).hasClass('asc') ? 'desc' : 'asc'
   	var orderName = $(this).closest('.dtbl-col').attr('data-sort');
   	queryParameters['sort'] = orderName;
   	queryParameters['order'] = orderType;
   	queryParameters['page'] = 1;
   	location.search = $.param(queryParameters);
	});
 
	$('.dtbl-item .dtbl-tab.remove').click(function(){
		var row = $(this).closest('.dtbl-item');
		var itemID = row.attr('data-username');
		var name = row.find('.dtbl-col.col-0 a').text().replace('@', '');
		var html = '<h3>DELETE @'+$.trim(name)+'</h3>';
		html += '<div class="line"></div>';
		html += '<p>Are you sure you want to delete this user?</p>';
		html += '<a href="javascript:void(0);" onclick="deleteMarketUser(\''+itemID+'\',true);">OK</a>';
		html += '<a href="javascript:void(0);" onclick="hidePopup();">CANCEL</a>';
		showMessageCustom(html);
		return false
	});
});


/* OPEN BOX */
$(function(){
	$('.dtbl-item .dtbl-tab:not(.remove)').click(function(){
		var item = $(this);
		var row = $(this).closest('.dtbl-item');
		var isActive = item.hasClass('active');
		if(row.hasClass('pending')) return false;
		if(isActive){
	    item.removeClass('active');
	    row.find('.dtbl-content').slideUp('slow',function(){
	    	$(this).html('');
	    	row.removeClass('opened');
	    });
	  }else{
	    row.find('.dtbl-tab.active').removeClass('active');
	    item.addClass('active');
	    row.addClass('opened');
	    getRowData(item.attr('data-type'),row);
	  }
		return false;
	});
});

function getRowData(itemType, row){
	var row =$(row);
	var username = row.attr('data-username');
  var url , params = {username: username};
  switch(itemType){
    case 'summary':
      url = '/ajax/users/dashboard/summary-info/';
      break;
    case 'alerts':
      url = '/ajax/users/dashboard/alerts-info/';
      break;
    default:
      return false;
  }
  $.get(url,params,function(data){
  	if (data){
  		row.find('.dtbl-content').html(data).slideDown('slow');
  	}
  });
  return true;
}

function getRowDataItems(itemType, row)
{
	var row =$(row);
	var username = row.attr('data-username');
  var url , params = {username: username};
  switch(itemType){
	  case 'summary':
	    openBox(row, '#tweets-box', "/ajax/users/dashboard/tweets-box/",params);
	    openBox(row, '#stats-box', "/ajax/users/dashboard/stats-box/",params);
	    openBox(row, '#alerts-box', "/ajax/users/dashboard/alerts-box/",params);
	    openBox(row, '#graphs-box', '/ajax/users/dashboard/graphs-box/',params);
	    break;
	  case 'alerts':
	    openBox(row, '#alerts-box-edit', "/ajax/users/dashboard/alerts-box/",$.extend(params,{type:'wider'}));
	    openBox(row, '#create-alerts-box', "/ajax/users/dashboard/create-alerts-box/",params);
	    break;
	  default:
	    return false;
  }
  return true;
}

function openBox(row, rel, url, params)
{
	$.get(url, params, function(data){
		if (data){
	    var box = row.find(rel); 
	    box.html(data);
	    box.find('.scrolling').jScrollPane();
			makeCustomSelect(box.find(".custom"));
			box.find('select:visible').each(function(){
				if(!$(this).is('.skip_stylize')) new StylizedSelect(this);
			});
			box.find('.select').click(function(){
		    var options = $('.options', this);
		    options.css({height: 'auto', overflowY: 'auto'});
		    var jsp = options.data('jsp');
		    if(jsp) jsp.reinitialise();
		    else options.jScrollPane({contentWidth: '0px'});
		  });
	    box.find('[tweets-username]').each(function(){loadTweets(this);});
   	}
  });
   
}
/* END OPEN BOX*/

/* SEARCH USER */
var searchMarketUserObj = {
	inited: false,
	list: null,
	key: null,
	ajax: null,
	id: null,
	init: function(){
		var This = this;
		if(This.inited) return;
		This.inited = true;
		This.key = $('#search-key');
		This.list = $('#search-list').hover(function(){
			This.list.find('tr').removeClass('active');
		});
	},
	reinit: function(){
		this.inited = false;
		this.init();
	},
	show: function(){
		var This = this;
		$('body').bind('click', This.onclick);
		var api = This.list.find('div.search-wrapper').data('jsp');
  	if(api) api.destroy();
  	This.key.focus();
  	This.list = $('#search-list');
  	This.list.fadeIn('fast', function(){
  		This.list.find('div.search-wrapper').jScrollPane();
  		This.list.find('tr').click(function(){
        This.id = $(this).attr('data-id');
        This.key.attr('value','@'+This.id);
        This.run();
      });
    });
	},
  hide: function(){
  	var This = this;
  	$('body').unbind('click', This.onclick);
  	This.reinit();
  	This.list.fadeOut('fast');
  },
  onclick: function(event){
    if(!$(event.target).closest('#search-list').length) searchMarketUserObj.hide();
  },
	move: function(step){
  	var This = this;
		if(!step) step = 1;
		var list = This.list.find('tr'), total = list.length, current;
		if(total){
			current = list.filter('.active');
			current = list
				.removeClass('active')
				.eq(((current.length ? list.index(current) : (step > 0 ? -1 : total)) + total + step) % total)
				.addClass('active');
			var api = This.list.find('div.search-wrapper').data('jsp');
			if(api) api.scrollToElement(current);
		}
	},
	go: function(){
		var active = this.list.find('tr.active');
		if(active.length){
		  var This = this;
		  This.id = active.attr('data-id');
		  This.key.attr('value','@'+This.id);
		  This.run();
		}
		return active.length > 0;
	},
	run: function(){
    var This = this;
    if(This.id){
      addMarketUser(This.id, true);
    }else{
    	This.search();
    }
    return true;
  },
  search: function(limit){
  	var This = this;
  	This.init();
  	var key = This.key.val();
  	if(!key){
    	This.hide();
    	return;
    }
  	if(This.ajax) This.ajax.abort();
	  This.ajax = $.ajax({
	    data: {key: key, limit: limit || 10},
	    url: '/ajax/search/user/',
	    success: function(data){
	    	This.ajax = null;
	    	This.id = data.match ? data.match : null;
	      if(!data.html){
        	This.hide();
        	return true;
        }
	      This.list.empty().html(data.html);
	     	This.show();
	    },
	    dataType: 'json'
	  });
  }
};//searchMarketUserObj
function searchMarketUser(limit){
	if(searchMarketUserObj.ajax == null){
		searchMarketUserObj.search(limit);
	}
  return false;
}//searchMarketUser


$(function(){
	var prev = '', val, search = $('#search-key');
	search.keyup(function(e){
		if(e.keyCode == 13){
			if(!searchMarketUserObj.go()) searchMarketUserObj.run();
		}else if(e.keyCode == 40) searchMarketUserObj.move(1);
		else if(e.keyCode == 38) searchMarketUserObj.move(-1);
		else{
			$('#search-list tr.active').removeClass('active');
			val = search.val();
			if(val != prev){
				prev = val;
				searchMarketUser();
			}
		}
	});
	$('#search-add').click(function(){
		searchMarketUserObj.run();
	});
});
/* END SEARCH USER */